/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/resources","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],te=function(G){for(var e=[],S=0,L=G.length;S<L;S++)e[S]=ee[G[S]];return e};define(ee[87],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(L,k){if(!L)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=S}),define(ee[63],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function L(n){const m=[];for(let d in n)S.call(n,d)&&m.push(n[d]);return m}e.values=L;function k(n,m){for(let d in n)if(S.call(n,d)&&m({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=k;function T(n,m){const d=Object.create(null);for(const g of n){const h=m(g);let C=d[h];C||(C=d[h]=[]),C.push(g)}return d}e.groupBy=T;function O(n){const m=Object.create(null);return n&&n.forEach((d,g)=>{m[g]=d}),m}e.fromMap=O;function R(n,m){const d=[],g=[];for(let h of n)m.has(h)||d.push(h);for(let h of m)n.has(h)||g.push(h);return{removed:d,added:g}}e.diffSets=R;function p(n,m){const d=[],g=[];for(let[h,C]of n)m.has(h)||d.push(C);for(let[h,C]of m)n.has(h)||g.push(C);return{removed:d,added:g}}e.diffMaps=p;class w{constructor(){this.map=new Map}add(m,d){let g=this.map.get(m);g||(g=new Set,this.map.set(m,g)),g.add(d)}delete(m,d){const g=this.map.get(m);!g||(g.delete(d),g.size===0&&this.map.delete(m))}forEach(m,d){const g=this.map.get(m);!g||g.forEach(d)}}e.SetMap=w}),define(ee[64],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(O){return(R,p,w)=>{let n=null,m=null;if(typeof w.value=="function"?(n="value",m=w.value):typeof w.get=="function"&&(n="get",m=w.get),!m)throw new Error("not supported");w[n]=O(m,p)}}e.createDecorator=S;function L(O,R,p){let w=null,n=null;if(typeof p.value=="function"?(w="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(w="get",n=p.get),!n)throw new Error("not supported");const m=`$memoize$${R}`;p[w]=function(...d){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[m]}}e.memoize=L;function k(O,R,p){return S((w,n)=>{const m=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...g){this[d]||(this[d]=p?p():void 0),clearTimeout(this[m]),R&&(this[d]=R(this[d],...g),g=[this[d]]),this[m]=setTimeout(()=>{w.apply(this,g),this[d]=p?p():void 0},O)}})}e.debounce=k;function T(O,R,p){return S((w,n)=>{const m=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,g=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[d]||(this[d]=p?p():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...C)),this[h])return;const I=this[g]+O;I<=Date.now()?(this[g]=Date.now(),w.apply(this,[this[d]]),this[d]=p?p():void 0):(this[h]=!0,this[m]=setTimeout(()=>{this[h]=!1,this[g]=Date.now(),w.apply(this,[this[d]]),this[d]=p?p():void 0},I-Date.now()))}})}e.throttle=T}),define(ee[11],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function k(a){p(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=k;function T(a){p(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function O(a){if(a instanceof Error){let{name:t,message:r}=a;const i=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:i}}return a}e.transformErrorForSerialization=O;const R="Canceled";function p(a){return a instanceof Error&&a.name===R&&a.message===R}e.isPromiseCanceledError=p;class w extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=w;function n(){const a=new Error(R);return a.name=a.message,a}e.canceled=n;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=m;function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=d;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function h(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=C;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function y(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=y;function s(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(ee[19],te([0,1,11]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filterSortedByKey=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(P,A=0){return P[P.length-(1+A)]}e.tail=L;function k(P){if(P.length===0)throw new Error("Invalid tail call");return[P.slice(0,P.length-1),P[P.length-1]]}e.tail2=k;function T(P,A,M=(N,x)=>N===x){if(P===A)return!0;if(!P||!A||P.length!==A.length)return!1;for(let N=0,x=P.length;N<x;N++)if(!M(P[N],A[N]))return!1;return!0}e.equals=T;function O(P,A,M){let N=0,x=P.length-1;for(;N<=x;){const H=(N+x)/2|0,J=M(P[H],A);if(J<0)N=H+1;else if(J>0)x=H-1;else return H}return-(N+1)}e.binarySearch=O;function R(P,A){let M=0,N=P.length;if(N===0)return 0;for(;M<N;){const x=Math.floor((M+N)/2);A(P[x])?N=x:M=x+1}return M}e.findFirstInSorted=R;function p(P,A,M){if(P=P|0,P>=A.length)throw new TypeError("invalid index");let N=A[Math.floor(A.length*Math.random())],x=[],H=[],J=[];for(let Q of A){const ie=M(Q,N);ie<0?x.push(Q):ie>0?H.push(Q):J.push(Q)}return P<x.length?p(P,x,M):P<x.length+J.length?J[0]:p(P-(x.length+J.length),H,M)}e.quickSelect=p;function w(P,A){const M=[];let N;for(const x of P.slice(0).sort(A))!N||A(N[0],x)!==0?(N=[x],M.push(N)):N.push(x);return M}e.groupBy=w;function n(P,A,M){const N=[];function x(Q,ie,Z){if(ie===0&&Z.length===0)return;const oe=N[N.length-1];oe&&oe.start+oe.deleteCount===Q?(oe.deleteCount+=ie,oe.toInsert.push(...Z)):N.push({start:Q,deleteCount:ie,toInsert:Z})}let H=0,J=0;for(;;){if(H===P.length){x(H,0,A.slice(J));break}if(J===A.length){x(H,P.length-H,[]);break}const Q=P[H],ie=A[J],Z=M(Q,ie);Z===0?(H+=1,J+=1):Z<0?(x(H,1,[]),H+=1):Z>0&&(x(H,0,[ie]),J+=1)}return N}e.sortedDiff=n;function m(P,A,M){const N=n(P,A,M),x=[],H=[];for(const J of N)x.push(...P.slice(J.start,J.start+J.deleteCount)),H.push(...J.toInsert);return{removed:x,added:H}}e.delta=m;function d(P,A,M){if(M===0)return[];const N=P.slice(0,M).sort(A);return h(P,A,N,M,P.length),N}e.top=d;function g(P,A,M,N,x){return M===0?Promise.resolve([]):new Promise((H,J)=>{(async()=>{const Q=P.length,ie=P.slice(0,M).sort(A);for(let Z=M,oe=Math.min(M+N,Q);Z<Q;Z=oe,oe=Math.min(oe+N,Q)){if(Z>M&&await new Promise(ue=>setTimeout(ue)),x&&x.isCancellationRequested)throw S.canceled();h(P,A,ie,Z,oe)}return ie})().then(H,J)})}e.topAsync=g;function h(P,A,M,N,x){for(const H=M.length;N<x;N++){const J=P[N];if(A(J,M[H-1])<0){M.pop();const Q=R(M,ie=>A(J,ie)<0);M.splice(Q,0,J)}}}function C(P){return P.filter(A=>!!A)}e.coalesce=C;function I(P){let A=0;for(let M=0;M<P.length;M++)P[M]&&(P[A]=P[M],A+=1);P.length=A}e.coalesceInPlace=I;function b(P,A,M){P.splice(M,0,P.splice(A,1)[0])}e.move=b;function D(P){return!Array.isArray(P)||P.length===0}e.isFalsyOrEmpty=D;function y(P){return Array.isArray(P)&&P.length>0}e.isNonEmptyArray=y;function s(P,A){if(!A)return P.filter((N,x)=>P.indexOf(N)===x);const M=Object.create(null);return P.filter(N=>{const x=A(N);return M[x]?!1:(M[x]=!0,!0)})}e.distinct=s;function a(P){const A=new Set;return P.filter(M=>A.has(M)?!1:(A.add(M),!0))}e.distinctES6=a;function t(P){const A=Object.create(null);return M=>{const N=P(M);return A[N]?!1:(A[N]=!0,!0)}}e.uniqueFilter=t;function r(P,A){for(let M=P.length-1;M>=0;M--){const N=P[M];if(A(N))return M}return-1}e.lastIndex=r;function i(P,A){return P.length>0?P[0]:A}e.firstOrDefault=i;function o(P,A,M=(N,x)=>N===x){let N=0;for(let x=0,H=Math.min(P.length,A.length);x<H&&M(P[x],A[x]);x++)N++;return N}e.commonPrefixLength=o;function u(P){return[].concat(...P)}e.flatten=u;function c(P,A){let M=typeof A=="number"?P:0;typeof A=="number"?M=P:(M=0,A=P);const N=[];if(M<=A)for(let x=M;x<A;x++)N.push(x);else for(let x=M;x>A;x--)N.push(x);return N}e.range=c;function l(P,A,M){return P.reduce((N,x)=>(N[A(x)]=M?M(x):x,N),Object.create(null))}e.index=l;function v(P,A){return P.push(A),()=>E(P,A)}e.insert=v;function E(P,A){const M=P.indexOf(A);if(M>-1)return P.splice(M,1),A}e.remove=E;function f(P,A,M){const N=P.slice(0,A),x=P.slice(A);return N.concat(M,x)}e.arrayInsert=f;function U(P,A){let M;if(typeof A=="number"){let N=A;M=()=>{const x=Math.sin(N++)*179426549;return x-Math.floor(x)}}else M=Math.random;for(let N=P.length-1;N>0;N-=1){const x=Math.floor(M()*(N+1)),H=P[N];P[N]=P[x],P[x]=H}}e.shuffle=U;function F(P,A){const M=P.indexOf(A);M>-1&&(P.splice(M,1),P.unshift(A))}e.pushToStart=F;function z(P,A){const M=P.indexOf(A);M>-1&&(P.splice(M,1),P.push(A))}e.pushToEnd=z;function $(P,A){return Array.isArray(P)?P.map(A):A(P)}e.mapArrayOrNot=$;function V(P){return Array.isArray(P)?P:[P]}e.asArray=V;function B(P){return P[Math.floor(Math.random()*P.length)]}e.getRandomElement=B;function _(P,A){for(const M of P){const N=A(M);if(N!==void 0)return N}}e.mapFind=_;function W(P,A){let M=Number.MAX_SAFE_INTEGER,N=0;return P.forEach((x,H)=>{const J=A(x);J<M&&(M=J,N=H)}),N}e.minIndex=W;function K(P,A){let M=Number.MIN_SAFE_INTEGER,N=0;return P.forEach((x,H)=>{const J=A(x);J>M&&(M=J,N=H)}),N}e.maxIndex=K;function j(P,A,M,N=M){const x=R(P,J=>M<=A(J)),H=R(P,J=>N<A(J));return x===H?null:P.slice(x,H)}e.filterSortedByKey=j}),define(ee[65],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(L){const k=this;let T=!1,O;return function(){return T||(T=!0,O=L.apply(k,arguments)),O}}e.once=S}),define(ee[53],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(L){function k(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=k;const T=Object.freeze([]);function O(){return T}L.empty=O;function*R(a){yield a}L.single=R;function p(a){return a||T}L.from=p;function w(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=w;function n(a){return a[Symbol.iterator]().next().value}L.first=n;function m(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=m;function d(a,t){for(const r of a)if(t(r))return r}L.find=d;function*g(a,t){for(const r of a)t(r)&&(yield r)}L.filter=g;function*h(a,t){let r=0;for(const i of a)yield t(i,r++)}L.map=h;function*C(...a){for(const t of a)for(const r of t)yield r}L.concat=C;function*I(a){for(const t of a)for(const r of t)yield r}L.concatNested=I;function b(a,t,r){let i=r;for(const o of a)i=t(i,o);return i}L.reduce=b;function*D(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=D;function y(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const i=a[Symbol.iterator]();for(let o=0;o<t;o++){const u=i.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=y;function s(a,t,r=(i,o)=>i===o){const i=a[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const u=i.next(),c=o.next();if(u.done!==c.done)return!1;if(u.done)return!0;if(!r(u.value,c.value))return!1}}L.equals=s})(S=e.Iterable||(e.Iterable={}))}),define(ee[32],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function O(t,r=!1){let i=0,o=t.length,u="",c=0,l=16,v=0;function E(B){let _=0,W=0;for(;_<B;){const K=t.charCodeAt(i);if(K>=48&&K<=57)W=W*16+K-48;else if(K>=65&&K<=70)W=W*16+K-65+10;else if(K>=97&&K<=102)W=W*16+K-97+10;else break;i++,_++}return _<B&&(W=-1),W}function f(B){i=B,u="",c=0,l=16,v=0}function U(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return v=3,t.substring(B,i);let _=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;_=i}else v=3;return t.substring(B,_)}function F(){let B="",_=i;for(;;){if(i>=o){B+=t.substring(_,i),v=2;break}const W=t.charCodeAt(i);if(W===34){B+=t.substring(_,i),i++;break}if(W===92){if(B+=t.substring(_,i),i++,i>=o){v=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const j=E(4);j>=0?B+=String.fromCharCode(j):v=4;break;default:v=5}_=i;continue}if(W>=0&&W<=31)if(p(W)){B+=t.substring(_,i),v=2;break}else v=6;i++}return B}function z(){if(u="",v=0,c=i,i>=o)return c=o,l=17;let B=t.charCodeAt(i);if(R(B)){do i++,u+=String.fromCharCode(B),B=t.charCodeAt(i);while(R(B));return l=15}if(p(B))return i++,u+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(B){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=F(),l=10;case 47:const _=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!p(t.charCodeAt(i));)i++;return u=t.substring(_,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const W=o-1;let K=!1;for(;i<W;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,K=!0;break}i++}return K||(i++,v=1),u=t.substring(_,i),l=13}return u+=String.fromCharCode(B),i++,l=16;case 45:if(u+=String.fromCharCode(B),i++,i===o||!w(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=U(),l=11;default:for(;i<o&&$(B);)i++,B=t.charCodeAt(i);if(c!==i){switch(u=t.substring(c,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(B),i++,l=16}}function $(B){if(R(B)||p(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let B;do B=z();while(B>=12&&B<=15);return B}return{setPosition:f,getPosition:()=>i,scan:r?V:z,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>v}}e.createScanner=O;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function m(t,r){const i=[],o=new Object;let u;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function v(E,f,U,F){c.value=E,c.offset=f,c.length=U,c.type=F,c.colonOffset=void 0,u=c}try{y(t,{onObjectBegin:(E,f)=>{if(r<=E)throw o;u=void 0,l=r>E,i.push("")},onObjectProperty:(E,f,U)=>{if(r<f||(v(E,f,U,"property"),i[i.length-1]=E,r<=f+U))throw o},onObjectEnd:(E,f)=>{if(r<=E)throw o;u=void 0,i.pop()},onArrayBegin:(E,f)=>{if(r<=E)throw o;u=void 0,i.push(0)},onArrayEnd:(E,f)=>{if(r<=E)throw o;u=void 0,i.pop()},onLiteralValue:(E,f,U)=>{if(r<f||(v(E,f,U,a(E)),r<=f+U))throw o},onSeparator:(E,f,U)=>{if(r<=f)throw o;if(E===":"&&u&&u.type==="property")u.colonOffset=f,l=!1,u=void 0;else if(E===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(E){if(E!==o)throw E}return{path:i,previousNode:u,isAtPropertyKey:l,matches:E=>{let f=0;for(let U=0;f<E.length&&U<i.length;U++)if(E[f]===i[U]||E[f]==="*")f++;else if(E[f]!=="**")return!1;return f===E.length}}}e.getLocation=m;function d(t,r=[],i=T.DEFAULT){let o=null,u=[];const c=[];function l(E){Array.isArray(u)?u.push(E):o!==null&&(u[o]=E)}return y(t,{onObjectBegin:()=>{const E={};l(E),c.push(u),u=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{const E=[];l(E),c.push(u),u=E,o=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:l,onError:(E,f,U)=>{r.push({error:E,offset:f,length:U})}},i),u[0]}e.parse=d;function g(t,r=[],i=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function c(E){return o.children.push(E),E}y(t,{onObjectBegin:E=>{o=c({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,f,U)=>{o=c({type:"property",offset:f,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:f,length:U,parent:o})},onObjectEnd:(E,f)=>{o.length=E+f-o.offset,o=o.parent,u(E+f)},onArrayBegin:(E,f)=>{o=c({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,f)=>{o.length=E+f-o.offset,o=o.parent,u(E+f)},onLiteralValue:(E,f,U)=>{c({type:a(E),offset:f,length:U,parent:o,value:E}),u(f+U)},onSeparator:(E,f,U)=>{o.type==="property"&&(E===":"?o.colonOffset=f:E===","&&u(f))},onError:(E,f,U)=>{r.push({error:E,offset:f,length:U})}},i);const v=o.children[0];return v&&delete v.parent,v}e.parseTree=g;function h(t,r){if(!t)return;let i=t;for(let o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===o){i=c.children[1],u=!0;break}if(!u)return}else{const u=o;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const r=Object.create(null);for(let i of t.children){const o=i.children[1];o&&(r[i.children[0].value]=I(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function D(t,r,i=!1){if(b(t,r,i)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=r;u++){const c=D(o[u],r,i);if(c)return c}return t}}e.findNodeAtOffset=D;function y(t,r,i=T.DEFAULT){const o=O(t,!1);function u(H){return H?()=>H(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(H){return H?J=>H(J,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),v=c(r.onObjectProperty),E=u(r.onObjectEnd),f=u(r.onArrayBegin),U=u(r.onArrayEnd),F=c(r.onLiteralValue),z=c(r.onSeparator),$=u(r.onComment),V=c(r.onError),B=i&&i.disallowComments,_=i&&i.allowTrailingComma;function W(){for(;;){const H=o.scan();switch(o.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:B||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(H){case 12:case 13:B?K(10):$();break;case 16:K(1);break;case 15:case 14:break;default:return H}}}function K(H,J=[],Q=[]){if(V(H),J.length+Q.length>0){let ie=o.getToken();for(;ie!==17;){if(J.indexOf(ie)!==-1){W();break}else if(Q.indexOf(ie)!==-1)break;ie=W()}}}function j(H){const J=o.getTokenValue();return H?F(J):v(J),W(),!0}function P(){switch(o.getToken()){case 11:let H=0;try{H=JSON.parse(o.getTokenValue()),typeof H!="number"&&(K(2),H=0)}catch(J){K(2)}F(H);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return W(),!0}function A(){return o.getToken()!==10?(K(3,[],[2,5]),!1):(j(!1),o.getToken()===6?(z(":"),W(),x()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function M(){l(),W();let H=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(H||K(4,[],[]),z(","),W(),o.getToken()===2&&_)break}else H&&K(6,[],[]);A()||K(4,[],[2,5]),H=!0}return E(),o.getToken()!==2?K(7,[2],[]):W(),!0}function N(){f(),W();let H=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(H||K(4,[],[]),z(","),W(),o.getToken()===4&&_)break}else H&&K(6,[],[]);x()||K(4,[],[4,5]),H=!0}return U(),o.getToken()!==4?K(8,[4],[]):W(),!0}function x(){switch(o.getToken()){case 3:return N();case 1:return M();case 10:return j(!0);default:return P()}}return W(),o.getToken()===17?i.allowEmptyContent?!0:(K(4,[],[]),!1):x()?(o.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=y;function s(t,r){let i=O(t),o=[],u,c=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:c!==l&&o.push(t.substring(c,l)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(u!==17);return o.join("")}e.stripComments=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(ee[46],te([0,1,32]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(p,w,n){let m,d,g,h,C;if(w){for(h=w.offset,C=h+w.length,g=h;g>0&&!R(p,g-1);)g--;let c=C;for(;c<p.length&&!R(p,c);)c++;d=p.substring(g,c),m=T(d,n)}else d=p,m=0,g=0,h=0,C=p.length;const I=O(n,p);let b=!1,D=0,y;n.insertSpaces?y=k(" ",n.tabSize||4):y="	";const s=S.createScanner(d,!1);let a=!1;function t(){return I+k(y,m+D)}function r(){let c=s.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=s.scan();return a=c===16||s.getTokenError()!==0,c}const i=[];function o(c,l,v){!a&&l<C&&v>h&&p.substring(l,v)!==c&&i.push({offset:l,length:v-l,content:c})}let u=r();if(u!==17){const c=s.getTokenOffset()+g,l=k(y,m);o(l,g,c)}for(;u!==17;){let c=s.getTokenOffset()+s.getTokenLength()+g,l=r(),v="";for(;!b&&(l===12||l===13);){const f=s.getTokenOffset()+g;o(" ",c,f),c=s.getTokenOffset()+s.getTokenLength()+g,v=l===12?t():"",l=r()}if(l===2)u!==1&&(D--,v=t());else if(l===4)u!==3&&(D--,v=t());else{switch(u){case 3:case 1:D++,v=t();break;case 5:case 12:v=t();break;case 13:b?v=t():v=" ";break;case 6:v=" ";break;case 10:if(l===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?v=" ":l!==5&&l!==17&&(a=!0);break;case 16:a=!0;break}b&&(l===12||l===13)&&(v=t())}const E=s.getTokenOffset()+g;o(v,c,E),u=l}return i}e.format=L;function k(p,w){let n="";for(let m=0;m<w;m++)n+=p;return n}function T(p,w){let n=0,m=0;const d=w.tabSize||4;for(;n<p.length;){const g=p.charAt(n);if(g===" ")m++;else if(g==="	")m+=d;else break;n++}return Math.floor(m/d)}function O(p,w){for(let n=0;n<w.length;n++){const m=w.charAt(n);if(m==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=O;function R(p,w){return`\r
`.indexOf(p.charAt(w))!==-1}e.isEOL=R}),define(ee[40],te([0,1,32,46]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,n,m){return T(w,n,void 0,m)}e.removeProperty=k;function T(w,n,m,d,g){const h=n.slice(),C=[],I=S.parseTree(w,C);let b,D;for(;h.length>0&&(D=h.pop(),b=S.findNodeAtLocation(I,h),b===void 0&&m!==void 0);)typeof D=="string"?m={[D]:m}:m=[m];if(b)if(b.type==="object"&&typeof D=="string"&&Array.isArray(b.children)){const y=S.findNodeAtLocation(b,[D]);if(y!==void 0)if(m===void 0){if(!y.parent)throw new Error("Malformed AST");const s=b.children.indexOf(y.parent);let a,t=y.parent.offset+y.parent.length;if(s>0){const r=b.children[s-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return O(w,{offset:a,length:t-a,content:""},d)}else return O(w,{offset:y.offset,length:y.length,content:JSON.stringify(m)},d);else{if(m===void 0)return[];const s=`${JSON.stringify(D)}: ${JSON.stringify(m)}`,a=g?g(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return O(w,t,d)}}else if(b.type==="array"&&typeof D=="number"&&Array.isArray(b.children))if(m!==void 0){const y=`${JSON.stringify(m)}`;let s;if(b.children.length===0||D===0)s={offset:b.offset+1,length:0,content:b.children.length===0?y:y+","};else{const a=D===-1||D>b.children.length?b.children.length:D,t=b.children[a-1];s={offset:t.offset+t.length,length:0,content:","+y}}return O(w,s,d)}else{const y=D,s=b.children[y];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===y){const t=b.children[y-1],r=t.offset+t.length,i=b.offset+b.length;a={offset:r,length:i-2-r,content:""}}else a={offset:s.offset,length:b.children[y+1].offset-s.offset,content:""};return O(w,a,d)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${b.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return O(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(m)},d)}}e.setProperty=T;function O(w,n,m){let d=R(w,n),g=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;g>0&&!L.isEOL(d,g-1);)g--;for(;h<d.length&&!L.isEOL(d,h);)h++}const C=L.format(d,{offset:g,length:h-g},m);for(let b=C.length-1;b>=0;b--){const D=C[b];d=R(d,D),g=Math.min(g,D.offset),h=Math.max(h,D.offset+D.length),h+=D.content.length-D.length}const I=w.length-(d.length-h)-g;return[{offset:g,length:I,content:d.substring(g,h)}]}e.withFormatting=O;function R(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=R;function p(w,n){let m=n.slice(0).sort((g,h)=>{const C=g.offset-h.offset;return C===0?g.length-h.length:C}),d=w.length;for(let g=m.length-1;g>=0;g--){let h=m[g];if(h.offset+h.length<=d)w=R(w,h);else throw new Error("Overlapping edit");d=h.offset}return w}e.applyEdits=p}),define(ee[2],te([0,1,65,53]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let T=null;function O(s){T=s}if(e.setDisposableTracker=O,k){const s="__is_disposable_tracked__";T=new class{trackDisposable(a){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(t)},3e3)}markTracked(a){if(a&&a!==C.None)try{a[s]=!0}catch{}}}}function R(s){!T||T.markTracked(s)}function p(s){return T&&T.trackDisposable(s),s}e.trackDisposable=p;class w extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=w;function n(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=n;function m(s){if(L.Iterable.is(s)){let a=[];for(const t of s)if(t){R(t);try{t.dispose()}catch(r){a.push(r)}}if(a.length===1)throw a[0];if(a.length>1)throw new w(a);return Array.isArray(s)?[]:s}else if(s)return R(s),s.dispose(),s}e.dispose=m;function d(...s){return s.forEach(R),g(()=>m(s))}e.combinedDisposable=d;function g(s){const a=p({dispose:()=>{R(a),s()}});return a}e.toDisposable=g;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(R(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return R(a),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new h,p(this)}dispose(){R(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class I{constructor(){this._isDisposed=!1,p(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&R(a),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,R(this),this._value?.dispose(),this._value=void 0}}e.MutableDisposable=I;class b{constructor(){this.references=new Map}acquire(a,...t){let r=this.references.get(a);r||(r={counter:0,object:this.createReferencedObject(a,...t)},this.references.set(a,r));const{object:i}=r,o=S.once(()=>{--r.counter==0&&(this.destroyReferencedObject(a,r.object),this.references.delete(a))});return r.counter++,{object:i,dispose:o}}}e.ReferenceCollection=b;class D{constructor(a){this.referenceCollection=a}async acquire(a,...t){const r=this.referenceCollection.acquire(a,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(i){throw r.dispose(),i}}}e.AsyncReferenceCollection=D;class y{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=y}),define(ee[88],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(T){this.element=T,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class L{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let T=this._first;for(;T!==S.Undefined;){const O=T.next;T.prev=S.Undefined,T.next=S.Undefined,T=O}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,O){const R=new S(T);if(this._first===S.Undefined)this._first=R,this._last=R;else if(O){const w=this._last;this._last=R,R.prev=w,w.next=R}else{const w=this._first;this._first=R,R.next=w,w.prev=R}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(R))}}shift(){if(this._first!==S.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==S.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==S.Undefined&&T.next!==S.Undefined){const O=T.prev;O.next=T.next,T.next.prev=O}else T.prev===S.Undefined&&T.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):T.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):T.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==S.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function G(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function O(p){T.push(p,Date.now())}function R(){const p=[];for(let w=0;w<T.length;w+=2)p.push({name:T[w],startTime:T[w+1]});return p}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const O of performance.getEntriesByType("mark"))T.push({name:O.name,startTime:Math.round(k+O.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function S(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),define(ee[7],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let L=!1,k=!1,T=!1,O=!1,R=!1,p=!1,w=!1,n,m=S,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)g=navigator.userAgent,L=g.indexOf("Windows")>=0,k=g.indexOf("Macintosh")>=0,w=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=g.indexOf("Linux")>=0,p=!0,n=navigator.language,m=n;else if(typeof h=="object"){L=h.platform==="win32",k=h.platform==="darwin",T=h.platform==="linux",O=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=S,m=S;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),u=o.availableLanguages["*"];n=o.locale,m=u||S,d=o._translationsConfigFile}catch(o){}R=!0}else console.error("Unable to resolve platform.");var I;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let D=0;k?D=1:L?D=3:T&&(D=2),e.isWindows=L,e.isMacintosh=k,e.isLinux=T,e.isLinuxSnap=O,e.isNative=R,e.isWeb=p,e.isIOS=w,e.platform=D,e.userAgent=g,e.language=m;var y;(function(i){function o(){return e.language}i.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function c(){return e.language==="en"}i.isDefault=c})(y=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let v=0,E=u.length;v<E;v++){const f=u[v];if(f.id===l.data.vscodeSetImmediateId){u.splice(v,1),f.callback();return}}});let c=0;return l=>{const v=++c;u.push({id:v,callback:l}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const o=Promise.resolve();return u=>o.then(u)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||w?2:L?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(ee[34],te([0,1,7]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const k=S.globals.vscode.process;L={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(T){return S.setImmediate(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:L={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(k){return S.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(ee[8],te([0,1,34]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,k=97,T=90,O=122,R=46,p=47,w=92,n=58,m=63;class d extends Error{constructor(s,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${i} ${r} of type ${a}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(y,s){if(typeof y!="string")throw new d(s,"string",y)}function h(y){return y===p||y===w}function C(y){return y===p}function I(y){return y>=L&&y<=T||y>=k&&y<=O}function b(y,s,a,t){let r="",i=0,o=-1,u=0,c=0;for(let l=0;l<=y.length;++l){if(l<y.length)c=y.charCodeAt(l);else{if(t(c))break;c=p}if(t(c)){if(!(o===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const v=r.lastIndexOf(a);v===-1?(r="",i=0):(r=r.slice(0,v),i=r.length-1-r.lastIndexOf(a)),o=l,u=0;continue}else if(r.length!==0){r="",i=0,o=l,u=0;continue}}s&&(r+=r.length>0?`${a}..`:"..",i=2)}else r.length>0?r+=`${a}${y.slice(o+1,l)}`:r=y.slice(o+1,l),i=l-o-1;o=l,u=0}else c===R&&u!==-1?++u:u=-1}return r}function D(y,s){if(s===null||typeof s!="object")throw new d("pathObject","Object",s);const a=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${t}`:`${a}${y}${t}`:t}e.win32={resolve(...y){let s="",a="",t=!1;for(let r=y.length-1;r>=-1;r--){let i;if(r>=0){if(i=y[r],g(i,"path"),i.length===0)continue}else s.length===0?i=S.cwd():(i=S.env[`=${s}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${s}\\`));const o=i.length;let u=0,c="",l=!1;const v=i.charCodeAt(0);if(o===1)h(v)&&(u=1,l=!0);else if(h(v))if(l=!0,h(i.charCodeAt(1))){let E=2,f=E;for(;E<o&&!h(i.charCodeAt(E));)E++;if(E<o&&E!==f){const U=i.slice(f,E);for(f=E;E<o&&h(i.charCodeAt(E));)E++;if(E<o&&E!==f){for(f=E;E<o&&!h(i.charCodeAt(E));)E++;(E===o||E!==f)&&(c=`\\\\${U}\\${i.slice(f,E)}`,u=E)}}}else u=1;else I(v)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),u=2,o>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(a=`${i.slice(u)}\\${a}`,t=l,l&&s.length>0)break}return a=b(a,!t,"\\",h),t?`${s}\\${a}`:`${s}${a}`||"."},normalize(y){g(y,"path");const s=y.length;if(s===0)return".";let a=0,t,r=!1;const i=y.charCodeAt(0);if(s===1)return C(i)?"\\":y;if(h(i))if(r=!0,h(y.charCodeAt(1))){let u=2,c=u;for(;u<s&&!h(y.charCodeAt(u));)u++;if(u<s&&u!==c){const l=y.slice(c,u);for(c=u;u<s&&h(y.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&!h(y.charCodeAt(u));)u++;if(u===s)return`\\\\${l}\\${y.slice(c)}\\`;u!==c&&(t=`\\\\${l}\\${y.slice(c,u)}`,a=u)}}}else a=1;else I(i)&&y.charCodeAt(1)===n&&(t=y.slice(0,2),a=2,s>2&&h(y.charCodeAt(2))&&(r=!0,a=3));let o=a<s?b(y.slice(a),!r,"\\",h):"";return o.length===0&&!r&&(o="."),o.length>0&&h(y.charCodeAt(s-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(y){g(y,"path");const s=y.length;if(s===0)return!1;const a=y.charCodeAt(0);return h(a)||s>2&&I(a)&&y.charCodeAt(1)===n&&h(y.charCodeAt(2))},join(...y){if(y.length===0)return".";let s,a;for(let i=0;i<y.length;++i){const o=y[i];g(o,"path"),o.length>0&&(s===void 0?s=a=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++r;const i=a.length;i>1&&h(a.charCodeAt(1))&&(++r,i>2&&(h(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(y,s){if(g(y,"from"),g(s,"to"),y===s)return"";const a=e.win32.resolve(y),t=e.win32.resolve(s);if(a===t||(y=a.toLowerCase(),s=t.toLowerCase(),y===s))return"";let r=0;for(;r<y.length&&y.charCodeAt(r)===w;)r++;let i=y.length;for(;i-1>r&&y.charCodeAt(i-1)===w;)i--;const o=i-r;let u=0;for(;u<s.length&&s.charCodeAt(u)===w;)u++;let c=s.length;for(;c-1>u&&s.charCodeAt(c-1)===w;)c--;const l=c-u,v=o<l?o:l;let E=-1,f=0;for(;f<v;f++){const F=y.charCodeAt(r+f);if(F!==s.charCodeAt(u+f))break;F===w&&(E=f)}if(f!==v){if(E===-1)return t}else{if(l>v){if(s.charCodeAt(u+f)===w)return t.slice(u+f+1);if(f===2)return t.slice(u+f)}o>v&&(y.charCodeAt(r+f)===w?E=f:f===2&&(E=3)),E===-1&&(E=0)}let U="";for(f=r+E+1;f<=i;++f)(f===i||y.charCodeAt(f)===w)&&(U+=U.length===0?"..":"\\..");return u+=E,U.length>0?`${U}${t.slice(u,c)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,c))},toNamespacedPath(y){if(typeof y!="string")return y;if(y.length===0)return"";const s=e.win32.resolve(y);if(s.length<=2)return y;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const a=s.charCodeAt(2);if(a!==m&&a!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(I(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return y},dirname(y){g(y,"path");const s=y.length;if(s===0)return".";let a=-1,t=0;const r=y.charCodeAt(0);if(s===1)return h(r)?y:".";if(h(r)){if(a=t=1,h(y.charCodeAt(1))){let u=2,c=u;for(;u<s&&!h(y.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&h(y.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&!h(y.charCodeAt(u));)u++;if(u===s)return y;u!==c&&(a=t=u+1)}}}}else I(r)&&y.charCodeAt(1)===n&&(a=s>2&&h(y.charCodeAt(2))?3:2,t=a);let i=-1,o=!0;for(let u=s-1;u>=t;--u)if(h(y.charCodeAt(u))){if(!o){i=u;break}}else o=!1;if(i===-1){if(a===-1)return".";i=a}return y.slice(0,i)},basename(y,s){s!==void 0&&g(s,"ext"),g(y,"path");let a=0,t=-1,r=!0,i;if(y.length>=2&&I(y.charCodeAt(0))&&y.charCodeAt(1)===n&&(a=2),s!==void 0&&s.length>0&&s.length<=y.length){if(s===y)return"";let o=s.length-1,u=-1;for(i=y.length-1;i>=a;--i){const c=y.charCodeAt(i);if(h(c)){if(!r){a=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return a===t?t=u:t===-1&&(t=y.length),y.slice(a,t)}for(i=y.length-1;i>=a;--i)if(h(y.charCodeAt(i))){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":y.slice(a,t)},extname(y){g(y,"path");let s=0,a=-1,t=0,r=-1,i=!0,o=0;y.length>=2&&y.charCodeAt(1)===n&&I(y.charCodeAt(0))&&(s=t=2);for(let u=y.length-1;u>=s;--u){const c=y.charCodeAt(u);if(h(c)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),c===R?a===-1?a=u:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||r===-1||o===0||o===1&&a===r-1&&a===t+1?"":y.slice(a,r)},format:D.bind(null,"\\"),parse(y){g(y,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return s;const a=y.length;let t=0,r=y.charCodeAt(0);if(a===1)return h(r)?(s.root=s.dir=y,s):(s.base=s.name=y,s);if(h(r)){if(t=1,h(y.charCodeAt(1))){let E=2,f=E;for(;E<a&&!h(y.charCodeAt(E));)E++;if(E<a&&E!==f){for(f=E;E<a&&h(y.charCodeAt(E));)E++;if(E<a&&E!==f){for(f=E;E<a&&!h(y.charCodeAt(E));)E++;E===a?t=E:E!==f&&(t=E+1)}}}}else if(I(r)&&y.charCodeAt(1)===n){if(a<=2)return s.root=s.dir=y,s;if(t=2,h(y.charCodeAt(2))){if(a===3)return s.root=s.dir=y,s;t=3}}t>0&&(s.root=y.slice(0,t));let i=-1,o=t,u=-1,c=!0,l=y.length-1,v=0;for(;l>=t;--l){if(r=y.charCodeAt(l),h(r)){if(!c){o=l+1;break}continue}u===-1&&(c=!1,u=l+1),r===R?i===-1?i=l:v!==1&&(v=1):i!==-1&&(v=-1)}return u!==-1&&(i===-1||v===0||v===1&&i===u-1&&i===o+1?s.base=s.name=y.slice(o,u):(s.name=y.slice(o,i),s.base=y.slice(o,u),s.ext=y.slice(i,u))),o>0&&o!==t?s.dir=y.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...y){let s="",a=!1;for(let t=y.length-1;t>=-1&&!a;t--){const r=t>=0?y[t]:S.cwd();g(r,"path"),r.length!==0&&(s=`${r}/${s}`,a=r.charCodeAt(0)===p)}return s=b(s,!a,"/",C),a?`/${s}`:s.length>0?s:"."},normalize(y){if(g(y,"path"),y.length===0)return".";const s=y.charCodeAt(0)===p,a=y.charCodeAt(y.length-1)===p;return y=b(y,!s,"/",C),y.length===0?s?"/":a?"./":".":(a&&(y+="/"),s?`/${y}`:y)},isAbsolute(y){return g(y,"path"),y.length>0&&y.charCodeAt(0)===p},join(...y){if(y.length===0)return".";let s;for(let a=0;a<y.length;++a){const t=y[a];g(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(y,s){if(g(y,"from"),g(s,"to"),y===s||(y=e.posix.resolve(y),s=e.posix.resolve(s),y===s))return"";const a=1,t=y.length,r=t-a,i=1,o=s.length-i,u=r<o?r:o;let c=-1,l=0;for(;l<u;l++){const E=y.charCodeAt(a+l);if(E!==s.charCodeAt(i+l))break;E===p&&(c=l)}if(l===u)if(o>u){if(s.charCodeAt(i+l)===p)return s.slice(i+l+1);if(l===0)return s.slice(i+l)}else r>u&&(y.charCodeAt(a+l)===p?c=l:l===0&&(c=0));let v="";for(l=a+c+1;l<=t;++l)(l===t||y.charCodeAt(l)===p)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(i+c)}`},toNamespacedPath(y){return y},dirname(y){if(g(y,"path"),y.length===0)return".";const s=y.charCodeAt(0)===p;let a=-1,t=!0;for(let r=y.length-1;r>=1;--r)if(y.charCodeAt(r)===p){if(!t){a=r;break}}else t=!1;return a===-1?s?"/":".":s&&a===1?"//":y.slice(0,a)},basename(y,s){s!==void 0&&g(s,"ext"),g(y,"path");let a=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=y.length){if(s===y)return"";let o=s.length-1,u=-1;for(i=y.length-1;i>=0;--i){const c=y.charCodeAt(i);if(c===p){if(!r){a=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return a===t?t=u:t===-1&&(t=y.length),y.slice(a,t)}for(i=y.length-1;i>=0;--i)if(y.charCodeAt(i)===p){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":y.slice(a,t)},extname(y){g(y,"path");let s=-1,a=0,t=-1,r=!0,i=0;for(let o=y.length-1;o>=0;--o){const u=y.charCodeAt(o);if(u===p){if(!r){a=o+1;break}continue}t===-1&&(r=!1,t=o+1),u===R?s===-1?s=o:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===a+1?"":y.slice(s,t)},format:D.bind(null,"/"),parse(y){g(y,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(y.length===0)return s;const a=y.charCodeAt(0)===p;let t;a?(s.root="/",t=1):t=0;let r=-1,i=0,o=-1,u=!0,c=y.length-1,l=0;for(;c>=t;--c){const v=y.charCodeAt(c);if(v===p){if(!u){i=c+1;break}continue}o===-1&&(u=!1,o=c+1),v===R?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(o!==-1){const v=i===0&&a?1:i;r===-1||l===0||l===1&&r===o-1&&r===i+1?s.base=s.name=y.slice(v,o):(s.name=y.slice(v,r),s.base=y.slice(v,o),s.ext=y.slice(r,o))}return i>0?s.dir=y.slice(0,i-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:G)[L]=S[L]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function S(L){if(e[L])return e[L].exports;var k=e[L]={i:L,l:!1,exports:{}};return G[L].call(k.exports,k,k.exports,S),k.l=!0,k.exports}return S.m=G,S.c=e,S.d=function(L,k,T){S.o(L,k)||Object.defineProperty(L,k,{enumerable:!0,get:T})},S.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,k){if(1&k&&(L=S(L)),8&k||4&k&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(S.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&k&&typeof L!="string")for(var O in L)S.d(T,O,function(R){return L[R]}.bind(null,O));return T},S.n=function(L){var k=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(k,"a",k),k},S.o=function(L,k){return Object.prototype.hasOwnProperty.call(L,k)},S.p="",S(S.s=0)}([function(G,e,S){(function(L){var k;e=G.exports=Q,k=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],w=0,n=w++;p[n]="0|[1-9]\\d*";var m=w++;p[m]="[0-9]+";var d=w++;p[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=w++;p[g]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var h=w++;p[h]="("+p[m]+")\\.("+p[m]+")\\.("+p[m]+")";var C=w++;p[C]="(?:"+p[n]+"|"+p[d]+")";var I=w++;p[I]="(?:"+p[m]+"|"+p[d]+")";var b=w++;p[b]="(?:-("+p[C]+"(?:\\."+p[C]+")*))";var D=w++;p[D]="(?:-?("+p[I]+"(?:\\."+p[I]+")*))";var y=w++;p[y]="[0-9A-Za-z-]+";var s=w++;p[s]="(?:\\+("+p[y]+"(?:\\."+p[y]+")*))";var a=w++,t="v?"+p[g]+p[b]+"?"+p[s]+"?";p[a]="^"+t+"$";var r="[v=\\s]*"+p[h]+p[D]+"?"+p[s]+"?",i=w++;p[i]="^"+r+"$";var o=w++;p[o]="((?:<|>)?=?)";var u=w++;p[u]=p[m]+"|x|X|\\*";var c=w++;p[c]=p[n]+"|x|X|\\*";var l=w++;p[l]="[v=\\s]*("+p[c]+")(?:\\.("+p[c]+")(?:\\.("+p[c]+")(?:"+p[b]+")?"+p[s]+"?)?)?";var v=w++;p[v]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[D]+")?"+p[s]+"?)?)?";var E=w++;p[E]="^"+p[o]+"\\s*"+p[l]+"$";var f=w++;p[f]="^"+p[o]+"\\s*"+p[v]+"$";var U=w++;p[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=w++;p[F]="(?:~>?)";var z=w++;p[z]="(\\s*)"+p[F]+"\\s+",R[z]=new RegExp(p[z],"g");var $=w++;p[$]="^"+p[F]+p[l]+"$";var V=w++;p[V]="^"+p[F]+p[v]+"$";var B=w++;p[B]="(?:\\^)";var _=w++;p[_]="(\\s*)"+p[B]+"\\s+",R[_]=new RegExp(p[_],"g");var W=w++;p[W]="^"+p[B]+p[l]+"$";var K=w++;p[K]="^"+p[B]+p[v]+"$";var j=w++;p[j]="^"+p[o]+"\\s*("+r+")$|^$";var P=w++;p[P]="^"+p[o]+"\\s*("+t+")$|^$";var A=w++;p[A]="(\\s*)"+p[o]+"\\s*("+r+"|"+p[l]+")",R[A]=new RegExp(p[A],"g");var M=w++;p[M]="^\\s*("+p[l]+")\\s+-\\s+("+p[l]+")\\s*$";var N=w++;p[N]="^\\s*("+p[v]+")\\s+-\\s+("+p[v]+")\\s*$";var x=w++;p[x]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)k(H,p[H]),R[H]||(R[H]=new RegExp(p[H]));function J(X,re){if(X instanceof Q)return X;if(typeof X!="string"||X.length>T||!(re?R[i]:R[a]).test(X))return null;try{return new Q(X,re)}catch(se){return null}}function Q(X,re){if(X instanceof Q){if(X.loose===re)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Q))return new Q(X,re);k("SemVer",X,re),this.loose=re;var se=X.trim().match(re?R[i]:R[a]);if(!se)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var ve=+ye;if(ve>=0&&ve<O)return ve}return ye}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(X,re){var se=J(X,re);return se?se.version:null},e.clean=function(X,re){var se=J(X.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(X){return k("SemVer.compare",this.version,this.loose,X),X instanceof Q||(X=new Q(X,this.loose)),this.compareMain(X)||this.comparePre(X)},Q.prototype.compareMain=function(X){return X instanceof Q||(X=new Q(X,this.loose)),Z(this.major,X.major)||Z(this.minor,X.minor)||Z(this.patch,X.patch)},Q.prototype.comparePre=function(X){if(X instanceof Q||(X=new Q(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ye=X.prerelease[re];if(k("prerelease compare",re,se,ye),se===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(se===void 0)return-1;if(se!==ye)return Z(se,ye)}while(++re)},Q.prototype.inc=function(X,re){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,re,se,ye){typeof se=="string"&&(ye=se,se=void 0);try{return new Q(X,se).inc(re,ye).version}catch(ve){return null}},e.diff=function(X,re){if(Se(X,re))return null;var se=J(X),ye=J(re);if(se.prerelease.length||ye.prerelease.length){for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==ye[ve])return"pre"+ve;return"prerelease"}for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==ye[ve])return ve},e.compareIdentifiers=Z;var ie=/^[0-9]+$/;function Z(X,re){var se=ie.test(X),ye=ie.test(re);return se&&ye&&(X=+X,re=+re),se&&!ye?-1:ye&&!se?1:X<re?-1:X>re?1:0}function oe(X,re,se){return new Q(X,se).compare(new Q(re,se))}function ue(X,re,se){return oe(X,re,se)>0}function ge(X,re,se){return oe(X,re,se)<0}function Se(X,re,se){return oe(X,re,se)===0}function Ie(X,re,se){return oe(X,re,se)!==0}function Pe(X,re,se){return oe(X,re,se)>=0}function Fe(X,re,se){return oe(X,re,se)<=0}function Oe(X,re,se,ye){var ve;switch(re){case"===":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),ve=X===se;break;case"!==":typeof X=="object"&&(X=X.version),typeof se=="object"&&(se=se.version),ve=X!==se;break;case"":case"=":case"==":ve=Se(X,se,ye);break;case"!=":ve=Ie(X,se,ye);break;case">":ve=ue(X,se,ye);break;case">=":ve=Pe(X,se,ye);break;case"<":ve=ge(X,se,ye);break;case"<=":ve=Fe(X,se,ye);break;default:throw new TypeError("Invalid operator: "+re)}return ve}function ke(X,re){if(X instanceof ke){if(X.loose===re)return X;X=X.value}if(!(this instanceof ke))return new ke(X,re);k("comparator",X,re),this.loose=re,this.parse(X),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(X,re){return Z(re,X)},e.major=function(X,re){return new Q(X,re).major},e.minor=function(X,re){return new Q(X,re).minor},e.patch=function(X,re){return new Q(X,re).patch},e.compare=oe,e.compareLoose=function(X,re){return oe(X,re,!0)},e.rcompare=function(X,re,se){return oe(re,X,se)},e.sort=function(X,re){return X.sort(function(se,ye){return e.compare(se,ye,re)})},e.rsort=function(X,re){return X.sort(function(se,ye){return e.rcompare(se,ye,re)})},e.gt=ue,e.lt=ge,e.eq=Se,e.neq=Ie,e.gte=Pe,e.lte=Fe,e.cmp=Oe,e.Comparator=ke;var _e={};function be(X,re){if(X instanceof be)return X.loose===re?X:new be(X.raw,re);if(X instanceof ke)return new be(X.value,re);if(!(this instanceof be))return new be(X,re);if(this.loose=re,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Ae(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ke(X,re,se,ye,ve,Re,we,Te,Ce,Le,Ue,q,ne){return((re=Ae(se)?"":Ae(ye)?">="+se+".0.0":Ae(ve)?">="+se+"."+ye+".0":">="+re)+" "+(Te=Ae(Ce)?"":Ae(Le)?"<"+(+Ce+1)+".0.0":Ae(Ue)?"<"+Ce+"."+(+Le+1)+".0":q?"<="+Ce+"."+Le+"."+Ue+"-"+q:"<="+Te)).trim()}function Ye(X,re){for(var se=0;se<X.length;se++)if(!X[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<X.length;se++)if(k(X[se].semver),X[se].semver!==_e&&X[se].semver.prerelease.length>0){var ye=X[se].semver;if(ye.major===re.major&&ye.minor===re.minor&&ye.patch===re.patch)return!0}return!1}return!0}function $e(X,re,se){try{re=new be(re,se)}catch(ye){return!1}return re.test(X)}function xe(X,re,se,ye){var ve,Re,we,Te,Ce;switch(X=new Q(X,ye),re=new be(re,ye),se){case">":ve=ue,Re=Fe,we=ge,Te=">",Ce=">=";break;case"<":ve=ge,Re=Pe,we=ue,Te="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(X,re,ye))return!1;for(var Le=0;Le<re.set.length;++Le){var Ue=re.set[Le],q=null,ne=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new ke(">=0.0.0")),q=q||ae,ne=ne||ae,ve(ae.semver,q.semver,ye)?q=ae:we(ae.semver,ne.semver,ye)&&(ne=ae)}),q.operator===Te||q.operator===Ce||(!ne.operator||ne.operator===Te)&&Re(X,ne.semver)||ne.operator===Ce&&we(X,ne.semver))return!1}return!0}ke.prototype.parse=function(X){var re=this.loose?R[j]:R[P],se=X.match(re);if(!se)throw new TypeError("Invalid comparator: "+X);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=_e},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(X){return k("Comparator.test",X,this.loose),this.semver===_e||(typeof X=="string"&&(X=new Q(X,this.loose)),Oe(X,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(X,re){if(!(X instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new be(X.value,re),$e(this.value,se,re);if(X.operator==="")return se=new be(this.value,re),$e(X.semver,se,re);var ye=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Re=this.semver.version===X.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Te=Oe(this.semver,"<",X.semver,re)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Ce=Oe(this.semver,">",X.semver,re)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return ye||ve||Re&&we||Te||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(X){var re=this.loose;X=X.trim(),k("range",X,re);var se=re?R[N]:R[M];X=X.replace(se,Ke),k("hyphen replace",X),X=X.replace(R[A],"$1$2$3"),k("comparator trim",X,R[A]),X=(X=(X=X.replace(R[z],"$1~")).replace(R[_],"$1^")).split(/\s+/).join(" ");var ye=re?R[j]:R[P],ve=X.split(" ").map(function(Re){return function(we,Te){return k("comp",we),we=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Ue){return function(q,ne){k("caret",q,ne);var ae=ne?R[K]:R[W];return q.replace(ae,function(le,ce,fe,me,pe){var he;return k("caret",q,le,ce,fe,me,pe),Ae(ce)?he="":Ae(fe)?he=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ae(me)?he=ce==="0"?">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+".0 <"+(+ce+1)+".0.0":pe?(k("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),he=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+me+pe+" <"+ce+"."+fe+"."+(+me+1):">="+ce+"."+fe+"."+me+pe+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+me+pe+" <"+(+ce+1)+".0.0"):(k("no pr"),he=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+me+" <"+ce+"."+fe+"."+(+me+1):">="+ce+"."+fe+"."+me+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+me+" <"+(+ce+1)+".0.0"),k("caret return",he),he})}(Ue,Le)}).join(" ")}(we,Te),k("caret",we),we=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Ue){return function(q,ne){var ae=ne?R[V]:R[$];return q.replace(ae,function(le,ce,fe,me,pe){var he;return k("tilde",q,le,ce,fe,me,pe),Ae(ce)?he="":Ae(fe)?he=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ae(me)?he=">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":pe?(k("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),he=">="+ce+"."+fe+"."+me+pe+" <"+ce+"."+(+fe+1)+".0"):he=">="+ce+"."+fe+"."+me+" <"+ce+"."+(+fe+1)+".0",k("tilde return",he),he})}(Ue,Le)}).join(" ")}(we,Te),k("tildes",we),we=function(Ce,Le){return k("replaceXRanges",Ce,Le),Ce.split(/\s+/).map(function(Ue){return function(q,ne){q=q.trim();var ae=ne?R[f]:R[E];return q.replace(ae,function(le,ce,fe,me,pe,he){k("xRange",q,le,ce,fe,me,pe,he);var Ee=Ae(fe),De=Ee||Ae(me),Me=De||Ae(pe);return ce==="="&&Me&&(ce=""),Ee?le=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Me?(De&&(me=0),Me&&(pe=0),ce===">"?(ce=">=",De?(fe=+fe+1,me=0,pe=0):Me&&(me=+me+1,pe=0)):ce==="<="&&(ce="<",De?fe=+fe+1:me=+me+1),le=ce+fe+"."+me+"."+pe):De?le=">="+fe+".0.0 <"+(+fe+1)+".0.0":Me&&(le=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),k("xRange return",le),le})}(Ue,Le)}).join(" ")}(we,Te),k("xrange",we),we=function(Ce,Le){return k("replaceStars",Ce,Le),Ce.trim().replace(R[x],"")}(we,Te),k("stars",we),we}(Re,re)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Re){return!!Re.match(ye)})),ve=ve.map(function(Re){return new ke(Re,re)})},be.prototype.intersects=function(X,re){if(!(X instanceof be))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ye){return X.set.some(function(ve){return ve.every(function(Re){return ye.intersects(Re,re)})})})})},e.toComparators=function(X,re){return new be(X,re).set.map(function(se){return se.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},be.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new Q(X,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],X))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(X,re,se){var ye=null,ve=null;try{var Re=new be(re,se)}catch(we){return null}return X.forEach(function(we){Re.test(we)&&(ye&&ve.compare(we)!==-1||(ve=new Q(ye=we,se)))}),ye},e.minSatisfying=function(X,re,se){var ye=null,ve=null;try{var Re=new be(re,se)}catch(we){return null}return X.forEach(function(we){Re.test(we)&&(ye&&ve.compare(we)!==1||(ve=new Q(ye=we,se)))}),ye},e.validRange=function(X,re){try{return new be(X,re).range||"*"}catch(se){return null}},e.ltr=function(X,re,se){return xe(X,re,"<",se)},e.gtr=function(X,re,se){return xe(X,re,">",se)},e.outside=xe,e.prerelease=function(X,re){var se=J(X,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(X,re,se){return X=new be(X,se),re=new be(re,se),X.intersects(re)},e.coerce=function(X){if(X instanceof Q)return X;if(typeof X!="string")return null;var re=X.match(R[U]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,S(1))},function(G,e){var S,L,k=G.exports={};function T(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(I){if(S===setTimeout)return setTimeout(I,0);if((S===T||!S)&&setTimeout)return S=setTimeout,setTimeout(I,0);try{return S(I,0)}catch(b){try{return S.call(null,I,0)}catch(D){return S.call(this,I,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:T}catch(I){S=T}try{L=typeof clearTimeout=="function"?clearTimeout:O}catch(I){L=O}})();var p,w=[],n=!1,m=-1;function d(){n&&p&&(n=!1,p.length?w=p.concat(w):m=-1,w.length&&g())}function g(){if(!n){var I=R(d);n=!0;for(var b=w.length;b;){for(p=w,w=[];++m<b;)p&&p[m].run();m=-1,b=w.length}p=null,n=!1,function(D){if(L===clearTimeout)return clearTimeout(D);if((L===O||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(D);try{L(D)}catch(y){try{return L.call(null,D)}catch(s){return L.call(this,D)}}}(I)}}function h(I,b){this.fun=I,this.array=b}function C(){}k.nextTick=function(I){var b=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)b[D-1]=arguments[D];w.push(new h(I,b)),w.length!==1||n||R(g)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=C,k.addListener=C,k.once=C,k.off=C,k.removeListener=C,k.removeAllListeners=C,k.emit=C,k.prependListener=C,k.prependOnceListener=C,k.listeners=function(I){return[]},k.binding=function(I){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(I){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ee[89],te([0,1,7]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=S.globals.performance&&typeof S.globals.performance.now=="function";class k{constructor(O){this._highResolution=L&&O,this._startTime=this._now(),this._stopTime=-1}static create(O=!0){return new k(O)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ee[3],te([0,1,11,65,2,88,89]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(y){y.None=()=>k.Disposable.None;function s(B){return(_,W=null,K)=>{let j=!1,P;return P=B(A=>{if(!j)return P?P.dispose():j=!0,_.call(W,A)},null,K),j&&P.dispose(),P}}y.once=s;function a(B,_){return c((W,K=null,j)=>B(P=>W.call(K,_(P)),null,j))}y.map=a;function t(B,_){return c((W,K=null,j)=>B(P=>{_(P),W.call(K,P)},null,j))}y.forEach=t;function r(B,_){return c((W,K=null,j)=>B(P=>_(P)&&W.call(K,P),null,j))}y.filter=r;function i(B){return B}y.signal=i;function o(...B){return(_,W=null,K)=>k.combinedDisposable(...B.map(j=>j(P=>_.call(W,P),null,K)))}y.any=o;function u(B,_,W){let K=W;return a(B,j=>(K=_(K,j),K))}y.reduce=u;function c(B){let _;const W=new d({onFirstListenerAdd(){_=B(W.fire,W)},onLastListenerRemove(){_.dispose()}});return W.event}function l(B,_,W=100,K=!1,j){let P,A,M,N=0;const x=new d({leakWarningThreshold:j,onFirstListenerAdd(){P=B(H=>{N++,A=_(A,H),K&&!M&&(x.fire(A),A=void 0),clearTimeout(M),M=setTimeout(()=>{const J=A;A=void 0,M=void 0,(!K||N>1)&&x.fire(J),N=0},W)})},onLastListenerRemove(){P.dispose()}});return x.event}y.debounce=l;function v(B,_=(W,K)=>W===K){let W=!0,K;return r(B,j=>{const P=W||!_(j,K);return W=!1,K=j,P})}y.latch=v;function E(B,_){return[y.filter(B,_),y.filter(B,W=>!_(W))]}y.split=E;function f(B,_=!1,W=[]){let K=W.slice(),j=B(M=>{K?K.push(M):A.fire(M)});const P=()=>{K&&K.forEach(M=>A.fire(M)),K=null},A=new d({onFirstListenerAdd(){j||(j=B(M=>A.fire(M)))},onFirstListenerDidAdd(){K&&(_?setTimeout(P):P())},onLastListenerRemove(){j&&j.dispose(),j=null}});return A.event}y.buffer=f;class U{constructor(_){this.event=_}map(_){return new U(a(this.event,_))}forEach(_){return new U(t(this.event,_))}filter(_){return new U(r(this.event,_))}reduce(_,W){return new U(u(this.event,_,W))}latch(){return new U(v(this.event))}debounce(_,W=100,K=!1,j){return new U(l(this.event,_,W,K,j))}on(_,W,K){return this.event(_,W,K)}once(_,W,K){return s(this.event)(_,W,K)}}function F(B){return new U(B)}y.chain=F;function z(B,_,W=K=>K){const K=(...M)=>A.fire(W(...M)),j=()=>B.on(_,K),P=()=>B.removeListener(_,K),A=new d({onFirstListenerAdd:j,onLastListenerRemove:P});return A.event}y.fromNodeEventEmitter=z;function $(B,_,W=K=>K){const K=(...M)=>A.fire(W(...M)),j=()=>B.addEventListener(_,K),P=()=>B.removeEventListener(_,K),A=new d({onFirstListenerAdd:j,onLastListenerRemove:P});return A.event}y.fromDOMEventEmitter=$;function V(B){return new Promise(_=>s(B)(_))}y.toPromise=V})(R=e.Event||(e.Event={}));class p{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${p._idPool++}`}start(s){this._stopWatch=new O.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let w=-1;function n(y){const s=w;return w=y,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=n;class m{constructor(s,a=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let a=w;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||s<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let i,o=0;for(const[u,c]of this._stacks)(!i||o<c)&&(i=u,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class d{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(s,a,t)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[s,a]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,a);const o=this._leakageMon?.check(this._listeners.size);let u;return u={dispose:()=>{o&&o(),u.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},t instanceof k.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){S.onUnexpectedError(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d,d._noop=function(){};class g extends d{async fireAsync(s,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],u={...i,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),o.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){S.onUnexpectedError(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const l of c)l.status==="rejected"&&S.onUnexpectedError(l.reason)})}}}}e.AsyncEmitter=g;class h extends d{constructor(s){super(s);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class C extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=C;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const a={event:s,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return k.toDisposable(L.once(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(a=>this.emitter.fire(a))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class b{constructor(){this.buffers=[]}wrapEvent(s){return(a,t,r)=>s(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>a.call(t,i)):a.call(t,i)},void 0,r)}bufferEvents(s){const a=[];this.buffers.push(a);const t=s();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=b;class D{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(ee[29],te([0,1,3]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,p){const w=setTimeout(R.bind(p),0);return{dispose(){clearTimeout(w)}}});var k;(function(R){function p(w){return w===R.None||w===R.Cancelled||w instanceof T?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=p,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=O}),define(ee[54],te([0,1,3]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(m){const d=this._icons.get(m.id);d?m.description?d.description=m.description:console.error(`Duplicate registration of codicon ${m.id}`):(this._icons.set(m.id,m),this._onDidRegister.fire(m))}get(m){return this._icons.get(m)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new L;e.iconRegistry=k;function T(n,m){return new R(n,m)}e.registerCodicon=T;function O(n){return n?n.replace(/\$\((.*?)\)/g,(m,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=O;class R{constructor(m,d,g){this.id=m,this.definition=d,this.description=g,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function p(n,m){const d=["codicon","codicon-"+n];return m&&d.push("codicon-modifier-"+m),d}e.getClassNamesArray=p;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const m=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(C){if(C instanceof R)return["codicon","codicon-"+C.id];const I=m.exec(C.id);if(!I)return d(R.error);let[,b,D]=I;const y=["codicon","codicon-"+b];return D&&y.push("codicon-modifier-"+D.substr(1)),y}n.asClassNameArray=d;function g(C){return d(C).join(" ")}n.asClassName=g;function h(C){return"."+d(C).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(ee[47],te([0,1,11,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(y){const s=y;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=k;function T(y){const s=y;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=T;function O(y,s){return new R(y,s)}e.newWriteableStream=O;class R{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?S.onUnexpectedError(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(y,s){const a=[];let t;for(;(t=y.read())!==null;)a.push(t);return s(a)}e.consumeReadable=p;function w(y,s,a){const t=[];let r;for(;(r=y.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return y.read()}}}e.peekReadable=w;function n(y,s){return new Promise((a,t)=>{const r=[];m(y,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):a(void 0)},onEnd:()=>{a(s?s(r):void 0)}})})}e.consumeStream=n;function m(y,s){y.on("error",a=>s.onError(a)),y.on("end",()=>s.onEnd()),y.on("data",a=>s.onData(a))}e.listenStream=m;function d(y,s){return new Promise((a,t)=>{const r=new L.DisposableStore,i=[],o=l=>{if(i.push(l),i.length>s)return r.dispose(),y.pause(),a({stream:y,buffer:i,ended:!1})},u=l=>t(l),c=()=>a({stream:y,buffer:i,ended:!0});r.add(L.toDisposable(()=>y.removeListener("error",u))),y.on("error",u),r.add(L.toDisposable(()=>y.removeListener("end",c))),y.on("end",c),r.add(L.toDisposable(()=>y.removeListener("data",o))),y.on("data",o)})}e.peekStream=d;function g(y,s){const a=O(s);return a.end(y),a}e.toStream=g;function h(){const y=O(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=h;function C(y){let s=!1;return{read:()=>s?null:(s=!0,y)}}e.toReadable=C;function I(y,s,a){const t=O(a);return m(y,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=I;function b(y,s,a){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?a([y,r]):y)}}}e.prefixedReadable=b;function D(y,s,a){let t=!1;const r=O(a);return m(s,{onData:i=>t?r.write(i):(t=!0,r.write(a([y,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(y)),r.end()}}),r}e.prefixedStream=D}),define(ee[20],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=S;const L=/{(\d+)}/g;function k(q,...ne){return ne.length===0?q:q.replace(L,function(ae,le){const ce=parseInt(le,10);return isNaN(ce)||ce<0||ce>=ne.length?ae:ne[ce]})}e.format=k;const T=/{([^}]+)}/g;function O(q,ne){return q.replace(T,(ae,le)=>ne[le]??ae)}e.format2=O;function R(q){return q.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}e.escape=R;function p(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function w(q,ne){let ae=0;const le=ne.charCodeAt(0);for(let ce=q.length-1;ce>=0;ce--)q.charCodeAt(ce)===le&&ae++;return ae}e.count=w;function n(q,ne,ae="\u2026"){return q.length<=ne?q:`${q.substr(0,ne)}${ae}`}e.truncate=n;function m(q,ne=" "){const ae=d(q,ne);return g(ae,ne)}e.trim=m;function d(q,ne){if(!q||!ne)return q;const ae=ne.length;if(ae===0||q.length===0)return q;let le=0;for(;q.indexOf(ne,le)===le;)le=le+ae;return q.substring(le)}e.ltrim=d;function g(q,ne){if(!q||!ne)return q;const ae=ne.length,le=q.length;if(ae===0||le===0)return q;let ce=le,fe=-1;for(;fe=q.lastIndexOf(ne,ce-1),!(fe===-1||fe+ae!==ce);){if(fe===0)return"";ce=fe}return q.substring(0,ce)}e.rtrim=g;function h(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(q){return q.replace(/\*/g,"")}e.stripWildcards=C;function I(q,ne,ae={}){if(!q)throw new Error("Cannot create regex from empty string");ne||(q=p(q)),ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let le="";return ae.global&&(le+="g"),ae.matchCase||(le+="i"),ae.multiline&&(le+="m"),ae.unicode&&(le+="u"),new RegExp(q,le)}e.createRegExp=I;function b(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function D(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function y(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=y;function s(q){return q.split(/\r\n|\r|\n/)}e.splitLines=s;function a(q){for(let ne=0,ae=q.length;ne<ae;ne++){const le=q.charCodeAt(ne);if(le!==32&&le!==9)return ne}return-1}e.firstNonWhitespaceIndex=a;function t(q,ne=0,ae=q.length){for(let le=ne;le<ae;le++){const ce=q.charCodeAt(le);if(ce!==32&&ce!==9)return q.substring(ne,le)}return q.substring(ne,ae)}e.getLeadingWhitespace=t;function r(q,ne=q.length-1){for(let ae=ne;ae>=0;ae--){const le=q.charCodeAt(ae);if(le!==32&&le!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(q,ne){return q<ne?-1:q>ne?1:0}e.compare=i;function o(q,ne,ae=0,le=q.length,ce=0,fe=ne.length){for(;ae<le&&ce<fe;ae++,ce++){let he=q.charCodeAt(ae),Ee=ne.charCodeAt(ce);if(he<Ee)return-1;if(he>Ee)return 1}const me=le-ae,pe=fe-ce;return me<pe?-1:me>pe?1:0}e.compareSubstring=o;function u(q,ne){return c(q,ne,0,q.length,0,ne.length)}e.compareIgnoreCase=u;function c(q,ne,ae=0,le=q.length,ce=0,fe=ne.length){for(;ae<le&&ce<fe;ae++,ce++){let he=q.charCodeAt(ae),Ee=ne.charCodeAt(ce);if(he===Ee)continue;const De=he-Ee;if(!(De===32&&v(Ee))&&!(De===-32&&v(he)))return l(he)&&l(Ee)?De:o(q.toLowerCase(),ne.toLowerCase(),ae,le,ce,fe)}const me=le-ae,pe=fe-ce;return me<pe?-1:me>pe?1:0}e.compareSubstringIgnoreCase=c;function l(q){return q>=97&&q<=122}e.isLowerAsciiLetter=l;function v(q){return q>=65&&q<=90}e.isUpperAsciiLetter=v;function E(q){return l(q)||v(q)}function f(q,ne){return q.length===ne.length&&U(q,ne)}e.equalsIgnoreCase=f;function U(q,ne,ae=q.length){for(let le=0;le<ae;le++){const ce=q.charCodeAt(le),fe=ne.charCodeAt(le);if(ce!==fe){if(E(ce)&&E(fe)){const me=Math.abs(ce-fe);if(me!==0&&me!==32)return!1}else if(String.fromCharCode(ce).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function F(q,ne){const ae=ne.length;return ne.length>q.length?!1:U(q,ne,ae)}e.startsWithIgnoreCase=F;function z(q,ne){let ae,le=Math.min(q.length,ne.length);for(ae=0;ae<le;ae++)if(q.charCodeAt(ae)!==ne.charCodeAt(ae))return ae;return le}e.commonPrefixLength=z;function $(q,ne){let ae,le=Math.min(q.length,ne.length);const ce=q.length-1,fe=ne.length-1;for(ae=0;ae<le;ae++)if(q.charCodeAt(ce-ae)!==ne.charCodeAt(fe-ae))return ae;return le}e.commonSuffixLength=$;function V(q){return 55296<=q&&q<=56319}e.isHighSurrogate=V;function B(q){return 56320<=q&&q<=57343}e.isLowSurrogate=B;function _(q,ne){return(q-55296<<10)+(ne-56320)+65536}e.computeCodePoint=_;function W(q,ne,ae){const le=q.charCodeAt(ae);if(V(le)&&ae+1<ne){const ce=q.charCodeAt(ae+1);if(B(ce))return _(le,ce)}return le}e.getNextCodePoint=W;function K(q,ne){const ae=q.charCodeAt(ne-1);if(B(ae)&&ne>1){const le=q.charCodeAt(ne-2);if(V(le))return _(le,ae)}return ae}function j(q,ne){const ae=ve.getInstance(),le=ne,ce=q.length,fe=W(q,ce,ne);ne+=fe>=65536?2:1;let me=ae.getGraphemeBreakType(fe);for(;ne<ce;){const pe=W(q,ce,ne),he=ae.getGraphemeBreakType(pe);if(se(me,he))break;ne+=pe>=65536?2:1,me=he}return ne-le}e.nextCharLength=j;function P(q,ne){const ae=ve.getInstance(),le=ne,ce=K(q,ne);ne-=ce>=65536?2:1;let fe=ae.getGraphemeBreakType(ce);for(;ne>0;){const me=K(q,ne),pe=ae.getGraphemeBreakType(me);if(se(pe,fe))break;ne-=me>=65536?2:1,fe=pe}return le-ne}e.prevCharLength=P;function A(q,ne){const ae=ve.getInstance(),le=q.length,ce=ne,fe=W(q,le,ne),me=ae.getGraphemeBreakType(fe);ne+=fe>=65536?2:1;let pe=me;for(;ne<le;){const Ee=W(q,le,ne),De=ae.getGraphemeBreakType(Ee);if(se(pe,De))break;ne+=Ee>=65536?2:1,pe=De}const he=ne;for(ne=ce,pe=me;ne>0;){const Ee=K(q,ne),De=ae.getGraphemeBreakType(Ee);if(se(De,pe))break;ne-=Ee>=65536?2:1,pe=De}return[ne,he]}function M(q,ne){return ne>0&&B(q.charCodeAt(ne))?A(q,ne-1):A(q,ne)}e.getCharContainingOffset=M;function N(q){const ne=q.length;let ae=0,le=0;for(;le<ne;){const me=W(q,ne,le);le+=me>=65536?2:1,me<128?ae+=1:me<2048?ae+=2:me<65536?ae+=3:ae+=4}const ce=new Uint8Array(ae);le=0;let fe=0;for(;le<ne;){const me=W(q,ne,le);le+=me>=65536?2:1,me<128?ce[fe++]=me:me<2048?(ce[fe++]=192|(me&1984)>>>6,ce[fe++]=128|(me&63)>>>0):me<65536?(ce[fe++]=224|(me&61440)>>>12,ce[fe++]=128|(me&4032)>>>6,ce[fe++]=128|(me&63)>>>0):(ce[fe++]=240|(me&1835008)>>>18,ce[fe++]=128|(me&258048)>>>12,ce[fe++]=128|(me&4032)>>>6,ce[fe++]=128|(me&63)>>>0)}return ce}e.encodeUTF8=N;function x(q){const ne=q.byteLength,ae=[];let le=0;for(;le<ne;){const ce=q[le];let fe;if(ce>=240&&le+3<ne?fe=(q[le++]&7)<<18>>>0|(q[le++]&63)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:ce>=224&&le+2<ne?fe=(q[le++]&15)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:ce>=192&&le+1<ne?fe=(q[le++]&31)<<6>>>0|(q[le++]&63)<<0>>>0:fe=q[le++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)ae.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const me=fe-65536,pe=55296+((me&1047552)>>>10),he=56320+((me&1023)>>>0);ae.push(String.fromCharCode(pe)),ae.push(String.fromCharCode(he))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=x;const H=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function J(q){return H.test(q)}e.containsRTL=J;const Q=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(q){return Q.test(q)}e.containsEmoji=ie;const Z=/^[\t\n\r\x20-\x7E]*$/;function oe(q){return Z.test(q)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ue(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ue;function ge(q){for(let ne=0,ae=q.length;ne<ae;ne++)if(Se(q.charCodeAt(ne)))return!0;return!1}e.containsFullWidthCharacter=ge;function Se(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=Se;function Ie(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=Ie;function Pe(q,ne){if(q.length<ne)return q;const ae=/\b/g;let le=0;for(;ae.test(q)&&!(q.length-ae.lastIndex<ne);)le=ae.lastIndex,ae.lastIndex+=1;return q.substring(le).replace(/^\s/,"")}e.lcut=Pe;const Fe=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function _e(q){return q&&(q=q.replace(Fe,""),q=q.replace(Oe,""),q=q.replace(ke,"")),q}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ae(q){return be(q)?q.substr(1):q}e.stripUTF8BOM=Ae;function Ke(q,ne){if(!q||!ne||q.length<ne.length)return!1;const ae=ne.length,le=q.toLowerCase();let ce=0,fe=-1;for(;ce<ae;){const me=le.indexOf(ne[ce],fe+1);if(me<0)return!1;fe=me,ce++}return!0}e.fuzzyContains=Ke;function Ye(q,ne=!1){return q?(ne&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Ye;function $e(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=$e;function xe(q,ne=1){if(ne===0)return"";let ae=-1;do ae=q.indexOf(`
`,ae+1),ne--;while(ne>0&&ae>=0);return ae===-1?q:(q[ae-1]==="\r"&&ae--,q.substr(0,ae))}e.getNLines=xe;function X(q){const ne=90-65+1;return q=q%(2*ne),q<ne?String.fromCharCode(97+q):String.fromCharCode(65+q-ne)}e.singleLetterHash=X;function re(q){return ve.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=re;function se(q,ne){return q===0?ne!==5&&ne!==7:q===2&&ne===3?!1:q===4||q===2||q===3||ne===4||ne===2||ne===3?!0:!(q===8&&(ne===8||ne===9||ne===11||ne===12)||(q===11||q===9)&&(ne===9||ne===10)||(q===12||q===10)&&ne===10||ne===5||ne===13||ne===7||q===1||q===13&&ne===14||q===6&&ne===6)}e.breakBetweenGraphemeBreakType=se;var ye;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=Re()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const ae=this._data,le=ae.length/3;let ce=1;for(;ce<=le;)if(ne<ae[3*ce])ce=2*ce;else if(ne>ae[3*ce+1])ce=2*ce+1;else return ae[3*ce+2];return 0}}ve._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(q,ne){if(q===0)return 0;const ae=Te(q,ne);if(ae!==void 0)return ae;const le=K(ne,q);return q-=Ce(le),q}e.getLeftDeleteOffset=we;function Te(q,ne){let ae=K(ne,q);for(q-=Ce(ae);Le(ae)||ae===65039||ae===8419;){if(q===0)return;ae=K(ne,q),q-=Ce(ae)}if(!!Ie(ae)){if(q>=0){const le=K(ne,q);le===8205&&(q-=Ce(le))}return q}}function Ce(q){return q>=65536?2:1}function Le(q){return 127995<=q&&q<=127999}var Ue;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(ee[25],te([0,1,20,47]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let R,p;class w{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return k?new w(Buffer.allocUnsafe(l)):new w(new Uint8Array(l))}static wrap(l){return k&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new w(l)}static fromString(l,v){return!(v?.dontUseNodeBuffer||!1)&&k?new w(Buffer.from(l)):T?(R||(R=new TextEncoder),new w(R.encode(l))):new w(S.encodeUTF8(l))}static concat(l,v){if(typeof v=="undefined"){v=0;for(let U=0,F=l.length;U<F;U++)v+=l[U].byteLength}const E=w.alloc(v);let f=0;for(let U=0,F=l.length;U<F;U++){const z=l[U];E.set(z,f),f+=z.byteLength}return E}toString(){return k?this.buffer.toString():O?(p||(p=new TextDecoder),p.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(l,v){return new w(this.buffer.subarray(l,v))}set(l,v){l instanceof w?this.buffer.set(l.buffer,v):this.buffer.set(l,v)}readUInt32BE(l){return d(this.buffer,l)}writeUInt32BE(l,v){g(this.buffer,l,v)}readUInt32LE(l){return h(this.buffer,l)}writeUInt32LE(l,v){C(this.buffer,l,v)}readUInt8(l){return I(this.buffer,l)}writeUInt8(l,v){b(this.buffer,l,v)}}e.VSBuffer=w;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function m(c,l,v){c[v+0]=l&255,l=l>>>8,c[v+1]=l&255}e.writeUInt16LE=m;function d(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=d;function g(c,l,v){c[v+3]=l,l=l>>>8,c[v+2]=l,l=l>>>8,c[v+1]=l,l=l>>>8,c[v]=l}e.writeUInt32BE=g;function h(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=h;function C(c,l,v){c[v+0]=l&255,l=l>>>8,c[v+1]=l&255,l=l>>>8,c[v+2]=l&255,l=l>>>8,c[v+3]=l&255}e.writeUInt32LE=C;function I(c,l){return c[l]}e.readUInt8=I;function b(c,l,v){c[v]=l}e.writeUInt8=b;function D(c){return L.consumeReadable(c,l=>w.concat(l))}e.readableToBuffer=D;function y(c){return L.toReadable(c)}e.bufferToReadable=y;function s(c){return L.consumeStream(c,l=>w.concat(l))}e.streamToBuffer=s;async function a(c){return c.ended?w.concat(c.buffer):w.concat([...c.buffer,await s(c.stream)])}e.bufferedStreamToBuffer=a;function t(c){return L.toStream(c,l=>w.concat(l))}e.bufferToStream=t;function r(c){return L.transform(c,{data:l=>typeof l=="string"?w.fromString(l):w.wrap(l)},l=>w.concat(l))}e.streamToBufferReadableStream=r;function i(c){return L.newWriteableStream(l=>w.concat(l),c)}e.newWriteableBufferStream=i;function o(c,l){return L.prefixedReadable(c,l,v=>w.concat(v))}e.prefixedBufferReadable=o;function u(c,l){return L.prefixedStream(c,l,v=>w.concat(v))}e.prefixedBufferStream=u}),define(ee[16],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(l){return Array.isArray(l)}e.isArray=S;function L(l){return typeof l=="string"}e.isString=L;function k(l){return Array.isArray(l)&&l.every(v=>L(v))}e.isStringArray=k;function T(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=T;function O(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=O;function R(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=R;function p(l){return l===!0||l===!1}e.isBoolean=p;function w(l){return typeof l=="undefined"}e.isUndefined=w;function n(l){return!m(l)}e.isDefined=n;function m(l){return w(l)||l===null}e.isUndefinedOrNull=m;function d(l,v){if(!l)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=d;function g(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=g;function h(...l){const v=[];for(let E=0;E<l.length;E++){const f=l[E];if(m(f))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);v.push(f)}return v}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function I(l){if(!T(l))return!1;for(let v in l)if(C.call(l,v))return!1;return!0}e.isEmptyObject=I;function b(l){return typeof l=="function"}e.isFunction=b;function D(...l){return l.length>0&&l.every(b)}e.areFunctions=D;function y(l,v){const E=Math.min(l.length,v.length);for(let f=0;f<E;f++)s(l[f],v[f])}e.validateConstraints=y;function s(l,v){if(L(v)){if(typeof l!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(b(v)){try{if(l instanceof v)return}catch{}if(!m(l)&&l.constructor===v||v.length===1&&v.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function a(l){let v=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)v=v.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return v}e.getAllPropertyNames=a;function t(l){const v=[];for(const E of a(l))typeof l[E]=="function"&&v.push(E);return v}e.getAllMethodNames=t;function r(l,v){const E=U=>function(){const F=Array.prototype.slice.call(arguments,0);return v(U,F)};let f={};for(const U of l)f[U]=E(U);return f}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function o(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=o;function u(l){return class{constructor(){return new Proxy({},{get(v,E){if(v[E])return v[E];throw new Error(`Not Implemented: ${l}->${String(E)}`)}})}}}e.NotImplementedProxy=u;function c(l){throw new Error("Unreachable")}e.assertNever=c}),define(ee[41],te([0,1,7,20,8,16]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(i){return i===47||i===92}e.isPathSeparator=O;function R(i){return i.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function p(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function w(i,o=k.posix.sep){if(!i)return"";const u=i.length,c=i.charCodeAt(0);if(O(c)){if(O(i.charCodeAt(1))&&!O(i.charCodeAt(2))){let v=3;const E=v;for(;v<u&&!O(i.charCodeAt(v));v++);if(E!==v&&!O(i.charCodeAt(v+1))){for(v+=1;v<u;v++)if(O(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,o)}}return o}else if(b(c)&&i.charCodeAt(1)===58)return O(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(O(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=w;function n(i){if(!S.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let u=2;const c=u;for(;u<i.length&&(o=i.charCodeAt(u),o!==92);u++);return!(c===u||(o=i.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=n;const m=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=S.isWindows){const u=o?m:d;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||o&&g.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,o,u){const c=i===o;return!u||c?c:!i||!o?!1:L.equalsIgnoreCase(i,o)}e.isEqual=C;function I(i,o,u,c=k.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(u){if(!L.startsWithIgnoreCase(i,o))return!1;if(o.length===i.length)return!0;let v=o.length;return o.charAt(o.length-1)===c&&v--,i.charAt(v)===c}return o.charAt(o.length-1)!==c&&(o+=c),i.indexOf(o)===0}e.isEqualOrParent=I;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function D(i,o){return S.isWindows&&i.endsWith(":")&&(i+=k.sep),k.isAbsolute(i)||(i=k.join(o,i)),i=k.normalize(i),S.isWindows?(i=L.rtrim(i,k.sep),i.endsWith(":")&&(i+=k.sep)):(i=L.rtrim(i,k.sep),i||(i=k.sep)),i}e.sanitizeFilePath=D;function y(i){const o=k.normalize(i);return S.isWindows?i.length>3?!1:s(o)&&(i.length===2||o.charCodeAt(2)===92):o===k.posix.sep}e.isRootOrDriveLetter=y;function s(i){return S.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function a(i){return s(i)?i[0]:void 0}e.getDriveLetter=a;function t(i,o,u){return o.length>i.length?-1:i===o?0:(u&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=t;function r(i){const o=i.split(":");let u,c,l;if(o.forEach(v=>{const E=Number(v);T.isNumber(E)?c===void 0?c=E:l===void 0&&(l=E):u=u?[u,v].join(":"):v}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ee[26],te([0,1,16]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const I=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?I[b]=L(C[b]):I[b]=C[b]}),I}e.deepClone=L;function k(C){if(!C||typeof C!="object")return C;const I=[C];for(;I.length>0;){const b=I.shift();Object.freeze(b);for(const D in b)if(T.call(b,D)){const y=b[D];typeof y=="object"&&!Object.isFrozen(y)&&I.push(y)}}return C}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function O(C,I){return R(C,I,new Set)}e.cloneAndChange=O;function R(C,I,b){if(S.isUndefinedOrNull(C))return C;const D=I(C);if(typeof D!="undefined")return D;if(S.isArray(C)){const y=[];for(const s of C)y.push(R(s,I,b));return y}if(S.isObject(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const y={};for(let s in C)T.call(C,s)&&(y[s]=R(C[s],I,b));return b.delete(C),y}return C}function p(C,I,b=!0){return S.isObject(C)?(S.isObject(I)&&Object.keys(I).forEach(D=>{D in C?b&&(S.isObject(C[D])&&S.isObject(I[D])?p(C[D],I[D],b):C[D]=I[D]):C[D]=I[D]}),C):I}e.mixin=p;function w(C,I){if(C===I)return!0;if(C==null||I===null||I===void 0||typeof C!=typeof I||typeof C!="object"||Array.isArray(C)!==Array.isArray(I))return!1;let b,D;if(Array.isArray(C)){if(C.length!==I.length)return!1;for(b=0;b<C.length;b++)if(!w(C[b],I[b]))return!1}else{const y=[];for(D in C)y.push(D);y.sort();const s=[];for(D in I)s.push(D);if(s.sort(),!w(y,s))return!1;for(b=0;b<y.length;b++)if(!w(C[y[b]],I[y[b]]))return!1}return!0}e.equals=w;function n(C){const I=new Set;return JSON.stringify(C,(b,D)=>{if(S.isObject(D)||Array.isArray(D)){if(I.has(D))return"[Circular]";I.add(D)}return D})}e.safeStringify=n;function m(C,I,b){const D=I(C);return typeof D=="undefined"?b:D}e.getOrDefault=m;function d(C,I){const b=Object.create(null);return!C||!I||Object.keys(I).forEach(y=>{const s=C[y],a=I[y];w(s,a)||(b[y]=a)}),b}e.distinct=d;function g(C,I){const b=I.toLowerCase(),D=Object.keys(C).find(y=>y.toLowerCase()===b);return D?C[D]:C[I]}e.getCaseInsensitive=g;function h(C,I){const b=Object.create(null);for(const D of Object.keys(C))I(D,C[D])&&(b[D]=C[D]);return b}e.filter=h}),define(ee[5],te([0,1,7,8]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,O=/^\/\//;function R(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!T.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,o){return!i&&!o?"file":i}function w(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==m&&(o=m+o):o=m;break}return o}const n="",m="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(o,u,c,l,v,E=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=p(o,E),this.authority=u||n,this.path=w(this.scheme,c||n),this.query=l||n,this.fragment=v||n,R(this,E))}static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return y(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:c,path:l,query:v,fragment:E}=o;return u===void 0?u=this.scheme:u===null&&(u=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),v===void 0?v=this.query:v===null&&(v=n),E===void 0?E=this.fragment:E===null&&(E=n),u===this.scheme&&c===this.authority&&l===this.path&&v===this.query&&E===this.fragment?this:new C(u,c,l,v,E)}static parse(o,u=!1){const c=d.exec(o);return c?new C(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),u):new C(n,n,n,n,n)}static file(o){let u=n;if(S.isWindows&&(o=o.replace(/\\/g,m)),o[0]===m&&o[1]===m){const c=o.indexOf(m,2);c===-1?(u=o.substring(2),o=m):(u=o.substring(2,c),o=o.substring(c)||m)}return new C("file",u,o,n,n)}static from(o){const u=new C(o.scheme,o.authority,o.path,o.query,o.fragment);return R(u,!0),u}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return S.isWindows&&o.scheme==="file"?c=g.file(L.win32.join(y(o,!0),...u)).path:c=L.posix.join(o.path,...u),o.with({path:c})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new C(o);return u._formatted=o.external,u._fsPath=o._sep===h?o.fsPath:null,u}}else return o}}e.URI=g;const h=S.isWindows?1:void 0;class C extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,o){let u,c=-1;for(let l=0;l<i.length;l++){const v=i.charCodeAt(l);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||o&&v===47)c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const E=I[v];E!==void 0?(c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u+=E):c===-1&&(c=l)}}return c!==-1&&(u+=encodeURIComponent(i.substring(c))),u!==void 0?u:i}function D(i){let o;for(let u=0;u<i.length;u++){const c=i.charCodeAt(u);c===35||c===63?(o===void 0&&(o=i.substr(0,u)),o+=I[c]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function y(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,S.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=y;function s(i,o){const u=o?D:b;let c="",{scheme:l,authority:v,path:E,query:f,fragment:U}=i;if(l&&(c+=l,c+=":"),(v||l==="file")&&(c+=m,c+=m),v){let F=v.indexOf("@");if(F!==-1){const z=v.substr(0,F);v=v.substr(F+1),F=z.indexOf(":"),F===-1?c+=u(z,!1):(c+=u(z.substr(0,F),!1),c+=":",c+=u(z.substr(F+1),!1)),c+="@"}v=v.toLowerCase(),F=v.indexOf(":"),F===-1?c+=u(v,!1):(c+=u(v.substr(0,F),!1),c+=v.substr(F))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const F=E.charCodeAt(1);F>=65&&F<=90&&(E=`/${String.fromCharCode(F+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const F=E.charCodeAt(0);F>=65&&F<=90&&(E=`${String.fromCharCode(F+32)}:${E.substr(2)}`)}c+=u(E,!0)}return f&&(c+="?",c+=u(f,!1)),U&&(c+="#",c+=o?U:b(U,!1)),c}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,o=>a(o)):i}}),define(ee[90],te([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function k(w){const n=[];let m;try{const d=JSON.parse(w.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),m=g.__$stack),n.push(...d)}catch(d){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:m}}e.parse=k;function T(w){if(typeof w!="string")return T(k(w).stack);const n=w;if(n){const m=O(n),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(d&&d.length===4)return{uri:S.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=T;function O(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function R(w,n){const{args:m,stack:d}=k(w),g=typeof m[0]=="string"&&m.length===1;let h=O(d);h&&(h=`(${h.trim()})`);let C=[];if(typeof m[0]=="string"?h&&g?C=[`%c[${n}] %c${m[0]} %c${h}`,p("blue"),p(""),p("grey")]:C=[`%c[${n}] %c${m[0]}`,p("blue"),p(""),...m.slice(1)]:C=[`%c[${n}]%`,p("blue"),...m],h&&!g&&C.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=R;function p(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(G,e,S,L,k){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!k:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?k.call(G,S):k?k.value=S:e.set(G,S),S},ze=this&&this.__classPrivateFieldGet||function(G,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(G):L?L.value:e.get(G)};define(ee[38],te([0,1,5,20]),function(G,e,S,L){"use strict";var k,T,O;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let o=t.get(r);return o===void 0&&(o=i,t.set(r,o)),o}e.getOrSet=R;function p(t){const r=[];return t.forEach((i,o)=>{r.push(`${o} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return i-o}value(){return this._value[this._pos]}}e.StringIterator=n;class m{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class d{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new h(r))}static forPaths(){return new I(new d)}static forStrings(){return new I(new n)}static forConfigKeys(){return new I(new m)}clear(){this._root=void 0}set(r,i){const o=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=o.value()),u=this._root;;){const l=o.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=o.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=o.value()),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new C,u.mid.segment=o.value()),u=u.mid;else break}const c=u.value;return u.value=i,u.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else break}return o}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const o=this._iter.reset(r),u=[];let c=this._root;for(;c;){const l=o.cmp(c.segment);if(l>0)u.push([1,c]),c=c.left;else if(l<0)u.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),u.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;u.length>0&&c.isEmpty();){let[v,E]=u.pop();switch(v){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}c=E}break}}}findSubstr(r){const i=this._iter.reset(r);let o=this._root,u;for(;o;){const c=i.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(i.hasNext())i.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[i,o]of this)r(o,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const o=i.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&i.push(o.left),o.mid&&i.push(o.mid),o.right&&i.push(o.right))}}}e.TernarySearchTree=I;class b{constructor(r,i){this[k]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[o,u]of this.map)r(u,S.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield S.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[S.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[S.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class y{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const o=this._map.get(r);if(!!o)return i!==0&&this.touch(o,i),o.value}set(r,i,o=0){let u=this._map.get(r);if(u)u.value=i,o!==0&&this.touch(u,o);else{switch(u={key:r,value:i,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const o=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,o=this.size;for(;i&&o>r;)this._map.delete(i.key),i=i.next,o--;this._head=i,this._size=o,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,o=r.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const o=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const o=r.next,u=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,o)=>{r.push([o,i])}),r}fromJSON(r){this.clear();for(const[i,o]of r)this.set(i,o)}}e.LinkedMap=y;class s extends y{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class a{constructor(r){O.set(this,void 0),ut(this,O,r,"f")}get size(){return ze(this,O,"f").size}forEach(r,i){ze(this,O,"f").forEach(r,i)}get(r){return ze(this,O,"f").get(r)}has(r){return ze(this,O,"f").has(r)}entries(){return ze(this,O,"f").entries()}keys(){return ze(this,O,"f").keys()}values(){return ze(this,O,"f").values()}[(O=new WeakMap,Symbol.iterator)](){return ze(this,O,"f").entries()}}e.ReadonlyMapView=a}),define(ee[91],te([0,1,25,20,5]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,p)}e.stringify=T;function O(n){let m=JSON.parse(n);return m=w(m),m}e.parse=O;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function p(n,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:L.regExpFlags(m)}:m}function w(n,m=0){if(!n||m>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return k.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof S.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=w(n[d],m+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=w(n[d],m+1))}return n}e.revive=w}),define(ee[17],te([0,1,5,7]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,w,n){this._hosts[p]=w,this._ports[p]=n}setConnectionToken(p,w){this._connectionTokens[p]=w}rewrite(p){if(this._delegate)return this._delegate(p);const w=p.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const m=this._ports[w],d=this._connectionTokens[w];let g=`path=${encodeURIComponent(p.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),S.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${n}:${m}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class O{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,w,n){const m=this.toUri(p,w);if(m.scheme===k.vscodeRemote)return e.RemoteAuthorities.rewrite(m);let d=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&m.scheme===k.file&&(d=!0),m.scheme===k.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(d=!0),d?m.with({scheme:k.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(p,w){const n=this.toUri(p,w);return n.scheme===k.vscodeFileResource?n.with({scheme:k.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,w){return S.URI.isUri(p)?p:S.URI.parse(w.toUrl(p))}}e.FileAccess=new O}),define(ee[66],te([0,1,38]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new S.LRUCache(1e4);function k(w){return p(w,"NFC",L)}e.normalizeNFC=k;const T=new S.LRUCache(1e4);function O(w){return p(w,"NFD",T)}e.normalizeNFD=O;const R=/[^\u0000-\u0080]/;function p(w,n,m){if(!e.canNormalize||!w)return w;const d=m.get(w);if(d)return d;let g;return R.test(w)?g=w.normalize(n):g=w,m.set(w,g),g}e.removeAccents=function(){if(e.canNormalize){const w=/[\u0300-\u036f]/g;return function(n){return O(n).replace(w,"")}}else return function(w){return w}}()}),define(ee[12],te([0,1,41,8,5,20,17,7]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(g){return k.uriToFsPath(g,!0)}e.originalFSPath=p;class w{constructor(h){this._ignorePathCasing=h}compare(h,C,I=!1){return h===C?0:T.compare(this.getComparisonKey(h,I),this.getComparisonKey(C,I))}isEqual(h,C,I=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,I)===this.getComparisonKey(C,I)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,I=!1){if(h.scheme===C.scheme){if(h.scheme===O.Schemas.file)return S.isEqualOrParent(p(h),p(C),this._ignorePathCasing(h))&&h.query===C.query&&(I||h.fragment===C.fragment);if(e.isEqualAuthority(h.authority,C.authority))return S.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(I||h.fragment===C.fragment)}return!1}joinPath(h,...C){return k.URI.joinPath(h,...C)}basenameOrAuthority(h){return e.basename(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===O.Schemas.file?C=k.URI.file(L.dirname(p(h))).path:(C=L.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===O.Schemas.file?C=k.URI.file(L.normalize(p(h))).path:C=L.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!e.isEqualAuthority(h.authority,C.authority))return;if(h.scheme===O.Schemas.file){const D=L.relative(p(h),p(C));return R.isWindows?S.toSlashes(D):D}let I=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let D=0;for(const y=Math.min(I.length,b.length);D<y&&!(I.charCodeAt(D)!==b.charCodeAt(D)&&I.charAt(D).toLowerCase()!==b.charAt(D).toLowerCase());D++);I=b.substr(0,D)+I.substr(D)}return L.posix.relative(I,b)}resolvePath(h,C){if(h.scheme===O.Schemas.file){const I=k.URI.file(L.resolve(p(h),C));return h.with({authority:I.authority,path:I.path})}return C=S.toPosixPath(C),h.with({path:L.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||T.equalsIgnoreCase(h,C)}hasTrailingPathSeparator(h,C=L.sep){if(h.scheme===O.Schemas.file){const I=p(h);return I.length>S.getRoot(I).length&&I[I.length-1]===C}else{const I=h.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=L.sep){return e.hasTrailingPathSeparator(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=L.sep){let I=!1;if(h.scheme===O.Schemas.file){const b=p(h);I=b!==void 0&&b.length===S.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;I=b.length===1&&b.charCodeAt(b.length-1)===47}return!I&&!e.hasTrailingPathSeparator(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(g=>g.scheme===O.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(g,h){const C=[];for(let I=0;I<g.length;I++){const b=h(g[I]);g.some((D,y)=>y===I?!1:e.isEqualOrParent(b,h(D)))||C.push(g[I])}return C}e.distinctParents=n;var m;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function h(C){const I=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(y=>{const[s,a]=y.split(":");s&&a&&I.set(s,a)});const D=C.path.substring(0,C.path.indexOf(";"));return D&&I.set(g.META_DATA_MIME,D),I}g.parseMetaData=h})(m=e.DataUri||(e.DataUri={}));function d(g,h,C){if(h){let I=g.path;return I&&I[0]!==L.posix.sep&&(I=L.posix.sep+I),g.with({scheme:C,authority:h,path:I})}return g.with({scheme:C})}e.toLocalResource=d}),define(ee[6],te([0,1,29,11,3,2,12]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(K){return!!K&&typeof K.then=="function"}e.isThenable=R;function p(K){const j=new S.CancellationTokenSource,P=K(j.token),A=new Promise((M,N)=>{j.token.onCancellationRequested(()=>{N(L.canceled())}),Promise.resolve(P).then(x=>{j.dispose(),M(x)},x=>{j.dispose(),N(x)})});return new class{cancel(){j.cancel()}then(M,N){return A.then(M,N)}catch(M){return this.then(void 0,M)}finally(M){return A.finally(M)}}}e.createCancelablePromise=p;function w(K,j,P){return Promise.race([K,new Promise(A=>j.onCancellationRequested(()=>A(P)))])}e.raceCancellation=w;async function n(K){let j=-1;const P=K.map((M,N)=>M.then(x=>(j=N,x))),A=await Promise.race(P);return K.forEach((M,N)=>{N!==j&&M.cancel()}),A}e.raceCancellablePromises=n;function m(K,j,P){let A;const M=setTimeout(()=>{A?.(void 0),P?.()},j);return Promise.race([K.finally(()=>clearTimeout(M)),new Promise(N=>A=N)])}e.raceTimeout=m;function d(K){return new Promise((j,P)=>{const A=K();R(A)?A.then(j,P):j(A)})}e.asPromise=d;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const P=()=>{this.queuedPromise=null;const A=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,A};this.queuedPromise=new Promise(A=>{this.activePromise.then(P,P).then(A)})}return new Promise((P,A)=>{this.queuedPromise.then(P,A)})}return this.activePromise=j(),new Promise((P,A)=>{this.activePromise.then(M=>{this.activePromise=null,P(M)},M=>{this.activePromise=null,A(M)})})}}e.Throttler=g;class h{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(j,P){const M=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.promiseMap.get(j)===M&&this.promiseMap.delete(j)});return this.promiseMap.set(j,M),M}}e.SequencerByKey=C;class I{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,P=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((A,M)=>{this.doResolve=A,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const A=this.task;return this.task=null,A()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},P),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class b{constructor(j){this.delayer=new I(j),this.throttler=new g}trigger(j,P){return this.delayer.trigger(()=>this.throttler.queue(j),P)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class D{constructor(){this._isOpen=!1,this._promise=new Promise((j,P)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=D;class y extends D{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=y;function s(K,j){return j?new Promise((P,A)=>{const M=setTimeout(P,K);j.onCancellationRequested(()=>{clearTimeout(M),A(L.canceled())})}):p(P=>s(K,P))}e.timeout=s;function a(K,j=0){const P=setTimeout(K,j);return T.toDisposable(()=>clearTimeout(P))}e.disposableTimeout=a;function t(K){return K.then(void 0,j=>{})}e.ignoreErrors=t;function r(K){const j=[];let P=0;const A=K.length;function M(){return P<A?K[P++]():null}function N(x){x!=null&&j.push(x);const H=M();return H?H.then(N):Promise.resolve(j)}return Promise.resolve(null).then(N)}e.sequence=r;function i(K,j=A=>!!A,P=null){let A=0;const M=K.length,N=()=>{if(A>=M)return Promise.resolve(P);const x=K[A++];return Promise.resolve(x()).then(J=>j(J)?Promise.resolve(J):N())};return N()}e.first=i;function o(K,j=A=>!!A,P=null){if(K.length===0)return Promise.resolve(P);let A=K.length;const M=()=>{A=-1;for(const N of K)N.cancel?.()};return new Promise((N,x)=>{for(const H of K)H.then(J=>{--A>=0&&j(J)?(M(),N(J)):A===0&&N(P)}).catch(J=>{--A>=0&&(M(),x(J))})})}e.firstParallel=o;class u{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((P,A)=>{this.outstandingPromises.push({factory:j,c:P,e:A}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const P=j.factory();P.then(j.c,j.e),P.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class c extends u{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(j,P=O.extUri){const A=P.getComparisonKey(j);let M=this.queues.get(A);return M||(M=new c,k.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(A)}),this.queues.set(A,M)),M}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=l;class v{constructor(j,P){this._token=-1,typeof j=="function"&&typeof P=="number"&&this.setIfNotSet(j,P)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,P){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},P)}setIfNotSet(j,P){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},P))}}e.TimeoutTimer=v;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,P){this.cancel(),this._token=setInterval(()=>{j()},P)}}e.IntervalTimer=E;class f{constructor(j,P){this.timeoutToken=-1,this.runner=j,this.timeout=P,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class U extends f{constructor(j,P){super(j,P);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class F extends T.Disposable{constructor(j,P,A,M){super();this.maxWorkChunkSize=j,this.maxPendingWork=P,this.throttleDelay=A,this.handler=M,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new f(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const K=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=j=>{const P=setTimeout(()=>j(K));let A=!1;return{dispose(){A||(A=!0,clearTimeout(P))}}}}else e.runWhenIdle=(K,j)=>{const P=requestIdleCallback(K,typeof j=="number"?{timeout:j}:void 0);let A=!1;return{dispose(){A||(A=!0,cancelIdleCallback(P))}}}}();class z{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(P){this._error=P}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function $(K,j,P){let A;for(let M=0;M<P;M++)try{return await K()}catch(N){A=N,await s(j)}throw A}e.retry=$;class V{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,P,A){return this._pending={taskId:j,cancel:()=>A?.(),promise:P},P.then(()=>this.donePending(j),()=>this.donePending(j)),P}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let P,A;const M=new Promise((N,x)=>{P=N,A=x});this._next={run:j,promise:M,promiseResolve:P,promiseReject:A}}return this._next.promise}}e.TaskSequentializer=V;class B{constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,P)=>{this.completeCallback=j,this.errorCallback=P})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(P=>{this.completeCallback(j),this.resolved=!0,P()})}error(j){return new Promise(P=>{this.errorCallback(j),this.rejected=!0,P()})}cancel(){new Promise(j=>{this.errorCallback(L.canceled()),this.rejected=!0,j()})}}e.DeferredPromise=_;var W;(function(K){async function j(P){let A;const M=await Promise.all(P.map(N=>N.then(x=>x,x=>{A||(A=x)})));if(typeof A!="undefined")throw A;return M}K.settled=j})(W=e.Promises||(e.Promises={}))}),define(ee[67],te([0,1,20,41,8,38,6]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const p="**",w="/",n="[/\\\\]",m="[^/\\\\]",d=/\//g;function g(A){switch(A){case 0:return"";case 1:return`${m}*?`;default:return`(?:${n}|${m}+${n}|${n}${m}+)*?`}}function h(A,M){if(!A)return[];const N=[];let x=!1,H=!1,J="";for(const Q of A){switch(Q){case M:if(!x&&!H){N.push(J),J="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":H=!0;break;case"]":H=!1;break}J+=Q}return J&&N.push(J),N}e.splitGlobAware=h;function C(A){if(!A)return"";let M="";const N=h(A,w);if(N.every(x=>x===p))M=".*";else{let x=!1;N.forEach((H,J)=>{if(H===p){x||(M+=g(2),x=!0);return}let Q=!1,ie="",Z=!1,oe="";for(const ue of H){if(ue!=="}"&&Q){ie+=ue;continue}if(Z&&(ue!=="]"||!oe)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!oe?ge="^":ue===w?ge="":ge=S.escapeRegExpCharacters(ue),oe+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":Z=!0;continue;case"}":M+=`(?:${h(ie,",").map(Ie=>C(Ie)).join("|")})`,Q=!1,ie="";break;case"]":M+="["+oe+"]",Z=!1,oe="";break;case"?":M+=m;continue;case"*":M+=g(1);continue;default:M+=S.escapeRegExpCharacters(ue)}}J<N.length-1&&(N[J+1]!==p||J+2<N.length)&&(M+=n),x=!1})}return M}const I=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,y=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(A,M){if(!A)return i;let N;typeof A!="string"?N=A.pattern:N=A,N=N.trim();const x=`${N}_${!!M.trimForExclusions}`;let H=t.get(x);if(H)return u(H,A);let J;if(I.test(N)){const Q=N.substr(4);H=function(ie,Z){return typeof ie=="string"&&ie.endsWith(Q)?N:null}}else(J=b.exec(c(N,M)))?H=l(J[1],N):(M.trimForExclusions?y:D).test(N)?H=v(N,M):(J=s.exec(c(N,M)))?H=E(J[1].substr(1),N,!0):(J=a.exec(c(N,M)))?H=E(J[1],N,!1):H=f(N);return t.set(x,H),u(H,A)}function u(A,M){return typeof M=="string"?A:function(N,x){return L.isEqualOrParent(N,M.base)?A(k.relative(M.base,N),x):null}}function c(A,M){return M.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function l(A,M){const N=`/${A}`,x=`\\${A}`,H=function(Q,ie){return typeof Q!="string"?null:ie?ie===A?M:null:Q===A||Q.endsWith(N)||Q.endsWith(x)?M:null},J=[A];return H.basenames=J,H.patterns=[M],H.allBasenames=J,H}function v(A,M){const N=P(A.slice(1,-1).split(",").map(ie=>o(ie,M)).filter(ie=>ie!==i),A),x=N.length;if(!x)return i;if(x===1)return N[0];const H=function(ie,Z){for(let oe=0,ue=N.length;oe<ue;oe++)if(N[oe](ie,Z))return A;return null},J=N.find(ie=>!!ie.allBasenames);J&&(H.allBasenames=J.allBasenames);const Q=N.reduce((ie,Z)=>Z.allPaths?ie.concat(Z.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function E(A,M,N){const x=k.sep===k.posix.sep,H=x?A:A.replace(d,k.sep),J=k.sep+H,Q=k.posix.sep+A,ie=N?function(Z,oe){return typeof Z=="string"&&(Z===H||Z.endsWith(J)||!x&&(Z===A||Z.endsWith(Q)))?M:null}:function(Z,oe){return typeof Z=="string"&&(Z===H||!x&&Z===A)?M:null};return ie.allPaths=[(N?"*/":"./")+A],ie}function f(A){try{const M=new RegExp(`^${C(A)}$`);return function(N){return M.lastIndex=0,typeof N=="string"&&M.test(N)?A:null}}catch(M){return i}}function U(A,M,N){return!A||typeof M!="string"?!1:F(A)(M,void 0,N)}e.match=U;function F(A,M={}){if(!A)return r;if(typeof A=="string"||B(A)){const N=o(A,M);if(N===i)return r;const x=function(H,J){return!!N(H,J)};return N.allBasenames&&(x.allBasenames=N.allBasenames),N.allPaths&&(x.allPaths=N.allPaths),x}return K(A,M)}e.parse=F;function z(A){if(!A)return;let M;return N=>(M||(M=(A()||Promise.resolve([])).then(x=>x?V(x):{})),M.then(x=>!!x[N]))}e.hasSiblingPromiseFn=z;function $(A){if(!A)return;let M;return N=>{if(!M){const x=A();M=x?V(x):{}}return!!M[N]}}e.hasSiblingFn=$;function V(A){const M={};for(const N of A)M[N]=!0;return M}function B(A){const M=A;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=B;function _(A){return A.allBasenames||[]}e.getBasenameTerms=_;function W(A){return A.allPaths||[]}e.getPathTerms=W;function K(A,M){const N=P(Object.getOwnPropertyNames(A).map(ie=>j(ie,A[ie],M)).filter(ie=>ie!==i)),x=N.length;if(!x)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(x===1)return N[0];const ie=function(ue,ge){for(let Se=0,Ie=N.length;Se<Ie;Se++){const Pe=N[Se](ue,ge);if(Pe)return Pe}return null},Z=N.find(ue=>!!ue.allBasenames);Z&&(ie.allBasenames=Z.allBasenames);const oe=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return oe.length&&(ie.allPaths=oe),ie}const H=function(ie,Z,oe){let ue;for(let ge=0,Se=N.length;ge<Se;ge++){const Ie=N[ge];Ie.requiresSiblings&&oe&&(Z||(Z=k.basename(ie)),ue||(ue=Z.substr(0,Z.length-k.extname(ie).length)));const Pe=Ie(ie,Z,ue,oe);if(Pe)return Pe}return null},J=N.find(ie=>!!ie.allBasenames);J&&(H.allBasenames=J.allBasenames);const Q=N.reduce((ie,Z)=>Z.allPaths?ie.concat(Z.allPaths):ie,[]);return Q.length&&(H.allPaths=Q),H}function j(A,M,N){if(M===!1)return i;const x=o(A,N);if(x===i)return i;if(typeof M=="boolean")return x;if(M){const H=M.when;if(typeof H=="string"){const J=(Q,ie,Z,oe)=>{if(!oe||!x(Q,ie))return null;const ue=H.replace("$(basename)",Z),ge=oe(ue);return O.isThenable(ge)?ge.then(Se=>Se?A:null):ge?A:null};return J.requiresSiblings=!0,J}}return x}function P(A,M){const N=A.filter(ie=>!!ie.basenames);if(N.length<2)return A;const x=N.reduce((ie,Z)=>{const oe=Z.basenames;return oe?ie.concat(oe):ie},[]);let H;if(M){H=[];for(let ie=0,Z=x.length;ie<Z;ie++)H.push(M)}else H=N.reduce((ie,Z)=>{const oe=Z.patterns;return oe?ie.concat(oe):ie},[]);const J=function(ie,Z){if(typeof ie!="string")return null;if(!Z){let ue;for(ue=ie.length;ue>0;ue--){const ge=ie.charCodeAt(ue-1);if(ge===47||ge===92)break}Z=ie.substr(ue)}const oe=x.indexOf(Z);return oe!==-1?H[oe]:null};J.basenames=x,J.patterns=H,J.allBasenames=x;const Q=A.filter(ie=>!ie.basenames);return Q.push(J),Q}}),define(ee[92],te([0,1,8,20,67,17,12]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(R=e.Mimes||(e.Mimes={}));let p=[],w=[],n=[];function m(r,i=!1){const o=d(r);p.push(o),o.userConfigured?n.push(o):w.push(o),i&&!o.userConfigured&&p.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=m;function d(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(S.posix.sep)>=0:!1}}function g(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],w=[],n=[])}e.clearTextMimes=g;function h(r,i){let o;if(r)switch(r.scheme){case T.Schemas.file:o=r.fsPath;break;case T.Schemas.data:o=O.DataUri.parseMetaData(r).get(O.DataUri.META_DATA_LABEL);break;default:o=r.path}if(!o)return[R.unknown];o=o.toLowerCase();const u=S.basename(o),c=C(o,u,n);if(c)return[c,R.text];const l=C(o,u,w);if(l)return[l,R.text];if(i){const v=I(i);if(v)return[v,R.text]}return[R.unknown]}e.guessMimeTypes=h;function C(r,i,o){let u=null,c=null,l=null;for(let v=o.length-1;v>=0;v--){const E=o[v];if(i===E.filenameLowercase){u=E;break}if(E.filepattern&&(!c||E.filepattern.length>c.filepattern.length)){const f=E.filepatternOnPath?r:i;k.match(E.filepatternLowercase,f)&&(c=E)}E.extension&&(!l||E.extension.length>l.extension.length)&&i.endsWith(E.extensionLowercase)&&(l=E)}return u?u.mime:c?c.mime:l?l.mime:null}function I(r){if(L.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const o=p[i];if(!o.firstline)continue;const u=r.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function b(r){return r?typeof r=="string"?r===R.binary||r===R.text||r===R.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function y(r){const i=S.extname(r);return D[i.toLowerCase()]}e.getMediaMime=y;function s(r){for(const i in D)if(D[i]===r)return i}e.getExtensionForMimeType=s;const a=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const o=a.exec(r);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(ee[93],te([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class k{constructor(m){this._uriTransformer=m}transformIncoming(m){const d=this._uriTransformer.transformIncoming(m);return d===m?m:L(S.URI.from(d))}transformOutgoing(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:L(S.URI.from(d))}transformOutgoingURI(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:S.URI.from(d)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,m,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof S.URI)return m.transformOutgoing(n);for(let g in n)if(Object.hasOwnProperty.call(n,g)){const h=T(n[g],m,d+1);h!==null&&(n[g]=h)}}return null}function O(n,m){const d=T(n,m,0);return d===null?n:d}e.transformOutgoingURIs=O;function R(n,m,d,g){if(!n||g>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?S.URI.revive(m.transformIncoming(n)):m.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=R(n[h],m,d,g+1);C!==null&&(n[h]=C)}}return null}function p(n,m){const d=R(n,m,!1,0);return d===null?n:d}e.transformIncomingURIs=p;function w(n,m){const d=R(n,m,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=w}),define(ee[30],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(p){return S.test(p)}e.isUUID=L;const k=new Uint8Array(16),T=[];for(let p=0;p<256;p++)T.push(p.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(p){for(let w=0;w<p.length;w++)p[w]=Math.floor(Math.random()*256);return p};function R(){O(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let p=0,w="";return w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w+="-",w+=T[k[p++]],w+=T[k[p++]],w+="-",w+=T[k[p++]],w+=T[k[p++]],w+="-",w+=T[k[p++]],w+=T[k[p++]],w+="-",w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w+=T[k[p++]],w}e.generateUuid=R}),define(ee[68],te([0,1,207]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new S.StringDecoder(T),this.remaining=null}write(T){const O=[],R=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(R.length<1)return O;let p=0,w,n=p;for(;n<R.length;)if(w=R.charCodeAt(n),w===13||w===10){if(O.push(R.substring(p,n)),n++,n<R.length){const m=w;w=R.charCodeAt(n),(m===13&&w===10||m===10&&w===13)&&n++}p=n}else n++;return this.remaining=p<R.length?R.substr(p):null,O}end(){return this.remaining}}e.LineDecoder=L}),define(ee[94],te([0,1,35]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(R){const p=R.replace(/\-/g,":").toLowerCase();return!L.has(p)}function T(){return new Promise(async(R,p)=>{const w=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await O())}catch(n){p(n)}finally{clearTimeout(w)}})}e.getMac=T;function O(){return new Promise((R,p)=>{try{const w=S.networkInterfaces();for(let n in w){const m=w[n];if(m){for(const{mac:d}of m)if(k(d))return R(d)}}p("Unable to retrieve mac address (unexpected format)")}catch(w){p(w)}})}}),define(ee[95],te([0,1,11,30,35,38,94]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=T.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,m=0;const d=k.networkInterfaces();for(let g in d){const h=d[g];if(h)for(const{mac:C,internal:I}of h)I||(m+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=m>0?n/m:0}return this._value}};let R;async function p(){return R||(R=(async()=>await w()||L.generateUuid())()),R}e.getMachineId=p;async function w(){try{const n=await new Promise((d,g)=>{G(["crypto"],d,g)}),m=await O.getMac();return n.createHash("sha256").update(m,"utf8").digest("hex")}catch(n){S.onUnexpectedError(n);return}}}),define(ee[18],te([0,1,48,35,208,8,6,7,41,30,66,12,5]),function(G,e,S,L,k,T,O,R,p,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function h(_,W=g.UNLINK){if(p.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");return W===g.UNLINK?I(_):C(_)}async function C(_){try{const W=T.join(L.tmpdir(),w.generateUuid());try{await e.Promises.rename(_,W)}catch(K){return I(_)}I(W).catch(K=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function I(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function b(_){if(p.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(_,{recursive:!0})}e.rimrafSync=b;async function D(_,W){return a(await(W?y(_):k.promisify(S.readdir)(_)))}async function y(_){try{return await k.promisify(S.readdir)(_,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const W=[],K=await D(_);for(const j of K){let P=!1,A=!1,M=!1;try{const N=await e.Promises.lstat(T.join(_,j));P=N.isFile(),A=N.isDirectory(),M=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}W.push({name:j,isFile:()=>P,isDirectory:()=>A,isSymbolicLink:()=>M})}return W}function s(_){return a(S.readdirSync(_))}e.readdirSync=s;function a(_){return _.map(W=>typeof W=="string"?R.isMacintosh?n.normalizeNFC(W):W:(W.name=R.isMacintosh?n.normalizeNFC(W.name):W.name,W))}async function t(_){const W=await D(_),K=[];for(const j of W)await i.existsDirectory(T.join(_,j))&&K.push(j);return K}function r(_,W=1e3){return new Promise(K=>{let j=!1;const P=setInterval(()=>{j||(j=!0,S.access(_,A=>{j=!1,A&&(clearInterval(P),K(void 0))}))},W)})}e.whenDeleted=r;var i;(function(_){async function W(P){let A;try{if(A=await e.Promises.lstat(P),!A.isSymbolicLink())return{stat:A}}catch(M){}try{return{stat:await e.Promises.stat(P),symbolicLink:A?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(R.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(P)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw N}throw M}}_.stat=W;async function K(P){try{const{stat:A,symbolicLink:M}=await _.stat(P);return A.isFile()&&M?.dangling!==!0}catch(A){}return!1}_.existsFile=K;async function j(P){try{const{stat:A,symbolicLink:M}=await _.stat(P);return A.isDirectory()&&M?.dangling!==!0}catch(A){}return!1}_.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new O.ResourceQueue;function u(_,W,K){return o.queueFor(d.URI.file(_),m.extUriBiasedIgnorePathCase).queue(()=>{const j=E(K);return new Promise((P,A)=>l(_,W,j,M=>M?A(M):P()))})}let c=!0;function l(_,W,K,j){if(!c)return S.writeFile(_,W,{mode:K.mode,flag:K.flag},j);S.open(_,K.flag,K.mode,(P,A)=>{if(P)return j(P);S.writeFile(A,W,M=>{if(M)return S.close(A,()=>j(M));S.fdatasync(A,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c=!1),S.close(A,x=>j(x))))})})}function v(_,W,K){const j=E(K);if(!c)return S.writeFileSync(_,W,{mode:j.mode,flag:j.flag});const P=S.openSync(_,j.flag,j.mode);try{S.writeFileSync(P,W);try{S.fdatasyncSync(P)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),c=!1}}finally{S.closeSync(P)}}e.writeFileSync=v;function E(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function f(_,W){if(_===W)return;async function K(j){try{const P=await e.Promises.lstat(j);if(P.isDirectory()||P.isSymbolicLink())return;await e.Promises.utimes(j,P.atime,new Date)}catch(P){}}try{await e.Promises.rename(_,W),await K(W)}catch(j){if(_.toLowerCase()!==W.toLowerCase()&&j.code==="EXDEV"||_.endsWith("."))await U(_,W,{preserveSymlinks:!1}),await h(_,g.MOVE),await K(W);else throw j}}async function U(_,W,K){return z(_,W,{root:{source:_,target:W},options:K,handledSourcePaths:new Set})}const F=511;async function z(_,W,K){if(K.handledSourcePaths.has(_))return;K.handledSourcePaths.add(_);const{stat:j,symbolicLink:P}=await i.stat(_);if(P){if(K.options.preserveSymlinks)try{return await B(_,W,K)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(P.dangling)return}return j.isDirectory()?$(_,W,j.mode&F,K):V(_,W,j.mode&F)}async function $(_,W,K,j){await e.Promises.mkdir(W,{recursive:!0,mode:K});const P=await D(_);for(const A of P)await z(T.join(_,A),T.join(W,A),j)}async function V(_,W,K){await e.Promises.copyFile(_,W),await e.Promises.chmod(W,K)}async function B(_,W,K){let j=await e.Promises.readlink(_);p.isEqualOrParent(j,K.root.source,!R.isLinux)&&(j=T.join(K.root.target,j.substr(K.root.source.length+1))),await e.Promises.symlink(j,W)}e.Promises=new class{get access(){return k.promisify(S.access)}get stat(){return k.promisify(S.stat)}get lstat(){return k.promisify(S.lstat)}get utimes(){return k.promisify(S.utimes)}get read(){return k.promisify(S.read)}get readFile(){return k.promisify(S.readFile)}get write(){return k.promisify(S.write)}get appendFile(){return k.promisify(S.appendFile)}get fdatasync(){return k.promisify(S.fdatasync)}get truncate(){return k.promisify(S.truncate)}get rename(){return k.promisify(S.rename)}get copyFile(){return k.promisify(S.copyFile)}get open(){return k.promisify(S.open)}get close(){return k.promisify(S.close)}get symlink(){return k.promisify(S.symlink)}get readlink(){return k.promisify(S.readlink)}get chmod(){return k.promisify(S.chmod)}get mkdir(){return k.promisify(S.mkdir)}get unlink(){return k.promisify(S.unlink)}get rmdir(){return k.promisify(S.rmdir)}get realpath(){return k.promisify(S.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return D}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return h}get move(){return f}get copy(){return U}}}),define(ee[96],te([0,1,48,20,8,18]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(n){const m=k.dirname(n);if(n===m)return n;const d=(k.basename(n)||n).toLowerCase();try{const h=T.readdirSync(m).filter(C=>C.toLowerCase()===d);if(h.length===1){const C=O(m);if(C)return k.join(C,h[0])}else if(h.length>1){const C=h.indexOf(d);if(C>=0){const I=O(m);if(I)return k.join(I,h[C])}}}catch(g){}return null}e.realcaseSync=O;async function R(n){try{return await T.Promises.realpath(n)}catch(m){const d=w(n);return await T.Promises.access(d,S.constants.R_OK),d}}e.realpath=R;function p(n){try{return S.realpathSync(n)}catch(m){const d=w(n);return S.accessSync(d,S.constants.R_OK),d}}e.realpathSync=p;function w(n){return L.rtrim(k.normalize(n),k.sep)}}),define(ee[97],te([0,1,18,35,8]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,O=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var p;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(p||(p={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class m{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:s=!1}={}){return s?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:s=!1,findPreview:a=!1}={}){const t=d({useAlternateBitness:s});if(!t)return null;const r=k.join(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const l of await S.Promises.readdir(r)){let v=-1;if(a){const f=l.indexOf("-");if(f<0)continue;const U=l.substring(0,f);if(!T.test(U)||l.substring(f+1)!=="preview")continue;v=parseInt(U,10)}else{if(!T.test(l))continue;v=parseInt(l,10)}if(v<=i)continue;const E=k.join(r,l,"pwsh.exe");!await S.SymlinkSupport.existsFile(E)||(o=E,i=v)}if(!o)return null;const u=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new m(o,`PowerShell${c}${u}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(a))if(t.test(i)){const o=k.join(a,i,"pwsh.exe");return new m(o,r)}return null}function C(){const s=k.join(L.homedir(),".dotnet","tools","pwsh.exe");return new m(s,".NET Core PowerShell Global Tool")}function I(){const s=k.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(s,"Windows PowerShell",!0)}async function*b(){let s=await g();s&&(yield s),s=await g({useAlternateBitness:!0}),s&&(yield s),s=await h(),s&&(yield s),s=C(),s&&(yield s),s=await g({findPreview:!0}),s&&(yield s),s=await h({findPreview:!0}),s&&(yield s),s=await g({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=I(),s&&(yield s)}async function*D(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=D;async function y(){for await(const s of D())return s;return null}e.getFirstAvailablePowerShellInstallation=y}),define(ee[98],te([0,1,42,17]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(O){return new Promise((R,p)=>{let w;const n=new Map;function m(g,h,C,I,b){const D=n.get(h);if(g===O||D){const y={name:d(C),cmd:C,pid:g,ppid:h,load:I,mem:b};n.set(g,y),g===O&&(w=y),D&&(D.children||(D.children=[]),D.children.push(y),D.children.length>1&&(D.children=D.children.sort((s,a)=>s.pid-a.pid)))}}function d(g){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,b=/\\pipe\\winpty-control/,D=/conhost\.exe/,y=/--type=([a-zA-Z-]+)/;if(C.exec(g))return"watcherService ";if(I.exec(g))return"electron-crash-reporter";if(b.exec(g))return"winpty-process";if(D.exec(g))return"console-window-host (Windows internal process)";let s=y.exec(g);if(s&&s.length===2)return s[1]==="renderer"?h.exec(g)?"shared-process":"window":s[1];const a=/[a-zA-Z-]+\.js/g;let t="";do s=a.exec(g),s&&(t+=s+" ");while(s);return t&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${t}`:g}if(process.platform==="win32"){const g=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{G(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(O,C=>{h.getProcessCpuUsage(C,I=>{const b=new Map;I.forEach(D=>{const y=g(D.commandLine||"");b.set(D.pid,{name:d(y),cmd:y,pid:D.pid,ppid:D.ppid,load:D.cpu||0,mem:D.memory||0})}),w=b.get(O),w?(b.forEach(D=>{const y=b.get(D.ppid);y&&(y.children||(y.children=[]),y.children.push(D))}),b.forEach(D=>{D.children&&(D.children=D.children.sort((y,s)=>y.pid-s.pid))}),R(w)):p(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let g=function(){let h=[w];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);I+=" "+C.join(" "),S.exec(I,{},(b,D,y)=>{if(b||y)p(b||new Error(y.toString()));else{const s=D.toString().split(`
`);for(let a=0;a<C.length;a++){const t=n.get(C[a]);t.load=parseFloat(s[a])}if(!w){p(new Error(`Root process ${O} not found`));return}R(w)}})};S.exec("which ps",{},(h,C,I)=>{if(h||I)if(process.platform!=="linux")p(h||new Error(I.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);S.exec(b,{},(D,y,s)=>{D||s?p(D||new Error(s.toString())):(T(y,m),g())})}else{const b=C.toString().trim(),D="-ax -o pid=,ppid=,pcpu=,pmem=,command=";S.exec(`${b} ${D}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,s,a)=>{y||a&&!a.includes("screen size is bogus")?p(y||new Error(a.toString())):(T(s,m),process.platform==="linux"?g():w?R(w):p(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=k;function T(O,R){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=O.toString().split(`
`);for(const n of w){const m=p.exec(n.trim());m&&m.length===6&&R(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(ee[99],te([0,1,8,48,7,66,2,18]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(m,d,g){return n({path:m,isDirectory:!1},d,g)}e.watchFile=p;function w(m,d,g){return n({path:m,isDirectory:!0},d,g)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(m,d,g){const h=S.basename(m.path),C=new Map;let I=!1,b=[O.toDisposable(()=>{C.forEach(D=>O.dispose(D)),C.clear()})];try{const D=L.watch(m.path);b.push(O.toDisposable(()=>{D.removeAllListeners(),D.close()}));const y=new Set;m.isDirectory&&R.Promises.readdir(m.path).then(s=>s.forEach(a=>y.add(a))),D.on("error",(s,a)=>{I||g(`Failed to watch ${m.path} for changes using fs.watch() (${s}, ${a})`)}),D.on("change",(s,a)=>{if(I)return;let t="";if(a&&(t=a.toString(),k.isMacintosh&&(t=T.normalizeNFC(t))),!t||s!=="change"&&s!=="rename")return;const r=m.isDirectory?S.join(m.path,t):m.path;if(m.isDirectory)if(s==="rename"){const i=C.get(r);i&&O.dispose(i);const o=setTimeout(async()=>{C.delete(r);const u=await R.Promises.exists(r);if(I)return;let c;u?y.has(t)?c="changed":(c="added",y.add(t)):(y.delete(t),c="deleted"),d(c,r)},e.CHANGE_BUFFER_DELAY);C.set(r,O.toDisposable(()=>clearTimeout(o)))}else{let i;y.has(t)?i="changed":(i="added",y.add(t)),d(i,r)}else if(s==="rename"||t!==h){const i=setTimeout(async()=>{const o=await R.Promises.exists(r);I||(o?(d("changed",r),b=[n(m,d,g)]):d("deleted",r))},e.CHANGE_BUFFER_DELAY);O.dispose(b),b=[O.toDisposable(()=>clearTimeout(i))]}else d("changed",r)})}catch(D){R.Promises.exists(m.path).then(y=>{y&&!I&&g(`Failed to watch ${m.path} for changes using fs.watch() (${D.toString()})`)})}return O.toDisposable(()=>{I=!0,b=O.dispose(b)})}});var de=this&&this.__decorate||function(G,e,S,L){var k=arguments.length,T=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(G,e,S,L);else for(var R=G.length-1;R>=0;R--)(O=G[R])&&(T=(k<3?O(T):k>3?O(e,S,T):O(e,S))||T);return k>3&&T&&Object.defineProperty(e,S,T),T};define(ee[36],te([0,1,3,2,6,29,11,25,19,16,91,20,64]),function(G,e,S,L,k,T,O,R,p,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(P){P[P.Promise=100]="Promise",P[P.PromiseCancel=101]="PromiseCancel",P[P.EventListen=102]="EventListen",P[P.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function h(P){switch(P){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(P){P[P.Initialize=200]="Initialize",P[P.PromiseSuccess=201]="PromiseSuccess",P[P.PromiseError=202]="PromiseError",P[P.PromiseErrorObj=203]="PromiseErrorObj",P[P.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function I(P){switch(P){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(P){P[P.Uninitialized=0]="Uninitialized",P[P.Idle=1]="Idle"})(b||(b={}));class D{constructor(A){this.buffer=A,this.pos=0}read(A){const M=this.buffer.slice(this.pos,this.pos+A);return this.pos+=M.byteLength,M}}class y{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var s;(function(P){P[P.Undefined=0]="Undefined",P[P.String=1]="String",P[P.Buffer=2]="Buffer",P[P.VSBuffer=3]="VSBuffer",P[P.Array=4]="Array",P[P.Object=5]="Object"})(s||(s={}));function a(P){const A=R.VSBuffer.alloc(4);return A.writeUInt32BE(P,0),A}function t(P){return P.read(4).readUInt32BE(0)}function r(P){const A=R.VSBuffer.alloc(1);return A.writeUInt8(P,0),A}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},o=typeof Buffer!="undefined";function u(P,A){if(typeof A=="undefined")P.write(i.Undefined);else if(typeof A=="string"){const M=R.VSBuffer.fromString(A);P.write(i.String),P.write(a(M.byteLength)),P.write(M)}else if(o&&Buffer.isBuffer(A)){const M=R.VSBuffer.wrap(A);P.write(i.Buffer),P.write(a(M.byteLength)),P.write(M)}else if(A instanceof R.VSBuffer)P.write(i.VSBuffer),P.write(a(A.byteLength)),P.write(A);else if(Array.isArray(A)){P.write(i.Array),P.write(a(A.length));for(const M of A)u(P,M)}else{const M=R.VSBuffer.fromString(JSON.stringify(A));P.write(i.Object),P.write(a(M.byteLength)),P.write(M)}}function c(P){switch(P.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return P.read(t(P)).toString();case s.Buffer:return P.read(t(P)).buffer;case s.VSBuffer:return P.read(t(P));case s.Array:{const M=t(P),N=[];for(let x=0;x<M;x++)N.push(c(P));return N}case s.Object:return JSON.parse(P.read(t(P)).toString())}}class l{constructor(A,M,N=null,x=1e3){this.protocol=A,this.ctx=M,this.logger=N,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(A,M){this.channels.set(A,M),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const M=this.send([A.type]);this.logger&&this.logger.logOutgoing(M,0,1,I(A.type));return}case 201:case 202:case 204:case 203:{const M=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(M,A.id,1,I(A.type),A.data);return}}}send(A,M=void 0){const N=new y;return u(N,A),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(M){return 0}}onRawMessage(A){const M=new D(A),N=c(M),x=c(M),H=N[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${h(H)}: ${N[2]}.${N[3]}`,x),this.onPromise({type:H,id:N[1],channelName:N[2],name:N[3],arg:x});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${h(H)}: ${N[2]}.${N[3]}`,x),this.onEventListen({type:H,id:N[1],channelName:N[2],name:N[3],arg:x});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],1,`${h(H)}`),this.disposeActiveRequest({type:H,id:N[1]})}}onPromise(A){const M=this.channels.get(A.channelName);if(!M){this.collectPendingRequest(A);return}const N=new T.CancellationTokenSource;let x;try{x=M.call(this.ctx,A.name,A.arg,N.token)}catch(Q){x=Promise.reject(Q)}const H=A.id;x.then(Q=>{this.sendResponse({id:H,data:Q,type:201}),this.activeRequests.delete(A.id)},Q=>{Q instanceof Error?this.sendResponse({id:H,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:H,data:Q,type:203}),this.activeRequests.delete(A.id)});const J=L.toDisposable(()=>N.cancel());this.activeRequests.set(A.id,J)}onEventListen(A){const M=this.channels.get(A.channelName);if(!M){this.collectPendingRequest(A);return}const N=A.id,H=M.listen(this.ctx,A.name,A.arg)(J=>this.sendResponse({id:N,data:J,type:204}));this.activeRequests.set(A.id,H)}disposeActiveRequest(A){const M=this.activeRequests.get(A.id);M&&(M.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let M=this.pendingRequests.get(A.channelName);M||(M=[],this.pendingRequests.set(A.channelName,M));const N=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:A,timeoutTimer:N})}flushPendingRequests(A){const M=this.pendingRequests.get(A);if(M){for(const N of M)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var v;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(A,M=null){this.protocol=A,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=M}getChannel(A){const M=this;return{call(N,x,H){return M.isDisposed?Promise.reject(O.canceled()):M.requestPromise(A,N,x,H)},listen(N,x){return M.isDisposed?Promise.reject(O.canceled()):M.requestEvent(A,N,x)}}}requestPromise(A,M,N,x=T.CancellationToken.None){const H=this.lastRequestId++,Q={id:H,type:100,channelName:A,name:M,arg:N};if(x.isCancellationRequested)return Promise.reject(O.canceled());let ie;return new Promise((oe,ue)=>{if(x.isCancellationRequested)return ue(O.canceled());const ge=()=>{const Fe=Oe=>{switch(Oe.type){case 201:this.handlers.delete(H),oe(Oe.data);break;case 202:this.handlers.delete(H);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,ue(ke);break;case 203:this.handlers.delete(H),ue(Oe.data);break}};this.handlers.set(H,Fe),this.sendRequest(Q)};let Se=null;this.state===b.Idle?ge():(Se=k.createCancelablePromise(Fe=>this.whenInitialized()),Se.then(()=>{Se=null,ge()}));const Ie=()=>{Se?(Se.cancel(),Se=null):this.sendRequest({id:H,type:101}),ue(O.canceled())},Pe=x.onCancellationRequested(Ie);ie=L.combinedDisposable(L.toDisposable(Ie),Pe),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(A,M,N){const x=this.lastRequestId++,J={id:x,type:102,channelName:A,name:M,arg:N};let Q=null;const ie=new S.Emitter({onFirstListenerAdd:()=>{Q=k.createCancelablePromise(oe=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(J)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:x,type:103}))}}),Z=oe=>ie.fire(oe.data);return this.handlers.set(x,Z),ie.event}sendRequest(A){switch(A.type){case 100:case 102:{const M=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(M,A.id,0,`${h(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const M=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(M,A.id,0,h(A.type));return}}}send(A,M=void 0){const N=new y;return u(N,A),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(M){return 0}}onBuffer(A){const M=new D(A),N=c(M),x=c(M),H=N[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,I(H)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,N[1],0,I(H),x),this.onResponse({type:N[0],id:N[1],data:x})}}onResponse(A){if(A.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(A.id);M&&M(A)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}de([d.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class f{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:M,onDidClientDisconnect:N})=>{S.Event.once(M.onMessage)(H=>{const J=new D(H),Q=c(J),ie=new l(M,Q),Z=new E(M);this.channels.forEach((ue,ge)=>ie.registerChannel(ge,ue));const oe={channelServer:ie,channelClient:Z,ctx:Q};this._connections.add(oe),this._onDidAddConnection.fire(oe),N(()=>{ie.dispose(),Z.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)})})})}get connections(){const A=[];return this._connections.forEach(M=>A.push(M)),A}getChannel(A,M){const N=this;return{call(x,H,J){let Q;if(w.isFunction(M)){let Z=p.getRandomElement(N.connections.filter(M));Q=Z?Promise.resolve(Z):S.Event.toPromise(S.Event.filter(N.onDidAddConnection,M))}else Q=M.routeCall(N,x,H);const ie=Q.then(Z=>Z.channelClient.getChannel(A));return F(ie).call(x,H,J)},listen(x,H){if(w.isFunction(M))return N.getMulticastEvent(A,M,x,H);const J=M.routeEvent(N,x,H).then(Q=>Q.channelClient.getChannel(A));return F(J).listen(x,H)}}}getMulticastEvent(A,M,N,x){const H=this;let J=new L.DisposableStore;const Q=new S.Emitter({onFirstListenerAdd:()=>{J=new L.DisposableStore;const ie=new S.EventMultiplexer,Z=new Map,oe=ge=>{const Ie=ge.channelClient.getChannel(A).listen(N,x),Pe=ie.add(Ie);Z.set(ge,Pe)},ue=ge=>{const Se=Z.get(ge);!Se||(Se.dispose(),Z.delete(ge))};H.connections.filter(M).forEach(oe),S.Event.filter(H.onDidAddConnection,M)(oe,void 0,J),H.onDidRemoveConnection(ue,void 0,J),ie.event(Q.fire,Q,J),J.add(ie)},onLastListenerRemove:()=>{J.dispose()}});return Q.event}registerChannel(A,M){this.channels.set(A,M),this._connections.forEach(N=>{N.channelServer.registerChannel(A,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class U{constructor(A,M,N=null){const x=new y;u(x,M),A.send(x.buffer),this.channelClient=new E(A,N),this.channelServer=new l(A,M,N)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,M){this.channelServer.registerChannel(A,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function F(P){return{call(A,M,N){return P.then(x=>x.call(A,M,N))},listen(A,M){const N=new S.Relay;return P.then(x=>N.input=x.listen(A,M)),N.event}}}e.getDelayedChannel=F;function z(P){let A=!1;return{call(M,N,x){return A?P.call(M,N,x):k.timeout(0).then(()=>A=!0).then(()=>P.call(M,N,x))},listen(M,N){if(A)return P.listen(M,N);const x=new S.Relay;return k.timeout(0).then(()=>A=!0).then(()=>x.input=P.listen(M,N)),x.event}}}e.getNextTickChannel=z;class ${constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const M of A.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await S.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=$;var V;(function(P){function A(x,H){const J=x,Q=H&&H.disableMarshalling,ie=new Map;for(const Z in J)N(Z)&&ie.set(Z,S.Event.buffer(J[Z],!0));return new class{listen(Z,oe){const ue=ie.get(oe);if(ue)return ue;throw new Error(`Event not found: ${oe}`)}call(Z,oe,ue){const ge=J[oe];if(typeof ge=="function"){if(!Q&&Array.isArray(ue))for(let Se=0;Se<ue.length;Se++)ue[Se]=n.revive(ue[Se]);return ge.apply(J,ue)}throw new Error(`Method not found: ${oe}`)}}}P.fromService=A;function M(x,H){const J=H&&H.disableMarshalling;return new Proxy({},{get(Q,ie){if(typeof ie=="string")return H?.properties?.has(ie)?H.properties.get(ie):N(ie)?x.listen(ie):async function(...Z){let oe;H&&!w.isUndefinedOrNull(H.context)?oe=[H.context,...Z]:oe=Z;const ue=await x.call(ie,oe);return J?ue:n.revive(ue)};throw new Error(`Property not found: ${String(ie)}`)}})}P.toService=M;function N(x){return x[0]==="o"&&x[1]==="n"&&m.isUpperAsciiLetter(x.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(P){if(Array.isArray(P))return P;if(P&&typeof P=="object"&&typeof P.toString=="function"){let A=P.toString();if(A!=="[object Object]")return A}return P}function W(P){return Array.isArray(P)?P.map(_):_(P)}function K(P,A,M,N,x,H,J){J=W(J);const Q=B[x],ie=Q[N%Q.length];let Z=[`%c[${P}]%c[${String(A).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(H)?(Z=Z.concat(J),Z.push(")")):Z.push(J),console.log.apply(console,Z)}e.logWithColors=K;class j{constructor(A,M){this._outgoingPrefix=A,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,M,N,x,H){this._totalOutgoing+=A,K(this._outgoingPrefix,this._totalOutgoing,A,M,N,x,H)}logIncoming(A,M,N,x,H){this._totalIncoming+=A,K(this._incomingPrefix,this._totalIncoming,A,M,N,x,H)}}e.IPCLogger=j}),define(ee[100],te([0,1,3,36,25]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(p){this.port=p,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",w=>k.VSBuffer.wrap(w.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class O extends L.IPCClient{constructor(p,w){const n=new T(p);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=O}),define(ee[101],te([0,1,102,3,36,100]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends k.IPCServer{static getOnDidClientConnect(){const p=L.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return L.Event.map(p,w=>{const{port1:n,port2:m}=new MessageChannel,g={protocol:new T.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[m]),g})}constructor(){super(O.getOnDidClientConnect())}}e.Server=O}),define(ee[103],te([0,1,11,25]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(R,p){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,m)=>{w.open(R.type||"GET",R.url||"",!0,R.user,R.password),T(w,R),w.responseType="arraybuffer",w.onerror=d=>m(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=d=>{n({res:{statusCode:w.status,headers:O(w)},stream:L.bufferToStream(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=d=>m(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(w.timeout=R.timeout),w.send(R.data),p.onCancellationRequested(()=>{w.abort(),m(S.canceled())})})}e.request=k;function T(R,p){if(p.headers){e:for(let w in p.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(w,p.headers[w])}}}function O(R){const p=Object.create(null);for(const w of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");p[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return p}}),define(ee[69],te([0,1,2,3,6,16]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var O;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class p extends S.Disposable{constructor(m,d=Object.create(null)){super();this.database=m,this.options=d,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((d,g)=>this.accept(g,d)),m.deleted?.forEach(d=>this.accept(d,void 0))}accept(m,d){if(this.state===R.Closed)return;let g=!1;T.isUndefinedOrNull(d)?g=this.cache.delete(m):this.cache.get(m)!==d&&(this.cache.set(m,d),g=!0),g&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,d){const g=this.cache.get(m);return T.isUndefinedOrNull(g)?d:g}getBoolean(m,d){const g=this.get(m);return T.isUndefinedOrNull(g)?d:g==="true"}getNumber(m,d){const g=this.get(m);return T.isUndefinedOrNull(g)?d:parseInt(g,10)}async set(m,d){if(this.state===R.Closed)return;if(T.isUndefinedOrNull(d))return this.delete(m);const g=String(d);if(this.cache.get(m)!==g)return this.cache.set(m,g),this.pendingInserts.set(m,g),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===R.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((d,g)=>this.items.set(g,d)),m.delete&&m.delete.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=w}),define(ee[104],te([13,14]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[55],te([0,1,104]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,k=L*60,T=k*24,O=T*7,R=T*30,p=T*365;function w(m,d){typeof m!="number"&&(m=m.getTime());const g=Math.round((new Date().getTime()-m)/1e3);if(g<-30)return S.localize(0,null,w(new Date().getTime()+g*1e3,!1));if(g<30)return S.localize(1,null);let h;return g<L?(h=g,d?h===1?S.localize(2,null,h):S.localize(3,null,h):h===1?S.localize(4,null,h):S.localize(5,null,h)):g<k?(h=Math.floor(g/L),d?h===1?S.localize(6,null,h):S.localize(7,null,h):h===1?S.localize(8,null,h):S.localize(9,null,h)):g<T?(h=Math.floor(g/k),d?h===1?S.localize(10,null,h):S.localize(11,null,h):h===1?S.localize(12,null,h):S.localize(13,null,h)):g<O?(h=Math.floor(g/T),d?h===1?S.localize(14,null,h):S.localize(15,null,h):h===1?S.localize(16,null,h):S.localize(17,null,h)):g<R?(h=Math.floor(g/O),d?h===1?S.localize(18,null,h):S.localize(19,null,h):h===1?S.localize(20,null,h):S.localize(21,null,h)):g<p?(h=Math.floor(g/R),d?h===1?S.localize(22,null,h):S.localize(23,null,h):h===1?S.localize(24,null,h):S.localize(25,null,h)):(h=Math.floor(g/p),d?h===1?S.localize(26,null,h):S.localize(27,null,h):h===1?S.localize(28,null,h):S.localize(29,null,h))}e.fromNow=w;function n(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(ee[105],te([13,14]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[43],te([0,1,105,16,19]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(w,n){return n&&(w.stack||w.stacktrace)?S.localize(0,null,R(w),O(w.stack)||O(w.stacktrace)):R(w)}function O(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function p(w=null,n=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const m=k.coalesce(w),d=p(m[0],n);return m.length>1?S.localize(4,null,d,m.length):d}if(L.isString(w))return w;if(w.detail){const m=w.detail;if(m.error)return T(m.error,n);if(m.exception)return T(m.exception,n)}return w.stack?T(w,n):w.message?w.message:S.localize(5,null)}e.toErrorMessage=p}),define(ee[106],te([13,14]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ee[107],te([0,1,8,18,42,106,34,16,26,41,7,68,17]),function(G,e,S,L,k,T,O,R,p,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,a){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=k.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,u)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{k.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,o,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=O.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class I{constructor(a,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=i;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(O.env).forEach(u=>{o[u]=O.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(S.sep);return t!==-1&&(a=a.substring(t+1)),I.WellKnowCommands[a]?a:"other"}start(a){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(O.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(t=>{let r,i;const o=new Promise((u,c)=>{r=u,i=c});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=k.exec(u,this.options,(c,l,v)=>{this.childProcess=null;const E=c;E&&E.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:v.toString()}):this.handleExec(r,a,c,l,v)})}else{let u=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,i);const v={terminated:this.terminateRequested};R.isNumber(l)&&(v.cmdCode=l),r(v)};if(this.shell&&n.isWindows){const l=p.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let v=!1,E=!1;const f=[];let U=this.ensureQuotes(this.cmd);f.push(U.value),v=U.quoted,this.args&&this.args.forEach(z=>{U=this.ensureQuotes(z),f.push(U.value),E=E&&U.quoted});const F=["/s","/c"];v?E?F.push('"'+f.join(" ")+'"'):f.length>1?F.push('"'+f[0]+'" '+f.slice(1).join(" ")):F.push('"'+f[0]+'"'):F.push(f.join(" ")),u=k.spawn(C(),F,l)}else this.cmd&&(u=k.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(R.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",c),this.handleSpawn(u,r,a,i,!0)))}return o})}handleClose(a,t,r,i){}ensureQuotes(a){return I.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,h(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!n.isWindows)return a(!1);const t=k.spawn(C(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class b extends I{constructor(a,t,r,i){super(a,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,i,o){[i,o].forEach((u,c)=>{const l=new m.LineDecoder;l.write(u).forEach(f=>{t({line:f,source:c===0?0:1})});const E=l.end();E&&t({line:E,source:c===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,i,o){const u=new m.LineDecoder,c=new m.LineDecoder;a.stdout.on("data",l=>{u.write(l).forEach(E=>r({line:E,source:0}))}),a.stderr.on("data",l=>{c.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=c}handleClose(a,t,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=b;function D(s){let a=[],t=!1;const r=function(i){if(t){a.push(i);return}(!s.send(i,u=>{if(u&&console.error(u),t=!1,a.length>0){const c=a.slice(0);a=[],c.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=D;var y;(function(s){async function a(t,r,i){if(S.isAbsolute(t))return t;if(r===void 0&&(r=O.cwd()),S.dirname(t)!=="."||(i===void 0&&R.isString(O.env.PATH)&&(i=O.env.PATH.split(S.delimiter)),i===void 0||i.length===0))return S.join(r,t);async function u(c){return await L.Promises.exists(c)?!(await L.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(S.isAbsolute(c)?l=S.join(c,t):l=S.join(r,c,t),await u(l))return l;let v=l+".com";if(await u(v)||(v=l+".exe",await u(v)))return v}return S.join(r,t)}s.findExecutable=a})(y=e.win32||(e.win32={}))}),define(ee[49],te([0,1,42,2,6,26,3,107,36,90,29,11,25,7]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(b){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(y){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",D=>d.VSBuffer.wrap(Buffer.from(D,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,D){this.modulePath=b,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new k.Delayer(y),this.child=null,this._client=null}getChannel(b){const D=this;return{call(y,s,a){return D.requestPromise(b,y,s,a)},listen(y,s){return D.requestEvent(b,y,s)}}}requestPromise(b,D,y,s=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=k.createCancelablePromise(o=>a.call(D,y,o)),r=s.onCancellationRequested(()=>t.cancel()),i=L.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,D,y){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let s;const a=new O.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(D,y)(a.fire,a),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env={...T.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(D.env={...D.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),g.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=S.fork(this.modulePath,b,D);const y=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(w.isRemoteConsoleLog(u)){w.log(u,`IPC Library: ${this.options.serverName}`);return}y.fire(d.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?R.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),r=y.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,c)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>L.dispose(l)),this.activeRequests.clear(),u!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:c})})}return this._client}getCachedChannel(b){let D=this.channels.get(b);return D||(D=this.client.getChannel(b),this.channels.set(b,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(ee[108],te([13,14]),function(G,e){return G.create("vs/base/node/zip",e)}),define(ee[109],te([13,14]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[110],te([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[111],te([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ee[112],te([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ee[113],te([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ee[114],te([13,14]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ee[115],te([13,14]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[116],te([13,14]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[117],te([13,14]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[118],te([13,14]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[119],te([13,14]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[120],te([13,14]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[121],te([13,14]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[122],te([13,14]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ee[123],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ee[124],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ee[125],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ee[126],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ee[127],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ee[128],te([13,14]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ee[129],te([0,1,8,12,64,55,17,5,34]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,C,I){this._args=h,this.paths=C,this.productService=I}get appRoot(){return S.dirname(O.FileAccess.asFileUri("",G).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file(S.join(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=T.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=S.join(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file(S.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(R.URI.file(S.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=p.env.VSCODE_PORTABLE;return h?R.URI.file(S.join(h,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file(S.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return S.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?S.resolve(h):S.normalize(S.join(O.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?S.resolve(h):S.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return S.resolve(h);const C=p.env.VSCODE_EXTENSIONS;if(C)return C;const I=p.env.VSCODE_PORTABLE;return I?S.join(I,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?R.URI.parse(C):R.URI.file(S.normalize(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?R.URI.parse(h):R.URI.file(S.normalize(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file(S.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([k.memoize],w.prototype,"appRoot",null),de([k.memoize],w.prototype,"userHome",null),de([k.memoize],w.prototype,"userDataPath",null),de([k.memoize],w.prototype,"appSettingsHome",null),de([k.memoize],w.prototype,"tmpDir",null),de([k.memoize],w.prototype,"userRoamingDataHome",null),de([k.memoize],w.prototype,"settingsResource",null),de([k.memoize],w.prototype,"userDataSyncHome",null),de([k.memoize],w.prototype,"userDataSyncLogResource",null),de([k.memoize],w.prototype,"sync",null),de([k.memoize],w.prototype,"machineSettingsResource",null),de([k.memoize],w.prototype,"globalStorageHome",null),de([k.memoize],w.prototype,"workspaceStorageHome",null),de([k.memoize],w.prototype,"keybindingsResource",null),de([k.memoize],w.prototype,"keyboardLayoutResource",null),de([k.memoize],w.prototype,"argvResource",null),de([k.memoize],w.prototype,"snippetsHome",null),de([k.memoize],w.prototype,"isExtensionDevelopment",null),de([k.memoize],w.prototype,"untitledWorkspacesHome",null),de([k.memoize],w.prototype,"installSourcePath",null),de([k.memoize],w.prototype,"builtinExtensionsPath",null),de([k.memoize],w.prototype,"extensionsPath",null),de([k.memoize],w.prototype,"extensionDevelopmentLocationURI",null),de([k.memoize],w.prototype,"extensionDevelopmentKind",null),de([k.memoize],w.prototype,"extensionTestsLocationURI",null),de([k.memoize],w.prototype,"debugExtensionHost",null),de([k.memoize],w.prototype,"serviceMachineIdResource",null),de([k.memoize],w.prototype,"telemetryLogResource",null),de([k.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(g,h){return d(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId)}e.parseExtensionHostPort=n;function m(g,h){return d(g["inspect-search"],g["inspect-brk-search"],5876,h)}e.parseSearchPort=m;function d(g,h,C,I,b){const y=Number(h||g)||(I?null:C),s=y?Boolean(!!h):!1;return{port:y,break:s,debugId:b}}}),function(){"use strict";function G(e,S,L,k){function T(R){const p=O(R),w=[p];return e.isAbsolute(p)||w.unshift(k),e.resolve(...w)}function O(R){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const w=R["user-data-dir"];if(w)return w;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(m,"AppData","Roaming")}break;case"darwin":n=e.join(S.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,L)}return{getUserDataPath:T}}if(typeof define=="function")define(ee[130],te([0,209,35,17,12,34]),function(e,S,L,k,T,O){const R=T.dirname(k.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);return G(S,L,p.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),L=require("os");module.exports=G(S,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[131],te([0,1,35,130,129]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends k.AbstractNativeEnvironmentService{constructor(R,p){super(R,{homeDir:S.homedir(),tmpDir:S.tmpdir(),userDataDir:L.getUserDataPath(R)},p)}}e.NativeEnvironmentService=T}),define(ee[132],te([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(I){const b=I.match(O);return b?b[1]:null}function n(I){if(I.indexOf("://")===-1){const b=I.match(L);return b?w(b[2]):null}try{const b=S.URI.parse(I);if(b.authority)return w(b.authority)}catch(b){}return null}function m(I,b){const D=new Set;let y;for(;y=R.exec(I);){const a=n(y[1]);a&&D.add(a)}const s=new Set(b);return Array.from(D).map(a=>s.has(a)?a:a.replace(p,"a"))}e.getDomainsOfRemotes=m;function d(I){const b=I.match(T);return b?b[2]:null}function g(I,b,D){return I&&b?(D&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${I}${b}`:`${I}/${b}`):null}function h(I,b){if(I.indexOf("://")===-1){const D=I.match(k);if(D)return g(D[2],D[3],b)}try{const D=S.URI.parse(I);if(D.authority)return g(d(D.authority),D.path,b)}catch(D){}return null}function C(I,b=!1){const D=[];let y;for(;y=R.exec(I);){const s=h(y[1],b);s&&D.push(s)}return D}e.getRemotes=C}),define(ee[133],te([0,1,3,5,93,26,2]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(h,C){return L.URI.revive(C?C.transformIncoming(h):h)}function p(h,C){return C?C.transformOutgoingURI(h):h}function w(h,C){C=C||k.DefaultURITransformer;const I=h.manifest;return{...k.transformAndReviveIncomingURIs({...h,manifest:void 0},C),manifest:I}}function n(h,C){return C?T.cloneAndChange(h,I=>I instanceof L.URI?C.transformOutgoingURI(I):void 0):h}class m{constructor(C,I){this.service=C,this.getUriTransformer=I,this.onInstallExtension=S.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=S.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=S.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,I){const b=this.getUriTransformer(C);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return S.Event.map(this.onDidInstallExtension,D=>({...D,local:D.local?n(D.local,b):D.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,I,b){const D=this.getUriTransformer(C);switch(I){case"zip":return this.service.zip(w(b[0],D)).then(y=>p(y,D));case"unzip":return this.service.unzip(R(b[0],D));case"install":return this.service.install(R(b[0],D),b[1]);case"getManifest":return this.service.getManifest(R(b[0],D));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],D),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],D));case"getInstalled":return this.service.getInstalled(b[0]).then(y=>y.map(s=>n(s,D)));case"updateMetadata":return this.service.updateMetadata(w(b[0],D),b[1]).then(y=>n(y,D));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],D),b[1]).then(y=>n(y,D));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class d extends O.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new S.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire(I))),this._register(this.channel.listen("onDidInstallExtension")(I=>this._onDidInstallExtension.fire({...I,local:I.local?w(I.local,null):I.local}))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(I=>L.URI.revive(I)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,I){return Promise.resolve(this.channel.call("install",[C,I])).then(b=>w(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,I){return Promise.resolve(this.channel.call("installFromGallery",[C,I])).then(b=>w(b,null))}uninstall(C,I){return Promise.resolve(this.channel.call("uninstall",[C,I]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(I=>I.map(b=>w(b,null)))}updateMetadata(C,I){return Promise.resolve(this.channel.call("updateMetadata",[C,I])).then(b=>w(b,null))}updateExtensionScope(C,I){return Promise.resolve(this.channel.call("updateExtensionScope",[C,I])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=d;class g{constructor(C){this.service=C}listen(C,I){throw new Error("Invalid listen")}call(C,I,b){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(ee[134],te([0,1,26]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function k(T,O){const R=p=>{if(typeof p!="string")return;const w=L.exec(p);if(!w)return;const n=O[w[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return S.cloneAndChange(T,R)}e.localizeManifest=k}),define(ee[135],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,O,R,p){return this.channel.call("promptImportantExtensionsInstallNotification",[T,O,R,p])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class L{constructor(T){this.service=T}listen(T,O){throw new Error(`Event not found: ${O}`)}call(T,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(ee[70],te([0,1,115]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=T;function O(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(L);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=O;function R(d){if(!d)return null;let g=d.majorBase,h=d.majorMustEqual,C=d.minorBase,I=d.minorMustEqual,b=d.patchBase,D=d.patchMustEqual;d.hasCaret&&(g===0||(I=!1),D=!1);let y=0;if(d.preRelease){const s=k.exec(d.preRelease);if(s){const[,a,t,r]=s;y=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:g,majorMustEqual:h,minorBase:C,minorMustEqual:I,patchBase:b,patchMustEqual:D,isMinimum:d.hasGreaterEquals,notBefore:y}}e.normalizeVersion=R;function p(d,g,h){let C;typeof d=="string"?C=R(O(d)):C=d;let I;g instanceof Date?I=g.getTime():typeof g=="string"&&(I=new Date(g).getTime());let b;if(typeof h=="string"?b=R(O(h)):b=h,!C||!b)return!1;let D=C.majorBase,y=C.minorBase,s=C.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,o=b.majorMustEqual,u=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?D>a?!0:D<a?!1:y>t?!0:y<t||I&&I<i?!1:s>=r:(D===1&&a===0&&(!o||!u||!c)&&(a=1,t=0,r=0,o=!0,u=!1,c=!1),D<a?!1:D>a?!o:y<t?!1:y>t?!u:s<r?!1:s>r?!c:!(I&&I<i))}e.isValidVersion=p;function w(d,g,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:m(d,g,h.engines.vscode,C)}e.isValidExtensionVersion=w;function n(d,g,h){return d==="*"||m(g,h,d)}e.isEngineValid=n;function m(d,g,h,C=[]){let I=R(O(h));if(!I)return C.push(S.localize(0,null,h)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return C.push(S.localize(1,null,h)),!1}else if(!I.majorMustEqual)return C.push(S.localize(2,null,h)),!1;return p(d,g,I)?!0:(C.push(S.localize(3,null,d,h)),!1)}}),define(ee[136],te([0,1,36,49,2,17]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends k.Disposable{constructor(p,w,n,m){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService(S.getNextTickChannel(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(ee[137],te([0,1,36,49,2,17]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends k.Disposable{constructor(p,w,n,m,d={}){super();this.folders=p,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=m,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(T.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService(S.getNextTickChannel(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(ee[138],te([0,1,42,68,67,17]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(p,w,n,m,d){this.watchedFolder=p,this.eventCallback=n,this.logCallback=m,this.verboseLogging=d,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(g=>k.parse(g)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=S.spawn(T.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,p);const w=new L.LineDecoder;this.handle.stdout.on("data",n=>{const m=[];for(const d of w.write(n)){const g=d.split("|");if(g.length===2){const h=Number(g[0]),C=g[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(I=>I(C))){this.verboseLogging&&this.log(C);continue}m.push({type:O.changeTypeMap[h],path:C})}else this.log(g[1])}}m.length>0&&this.eventCallback(m)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,m)=>this.onExit(n,m))}onError(p){this.error("process error: "+p.toString())}onExit(p,w){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${w})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(ee[139],te([0,1,138,8,20]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(R,p,w,n){this.onDidFilesChange=p,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=k.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(ee[50],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class S{constructor(T,O=[],R=!1){this.ctor=T,this.staticArguments=O,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=S;const L=(k,...T)=>new S(k,T);e.createSyncDescriptor=L}),define(ee[140],te([0,1,50]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function k(O,R,p){R instanceof S.SyncDescriptor||(R=new S.SyncDescriptor(R,[],p)),L.push([O,R])}e.registerSingleton=k;function T(){return L}e.getSingletonServiceDescriptors=T}),define(ee[141],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=S;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let O of this._nodes.values())O.outgoing.size===0&&T.push(O);return T}insertEdge(T,O){const R=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(O);R.outgoing.set(this._hashFn(O),p),p.incoming.set(this._hashFn(T),R)}removeNode(T){const O=this._hashFn(T);this._nodes.delete(O);for(let R of this._nodes.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(T){const O=this._hashFn(T);let R=this._nodes.get(O);return R||(R=new S(T),this._nodes.set(O,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[O,R]of this._nodes)T.push(`${O}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,O]of this._nodes){const R=new Set([T]),p=this._findCycle(O,R);if(p)return p}}_findCycle(T,O){for(let[R,p]of T.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const w=this._findCycle(p,O);if(w)return w;O.delete(R)}}}e.Graph=L}),define(ee[4],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(w){return w[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(S=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function L(R,p,w,n){p[S.DI_TARGET]===p?p[S.DI_DEPENDENCIES].push({id:R,index:w,optional:n}):(p[S.DI_DEPENDENCIES]=[{id:R,index:w,optional:n}],p[S.DI_TARGET]=p)}function k(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const p=function(w,n,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(p,w,m,!1)};return p.toString=()=>R,S.serviceIds.set(R,p),p}e.createDecorator=k;function T(R){return R}e.refineServiceDecorator=T;function O(R){return function(p,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(R,p,n,!0)}}e.optional=O}),define(ee[142],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=S.createDecorator("checksumService")}),define(ee[143],te([0,1,20,4,7]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=k.userAgent||"";const O=new Map;O.set("false",!1),O.set("true",!0),O.set("isMac",k.isMacintosh),O.set("isLinux",k.isLinux),O.set("isWindows",k.isWindows),O.set("isWeb",k.isWeb),O.set("isMacNative",k.isMacintosh&&!k.isWeb),O.set("isEdge",T.indexOf("Edg/")>=0),O.set("isFirefox",T.indexOf("Firefox")>=0),O.set("isChrome",T.indexOf("Chrome")>=0),O.set("isSafari",T.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var p;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return m.INSTANCE}static true(){return d.INSTANCE}static has(f){return g.create(f)}static equals(f,U){return h.create(f,U)}static notEquals(f,U){return b.create(f,U)}static regex(f,U){return r.create(f,U)}static in(f,U){return C.create(f,U)}static not(f){return D.create(f)}static and(...f){return o.create(f)}static or(...f){return u.create(f)}static greater(f,U){return y.create(f,U)}static less(f,U){return a.create(f,U)}static deserialize(f,U=!1){if(!!f)return this._deserializeOrExpression(f,U)}static _deserializeOrExpression(f,U){let F=f.split("||");return u.create(F.map(z=>this._deserializeAndExpression(z,U)))}static _deserializeAndExpression(f,U){let F=f.split("&&");return o.create(F.map(z=>this._deserializeOne(z,U)))}static _deserializeOne(f,U){if(f=f.trim(),f.indexOf("!=")>=0){let F=f.split("!=");return b.create(F[0].trim(),this._deserializeValue(F[1],U))}if(f.indexOf("==")>=0){let F=f.split("==");return h.create(F[0].trim(),this._deserializeValue(F[1],U))}if(f.indexOf("=~")>=0){let F=f.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(f.indexOf(" in ")>=0){let F=f.split(" in ");return C.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const F=f.split(">=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const F=f.split(">");return y.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const F=f.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const F=f.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(f)?D.create(f.substr(1).trim()):g.create(f)}static _deserializeValue(f,U){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let F=/^'([^']*)'$/.exec(f);return F?F[1].trim():f}static _deserializeRegexValue(f,U){if(S.isFalsyOrWhitespace(f)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=f.indexOf("/"),z=f.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let $=f.slice(F+1,z),V=f[z+1]==="i"?"i":"";try{return new RegExp($,V)}catch(B){if(U)throw new Error(`bad regexp-value '${f}', parse error: ${B}`);return console.warn(`bad regexp-value '${f}', parse error: ${B}`),null}}}e.ContextKeyExpr=w;function n(E,f){return E.cmp(f)}class m{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class d{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(f){this.key=f,this.type=2}static create(f){const U=O.get(f);return typeof U=="boolean"?U?d.INSTANCE:m.INSTANCE:new g(f)}cmp(f){return f.type!==this.type?this.type-f.type:l(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=g;class h{constructor(f,U){this.key=f,this.value=U,this.type=4}static create(f,U){if(typeof U=="boolean")return U?g.create(f):D.create(f);const F=O.get(f);return typeof F=="boolean"?U===(F?"true":"false")?d.INSTANCE:m.INSTANCE:new h(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(f,U){this.key=f,this.valueKey=U,this.type=10}static create(f,U){return new C(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const U=f.getValue(this.valueKey),F=f.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?R.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=C;class I{constructor(f){this._actual=f,this.type=11}static create(f){return new I(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new I(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class b{constructor(f,U){this.key=f,this.value=U,this.type=5}static create(f,U){if(typeof U=="boolean")return U?D.create(f):g.create(f);const F=O.get(f);return typeof F=="boolean"?U===(F?"true":"false")?m.INSTANCE:d.INSTANCE:new b(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class D{constructor(f){this.key=f,this.type=3}static create(f){const U=O.get(f);return typeof U=="boolean"?U?m.INSTANCE:d.INSTANCE:new D(f)}cmp(f){return f.type!==this.type?this.type-f.type:l(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=D;class y{constructor(f,U){this.key=f,this.value=U,this.type=12}static create(f,U){return new y(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=y;class s{constructor(f,U){this.key=f,this.value=U,this.type=13}static create(f,U){return new s(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class a{constructor(f,U){this.key=f,this.value=U,this.type=14}static create(f,U){return new a(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(f,U){this.key=f,this.value=U,this.type=15}static create(f,U){return new t(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:v(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return y.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(f,U){this.key=f,this.regexp=U,this.type=7}static create(f,U){return new r(f,U)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const U=this.regexp?this.regexp.source:"",F=f.regexp?f.regexp.source:"";return U<F?-1:U>F?1:0}equals(f){if(f.type===this.type){const U=this.regexp?this.regexp.source:"",F=f.regexp?f.regexp.source:"";return this.key===f.key&&U===F}return!1}evaluate(f){let U=f.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(f){this._actual=f,this.type=8}static create(f){return new i(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new i(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class o{constructor(f){this.expr=f,this.type=6}static create(f){return o._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=n(this.expr[U],f.expr[U]);if(z!==0)return z}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}evaluate(f){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(f))return!1;return!0}static _normalizeArr(f){const U=[];let F=!1;for(const z of f)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return m.INSTANCE;if(z.type===6){U.push(...z.expr);continue}U.push(z)}if(U.length===0&&F)return d.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];for(U.sort(n);U.length>1;){const z=U[U.length-1];if(z.type!==9)break;U.pop();const $=U.pop(),V=u.create(z.expr.map(B=>o.create([B,$])));V&&(U.push(V),U.sort(n))}return U.length===1?U[0]:new o(U)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let U of this.expr)f.push(...U.keys());return f}map(f){return new o(this.expr.map(U=>U.map(f)))}negate(){let f=[];for(let U of this.expr)f.push(U.negate());return u.create(f)}}e.ContextKeyAndExpr=o;class u{constructor(f){this.expr=f,this.type=9}static create(f){const U=u._normalizeArr(f);if(U.length!==0)return U.length===1?U[0]:new u(U)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=n(this.expr[U],f.expr[U]);if(z!==0)return z}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}evaluate(f){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(f))return!0;return!1}static _normalizeArr(f){let U=[],F=!1;if(f){for(let z=0,$=f.length;z<$;z++){const V=f[z];if(!!V){if(V.type===0){F=!0;continue}if(V.type===1)return[d.INSTANCE];if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&F)return[m.INSTANCE];U.sort(n)}return U}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let U of this.expr)f.push(...U.keys());return f}map(f){return new u(this.expr.map(U=>U.map(f)))}negate(){let f=[];for(let F of this.expr)f.push(F.negate());const U=F=>F.type===9?F.expr:[F];for(;f.length>1;){const F=f.shift(),z=f.shift(),$=[];for(const V of U(F))for(const B of U(z))$.push(w.and(V,B));f.unshift(w.or(...$))}return f[0]}}e.ContextKeyOrExpr=u;class c extends g{constructor(f,U,F){super(f);this._defaultValue=U,typeof F=="object"?c._info.push({...F,key:f}):F!==!0&&c._info.push({key:f,description:F,type:U!=null?typeof U:void 0})}static all(){return c._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(f){return w.equals(this.key,f)}notEqualsTo(f){return w.notEquals(this.key,f)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=L.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(E,f){return E<f?-1:E>f?1:0}function v(E,f,U,F){return E<U?-1:E>U?1:f<F?-1:f>F?1:0}}),define(ee[71],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=S.createDecorator(e.ID);function L(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=L}),define(ee[72],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=S.createDecorator("downloadService")}),define(ee[9],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=S.createDecorator("environmentService"),e.INativeEnvironmentService=S.refineServiceDecorator(e.IEnvironmentService)}),define(ee[28],te([0,1,110,4,17]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=T;var O;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(O=e.SortBy||(e.SortBy={}));var R;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var p;(function(m){m.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var w;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,g){super(d);this.code=g,this.name=g}}e.ExtensionManagementError=n,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=S.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=S.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")});var Y=this&&this.__param||function(G,e){return function(S,L){e(S,L,G)}};define(ee[144],te([0,1,2,28]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let k=class extends S.Disposable{constructor(O){super();this.extensionManagementService=O,this._register(O),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};k=de([Y(0,L.IExtensionManagementService)],k),e.DeprecatedExtensionsCleaner=k}),define(ee[73],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function k(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=S.createDecorator("IExtensionRecommendationNotificationService")}),define(ee[74],te([0,1,20,4]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=k;function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));class R{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,d){if(typeof m=="undefined"||m===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){let g=typeof m=="string"?m:m.value,h=typeof d=="string"?d:d.value;return S.equalsIgnoreCase(g,h)}return m._lower===d._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=R;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(ee[33],te([0,1,20,74]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:S.compareIgnoreCase(h.id,C.id)===0}e.areSameExtensions=k;class T{constructor(C,I){this.version=I,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof T?k(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=T;function O(h,C){return`${h}.${C}`}e.getExtensionId=O;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function p(h,C){return R(O(h,C))}e.getGalleryExtensionId=p;function w(h,C){const I=[],b=D=>{for(const y of I)if(y.some(s=>k(C(s),C(D))))return y;return null};for(const D of h){const y=b(D);y?y.push(D):I.push([D])}return I}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function m(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(h){const C=new Set;for(const I of h)I.malicious&&C.add(I.id.id);return C}e.getMaliciousExtensionsSet=d;function g(h,C){const I=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const D=b.shift();if(D&&I.every(y=>!k(y.identifier,{id:D}))){const y=h.filter(s=>k(s.identifier,{id:D}));y.length===1&&(I.push(y[0]),b.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=g}),define(ee[145],te([0,1,2,8,74,18]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends S.Disposable{constructor(p,w){super();this.environmentService=p,this.extensionsManifestCache=L.join(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(p){p.error||this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(ee[10],te([0,1,117,8,5,4,20,16,38]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=T.createDecorator("fileService");function w(_){return _.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var m;(function(_){_[_.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=g;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function I(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=I;var b;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor(W,K){super(W);this.code=K}}e.FileSystemProviderError=D;function y(_,W){const K=new D(_.toString(),W);return a(K,W),K}e.createFileSystemProviderError=y;function s(_){return _||y(S.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function a(_,W){return _.name=W?`${W} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=a;function t(_){if(!_)return b.Unknown;if(_ instanceof D)return _.code;const W=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!W)return b.Unknown;switch(W[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(_){if(_ instanceof v)return _.fileOperationResult;switch(t(_)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(W,K,j){this.resource=W,this.operation=K,this.target=j}isOperation(W){return this.operation===W}}e.FileOperationEvent=o;var u;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(W,K){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of W)switch(j.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>K)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>K)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>K)),this.deleted.set(j.resource,j);break}}contains(W,...K){return this.doContains(W,{includeChildren:!1},...K)}affects(W,...K){return this.doContains(W,{includeChildren:!0},...K)}doContains(W,K,...j){if(!W)return!1;const P=j.length>0;return!!((!P||j.includes(1))&&(this.added?.get(W)||K.includeChildren&&this.added?.findSuperstr(W))||(!P||j.includes(0))&&(this.updated?.get(W)||K.includeChildren&&this.updated?.findSuperstr(W))||(!P||j.includes(2))&&(this.deleted?.findSubstr(W)||K.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(_,W,K){return!_||!W||_===W||W.length>_.length?!1:(W.charAt(W.length-1)!==L.sep&&(W+=L.sep),K?O.startsWithIgnoreCase(_,W):_.indexOf(W)===0)}e.isParent=l;class v extends Error{constructor(W,K,j){super(W);this.fileOperationResult=K,this.options=j}}e.FileOperationError=v;class E extends v{constructor(W,K,j){super(W,2,j);this.stat=K}}e.NotModifiedSinceFileOperationError=E;var f;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=F;async function z(_,W){if(!W.canHandleResource(k.URI.from({scheme:_.scheme})))return new Promise(K=>{const j=W.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(j.dispose(),K())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(W){return R.isNumber(W)||(W=0),W<$.KB?S.localize(1,null,W.toFixed(0)):W<$.MB?S.localize(2,null,(W/$.KB).toFixed(2)):W<$.GB?S.localize(3,null,(W/$.MB).toFixed(2)):W<$.TB?S.localize(4,null,(W/$.GB).toFixed(2)):S.localize(5,null,(W/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var V;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function B(_){return{maxFileSize:_===0?300*$.MB:16*$.GB,maxHeapSize:_===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=B}),define(ee[146],te([0,1,147,47,10]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(p,w)=>{const n=S.createHash("md5"),m=(await this.fileService.readFileStream(R)).value;L.listenStream(m,{onData:d=>n.update(d.buffer),onError:d=>w(d),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};T=de([Y(0,k.IFileService)],T),e.ChecksumService=T}),define(ee[75],te([0,1,5,10,7]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(p){return p.map(w=>({type:w.type,resource:S.URI.file(w.path)}))}e.toFileChanges=T;function O(p){const w=new R;for(const n of p)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=O;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const m=n.type,d=w.type;m===1&&d===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):m===2&&d===1?n.type=0:m===1&&d===0||(n.type=d)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(m=>m.type!==2?(w.push(m),!1):!0).sort((m,d)=>m.path.length-d.path.length).filter(m=>n.some(d=>L.isParent(m.path,d,!k.isLinux))?!1:(n.push(m.path),!0)).concat(w)}}}),define(ee[148],te([0,1,75,2,18,96,99,6,8]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(m,d,g,h){super();this.path=m,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:d}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let g=this.path;if(d)try{g=await T.realpath(g)}catch(h){if(this.onError(h),d.dangling)return}m.isDirectory()?this._register(O.watchFolder(g,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:p.join(this.path,p.basename(C))})},h=>this.onError(h))):this._register(O.watchFile(g,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=S.normalizeFileChanges(d);if(this.verboseLogging)for(const h of g)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);g.length>0&&this.onDidFilesChange(g)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(ee[76],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...k){this._entries=new Map;for(let[T,O]of k)this.set(T,O)}set(k,T){const O=this._entries.get(k);return this._entries.set(k,T),O}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=S}),define(ee[149],te([0,1,11,141,50,4,76,6]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new O.ServiceCollection,C=!1,I){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=I,this._services.set(T.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let I=d.traceInvocation(h),b=!1;try{return h({get:(y,s)=>{if(b)throw S.illegalState("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(y,I);if(!a&&s!==T.optional)throw new Error(`[invokeFunction] unknown service '${y}'`);return a}},...C)}finally{b=!0,I.stop()}}createInstance(h,...C){let I,b;return h instanceof k.SyncDescriptor?(I=d.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),I)):(I=d.traceCreation(h),b=this._createInstance(h,C,I)),I.stop(),b}_createInstance(h,C=[],I){let b=T._util.getServiceDependencies(h).sort((s,a)=>s.index-a.index),D=[];for(const s of b){let a=this._getOrCreateServiceInstance(s.id,I);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);D.push(a)}let y=b.length>0?b[0].index:C.length;if(C.length!==y){console.warn(`[createInstance] First service dependency of ${h.name} at position ${y+1} conflicts with ${C.length} static arguments`);let s=y-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,y)}return new h(...[...C,...D])}_setServiceInstance(h,C){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let I=this._getServiceInstanceOrDescriptor(h);return I instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,I,C.branch(h,!0)):(C.branch(h,!1),I)}_safeCreateAndCacheServiceInstance(h,C,I){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,I)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,I){const b=new L.Graph(s=>s.id.toString());let D=0;const y=[{id:h,desc:C,_trace:I}];for(;y.length;){const s=y.pop();if(b.lookupOrInsertNode(s),D++>1e3)throw new w(b);for(let a of T._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:a.id,desc:t,_trace:s._trace.branch(a.id,!0)};b.insertEdge(s,r),y.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,I=[],b,D){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(C,I,b,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,I,b,D);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],I,b){if(I){const D=new R.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(y,s){if(s in y)return y[s];let a=D.value,t=a[s];return typeof t!="function"||(t=t.bind(a),y[s]=t),t},set(y,s,a){return D.value[s]=a,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var m;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(m||(m={}));class d{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return p?new d(0,h.name):d._None}branch(h,C){let I=new d(2,h.toString());return this._dep.push([h,C,I]),I}stop(){let h=Date.now()-this._start;d._totals+=h;let C=!1;function I(D,y){let s=[],a=new Array(D+1).join("	");for(const[t,r,i]of y._dep)if(r&&i){C=!0,s.push(`${a}CREATES -> ${t}`);let o=I(D+1,i);o&&s.push(o)}else s.push(`${a}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ee[150],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=S}),define(ee[151],te([0,1,36,50,140,4]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(g,h,C){const I=C.getChannel(g);return R(h)?new h.channelClientCtor(I):S.ProxyChannel.toService(I,h?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=T.createDecorator("mainProcessService");let p=class extends O{constructor(g,h,C){super(g,h,C)}};p=de([Y(2,e.IMainProcessService)],p);function w(d,g,h){k.registerSingleton(d,new L.SyncDescriptor(p,[g,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=T.createDecorator("sharedProcessService");let n=class extends O{constructor(g,h,C){super(g,h,C)}};n=de([Y(2,e.ISharedProcessService)],n);function m(d,g,h){k.registerSingleton(d,new L.SyncDescriptor(n,[g,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=m}),define(ee[56],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=S.createDecorator("localizationsService");function L(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const T of k.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=L}),define(ee[152],te([0,1,2,56]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends S.Disposable{constructor(O){super();this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([Y(0,L.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(ee[15],te([0,1,4,2,7,3,43]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=S.createDecorator("logService"),e.ILoggerService=S.createDecorator("loggerService");function R(){return new Date().toISOString()}var p;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class w extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let o=t[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}r+=(i>0?" ":"")+o}return r}}e.AbstractMessageLogger=n;class m extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class d extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:O.toErrorMessage(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class I extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class b{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function D(a){if(a.verbose)return p.Trace;if(typeof a.logLevel=="string"){const t=y(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function y(a){switch(a){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=y;function s(a){switch(a){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=s}),define(ee[153],te([0,1,9,8,18,11,2,6,15]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends O.Disposable{constructor(m,d){super();this.environmentService=m,this.logService=d,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const m=L.basename(this.environmentService.logsPath),d=L.dirname(this.environmentService.logsPath),C=(await k.Promises.readdir(d)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==m),I=C.slice(0,Math.max(0,C.length-9));I.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${I.join(", ")}'`),await Promise.all(I.map(b=>k.Promises.rm(L.join(d,b)))))}catch(m){T.onUnexpectedError(m)}}};w=de([Y(0,S.IEnvironmentService),Y(1,p.ILogService)],w),e.LogsDataCleaner=w}),define(ee[154],te([0,1,9,8,18,11,2,6,15]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends O.Disposable{constructor(m,d,g){super();this.backupWorkspacesPath=m,this.environmentService=d,this.logService=g,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const m=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),g=JSON.parse(m).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&g.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await k.Promises.rm(L.join(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(m){T.onUnexpectedError(m)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=de([Y(1,S.INativeEnvironmentService),Y(2,p.ILogService)],w),e.StorageDataCleaner=w}),define(ee[155],te([0,1,18,2,10,28,9,5,12,33,15,30,57,7,6,11]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(y,s,a,t){super();this.fileService=s,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=R.URI.file(y.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(y,s){await this.cleanUpPromise;const a=this.getName(y),t=p.joinPath(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=p.joinPath(this.extensionsDownloadDir,`.${m.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(y,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(o){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",y.identifier.id);else throw this.logService.info(`Rename failed because of ${C.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(y){}async rename(y,s,a){try{await S.Promises.rename(y.fsPath,s.fsPath)}catch(t){if(g.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${y} to ${s} with 'EPERM' error. Trying again...`),this.rename(y,s,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const y=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(y.children){const s=[],a=[];for(const i of y.children){const o=this.parse(i.name);o&&a.push([o,i])}const t=w.groupByExtension(a,([i])=>i),r=[];for(const i of t)i.sort((o,u)=>d.rcompare(o[0].version,u[0].version)),s.push(...i.slice(1).map(o=>o[1].resource)),r.push(i[0][1]);r.sort((i,o)=>i.mtime-o.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(y){this.logService.error(y)}}getName(y){return this.cache?new w.ExtensionIdentifierWithVersion(y.identifier,y.version).key().toLowerCase():m.generateUuid()}parse(y){const s=I.exec(y);return s&&s[1]&&s[2]?new w.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=de([Y(0,O.INativeEnvironmentService),Y(1,k.IFileService),Y(2,T.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(ee[156],te([0,1,2,15,42,43,8,6,3,17,18,9]),function(G,e,S,L,k,T,O,R,p,w,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends S.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new R.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${I}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(h,C){const I=`vscode:${C}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[I]=="string"){const b=h.manifest.scripts[I].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${I} should be a node script`),null):{script:O.join(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,I,b,D){return new Promise((y,s)=>{const a=this.start(h,C,I,D);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):y(void 0)};a.on("error",i=>{r(T.toErrorMessage(i)||"Unknown")}),a.on("exit",(i,o)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),s("timed out")},5e3))})}start(h,C,I,b){const D={silent:!0,execArgv:void 0},y=k.fork(h,[`--type=extension-post-${C}`,...I],D);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const s=p.Event.fromNodeEventEmitter(y.stdout,"data"),a=p.Event.fromNodeEventEmitter(y.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),a(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=p.Event.any(p.Event.map(s,i=>({data:`%c${i}`,format:[""]})),p.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),y}getExtensionStoragePath(h){return O.join(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([Y(0,m.IEnvironmentService),Y(1,L.ILogService)],d),e.ExtensionsLifecycle=d}),define(ee[157],te([0,1,2,9,3,10,5,33,12,15]),function(G,e,S,L,k,T,O,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends S.Disposable{constructor(d,g,h,C){super();this.extensionsManagementService=d,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(y=>y.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(D=>this.onInstallExtension(D))),this._register(d.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(d.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const I=O.URI.file(h.extensionsPath),b=new p.ExtUri(D=>!g.hasCapability(D,1024));this._register(g.watch(I)),this._register(k.Event.filter(g.onDidChangeFilesRaw,D=>D.changes.some(y=>this.doesChangeAffects(y,I,b)))(()=>this.onDidChange()))}doesChangeAffects(d,g,h){return h.isEqual(h.dirname(d.resource),g)?h.isEqual(d.resource,h.joinPath(g,".obsolete"))?!0:!(d.type!==1&&d.type!==2||h.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtension(d){this.removeInstallingExtension(d.identifier),d.error||this.addInstalledExtension(d.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(g=>!R.areSameExtensions(g,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(g=>!R.areSameExtensions(g,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),g=d.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(I=>R.areSameExtensions(I,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(I=>R.areSameExtensions(I,C))?!1:d.every(I=>!R.areSameExtensions(I.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=d.map(C=>C.identifier),(g.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:g,removed:h})}}};n=de([Y(1,T.IFileService),Y(2,L.INativeEnvironmentService),Y(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(ee[158],te([0,1,18,147,28,2,9,6,33,15,56,19,3,17,8]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends T.Disposable{constructor(D,y,s){super();this.extensionManagementService=D,this.logService=s,this._onDidLanguagesChange=this._register(new d.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new I(y,s)),this._register(D.onDidInstallExtension(({local:a})=>this.onDidInstallExtension(a))),this._register(D.onDidUninstallExtension(({identifier:a})=>this.onDidUninstallExtension(a)))}getLanguageIds(){return this.cache.getLanguagePacks().then(D=>{const y=["en",...Object.keys(D)];return m.distinct(y)})}onDidInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",D.identifier.id),this.update().then(y=>{y&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(D){this.cache.getLanguagePacks().then(y=>{Object.keys(y).some(s=>y[s]&&y[s].extensions.some(a=>p.areSameExtensions(a.extensionIdentifier,D)))&&(this.logService.debug("Removing language packs from the extension",D.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[D,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(y);return!m.equals(Object.keys(D),Object.keys(s))}};C=de([Y(0,k.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,w.ILogService)],C),e.LocalizationsService=C;let I=class extends T.Disposable{constructor(D,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=h.join(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(y=>{Object.keys(y).forEach(s=>delete y[s]),this.createLanguagePacksFromExtensions(y,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...y){for(const s of y)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,s);Object.keys(D).forEach(s=>this.updateHash(D[s]))}createLanguagePacksFromExtension(D,y){const s=y.identifier,a=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const t of a)if(y.location.scheme===g.Schemas.file&&n.isValidLocalization(t)){let r=D[t.languageId];r||(r={hash:"",extensions:[],translations:{}},D[t.languageId]=r);let i=r.extensions.filter(o=>p.areSameExtensions(o.extensionIdentifier,s))[0];i?i.version=y.manifest.version:r.extensions.push({extensionIdentifier:s,version:y.manifest.version});for(const o of t.translations)r.translations[o.id]=h.join(y.location.fsPath,o.path)}}updateHash(D){if(D){const y=L.createHash("md5");for(const s of D.extensions)y.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);D.hash=y.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(a){return{}}}).then(s=>(y=D(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.languagePacks=s,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),S.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>y,s=>this.logService.error(s))})}};I=de([Y(0,O.INativeEnvironmentService),Y(1,w.ILogService)],I)}),define(ee[77],te([0,1,15,3,5]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(d){this.service=d,this.onDidChangeLogLevel=L.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=T;class O{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){O.setLevel(this.channel,d)}static setLevel(d,g){return d.call("setLevel",g)}}e.LogLevelChannelClient=O;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,g){throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"createLogger":this.createLogger(k.URI.revive(h[0]),h[1]);return;case"log":return this.log(k.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${g}`)}createLogger(d,g){this.loggers.set(d.toString(),this.loggerService.createLogger(d,g))}consoleLog(d,g){let h=console.log;switch(d){case S.LogLevel.Error:h=console.error;break;case S.LogLevel.Warning:h=console.warn;break;case S.LogLevel.Info:h=console.info;break}h.call(console,...g)}log(d,g){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,I]of g)switch(C){case S.LogLevel.Trace:h.trace(I);break;case S.LogLevel.Debug:h.debug(I);break;case S.LogLevel.Info:h.info(I);break;case S.LogLevel.Warning:h.warn(I);break;case S.LogLevel.Error:h.error(I);break;case S.LogLevel.Critical:h.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class p extends S.AbstractLoggerService{constructor(d,g,h){super(d,g);this.channel=h}createConsoleMainLogger(){return new S.AdapterLogger({log:(d,g)=>{this.channel.call("consoleLog",[d,g])}})}doCreateLogger(d,g,h){return new w(this.channel,d,g,h)}}e.LoggerChannelClient=p;class w extends S.AbstractMessageLogger{constructor(d,g,h,C){super(C?.always);this.channel=d,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[g,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,g){const h=[[d,g]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class n extends S.LogService{constructor(d,g){super(g);this.parent=d,this._register(d.onDidChangeLogLevel(h=>g.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=n}),define(ee[58],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=S.createDecorator("nativeHostService")}),define(ee[51],te([0,1,17,7,34,12]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const R=L.globals.vscode.context.configuration();if(R)O=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof G?.__$__nodeRequire=="function"){const R=T.dirname(S.FileAccess.asFileUri("",G));O=G.__$__nodeRequire(T.joinPath(R,"product.json").fsPath);const p=G.__$__nodeRequire(T.joinPath(R,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`}),Object.assign(O,{version:p.version})}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.58.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=O}),define(ee[78],te([0,1,118,25,10,11,51]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(m,d,g,h,C,I){let b;try{await p(m,d,g,h,C,I)}catch(D){b=D}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&g.error(b),g.end()}}e.readFileIntoStream=R;async function p(m,d,g,h,C,I){w(I);const b=await m.open(d,{create:!1});try{w(I);let D=0,y=0,s=C&&typeof C.length=="number"?C.length:void 0,a=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do y=await m.read(b,t,a.buffer,r,a.byteLength-r),t+=y,r+=y,D+=y,typeof s=="number"&&(s-=y),r===a.byteLength&&(await g.write(h(a)),a=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),r=0);while(y>0&&(typeof s!="number"||s>0)&&w(I)&&n(D,C));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),g.write(h(a.slice(0,i)))}}catch(D){throw k.ensureFileSystemProviderError(D)}finally{await m.close(b)}}function w(m){if(m.isCancellationRequested)throw T.canceled();return!0}function n(m,d){if(d?.limits){if(typeof d.limits.memory=="number"&&m>d.limits.memory)throw k.createFileSystemProviderError(S.localize(0,null,O.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&m>d.limits.size)throw k.createFileSystemProviderError(S.localize(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[159],te([0,1,116,160,2,10,3,12,38,19,15,25,47,6,29,17,78,53]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class je extends k.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new O.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new g.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new T.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new g.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new T.FileChangesEvent(a,!0)))),this.watchedResources=p.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new g.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);L.mark(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const t=new k.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),k.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),k.dispose(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){a.push(t)}}),!this.provider.has(s)&&await g.Promises.settled(a)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,a){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!R.isAbsolutePath(s))throw new T.FileOperationError(S.localize(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=S.localize(1,null,s.toString()),t}return a}async withReadProvider(s){const a=await this.withProvider(s);if(T.hasOpenReadWriteCloseCapability(a)||T.hasReadWriteCapability(a)||T.hasFileReadStreamCapability(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if(T.hasOpenReadWriteCloseCapability(a)||T.hasReadWriteCapability(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(t){throw T.toFileSystemProviderErrorCode(t)===T.FileSystemProviderErrorCode.FileNotFound?new T.FileOperationError(S.localize(2,null,this.resourceForError(s)),1):T.ensureFileSystemProviderError(t)}}async doResolveFile(s,a){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=a?.resolveTo,o=a?.resolveSingleChildDescendants,u=a?.resolveMetadata,c=await t.stat(s);let l;return this.toFileStat(t,s,c,void 0,!!u,(v,E)=>(l||(l=p.TernarySearchTree.forUris(()=>!r),l.set(s,!0),w.isNonEmptyArray(i)&&i.forEach(f=>l.set(f,!0))),Boolean(l.findSuperstr(v.resource)||l.get(v.resource))?!0:v.isDirectory&&o?E===1:!1))}async toFileStat(s,a,t,r,i,o){const{providerExtUri:u}=this.getExtUri(s),c={resource:a,name:u.basename(a),isFile:(t.type&T.FileType.File)!=0,isDirectory:(t.type&T.FileType.Directory)!=0,isSymbolicLink:(t.type&T.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&T.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:T.etag({mtime:t.mtime,size:t.size})};if(c.isDirectory&&o(c,r)){try{const l=await s.readdir(a),v=await g.Promises.settled(l.map(async([E,f])=>{try{const U=u.joinPath(a,E),F=i?await s.stat(U):{type:f};return await this.toFileStat(s,U,F,l.length,i,o)}catch(U){return this.logService.trace(U),null}}));c.children=w.coalesce(v)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(s){return g.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch(t){return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(t){return t}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new T.FileOperationError(S.localize(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,a);return this._onDidRunOperation.fire(new T.FileOperationEvent(s,0,r)),r}async writeFile(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let u;if(T.hasReadWriteCapability(r)&&!(a instanceof m.VSBuffer))if(d.isReadableStream(a)){const c=await d.peekStream(a,3);c.ended?u=m.VSBuffer.concat(c.buffer):u=c}else u=d.peekReadable(a,c=>m.VSBuffer.concat(c),3);else u=a;!T.hasOpenReadWriteCloseCapability(r)||T.hasReadWriteCapability(r)&&u instanceof m.VSBuffer?await this.doWriteUnbuffered(r,s,t,u):await this.doWriteBuffered(r,s,t,u instanceof m.VSBuffer?m.bufferToReadable(u):u)}catch(o){throw new T.FileOperationError(S.localize(4,null,this.resourceForError(s),T.ensureFileSystemProviderError(o).toString()),T.toFileOperationResult(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error(S.localize(5,null,this.resourceForError(a)));let i;try{i=await s.stat(a)}catch(o){return}if((i.type&T.FileType.Directory)!=0)throw new T.FileOperationError(S.localize(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==T.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==T.etag({mtime:t.mtime,size:i.size}))throw new T.FileOperationError(S.localize(7,null),3,t);return i}async readFile(s,a){const t=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(t,s,a):this.doReadFile(t,s,a)}async doReadFileAtomic(s,a,t){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,a,t);r(o)}catch(o){i(o)}})})}async doReadFile(s,a,t){const r=await this.doReadFileStream(s,a,{...t,preferUnbuffered:!0});return{...r,value:await m.streamToBuffer(r.value)}}async readFileStream(s,a){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,a)}async doReadFileStream(s,a,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(a,t).then(u=>u,u=>{throw r.cancel(),u});let o;try{return t&&typeof t.etag=="string"&&t.etag!==T.ETAG_DISABLED&&await i,!(T.hasOpenReadWriteCloseCapability(s)||T.hasFileReadStreamCapability(s))||T.hasReadWriteCapability(s)&&t?.preferUnbuffered?o=this.readFileUnbuffered(s,a,t):T.hasFileReadStreamCapability(s)?o=this.readFileStreamed(s,a,r.token,t):o=this.readFileBuffered(s,a,r.token,t),{...await i,value:o}}catch(u){o&&await d.consumeStream(o);const c=S.localize(8,null,this.resourceForError(a),T.ensureFileSystemProviderError(u).toString());throw u instanceof T.NotModifiedSinceFileOperationError?new T.NotModifiedSinceFileOperationError(c,u.stat,t):new T.FileOperationError(c,T.toFileOperationResult(u),t)}}readFileStreamed(s,a,t,r=Object.create(null)){const i=s.readFileStream(a,r,t);return d.transform(i,{data:o=>o instanceof m.VSBuffer?o:m.VSBuffer.wrap(o),error:o=>new T.FileOperationError(S.localize(9,null,this.resourceForError(a),T.ensureFileSystemProviderError(o).toString()),T.toFileOperationResult(o),r)},o=>m.VSBuffer.concat(o))}readFileBuffered(s,a,t,r=Object.create(null)){const i=m.newWriteableBufferStream();return I.readFileIntoStream(s,a,i,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new T.FileOperationError(S.localize(10,null,this.resourceForError(a),T.ensureFileSystemProviderError(o).toString()),T.toFileOperationResult(o),r)},t),i}readFileUnbuffered(s,a,t){const r=d.newWriteableStream(i=>m.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(a);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(a,i.byteLength,t),r.end(m.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,a){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new T.FileOperationError(S.localize(11,null,this.resourceForError(s)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==T.ETAG_DISABLED&&a.etag===t.etag)throw new T.NotModifiedSinceFileOperationError(S.localize(12,null),t,a);return this.validateReadFileLimits(s,t.size,a),t}validateReadFileLimits(s,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new T.FileOperationError(S.localize(13,null,this.resourceForError(s)),r)}}async canMove(s,a,t){return this.doCanMoveCopy(s,a,"move",t)}async canCopy(s,a,t){return this.doCanMoveCopy(s,a,"copy",t)}async doCanMoveCopy(s,a,t,r){if(s.toString()!==a.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,s,o,a,t,r)}catch(i){return i}return!0}async move(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,s,i,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,a,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,s,i,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,a,t,r,i,o){if(a.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,a,t,r,i,o);if(u&&!c&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&T.hasFileFolderCopyCapability(s))await s.copy(a,r,{overwrite:o});else{const l=await this.resolve(a);l.isDirectory?await this.doCopyFolder(s,l,t,r):await this.doCopyFile(s,a,t,r)}return i}else return s===t?(await s.rename(a,r,{overwrite:o}),i):(await this.doMoveCopy(s,a,t,r,"copy",o),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,t,r){if(T.hasOpenReadWriteCloseCapability(s)&&T.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(s,a,t,r);if(T.hasOpenReadWriteCloseCapability(s)&&T.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(s,a,t,r);if(T.hasReadWriteCapability(s)&&T.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(s,a,t,r);if(T.hasReadWriteCapability(s)&&T.hasReadWriteCapability(t))return this.doPipeUnbuffered(s,a,t,r)}async doCopyFolder(s,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await g.Promises.settled(a.children.map(async i=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,o):this.doCopyFile(s,i.resource,t,o)}))}async doValidateMoveCopy(s,a,t,r,i,o){let u=!1;if(s===t){const{providerExtUri:l,isPathCaseSensitive:v}=this.getExtUri(s);if(v||(u=l.isEqual(a,r)),u&&i==="copy")throw new Error(S.localize(14,null,this.resourceForError(a),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,a))throw new Error(S.localize(15,null,this.resourceForError(a),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!u){if(!o)throw new T.FileOperationError(S.localize(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(s===t){const{providerExtUri:l}=this.getExtUri(s);if(l.isEqualOrParent(a,r))throw new Error(S.localize(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(s,0,t)),t}async mkdirp(s,a){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(a,r.dirname(a));)try{if(((await s.stat(a)).type&T.FileType.Directory)==0)throw new Error(S.localize(18,null,this.resourceForError(a)));break}catch(i){if(T.toFileSystemProviderErrorCode(i)!==T.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(a)),a=r.dirname(a)}for(let i=t.length-1;i>=0;i--){a=r.joinPath(a,t[i]);try{await s.mkdir(a)}catch(o){if(T.toFileSystemProviderErrorCode(o)!==T.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(t){return t}return!0}async doValidateDelete(s,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error(S.localize(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(u){}if(i)this.throwIfFileIsReadonly(s,i);else throw new T.FileOperationError(S.localize(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(S.localize(21,null,this.resourceForError(s)))}return t}async del(s,a){const t=await this.doValidateDelete(s,a),r=!!a?.useTrash,i=!!a?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new T.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new T.FileChangesEvent(t,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const t=new k.DisposableStore;{let r=!1,i=()=>{r=!0};t.add(k.toDisposable(()=>i())),this.doWatch(s,a).then(o=>{r?k.dispose(o):i=()=>k.dispose(o)},o=>this.logService.error(o))}return a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add(k.toDisposable(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,a){const t=await this.withProvider(s),r=this.toWatchKey(t,s,a),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,k.toDisposable(()=>{i.count--,i.count===0&&(k.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,a,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>k.dispose(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(a,{create:!0,unlock:t?.unlock??!1});try{d.isReadableStream(r)||d.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(o){throw T.ensureFileSystemProviderError(o)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,a,t){let r=0,i;if(d.isReadableBufferedStream(t)){if(t.buffer.length>0){const o=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,a,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(o,u)=>{d.listenStream(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(s,a,c,c.byteLength,r,0)}catch(l){return u(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>u(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,a,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,a,t,r,i,o){let u=0;for(;u<r;)u+=await s.write(a,i+u,t.buffer,o+u,r-u)}async doWriteUnbuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,t,r))}async doWriteUnbufferedQueued(s,a,t,r){let i;r instanceof m.VSBuffer?i=r:d.isReadableStream(r)?i=await m.streamToBuffer(r):d.isReadableBufferedStream(r)?i=await m.bufferedStreamToBuffer(r):i=m.readableToBuffer(r),await s.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,t,r))}async doPipeBufferedQueued(s,a,t,r){let i,o;try{i=await s.open(a,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const u=m.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,v=0;do v=await s.read(i,c,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,o,u,v,c,l),c+=v,l+=v,l===u.byteLength&&(l=0);while(v>0)}catch(u){throw T.ensureFileSystemProviderError(u)}finally{await g.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,t,r))}async doPipeUnbufferedQueued(s,a,t,r){return t.writeFile(r,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,t,r))}async doPipeUnbufferedToBufferedQueued(s,a,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const o=await s.readFile(a);await this.doWriteBuffer(t,i,m.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw T.ensureFileSystemProviderError(o)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,a,t,r){const i=await m.streamToBuffer(this.readFileBuffered(s,a,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new T.FileOperationError(S.localize(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&T.FilePermission.Readonly)throw new T.FileOperationError(S.localize(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};D.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},D=de([Y(0,n.ILogService)],D),e.FileService=D}),define(ee[161],te([0,1,2,10,3,7,18,8,12,41,6,15,119,75,137,139,136,148,47,78,19,25]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends S.Disposable{constructor(i,o){super();this.logService=i,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:u}=await O.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,u),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await O.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(o.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat(p.joinPath(i,c.name))).type:l=this.toType(c),u.push([c.name,l])}catch(l){this.logService.trace(l)}})),u}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let u;return o?.dangling?u=L.FileType.Unknown:i.isFile()?u=L.FileType.File:i.isDirectory()?u=L.FileType.Directory:u=L.FileType.Unknown,o&&(u|=L.FileType.SymbolicLink),u}async readFile(i){try{const o=this.toFilePath(i);return await O.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(i,o,u){const c=D.newWriteableStream(l=>a.VSBuffer.concat(l.map(v=>a.VSBuffer.wrap(v))).buffer);return y.readFileIntoStream(this,i,c,l=>l.buffer,{...o,bufferSize:this.BUFFER_SIZE},u),c}async writeFile(i,o,u){let c;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await O.Promises.exists(l)){if(!u.overwrite)throw L.createFileSystemProviderError(d.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw L.createFileSystemProviderError(d.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,o){try{const u=this.toFilePath(i);if(L.isFileOpenForWriteOptions(o)&&o.unlock)try{const{stat:v}=await O.SymlinkSupport.stat(u);v.mode&128||await O.Promises.chmod(u,v.mode|128)}catch(v){this.logService.trace(v)}let c;if(L.isFileOpenForWriteOptions(o)){if(T.isWindows)try{await O.Promises.truncate(u,0),c="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}c||(c="w")}else c="r";const l=await O.Promises.open(u,c);return this.mapHandleToPos.set(l,0),L.isFileOpenForWriteOptions(o)&&this.writeHandles.set(l,i),l}catch(u){throw L.isFileOpenForWriteOptions(o)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await O.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await O.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}}async read(i,o,u,c,l){const v=this.normalizePos(i,o);let E=null;try{const f=await O.Promises.read(i,u,c,l,v);return typeof f=="number"?E=f:E=f.bytesRead,E}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(i,v,E)}}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,u){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof o=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,c+u):this.mapHandleToPos.delete(i)))}async write(i,o,u,c,l){return n.retry(()=>this.doWrite(i,o,u,c,l),100,3)}async doWrite(i,o,u,c,l){const v=this.normalizePos(i,o);let E=null;try{const f=await O.Promises.write(i,u,c,l,v);return typeof f=="number"?E=f:E=f.bytesWritten,E}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),f)}finally{this.updatePos(i,v,E)}}async mkdir(i){try{await O.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const u=this.toFilePath(i);await this.doDelete(u,o)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,o){o.recursive?await O.Promises.rm(i,O.RimRafMode.MOVE):await O.Promises.unlink(i)}async rename(i,o,u){const c=this.toFilePath(i),l=this.toFilePath(o);if(c!==l)try{await this.validateTargetDeleted(i,o,"move",u.overwrite),await O.Promises.move(c,l)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error(d.localize(2,null,R.basename(c),R.basename(R.dirname(l)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(i,o,u){const c=this.toFilePath(i),l=this.toFilePath(o);if(c!==l)try{await this.validateTargetDeleted(i,o,"copy",u.overwrite),await O.Promises.copy(c,l,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error(d.localize(3,null,R.basename(c),R.basename(R.dirname(l)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(i,o,u,c){const l=this.toFilePath(i),v=this.toFilePath(o);let E=!1;if(!!(this.capabilities&1024)||(E=w.isEqual(l,v,!0)),E&&u==="copy")throw L.createFileSystemProviderError(d.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!E&&await O.Promises.exists(v)){if(!c)throw L.createFileSystemProviderError(d.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(i,o){return o.recursive?this.watchRecursive(i,o.excludes):this.watchNonRecursive(i)}watchRecursive(i,o){const u={path:this.toFilePath(i),excludes:o},c=s.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),S.toDisposable(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(S.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,o;this.options?.watcher?.usePolling?(i=h.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=I.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire(g.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===m.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))}}watchNonRecursive(i){const o=new b.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire(g.toFileChanges(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===m.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return S.combinedDisposable(o,u)}toFilePath(i){return R.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=L.FileSystemProviderErrorCode.NoPermissions;break;default:o=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(i,o)}async toFileSystemProviderWriteError(i,o){let u=this.toFileSystemProviderError(o);if(i&&u.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await O.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(u=L.createFileSystemProviderError(o,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return u}dispose(){super.dispose(),S.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,S.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(ee[27],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=S.createDecorator("productService")}),define(ee[162],te([0,1,8,11,2,18,27,6,15]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends k.Disposable{constructor(m,d,g){super();this.productService=d,this.logService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(m)},30*1e3)).schedule()}async cleanUpCodeCaches(m){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),g=S.dirname(m),h=S.basename(m),C=await T.Promises.readdir(g);await Promise.all(C.map(async I=>{if(I===h)return;const b=S.join(g,I),D=await T.Promises.stat(b);if(D.isDirectory()&&d-D.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${I}.`),T.Promises.rm(b)}))}catch(d){L.onUnexpectedError(d)}}};w=de([Y(1,O.IProductService),Y(2,p.ILogService)],w),e.CodeCacheCleaner=w}),define(ee[163],te([0,1,8,18,27,2,11,15,9,6]),function(G,e,S,L,k,T,O,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends T.Disposable{constructor(d,g,h){super();this.environmentService=d,this.logService=g,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),g=JSON.parse(await L.Promises.readFile(S.join(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let D of Object.keys(g)){const y=g[D];d[`${y.hash}.${D}`]=!0}const h=S.join(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const I=await L.Promises.readdir(h);for(const D of I){if(d[D]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${D}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${D}`),await L.Promises.rm(S.join(h,D))}const b=Date.now();for(const D of Object.keys(d)){const y=S.join(h,D),s=await L.Promises.readdir(y);for(const a of s){if(a==="tcf.json")continue;const t=S.join(y,a),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${S.join(D,a)}`),await L.Promises.rm(t))}}}catch(d){O.onUnexpectedError(d)}}};n=de([Y(0,p.INativeEnvironmentService),Y(1,R.ILogService),Y(2,k.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(ee[31],te([0,1,16,87]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(O,R){L.ok(S.isString(O)),L.ok(S.isObject(R)),L.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,R)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new k}),define(ee[79],te([0,1,31,3]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,w){this.schemasById[k(p)]=w,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new T;S.Registry.add(e.Extensions.JSONContribution,O)}),define(ee[37],te([0,1,109,3,31,16,79]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=k.Registry.as(O.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,D=!0){this.registerConfigurations([b],D)}registerConfigurations(b,D=!0){const y=[];b.forEach(s=>{y.push(...this.validateAndRegisterProperties(s,D,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterConfigurations(b){const D=[],y=s=>{if(s.properties)for(const a in s.properties)D.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a]);s.allOf&&s.allOf.forEach(a=>y(a))};for(const s of b){y(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}p.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(b){const D=[],y=[];for(const s of b)for(const a in s)if(D.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...s[a]};const t={type:"object",default:this.defaultValues[a],description:S.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};y.push(m(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=s[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(y),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(b){const D=[];for(const y of b)for(const s in y)if(D.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const D of b)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,D=!0,y,s=3){s=T.isUndefinedOrNull(b.scope)?s:b.scope;let a=[],t=b.properties;if(t)for(let i in t){if(D&&h(i)){delete t[i];continue}const o=t[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:(o.scope=T.isUndefinedOrNull(o.scope)?s:o.scope,o.restricted=T.isUndefinedOrNull(o.restricted)?!!y?.restrictedConfigurations?.includes(i):o.restricted),t[i].hasOwnProperty("included")&&!t[i].included){this.excludedConfigurationProperties[i]=t[i],delete t[i];continue}else this.configurationProperties[i]=t[i];!t[i].deprecationMessage&&t[i].markdownDeprecationMessage&&(t[i].deprecationMessage=t[i].markdownDeprecationMessage),a.push(i)}let r=b.allOf;if(r)for(let i of r)a.push(...this.validateAndRegisterProperties(i,D,y,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const D=y=>{let s=y.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let a=y.allOf;a&&a.forEach(D)};D(b)}updateSchema(b,D){switch(e.allSettings.properties[b]=D,D.scope){case 1:e.applicationSettings.properties[b]=D;break;case 2:e.machineSettings.properties[b]=D;break;case 6:e.machineOverridableSettings.properties[b]=D;break;case 3:e.windowSettings.properties[b]=D;break;case 4:e.resourceSettings.properties[b]=D;break;case 5:e.resourceSettings.properties[b]=D,this.resourceLanguageSettingsSchema.properties[b]=D;break}}removeFromSchema(b,D){switch(delete e.allSettings.properties[b],D.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const D=`[${b}]`,y={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,y),e.allSettings.properties[D]=y,e.applicationSettings.properties[D]=y,e.machineSettings.properties[D]=y,e.machineOverridableSettings.properties[D]=y,e.windowSettings.properties[D]=y,e.resourceSettings.properties[D]=y}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,D){let y=this.defaultValues[b];T.isUndefined(y)&&(y=D.default),T.isUndefined(y)&&(y=d(D.type)),D.default=y}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=m;function d(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new w;k.Registry.add(e.Extensions.Configuration,g);function h(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?S.localize(5,null,I):g.getConfigurationProperties()[I]!==void 0?S.localize(6,null,I):null:S.localize(4,null)}e.validateProperty=h;function C(){const I=[],b=g.getConfigurationProperties();for(const D of Object.keys(b))I.push([D,b[D].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=C}),define(ee[23],te([0,1,26,16,5,31,4,37]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=O.createDecorator("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=p;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function m(r,i){const o=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],u=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],c=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const F=b(r.contents,U),z=b(i.contents,U);S.equals(F,z)||c.push(U)}}const l=[],v=U=>{const F={};for(const z of U)for(const $ of z.identifiers)F[a($)]=z;return F},E=i?v(i.overrides):{},f=r?v(r.overrides):{};if(Object.keys(E).length)for(const U of o){const F=E[U];F&&l.push([R.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(f).length)for(const U of u){const F=f[U];F&&l.push([R.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(E).length&&Object.keys(f).length)for(const U of c){const F=f[U],z=E[U];if(F&&z){const $=m({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});l.push([R.overrideIdentifierFromKey(U),[...$.added,...$.removed,...$.updated]])}}return{added:o,removed:u,updated:c,overrides:l}}e.compare=m;function d(r,i){const o=[];for(const u of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(u)){const c={};for(const l in r[u])c[l]=r[u][l];o.push({identifiers:[R.overrideIdentifierFromKey(u).trim()],keys:Object.keys(c),contents:g(c,i)})}return o}e.toOverrides=d;function g(r,i){const o=Object.create(null);for(let u in r)h(o,u,r[u],i);return o}e.toValuesTree=g;function h(r,i,o,u){const c=i.split("."),l=c.pop();let v=r;for(let E=0;E<c.length;E++){let f=c[E],U=v[f];switch(typeof U){case"undefined":U=v[f]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(U)}`);return}v=U}if(typeof v=="object"&&v!==null)try{v[l]=o}catch(E){u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(v)}`)}else u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=h;function C(r,i){const o=i.split(".");I(r,o)}e.removeFromValueTree=C;function I(r,i){const o=i.shift();if(i.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const u=r[o];typeof u=="object"&&!Array.isArray(u)&&(I(u,i),Object.keys(u).length===0&&delete r[o])}}function b(r,i,o){function u(v,E){let f=v;for(const U of E){if(typeof f!="object"||f===null)return;f=f[U]}return f}const c=i.split("."),l=u(r,c);return typeof l=="undefined"?o:l}e.getConfigurationValue=b;function D(r,i,o){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(i[u])?D(r[u],i[u],o):o&&(r[u]=i[u]):r[u]=i[u])})}e.merge=D;function y(){const r=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=y;function s(){const r=Object.create(null),i=T.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let o in i){let u=i[o].default;h(r,o,u,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=s;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,i,o){const u=r.inspect(i),c=r.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=t}),define(ee[164],te([0,1,32,38,19,16,26,5,37,23,31,2,3]),function(G,e,S,L,k,T,O,R,p,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?w.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?w.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const o of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[o],c=r[o];c&&(typeof u=="object"&&typeof c=="object"?(u=O.deepClone(u),this.mergeContents(u,c)):u=c),i[o]=u}return new g(i,this.keys,this.overrides)}merge(...t){const r=O.deepClone(this.contents),i=O.deepClone(this.overrides),o=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const c of u.overrides){const[l]=i.filter(v=>k.equals(v.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(O.deepClone(c))}for(const c of u.keys)o.indexOf(c)===-1&&o.push(c)}return new g(r,o,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&T.isObject(t[i])&&T.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=O.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?O.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),w.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&w.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class h extends g{constructor(){const t=w.getDefaultValues(),r=w.getConfigurationKeys(),i=[];for(const o of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(o)&&i.push({identifiers:[p.overrideIdentifierFromKey(o).trim()],keys:Object.keys(t[o]),contents:w.toValuesTree(t[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!T.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:o,overrides:u,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new g(i,o,u),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,o=[],u=[],c=[];function l(E){Array.isArray(o)?o.push(E):i&&(o[i]=E)}let v={onObjectBegin:()=>{let E={};l(E),u.push(o),o=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let E=[];l(E),u.push(o),o=E,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:l,onError:(E,f,U)=>{c.push({error:E,offset:f,length:U})}};if(t)try{S.visit(t,v),r=o[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,i,!0,r);t=o.raw;const u=w.toValuesTree(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),c=Object.keys(t),l=w.toOverrides(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:u,keys:c,overrides:l,restricted:o.restricted}}filter(t,r,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[]};const u={},c=[];for(let l in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const v=this.filter(t[l],r,!1,o);u[l]=v.raw,c.push(...v.restricted)}else{const v=r[l],E=v?typeof v.scope!="undefined"?v.scope:3:void 0;v?.restricted&&c.push(l),(E===void 0||o.scopes===void 0||o.scopes.includes(E))&&(o.skipRestricted&&v?.restricted||(u[l]=t[l]))}return{raw:u,restricted:c}}}e.ConfigurationModelParser=C;class I extends m.Disposable{constructor(t,r,i,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class b{constructor(t,r,i=new g,o=new g,u=new L.ResourceMap,c=new g,l=new L.ResourceMap,v=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=v,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new g,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const o=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),v=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),$=o.getValue(t),V=k.distinct(k.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(t,B)!==void 0);return{defaultValue:l,userValue:v,userLocalValue:E,userRemoteValue:f,workspaceValue:U,workspaceFolderValue:F,memoryValue:z,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:v!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(o=>p.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=p.overrideIdentifierFromKey(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),v=[...l.filter(E=>c.indexOf(E)===-1),...c.filter(E=>l.indexOf(E)===-1),...c.filter(E=>!O.equals(this._defaultConfiguration.override(u).getValue(E),t.override(u).getValue(E)))];return[u,v]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.localUserConfiguration,t),c=[...r,...i,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.remoteUserConfiguration,t);let c=[...r,...i,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.workspaceConfiguration,t);let c=[...r,...i,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:o,updated:u,removed:c,overrides:l}=w.compare(i,r);let v=[...o,...u,...c];return(v.length||!i)&&this.updateFolderConfiguration(t,r),{keys:v,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:o,removed:u,overrides:c}=w.compare(r,void 0);return{keys:[...i,...o,...u],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=i.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:o,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((c,l)=>(c.set(R.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new L.ResourceMap);return new b(r,i,new g,o,u,new g,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function D(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const o of a)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,c])=>{const l=L.getOrSet(r,u,new Set);c.forEach(v=>l.add(v))});const i=[];return r.forEach((o,u)=>i.push([u,[...o.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=D;class y{constructor(t,r,i,o){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(v=>u.add(v))),this.affectedKeys=[...u.values()];const c=new g;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!O.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=w.toValuesTree({[r]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(t=t[o],!t)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=y;class s extends y{constructor(t,r,i,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(ee[165],te([0,1,31,37,2,23,164,3,6,12]),function(G,e,S,L,k,T,O,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends k.Disposable{constructor(d,g){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,g)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,g){const h=typeof d=="string"?d:void 0,C=T.isConfigurationOverrides(d)?d:T.isConfigurationOverrides(g)?g:{};return this.configuration.getValue(h,C,void 0)}updateValue(d,g,h,C){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,g,1)}onDidDefaultConfigurationChange(d){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,d);this.trigger(h,g,6)}trigger(d,g,h){const C=new O.ConfigurationChangeEvent(d,{data:g},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(ee[166],te([0,1,23,15,103]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(R,p){this.configurationService=R,this.logService=p}request(R,p){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),k.request(R,p)}async resolveProxy(R){}};T=de([Y(0,S.IConfigurationService),Y(1,L.ILogService)],T),e.RequestService=T}),define(ee[39],te([0,1,120,4,37,31,25]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function p(h){return h.res.statusCode===204}async function w(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return p(h)?null:(await O.streamToBuffer(h.stream)).toString()}e.asText=w;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const I=(await O.streamToBuffer(h.stream)).toString();try{return JSON.parse(I)}catch(b){throw b.message+=`:
`+I,b}}e.asJson=n;function m(h){g(h)}e.updateProxyConfigurationsScope=m;let d;function g(h){const C=T.Registry.as(k.Extensions.Configuration);d&&C.deregisterConfigurations([d]),d={id:"http",order:15,title:S.localize(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:S.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:S.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:S.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[S.localize(4,null),S.localize(5,null),S.localize(6,null),S.localize(7,null)],default:"override",description:S.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:S.localize(9,null),restricted:!0}}},C.registerConfiguration(d)}g(2)}),define(ee[167],te([0,1,39,29,10,17]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(p,w){this.requestService=p,this.fileService=w}async download(p,w,n=L.CancellationToken.None){if(p.scheme===T.Schemas.file||p.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(p,w);return}const m={type:"GET",url:p.toString()},d=await this.requestService.request(m,n);if(d.res.statusCode===200)await this.fileService.writeFile(w,d.stream);else{const g=await S.asText(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};O=de([Y(0,S.IRequestService),Y(1,k.IFileService)],O),e.DownloadService=O}),define(ee[168],te([0,1,27,10,19,63,39,29,15,12,132,2]),function(G,e,S,L,k,T,O,R,p,w,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends m.Disposable{constructor(h,C,I,b){super();this.fileService=h,this.productService=C,this.requestService=I,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&T.forEach(this.productService.configBasedExtensionTips,({value:D})=>this.allConfigBasedTips.set(D.configPath,D))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[I,b]of this.allConfigBasedTips)try{const D=await this.fileService.readFile(w.joinPath(h,I)),y=new Map;T.forEach(b.recommendations,({key:a,value:t})=>{if(k.isNonEmptyArray(t.remotes))for(const r of t.remotes)y.set(r,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=n.getDomainsOfRemotes(D.value.toString(),[...y.keys()]);for(const a of s){const t=y.get(a);t&&C.push(t)}}catch(D){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},R.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await O.asJson(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([Y(0,L.IFileService),Y(1,S.IProductService),Y(2,O.IRequestService),Y(3,p.ILogService)],d),e.ExtensionTipsService=d}),define(ee[44],te([0,1,30,25]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,O,R){let p=R&&R.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await O.readFile(T.serviceMachineIdResource)).value.toString();p=S.isUUID(n)?n:null}catch(w){p=null}if(!p){p=S.generateUuid();try{await O.writeFile(T.serviceMachineIdResource,L.VSBuffer.fromString(p))}catch(w){}}return R&&R.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=k}),define(ee[21],te([0,1,4,3,2,16,69,6]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=S.createDecorator("storageService");var w;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var m;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(I={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=R.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){k.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,b){b===p?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:b,target:this.getKeyTargets(I)[b]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,b,D){return this.getStorage(b)?.get(I,D)}getBoolean(I,b,D){return this.getStorage(b)?.getBoolean(I,D)}getNumber(I,b,D){return this.getStorage(b)?.getNumber(I,D)}store(I,b,D,y){if(T.isUndefinedOrNull(b)){this.remove(I,D);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,D,y),this.getStorage(D)?.set(I,b)})}remove(I,b){this.withPausedEmitters(()=>{this.updateKeyTarget(I,b,void 0),this.getStorage(b)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,b){const D=[],y=this.getKeyTargets(I);for(const s of Object.keys(y))y[s]===b&&D.push(s);return D}updateKeyTarget(I,b,D){const y=this.getKeyTargets(b);typeof D=="number"?y[I]!==D&&(y[I]=D,this.getStorage(b)?.set(p,JSON.stringify(y))):typeof y[I]=="number"&&(delete y[I],this.getStorage(b)?.set(p,JSON.stringify(y)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const b=this.get(p,I);if(b)try{return JSON.parse(b)}catch(D){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(I,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends d{constructor(){super();this.globalStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=g;async function h(C,I,b,D){const y=u=>{try{return JSON.parse(u)}catch(c){return u}},s=new Map,a=new Map;C.forEach((u,c)=>{s.set(c,u),a.set(c,y(u))});const t=new Map,r=new Map;I.forEach((u,c)=>{t.set(c,u),r.set(c,y(u))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((u,c)=>{i.push({key:c,value:u})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${D})`);let o=[];t.forEach((u,c)=>{o.push({key:c,value:u})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=h}),define(ee[169],te([0,1,3,2,28,33,21,16]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends L.Disposable{constructor(m){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(m)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(m,d){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}async disableExtension(m,d){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){let d=this.getDisabledExtensions();return d.every(g=>!T.areSameExtensions(g,m))?(d.push(m),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(m){let d=this.getDisabledExtensions();for(let g=0;g<d.length;g++){const h=d[g];if(T.areSameExtensions(h,m))return d.splice(g,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(m){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,0)}_setExtensions(m,d){this.storageManger.set(m,d,0)}};p=de([Y(0,O.IStorageService)],p),e.GlobalExtensionEnablementService=p;class w extends L.Disposable{constructor(m){super();this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(m,d){let g;return d===0?(R.isUndefinedOrNull(this.storage[m])&&(this.storage[m]=this._get(m,d)),g=this.storage[m]):g=this._get(m,d),JSON.parse(g)}set(m,d,g){let h=JSON.stringify(d.map(({id:I,uuid:b})=>({id:I,uuid:b})));this._get(m,g)!==h&&(g===0&&(d.length?this.storage[m]=h:delete this.storage[m]),this._set(m,d.length?h:void 0,g))}onDidStorageChange(m){if(m.scope===0&&!R.isUndefinedOrNull(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const g=this.get(m.key,m.scope);delete this.storage[m.key];const h=this.get(m.key,m.scope),C=g.filter(b=>!h.some(D=>T.areSameExtensions(b,D))),I=h.filter(b=>!g.some(D=>T.areSameExtensions(D,b)));(C.length||I.length)&&this._onDidChange.fire([...C,...I])}}_get(m,d){return this.storageService.get(m,d,"[]")}_set(m,d,g){d?this.storageService.store(m,d,g,1):this.storageService.remove(m,g)}}e.StorageManager=w}),define(ee[170],te([0,1,3,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class T extends k{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class O extends k{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=S.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class R extends L.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new O(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ee[171],te([0,1,2,21,69,6,160,170,12]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(m,d,g){super();this.mainProcessService=d,this.environmentService=g,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(m)}createGlobalStorage(){const m=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),d=new k.Storage(m.globalStorage);return this._register(d.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),d}createWorkspaceStorage(m){const d=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),m);if(d.workspaceStorage){const g=new k.Storage(d.workspaceStorage);return this.workspaceStorageDisposable.value=g.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=m?.id,g}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){O.mark("code/willInitStorage");try{await T.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{O.mark("code/didInitStorage")}}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${p.joinPath(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await T.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(m){const d=this.workspaceStorage,g=d?.items??new Map;d&&(await d.close(),d.dispose()),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init();for(const[h,C]of g)this.workspaceStorage.set(h,C)}}e.NativeStorageService=w}),define(ee[172],te([0,1,7,34,30,5]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,n,m,d,g,h,C,I,b,D){const y=Object.create(null);y["common.machineId"]=C,y.sessionID=k.generateUuid()+Date.now(),y.commitHash=g,y.version=h,y["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),y["common.platform"]=S.PlatformToString(S.platform),y["common.nodePlatform"]=L.platform,y["common.nodeArch"]=d,y["common.product"]=D||"desktop";const s=p(I||[]);s&&(y["common.msftInternal"]=s);let a=0;const t=Date.now();Object.defineProperties(y,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),S.isLinuxSnap&&(y["common.snap"]="true");const r=O(m);r&&(y["common.platformDetail"]=r);try{const i=await w.readFile(T.URI.file(b));y["common.source"]=i.value.toString().slice(0,30)}catch(i){}return y}e.resolveCommonProperties=R;function p(w){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const m=n.toLowerCase();return w.some(d=>m===d)}e.verifyMicrosoftInternalDomain=p}),define(ee[24],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=S.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=S.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(ee[173],te([0,1,35,95,71,8,32,98,27,7,5,24,53,17,10,18]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,o=new Map,u=2e4;function c(E,f,U,F){const z=f.substring(E.length+1);return new Promise(async $=>{let V;try{V=await C.Promises.readdir(f,{withFileTypes:!0})}catch(W){$();return}if(F.count>=u){F.count+=V.length,F.maxReached=!0,$();return}let B=V.length;if(B===0){$();return}let _=V;F.count+V.length>u&&(F.maxReached=!0,B=u-F.count,_=V.slice(0,B)),F.count+=V.length;for(const W of _)if(W.isDirectory()){if(U.includes(W.name)||await c(E,T.join(f,W.name),U,F),--B==0){$();return}}else{const K=W.name.lastIndexOf(".");if(K>=0){const j=W.name.substring(K+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test(z)!==!1&&j.filePattern.test(W.name)&&o.set(j.tag,(o.get(j.tag)??0)+1);if(--B==0){$();return}}})}const l={count:0,maxReached:!1};await c(a,a,t,l);const v=await y(a);return{configFiles:b(o),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=I;function b(a){return[...d.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function D(){const a={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=S.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=D;async function y(a){try{const t=new Map,r=T.join(a,".vscode","launch.json"),i=await C.Promises.readFile(r),o=[],u=O.parse(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if(O.getNodeType(u)==="object"&&u.configurations)for(const c of u.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=y;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${S.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([R.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[o,u]=i,c=this.formatProcessList(t,o);return r.forEach(l=>{if(k.isRemoteDiagnosticError(l))c+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const v of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[v];let f=`${E.fileCount} files`;E.maxFilesReached&&(f=`more than ${f}`),u+=`|    Folder (${v}): ${f}`,u+=this.formatWorkspaceStats(E)}}}),{processInfo:c,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:o,os:u,cpus:c}=D(),l={os:u,memory:i,cpus:c,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(l.load=`${S.loadavg().map(v=>Math.round(v)).join(", ")}`),w.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return R.listProcesses(t.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if(k.isRemoteDiagnosticError(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const c of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[c];let v=`${l.fileCount} files`;l.maxFilesReached&&(v=`more than ${v}`),i.push(`Folder (${c}): ${v}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let o=0;const u=(E,f)=>{const U=` ${E}(${f})`;o+U.length>i?(r.push(c),c="|                 ",o=c.length):o+=U.length,c+=U};let c="|      File types:";const l=10;let v=t.fileTypes.length>l?l:t.fileTypes.length;for(let E=0;E<v;E++){const f=t.fileTypes[E];u(f.name,f.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",o=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),r.push(c)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(f=>{E+=f.count>1?` ${f.name}(${f.count})`:` ${f.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const c=n.URI.revive(u);if(c.scheme===g.Schemas.file){const l=c.fsPath;i.push(I(l,["node_modules",".git"]).then(v=>{let E=`${v.fileCount} files`;v.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${T.basename(l)}): ${E}`),r.push(this.formatWorkspaceStats(v))}).catch(v=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${v.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(t,r,i,o,u){const c=u===0;let l;c?l=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(l=`${l} (${r.get(o.pid)})`));const v=process.platform==="win32"?o.mem:S.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(o.children)&&o.children.forEach(E=>this.formatProcessItem(t,r,i,E,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==g.Schemas.file)continue;const o=i.fsPath;try{const u=await I(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};s=de([Y(0,m.ITelemetryService),Y(1,p.IProductService)],s),e.DiagnosticsService=s}),define(ee[174],te([0,1,11,28,33,26,24,39,70,9,29,15,10,5,27,21,44,4,12]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var y;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished"})(y||(y={}));function s(...j){return String(j.reduce((P,A)=>P|A,0))}var a;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:y.None,criteria:[],assetTypes:[]};class u{constructor(P=o){this.state=P}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(P,A=this.state.pageSize){return new u({...this.state,pageNumber:P,pageSize:A})}withFilter(P,...A){const M=[...this.state.criteria,...A.length?A.map(N=>({filterType:P,value:N})):[{filterType:P}]];return new u({...this.state,criteria:M})}withSortBy(P){return new u({...this.state,sortBy:P})}withSortOrder(P){return new u({...this.state,sortOrder:P})}withFlags(...P){return new u({...this.state,flags:P.reduce((A,M)=>A|M,0)})}withAssetTypes(...P){return new u({...this.state,assetTypes:P})}get raw(){const{criteria:P,pageNumber:A,pageSize:M,sortBy:N,sortOrder:x,flags:H,assetTypes:J}=this.state;return{filters:[{criteria:P,pageNumber:A,pageSize:M,sortBy:N,sortOrder:x}],assetTypes:J,flags:H}}get searchText(){const P=this.state.criteria.filter(A=>A.filterType===a.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(P=>String(P.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(j,P){const A=(j||[]).filter(M=>M.statisticName===P)[0];return A?A.value:0}function l(j){const P="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(M=>M.assetType.indexOf(P)===0).reduce((M,N)=>{const x=U(j,N.assetType);return x&&M.push([N.assetType.substring(P.length),x]),M},[])}function v(j){if(j.properties){const P=j.properties.filter(N=>N.key===t.Repository),A=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=P.filter(N=>A.test(N.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return U(j,t.Repository)}function E(j){return{uri:`${j.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${j.fallbackAssetUri}/${t.VSIX}`}}function f(j){const P=U(j,t.Icon);if(P)return P;const A=L.DefaultIconPath;return{uri:A,fallbackUri:A}}function U(j,P){return j.files.filter(M=>M.assetType===P)[0]?{uri:`${j.assetUri}/${P}`,fallbackUri:`${j.fallbackAssetUri}/${P}`}:null}function F(j,P){const A=j.properties?j.properties.filter(N=>N.key===P):[],M=A.length>0&&A[0].value;return M?M.split(",").map(N=>k.adoptToGalleryExtensionId(N)):[]}function z(j){const P=j.properties?j.properties.filter(A=>A.key===r.Engine):[];return P.length>0&&P[0].value||""}function $(j){const P=j.properties?j.properties.filter(M=>M.key===r.LocalizedLanguages):[],A=P.length>0&&P[0].value||"";return A?A.split(","):[]}function V(j){return j.indexOf("preview")!==-1}function B(j){return j.files.some(P=>P.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?D.joinPath(g.URI.parse(j.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function _(j,P,A,M,N){const x={manifest:U(P,t.Manifest),readme:U(P,t.Details),changelog:U(P,t.Changelog),license:U(P,t.License),repository:v(P),download:E(P),icon:f(P),coreTranslations:l(P)};return{identifier:{id:k.getGalleryExtensionId(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:P.version,date:P.lastUpdated,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,description:j.shortDescription||"",installCount:c(j.statistics,"install"),rating:c(j.statistics,"averagerating"),ratingCount:c(j.statistics,"ratingcount"),assetUri:g.URI.parse(P.assetUri),webExtension:!!j.tags?.includes(L.WEB_EXTENSION_TAG),webResource:B(P),assetTypes:P.files.map(({assetType:H})=>H),assets:x,properties:{dependencies:F(P,r.Dependency),extensionPack:F(P,r.ExtensionPack),engine:z(P),localizedLanguages:$(P)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+A,querySource:N},preview:V(j.flags)}}let W=class{constructor(P,A,M,N,x,H,J){this.requestService=P,this.logService=A,this.environmentService=M,this.telemetryService=N,this.fileService=x,this.productService=H;const Q=H.extensionsGallery;this.extensionsGalleryUrl=Q&&Q.serviceUrl,this.extensionsControlUrl=Q&&Q.controlUrl,this.commonHeadersPromise=K(H.version,this.environmentService,this.fileService,J)}api(P=""){return`${this.extensionsGalleryUrl}${P}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(P,A){const M=[];let{total:N,firstPage:x,getPage:H}=await this.query({names:P,pageSize:P.length},A);M.push(...x);for(let J=1;M.length<N&&(x=await H(J,A),x.length);J++)M.push(...x);return M}async getCompatibleExtension(P,A){return this.getCompatibleExtensionByEngine(P,A)}async getCompatibleExtensionByEngine(P,A){const M=L.isIExtensionIdentifier(P)?null:P;if(M&&M.properties.engine&&p.isEngineValid(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:N,uuid:x}=M?M.identifier:P;let H=new u().withFlags(y.IncludeAssetUri,y.IncludeStatistics,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");x?H=H.withFilter(a.ExtensionId,x):H=H.withFilter(a.ExtensionName,N);const{galleryExtensions:J}=await this.queryGallery(H,n.CancellationToken.None),[Q]=J;if(!Q||!Q.versions.length)return null;if(A){const Z=Q.versions.filter(oe=>oe.version===A)[0];if(Z){const oe=_(Q,Z,0,H);if(oe.properties.engine&&p.isEngineValid(oe.properties.engine,this.productService.version,this.productService.date))return oe}return null}const ie=await this.getLastValidExtensionVersion(Q,Q.versions);return ie?_(Q,ie,0,H):null}async query(P,A){const M=n.CancellationToken.isCancellationToken(P)?{}:P,N=n.CancellationToken.isCancellationToken(P)?P:A;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=M.text||"";const H=T.getOrDefault(M,ue=>ue.pageSize,50);let J=new u().withFlags(y.IncludeLatestVersionOnly,y.IncludeAssetUri,y.IncludeStatistics,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,H).withFilter(a.Target,"Microsoft.VisualStudio.Code");x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,Se)=>(J=J.withFilter(a.Category,Se||ge),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ge,Se)=>(J=J.withFilter(a.Tag,Se||ge),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(a.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),J=J.withFilter(a.SearchText,x)),J=J.withSortBy(0)):M.ids?J=J.withFilter(a.ExtensionId,...M.ids):M.names?J=J.withFilter(a.ExtensionName,...M.names):J=J.withSortBy(4),typeof M.sortBy=="number"&&(J=J.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(J=J.withSortOrder(M.sortOrder));const{galleryExtensions:Q,total:ie}=await this.queryGallery(J,N),Z=Q.map((ue,ge)=>_(ue,ue.versions[0],ge,J,M.source)),oe=async(ue,ge)=>{if(ge.isCancellationRequested)throw S.canceled();const Se=J.withPage(ue+1),{galleryExtensions:Ie}=await this.queryGallery(Se,ge);return Ie.map((Pe,Fe)=>_(Pe,Pe.versions[0],Fe,Se,M.source))};return{firstPage:Z,total:ie,pageSize:J.pageSize,getPage:oe}}async queryGallery(P,A){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,y.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,s(y.Unpublished));const M=await this.commonHeadersPromise,N=JSON.stringify(P.raw),x={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(N.length)},H=new Date().getTime();let J,Q,ie=0;try{if(J=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:N,headers:x},A),J.res.statusCode&&J.res.statusCode>=400&&J.res.statusCode<500)return{galleryExtensions:[],total:ie};const Z=await R.asJson(J);if(Z){const oe=Z.results[0],ue=oe.extensions,ge=oe.resultMetadata&&oe.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ie=ge&&ge.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:ue,total:ie}}return{galleryExtensions:[],total:ie}}catch(Z){throw Q=Z,Z}finally{this.telemetryService.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(N.length),duration:new Date().getTime()-H,success:!!J&&R.isSuccess(J),responseBodySize:J?.res.headers["Content-Length"],statusCode:J?String(J.res.statusCode):void 0,errorCode:Q?S.isPromiseCanceledError(Q)?"canceled":S.getErrorMessage(Q).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ie)})}}async reportStatistic(P,A,M,N){if(!this.isEnabled())return;const H={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${P}/extensions/${A}/${M}/stats?statType=${N}`),headers:H},n.CancellationToken.None)}catch(J){}}async download(P,A,M){this.logService.trace("ExtensionGalleryService#download",P.identifier.id);const N=k.getGalleryExtensionTelemetryData(P),x=new Date().getTime(),H=Z=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...N,duration:Z}),J=M===1?"install":M===2?"update":"",Q=J?{uri:`${P.assets.download.uri}&${J}=true`,fallbackUri:`${P.assets.download.fallbackUri}?${J}=true`}:P.assets.download,ie=await this.getAsset(Q);await this.fileService.writeFile(A,ie.stream),H(new Date().getTime()-x)}async getReadme(P,A){if(P.assets.readme){const M=await this.getAsset(P.assets.readme,{},A);return await R.asText(M)||""}return""}async getManifest(P,A){if(P.assets.manifest){const M=await this.getAsset(P.assets.manifest,{},A),N=await R.asText(M);return N?JSON.parse(N):null}return null}async getCoreTranslation(P,A){const M=P.assets.coreTranslations.filter(N=>N[0]===A.toUpperCase())[0];if(M){const N=await this.getAsset(M[1]),x=await R.asText(N);return x?JSON.parse(x):null}return null}async getChangelog(P,A){if(P.assets.changelog){const M=await this.getAsset(P.assets.changelog,{},A);return await R.asText(M)||""}return""}async getAllVersions(P,A){let M=new u().withFlags(y.IncludeVersions,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");P.identifier.uuid?M=M.withFilter(a.ExtensionId,P.identifier.uuid):M=M.withFilter(a.ExtensionName,P.identifier.id);const N=[],{galleryExtensions:x}=await this.queryGallery(M,n.CancellationToken.None);return x.length&&(A?await Promise.all(x[0].versions.map(async H=>{let J;try{J=await this.getEngine(H)}catch(Q){}J&&p.isEngineValid(J,this.productService.version,this.productService.date)&&N.push({version:H.version,date:H.lastUpdated})})):N.push(...x[0].versions.map(H=>({version:H.version,date:H.lastUpdated})))),N}async getAsset(P,A={},M=n.CancellationToken.None){const N=await this.commonHeadersPromise,x={type:"GET"},H={...N,...A.headers||{}};A={...A,...x,headers:H};const J=P.uri,Q=P.fallbackUri,ie={...A,url:J};try{const Z=await this.requestService.request(ie,M);if(Z.res.statusCode===200)return Z;const oe=await R.asText(Z);throw new Error(`Expected 200, got back ${Z.res.statusCode} instead.

${oe}`)}catch(Z){if(S.isPromiseCanceledError(Z))throw Z;const oe=S.getErrorMessage(Z);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:J,message:oe});const ue={...A,url:Q};return this.requestService.request(ue,M)}}async getLastValidExtensionVersion(P,A){const M=this.getLastValidExtensionVersionFromProperties(P,A);return M||this.getLastValidExtensionVersionRecursively(P,A)}getLastValidExtensionVersionFromProperties(P,A){for(const M of A){const N=z(M);if(!N)return null;if(p.isEngineValid(N,this.productService.version,this.productService.date))return M}return null}async getEngine(P){const A=z(P);if(A)return A;const M=U(P,t.Manifest);if(!M)throw new Error("Manifest was not found");const N={"Accept-Encoding":"gzip"},x=await this.getAsset(M,{headers:N}),H=await R.asJson(x);if(H)return H.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(P,A){if(!A.length)return null;const M=A[0],N=await this.getEngine(M);return p.isEngineValid(N,this.productService.version,this.productService.date)?{...M,properties:[...M.properties||[],{key:r.Engine,value:N}]}:this.getLastValidExtensionVersionRecursively(P,A.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const P=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const A=await R.asJson(P),M=new Map;if(A)for(const N of A.malicious){const x=M.get(N)||{id:{id:N},malicious:!0,slow:!1};x.malicious=!0,M.set(N,x)}return[...M.values()]}};W=de([Y(0,R.IRequestService),Y(1,m.ILogService),Y(2,w.IEnvironmentService),Y(3,O.ITelemetryService),Y(4,d.IFileService),Y(5,h.IProductService),Y(6,b.optional(C.IStorageService))],W),e.ExtensionGalleryService=W;async function K(j,P,A,M){const N={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j}`},x=await I.getServiceMachineId(P,A,M);return N["X-Market-User-Id"]=x,N}e.resolveMarketplaceHeaders=K}),define(ee[175],te([0,1,5,8,27,9,34,10,7,19,28,63,39,15,168,6,24,73,111,21,3,58]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(u,c,l,v,E,f,U,F,z,$){super(U,F,z,$);this.environmentService=u,this.telemetryService=c,this.extensionManagementService=l,this.storageService=v,this.nativeHostService=E,this.extensionRecommendationNotificationService=f,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&m.forEach(F.exeBasedExtensionTips,({key:V,value:B})=>{const _=[],W=[],K=[];m.forEach(B.recommendations,({key:j,value:P})=>{P.important?B.important?_.push({extensionId:j,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):W.push({extensionId:j,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):K.push({extensionId:j,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:_}),W.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:W}),K.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:K})}),C.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(u,c){const l=new Map;u.forEach(F=>l.set(F.extensionId.toLowerCase(),F));const{installed:v,uninstalled:E}=this.groupByInstalled([...l.keys()],c);for(const F of v){const z=l.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:L.basename(z.windowsPath)})}for(const F of E){const z=l.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:L.basename(z.windowsPath)})}const f=this.getPromptedExecutableTips(),U=new Map;for(const F of E){const z=l.get(F);if(z&&(!f[z.exeName]||!f[z.exeName].includes(z.extensionId))){let $=U.get(z.exeName);$||($=[],U.set(z.exeName,$)),$.push(z)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const v=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(v(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register(C.disposableTimeout(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),c=Date.now()-u,l=7*24*60*60*1e3;if(c<l){const f=this._register(C.disposableTimeout(()=>{f.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[v,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(f=>{switch(f){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(v),this.addToRecommendedExecutables(E[0].exeName,E);const U=this._register(C.disposableTimeout(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(v),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register(C.disposableTimeout(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const c=u.map(({extensionId:v})=>v.toLowerCase()),l=D.localize(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,c){const l=this.getPromptedExecutableTips();l[u]=c.map(({extensionId:v})=>v.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,c){const l=[],v=[],E=c.reduce((f,U)=>(f.add(U.identifier.id.toLowerCase()),f),new Set);return u.forEach(f=>{E.has(f.toLowerCase())?l.push(f):v.push(f)}),{installed:l,uninstalled:v}}async getValidExecutableBasedExtensionTips(u){const c=[],l=new Map;for(const v of u.keys()){const E=u.get(v);if(!E||!w.isNonEmptyArray(E.recommendations))continue;const f=[];p.isWindows?E.windowsPath&&f.push(E.windowsPath.replace("%USERPROFILE%",O.env.USERPROFILE).replace("%ProgramFiles(x86)%",O.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",O.env.ProgramFiles).replace("%APPDATA%",O.env.APPDATA).replace("%WINDIR%",O.env.WINDIR)):(f.push(L.join("/usr/local/bin",v)),f.push(L.join("/usr/bin",v)),f.push(L.join(this.environmentService.userHome.fsPath,v)));for(const U of f){let F=l.get(U);if(F===void 0&&(F=await this.fileService.exists(S.URI.file(U)),l.set(U,F)),F)for(const{extensionId:z,extensionName:$,isExtensionPack:V}of E.recommendations)c.push({extensionId:z,extensionName:$,isExtensionPack:V,exeName:v,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return c}};i=de([Y(0,T.INativeEnvironmentService),Y(1,I.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,y.IStorageService),Y(4,a.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,R.IFileService),Y(7,k.IProductService),Y(8,d.IRequestService),Y(9,g.ILogService)],i),e.ExtensionTipsService=i}),define(ee[80],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(T){this.appender=T}listen(T,O){throw new Error(`Event not found: ${O}`)}call(T,O,{eventName:R,data:p}){return this.appender.log(R,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class L{constructor(T){this.channel=T}log(T,O){return this.channel.call("log",{eventName:T,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(ee[81],te([0,1,51,121,20,4,23,37,2,26,31]),function(G,e,S,L,k,T,O,R,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp(k.escapeRegExpCharacters(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const b=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(d);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,I=h["common.instanceId"],b=h["common.machineId"],D=h["common.firstSessionDate"],y=h["common.msftInternal"];return{sessionId:C,instanceId:I,machineId:b,firstSessionDate:D,msftInternal:y}}dispose(){this._disposables.dispose()}publicLog(h,C,I){return this.isOptedIn?this._commonProperties.then(b=>{C=w.mixin(C,b),C=w.mixin(C,this._experimentProperties),C=w.cloneAndChange(C,D=>{if(typeof D=="string")return this._cleanupInfo(D,I)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,I){return this.publicLog(h,C,I)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let I=h;if(C){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(h);if(!t)break;b.push([t.index,a.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(I="";;){const a=y.exec(h);if(!a)break;!D.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(I+=h.substring(s,a.index)+"<REDACTED: user-file-path>",s=y.lastIndex)}s<h.length&&(I+=h.substr(s))}for(let b of this._cleanupPatterns)I=I.replace(b,"");return I}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([Y(1,T.optional(O.IConfigurationService))],m),e.TelemetryService=m;const d="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:d,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?L.localize(2,null,S.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(ee[59],te([0,1,23,26,16,6]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(C,I,b){}async publicLogError(C,I,b){}}e.NullEndpointTelemetryService=O;function R(...h){return{log:(C,I)=>h.forEach(b=>b.log(C,I)),flush:()=>T.Promises.settled(h.map(C=>C.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(h,C){return C.onDidChangeConfiguration(I=>{I.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:S.ConfigurationTargetToString(I.source),configurationKeys:d(I.sourceConfig)})})}e.configurationTelemetry=p;function w(h){const C=Object.create(null),I=Object.create(null),b=Object.create(null);m(h,b);for(let D in b){D=D.length>150?D.substr(D.length-149):D;const y=b[D];typeof y=="number"?I[D]=y:typeof y=="boolean"?I[D]=y?1:0:typeof y=="string"?C[D]=y.substring(0,1023):typeof y!="undefined"&&y!==null&&(C[D]=y)}return{properties:C,measurements:I}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function m(h,C,I=0,b){if(!!h)for(let D of Object.getOwnPropertyNames(h)){const y=h[D],s=b?b+D:D;Array.isArray(y)?C[s]=L.safeStringify(y):y instanceof Date?C[s]=y.toISOString():k.isObject(y)?I<2?m(y,C,I+1,s+"."):C[s]=L.safeStringify(y):C[s]=y}}function d(h){if(!h)return[];const C=[];return g(C,"",h),C}function g(h,C,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(b=>g(h,C?`${C}.${b}`:b,I[b])):h.push(C)}}),define(ee[176],te([0,1,2,9,15,59]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends S.Disposable{constructor(p,w){super();this.logger=this._register(p.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(p,w){this.logger.trace(`telemetry/${p}`,T.validateTelemetryData(w))}};O=de([Y(0,k.ILoggerService),Y(1,L.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(ee[177],te([0,1,11,26,59]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(R){const p=await new Promise((n,m)=>{G(["applicationinsights"],n,m)});let w;return p.defaultClient?(w=new p.TelemetryClient(R),w.channel.setUseDiskRetryCaching(!0)):(p.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=p.defaultClient),R.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class O{constructor(p,w,n){this._eventPrefix=p,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(w=>{p(w)},w=>{S.onUnexpectedError(w),console.error(w)})}}log(p,w){!this._aiClient||(w=L.mixin(w,this._defaultData),w=k.validateTelemetryData(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=O}),define(ee[178],te([0,1,49,80,17,81,23,24]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(n,m){this.configurationService=n,this.telemetryService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:m,sessionId:d}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=m,g["common.vscodesessionid"]=d;const h=[n.id,JSON.stringify(g),n.aiKey],I=new S.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new L.TelemetryAppenderClient(I);this.customTelemetryServices.set(n.id,new T.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,m,d){await(await this.getCustomTelemetryService(n)).publicLog(m,d)}async publicLogError(n,m,d){await(await this.getCustomTelemetryService(n)).publicLogError(m,d)}};p=de([Y(0,O.IConfigurationService),Y(1,R.ITelemetryService)],p),e.CustomEndpointTelemetryService=p}),define(ee[82],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.TitleMode="terminal.integrated.titleMode",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var O;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence"})(O=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=S.createDecorator("localTerminalService"),e.IPtyService=S.createDecorator("ptyService");var p;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(g){g.TerminalView="view",g.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(ee[179],te([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=S.createDecorator("localPtyService")}),define(ee[180],te([0,1,35,8,34,18,16,26,7]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let d=0;return m&&m.length===4&&(d=parseInt(m[3])),d}e.getWindowsBuildNumber=w;async function n(m,d,g,h=k.env,C=T.Promises.exists){if(L.isAbsolute(m))return await C(m)?m:void 0;if(d===void 0&&(d=k.cwd()),L.dirname(m)!=="."){const y=L.join(d,m);return await C(y)?y:void 0}const b=R.getCaseInsensitive(h,"PATH");if(g===void 0&&O.isString(b)&&(g=b.split(L.delimiter)),g===void 0||g.length===0){const y=L.join(d,m);return await C(y)?y:void 0}for(let y of g){let s;if(L.isAbsolute(y)?s=L.join(y,m):s=L.join(d,y,m),await C(s))return s;if(p.isWindows){let a=s+".com";if(await C(a)||(a=s+".exe",await C(a)))return a}}const D=L.join(d,m);return await C(D)?D:void 0}e.findExecutable=n}),define(ee[181],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(ee[83],te([0,1,4,2,31,3,181,54]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=S.createDecorator("themeService");var p;(function(I){function b(D){return D&&typeof D=="object"&&typeof D.id=="string"}I.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var n;(function(I){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}I.isThemeIcon=b;const D=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function y(r){const i=D.exec(r);if(!i)return;let[,o]=i;return{id:o}}I.fromString=y;function s(r,i){let o=r.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),i&&(o=`${o}~${i}`),{id:o}}I.modify=s;function a(r,i){return r.id===i.id&&r.color?.id===i.color?.id}I.isEqual=a;function t(r){return{id:r.id}}I.asThemeIcon=t,I.asClassNameArray=R.CSSIcon.asClassNameArray,I.asClassName=R.CSSIcon.asClassName,I.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function m(I){switch(I){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),L.toDisposable(()=>{const D=this.themingParticipants.indexOf(b);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;k.Registry.add(e.Extensions.ThemingContribution,g);function h(I){return g.onColorThemeChange(I)}e.registerThemingParticipant=h;class C extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,D){let y=this.theme.getColor(b);return y&&D&&(y=D(y,this.theme)),y?y.toString():null}}e.Themable=C}),define(ee[182],te([0,1,37,122,31,54,83]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:L.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:L.localize(1,null),type:"boolean"},icon:{description:L.localize(2,null),type:"string",enum:Array.from(T.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(T.iconRegistry.all,b=>`$(${b.id})`)},color:{description:L.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:L.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:L.localize(5,null),type:["string","array"],items:{type:"string"}},...R}},w=L.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=L.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=L.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d={id:"terminal",order:100,title:L.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:L.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:L.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:L.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:L.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:L.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:L.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:L.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:L.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:L.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:L.localize(19,null)}},{type:"string",markdownDescription:L.localize(20,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:L.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:L.localize(22,null),enum:["PowerShell","Git Bash"]},...R}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:L.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:L.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:L.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:L.localize(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:L.localize(27,null),type:"boolean",default:!0}}};function g(){k.Registry.as(S.Extensions.Configuration).registerConfiguration(d),C()}e.registerTerminalPlatformConfiguration=g;let h;function C(b){const D=k.Registry.as(S.Extensions.Configuration);h&&D.deregisterConfigurations([h]);let y,s;if(b){const a=b.profiles.map(t=>({name:t.profileName,description:I(t)}));y=a.map(t=>t.name),s=a.map(t=>t.description)}h={id:"terminal",order:100,title:L.localize(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:L.localize(29,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:b?.os===3?y:void 0,markdownEnumDescriptions:b?.os===3?s:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:L.localize(30,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:b?.os===2?y:void 0,markdownEnumDescriptions:b?.os===2?s:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:L.localize(31,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:b?.os===1?y:void 0,markdownEnumDescriptions:b?.os===1?s:void 0}}},D.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function I(b){let D=`$(${O.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:T.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?D+=`
- args: "${b.args}"`:D+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(D+=`
- overrideName: ${b.overrideName}`),b.color&&(D+=`
- color: ${b.color}`),b.env&&(D+=`
- env: ${JSON.stringify(b.env)}`),D}}),define(ee[183],te([0,1,8,97,180,42,18,54,7,83]),function(G,e,S,L,k,T,O,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function m(t,r,i,o,u,c,l,v){return u=u||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},p.isWindows?d(i,u,c,o.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),v,l):y(u,c,i,t&&typeof t=="object"?{...t}:o.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,l)}e.detectAvailableProfiles=m;async function d(t,r,i,o,u,c,l,v){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let U=!1;k.getWindowsBuildNumber()>=16299&&(U=!0),await C(l);const F=new Map;t&&(F.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${f}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${f}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),s(u,F);const z=await g(F.entries(),c,r,i,v);if(t||!t&&o)try{const $=await b(`${f}\\${U?"wsl":"bash"}.exe`,c);for(const V of $)(!u||!(V.profileName in u))&&z.push(V)}catch($){i?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function g(t,r,i,o,u){const c=[];for(const[l,v]of t){if(v===null)continue;let E,f,U;if("source"in v){const $=n?.get(v.source);if(!$)continue;E=$.paths,f=v.args||$.args,v.icon?U=h(v.icon):$.icon&&(U=$.icon)}else E=Array.isArray(v.path)?v.path:[v.path],f=p.isWindows||Array.isArray(v.args)?v.args:void 0,U=h(v.icon)||void 0;const F=await u?.(E)||E.slice(),z=await a(l,r,F,i,f,v.env,v.overrideName,v.isAutoDetected,o);z?(z.isAutoDetected=v.isAutoDetected,z.icon=U,z.color=v.color,c.push(z)):o?.trace("profile not validated",l,E)}return c}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await I(),icon:w.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function I(){const t=[];for await(const r of L.enumeratePowerShellInstallations())t.push(r.exePath);return t}async function b(t,r){const i=[],o=await new Promise((l,v)=>{T.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,f)=>{if(E)return v("Problem occurred when getting wsl distros");l(f)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),c=o.split(u).filter(l=>l.trim().length>0&&l!=="");for(const l of c){if(l===""||l.startsWith("docker-desktop"))continue;const v=`${l} (WSL)`,E={profileName:v,path:t,args:["-d",`${l}`],isDefault:v===r,icon:D(l)};i.push(E)}return i}function D(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux)}async function y(t,r,i,o,u,c,l){const v=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),f=c||E.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),U=new Map;for(const F of f){let z=S.basename(F),$=U.get(z)||0;$++,$>1&&(z=`${z} (${$})`),U.set(z,$),v.set(z,{path:F,isAutoDetected:!0})}}return s(o,v),await g(v.entries(),u,t,r,l)}function s(t,r){if(!!t)for(const[i,o]of Object.entries(t))o===null||!("path"in o)&&!("source"in o)?r.delete(i):r.set(i,o)}async function a(t,r,i,o,u,c,l,v,E){if(i.length===0)return Promise.resolve(void 0);const f=i.shift();if(f==="")return a(t,r,i,o,u,c,l,v);const U={profileName:t,path:f,args:u,env:c,overrideName:l,isAutoDetected:v,isDefault:t===r};if(S.basename(f)===f){const z=process.env.PATH?process.env.PATH.split(S.delimiter):void 0;return await k.findExecutable(f,void 0,z,void 0,o.existsFile)?U:a(t,r,i,o,u)}return await o.existsFile(S.normalize(f))?U:a(t,r,i,o,u,c,l,v)}}),define(ee[184],te([0,1,2,15,82,49,17,36,3,77,24,183,23,182]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(D){D[D.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let C=0,I=0,b=class extends S.Disposable{constructor(y,s,a,t){super();this._reconnectConstants=y,this._configurationService=s,this._logService=a,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new p.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new p.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new p.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new p.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new p.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new p.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new p.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new p.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new p.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new p.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new p.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new p.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new p.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new p.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,g.registerTerminalPlatformConfiguration(),this._register(S.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const y=new T.Client(O.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(y.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(y.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const a=y.getChannel(k.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const t=R.ProxyChannel.toService(y.getChannel(k.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[y,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(y,s,a,t,r,i,o,u,c,l){const v=setTimeout(()=>this._handleUnresponsiveCreateProcess(),k.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(y,s,a,t,r,i,o,u,c,l);return clearTimeout(v),C=Math.max(C,E),E}updateTitle(y,s,a){return this._proxy.updateTitle(y,s,a)}updateIcon(y,s,a){return this._proxy.updateIcon(y,s,a)}attachToProcess(y){return this._proxy.attachToProcess(y)}detachFromProcess(y){return this._proxy.detachFromProcess(y)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(y){return this._proxy.start(y)}shutdown(y,s){return this._proxy.shutdown(y,s)}input(y,s){return this._proxy.input(y,s)}processBinary(y,s){return this._proxy.processBinary(y,s)}resize(y,s,a){return this._proxy.resize(y,s,a)}acknowledgeDataEvent(y,s){return this._proxy.acknowledgeDataEvent(y,s)}getInitialCwd(y){return this._proxy.getInitialCwd(y)}getCwd(y){return this._proxy.getCwd(y)}getLatency(y){return this._proxy.getLatency(y)}orphanQuestionReply(y){return this._proxy.orphanQuestionReply(y)}getDefaultSystemShell(y){return this._proxy.getDefaultSystemShell(y)}async getProfiles(y,s,a=!1){return m.detectAvailableProfiles(y,s,a,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(y){return this._proxy.getWslPath(y)}setTerminalLayoutInfo(y){return this._proxy.setTerminalLayoutInfo(y)}async getTerminalLayoutInfo(y){return await this._proxy.getTerminalLayoutInfo(y)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(y){return new Promise(s=>{const a=++I;this._pendingResolveVariablesRequests.set(a,s),this._onPtyHostRequestResolveVariables.fire({id:a,originalText:y})})}async acceptPtyHostResolvedVariables(y,s){const a=this._pendingResolveVariablesRequests.get(y);a?(a(s),this._pendingResolveVariablesRequests.delete(y)):this._logService.warn(`Resolved variables received without matching request ${y}`)}};b=de([Y(1,d.IConfigurationService),Y(2,L.ILogService),Y(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(ee[52],te([0,1,40]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(O,R,p,w){const n=S.setProperty(O,R,p,w)[0];return n&&(O=O.substring(0,n.offset)+n.content+O.substring(n.offset+n.length)),O}e.edit=L;function k(O,R,p){let w=p;for(;w>=0;){if(O.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&O.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=k;function T(O,R,p){let w=p;for(;w>=0;)if(O.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&O.charAt(w)===R.charAt(1)))return w;return O.length-1}e.getLineEndOffset=T}),define(ee[185],te([0,1,26,57]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(m,d,g,h,C){const I=[],b=[],D=[];if(!d){const U=m.filter(({identifier:F})=>C.every(z=>z.toLowerCase()!==F.id.toLowerCase()));return{local:{added:I,removed:b,updated:D},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}m=m.map(w),d=d.map(w),g=g?g.map(w):null;const y=new Map,s=U=>{U.uuid&&y.set(U.id.toLowerCase(),U.uuid)};m.forEach(({identifier:U})=>s(U)),d.forEach(({identifier:U})=>s(U)),g&&g.forEach(({identifier:U})=>s(U));const a=U=>{const F=U.identifier.uuid||y.get(U.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${U.identifier.id.toLowerCase()}`},t=(U,F)=>(U.set(a(F),F),U),r=m.reduce(t,new Map),i=d.reduce(t,new Map),o=d.reduce((U,F)=>{const z=a(F);F=S.deepClone(F);const $=r.get(z);return $&&($.installed&&(F.installed=!0),F.version||(F.version=$.version)),t(U,F)},new Map),u=g?g.reduce(t,new Map):null,c=h.reduce(t,new Map),l=C.reduce((U,F)=>{const z=y.get(F.toLowerCase());return U.add(z?`uuid:${z}`:`id:${F.toLowerCase()}`)},new Set),v=T(r,i,l);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const U=T(u,r,l),F=T(u,i,l),z=($,V)=>{const B=r.get($);if(B){const _=i.get($);return{...V?_:B,version:(_.version&&L.gt(_.version,B.version),B.version),state:O(B,_,u?.get($))}}};for(const $ of F.removed.values()){const V=r.get($);V&&b.push(V.identifier)}for(const $ of F.added.values())if(U.added.has($)){if(v.updated.has($)){const V=z($,!0);V&&(D.push(n(V,$)),o.set($,V))}}else{const V=i.get($);V.installed&&I.push(n(V,$))}for(const $ of F.updated.values()){const V=z($,!0);V&&(D.push(n(V,$)),o.set($,V))}for(const $ of U.added.values())F.added.has($)||o.set($,r.get($));for(const $ of U.updated.values())if(!F.removed.has($)&&!F.updated.has($)){const V=z($,!1);V&&(o.get($)?.installed&&(V.installed=!0),o.set($,V))}for(const $ of U.removed.values())!c.has($)&&!F.updated.has($)&&u?.get($)?.installed&&o.delete($)}const E=[],f=T(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(f.added.size>0||f.updated.size>0||f.removed.size>0)&&o.forEach((U,F)=>E.push(n(U,F))),{local:{added:I,removed:b,updated:D},remote:E.length?{added:[...f.added].map(U=>o.get(U)),updated:[...f.updated].map(U=>o.get(U)),removed:[...f.removed].map(U=>i.get(U)),all:E}:null}}e.merge=k;function T(m,d,g,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=m?[...m.keys()].filter(a=>!g.has(a)):[],b=[...d.keys()].filter(a=>!g.has(a)),D=b.filter(a=>I.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),y=I.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),s=new Set;for(const a of I){if(y.has(a))continue;const t=m.get(a),r=d.get(a);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&s.add(a)}return{added:D,removed:y,updated:s}}function O(m,d,g){const h=m.state,C=d.state,I=g?.state;if(!d.version||h&&L.gt(m.version,d.version))return h;if(C&&L.gt(d.version,m.version)||!h)return C;if(!C)return h;const b=S.deepClone(h),D=I?R(I,C):{added:Object.keys(C).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},y=I?R(I,h):{added:Object.keys(h).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...D.added.values(),...D.updated.values()])b[s]=C[s];for(const s of D.removed.values())y.updated.has(s)||delete b[s];return b}function R(m,d){const g=Object.keys(m),h=Object.keys(d),C=h.filter(D=>g.indexOf(D)===-1).reduce((D,y)=>(D.add(y),D),new Set),I=g.filter(D=>h.indexOf(D)===-1).reduce((D,y)=>(D.add(y),D),new Set),b=new Set;for(const D of g){if(I.has(D))continue;const y=m[D],s=d[D];S.equals(y,s)||b.add(D)}return{added:C,removed:I,updated:b}}function p(m={},d={}){const{added:g,removed:h,updated:C}=R(m,d);return g.size===0&&h.size===0&&C.size===0}function w(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function n(m,d){const g={identifier:{id:m.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return m.version&&(g.version=m.version),m.disabled&&(g.disabled=!0),m.installed&&(g.installed=!0),m.state&&(g.state=m.state),g}}),define(ee[84],te([0,1,19,3,2,33,4,27,21]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=O.createDecorator("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends k.Disposable{constructor(d,g){super();this.storageService=d,this.productService=g,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${T.adoptToGalleryExtensionId(d.id)}@${d.version}`}static fromKey(d){const g=w.exec(d);if(g&&g[1])return{id:g[1],version:g[2]}}initialize(){const d=this.storageService.keys(0,1);for(const g of d){const h=Ze.fromKey(g);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const g=Ze.fromKey(d.key);if(g){this.extensionsWithKeysForSync.add(g.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,g){this.storageService.store(Ze.toKey(d),JSON.stringify(g),0,1)}getKeysForSync(d){const g=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(Ze.toKey(d),0),C=h?JSON.parse(h):void 0;return C&&g?S.distinct([...C,...g]):C||g}};n=de([Y(0,p.IStorageService),Y(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(ee[85],te([0,1,19,23,4]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=k.createDecorator("IIgnoredExtensionsManagementService");let T=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,p){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),p&&w.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(R,p){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==R&&n!==`-${R}`),p&&w.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(R){const p=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),n=[],m=[];if(Array.isArray(w))for(const d of w)d.startsWith("-")?m.push(d.substring(1)):n.push(d);return S.distinct([...p,...n].filter(d=>m.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};T=de([Y(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ee[186],te([0,1,26,32,19,143,52]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(s){return L.parse(s)||[]}e.parseKeybindings=R;async function p(s,a,t,r,i){const o=R(s),u=R(a),c=t?R(t):null,l=[...o,...u,...c||[]].map(W=>W.key),v=await i.resolveUserBindings(l);let E=n(o,u,c,v);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const f=d(o),U=d(u),F=c?d(c):null,z=h(f,U,v),$=F?h(F,f,v):{added:[...f.keys()].reduce((W,K)=>(W.add(K),W),new Set),removed:new Set,updated:new Set},V=F?h(F,U,v):{added:[...U.keys()].reduce((W,K)=>(W.add(K),W),new Set),removed:new Set,updated:new Set},B=w(z,$,V);let _=s;for(const W of B.removed.values())B.conflicts.has(W)||(_=D(_,W,r));for(const W of B.added.values()){if(B.conflicts.has(W))continue;const K=U.get(W);if(K.some(j=>j.command!==`-${W}`&&E.conflicts.has(v[j.key]))){B.conflicts.add(W);continue}_=b(_,K,r)}for(const W of B.updated.values()){if(B.conflicts.has(W))continue;const K=U.get(W);if(K.some(j=>j.command!==`-${W}`&&E.conflicts.has(v[j.key]))){B.conflicts.add(W);continue}_=y(_,W,K,r)}return{mergeContent:_,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=p;function w(s,a,t){const r=new Set,i=new Set,o=new Set,u=new Set;for(const c of a.removed.values())t.updated.has(c)&&u.add(c);for(const c of t.removed.values())u.has(c)||(a.updated.has(c)?u.add(c):i.add(c));for(const c of a.added.values())u.has(c)||t.added.has(c)&&s.updated.has(c)&&u.add(c);for(const c of t.added.values())u.has(c)||(a.added.has(c)?s.updated.has(c)&&u.add(c):r.add(c));for(const c of a.updated.values())u.has(c)||t.updated.has(c)&&s.updated.has(c)&&u.add(c);for(const c of t.updated.values())u.has(c)||(a.updated.has(c)?s.updated.has(c)&&u.add(c):o.add(c));return{added:r,removed:i,updated:o,conflicts:u}}function n(s,a,t,r){const i=new Set,o=m(s,r),u=m(a,r),c=t?m(t,r):null,l=g(o,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const v=c?g(c,o):{added:[...o.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=c?g(c,u):{added:[...u.keys()].reduce(($,V)=>($.add(V),$),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:f,removed:U,updated:F,conflicts:z}=w(l,v,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:U,updated:F,conflicts:z}}function m(s,a){const t=new Map;for(const r of s){const i=a[r.key];let o=t.get(i);o||(o=[],t.set(i,o)),o.push(r)}return t}function d(s){const a=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=a.get(r);i||(i=[],a.set(r,i)),i.push(t)}return a}function g(s,a){const t=[...s.keys()],r=[...a.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),o=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),u=new Set;for(const c of t){if(o.has(c))continue;const l=s.get(c).map(E=>({...E,key:c})),v=a.get(c).map(E=>({...E,key:c}));k.equals(l,v,(E,f)=>I(E,f))||u.add(c)}return{added:i,removed:o,updated:u}}function h(s,a,t){const r=[...s.keys()],i=[...a.keys()],o=i.filter(l=>r.indexOf(l)===-1).reduce((l,v)=>(l.add(v),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,v)=>(l.add(v),l),new Set),c=new Set;for(const l of r){if(u.has(l))continue;const v=s.get(l).map(f=>({...f,key:t[f.key]})),E=a.get(l).map(f=>({...f,key:t[f.key]}));C(v,E)||c.add(l)}return{added:o,removed:u,updated:c}}function C(s,a){return!(!k.equals(s.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>I(t,r))||!k.equals(s.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>I(t,r)))}function I(s,a){if(s.command!==a.command||s.key!==a.key)return!1;const t=T.ContextKeyExpr.deserialize(s.when),r=T.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!S.equals(s.args,a.args))}function b(s,a,t){for(const r of a)s=O.edit(s,[-1],r,t);return s}function D(s,a,t){const r=R(s);for(let i=r.length-1;i>=0;i--)(r[i].command===a||r[i].command===`-${a}`)&&(s=O.edit(s,[i],void 0,t));return s}function y(s,a,t,r){const i=R(s),o=i.findIndex(u=>u.command===a||u.command===`-${a}`);for(let u=i.length-1;u>=0;u--)(i[u].command===a||i[u].command===`-${a}`)&&(s=O.edit(s,[u],void 0,r));for(let u=t.length-1;u>=0;u--)s=O.edit(s,[o],t[u],r);return s}}),define(ee[187],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(T,O,R){const p={},w={},n=new Set;if(!O)return{local:{added:p,updated:w,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const m=L(T,O);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:p,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=L(R,T),g=L(R,O),h={},C={},I=new Set,b=new Set;for(const D of d.removed.values())g.updated.has(D)?p[D]=O[D]:I.add(D);for(const D of g.removed.values())b.has(D)||(d.updated.has(D)?b.add(D):n.add(D));for(const D of d.updated.values())b.has(D)||(g.updated.has(D)?m.updated.has(D)&&b.add(D):C[D]=T[D]);for(const D of g.updated.values())b.has(D)||(d.updated.has(D)?m.updated.has(D)&&b.add(D):T[D]!==void 0&&(w[D]=O[D]));for(const D of d.added.values())b.has(D)||(g.added.has(D)?m.updated.has(D)&&b.add(D):h[D]=T[D]);for(const D of g.added.values())b.has(D)||(d.added.has(D)?m.updated.has(D)&&b.add(D):p[D]=O[D]);return{local:{added:p,removed:[...n.values()],updated:w},remote:{added:h,removed:[...I.values()],updated:C},conflicts:[...b.values()]}}e.merge=S;function L(T,O){const R=T?Object.keys(T):[],p=O?Object.keys(O):[],w=p.filter(d=>R.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),n=R.filter(d=>p.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),m=new Set;for(const d of R){if(n.has(d))continue;const g=T[d],h=O[d];g!==h&&m.add(d)}return{added:w,removed:n,updated:m}}function k(T,O){const{added:R,removed:p,updated:w}=L(T,O);return R.size===0&&p.size===0&&w.size===0}e.areSame=k}),define(ee[22],te([0,1,4,28,31,37,127,79,12,19,16]),function(G,e,S,L,k,T,O,R,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function m(){const c=k.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=m;function d(){const c=k.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(f=>!!c[f].ignoreSync),v=Object.keys(c).filter(f=>c[f].scope===2||c[f].scope===6),E=m();return w.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...l,...v,...E])}e.getDefaultIgnoredSettings=d;function g(){const c="vscode://schemas/ignoredSettings",l=k.Registry.as(T.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:O.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:O.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:O.localize(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:O.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:O.localize(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const v=k.Registry.as(R.Extensions.JSONContribution),E=()=>{const f=m(),U=d().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(T.allSettings.properties).filter(V=>U.indexOf(V)===-1),z=U.filter(V=>f.indexOf(V)===-1),$={items:{type:"string",enum:[...F,...z.map(V=>`-${V}`)]}};v.registerSchema(c,$)};return l.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=g;function h(c){return c&&n.isObject(c)&&n.isString(c.id)&&n.isArray(c.scopes)}e.isAuthenticationProvider=h;var C;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function I(c,l,v){return v.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=I,e.IUserDataSyncStoreManagementService=S.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=S.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=S.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=b;var D;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(D=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class y extends Error{constructor(l,v,E,f){super(l);this.code=v,this.resource=E,this.operationId=f,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=y;class s extends y{constructor(l,v,E,f){super(l,E,void 0,f);this.url=v}}e.UserDataSyncStoreError=s;class a extends y{constructor(l,v){super(l,v)}}e.UserDataAutoSyncError=a,function(c){function l(v){if(v instanceof c)return v;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(v.name);if(E&&E[1]){const f=E[2]==="unknown"?void 0:E[2],U=E[3]==="unknown"?void 0:E[3];return new c(v.message,E[1],f,U)}return new c(v.message,D.Unknown)}c.toUserDataSyncError=l}(y=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(c){return`sync.enable.${c}`}e.getEnablementKey=o,e.IUserDataSyncResourceEnablementService=S.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=S.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=S.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=S.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=S.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=S.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(v=>p.isEqualOrParent(c,p.joinPath(l.userDataSyncHome,v,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(ee[45],te([0,1,2,10,25,5,22,9,12,6,3,24,32,123,23,16,20,19,44,21,29]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=a;let t=class extends S.Disposable{constructor(c,l,v,E,f,U,F,z,$,V){super();this.resource=c,this.fileService=l,this.environmentService=v,this.userDataSyncStoreService=f,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=F,this.telemetryService=z,this.logService=$,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=I.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(v.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,O.PREVIEW_DIR_NAME),this.lastSyncResource=O.getLastSyncResourceUri(c,v,this.extUri),this.currentMachineIdPromise=D.getServiceMachineId(v,l,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:v})=>v!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders={...l};const v=await this.doApply(c);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,v){try{if(this.syncHeaders={...v},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const f=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(c,f);return E=await this.performSync(U,f,l),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const v=this.parseSyncData(l);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),f=await this.getLatestRemoteUserData(null,E),U=await this.isRemoteDataFromCurrentMachine(f),F=await this.generateSyncPreview({ref:f.ref,syncData:v},E,U,s.CancellationToken.None),z=[];for(const $ of F){const V=await this.getAcceptResult($,$.remoteResource,void 0,s.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult($,$.previewResource,$.remoteContent,s.CancellationToken.None);z.push([$,{...V,remoteChange:B!==0?B:2}])}await this.applyResult(f,E,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const l=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===l}async getLatestRemoteUserData(c,l){if(l){const v=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===v||v===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,v){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new O.UserDataSyncError(g.localize(0,null,this.resource,this.version,c.syncData.version),O.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(c,l,v)}catch(E){if(E instanceof O.UserDataSyncError)switch(E.code){case O.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,v);case O.UserDataSyncErrorCode.Conflict:case O.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,v)}throw E}}async doSync(c,l,v){try{this.syncPreviewPromise||(this.syncPreviewPromise=w.createCancelablePromise(f=>this.doGenerateSyncResourcePreview(c,l,v,f)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const v=await this.getMergeResult(l,s.CancellationToken.None);await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString(v?.content||""));const E=v&&!v.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,s.CancellationToken.None):void 0;return l.acceptResult=E,l.mergeState=v.hasConflicts?"conflict":E?"accepted":"preview",l.localChange=E?E.localChange:v.localChange,l.remoteChange=E?E.remoteChange:v.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async v=>{const E=await this.getAcceptResult(v,c,l,s.CancellationToken.None);return v.acceptResult=E,v.mergeState="accepted",v.localChange=E.localChange,v.remoteChange=E.remoteChange,v}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const v=await this.getMergeResult(l,s.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,k.VSBuffer.fromString(v.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=v.localChange,l.remoteChange=v.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const E=v.resourcePreviews.findIndex(({localResource:f,remoteResource:U,previewResource:F})=>this.extUri.isEqual(f,c)||this.extUri.isEqual(U,c)||this.extUri.isEqual(F,c));E!==-1&&(this.syncPreviewPromise=w.createCancelablePromise(async f=>{const U=[...v.resourcePreviews];return U[E]=await l(U[E]),{...v,resourcePreviews:U}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:f})=>f==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(v=>[v,v.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:v})=>v==="conflict");b.equals(this._conflicts,l,(v,E)=>this.extUri.isEqual(v.previewResource,E.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:v})=>({created:l,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:v})=>({created:l,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(c){return T.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return T.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:v}=await this.getUserData(l);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:v}=await this.getUserData(l);return v}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const v of l.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,c))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,c))return v.remoteContent;if(this.extUri.isEqual(v.localResource,c))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,v,E){const f=await this.isRemoteDataFromCurrentMachine(c),U=await this.generateSyncPreview(c,l,f,E),F=[];for(const z of U){const $=z.previewResource.with({scheme:O.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)F.push({...z,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=v?await this.getMergeResult(z,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,k.VSBuffer.fromString(V?.content||""));const B=V&&!V.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,E):void 0;F.push({...z,acceptResult:B,mergeState:V?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:V?V.localChange:z.localChange,remoteChange:B?B.remoteChange:V?V.remoteChange:z.remoteChange})}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:F,isLastSyncFromCurrentMachine:f}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&v&&l.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const E=l;if(E.content===null)return{ref:l.ref,syncData:null};const f=JSON.parse(E.content);if(a(f))return{...l,syncData:f,content:void 0}}catch(c){c instanceof L.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:v,...l};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(c){const{ref:l,content:v}=await this.getUserData(c);let E=null;return v!==null&&(E=this.parseSyncData(v)),{ref:l,syncData:E}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}throw new O.UserDataSyncError(g.localize(1,null),O.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(c){if(C.isString(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const v=await this.currentMachineIdPromise,E={version:this.version,machineId:v,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),l,this.syncHeaders),{ref:l,syncData:E}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Y(1,L.IFileService),Y(2,R.IEnvironmentService),Y(3,y.IStorageService),Y(4,O.IUserDataSyncStoreService),Y(5,O.IUserDataSyncBackupStoreService),Y(6,O.IUserDataSyncResourceEnablementService),Y(7,m.ITelemetryService),Y(8,O.IUserDataSyncLogService),Y(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,v,E,f,U,F,z,$,V,B){super(l,v,E,f,U,F,z,$,V,B);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(_=>this.onFileChanges(_)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,v){try{l?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c),v?void 0:l):await this.fileService.createFile(this.file,k.VSBuffer.fromString(c),{overwrite:v})}catch(E){throw E instanceof L.FileOperationError&&E.fileOperationResult===1||E instanceof L.FileOperationError&&E.fileOperationResult===3?new O.UserDataSyncError(E.message,O.UserDataSyncErrorCode.LocalPreconditionFailed):E}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,L.IFileService),Y(3,R.IEnvironmentService),Y(4,y.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,v,E,f,U,F,z,$,V,B,_){super(c,l,v,E,f,U,F,z,$,V,_);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(c){const l=[];return d.parse(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([Y(2,L.IFileService),Y(3,R.IEnvironmentService),Y(4,y.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,O.IUserDataSyncUtilService),Y(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let o=class{constructor(c,l,v,E){this.resource=c,this.environmentService=l,this.logService=v,this.fileService=E,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=O.getLastSyncResourceUri(this.resource,l,p.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(l);if(!v)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:v})}catch(f){this.logService.error(f)}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const v={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(v)))}};o=de([Y(1,R.IEnvironmentService),Y(2,O.IUserDataSyncLogService),Y(3,L.IFileService)],o),e.AbstractInitializer=o}),define(ee[188],te([0,1,22,3,9,28,33,10,23,185,45,24,5,46,40,20,21,85,11,84,6]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,c){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const v=(await c.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of l)u.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),u.version===2&&v.every(f=>!O.areSameExtensions(f.identifier,E.identifier))&&(E.installed=!0)}return l}function t(u,c,l){const v=l.get(O.getExtensionId(u,c),0)||"{}";return JSON.parse(v)}e.getExtensionStorageState=t;function r(u,c,l,v){v.store(O.getExtensionId(u,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(c,l,v,E,f,U,F,z,$,V,B,_,W,K){super("extensions",l,c,v,E,f,_,W,$,B);this.storageService=v,this.extensionManagementService=U,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=V,this.extensionsStorageSyncService=K,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtension,j=>!!j.gallery),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const v=c.syncData?await a(c.syncData,this.extensionManagementService):null,E=l?.skippedExtensions||[],f=l?.syncData?await a(l.syncData,this.extensionManagementService):null,U=await this.extensionManagementService.getInstalled(),F=this.getLocalExtensions(U),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(U);v?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:V}=w.merge(F,v,f,E,z),B={local:$,remote:V,content:this.getPreviewContent(F,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:v?this.format(v):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,v,E){const f=[...l,...v],U=new Set,F=z=>{U.add(z.id.toLowerCase()),z.uuid&&U.add(z.uuid)};f.forEach(({identifier:z})=>F(z)),E.forEach(F);for(const z of c)U.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&U.has(z.identifier.uuid)||f.push(z);return this.format(f)}async getMergeResult(c,l){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,l,v,E){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=w.merge(c.localExtensions,null,null,c.skippedExtensions,v),{local:f,remote:U}=E;return{content:c.localContent,local:f,remote:U,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:U!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),v=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=c.remoteContent?JSON.parse(c.remoteContent):null;if(E!==null){const f=w.merge(c.localExtensions,E,c.localExtensions,[],v),{local:U,remote:F}=f;return{content:c.remoteContent,local:U,remote:F,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,v,E){let{skippedExtensions:f,localExtensions:U}=v[0][0],{local:F,remote:z,localChange:$,remoteChange:V}=v[0][1];if($===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(U)),f=await this.updateLocalExtensions(F.added,F.removed,F.updated,f)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify(z.all);c=await this.updateRemoteUserData(B,E?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(_=>_.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(_=>_.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(_=>_.identifier.id))}.`:""}`)}l?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:f}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${f.length?` Skipped: ${JSON.stringify(f.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const v=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),f=this.getLocalExtensions(v).filter(U=>!E.some(F=>O.areSameExtensions({id:F},U.identifier)));return this.format(f)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const v=this.parseSyncData(l);if(v)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(v))}}return null}format(c){c.sort((E,f)=>!E.identifier.uuid&&f.identifier.uuid?-1:E.identifier.uuid&&!f.identifier.uuid?1:C.compare(E.identifier.id,f.identifier.id));const l=JSON.stringify(c),v=g.format(l,void 0,{});return h.applyEdits(l,v)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(v=>v.installed||v.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,v,E){const f=[],U=[],F=await this.extensionManagementService.getInstalled();if(l.length){const $=F.filter(({identifier:V,isBuiltin:B})=>!B&&l.some(_=>O.areSameExtensions(V,_)));await s.Promises.settled($.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),f.push(V.identifier)}))}(c.length||v.length)&&await s.Promises.settled([...c,...v].map(async $=>{const V=F.find(_=>O.areSameExtensions(_.identifier,$.identifier));if(V&&V.isBuiltin){$.state&&V.manifest.version===$.version&&this.updateExtensionState($.state,V.manifest.publisher,V.manifest.name,V.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),f.push($.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension($.identifier);if($.state&&(V?V.manifest.version===$.version:!!B)){const _=V?V.manifest.publisher:B.publisher,W=V?V.manifest.name:B.name;this.updateExtensionState($.state,_,W,V?.manifest.version)}if(B)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,B.version)),V||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,B.version),f.push(B.identifier))}catch(_){U.push($),this.logService.error(_),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else U.push($)}));const z=[];for(const $ of E)f.some(V=>O.areSameExtensions(V,$.identifier))||z.push($);for(const $ of U)z.some(V=>O.areSameExtensions(V.identifier,$.identifier))||z.push($);return z}updateExtensionState(c,l,v,E){const f=t(l,v,this.storageService),U=E?this.extensionsStorageSyncService.getKeysForSync({id:O.getGalleryExtensionId(l,v),version:E}):void 0;U?U.forEach(F=>{f[F]=c[F]}):Object.keys(c).forEach(F=>f[F]=c[F]),r(l,v,f,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:v,isBuiltin:E,manifest:f})=>{const U={identifier:v,version:f.version};l.some(F=>O.areSameExtensions(F,v))&&(U.disabled=!0),E||(U.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:v.id,version:f.version});if(F){const z=t(f.publisher,f.name,this.storageService);U.state=Object.keys(z).reduce(($,V)=>(F.includes(V)&&($[V]=z[V]),$),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,D.getErrorMessage(F))}return U})}};i.EXTENSIONS_DATA_URI=d.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,k.IEnvironmentService),Y(1,R.IFileService),Y(2,I.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,T.IExtensionManagementService),Y(6,T.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,S.IUserDataSyncLogService),Y(9,T.IExtensionGalleryService),Y(10,p.IConfigurationService),Y(11,S.IUserDataSyncResourceEnablementService),Y(12,m.ITelemetryService),Y(13,y.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let o=class extends n.AbstractInitializer{constructor(c,l,v,E,f){super("extensions",E,f,v);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await a(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const v=[],E=[],f=[];for(const U of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(U.identifier.id))continue;const F=l.find(z=>O.areSameExtensions(z.identifier,U.identifier));F?(v.push(F),U.disabled&&f.push(U.identifier)):U.installed&&(E.push(U.identifier),U.disabled&&f.push(U.identifier))}return{installedExtensions:v,newExtensions:E,disabledExtensions:f,remoteExtensions:c}}};o=de([Y(0,T.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,R.IFileService),Y(3,k.IEnvironmentService),Y(4,S.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(ee[189],te([0,1,26,22]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(R,p,w,n,m){if(!p)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=T(R,p);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const g=w?T(w,p):{added:Object.keys(p).reduce((D,y)=>(D.add(y),D),new Set),removed:new Set,updated:new Set},h=w?T(w,R):{added:Object.keys(R).reduce((D,y)=>(D.add(y),D),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},I=S.deepClone(p),b=!w;for(const D of h.added.values())D!==L.SYNC_SERVICE_URL_TYPE&&b&&g.added.has(D)||(I[D]=R[D]);for(const D of h.updated.values())I[D]=R[D];for(const D of h.removed.values())n.unregistered.includes(D)||delete I[D];for(const D of g.added.values()){const y=p[D];if(n.machine.includes(D)){m.info(`GlobalState: Skipped adding ${D} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(D))continue;const s=R[D];s&&s.value===y.value||D===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(D)||(s?C.updated[D]=y:C.added[D]=y)}for(const D of g.updated.values()){const y=p[D];if(n.machine.includes(D)){m.info(`GlobalState: Skipped updating ${D} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(D)||h.removed.has(D))continue;const s=R[D];s&&s.value===y.value||(C.updated[D]=y)}for(const D of g.removed.values()){if(n.machine.includes(D)){m.trace(`GlobalState: Skipped removing ${D} in local storage because it is declared as machine scoped.`);continue}h.updated.has(D)||h.removed.has(D)||C.removed.push(D)}return{local:C,remote:O(I,p)?null:I}}e.merge=k;function T(R,p){const w=Object.keys(R),n=Object.keys(p),m=n.filter(h=>w.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),d=w.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),g=new Set;for(const h of w){if(d.has(h))continue;const C=R[h],I=p[h];S.equals(C,I)||g.add(h)}return{added:m,removed:d,updated:g}}function O(R,p){const{added:w,removed:n,updated:m}=T(R,p);return w.size===0&&n.size===0&&m.size===0}}),define(ee[190],te([0,1,22,25,3,9,10,52,189,32,45,24,23,5,46,40,21,7,44,30,15]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(l){const v=l.storage?Object.keys(l.storage).sort():[],E={};v.forEach(F=>E[F]=l.storage[F]),l.storage=E;const f=JSON.stringify(l),U=h.format(f,void 0,{});return C.applyEdits(f,U)}const i=1;let o=class ot extends n.AbstractSynchroniser{constructor(v,E,f,U,F,z,$,V,B){super("globalState",v,F,B,E,f,z,$,U,V);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(v.onDidFilesChange,_=>_.contains(this.environmentService.argvResource)),k.Event.filter(B.onDidChangeValue,_=>_.scope===0&&_.target!==void 0?_.target===0:B.keys(0,0).includes(_.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,E,f,U){const F=v.syncData?JSON.parse(v.syncData.content):null;E=E===null&&f?v:E;const z=E&&E.syncData?JSON.parse(E.syncData.content):null,$=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys(z),{local:B,remote:_}=p.merge($.storage,F?F.storage:null,z?z.storage:null,V,this.logService),W={content:null,local:B,remote:_,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:_!==null?2:0};return[{localResource:this.localResource,localContent:r($),localUserData:$,remoteResource:this.remoteResource,remoteContent:F?r(F):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(v,E){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,E,f,U){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(E,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const E=JSON.parse(v.remoteContent),{local:f,remote:U}=p.merge(v.localUserData.storage,E.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:f,remote:U,localChange:Object.keys(f.added).length>0||Object.keys(f.updated).length>0||f.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,E,f,U){let{localUserData:F}=f[0][0],{local:z,remote:$,localChange:V,remoteChange:B}=f[0][1];if(V===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const _=JSON.stringify({storage:$});v=await this.updateRemoteUserData(_,U?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,ot.GLOBAL_STATE_DATA_URI)){const f=await this.getLocalGlobalState();return r(f)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let E=await super.resolveContent(v);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(v)),E){const f=this.parseSyncData(E);if(f)switch(this.extUri.basename(v)){case"globalState.json":return r(JSON.parse(f.content))}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${a}.locale`]?.value!=="en")return!0}catch(v){}return!1}async getLocalGlobalState(){const v={},E=await this.getLocalArgvContent(),f=w.parse(E);for(const U of t)f[U]!==void 0&&(v[`${a}${U}`]={version:1,value:f[U]});for(const U of this.storageService.keys(0,0)){const F=this.storageService.get(U,0);F&&(v[U]={version:1,value:F})}return{storage:v}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(v){}return"{}"}async writeLocalGlobalState({added:v,removed:E,updated:f}){const U={},F={},z=(V,B)=>{for(const _ of V){if(_.startsWith(a)){U[_.substring(a.length)]=B?B[_].value:void 0;continue}if(B){const W=B[_];W.value!==String(this.storageService.get(_,0))&&(F[_]=W.value)}else this.storageService.get(_,0)!==void 0&&(F[_]=void 0)}};if(z(Object.keys(v),v),z(Object.keys(f),f),z(E),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(F))this.storageService.store(V,F[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(v){const E=await this.getLocalArgvContent();let f=E;for(const U of Object.keys(v))f=R.edit(f,[U],v[U],{});E!==f&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(f)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const E=this.storageService.keys(0,0),f=this.storageService.keys(0,1),U=[...E,...f],F=v?.storage?Object.keys(v.storage).filter(z=>!z.startsWith(a)&&!U.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!b.isWeb){const z=[...S.ALL_SYNC_RESOURCES.map($=>S.getEnablementKey($)),S.SYNC_SERVICE_URL_TYPE];F.push(...z),f.push(...z)}return{user:E,machine:f,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=g.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,O.IFileService),Y(1,S.IUserDataSyncStoreService),Y(2,S.IUserDataSyncBackupStoreService),Y(3,S.IUserDataSyncLogService),Y(4,T.IEnvironmentService),Y(5,S.IUserDataSyncResourceEnablementService),Y(6,m.ITelemetryService),Y(7,d.IConfigurationService),Y(8,I.IStorageService)],o),e.GlobalStateSynchroniser=o;let u=class extends n.AbstractInitializer{constructor(v,E,f,U){super("globalState",f,U,E);this.storageService=v}async doInitialize(v){const E=v.syncData?JSON.parse(v.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const f={},U={};for(const F of Object.keys(E.storage))F.startsWith(a)?f[F.substring(a.length)]=E.storage[F].value:this.storageService.get(F,0)===void 0&&(U[F]=E.storage[F].value);if(Object.keys(f).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(f))F=R.edit(F,[z],f[z],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(F))}if(Object.keys(U).length)for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0)}};u=de([Y(0,I.IStorageService),Y(1,O.IFileService),Y(2,T.IEnvironmentService),Y(3,S.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let c=class{constructor(v,E,f,U,F){this.userDataSyncStoreClient=v,this.storageService=E,this.environmentService=f,this.fileService=U,this.logService=F}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const E=S.createSyncHeaders(y.generateUuid());try{return await this.doSync(v,E)}catch(f){if(f instanceof S.UserDataSyncError)switch(f.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,E)}throw f}}async doSync(v,E){const f=await this.userDataSyncStoreClient.read("globalState",null,E),U=this.parseGlobalState(f)||{storage:{}};U.storage[S.SYNC_SERVICE_URL_TYPE]={value:v,version:i};const F=await D.getServiceMachineId(this.environmentService,this.fileService,this.storageService),z={version:i,machineId:F,content:r(U)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),f.ref,E)}parseGlobalState({content:v}){if(!v)return null;const E=JSON.parse(v);if(n.isSyncData(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,I.IStorageService),Y(2,T.IEnvironmentService),Y(3,O.IFileService),Y(4,s.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ee[191],te([0,1,10,22,186,32,124,9,23,7,16,19,45,24,21,25,3]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,a){const t=JSON.parse(s);if(!a)return n.isUndefined(t.all)?null:t.all;switch(w.OS){case 2:return n.isUndefined(t.mac)?null:t.mac;case 3:return n.isUndefined(t.linux)?null:t.linux;case 1:return n.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let D=class extends d.AbstractJsonFileSynchroniser{constructor(a,t,r,i,o,u,c,l,v,E){super(c.keybindingsResource,"keybindings",u,c,l,a,t,o,E,r,v,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(I.Event.filter(i.onDidChangeConfiguration,f=>f.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,i){const o=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let v=null,E=!1,f=!1,U=!1;if(o){let z=c?c.value.toString():"[]";if(z=z||"[]",this.hasErrors(z))throw new L.UserDataSyncError(O.localize(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==z||u!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await k.merge(z,o,u,l,this.userDataSyncUtilService);$.hasChanges&&(v=$.mergeContent,U=$.hasConflicts,E=U||$.mergeContent!==z,f=U||$.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=c.value.toString(),f=!0);const F={content:v,localChange:E?c?2:1:0,remoteChange:f?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,i){const{fileContent:o}=r[0][0];let{content:u,localChange:c,remoteChange:l}=r[0][1];if(c===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new L.UserDataSyncError(O.localize(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(u||"[]",o,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(u||"[]",a.syncData?.content);a=await this.updateRemoteUserData(v,i?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(v){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=T.parse(a.value.toString());if(m.isNonEmptyArray(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,w.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let a=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return a!==void 0||(a=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,a!==void 0)?a:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};D=de([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncBackupStoreService),Y(2,L.IUserDataSyncLogService),Y(3,p.IConfigurationService),Y(4,L.IUserDataSyncResourceEnablementService),Y(5,S.IFileService),Y(6,R.IEnvironmentService),Y(7,h.IStorageService),Y(8,L.IUserDataSyncUtilService),Y(9,g.ITelemetryService)],D),e.KeybindingsSynchroniser=D;let y=class extends d.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=T.parse(a.value.toString());return!m.isNonEmptyArray(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};y=de([Y(0,S.IFileService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],y),e.KeybindingsInitializer=y}),define(ee[192],te([0,1,26,32,40,46,52,22,19]),function(G,e,S,L,k,T,O,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(c,l,v){let E=[];v?E=m(v):E=n(l);const f=[],U=[...R.getDisallowedIgnoredSettings()];if(Array.isArray(E))for(const F of E)F.startsWith("-")?U.push(F.substring(1)):f.push(F);return p.distinct([...c,...f].filter(F=>U.indexOf(F)===-1))}e.getIgnoredSettings=w;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function m(c){const l=L.parse(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function d(c,l,v,E){if(v.length){const f=u(l),U=L.parse(l),F=L.parse(c),z=[];for(const $ of v){const V=U[$],B=F[$];V===void 0?c=O.edit(c,[$],void 0,E):B!==void 0?c=O.edit(c,[$],V,E):z.push(a($,f))}z.sort(($,V)=>$.startOffset-V.startOffset),z.forEach($=>c=b($.setting.key,l,c,E))}return c}e.updateIgnoredSettings=d;function g(c,l,v,E,f,U){const F=d(c,l,E,U),z=v!==F,$=v!==l;if(!z&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!$)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if($&&!z)return{conflictsSettings:[],localContent:d(l,c,E,U),remoteContent:null,hasConflicts:!1};if(v===null&&C(c)){const Z=h(c,l,E)?null:d(l,c,E,U);return{conflictsSettings:[],localContent:Z,remoteContent:null,hasConflicts:!1}}let V=c,B=l;const _=L.parse(c),W=L.parse(l),K=v?L.parse(v):null,j=E.reduce((Z,oe)=>(Z.add(oe),Z),new Set),P=I(_,W,j),A=I(K,_,j),M=I(K,W,j),N=new Map,x=new Set,H=Z=>{x.add(Z);const oe=f.filter(({key:ue})=>ue===Z)[0];oe?(V=O.edit(V,[Z],oe.value,U),B=O.edit(B,[Z],oe.value,U)):N.set(Z,{key:Z,localValue:_[Z],remoteValue:W[Z]})};for(const Z of A.removed.values())M.updated.has(Z)?H(Z):B=O.edit(B,[Z],void 0,U);for(const Z of M.removed.values())x.has(Z)||(A.updated.has(Z)?H(Z):V=O.edit(V,[Z],void 0,U));for(const Z of A.updated.values())x.has(Z)||(M.updated.has(Z)?P.updated.has(Z)&&H(Z):B=O.edit(B,[Z],_[Z],U));for(const Z of M.updated.values())x.has(Z)||(A.updated.has(Z)?P.updated.has(Z)&&H(Z):V=O.edit(V,[Z],W[Z],U));for(const Z of A.added.values())x.has(Z)||(M.added.has(Z)?P.updated.has(Z)&&H(Z):B=b(Z,V,B,U));for(const Z of M.added.values())x.has(Z)||(A.added.has(Z)?P.updated.has(Z)&&H(Z):V=b(Z,B,V,U));const J=N.size>0||!h(V,B,E),Q=J||!h(V,c,[]),ie=J||!h(B,l,[]);return{localContent:Q?V:null,remoteContent:ie?B:null,conflictsSettings:[...N.values()],hasConflicts:J}}e.merge=g;function h(c,l,v){if(c===l)return!0;const E=L.parse(c),f=L.parse(l),U=v.reduce(($,V)=>($.add(V),$),new Set),F=u(c).filter($=>!($.setting&&U.has($.setting.key))),z=u(l).filter($=>!($.setting&&U.has($.setting.key)));if(F.length!==z.length)return!1;for(let $=0;$<F.length;$++){const V=F[$],B=z[$];if(V.setting&&B.setting){if(V.setting.key!==B.setting.key||!S.equals(E[V.setting.key],f[V.setting.key]))return!1}else if(!V.setting&&!B.setting){if(V.value!==B.value)return!1}else return!1}return!0}e.areSame=h;function C(c){return c?u(c).length===0:!0}e.isEmpty=C;function I(c,l,v){const E=c?Object.keys(c).filter($=>!v.has($)):[],f=Object.keys(l).filter($=>!v.has($)),U=f.filter($=>E.indexOf($)===-1).reduce(($,V)=>($.add(V),$),new Set),F=E.filter($=>f.indexOf($)===-1).reduce(($,V)=>($.add(V),$),new Set),z=new Set;if(c)for(const $ of E){if(F.has($))continue;const V=c[$],B=l[$];S.equals(V,B)||z.add($)}return{added:U,removed:F,updated:z}}function b(c,l,v,E){const f=L.parse(l),U=u(l),F=u(v),z=D(c,U,F);return y(v,c,f[c],z,F,E)}e.addSetting=b;function D(c,l,v){const E=l.findIndex(U=>U.setting?.key===c),f=l[E-1];if(f){if(f.setting){const F=a(f.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!0}}else{const F=t(E,l);if(F){const z=a(F.setting.key,v);if(z){const $=r(v.indexOf(z),v),V=i(l,F,l[E]);if($){const B=i(v,z,$),_=o(V,B);return _?{index:v.indexOf(_),insertAfter:!0}:{index:v.indexOf($),insertAfter:!1}}else{const B=i(v,z,v[v.length-1]),_=o(V,B);return _?{index:v.indexOf(_),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const U=l[E+1];if(U)if(U.setting){const F=a(U.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!1}}else{const F=r(E,l);if(F){const z=a(F.setting.key,v);if(z){const $=t(v.indexOf(z),v),V=i(l,l[E],F);if($){const B=i(v,$,z),_=o(V.reverse(),B.reverse());return _?{index:v.indexOf(_),insertAfter:!1}:{index:v.indexOf($),insertAfter:!0}}else{const B=i(v,v[0],z),_=o(V.reverse(),B.reverse());return _?{index:v.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function y(c,l,v,E,f,U){let F;return E.index===-1?F=k.setProperty(c,[l],v,U):F=s(c,l,v,E,f,U).map(z=>k.withFormatting(c,z,U)[0]),k.applyEdits(c,F)}function s(c,l,v,E,f,U){const F=`${JSON.stringify(l)}: ${JSON.stringify(v)}`,z=T.getEOL(U,c),$=f[E.index];if(E.insertAfter){const V=[];if($.setting)V.push({offset:$.endOffset,length:0,content:","+F});else{const B=r(E.index,f),_=t(E.index,f),W=_?.setting?.commaOffset;_&&W===void 0&&V.push({offset:_.endOffset,length:0,content:","});const K=W!==void 0&&W>$.endOffset;V.push({offset:K?W+1:$.endOffset,length:0,content:B?z+F+",":z+F})}return V}else{if($.setting)return[{offset:$.startOffset,length:0,content:F+","}];const V=(f[E.index-1]&&!f[E.index-1].setting?z:"")+F+(r(E.index,f)?",":"")+z;return[{offset:$.startOffset,length:0,content:V}]}}function a(c,l){return l.filter(v=>v.setting?.key===c)[0]}function t(c,l){for(let v=c-1;v>=0;v--)if(l[v].setting)return l[v]}function r(c,l){for(let v=c+1;v<l.length;v++)if(l[v].setting)return l[v]}function i(c,l,v){const E=c.indexOf(l),f=c.indexOf(v);return c.filter((U,F)=>E<F&&F<f)}function o(c,l){if(c.length&&l.length){let v=0;for(;v<l.length&&v<c.length;v++)if(c[v].value!==l[v].value)return l[v-1];return l[v-1]}}function u(c){const l=[];let v=-1,E,f;const U={onObjectBegin:F=>{v++},onObjectProperty:(F,z,$)=>{v===0&&(E=z,f=F)},onObjectEnd:(F,z)=>{v--,v===0&&l.push({startOffset:E,endOffset:F+z,value:c.substring(E,F+z),setting:{key:f,commaOffset:void 0}})},onArrayBegin:(F,z)=>{v++},onArrayEnd:(F,z)=>{v--,v===0&&l.push({startOffset:E,endOffset:F+z,value:c.substring(E,F+z),setting:{key:f,commaOffset:void 0}})},onLiteralValue:(F,z,$)=>{v===0&&l.push({startOffset:E,endOffset:z+$,value:c.substring(E,z+$),setting:{key:f,commaOffset:void 0}})},onSeparator:(F,z,$)=>{if(v===0&&F===","){let V=l.length-1;for(;V>=0&&!l[V].setting;V--);const B=l[V];B&&l.splice(V,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:z}})}},onComment:(F,z)=>{v===0&&l.push({startOffset:F,endOffset:F+z,value:c.substring(F,F+z)})}};return L.visit(c,U),l}}),define(ee[193],te([0,1,10,22,25,125,3,9,23,192,52,45,24,28,21,40]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return I(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let D=class extends m.AbstractJsonFileSynchroniser{constructor(t,r,i,o,u,c,l,v,E,f,U){super(r.settingsResource,"settings",t,r,i,o,u,E,f,c,l,v);this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,o){const u=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const v=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let f=null,U=!1,F=!1,z=!1;if(l){let V=u?u.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=w.merge(V,l.settings,v?v.settings:null,E,[],c);f=B.localContent||B.remoteContent,U=B.localContent!==null,F=B.remoteContent!==null,z=B.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=u.value.toString(),F=!0);const $={content:f,localChange:U?2:0,remoteChange:F?2:0,hasConflicts:z};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?w.updateIgnoredSettings(t.previewResult.content,"{}",o,i):null}}async getAcceptResult(t,r,i,o){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?w.updateIgnoredSettings(t.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?w.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?w.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,o){const{fileContent:u}=i[0][0];let{content:c,localChange:l,remoteChange:v}=i[0][1];if(l===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const E=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t),U=await this.getIgnoredSettings(c);c=w.updateIgnoredSettings(c,f?f.settings:"{}",U,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=n.edit(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!w.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=w.updateIgnoredSettings(r,"{}",o,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return w.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError(T.localize(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let o=i.settings;const u=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=C.setProperty(o,[c],r[c],u);l.length&&(o=C.applyEdits(o,l))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(o))}catch(t){}}};D=de([Y(0,S.IFileService),Y(1,R.IEnvironmentService),Y(2,h.IStorageService),Y(3,L.IUserDataSyncStoreService),Y(4,L.IUserDataSyncBackupStoreService),Y(5,L.IUserDataSyncLogService),Y(6,L.IUserDataSyncUtilService),Y(7,p.IConfigurationService),Y(8,L.IUserDataSyncResourceEnablementService),Y(9,d.ITelemetryService),Y(10,g.IExtensionManagementService)],D),e.SettingsSynchroniser=D;let y=class extends m.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return w.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};y=de([Y(0,S.IFileService),Y(1,R.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],y),e.SettingsInitializer=y;function s(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(ee[194],te([0,1,22,9,10,23,45,24,25,187,21,26,3]),function(G,e,S,L,k,T,O,R,p,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let g=class extends O.AbstractSynchroniser{constructor(I,b,D,y,s,a,t,r,i){super("snippets",b,I,D,y,s,r,i,a,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(d.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,b,D,y){const s=await this.getSnippetsFileContents(),a=this.toSnippetsContents(s),t=I.syncData?this.parseSnippets(I.syncData):null;b=b===null&&D?I:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=w.merge(a,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(I,b){return I.previewResult}async getAcceptResult(I,b,D,y){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return D===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:D,localChange:D===null?I.fileContent!==null?3:0:2,remoteChange:D===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(I,b,D,y){const s=D.map(([a,t])=>({...a,acceptResult:t}));s.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,y)),s.some(({remoteChange:a})=>a!==0)&&(I=await this.updateRemoteSnippets(s,I,y)),b?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of s)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(I,b,D){const y=new Map;for(const s of Object.keys(I.local.added)){const a={content:I.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};y.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.local.updated)){const a={content:I.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.added)){const a={content:I.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(I.remote.updated)){const a={content:I.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of I.conflicts){const a={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:D[s]?2:1};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!y.has(s)){const a={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};y.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...y.values()]}async getAssociatedResources({uri:I}){let b=await super.resolveContent(I);if(b){const D=this.parseSyncData(b);if(D){const y=this.parseSnippets(D),s=[];for(const a of Object.keys(y)){const t=this.extUri.joinPath(I,a),r=this.extUri.joinPath(this.snippetsFolder,a),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let b=await super.resolveContent(I);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(I)),b){const D=this.parseSyncData(b);if(D)return this.parseSnippets(D)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const b={};for(const D of I)D.fileContent&&(b[this.extUri.basename(D.localResource)]=D.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(I,b){for(const{fileContent:D,acceptResult:y,localResource:s,remoteResource:a,localChange:t}of I)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(y.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(y.content),b?void 0:D),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(I,b,D){const y=b.syncData?this.parseSnippets(b.syncData):{},s=m.deepClone(y);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:i}of I)if(i!==0){const o=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[o]:s[o]=a.content}return w.areSame(y,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),D?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const b={};for(const D of Object.keys(I))b[D]=I[D].value.toString();return b}async getSnippetsFileContents(){const I={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(D){if(D instanceof k.FileOperationError&&D.fileOperationResult===1)return I;throw D}for(const D of b.children||[]){const y=D.resource,s=this.extUri.extname(y);if(s===".json"||s===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,y),t=await this.fileService.readFile(y);I[a]=t}}return I}};g=de([Y(0,L.IEnvironmentService),Y(1,k.IFileService),Y(2,n.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncBackupStoreService),Y(5,S.IUserDataSyncLogService),Y(6,T.IConfigurationService),Y(7,S.IUserDataSyncResourceEnablementService),Y(8,R.ITelemetryService)],g),e.SnippetsSynchroniser=g;let h=class extends O.AbstractInitializer{constructor(I,b,D){super("snippets",b,D,I)}async doInitialize(I){const b=I.syncData?JSON.parse(I.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const y of Object.keys(b)){const s=b[y];if(s){const a=this.extUri.joinPath(this.environmentService.snippetsHome,y);await this.fileService.createFile(a,p.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};h=de([Y(0,k.IFileService),Y(1,L.IEnvironmentService),Y(2,S.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(ee[60],te([0,1,4,3,2,22]),function(G,e,S,L,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=S.createDecorator("IUserDataSyncAccountService");let O=class extends k.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};O=de([Y(0,T.IUserDataSyncStoreService)],O),e.UserDataSyncAccountService=O}),define(ee[195],te([0,1,2,22,12,23,10,9,55,25,6]),function(G,e,S,L,k,T,O,R,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends S.Disposable{constructor(g,h,C,I){super();this.environmentService=g,this.fileService=h,this.configurationService=C,this.logService=I,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(g){const h=k.joinPath(this.environmentService.userDataSyncHome,g),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(g,h){if(!h){const C=await this.getAllRefs(g);C.length&&(h=C[C.length-1].ref)}if(h){const C=k.joinPath(this.environmentService.userDataSyncHome,g,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(g,h){const C=k.joinPath(this.environmentService.userDataSyncHome,g),I=k.joinPath(C,`${p.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(g)}catch(b){}}async cleanUpBackup(g){const h=k.joinPath(this.environmentService.userDataSyncHome,g);try{try{if(!await this.fileService.exists(h))return}catch(I){return}const C=await this.fileService.resolve(h);if(C.children){const I=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let D=I.filter(s=>Date.now()-this.getCreationTime(s)>b);const y=I.length-D.length;y<10&&(D=D.slice(10-y)),await n.Promises.settled(D.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};m=de([Y(0,R.IEnvironmentService),Y(1,O.IFileService),Y(2,T.IConfigurationService),Y(3,L.IUserDataSyncLogService)],m),e.UserDataSyncBackupStoreService=m}),define(ee[196],te([0,1,5,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(d){this.service=d}listen(d,g){switch(g){case"onError":return this.service.onError}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(d){this.service=d}listen(d,g){throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class O{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=O;class R{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class p{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class w{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends L.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:S.URI.revive(d.url),type:d.type,defaultUrl:S.URI.revive(d.defaultUrl),insidersUrl:S.URI.revive(d.insidersUrl),stableUrl:S.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(ee[197],te([0,1,15,9]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends S.AbstractLogger{constructor(O,R){super();this.logger=this._register(O.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...R){this.logger.trace(O,...R)}debug(O,...R){this.logger.debug(O,...R)}info(O,...R){this.logger.info(O,...R)}warn(O,...R){this.logger.warn(O,...R)}error(O,...R){this.logger.error(O,...R)}critical(O,...R){this.logger.critical(O,...R)}flush(){this.logger.flush()}};k=de([Y(0,S.ILoggerService),Y(1,L.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ee[61],te([0,1,4,2,44,9,10,21,22,128,27,7,20,3]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=S.createDecorator("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ge extends L.Disposable{constructor(b,D,y,s,a,t){super();this.storageService=y,this.userDataSyncStoreService=s,this.logService=a,this.productService=t,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=k.getServiceMachineId(b,D,y)}async getMachines(b){const D=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===D}))}async addCurrentMachine(b){const D=await this.currentMachineIdPromise,y=await this.readMachinesData(b);y.machines.some(({id:s})=>s===D)||(y.machines.push({id:D,name:this.computeCurrentMachineName(y.machines)}),await this.writeMachinesData(y))}async removeCurrentMachine(b){const D=await this.currentMachineIdPromise,y=await this.readMachinesData(b),s=y.machines.filter(({id:a})=>a!==D);s.length!==y.machines.length&&(y.machines=s,await this.writeMachinesData(y))}async renameMachine(b,D,y){const s=await this.currentMachineIdPromise,a=await this.readMachinesData(y),t=a.machines.find(({id:r})=>r===b);t&&(t.name=D,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===s)&&this.storageService.store(h,D,0,1))}async setEnablement(b,D){const y=await this.readMachinesData(),s=y.machines.find(({id:a})=>a===b);s&&(s.disabled=D?void 0:!0,await this.writeMachinesData(y))}computeCurrentMachineName(b){const D=this.storageService.get(h,0);if(D)return D;const y=`${this.productService.nameLong} (${m.PlatformToString(m.isWeb?0:m.platform)})`,s=new RegExp(`${d.escapeRegExpCharacters(y)}\\s#(\\d+)`);let a=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;a=i>a?i:a}return`${y} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const D=this.parse(this.userData);if(D.version!==Ge.VERSION)throw new Error(w.localize(0,null,this.productService.nameLong));return D}async writeMachinesData(b){const D=JSON.stringify(b),y=await this.userDataSyncStoreService.write(Ge.RESOURCE,D,this.userData?.ref||null);this.userData={ref:y,content:D},this._onDidChange.fire()}async readUserData(b){if(this.userData){const D=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===D)return this.userData;if(D===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(D){this.logService.error(D)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([Y(0,T.IEnvironmentService),Y(1,O.IFileService),Y(2,R.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(ee[86],te([0,1,6,3,2,22,60,24,11,21,9,61,126,55,5,12,7,27]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const D="sync.enable",y="sync.disableMachineEventually",s="sync.sessionId",a="sync.storeUrl",t="sync.productQuality";let r=class extends k.Disposable{constructor(c,l,v){super();this.storageService=c,this.environmentService=l,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(D,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(D,c,0,1)}onDidStorageChange(c){if(c.scope===0&&D===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([Y(0,w.IStorageService),Y(1,n.IEnvironmentService),Y(2,T.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends k.Disposable{constructor(c,l,v,E,f,U,F,z,$,V,B){super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=f,this.logService=U,this.userDataSyncAccountService=F,this.telemetryService=z,this.userDataSyncMachinesService=$,this.storageService=V,this.autoSync=this._register(new k.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=B,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{C.isEqual(this.syncUrl,l.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(f.onDidChangeLocal,(_,W)=>_?[..._,W]:[W],1e3)(_=>this.triggerSync(_,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,_])=>_)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(a,0);return c?h.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(a,c.toString(),0,1):this.storageService.remove(a,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:l}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${g.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,l,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(l)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(D,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const l=T.UserDataSyncError.toUserDataSyncError(c);l instanceof T.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===T.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===T.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===T.UserDataSyncErrorCode.LocalTooManyRequests||l.code===T.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===T.UserDataSyncErrorCode.UpgradeRequired||l.code===T.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===T.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===T.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===T.UserDataSyncErrorCode.ServiceChanged||l.code===T.UserDataSyncErrorCode.DefaultServiceChanged?I.isWeb&&l.code===T.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(y,!0,0,1),await S.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(y,0,!1)}stopDisableMachineEventually(){this.storageService.remove(y,0)}async triggerSync(c,l,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([Y(0,b.IProductService),Y(1,T.IUserDataSyncStoreManagementService),Y(2,T.IUserDataSyncStoreService),Y(3,T.IUserDataSyncResourceEnablementService),Y(4,T.IUserDataSyncService),Y(5,T.IUserDataSyncLogService),Y(6,O.IUserDataSyncAccountService),Y(7,R.ITelemetryService),Y(8,m.IUserDataSyncMachinesService),Y(9,w.IStorageService),Y(10,T.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class o extends k.Disposable{constructor(c,l,v,E,f,U,F,z){super();this.lastSyncUrl=c,this.interval=l,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=E,this.userDataSyncService=f,this.userDataSyncMachinesService=U,this.logService=F,this.storageService=z,this.intervalHandler=this._register(new k.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(k.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=S.disposableTimeout(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(c,l){const v=S.createCancelablePromise(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if(p.isPromiseCanceledError(f))return}return this.doSync(c,l,E)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!C.isEqual(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!c&&(!C.isEqual(l.defaultUrl,c.defaultUrl)||!C.isEqual(l.insidersUrl,c.insidersUrl)||!C.isEqual(l.stableUrl,c.stableUrl))}async doSync(c,l,v){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),v.isCancellationRequested)return;let f=this.syncTask.manifest;if(f===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new T.UserDataAutoSyncError(d.localize(0,null),T.UserDataSyncErrorCode.DefaultServiceChanged):new T.UserDataAutoSyncError(d.localize(1,null),T.UserDataSyncErrorCode.ServiceChanged):new T.UserDataAutoSyncError(d.localize(2,null),T.UserDataSyncErrorCode.TurnedOff);const U=this.storageService.get(s,0);if(U&&f&&U!==f.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new T.UserDataAutoSyncError(d.localize(3,null),T.UserDataSyncErrorCode.DefaultServiceChanged):new T.UserDataAutoSyncError(d.localize(4,null),T.UserDataSyncErrorCode.ServiceChanged):new T.UserDataAutoSyncError(d.localize(5,null),T.UserDataSyncErrorCode.SessionExpired);const F=await this.userDataSyncMachinesService.getMachines(f||void 0);if(v.isCancellationRequested)return;const z=F.find($=>$.isCurrent);if(z?.disabled)throw new T.UserDataAutoSyncError(d.localize(6,null),T.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),f===null&&(f=await this.userDataSyncStoreService.manifest()),f&&f.session!==U&&this.storageService.store(s,f.session,0,1),v.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(f||void 0)}catch(f){this.logService.error(f),E=f}this._onDidFinishSync.fire(E)}register(c){return super._register(c)}}o.INTERVAL_SYNCING="Interval"}),define(ee[198],te([0,1,22,2,3,21,24,7]),function(G,e,S,L,k,T,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends L.Disposable{constructor(n,m){super();this.storageService=n,this.telemetryService=m,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(n){return this.storageService.getBoolean(S.getEnablementKey(n),0,!0)}setResourceEnablement(n,m){if(this.isResourceEnabled(n)!==m){const d=S.getEnablementKey(n);this.telemetryService.publicLog2(d,{enabled:m}),this.storeResourceEnablement(d,m)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,m){this.storageService.store(n,m,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const m=S.ALL_SYNC_RESOURCES.filter(d=>S.getEnablementKey(d)===n.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}}};p=de([Y(0,T.IStorageService),Y(1,O.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(ee[199],te([0,1,22,2,4,3,188,191,190,43,24,19,21,193,12,194,30,6,11]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const y="sync.lastSyncTime";let s=class extends L.Disposable{constructor(i,o,u,c,l,v){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=o,this.instantiationService=u,this.logService=c,this.telemetryService=l,this.storageService=v,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(O.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(T.Event.any(...this.synchronisers.map(E=>T.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(T.Event.any(...this.synchronisers.map(E=>T.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(y,0,void 0),this.onDidChangeLocal=T.Event.any(...this.synchronisers.map(E=>T.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const o=I.generateUuid();let u;try{const E=S.createSyncHeaders(o);i&&(E["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(E)}catch(E){const f=S.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(f,o),f}let c=!1;const l=this;let v;return{manifest:u,run(){if(c)throw new Error("Can run a task only once");return v=b.createCancelablePromise(E=>l.sync(u,o,E)),v.finally(()=>v=void 0)},async stop(){if(v&&v.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=I.generateUuid(),o=S.createSyncHeaders(i);let u;try{u=await this.userDataSyncStoreService.manifest(o)}catch(c){const l=S.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new a(i,u,o,this.synchronisers,this.logService)}async sync(i,o,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=S.createSyncHeaders(o);for(const v of this.synchronisers){if(u.isCancellationRequested)return;try{await v.sync(i,l)}catch(E){if(E instanceof S.UserDataSyncError)switch(E.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(E.message,E.code,v.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const f=S.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(f,o),this.logService.error(E),this.logService.error(`${v.resource}: ${w.toErrorMessage(E)}`),this._syncErrors.push([v.resource,f])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const v=S.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(v,o),v}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(o){this.logService.error(o)}}async replace(i){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(i))return}async accept(i,o,u,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(o,u),c&&await l.apply(!1,S.createSyncHeaders(I.generateUuid()))}async resolveContent(i){for(const o of this.synchronisers){const u=await o.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,o){return this.getSynchroniser(i).getAssociatedResources(o)}getMachineId(i,o){return this.getSynchroniser(i).getMachineId(o)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of i)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(y,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(o){this.logService.error(`${i.resource}: ${w.toErrorMessage(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const o=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();m.equals(this._conflicts,i,([o,u],[c,l])=>o===o&&m.equals(u,l,(v,E)=>h.isEqual(v.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(y,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,o){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof S.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(o=>o.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=de([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,k.IInstantiationService),Y(3,S.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,d.IStorageService)],s),e.UserDataSyncService=s;class a extends L.Disposable{constructor(i,o,u,c,l){super();this.id=i,this.manifest=o,this.syncHeaders=u,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=b.createCancelablePromise(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,o){try{return await this.performAction(i,u=>u.accept(i,o))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,o=>o.merge(i)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(i){try{return await this.performAction(i,o=>o.discard(i))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,o]of this.previews)for(const u of o.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const o of i)await this.discard(o);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(v=>v.resource===o);for(const v of u.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&await c.merge(v.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of o.resourcePreviews)await u.accept(c.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of o.resourcePreviews)await u.accept(c.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(o){D.isPromiseCanceledError(o)||this.logService.error(o)}this.reset()}async performAction(i,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:$,previewResource:V,remoteResource:B})=>h.isEqual(i,$)||h.isEqual(i,V)||h.isEqual(i,B)));if(u===-1)return this.previews;const[c,l]=this.previews[u],v=l.resourcePreviews.find(({localResource:z,remoteResource:$,previewResource:V})=>h.isEqual(z,i)||h.isEqual($,i)||h.isEqual(V,i));if(!v)return this.previews;let E=this.synchronizingResources.find(z=>z[0]===c);E||(E=[c,[]],this.synchronizingResources.push(E)),E[1].some(z=>h.isEqual(z,v.localResource))||(E[1].push(v.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const f=this.synchronisers.find(z=>z.resource===this.previews[u][0]),U=await o(f);U?this.previews.splice(u,1,this.toSyncResourcePreview(f.resource,U)):this.previews.splice(u,1);const F=this.synchronizingResources.findIndex(z=>z[0]===c);return this.synchronizingResources[F][1].splice(E[1].findIndex(z=>h.isEqual(z,v.localResource)),1),E[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(v=>v.resource===o);let l=u;for(const v of u.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&(l=await c.merge(v.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const o=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const c=await u.preview(this.manifest,this.syncHeaders);c&&o.push(this.toSyncResourcePreview(u.resource,c))}return o}toSyncResourcePreview(i,o){return[i,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(ee[200],te([0,1,3,22,5,2,16]),function(G,e,S,L,k,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(m,d){this.service=m,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(m,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(m,d,g){try{return await this._call(m,d,g)}catch(h){throw this.logService.error(h),h}}async _call(m,d,g){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(g[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(g[0],k.URI.revive(g[1]),g[2],g[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(g[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(g[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(g[0]);case"getAssociatedResources":return this.service.getAssociatedResources(g[0],{created:g[1].created,uri:k.URI.revive(g[1].uri)});case"getMachineId":return this.service.getMachineId(g[0],{created:g[1].created,uri:k.URI.revive(g[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),C=g[0],I=this.getManualSyncTask(C);switch(g=g.slice(1),h){case"preview":return I.preview();case"accept":return I.accept(k.URI.revive(g[0]),g[1]);case"merge":return I.merge(k.URI.revive(g[0]));case"discard":return I.discard(k.URI.revive(g[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(m){const d=this.manualSyncTasks.get(this.createKey(m));if(!d)throw new Error(`Manual sync taks not found: ${m}`);return d.manualSyncTask}async createManualSyncTask(){const m=new T.DisposableStore,d=m.add(await this.service.createManualSyncTask());return m.add(d.onSynchronizeResources(g=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:g}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:m}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(m){m.dispose();const d=this.createKey(m.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=R;class p extends T.Disposable{constructor(m){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,g,h){return m.call(d,g,h).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(d,g){return m.listen(d,g)}},this.channel.call("_getInitialData").then(([d,g,h])=>{this.updateStatus(d),this.updateConflicts(g),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([g,h])=>[g,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:m,manifest:d,status:g}=await this.channel.call("createManualSyncTask"),h=this,C=new w(m,d,g,{async call(I,b,D){return h.channel.call(`manualSync/${I}`,[m,...O.isArray(b)?b:[b]],D)},listen(I,b){return S.Event.map(S.Event.filter(h.channel.listen(`manualSync/${I}`,b),D=>!C.isDiposed()&&D.manualSyncTaskId===m),D=>D.data)}});return C}replace(m){return this.channel.call("replace",[m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,d,g,h){return this.channel.call("accept",[m,d,g,h])}resolveContent(m){return this.channel.call("resolveContent",[m])}async getLocalSyncResourceHandles(m){return(await this.channel.call("getLocalSyncResourceHandles",[m])).map(({created:g,uri:h})=>({created:g,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(m){return(await this.channel.call("getRemoteSyncResourceHandles",[m])).map(({created:g,uri:h})=>({created:g,uri:k.URI.revive(h)}))}async getAssociatedResources(m,d){return(await this.channel.call("getAssociatedResources",[m,d])).map(({resource:h,comparableResource:C})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(C)}))}async getMachineId(m,d){return this.channel.call("getMachineId",[m,d])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(([d,g])=>[d,g.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}}e.UserDataSyncChannelClient=p;class w extends T.Disposable{constructor(m,d,g,h){super();this.id=m,this.manifest=d,this._disposed=!1,this._status=g;const C=this;this.channel={async call(I,b,D){try{const y=await h.call(I,b,D);return C.isDiposed()||(C._status=await h.call("_getStatus")),y}catch(y){throw L.UserDataSyncError.toUserDataSyncError(y)}},listen(I,b){return h.listen(I,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const m=await this.channel.call("preview");return this.deserializePreviews(m)}async accept(m,d){const g=await this.channel.call("accept",[m,d]);return this.deserializePreviews(g)}async merge(m){const d=await this.channel.call("merge",[m]);return this.deserializePreviews(d)}async discard(m){const d=await this.channel.call("discard",[m]);return this.deserializePreviews(d)}async discardConflicts(){const m=await this.channel.call("discardConflicts");return this.deserializePreviews(m)}async apply(){const m=await this.channel.call("apply");return this.deserializePreviews(m)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(m){return m.map(([d,g])=>[d,{isLastSyncFromCurrentMachine:g.isLastSyncFromCurrentMachine,resourcePreviews:g.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(ee[201],te([0,1,2,22,39,12,29,23,27,44,9,10,21,30,7,3,6,16,5,11,92]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",o=100,u=1e3*60*5;let c=class extends S.Disposable{constructor(F,z,$){super();this.productService=F,this.configurationService=z,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter($.onDidChangeValue,V=>V.key===L.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(F){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,F,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F,z){F=h.isWeb&&F?.web?{...F,...F.web}:F;const $={...F||{},...z||{}};if($&&b.isString($.url)&&b.isObject($.authenticationProviders)&&Object.keys($.authenticationProviders).every(V=>b.isArray($.authenticationProviders[V].scopes))){const V=$,B=!!V.canSwitch&&!z?.url,_=V.url===V.insidersUrl?"insiders":"stable",W=(B?this.userDataSyncStoreType:void 0)||_,K=z?.url||(W==="insiders"?V.insidersUrl:W==="stable"?V.stableUrl:V.url);return{url:D.URI.parse(K),type:W,defaultType:_,defaultUrl:D.URI.parse(V.url),stableUrl:D.URI.parse(V.stableUrl),insidersUrl:D.URI.parse(V.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(V.authenticationProviders).reduce((j,P)=>(j.push({id:P,scopes:V.authenticationProviders[P].scopes}),j),[])}}}};c=de([Y(0,p.IProductService),Y(1,R.IConfigurationService),Y(2,d.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(F,z,$){super(F,z,$);const V=this.storageService.get(a,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const B=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];B?this.storageService.store(a,JSON.stringify(B),0,1):this.storageService.remove(a,0)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,p.IProductService),Y(1,R.IConfigurationService),Y(2,d.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let v=class extends S.Disposable{constructor(F,z,$,V,B,_,W){super();this.requestService=$,this.logService=V,this.storageService=W,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=w.getServiceMachineId(B,_,W).then(K=>{const j={"X-Client-Name":`${z.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":z.version,"X-Machine-Id":K};return z.commit&&(j["X-Client-Commit"]=z.commit),j}),this.session=new f(o,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(S.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(F,z){this.authToken={token:F,type:z}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?T.joinPath(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(t,0);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){this._donotMakeRequestsUntil?.getTime()!==F?.getTime()&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=I.createCancelablePromise(z=>I.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=T.joinPath(this.userDataSyncStoreUrl,"resource",F),$={},V=await this.request(z.toString(),{type:"GET",headers:$},[],O.CancellationToken.None);return(await k.asJson(V)||[]).map(({url:_,created:W})=>({ref:T.relativePath(z,z.with({path:_})),created:W*1e3}))}async resolveContent(F,z){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=T.joinPath(this.userDataSyncStoreUrl,"resource",F,z).toString(),V={};V["Cache-Control"]="no-cache";const B=await this.request($,{type:"GET",headers:V},[],O.CancellationToken.None);return await k.asText(B)}async delete(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=T.joinPath(this.userDataSyncStoreUrl,"resource",F).toString(),$={};await this.request(z,{type:"DELETE",headers:$},[],O.CancellationToken.None)}async read(F,z,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=T.joinPath(this.userDataSyncStoreUrl,"resource",F,"latest").toString();$={...$},$["Cache-Control"]="no-cache",z&&($["If-None-Match"]=z.ref);const B=await this.request(V,{type:"GET",headers:$},[304],O.CancellationToken.None);if(B.res.statusCode===304)return z;const _=B.res.headers.etag;if(!_)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,B.res.headers[L.HEADER_OPERATION_ID]);const W=await k.asText(B);return{ref:_,content:W}}async write(F,z,$,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=T.joinPath(this.userDataSyncStoreUrl,"resource",F).toString();V={...V},V["Content-Type"]=s.Mimes.text,$&&(V["If-Match"]=$);const _=await this.request(B,{type:"POST",data:z,headers:V},[],O.CancellationToken.None),W=_.res.headers.etag;if(!W)throw new L.UserDataSyncStoreError("Server did not return the ref",B,L.UserDataSyncErrorCode.NoRef,_.res.headers[L.HEADER_OPERATION_ID]);return W}async manifest(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=T.joinPath(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json";const $=await this.request(z,{type:"GET",headers:F},[],O.CancellationToken.None),V=await k.asJson($),B=this.storageService.get(r,0);return B&&V&&B!==V.session&&this.clearSession(),V===null&&B&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=T.joinPath(this.userDataSyncStoreUrl,"resource").toString(),z={"Content-Type":s.Mimes.text};await this.request(F,{type:"DELETE",headers:z},[],O.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(F,z,$,V){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",F,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;z.headers={...z.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(z.headers),this.logService.trace("Sending request to server",{url:F,type:z.type,headers:{...z.headers,authorization:void 0}});let _;try{_=await this.session.request(F,z,V)}catch(P){if(!(P instanceof L.UserDataSyncStoreError)){const A=y.isPromiseCanceledError(P)?L.UserDataSyncErrorCode.RequestCanceled:y.getErrorMessage(P).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;P=new L.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,A,void 0)}throw this.logService.info("Request failed",F),P}const W=_.res.headers[L.HEADER_OPERATION_ID],K={url:F,status:_.res.statusCode,"execution-id":z.headers[L.HEADER_EXECUTION_ID],"operation-id":W},j=k.isSuccess(_)||_.res.statusCode&&$.indexOf(_.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",K):this.logService.info("Request failed",K),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${F}' failed because of Unauthorized (401).`,F,L.UserDataSyncErrorCode.Unauthorized,W);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,L.UserDataSyncErrorCode.Conflict,W);if(_.res.statusCode===410)throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because the requested resource is not longer available (410).`,F,L.UserDataSyncErrorCode.Gone,W);if(_.res.statusCode===412)throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,L.UserDataSyncErrorCode.PreconditionFailed,W);if(_.res.statusCode===413)throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too large payload (413).`,F,L.UserDataSyncErrorCode.TooLarge,W);if(_.res.statusCode===426)throw new L.UserDataSyncStoreError(`${z.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,L.UserDataSyncErrorCode.UpgradeRequired,W);if(_.res.statusCode===429){const P=_.res.headers["retry-after"];throw P?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(P)*1e3)),new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,W)):new L.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,L.UserDataSyncErrorCode.TooManyRequests,W)}if(!j)throw new L.UserDataSyncStoreError("Server returned "+_.res.statusCode,F,L.UserDataSyncErrorCode.Unknown,W);return _}addSessionHeaders(F){let z=this.storageService.get(i,0);z===void 0&&(z=g.generateUuid(),this.storageService.store(i,z,0,1)),F["X-Machine-Session-Id"]=z;const $=this.storageService.get(r,0);$!==void 0&&(F["X-User-Session-Id"]=$)}};v=de([Y(1,p.IProductService),Y(2,k.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,m.IFileService),Y(6,d.IStorageService)],v),e.UserDataSyncStoreClient=v;let E=class extends v{constructor(F,z,$,V,B,_,W){super(F.userDataSyncStore?.url,z,$,V,B,_,W);this._register(F.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(F.userDataSyncStore?.url)))}};E=de([Y(0,L.IUserDataSyncStoreManagementService),Y(1,p.IProductService),Y(2,k.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,m.IFileService),Y(6,d.IStorageService)],E),e.UserDataSyncStoreService=E;class f{constructor(F,z,$,V){this.limit=F,this.interval=z,this.requestService=$,this.logService=V,this.requests=[],this.startTime=void 0}request(F,z,$){if(this.isExpired()&&this.reset(),z.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(z,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=f}),define(ee[202],te([0,1,22,3,58,86,60,24,21,61,27]),function(G,e,S,L,k,T,O,R,p,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends T.UserDataAutoSyncService{constructor(g,h,C,I,b,D,y,s,a,t,r,i){super(g,h,C,I,b,y,s,a,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(D.onDidFocusWindow,()=>"windowFocus"),L.Event.map(D.onDidOpenWindow,()=>"windowOpen")),(o,u)=>o?[...o,u]:[u],1e3)(o=>this.triggerSync(o,!0,!1)))}};m=de([Y(0,n.IProductService),Y(1,S.IUserDataSyncStoreManagementService),Y(2,S.IUserDataSyncStoreService),Y(3,S.IUserDataSyncResourceEnablementService),Y(4,S.IUserDataSyncService),Y(5,k.INativeHostService),Y(6,S.IUserDataSyncLogService),Y(7,O.IUserDataSyncAccountService),Y(8,R.ITelemetryService),Y(9,w.IUserDataSyncMachinesService),Y(10,p.IStorageService),Y(11,S.IUserDataAutoSyncEnablementService)],m),e.UserDataAutoSyncService=m}),define(ee[203],te([0,1,3,2,6]),function(G,e,S,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:p,getActiveWindowId:w}){super();this.disposables=this._register(new L.DisposableStore),S.Event.latch(S.Event.any(R,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=k.createCancelablePromise(()=>w()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ee[62],te([0,1,108,8,48,6,18,210,211,16]),function(G,e,S,L,k,T,O,R,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function m(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function d(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function g(a,t,r,i,o,u){const c=L.dirname(t),l=L.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const v=L.join(i,t);let E;return u.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(O.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((f,U)=>{if(!u.isCancellationRequested)try{E=k.createWriteStream(v,{mode:r}),E.once("close",()=>f()),E.once("error",U),a.once("error",U),a.pipe(E)}catch(F){U(F)}}))}function h(a,t,r,i){let o=T.createCancelablePromise(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{o.cancel(),a.close()}),new Promise((c,l)=>{const v=new T.Sequencer,E=f=>{f.isCancellationRequested||(u++,a.readEntry())};a.once("error",l),a.once("close",()=>o.then(()=>{i.isCancellationRequested||a.entryCount===u?c():l(new n("Incomplete",new Error(S.localize(1,null,u,a.entryCount))))},l)),a.readEntry(),a.on("entry",f=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(f.fileName)){E(i);return}const U=f.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const $=L.join(t,U);o=T.createCancelablePromise(V=>O.Promises.mkdir($,{recursive:!0}).then(()=>E(V)).then(void 0,l));return}const F=I(a,f),z=m(f);o=T.createCancelablePromise($=>v.queue(()=>F.then(V=>g(V,U,z,t,r,$).then(()=>E($)))).then(null,l))})})}function C(a,t=!1){return new Promise((r,i)=>{R.open(a,t?{lazyEntries:!0}:void 0,(o,u)=>{o?i(d(o)):r(w.assertIsDefined(u))})})}function I(a,t){return new Promise((r,i)=>{a.openReadStream(t,(o,u)=>{o?i(d(o)):r(w.assertIsDefined(u))})})}function b(a,t){return new Promise((r,i)=>{const o=new p.ZipFile;t.forEach(c=>{c.contents?o.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&o.addFile(c.localPath,c.path)}),o.end();const u=k.createWriteStream(a);o.outputStream.pipe(u),o.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(a))})}e.zip=b;function D(a,t,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(a,!0);return r.overwrite&&(u=u.then(c=>O.Promises.rm(t).then(()=>c))),u.then(c=>h(c,t,{sourcePathRegex:o},i))}e.extract=D;function y(a,t){return C(a).then(r=>new Promise((i,o)=>{r.on("entry",u=>{u.fileName===t&&I(r,u).then(c=>i(c),c=>o(c))}),r.once("close",()=>o(new Error(S.localize(2,null,t))))}))}function s(a,t){return y(a,t).then(r=>new Promise((i,o)=>{const u=[];r.once("error",o),r.on("data",c=>u.push(c)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=s}),define(ee[204],te([0,1,62,113]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return S.buffer(T,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(R){throw new Error(L.localize(0,null))}})}e.getManifest=k}),define(ee[205],te([0,1,57,2,18,8,15,28,33,6,5,9,134,114,27,62,7,19,17,10,12,30,11]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",o="extracting",u="deleting",c="renaming";let l=class extends L.Disposable{constructor(E,f,U,F,z){super();this.beforeRemovingExtension=E,this.fileService=f,this.logService=U,this.environmentService=F,this.productService=z,this._devSystemExtensionsPath=null,this.systemExtensionsPath=F.builtinExtensionsPath,this.extensionsPath=F.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const f=[];(E===null||E===0)&&f.push(this.scanSystemExtensions().then(null,U=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(U).message,r)))),(E===null||E===1)&&f.push(this.scanUserExtensions(!0).then(null,U=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(U).message,i))));try{const U=await Promise.all(f);return b.flatten(U)}catch(U){throw this.joinErrors(U)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[f,U]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return U=U.filter(F=>!f[new p.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]),E&&(U=p.groupByExtension(U,z=>z.identifier).map(z=>z.sort(($,V)=>S.rcompare($.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",U.length),U}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,f,U){const F=E.key(),z=T.join(this.extensionsPath,`.${a.generateUuid()}`),$=T.join(this.extensionsPath,F);try{await k.Promises.rm($)}catch(B){try{await k.Promises.rm($)}catch(_){}throw new R.ExtensionManagementError(g.localize(0,null,$,E.id),u)}await this.extractAtLocation(E,f,z,U);let V=await this.scanExtension(n.URI.file(z),1);if(!V)throw new Error(g.localize(1,null,z));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(E,z,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(B){try{await k.Promises.rm(z)}catch(_){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(B)}. Deleted from extracted location`,z),B}try{V=await this.scanExtension(n.URI.file($),1)}catch(B){}if(V)return V;throw new Error(g.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,f){return this.setMetadata(E,f),await this.storeMetadata(E,{...f,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,f){f.isMachineScoped=f.isMachineScoped||void 0,f.isBuiltin=f.isBuiltin||void 0,f.installedTimestamp=f.installedTimestamp||void 0;const U=T.join(E.location.fsPath,"package.json"),F=await k.Promises.readFile(U,"utf8"),{manifest:z}=await this.parseManifest(F);return z.__metadata=f,await k.Promises.writeFile(U,JSON.stringify(z,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const f=E.map(U=>new p.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version));await this.withUninstalledExtensions(U=>{f.forEach(F=>U[F.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(F=>delete F[E.key()]);const U=(await this.scanExtensions(1)).find(F=>new p.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(E))||null;return U?(await this.storeMetadata(U,{installedTimestamp:Date.now()}),this.scanExtension(U.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let f;try{f=await k.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let U={};if(f)try{U=JSON.parse(f)}catch(F){}return E&&(E(U),Object.keys(U).length?await k.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await k.Promises.rm(this.uninstalledPath)),U})}async removeExtension(E,f){this.logService.trace(`Deleting ${f} extension from disk`,E.identifier.id,E.location.fsPath),await k.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(f=>delete f[new p.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,f,U,F){this.logService.trace(`Started extracting the extension from ${f} to ${U}`);try{await k.Promises.rm(U)}catch(z){throw new R.ExtensionManagementError(this.joinErrors(z).message,u)}try{await C.extract(f,U,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${U}:`,E.id)}catch(z){try{await k.Promises.rm(U)}catch($){}throw new R.ExtensionManagementError(z.message,z instanceof C.ExtractError&&z.type?z.type:o)}}async rename(E,f,U,F){try{await k.Promises.rename(f,U)}catch(z){if(I.isWindows&&z&&z.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${f} to ${U} with 'EPERM' error. Trying again...`,E.id),this.rename(E,f,U,F);throw new R.ExtensionManagementError(z.message||g.localize(3,null,f,U),z.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const f=this.scanDevSystemExtensions(),[U,F]=await Promise.all([E,f]);return[...U,...F]}async scanExtensionsInDir(E,f){const U=new w.Limiter(10),F=await this.fileService.resolve(n.URI.file(E));return F.children?(await Promise.all(F.children.filter($=>$.isDirectory).map($=>U.queue(async()=>f===1&&s.basename($.resource).indexOf(".")===0?null:this.scanExtension($.resource,f))))).filter($=>$&&$.identifier):[]}async scanExtension(E,f){try{const U=await this.fileService.resolve(E);if(U.children){const{manifest:F,metadata:z}=await this.readManifest(E.fsPath),$=U.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,V=U.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,B={id:p.getGalleryExtensionId(F.publisher,F.name)},_={type:f,identifier:B,manifest:F,location:E,readmeUrl:$,changelogUrl:V,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:f===0};return z&&(this.setMetadata(_,z),_.installedTimestamp=z.installedTimestamp),_}}catch(U){f!==0&&this.logService.trace(U)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const f=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",f.length),f.filter(U=>E.some(F=>p.areSameExtensions(U.identifier,{id:F})))}else return[]}setMetadata(E,f){E.publisherDisplayName=f.publisherDisplayName||null,E.publisherId=f.publisherId||null,E.identifier.uuid=f.id,E.isMachineScoped=!!f.isMachineScoped,E.isBuiltin=E.type===0||!!f.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),f=await this.scanAllUserExtensions(),U=new Set;for(const $ of f)E[new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]||U.add($.identifier.id.toLowerCase());const F=p.groupByExtension(f,$=>$.identifier);await w.Promises.settled(F.map(async $=>{const V=$.sort((B,_)=>S.rcompare(B.manifest.version,_.manifest.version))[0];U.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const z=f.filter($=>E[new p.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]);await w.Promises.settled(z.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),f=[],U=p.groupByExtension(E,F=>F.identifier);f.push(...b.flatten(U.map(F=>F.sort((z,$)=>S.rcompare(z.manifest.version,$.manifest.version)).slice(1)))),await w.Promises.settled(f.map(F=>this.removeExtension(F,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const f=Array.isArray(E)?E:[E];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((U,F)=>new Error(`${U.message}${U.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(D.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const f=[k.Promises.readFile(T.join(E,"package.json"),"utf8").then($=>this.parseManifest($)),k.Promises.readFile(T.join(E,"package.nls.json"),"utf8").then(void 0,$=>$.code!=="ENOENT"?Promise.reject($):"{}").then($=>JSON.parse($))],[{manifest:U,metadata:F},z]=await Promise.all(f);return{manifest:d.localizeManifest(U,z),metadata:F}}parseManifest(E){return new Promise((f,U)=>{try{const F=JSON.parse(E),z=F.__metadata||null;f({manifest:F,metadata:z})}catch(F){U(new Error(g.localize(4,null)))}})}};l=de([Y(1,y.IFileService),Y(2,O.ILogService),Y(3,m.INativeEnvironmentService),Y(4,h.IProductService)],l),e.ExtensionsScanner=l}),define(ee[206],te([0,1,112,8,18,2,19,62,28,33,9,6,3,57,5,51,7,15,145,43,24,70,12,30,72,4,17,29,204,155,205,156,157,10]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s,a,t,r,i,o,u,c,l,v,E,f,U,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const z="unsetUninstalled",$="downloading",V="validating",B="local",_="cancelled",W="unknown";let K=class extends T.Disposable{constructor(P,A,M,N,x,H,J){super();this.environmentService=P,this.galleryService=A,this.logService=M,this.downloadService=N,this.telemetryService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new d.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new d.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new d.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new d.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(H.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(E.ExtensionsScanner,Z=>Q.postUninstall(Z))),this.manifestCache=this._register(new D.ExtensionsManifestCache(P,this)),this.extensionsDownloader=this._register(H.createInstance(v.ExtensionsDownloader));const ie=this._register(new U.ExtensionsWatcher(this,J,P,M));this._register(ie.onDidChangeExtensionsByAnotherSource(({added:Z,removed:oe})=>{Z.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),oe.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register(T.toDisposable(()=>{this.installingExtensions.forEach(Z=>Z.cancel()),this.uninstallingExtensions.forEach(Z=>Z.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(P){this.logService.trace("ExtensionManagementService#zip",P.identifier.id);const A=await this.collectFiles(P),M=await R.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,A);return h.URI.file(M)}async unzip(P){return this.logService.trace("ExtensionManagementService#unzip",P.toString()),(await this.install(P)).identifier}async getManifest(P){const A=await this.downloadVsix(P),M=L.resolve(A.fsPath);return l.getManifest(M)}async collectFiles(P){const A=async N=>{let x=await k.Promises.readdir(N);x=x.map(Q=>L.join(N,Q));const H=await Promise.all(x.map(Q=>k.Promises.stat(Q)));let J=Promise.resolve([]);return H.forEach((Q,ie)=>{const Z=x[ie];Q.isFile()&&(J=J.then(oe=>[...oe,Z])),Q.isDirectory()&&(J=J.then(oe=>A(Z).then(ue=>[...oe,...ue])))}),J};return(await A(P.location.fsPath)).map(N=>({path:`extension/${L.relative(P.location.fsPath,N)}`,localPath:N}))}async install(P,A={}){return this.logService.trace("ExtensionManagementService#install",P.toString()),m.createCancelablePromise(async M=>{const N=await this.downloadVsix(P),x=L.resolve(N.fsPath),H=await l.getManifest(x),J={id:w.getGalleryExtensionId(H.publisher,H.name)};let Q=1;if(H.engines&&H.engines.vscode&&!a.isEngineValid(H.engines.vscode,C.default.version,C.default.date))throw new Error(S.localize(0,null,J.id,C.default.version));const ie=new w.ExtensionIdentifierWithVersion(J,H.version),oe=(await this.getInstalled(1)).find(ge=>w.areSameExtensions(J,ge.identifier));if(oe)if(A.isMachineScoped=A.isMachineScoped||oe.isMachineScoped,A.isBuiltin=A.isBuiltin||oe.isBuiltin,Q=2,ie.equals(new w.ExtensionIdentifierWithVersion(oe.identifier,oe.manifest.version)))try{await this.extensionsScanner.removeExtension(oe,"existing")}catch(ge){throw new Error(S.localize(1,null,H.displayName||H.name))}else g.gt(oe.manifest.version,H.version)&&await this.uninstallExtension(oe);else{const ge=await this.unsetUninstalledAndGetLocal(ie);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(Se){throw new Error(S.localize(2,null,H.displayName||H.name))}}this.logService.info("Installing the extension:",J.id),this._onInstallExtension.fire({identifier:J,zipPath:x});let ue;try{ue=await this.getGalleryMetadata(w.getGalleryExtensionId(H.publisher,H.name))}catch(ge){}try{const ge=await this.installFromZipPath(ie,x,A.installOnlyNewlyAddedFromExtensionPack?oe:void 0,{...ue||{},...A},A,Q,M);return this.logService.info("Successfully installed the extension:",J.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",J.id,ge.message),ge}})}async downloadVsix(P){if(P.scheme===u.Schemas.file)return P;if(!this.downloadService)throw new Error("Download service is not available");const A=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(P,A),A}async installFromZipPath(P,A,M,N,x,H,J){try{const Q=await this.installExtension({zipPath:A,identifierWithVersion:P,metadata:N},J);try{x.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(Q,M,x)}catch(ie){O.isNonEmptyArray(Q.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",Q.identifier.id,ie.message),O.isNonEmptyArray(Q.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",Q.identifier.id,ie.message)}return this._onDidInstallExtension.fire({identifier:P,zipPath:A,local:Q,operation:H}),Q}catch(Q){throw this._onDidInstallExtension.fire({identifier:P,zipPath:A,operation:H,error:Q}),Q}}async canInstall(P){return!0}async installFromGallery(P,A={}){if(!this.galleryService.isEnabled())throw new Error(S.localize(3,null));try{P=await this.checkAndGetCompatibleVersion(P)}catch(N){const x=N&&N.code?N.code:W;throw this.logService.error("Failed to install extension:",P.identifier.id,N?N.message:x),this.reportTelemetry(this.getTelemetryEvent(1),w.getGalleryExtensionTelemetryData(P),void 0,N),N instanceof Error&&(N.name=x),N}let M=this.installingExtensions.get(new w.ExtensionIdentifierWithVersion(P.identifier,P.version).key());return M?(this.logService.info("Extensions is already requested to install",P.identifier.id),(await M.resultPromise).local):(M=this.createInstallFromGalleryExtensionTask(P,A),(await this.runInstallGalleryExtensionTask(M,A)).local)}createInstallFromGalleryExtensionTask(P,A){const M=new w.ExtensionIdentifierWithVersion(P.identifier,P.version).key();this._onInstallExtension.fire({identifier:P.identifier,gallery:P}),this.logService.info("Installing extension:",P.identifier.id);let N;const x=new m.Barrier,H={extension:P,get resultPromise(){return x.wait().then(()=>N)},run:async()=>(N||(N=m.createCancelablePromise(async J=>{try{const Q=await this.installGalleryExtension(P,A,J);return this.logService.info("Extensions installed successfully:",P.identifier.id),this._onDidInstallExtension.fire({identifier:P.identifier,gallery:Q.gallery,local:Q.local,operation:Q.operation}),Q}catch(Q){const ie=Q&&Q.code?Q.code:W;throw this.logService.error("Failed to install extension:",P.identifier.id,Q?Q.message:ie),this._onDidInstallExtension.fire({identifier:P.identifier,gallery:P,operation:1,error:ie}),Q instanceof Error&&(Q.name=ie),Q}})),x.open(),N.finally(()=>this.installingExtensions.delete(M)),N),cancel:()=>{N?N.cancel():this._onDidInstallExtension.fire({identifier:P.identifier,gallery:P,operation:1,error:_})}};return this.installingExtensions.set(M,H),H}async runInstallGalleryExtensionTask(P,A){if(A.donotIncludePackAndDependencies)return this.logService.info("Installing the extension without checking dependencies and pack",P.extension.identifier.id),P.run();const M=new Map,N=[];try{const x=await this.galleryService.getManifest(P.extension,c.CancellationToken.None);if(x===null){const ie=new p.ExtensionManagementError(`Missing manifest for extension ${P.extension.identifier.id}`,V);throw this.logService.error("Failed to install extension:",P.extension.identifier.id,ie.message),ie}M.set(P.extension.identifier.id.toLowerCase(),{task:P,manifest:x});const H=await this.getAllDepsAndPackExtensionsToInstall(P.extension.identifier,x,c.CancellationToken.None);let J=!1;for(const{gallery:ie,manifest:Z}of H)if(J=J||!!Z.extensionDependencies?.some(oe=>w.areSameExtensions({id:oe},P.extension.identifier)),this.installingExtensions.has(new w.ExtensionIdentifierWithVersion(ie.identifier,ie.version).key()))this.logService.info("Extension is already requested to install",ie.identifier.id);else{const oe=this.createInstallFromGalleryExtensionTask(ie,{...A,donotIncludePackAndDependencies:!0});M.set(ie.identifier.id.toLowerCase(),{task:oe,manifest:Z})}for(;M.size;){const ie=[...M.values()].filter(({manifest:oe})=>!oe.extensionDependencies?.some(ue=>M.has(ue.toLowerCase())));let Z;ie.length?Z=M.size===1?ie:ie.filter(({task:oe})=>!(oe===P&&!J)):(this.logService.info("Found extensions with circular dependencies",ie.map(({task:oe})=>oe.extension.identifier.id)),Z=[...M.values()]),await Promise.all(Z.map(async({task:oe})=>{N.push(await oe.run()),M.delete(oe.extension.identifier.id.toLowerCase())}))}const Q=N.find(({local:ie})=>w.areSameExtensions(ie.identifier,P.extension.identifier));if(Q)return Q;throw new Error("Extension is not installed")}catch(x){throw M.size?M.forEach(({task:H})=>H.cancel()):P.cancel(),x}}async installGalleryExtension(P,A,M){const N=new Date().getTime();let x=1;try{const J=(await this.getInstalled()).find(Z=>w.areSameExtensions(Z.identifier,P.identifier));J&&(x=2);const Q=await this.downloadInstallableExtension(P,x);Q.metadata.isMachineScoped=A.isMachineScoped||J?.isMachineScoped,Q.metadata.isBuiltin=A.isBuiltin||J?.isBuiltin;const ie=await this.installExtension(Q,M);J&&g.neq(J.manifest.version,P.version)&&await this.extensionsScanner.setUninstalled(J);try{await this.extensionsDownloader.delete(h.URI.file(Q.zipPath))}catch(Z){}return this.reportTelemetry(this.getTelemetryEvent(x),w.getGalleryExtensionTelemetryData(P),new Date().getTime()-N,void 0),{local:ie,operation:x,gallery:P}}catch(H){throw this.reportTelemetry(this.getTelemetryEvent(x),w.getGalleryExtensionTelemetryData(P),new Date().getTime()-N,H),H}}async getAllDepsAndPackExtensionsToInstall(P,A,M){let N=await this.getInstalled();const x=[P,...N.map(Q=>Q.identifier)],H=[],J=async(Q,ie)=>{const Z=ie.extensionDependencies||[];if(ie.extensionPack){const oe=N.find(ue=>w.areSameExtensions(ue.identifier,Q));for(const ue of ie.extensionPack)oe&&oe.manifest.extensionPack&&oe.manifest.extensionPack.some(ge=>w.areSameExtensions({id:ge},{id:ue}))||Z.every(ge=>!w.areSameExtensions({id:ge},{id:ue}))&&Z.push(ue)}if(Z.length){const oe=[...x,...H.map(ge=>ge.gallery.identifier)],ue=Z.filter(ge=>oe.every(Se=>!w.areSameExtensions(Se,{id:ge})));if(ue.length){const ge=await this.galleryService.query({names:ue,pageSize:Z.length},c.CancellationToken.None);for(const Se of ge.firstPage){if(oe.find(Fe=>w.areSameExtensions(Fe,Se.identifier)))continue;const Ie=await this.checkAndGetCompatibleVersion(Se),Pe=await this.galleryService.getManifest(Ie,c.CancellationToken.None);if(Pe===null)throw new p.ExtensionManagementError(`Missing manifest for extension ${Ie.identifier.id}`,V);H.push({gallery:Ie,manifest:Pe}),await J(Ie.identifier,Pe)}}}};return await J(P,A),N=await this.getInstalled(),H.filter(Q=>!N.some(ie=>w.areSameExtensions(ie.identifier,Q.gallery.identifier)))}async checkAndGetCompatibleVersion(P){if(await this.isMalicious(P))throw new p.ExtensionManagementError(S.localize(4,null),p.INSTALL_ERROR_MALICIOUS);const A=await this.galleryService.getCompatibleExtension(P);if(!A)throw new p.ExtensionManagementError(S.localize(5,null,P.identifier.id,C.default.version),p.INSTALL_ERROR_INCOMPATIBLE);return A}async reinstallFromGallery(P){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",P.identifier.id),!this.galleryService.isEnabled())throw new Error(S.localize(6,null));const A=await this.findGalleryExtension(P);if(!A)throw new Error(S.localize(7,null));await this.extensionsScanner.setUninstalled(P);try{await this.extensionsScanner.removeUninstalledExtension(P)}catch(M){throw new Error(S.localize(8,null,y.toErrorMessage(M)))}await this.installFromGallery(A)}getTelemetryEvent(P){return P===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(P){const A=await this.getExtensionsReport();return w.getMaliciousExtensionsSet(A).has(P.identifier.id)}async downloadInstallableExtension(P,A){const M={id:P.identifier.uuid,publisherId:P.publisherId,publisherDisplayName:P.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",P.identifier.id),N=(await this.extensionsDownloader.downloadExtension(P,A)).fsPath,this.logService.info("Downloaded extension:",P.identifier.id,N)}catch(x){throw new p.ExtensionManagementError(this.joinErrors(x).message,$)}try{const x=await l.getManifest(N);return{zipPath:N,identifierWithVersion:new w.ExtensionIdentifierWithVersion(P.identifier,x.version),metadata:M}}catch(x){throw new p.ExtensionManagementError(this.joinErrors(x).message,V)}}async installExtension(P,A){try{const M=await this.unsetUninstalledAndGetLocal(P.identifierWithVersion);if(M)return P.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,P.metadata):M}catch(M){throw I.isMacintosh?new p.ExtensionManagementError(S.localize(9,null),z):new p.ExtensionManagementError(S.localize(10,null),z)}return this.extractAndInstall(P,A)}async unsetUninstalledAndGetLocal(P){if(!await this.isUninstalled(P))return null;this.logService.trace("Removing the extension from uninstalled list:",P.id);const M=await this.extensionsScanner.setInstalled(P);return this.logService.info("Removed the extension from uninstalled list:",P.id),M}async extractAndInstall({zipPath:P,identifierWithVersion:A,metadata:M},N){let x=await this.extensionsScanner.extractUserExtension(A,P,N);return this.logService.info("Installation completed.",A.id),M&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,M)),x}async installDependenciesAndPackExtensions(P,A,M){if(!this.galleryService.isEnabled())return;const N=P.manifest.extensionDependencies||[];if(P.manifest.extensionPack)for(const x of P.manifest.extensionPack)A&&A.manifest.extensionPack&&A.manifest.extensionPack.some(H=>w.areSameExtensions({id:H},{id:x}))||N.every(H=>!w.areSameExtensions({id:H},{id:x}))&&N.push(x);if(N.length){const x=await this.getInstalled(),H=N.filter(J=>x.every(({identifier:Q})=>!w.areSameExtensions(Q,{id:J})));if(H.length){const Q=(await this.galleryService.query({names:H,pageSize:N.length},c.CancellationToken.None)).firstPage;try{await m.Promises.settled(Q.map(ie=>this.installFromGallery(ie,M)))}catch(ie){try{await this.rollback(Q)}catch(Z){}throw ie}}}}async rollback(P){const M=(await this.getInstalled(1)).filter(N=>P.some(x=>new w.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new w.ExtensionIdentifierWithVersion(x.identifier,x.version))));await m.Promises.settled(M.map(N=>this.uninstall(N)))}async uninstall(P,A={}){this.logService.trace("ExtensionManagementService#uninstall",P.identifier.id);const M=await this.getInstalled(1),N=M.find(x=>w.areSameExtensions(x.identifier,P.identifier));if(!N)throw new Error(S.localize(11,null,P.manifest.displayName||P.manifest.name));try{await this.checkForDependenciesAndUninstall(N,M,A)}catch(x){throw this.joinErrors(x)}}async updateMetadata(P,A){return this.logService.trace("ExtensionManagementService#updateMetadata",P.identifier.id),P=await this.extensionsScanner.saveMetadataForLocalExtension(P,{...P.manifest.__metadata||{},...A}),this.manifestCache.invalidate(),P}async updateExtensionScope(P,A){return this.logService.trace("ExtensionManagementService#updateExtensionScope",P.identifier.id),P=await this.extensionsScanner.saveMetadataForLocalExtension(P,{...P.manifest.__metadata||{},isMachineScoped:A}),this.manifestCache.invalidate(),P}async getGalleryMetadata(P){const A=await this.findGalleryExtensionByName(P);return A?{id:A.identifier.uuid,publisherDisplayName:A.publisherDisplayName,publisherId:A.publisherId}:void 0}async findGalleryExtension(P){if(P.identifier.uuid){const A=await this.findGalleryExtensionById(P.identifier.uuid);return A||this.findGalleryExtensionByName(P.identifier.id)}return this.findGalleryExtensionByName(P.identifier.id)}async findGalleryExtensionById(P){return(await this.galleryService.query({ids:[P],pageSize:1},c.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(P){return(await this.galleryService.query({names:[P],pageSize:1},c.CancellationToken.None)).firstPage[0]}joinErrors(P){const A=Array.isArray(P)?P:[P];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((M,N)=>new Error(`${M.message}${M.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(P,A,M){try{await this.preUninstallExtension(P);const N=M.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(P,A);await this.uninstallExtensions(P,N,A,M)}catch(N){throw await this.postUninstallExtension(P,new p.ExtensionManagementError(N instanceof Error?N.message:N,B)),N}await this.postUninstallExtension(P)}async uninstallExtensions(P,A,M,N){const x=[P,...A];if(!N.donotCheckDependents)for(const H of x)this.checkForDependents(H,x,M,P);await m.Promises.settled([this.uninstallExtension(P),...A.map(H=>this.doUninstall(H))])}checkForDependents(P,A,M,N){const x=this.getDependents(P,M);if(x.length){const H=x.filter(J=>A.indexOf(J)===-1);if(H.length)throw new Error(this.getDependentsErrorMessage(P,H,N))}}getDependentsErrorMessage(P,A,M){return M===P?A.length===1?S.localize(12,null,M.manifest.displayName||M.manifest.name,A[0].manifest.displayName||A[0].manifest.name):A.length===2?S.localize(13,null,M.manifest.displayName||M.manifest.name,A[0].manifest.displayName||A[0].manifest.name,A[1].manifest.displayName||A[1].manifest.name):S.localize(14,null,M.manifest.displayName||M.manifest.name,A[0].manifest.displayName||A[0].manifest.name,A[1].manifest.displayName||A[1].manifest.name):A.length===1?S.localize(15,null,M.manifest.displayName||M.manifest.name,P.manifest.displayName||P.manifest.name,A[0].manifest.displayName||A[0].manifest.name):A.length===2?S.localize(16,null,M.manifest.displayName||M.manifest.name,P.manifest.displayName||P.manifest.name,A[0].manifest.displayName||A[0].manifest.name,A[1].manifest.displayName||A[1].manifest.name):S.localize(17,null,M.manifest.displayName||M.manifest.name,P.manifest.displayName||P.manifest.name,A[0].manifest.displayName||A[0].manifest.name,A[1].manifest.displayName||A[1].manifest.name)}getAllPackExtensionsToUninstall(P,A,M=[]){if(M.indexOf(P)!==-1)return[];M.push(P);const N=P.manifest.extensionPack?P.manifest.extensionPack:[];if(N.length){const x=A.filter(J=>!J.isBuiltin&&N.some(Q=>w.areSameExtensions({id:Q},J.identifier))),H=[];for(const J of x)H.push(...this.getAllPackExtensionsToUninstall(J,A,M));return[...x,...H]}return[]}getDependents(P,A){return A.filter(M=>M.manifest.extensionDependencies&&M.manifest.extensionDependencies.some(N=>w.areSameExtensions({id:N},P.identifier)))}async doUninstall(P){try{await this.preUninstallExtension(P),await this.uninstallExtension(P)}catch(A){throw await this.postUninstallExtension(P,new p.ExtensionManagementError(A instanceof Error?A.message:A,B)),A}await this.postUninstallExtension(P)}async preUninstallExtension(P){if(!await k.Promises.exists(P.location.fsPath))throw new Error(S.localize(18,null));this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier)}async uninstallExtension(P){let A=this.uninstallingExtensions.get(P.identifier.id);return A||(A=m.createCancelablePromise(async()=>{const M=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...M.filter(N=>w.areSameExtensions(N.identifier,P.identifier)))}),this.uninstallingExtensions.set(P.identifier.id,A),A.finally(()=>this.uninstallingExtensions.delete(P.identifier.id))),A}async postUninstallExtension(P,A){if(A)this.logService.error("Failed to uninstall extension:",P.identifier.id,A.message);else if(this.logService.info("Successfully uninstalled extension:",P.identifier.id),P.identifier.uuid)try{await this.galleryService.reportStatistic(P.manifest.publisher,P.manifest.name,P.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",w.getLocalExtensionTelemetryData(P),void 0,A);const M=A?A instanceof p.ExtensionManagementError?A.code:W:void 0;this._onDidUninstallExtension.fire({identifier:P.identifier,error:M})}getInstalled(P=null){return this.extensionsScanner.scanExtensions(P)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(P){return(await this.filterUninstalled(P)).length===1}async filterUninstalled(...P){const A=[],M=await this.extensionsScanner.getUninstalledExtensions();for(const N of P)M[N.key()]&&A.push(N.key());return A}getExtensionsReport(){const P=new Date().getTime();return(!this.reportedExtensions||P-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=P),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const P=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${P.length} reported extensions from service`),P}catch(P){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(P,A,M,N){const x=N?N instanceof p.ExtensionManagementError?N.code:W:void 0;this.telemetryService.publicLogError(P,{...A,success:!N,duration:M,errorcode:x})}};K=de([Y(0,n.INativeEnvironmentService),Y(1,p.IExtensionGalleryService),Y(2,b.ILogService),Y(3,o.optional(i.IDownloadService)),Y(4,s.ITelemetryService),Y(5,o.IInstantiationService),Y(6,F.IFileService)],K),e.ExtensionManagementService=K}),define(ee[212],te([0,1,48,35,213,102,51,101,36,76,50,149,9,131,133,28,206,174,23,165,39,166,24,59,172,80,81,177,15,77,158,56,2,167,72,162,163,154,153,151,150,173,71,159,10,161,17,27,22,199,201,196,58,197,202,171,21,169,198,60,195,175,61,73,135,203,176,86,85,84,4,152,144,11,43,82,184,179,200,142,146,178,5,12]),function(G,e,S,L,k,T,O,R,p,w,n,m,d,g,h,C,I,b,D,y,s,a,t,r,i,o,u,c,l,v,E,f,U,F,z,$,V,B,_,W,K,j,P,A,M,N,x,H,J,Q,ie,Z,oe,ue,ge,Se,Ie,Pe,Fe,Oe,ke,_e,be,Ae,Ke,Ye,$e,xe,X,re,se,ye,ve,Re,we,Te,Ce,Le,Ue,q,ne,ae,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class fe extends U.Disposable{constructor(he){super();this.configuration=he,this.server=this._register(new R.Server),k.gracefulify(S),this.registerListeners()}registerListeners(){const he=()=>this.dispose();process.once("exit",he),T.ipcRenderer.once("vscode:electron-main->shared-process=exit",he)}async open(){const he=await this.initServices();J.registerConfiguration(),he.invokeFunction(Ee=>{const De=Ee.get(l.ILogService);De.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(De)}),this._register(U.combinedDisposable(he.createInstance($.CodeCacheCleaner,this.configuration.codeCachePath),he.createInstance(V.LanguagePackCachedDataCleaner),he.createInstance(B.StorageDataCleaner,this.configuration.backupWorkspacesPath),he.createInstance(_.LogsDataCleaner),he.createInstance(ye.LocalizationsUpdater),he.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const he=new w.ServiceCollection,Ee={_serviceBrand:void 0,...O.default};he.set(H.IProductService,Ee);const De=new p.StaticRouter(Be=>Be==="main"),Me=new K.MessagePortMainProcessService(this.server,De);he.set(W.IMainProcessService,Me);const Ne=new g.NativeEnvironmentService(this.configuration.args,Ee);he.set(d.INativeEnvironmentService,Ne);const et=new v.LogLevelChannelClient(this.server.getChannel("logLevel",De)),Je=new v.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Me.getChannel("logger"));he.set(l.ILoggerService,Je);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger(ce.joinPath(le.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new v.FollowerLogService(et,nt));he.set(l.ILogService,We);const Ve=this._register(new A.FileService(We));he.set(M.IFileService,Ve);const it=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(x.Schemas.file,it);const qe=this._register(new y.ConfigurationService(Ne.settingsResource,Ve));he.set(D.IConfigurationService,qe),await qe.initialize();const Xe=new Se.NativeStorageService(void 0,Me,Ne);he.set(Ie.IStorageService,Xe),await Xe.initialize(),this._register(U.toDisposable(()=>Xe.flush())),he.set(s.IRequestService,new n.SyncDescriptor(a.RequestService)),he.set(q.IChecksumService,new n.SyncDescriptor(ne.ChecksumService));const tt=p.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});he.set(oe.INativeHostService,tt),he.set(z.IDownloadService,new n.SyncDescriptor(F.DownloadService));const rt=this._register(new Ye.ActiveWindowManager(tt)),ht=new p.StaticRouter(Be=>rt.getActiveClientId().then(st=>Be===st));he.set(Ae.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Ee.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:Be,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Ne;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new c.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register(U.toDisposable(()=>ct.flush())),He=r.combinedAppender(ct,He)}Qe=new u.TelemetryService({appender:He,commonProperties:i.resolveCommonProperties(Ve,L.release(),L.hostname(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Be,st]},qe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(He)),he.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe);return he.set(t.ICustomEndpointTelemetryService,ft),he.set(C.IExtensionManagementService,new n.SyncDescriptor(I.ExtensionManagementService)),he.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),he.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),he.set(f.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),he.set(P.IDiagnosticsService,new n.SyncDescriptor(j.DiagnosticsService)),he.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),he.set(J.IUserDataSyncLogService,new n.SyncDescriptor(ue.UserDataSyncLogService)),he.set(J.IUserDataSyncUtilService,new Z.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),he.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Pe.GlobalExtensionEnablementService)),he.set(X.IIgnoredExtensionsManagementService,new n.SyncDescriptor(X.IgnoredExtensionsManagementService)),he.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),he.set(J.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),he.set(J.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),he.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),he.set(J.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),he.set(J.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(xe.UserDataAutoSyncEnablementService)),he.set(J.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Fe.UserDataSyncResourceEnablementService)),he.set(J.IUserDataSyncService,new n.SyncDescriptor(Q.UserDataSyncService)),he.set(Le.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,We,Qe))),new m.InstantiationService(he)}initChannels(he){const Ee=new h.ExtensionManagementChannel(he.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const De=p.ProxyChannel.fromService(he.get(f.ILocalizationsService));this.server.registerChannel("localizations",De);const Me=p.ProxyChannel.fromService(he.get(P.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const Ne=new h.ExtensionTipsChannel(he.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const et=p.ProxyChannel.fromService(he.get(q.IChecksumService));this.server.registerChannel("checksum",et);const Je=new Z.UserDataSyncMachinesServiceChannel(he.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const nt=p.ProxyChannel.fromService(he.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const We=new Z.UserDataSyncAccountServiceChannel(he.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new Z.UserDataSyncStoreManagementServiceChannel(he.get(J.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const it=new Ue.UserDataSyncChannel(he.get(J.IUserDataSyncService),he.get(l.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(he.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Xe=new Z.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=he.get(Le.ILocalPtyService),rt=p.ProxyChannel.fromService(tt);this.server.registerChannel(Te.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(he){window.addEventListener("unhandledrejection",Ee=>{Re.onUnexpectedError(Ee.reason),Ee.preventDefault()}),Re.setUnexpectedErrorHandler(Ee=>{const De=we.toErrorMessage(Ee,!0);!De||he.error(`[uncaught exception in sharedProcess]: ${De}`)})}}async function me(pe){const he=new fe(pe);T.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await he.open(),T.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=me})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cc528230987ce3ac61fc4f094ae247d5ff24db3c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
