/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/base/common/extpath","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(q){for(var e=[],g=0,M=q.length;g<M;g++)e[g]=J[q[g]];return e};define(J[103],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(M,D){if(!M)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(J[47],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(E){return(n,w,v)=>{let i=null,b=null;if(typeof v.value=="function"?(i="value",b=v.value):typeof v.get=="function"&&(i="get",b=v.get),!b)throw new Error("not supported");v[i]=E(b,w)}}e.createDecorator=g;function M(E,n,w){let v=null,i=null;if(typeof w.value=="function"?(v="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(v="get",i=w.get),!i)throw new Error("not supported");const b=`$memoize$${n}`;w[v]=function(...k){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,k)}),this[b]}}e.memoize=M;function D(E,n,w){return g((v,i)=>{const b=`$debounce$${i}`,k=`$debounce$result$${i}`;return function(...y){this[k]||(this[k]=w?w():void 0),clearTimeout(this[b]),n&&(this[k]=n(this[k],...y),y=[this[k]]),this[b]=setTimeout(()=>{v.apply(this,y),this[k]=w?w():void 0},E)}})}e.debounce=D;function S(E,n,w){return g((v,i)=>{const b=`$throttle$timer$${i}`,k=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...m){if(this[k]||(this[k]=w?w():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[k]=n(this[k],...m)),this[d])return;const P=this[y]+E;P<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[k]]),this[k]=w?w():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),v.apply(this,[this[k]]),this[k]=w?w():void 0},P-Date.now()))}})}e.throttle=S}),define(J[16],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function M(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=M;function D(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function S(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=S;function E(l){if(l instanceof Error){let{name:t,message:s}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:t,message:s,stack:r}}return l}e.transformErrorForSerialization=E;const n="Canceled";function w(l){return l instanceof Error&&l.name===n&&l.message===n}e.isPromiseCanceledError=w;class v extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=v;function i(){const l=new Error(n);return l.name=l.message,l}e.canceled=i;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function k(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=k;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(l){const t=new Error(`${l} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=m;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(l){const t=l;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function o(l,t=Object.create(null)){const s=new Error(l);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=o}),define(J[36],Z([0,1,16]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filterSortedByKey=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(T,R=0){return T[T.length-(1+R)]}e.tail=M;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=D;function S(T,R,O=(W,A)=>W===A){if(T===R)return!0;if(!T||!R||T.length!==R.length)return!1;for(let W=0,A=T.length;W<A;W++)if(!O(T[W],R[W]))return!1;return!0}e.equals=S;function E(T,R,O){let W=0,A=T.length-1;for(;W<=A;){const N=(W+A)/2|0,z=O(T[N],R);if(z<0)W=N+1;else if(z>0)A=N-1;else return N}return-(W+1)}e.binarySearch=E;function n(T,R){let O=0,W=T.length;if(W===0)return 0;for(;O<W;){const A=Math.floor((O+W)/2);R(T[A])?W=A:O=A+1}return O}e.findFirstInSorted=n;function w(T,R,O){if(T=T|0,T>=R.length)throw new TypeError("invalid index");let W=R[Math.floor(R.length*Math.random())],A=[],N=[],z=[];for(let Y of R){const G=O(Y,W);G<0?A.push(Y):G>0?N.push(Y):z.push(Y)}return T<A.length?w(T,A,O):T<A.length+z.length?z[0]:w(T-(A.length+z.length),N,O)}e.quickSelect=w;function v(T,R){const O=[];let W;for(const A of T.slice(0).sort(R))!W||R(W[0],A)!==0?(W=[A],O.push(W)):W.push(A);return O}e.groupBy=v;function i(T,R,O){const W=[];function A(Y,G,X){if(G===0&&X.length===0)return;const ne=W[W.length-1];ne&&ne.start+ne.deleteCount===Y?(ne.deleteCount+=G,ne.toInsert.push(...X)):W.push({start:Y,deleteCount:G,toInsert:X})}let N=0,z=0;for(;;){if(N===T.length){A(N,0,R.slice(z));break}if(z===R.length){A(N,T.length-N,[]);break}const Y=T[N],G=R[z],X=O(Y,G);X===0?(N+=1,z+=1):X<0?(A(N,1,[]),N+=1):X>0&&(A(N,0,[G]),z+=1)}return W}e.sortedDiff=i;function b(T,R,O){const W=i(T,R,O),A=[],N=[];for(const z of W)A.push(...T.slice(z.start,z.start+z.deleteCount)),N.push(...z.toInsert);return{removed:A,added:N}}e.delta=b;function k(T,R,O){if(O===0)return[];const W=T.slice(0,O).sort(R);return d(T,R,W,O,T.length),W}e.top=k;function y(T,R,O,W,A){return O===0?Promise.resolve([]):new Promise((N,z)=>{(async()=>{const Y=T.length,G=T.slice(0,O).sort(R);for(let X=O,ne=Math.min(O+W,Y);X<Y;X=ne,ne=Math.min(ne+W,Y)){if(X>O&&await new Promise(se=>setTimeout(se)),A&&A.isCancellationRequested)throw g.canceled();d(T,R,G,X,ne)}return G})().then(N,z)})}e.topAsync=y;function d(T,R,O,W,A){for(const N=O.length;W<A;W++){const z=T[W];if(R(z,O[N-1])<0){O.pop();const Y=n(O,G=>R(z,G)<0);O.splice(Y,0,z)}}}function m(T){return T.filter(R=>!!R)}e.coalesce=m;function P(T){let R=0;for(let O=0;O<T.length;O++)T[O]&&(T[R]=T[O],R+=1);T.length=R}e.coalesceInPlace=P;function I(T,R,O){T.splice(O,0,T.splice(R,1)[0])}e.move=I;function c(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=c;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function o(T,R){if(!R)return T.filter((W,A)=>T.indexOf(W)===A);const O=Object.create(null);return T.filter(W=>{const A=R(W);return O[A]?!1:(O[A]=!0,!0)})}e.distinct=o;function l(T){const R=new Set;return T.filter(O=>R.has(O)?!1:(R.add(O),!0))}e.distinctES6=l;function t(T){const R=Object.create(null);return O=>{const W=T(O);return R[W]?!1:(R[W]=!0,!0)}}e.uniqueFilter=t;function s(T,R){for(let O=T.length-1;O>=0;O--){const W=T[O];if(R(W))return O}return-1}e.lastIndex=s;function r(T,R){return T.length>0?T[0]:R}e.firstOrDefault=r;function a(T,R,O=(W,A)=>W===A){let W=0;for(let A=0,N=Math.min(T.length,R.length);A<N&&O(T[A],R[A]);A++)W++;return W}e.commonPrefixLength=a;function u(T){return[].concat(...T)}e.flatten=u;function p(T,R){let O=typeof R=="number"?T:0;typeof R=="number"?O=T:(O=0,R=T);const W=[];if(O<=R)for(let A=O;A<R;A++)W.push(A);else for(let A=O;A>R;A--)W.push(A);return W}e.range=p;function f(T,R,O){return T.reduce((W,A)=>(W[R(A)]=O?O(A):A,W),Object.create(null))}e.index=f;function L(T,R){return T.push(R),()=>F(T,R)}e.insert=L;function F(T,R){const O=T.indexOf(R);if(O>-1)return T.splice(O,1),R}e.remove=F;function _(T,R,O){const W=T.slice(0,R),A=T.slice(R);return W.concat(O,A)}e.arrayInsert=_;function C(T,R){let O;if(typeof R=="number"){let W=R;O=()=>{const A=Math.sin(W++)*179426549;return A-Math.floor(A)}}else O=Math.random;for(let W=T.length-1;W>0;W-=1){const A=Math.floor(O()*(W+1)),N=T[W];T[W]=T[A],T[A]=N}}e.shuffle=C;function K(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.unshift(R))}e.pushToStart=K;function ee(T,R){const O=T.indexOf(R);O>-1&&(T.splice(O,1),T.push(R))}e.pushToEnd=ee;function V(T,R){return Array.isArray(T)?T.map(R):R(T)}e.mapArrayOrNot=V;function x(T){return Array.isArray(T)?T:[T]}e.asArray=x;function Q(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=Q;function U(T,R){for(const O of T){const W=R(O);if(W!==void 0)return W}}e.mapFind=U;function $(T,R){let O=Number.MAX_SAFE_INTEGER,W=0;return T.forEach((A,N)=>{const z=R(A);z<O&&(O=z,W=N)}),W}e.minIndex=$;function H(T,R){let O=Number.MIN_SAFE_INTEGER,W=0;return T.forEach((A,N)=>{const z=R(A);z>O&&(O=z,W=N)}),W}e.maxIndex=H;function B(T,R,O,W=O){const A=n(T,z=>O<=R(z)),N=n(T,z=>W<R(z));return A===N?null:T.slice(A,N)}e.filterSortedByKey=B}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(M){const D=this;let S=!1,E;return function(){return S||(S=!0,E=M.apply(D,arguments)),E}}e.once=g}),define(J[63],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(M){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}M.is=D;const S=Object.freeze([]);function E(){return S}M.empty=E;function*n(l){yield l}M.single=n;function w(l){return l||S}M.from=w;function v(l){return!l||l[Symbol.iterator]().next().done===!0}M.isEmpty=v;function i(l){return l[Symbol.iterator]().next().value}M.first=i;function b(l,t){for(const s of l)if(t(s))return!0;return!1}M.some=b;function k(l,t){for(const s of l)if(t(s))return s}M.find=k;function*y(l,t){for(const s of l)t(s)&&(yield s)}M.filter=y;function*d(l,t){let s=0;for(const r of l)yield t(r,s++)}M.map=d;function*m(...l){for(const t of l)for(const s of t)yield s}M.concat=m;function*P(l){for(const t of l)for(const s of t)yield s}M.concatNested=P;function I(l,t,s){let r=s;for(const a of l)r=t(r,a);return r}M.reduce=I;function*c(l,t,s=l.length){for(t<0&&(t+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);t<s;t++)yield l[t]}M.slice=c;function h(l,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,l];const r=l[Symbol.iterator]();for(let a=0;a<t;a++){const u=r.next();if(u.done)return[s,M.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return r}}]}M.consume=h;function o(l,t,s=(r,a)=>r===a){const r=l[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const u=r.next(),p=a.next();if(u.done!==p.done)return!1;if(u.done)return!0;if(!s(u.value,p.value))return!1}}M.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,s=!1){let r=0,a=t.length,u="",p=0,f=16,L=0;function F(Q){let U=0,$=0;for(;U<Q;){const H=t.charCodeAt(r);if(H>=48&&H<=57)$=$*16+H-48;else if(H>=65&&H<=70)$=$*16+H-65+10;else if(H>=97&&H<=102)$=$*16+H-97+10;else break;r++,U++}return U<Q&&($=-1),$}function _(Q){r=Q,u="",p=0,f=16,L=0}function C(){const Q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&v(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&v(t.charCodeAt(r)))for(r++;r<t.length&&v(t.charCodeAt(r));)r++;else return L=3,t.substring(Q,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&v(t.charCodeAt(r))){for(r++;r<t.length&&v(t.charCodeAt(r));)r++;U=r}else L=3;return t.substring(Q,U)}function K(){let Q="",U=r;for(;;){if(r>=a){Q+=t.substring(U,r),L=2;break}const $=t.charCodeAt(r);if($===34){Q+=t.substring(U,r),r++;break}if($===92){if(Q+=t.substring(U,r),r++,r>=a){L=2;break}switch(t.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const B=F(4);B>=0?Q+=String.fromCharCode(B):L=4;break;default:L=5}U=r;continue}if($>=0&&$<=31)if(w($)){Q+=t.substring(U,r),L=2;break}else L=6;r++}return Q}function ee(){if(u="",L=0,p=r,r>=a)return p=a,f=17;let Q=t.charCodeAt(r);if(n(Q)){do r++,u+=String.fromCharCode(Q),Q=t.charCodeAt(r);while(n(Q));return f=15}if(w(Q))return r++,u+=String.fromCharCode(Q),Q===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),f=14;switch(Q){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,u=K(),f=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!w(t.charCodeAt(r));)r++;return u=t.substring(U,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const $=a-1;let H=!1;for(;r<$;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,L=1),u=t.substring(U,r),f=13}return u+=String.fromCharCode(Q),r++,f=16;case 45:if(u+=String.fromCharCode(Q),r++,r===a||!v(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=C(),f=11;default:for(;r<a&&V(Q);)r++,Q=t.charCodeAt(r);if(p!==r){switch(u=t.substring(p,r),u){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return u+=String.fromCharCode(Q),r++,f=16}}function V(Q){if(n(Q)||w(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let Q;do Q=ee();while(Q>=12&&Q<=15);return Q}return{setPosition:_,getPosition:()=>r,scan:s?x:ee,getToken:()=>f,getTokenValue:()=>u,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>L}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function b(t,s){const r=[],a=new Object;let u;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function L(F,_,C,K){p.value=F,p.offset=_,p.length=C,p.type=K,p.colonOffset=void 0,u=p}try{h(t,{onObjectBegin:(F,_)=>{if(s<=F)throw a;u=void 0,f=s>F,r.push("")},onObjectProperty:(F,_,C)=>{if(s<_||(L(F,_,C,"property"),r[r.length-1]=F,s<=_+C))throw a},onObjectEnd:(F,_)=>{if(s<=F)throw a;u=void 0,r.pop()},onArrayBegin:(F,_)=>{if(s<=F)throw a;u=void 0,r.push(0)},onArrayEnd:(F,_)=>{if(s<=F)throw a;u=void 0,r.pop()},onLiteralValue:(F,_,C)=>{if(s<_||(L(F,_,C,l(F)),s<=_+C))throw a},onSeparator:(F,_,C)=>{if(s<=_)throw a;if(F===":"&&u&&u.type==="property")u.colonOffset=_,f=!1,u=void 0;else if(F===","){const K=r[r.length-1];typeof K=="number"?r[r.length-1]=K+1:(f=!0,r[r.length-1]=""),u=void 0}}})}catch(F){if(F!==a)throw F}return{path:r,previousNode:u,isAtPropertyKey:f,matches:F=>{let _=0;for(let C=0;_<F.length&&C<r.length;C++)if(F[_]===r[C]||F[_]==="*")_++;else if(F[_]!=="**")return!1;return _===F.length}}}e.getLocation=b;function k(t,s=[],r=S.DEFAULT){let a=null,u=[];const p=[];function f(F){Array.isArray(u)?u.push(F):a!==null&&(u[a]=F)}return h(t,{onObjectBegin:()=>{const F={};f(F),p.push(u),u=F,a=null},onObjectProperty:F=>{a=F},onObjectEnd:()=>{u=p.pop()},onArrayBegin:()=>{const F=[];f(F),p.push(u),u=F,a=null},onArrayEnd:()=>{u=p.pop()},onLiteralValue:f,onError:(F,_,C)=>{s.push({error:F,offset:_,length:C})}},r),u[0]}e.parse=k;function y(t,s=[],r=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(F){a.type==="property"&&(a.length=F-a.offset,a=a.parent)}function p(F){return a.children.push(F),F}h(t,{onObjectBegin:F=>{a=p({type:"object",offset:F,length:-1,parent:a,children:[]})},onObjectProperty:(F,_,C)=>{a=p({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:F,offset:_,length:C,parent:a})},onObjectEnd:(F,_)=>{a.length=F+_-a.offset,a=a.parent,u(F+_)},onArrayBegin:(F,_)=>{a=p({type:"array",offset:F,length:-1,parent:a,children:[]})},onArrayEnd:(F,_)=>{a.length=F+_-a.offset,a=a.parent,u(F+_)},onLiteralValue:(F,_,C)=>{p({type:l(F),offset:_,length:C,parent:a,value:F}),u(_+C)},onSeparator:(F,_,C)=>{a.type==="property"&&(F===":"?a.colonOffset=_:F===","&&u(_))},onError:(F,_,C)=>{s.push({error:F,offset:_,length:C})}},r);const L=a.children[0];return L&&delete L.parent,L}e.parseTree=y;function d(t,s){if(!t)return;let r=t;for(let a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===a){r=p.children[1],u=!0;break}if(!u)return}else{const u=a;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=d;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=m;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const s=Object.create(null);for(let r of t.children){const a=r.children[1];a&&(s[r.children[0].value]=P(a))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=I;function c(t,s,r=!1){if(I(t,s,r)){const a=t.children;if(Array.isArray(a))for(let u=0;u<a.length&&a[u].offset<=s;u++){const p=c(a[u],s,r);if(p)return p}return t}}e.findNodeAtOffset=c;function h(t,s,r=S.DEFAULT){const a=E(t,!1);function u(N){return N?()=>N(a.getTokenOffset(),a.getTokenLength()):()=>!0}function p(N){return N?z=>N(z,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=u(s.onObjectBegin),L=p(s.onObjectProperty),F=u(s.onObjectEnd),_=u(s.onArrayBegin),C=u(s.onArrayEnd),K=p(s.onLiteralValue),ee=p(s.onSeparator),V=u(s.onComment),x=p(s.onError),Q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function $(){for(;;){const N=a.scan();switch(a.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:Q||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(N){case 12:case 13:Q?H(10):V();break;case 16:H(1);break;case 15:case 14:break;default:return N}}}function H(N,z=[],Y=[]){if(x(N),z.length+Y.length>0){let G=a.getToken();for(;G!==17;){if(z.indexOf(G)!==-1){$();break}else if(Y.indexOf(G)!==-1)break;G=$()}}}function B(N){const z=a.getTokenValue();return N?K(z):L(z),$(),!0}function T(){switch(a.getToken()){case 11:let N=0;try{N=JSON.parse(a.getTokenValue()),typeof N!="number"&&(H(2),N=0)}catch(z){H(2)}K(N);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return $(),!0}function R(){return a.getToken()!==10?(H(3,[],[2,5]),!1):(B(!1),a.getToken()===6?(ee(":"),$(),A()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function O(){f(),$();let N=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(N||H(4,[],[]),ee(","),$(),a.getToken()===2&&U)break}else N&&H(6,[],[]);R()||H(4,[],[2,5]),N=!0}return F(),a.getToken()!==2?H(7,[2],[]):$(),!0}function W(){_(),$();let N=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(N||H(4,[],[]),ee(","),$(),a.getToken()===4&&U)break}else N&&H(6,[],[]);A()||H(4,[],[4,5]),N=!0}return C(),a.getToken()!==4?H(8,[4],[]):$(),!0}function A(){switch(a.getToken()){case 3:return W();case 1:return O();case 10:return B(!0);default:return T()}}return $(),a.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):A()?(a.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function o(t,s){let r=E(t),a=[],u,p=0,f;do switch(f=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:p!==f&&a.push(t.substring(p,f)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),p=r.getPosition();break}while(u!==17);return a.join("")}e.stripComments=o;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(J[104],Z([0,1,40]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function M(w,v,i){let b,k,y,d,m;if(v){for(d=v.offset,m=d+v.length,y=d;y>0&&!n(w,y-1);)y--;let p=m;for(;p<w.length&&!n(w,p);)p++;k=w.substring(y,p),b=S(k,i)}else k=w,b=0,y=0,d=0,m=w.length;const P=E(i,w);let I=!1,c=0,h;i.insertSpaces?h=D(" ",i.tabSize||4):h="	";const o=g.createScanner(k,!1);let l=!1;function t(){return P+D(h,b+c)}function s(){let p=o.scan();for(I=!1;p===15||p===14;)I=I||p===14,p=o.scan();return l=p===16||o.getTokenError()!==0,p}const r=[];function a(p,f,L){!l&&f<m&&L>d&&w.substring(f,L)!==p&&r.push({offset:f,length:L-f,content:p})}let u=s();if(u!==17){const p=o.getTokenOffset()+y,f=D(h,b);a(f,y,p)}for(;u!==17;){let p=o.getTokenOffset()+o.getTokenLength()+y,f=s(),L="";for(;!I&&(f===12||f===13);){const _=o.getTokenOffset()+y;a(" ",p,_),p=o.getTokenOffset()+o.getTokenLength()+y,L=f===12?t():"",f=s()}if(f===2)u!==1&&(c--,L=t());else if(f===4)u!==3&&(c--,L=t());else{switch(u){case 3:case 1:c++,L=t();break;case 5:case 12:L=t();break;case 13:I?L=t():L=" ";break;case 6:L=" ";break;case 10:if(f===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?L=" ":f!==5&&f!==17&&(l=!0);break;case 16:l=!0;break}I&&(f===12||f===13)&&(L=t())}const F=o.getTokenOffset()+y;a(L,p,F),u=f}return r}e.format=M;function D(w,v){let i="";for(let b=0;b<v;b++)i+=w;return i}function S(w,v){let i=0,b=0;const k=v.tabSize||4;for(;i<w.length;){const y=w.charAt(i);if(y===" ")b++;else if(y==="	")b+=k;else break;i++}return Math.floor(b/k)}function E(w,v){for(let i=0;i<v.length;i++){const b=v.charAt(i);if(b==="\r")return i+1<v.length&&v.charAt(i+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function n(w,v){return`\r
`.indexOf(w.charAt(v))!==-1}e.isEOL=n}),define(J[78],Z([0,1,40,104]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(v,i,b){return S(v,i,void 0,b)}e.removeProperty=D;function S(v,i,b,k,y){const d=i.slice(),m=[],P=g.parseTree(v,m);let I,c;for(;d.length>0&&(c=d.pop(),I=g.findNodeAtLocation(P,d),I===void 0&&b!==void 0);)typeof c=="string"?b={[c]:b}:b=[b];if(I)if(I.type==="object"&&typeof c=="string"&&Array.isArray(I.children)){const h=g.findNodeAtLocation(I,[c]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const o=I.children.indexOf(h.parent);let l,t=h.parent.offset+h.parent.length;if(o>0){const s=I.children[o-1];l=s.offset+s.length}else l=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return E(v,{offset:l,length:t-l,content:""},k)}else return E(v,{offset:h.offset,length:h.length,content:JSON.stringify(b)},k);else{if(b===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(b)}`,l=y?y(I.children.map(s=>s.children[0].value)):I.children.length;let t;if(l>0){const s=I.children[l-1];t={offset:s.offset+s.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return E(v,t,k)}}else if(I.type==="array"&&typeof c=="number"&&Array.isArray(I.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let o;if(I.children.length===0||c===0)o={offset:I.offset+1,length:0,content:I.children.length===0?h:h+","};else{const l=c===-1||c>I.children.length?I.children.length:c,t=I.children[l-1];o={offset:t.offset+t.length,length:0,content:","+h}}return E(v,o,k)}else{const h=c,o=I.children[h];let l;if(I.children.length===1)l={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===h){const t=I.children[h-1],s=t.offset+t.length,r=I.offset+I.length;l={offset:s,length:r-2-s,content:""}}else l={offset:o.offset,length:I.children[h+1].offset-o.offset,content:""};return E(v,l,k)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${I.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return E(v,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(b)},k)}}e.setProperty=S;function E(v,i,b){let k=n(v,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!M.isEOL(k,y-1);)y--;for(;d<k.length&&!M.isEOL(k,d);)d++}const m=M.format(k,{offset:y,length:d-y},b);for(let I=m.length-1;I>=0;I--){const c=m[I];k=n(k,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const P=v.length-(k.length-d)-y;return[{offset:y,length:P,content:k.substring(y,d)}]}e.withFormatting=E;function n(v,i){return v.substring(0,i.offset)+i.content+v.substring(i.offset+i.length)}e.applyEdit=n;function w(v,i){let b=i.slice(0).sort((y,d)=>{const m=y.offset-d.offset;return m===0?y.length-d.length:m}),k=v.length;for(let y=b.length-1;y>=0;y--){let d=b[y];if(d.offset+d.length<=k)v=n(v,d);else throw new Error("Overlapping edit");k=d.offset}return v}e.applyEdits=w}),define(J[57],Z([0,1,16]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var M;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(M=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const S=new D,E=new D,n=new D;(function(){function c(h,o,l=o,t=l){S.define(h,o),E.define(h,l),n.define(h,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var w;(function(c){function h(r){return S.keyCodeToStr(r)}c.toString=h;function o(r){return S.strToKeyCode(r)}c.fromString=o;function l(r){return E.keyCodeToStr(r)}c.toUserSettingsUS=l;function t(r){return n.keyCodeToStr(r)}c.toUserSettingsGeneral=t;function s(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}c.fromUserSettings=s})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var v;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(v||(v={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function b(c,h){const o=(h&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=b;function k(c,h){if(c===0)return null;const o=(c&65535)>>>0,l=(c&4294901760)>>>16;return l!==0?new m([y(o,h),y(l,h)]):new m([y(o,h)])}e.createKeybinding=k;function y(c,h){const o=!!(c&2048),l=!!(c&256),t=h===2?l:o,s=!!(c&1024),r=!!(c&512),a=h===2?o:l,u=c&255;return new d(t,s,r,a,u)}e.createSimpleKeybinding=y;class d{constructor(h,o,l,t,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyCode=s}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",l=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${o}${l}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(h){if(h.length===0)throw g.illegalArgument("parts");this.parts=h}getHashCode(){let h="";for(let o=0,l=this.parts.length;o<l;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class P{constructor(h,o,l,t,s,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=l,this.metaKey=t,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(J[2],Z([0,1,43,63]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let S=null;function E(o){S=o}if(e.setDisposableTracker=E,D){const o="__is_disposable_tracked__";S=new class{trackDisposable(l){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(t)},3e3)}markTracked(l){if(l&&l!==m.None)try{l[o]=!0}catch{}}}}function n(o){!S||S.markTracked(o)}function w(o){return S&&S.trackDisposable(o),o}e.trackDisposable=w;class v extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=v;function i(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=i;function b(o){if(M.Iterable.is(o)){let l=[];for(const t of o)if(t){n(t);try{t.dispose()}catch(s){l.push(s)}}if(l.length===1)throw l[0];if(l.length>1)throw new v(l);return Array.isArray(o)?[]:o}else if(o)return n(o),o.dispose(),o}e.dispose=b;function k(...o){return o.forEach(n),y(()=>b(o))}e.combinedDisposable=k;function y(o){const l=w({dispose:()=>{n(l),o()}});return l}e.toDisposable=y;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{b(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,w(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,n(this),this._value?.dispose(),this._value=void 0}}e.MutableDisposable=P;class I{constructor(){this.references=new Map}acquire(l,...t){let s=this.references.get(l);s||(s={counter:0,object:this.createReferencedObject(l,...t)},this.references.set(l,s));const{object:r}=s,a=g.once(()=>{--s.counter==0&&(this.destroyReferencedObject(l,s.object),this.references.delete(l))});return s.counter++,{object:r,dispose:a}}}e.ReferenceCollection=I;class c{constructor(l){this.referenceCollection=l}async acquire(l,...t){const s=this.referenceCollection.acquire(l,...t);try{return{object:await s.object,dispose:()=>s.dispose()}}catch(r){throw s.dispose(),r}}}e.AsyncReferenceCollection=c;class h{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=h}),define(J[105],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class M{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const E=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=E}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new g(S);if(this._first===g.Undefined)this._first=n,this._last=n;else if(E){const v=this._last;this._last=n,n.prev=v,v.next=n}else{const v=this._first;this._first=n,n.next=v,v.prev=n}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(n))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=M}),function(){function q(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function E(w){S.push(w,Date.now())}function n(){const w=[];for(let v=0;v<S.length;v+=2)w.push({name:S[v],startTime:S[v+1]});return w}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(D+E.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=g(M))}(),define(J[3],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let M=!1,D=!1,S=!1,E=!1,n=!1,w=!1,v=!1,i,b=g,k,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=m&&d?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!m)y=navigator.userAgent,M=y.indexOf("Windows")>=0,D=y.indexOf("Macintosh")>=0,v=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=y.indexOf("Linux")>=0,w=!0,i=navigator.language,b=i;else if(typeof d=="object"){M=d.platform==="win32",D=d.platform==="darwin",S=d.platform==="linux",E=S&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=g,b=g;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),u=a.availableLanguages["*"];i=a.locale,b=u||g,k=a._translationsConfigFile}catch(a){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let c=0;D?c=1:M?c=3:S&&(c=2),e.isWindows=M,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=E,e.isNative=n,e.isWeb=w,e.isIOS=v,e.platform=c,e.userAgent=y,e.language=b;var h;(function(r){function a(){return e.language}r.value=a;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=u;function p(){return e.language==="en"}r.isDefault=p})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=k,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let L=0,F=u.length;L<F;L++){const _=u[L];if(_.id===f.data.vscodeSetImmediateId){u.splice(L,1),_.callback();return}}});let p=0;return f=>{const L=++p;u.push({id:L,callback:f}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const a=Promise.resolve();return u=>a.then(u)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||v?2:M?1:3;let l=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let M;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;M={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return g.setImmediate(S)}}}else typeof process!="undefined"?M={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:M={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(D){return g.setImmediate(D)},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.nextTick=M.nextTick}),define(J[8],Z([0,1,33]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,D=97,S=90,E=122,n=46,w=47,v=92,i=58,b=63;class k extends Error{constructor(o,l,t){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${s} of type ${l}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,o){if(typeof h!="string")throw new k(o,"string",h)}function d(h){return h===w||h===v}function m(h){return h===w}function P(h){return h>=M&&h<=S||h>=D&&h<=E}function I(h,o,l,t){let s="",r=0,a=-1,u=0,p=0;for(let f=0;f<=h.length;++f){if(f<h.length)p=h.charCodeAt(f);else{if(t(p))break;p=w}if(t(p)){if(!(a===f-1||u===1))if(u===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const L=s.lastIndexOf(l);L===-1?(s="",r=0):(s=s.slice(0,L),r=s.length-1-s.lastIndexOf(l)),a=f,u=0;continue}else if(s.length!==0){s="",r=0,a=f,u=0;continue}}o&&(s+=s.length>0?`${l}..`:"..",r=2)}else s.length>0?s+=`${l}${h.slice(a+1,f)}`:s=h.slice(a+1,f),r=f-a-1;a=f,u=0}else p===n&&u!==-1?++u:u=-1}return s}function c(h,o){if(o===null||typeof o!="object")throw new k("pathObject","Object",o);const l=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return l?l===o.root?`${l}${t}`:`${l}${h}${t}`:t}e.win32={resolve(...h){let o="",l="",t=!1;for(let s=h.length-1;s>=-1;s--){let r;if(s>=0){if(r=h[s],y(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===v)&&(r=`${o}\\`));const a=r.length;let u=0,p="",f=!1;const L=r.charCodeAt(0);if(a===1)d(L)&&(u=1,f=!0);else if(d(L))if(f=!0,d(r.charCodeAt(1))){let F=2,_=F;for(;F<a&&!d(r.charCodeAt(F));)F++;if(F<a&&F!==_){const C=r.slice(_,F);for(_=F;F<a&&d(r.charCodeAt(F));)F++;if(F<a&&F!==_){for(_=F;F<a&&!d(r.charCodeAt(F));)F++;(F===a||F!==_)&&(p=`\\\\${C}\\${r.slice(_,F)}`,u=F)}}}else u=1;else P(L)&&r.charCodeAt(1)===i&&(p=r.slice(0,2),u=2,a>2&&d(r.charCodeAt(2))&&(f=!0,u=3));if(p.length>0)if(o.length>0){if(p.toLowerCase()!==o.toLowerCase())continue}else o=p;if(t){if(o.length>0)break}else if(l=`${r.slice(u)}\\${l}`,t=f,f&&o.length>0)break}return l=I(l,!t,"\\",d),t?`${o}\\${l}`:`${o}${l}`||"."},normalize(h){y(h,"path");const o=h.length;if(o===0)return".";let l=0,t,s=!1;const r=h.charCodeAt(0);if(o===1)return m(r)?"\\":h;if(d(r))if(s=!0,d(h.charCodeAt(1))){let u=2,p=u;for(;u<o&&!d(h.charCodeAt(u));)u++;if(u<o&&u!==p){const f=h.slice(p,u);for(p=u;u<o&&d(h.charCodeAt(u));)u++;if(u<o&&u!==p){for(p=u;u<o&&!d(h.charCodeAt(u));)u++;if(u===o)return`\\\\${f}\\${h.slice(p)}\\`;u!==p&&(t=`\\\\${f}\\${h.slice(p,u)}`,l=u)}}}else l=1;else P(r)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),l=2,o>2&&d(h.charCodeAt(2))&&(s=!0,l=3));let a=l<o?I(h.slice(l),!s,"\\",d):"";return a.length===0&&!s&&(a="."),a.length>0&&d(h.charCodeAt(o-1))&&(a+="\\"),t===void 0?s?`\\${a}`:a:s?`${t}\\${a}`:`${t}${a}`},isAbsolute(h){y(h,"path");const o=h.length;if(o===0)return!1;const l=h.charCodeAt(0);return d(l)||o>2&&P(l)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,l;for(let r=0;r<h.length;++r){const a=h[r];y(a,"path"),a.length>0&&(o===void 0?o=l=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++s;const r=l.length;r>1&&d(l.charCodeAt(1))&&(++s,r>2&&(d(l.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&d(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o)return"";const l=e.win32.resolve(h),t=e.win32.resolve(o);if(l===t||(h=l.toLowerCase(),o=t.toLowerCase(),h===o))return"";let s=0;for(;s<h.length&&h.charCodeAt(s)===v;)s++;let r=h.length;for(;r-1>s&&h.charCodeAt(r-1)===v;)r--;const a=r-s;let u=0;for(;u<o.length&&o.charCodeAt(u)===v;)u++;let p=o.length;for(;p-1>u&&o.charCodeAt(p-1)===v;)p--;const f=p-u,L=a<f?a:f;let F=-1,_=0;for(;_<L;_++){const K=h.charCodeAt(s+_);if(K!==o.charCodeAt(u+_))break;K===v&&(F=_)}if(_!==L){if(F===-1)return t}else{if(f>L){if(o.charCodeAt(u+_)===v)return t.slice(u+_+1);if(_===2)return t.slice(u+_)}a>L&&(h.charCodeAt(s+_)===v?F=_:_===2&&(F=3)),F===-1&&(F=0)}let C="";for(_=s+F+1;_<=r;++_)(_===r||h.charCodeAt(_)===v)&&(C+=C.length===0?"..":"\\..");return u+=F,C.length>0?`${C}${t.slice(u,p)}`:(t.charCodeAt(u)===v&&++u,t.slice(u,p))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===v){if(o.charCodeAt(1)===v){const l=o.charCodeAt(2);if(l!==b&&l!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===v)return`\\\\?\\${o}`;return h},dirname(h){y(h,"path");const o=h.length;if(o===0)return".";let l=-1,t=0;const s=h.charCodeAt(0);if(o===1)return d(s)?h:".";if(d(s)){if(l=t=1,d(h.charCodeAt(1))){let u=2,p=u;for(;u<o&&!d(h.charCodeAt(u));)u++;if(u<o&&u!==p){for(p=u;u<o&&d(h.charCodeAt(u));)u++;if(u<o&&u!==p){for(p=u;u<o&&!d(h.charCodeAt(u));)u++;if(u===o)return h;u!==p&&(l=t=u+1)}}}}else P(s)&&h.charCodeAt(1)===i&&(l=o>2&&d(h.charCodeAt(2))?3:2,t=l);let r=-1,a=!0;for(let u=o-1;u>=t;--u)if(d(h.charCodeAt(u))){if(!a){r=u;break}}else a=!1;if(r===-1){if(l===-1)return".";r=l}return h.slice(0,r)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let l=0,t=-1,s=!0,r;if(h.length>=2&&P(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(l=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,u=-1;for(r=h.length-1;r>=l;--r){const p=h.charCodeAt(r);if(d(p)){if(!s){l=r+1;break}}else u===-1&&(s=!1,u=r+1),a>=0&&(p===o.charCodeAt(a)?--a==-1&&(t=r):(a=-1,t=u))}return l===t?t=u:t===-1&&(t=h.length),h.slice(l,t)}for(r=h.length-1;r>=l;--r)if(d(h.charCodeAt(r))){if(!s){l=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(l,t)},extname(h){y(h,"path");let o=0,l=-1,t=0,s=-1,r=!0,a=0;h.length>=2&&h.charCodeAt(1)===i&&P(h.charCodeAt(0))&&(o=t=2);for(let u=h.length-1;u>=o;--u){const p=h.charCodeAt(u);if(d(p)){if(!r){t=u+1;break}continue}s===-1&&(r=!1,s=u+1),p===n?l===-1?l=u:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||s===-1||a===0||a===1&&l===s-1&&l===t+1?"":h.slice(l,s)},format:c.bind(null,"\\"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const l=h.length;let t=0,s=h.charCodeAt(0);if(l===1)return d(s)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(s)){if(t=1,d(h.charCodeAt(1))){let F=2,_=F;for(;F<l&&!d(h.charCodeAt(F));)F++;if(F<l&&F!==_){for(_=F;F<l&&d(h.charCodeAt(F));)F++;if(F<l&&F!==_){for(_=F;F<l&&!d(h.charCodeAt(F));)F++;F===l?t=F:F!==_&&(t=F+1)}}}}else if(P(s)&&h.charCodeAt(1)===i){if(l<=2)return o.root=o.dir=h,o;if(t=2,d(h.charCodeAt(2))){if(l===3)return o.root=o.dir=h,o;t=3}}t>0&&(o.root=h.slice(0,t));let r=-1,a=t,u=-1,p=!0,f=h.length-1,L=0;for(;f>=t;--f){if(s=h.charCodeAt(f),d(s)){if(!p){a=f+1;break}continue}u===-1&&(p=!1,u=f+1),s===n?r===-1?r=f:L!==1&&(L=1):r!==-1&&(L=-1)}return u!==-1&&(r===-1||L===0||L===1&&r===u-1&&r===a+1?o.base=o.name=h.slice(a,u):(o.name=h.slice(a,r),o.base=h.slice(a,u),o.ext=h.slice(r,u))),a>0&&a!==t?o.dir=h.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",l=!1;for(let t=h.length-1;t>=-1&&!l;t--){const s=t>=0?h[t]:g.cwd();y(s,"path"),s.length!==0&&(o=`${s}/${o}`,l=s.charCodeAt(0)===w)}return o=I(o,!l,"/",m),l?`/${o}`:o.length>0?o:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===w,l=h.charCodeAt(h.length-1)===w;return h=I(h,!o,"/",m),h.length===0?o?"/":l?"./":".":(l&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===w},join(...h){if(h.length===0)return".";let o;for(let l=0;l<h.length;++l){const t=h[l];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const l=1,t=h.length,s=t-l,r=1,a=o.length-r,u=s<a?s:a;let p=-1,f=0;for(;f<u;f++){const F=h.charCodeAt(l+f);if(F!==o.charCodeAt(r+f))break;F===w&&(p=f)}if(f===u)if(a>u){if(o.charCodeAt(r+f)===w)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else s>u&&(h.charCodeAt(l+f)===w?p=f:f===0&&(p=0));let L="";for(f=l+p+1;f<=t;++f)(f===t||h.charCodeAt(f)===w)&&(L+=L.length===0?"..":"/..");return`${L}${o.slice(r+p)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===w;let l=-1,t=!0;for(let s=h.length-1;s>=1;--s)if(h.charCodeAt(s)===w){if(!t){l=s;break}}else t=!1;return l===-1?o?"/":".":o&&l===1?"//":h.slice(0,l)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let l=0,t=-1,s=!0,r;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,u=-1;for(r=h.length-1;r>=0;--r){const p=h.charCodeAt(r);if(p===w){if(!s){l=r+1;break}}else u===-1&&(s=!1,u=r+1),a>=0&&(p===o.charCodeAt(a)?--a==-1&&(t=r):(a=-1,t=u))}return l===t?t=u:t===-1&&(t=h.length),h.slice(l,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===w){if(!s){l=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(l,t)},extname(h){y(h,"path");let o=-1,l=0,t=-1,s=!0,r=0;for(let a=h.length-1;a>=0;--a){const u=h.charCodeAt(a);if(u===w){if(!s){l=a+1;break}continue}t===-1&&(s=!1,t=a+1),u===n?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===l+1?"":h.slice(o,t)},format:c.bind(null,"/"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const l=h.charCodeAt(0)===w;let t;l?(o.root="/",t=1):t=0;let s=-1,r=0,a=-1,u=!0,p=h.length-1,f=0;for(;p>=t;--p){const L=h.charCodeAt(p);if(L===w){if(!u){r=p+1;break}continue}a===-1&&(u=!1,a=p+1),L===n?s===-1?s=p:f!==1&&(f=1):s!==-1&&(f=-1)}if(a!==-1){const L=r===0&&l?1:r;s===-1||f===0||f===1&&s===a-1&&s===r+1?o.base=o.name=h.slice(L,a):(o.name=h.slice(L,s),o.base=h.slice(L,a),o.ext=h.slice(s,a))}return r>0?o.dir=h.slice(0,r-1):l&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[106],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var M;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(M=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...E){const n=E.reduce((i,b)=>(i[b]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let b=0;b<w.length;b++)if(i.search(w[b])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(J[79],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var g;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(g=e.ScanCode||(e.ScanCode={}));const M=[],D=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>D[n]||0,toString:n=>M[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(w,v,i,b,k){this.ctrlKey=w,this.shiftKey=v,this.altKey=i,this.metaKey=b,this.scanCode=k}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(w,v){M[w]=v,D[v]=w,S[v.toLowerCase()]=w}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function n(w,v){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=v,v!==0&&v!==3&&v!==5&&v!==4&&v!==6&&v!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[v]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[107],Z([0,1,57,79]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,w=!1,v=!1,i=!1,b;do b=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(E)&&(w=!0,E=E.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(E)&&(v=!0,E=E.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),b=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),b=!0);while(b);let k;const y=E.indexOf(" ");return y>0?(k=E.substring(0,y),E=E.substring(y)):(k=E,E=""),{remains:E,ctrl:n,shift:w,alt:v,meta:i,key:k}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),w=g.KeyCodeUtils.fromUserSettings(n.key);return[new g.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseKeybinding(E,n){if(!E)return null;const w=[];let v;do[v,E]=this.parseSimpleKeybinding(E),w.push(v);while(E.length>0);return new g.ChordKeybinding(w)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),w=n.key.match(/^\[([^\]]+)\]$/);if(w){const i=w[1],b=M.ScanCodeUtils.lowerCaseToEnum(i);return[new M.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,b),n.remains]}const v=g.KeyCodeUtils.fromUserSettings(n.key);return[new g.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,v),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let w;for(;E.length>0;)[w,E]=this.parseSimpleUserBinding(E),n.push(w);return n}}e.KeybindingParser=D}),define(J[108],Z([0,1,3]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(E){this._highResolution=M&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new D(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(J[5],Z([0,1,16,43,2,105,108]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(h){h.None=()=>D.Disposable.None;function o(Q){return(U,$=null,H)=>{let B=!1,T;return T=Q(R=>{if(!B)return T?T.dispose():B=!0,U.call($,R)},null,H),B&&T.dispose(),T}}h.once=o;function l(Q,U){return p(($,H=null,B)=>Q(T=>$.call(H,U(T)),null,B))}h.map=l;function t(Q,U){return p(($,H=null,B)=>Q(T=>{U(T),$.call(H,T)},null,B))}h.forEach=t;function s(Q,U){return p(($,H=null,B)=>Q(T=>U(T)&&$.call(H,T),null,B))}h.filter=s;function r(Q){return Q}h.signal=r;function a(...Q){return(U,$=null,H)=>D.combinedDisposable(...Q.map(B=>B(T=>U.call($,T),null,H)))}h.any=a;function u(Q,U,$){let H=$;return l(Q,B=>(H=U(H,B),H))}h.reduce=u;function p(Q){let U;const $=new k({onFirstListenerAdd(){U=Q($.fire,$)},onLastListenerRemove(){U.dispose()}});return $.event}function f(Q,U,$=100,H=!1,B){let T,R,O,W=0;const A=new k({leakWarningThreshold:B,onFirstListenerAdd(){T=Q(N=>{W++,R=U(R,N),H&&!O&&(A.fire(R),R=void 0),clearTimeout(O),O=setTimeout(()=>{const z=R;R=void 0,O=void 0,(!H||W>1)&&A.fire(z),W=0},$)})},onLastListenerRemove(){T.dispose()}});return A.event}h.debounce=f;function L(Q,U=($,H)=>$===H){let $=!0,H;return s(Q,B=>{const T=$||!U(B,H);return $=!1,H=B,T})}h.latch=L;function F(Q,U){return[h.filter(Q,U),h.filter(Q,$=>!U($))]}h.split=F;function _(Q,U=!1,$=[]){let H=$.slice(),B=Q(O=>{H?H.push(O):R.fire(O)});const T=()=>{H&&H.forEach(O=>R.fire(O)),H=null},R=new k({onFirstListenerAdd(){B||(B=Q(O=>R.fire(O)))},onFirstListenerDidAdd(){H&&(U?setTimeout(T):T())},onLastListenerRemove(){B&&B.dispose(),B=null}});return R.event}h.buffer=_;class C{constructor(U){this.event=U}map(U){return new C(l(this.event,U))}forEach(U){return new C(t(this.event,U))}filter(U){return new C(s(this.event,U))}reduce(U,$){return new C(u(this.event,U,$))}latch(){return new C(L(this.event))}debounce(U,$=100,H=!1,B){return new C(f(this.event,U,$,H,B))}on(U,$,H){return this.event(U,$,H)}once(U,$,H){return o(this.event)(U,$,H)}}function K(Q){return new C(Q)}h.chain=K;function ee(Q,U,$=H=>H){const H=(...O)=>R.fire($(...O)),B=()=>Q.on(U,H),T=()=>Q.removeListener(U,H),R=new k({onFirstListenerAdd:B,onLastListenerRemove:T});return R.event}h.fromNodeEventEmitter=ee;function V(Q,U,$=H=>H){const H=(...O)=>R.fire($(...O)),B=()=>Q.addEventListener(U,H),T=()=>Q.removeEventListener(U,H),R=new k({onFirstListenerAdd:B,onLastListenerRemove:T});return R.event}h.fromDOMEventEmitter=V;function x(Q){return new Promise(U=>o(Q)(U))}h.toPromise=x})(n=e.Event||(e.Event={}));class w{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${w._idPool++}`}start(o){this._stopWatch=new E.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let v=-1;function i(h){const o=v;return v=h,{dispose(){v=o}}}e.setGlobalLeakWarningThreshold=i;class b{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let l=v;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||o<l)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let r,a=0;for(const[u,p]of this._stacks)(!r||a<p)&&(r=u,a=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class k{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=v>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(o,l,t)=>{this._listeners||(this._listeners=new S.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(l?[o,l]:o);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const a=this._leakageMon?.check(this._listeners.size);let u;return u={dispose:()=>{a&&a(),u.dispose=k._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},t instanceof D.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,t]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,t):l[0].call(l[1],t)}catch(s){g.onUnexpectedError(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=k,k._noop=function(){};class y extends k{async fireAsync(o,l,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,o]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],u={...r,waitUntil:p=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");t&&(p=t(p,typeof s=="function"?s:s[0])),a.push(p)}};try{typeof s=="function"?s.call(void 0,u):s[0].call(s[1],u)}catch(p){g.onUnexpectedError(p);continue}Object.freeze(a),await Promise.allSettled(a).then(p=>{for(const f of p)f.status==="rejected"&&g.onUnexpectedError(f.reason)})}}}}e.AsyncEmitter=y;class d extends k{constructor(o){super(o);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class m extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=m;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new k({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const t=()=>{this.hasListeners&&this.unhook(l);const s=this.events.indexOf(l);this.events.splice(s,1)};return D.toDisposable(M.once(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class I{constructor(){this.buffers=[]}wrapEvent(o){return(l,t,s)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>l.call(t,r)):l.call(t,r)},void 0,s)}bufferEvents(o){const l=[];this.buffers.push(l);const t=o();return this.buffers.pop(),l.forEach(s=>s()),t}}e.EventBufferer=I;class c{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new k({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(J[25],Z([0,1,5]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(n,w){const v=setTimeout(n.bind(w),0);return{dispose(){clearTimeout(v)}}});var D;(function(n){function w(v){return v===n.None||v===n.Cancelled||v instanceof S?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}n.isCancellationToken=w,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=E}),define(J[109],Z([0,1,5]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(b){const k=this._icons.get(b.id);k?b.description?k.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new M;e.iconRegistry=D;function S(i,b){return new n(i,b)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(b,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(b,k,y){this.id=b,this.definition=k,this.description=y,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function w(i,b){const k=["codicon","codicon-"+i];return b&&k.push("codicon-modifier-"+b),k}e.getClassNamesArray=w;var v;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(m){if(m instanceof n)return["codicon","codicon-"+m.id];const P=b.exec(m.id);if(!P)return k(n.error);let[,I,c]=P;const h=["codicon","codicon-"+I];return c&&h.push("codicon-modifier-"+c.substr(1)),h}i.asClassNameArray=k;function y(m){return k(m).join(" ")}i.asClassName=y;function d(m){return"."+k(m).join(".")}i.asCSSSelector=d})(v=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function S(h){const o=h;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(h,o){return new n(h,o)}e.newWriteableStream=E;class n{constructor(o,l){this.reducer=o,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(l=>l(o))}emitError(o){this.listeners.error.length===0?g.onUnexpectedError(o):this.listeners.error.slice(0).forEach(l=>l(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,l){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(o,l){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(l);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(h,o){const l=[];let t;for(;(t=h.read())!==null;)l.push(t);return o(l)}e.consumeReadable=w;function v(h,o,l){const t=[];let s;for(;(s=h.read())!==null&&t.length<l;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return h.read()}}}e.peekReadable=v;function i(h,o){return new Promise((l,t)=>{const s=[];b(h,{onData:r=>{o&&s.push(r)},onError:r=>{o?t(r):l(void 0)},onEnd:()=>{l(o?o(s):void 0)}})})}e.consumeStream=i;function b(h,o){h.on("error",l=>o.onError(l)),h.on("end",()=>o.onEnd()),h.on("data",l=>o.onData(l))}e.listenStream=b;function k(h,o){return new Promise((l,t)=>{const s=new M.DisposableStore,r=[],a=f=>{if(r.push(f),r.length>o)return s.dispose(),h.pause(),l({stream:h,buffer:r,ended:!1})},u=f=>t(f),p=()=>l({stream:h,buffer:r,ended:!0});s.add(M.toDisposable(()=>h.removeListener("error",u))),h.on("error",u),s.add(M.toDisposable(()=>h.removeListener("end",p))),h.on("end",p),s.add(M.toDisposable(()=>h.removeListener("data",a))),h.on("data",a)})}e.peekStream=k;function y(h,o){const l=E(o);return l.end(h),l}e.toStream=y;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function m(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=m;function P(h,o,l){const t=E(l);return b(h,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}e.transform=P;function I(h,o,l){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?l([h,s]):h)}}}e.prefixedReadable=I;function c(h,o,l){let t=!1;const s=E(l);return b(o,{onData:r=>t?s.write(r):(t=!0,s.write(l([h,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(h)),s.end()}}),s}e.prefixedStream=c}),define(J[23],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=g;const M=/{(\d+)}/g;function D(j,...ie){return ie.length===0?j:j.replace(M,function(oe,ae){const fe=parseInt(ae,10);return isNaN(fe)||fe<0||fe>=ie.length?oe:ie[fe]})}e.format=D;const S=/{([^}]+)}/g;function E(j,ie){return j.replace(S,(oe,ae)=>ie[ae]??oe)}e.format2=E;function n(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=n;function w(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function v(j,ie){let oe=0;const ae=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ae&&oe++;return oe}e.count=v;function i(j,ie,oe="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${oe}`}e.truncate=i;function b(j,ie=" "){const oe=k(j,ie);return y(oe,ie)}e.trim=b;function k(j,ie){if(!j||!ie)return j;const oe=ie.length;if(oe===0||j.length===0)return j;let ae=0;for(;j.indexOf(ie,ae)===ae;)ae=ae+oe;return j.substring(ae)}e.ltrim=k;function y(j,ie){if(!j||!ie)return j;const oe=ie.length,ae=j.length;if(oe===0||ae===0)return j;let fe=ae,Se=-1;for(;Se=j.lastIndexOf(ie,fe-1),!(Se===-1||Se+oe!==fe);){if(Se===0)return"";fe=Se}return j.substring(0,fe)}e.rtrim=y;function d(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(j){return j.replace(/\*/g,"")}e.stripWildcards=m;function P(j,ie,oe={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=w(j)),oe.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ae="";return oe.global&&(ae+="g"),oe.matchCase||(ae+="i"),oe.multiline&&(ae+="m"),oe.unicode&&(ae+="u"),new RegExp(j,ae)}e.createRegExp=P;function I(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function c(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=h;function o(j){return j.split(/\r\n|\r|\n/)}e.splitLines=o;function l(j){for(let ie=0,oe=j.length;ie<oe;ie++){const ae=j.charCodeAt(ie);if(ae!==32&&ae!==9)return ie}return-1}e.firstNonWhitespaceIndex=l;function t(j,ie=0,oe=j.length){for(let ae=ie;ae<oe;ae++){const fe=j.charCodeAt(ae);if(fe!==32&&fe!==9)return j.substring(ie,ae)}return j.substring(ie,oe)}e.getLeadingWhitespace=t;function s(j,ie=j.length-1){for(let oe=ie;oe>=0;oe--){const ae=j.charCodeAt(oe);if(ae!==32&&ae!==9)return oe}return-1}e.lastNonWhitespaceIndex=s;function r(j,ie){return j<ie?-1:j>ie?1:0}e.compare=r;function a(j,ie,oe=0,ae=j.length,fe=0,Se=ie.length){for(;oe<ae&&fe<Se;oe++,fe++){let ce=j.charCodeAt(oe),ge=ie.charCodeAt(fe);if(ce<ge)return-1;if(ce>ge)return 1}const Pe=ae-oe,Fe=Se-fe;return Pe<Fe?-1:Pe>Fe?1:0}e.compareSubstring=a;function u(j,ie){return p(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=u;function p(j,ie,oe=0,ae=j.length,fe=0,Se=ie.length){for(;oe<ae&&fe<Se;oe++,fe++){let ce=j.charCodeAt(oe),ge=ie.charCodeAt(fe);if(ce===ge)continue;const pe=ce-ge;if(!(pe===32&&L(ge))&&!(pe===-32&&L(ce)))return f(ce)&&f(ge)?pe:a(j.toLowerCase(),ie.toLowerCase(),oe,ae,fe,Se)}const Pe=ae-oe,Fe=Se-fe;return Pe<Fe?-1:Pe>Fe?1:0}e.compareSubstringIgnoreCase=p;function f(j){return j>=97&&j<=122}e.isLowerAsciiLetter=f;function L(j){return j>=65&&j<=90}e.isUpperAsciiLetter=L;function F(j){return f(j)||L(j)}function _(j,ie){return j.length===ie.length&&C(j,ie)}e.equalsIgnoreCase=_;function C(j,ie,oe=j.length){for(let ae=0;ae<oe;ae++){const fe=j.charCodeAt(ae),Se=ie.charCodeAt(ae);if(fe!==Se){if(F(fe)&&F(Se)){const Pe=Math.abs(fe-Se);if(Pe!==0&&Pe!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function K(j,ie){const oe=ie.length;return ie.length>j.length?!1:C(j,ie,oe)}e.startsWithIgnoreCase=K;function ee(j,ie){let oe,ae=Math.min(j.length,ie.length);for(oe=0;oe<ae;oe++)if(j.charCodeAt(oe)!==ie.charCodeAt(oe))return oe;return ae}e.commonPrefixLength=ee;function V(j,ie){let oe,ae=Math.min(j.length,ie.length);const fe=j.length-1,Se=ie.length-1;for(oe=0;oe<ae;oe++)if(j.charCodeAt(fe-oe)!==ie.charCodeAt(Se-oe))return oe;return ae}e.commonSuffixLength=V;function x(j){return 55296<=j&&j<=56319}e.isHighSurrogate=x;function Q(j){return 56320<=j&&j<=57343}e.isLowSurrogate=Q;function U(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=U;function $(j,ie,oe){const ae=j.charCodeAt(oe);if(x(ae)&&oe+1<ie){const fe=j.charCodeAt(oe+1);if(Q(fe))return U(ae,fe)}return ae}e.getNextCodePoint=$;function H(j,ie){const oe=j.charCodeAt(ie-1);if(Q(oe)&&ie>1){const ae=j.charCodeAt(ie-2);if(x(ae))return U(ae,oe)}return oe}function B(j,ie){const oe=Ne.getInstance(),ae=ie,fe=j.length,Se=$(j,fe,ie);ie+=Se>=65536?2:1;let Pe=oe.getGraphemeBreakType(Se);for(;ie<fe;){const Fe=$(j,fe,ie),ce=oe.getGraphemeBreakType(Fe);if($e(Pe,ce))break;ie+=Fe>=65536?2:1,Pe=ce}return ie-ae}e.nextCharLength=B;function T(j,ie){const oe=Ne.getInstance(),ae=ie,fe=H(j,ie);ie-=fe>=65536?2:1;let Se=oe.getGraphemeBreakType(fe);for(;ie>0;){const Pe=H(j,ie),Fe=oe.getGraphemeBreakType(Pe);if($e(Fe,Se))break;ie-=Pe>=65536?2:1,Se=Fe}return ae-ie}e.prevCharLength=T;function R(j,ie){const oe=Ne.getInstance(),ae=j.length,fe=ie,Se=$(j,ae,ie),Pe=oe.getGraphemeBreakType(Se);ie+=Se>=65536?2:1;let Fe=Pe;for(;ie<ae;){const ge=$(j,ae,ie),pe=oe.getGraphemeBreakType(ge);if($e(Fe,pe))break;ie+=ge>=65536?2:1,Fe=pe}const ce=ie;for(ie=fe,Fe=Pe;ie>0;){const ge=H(j,ie),pe=oe.getGraphemeBreakType(ge);if($e(pe,Fe))break;ie-=ge>=65536?2:1,Fe=pe}return[ie,ce]}function O(j,ie){return ie>0&&Q(j.charCodeAt(ie))?R(j,ie-1):R(j,ie)}e.getCharContainingOffset=O;function W(j){const ie=j.length;let oe=0,ae=0;for(;ae<ie;){const Pe=$(j,ie,ae);ae+=Pe>=65536?2:1,Pe<128?oe+=1:Pe<2048?oe+=2:Pe<65536?oe+=3:oe+=4}const fe=new Uint8Array(oe);ae=0;let Se=0;for(;ae<ie;){const Pe=$(j,ie,ae);ae+=Pe>=65536?2:1,Pe<128?fe[Se++]=Pe:Pe<2048?(fe[Se++]=192|(Pe&1984)>>>6,fe[Se++]=128|(Pe&63)>>>0):Pe<65536?(fe[Se++]=224|(Pe&61440)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0):(fe[Se++]=240|(Pe&1835008)>>>18,fe[Se++]=128|(Pe&258048)>>>12,fe[Se++]=128|(Pe&4032)>>>6,fe[Se++]=128|(Pe&63)>>>0)}return fe}e.encodeUTF8=W;function A(j){const ie=j.byteLength,oe=[];let ae=0;for(;ae<ie;){const fe=j[ae];let Se;if(fe>=240&&ae+3<ie?Se=(j[ae++]&7)<<18>>>0|(j[ae++]&63)<<12>>>0|(j[ae++]&63)<<6>>>0|(j[ae++]&63)<<0>>>0:fe>=224&&ae+2<ie?Se=(j[ae++]&15)<<12>>>0|(j[ae++]&63)<<6>>>0|(j[ae++]&63)<<0>>>0:fe>=192&&ae+1<ie?Se=(j[ae++]&31)<<6>>>0|(j[ae++]&63)<<0>>>0:Se=j[ae++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)oe.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Pe=Se-65536,Fe=55296+((Pe&1047552)>>>10),ce=56320+((Pe&1023)>>>0);oe.push(String.fromCharCode(Fe)),oe.push(String.fromCharCode(ce))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=A;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(j){return N.test(j)}e.containsRTL=z;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function G(j){return Y.test(j)}e.containsEmoji=G;const X=/^[\t\n\r\x20-\x7E]*$/;function ne(j){return X.test(j)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=se;function ue(j){for(let ie=0,oe=j.length;ie<oe;ie++)if(de(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ue;function de(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=de;function re(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=re;function le(j,ie){if(j.length<ie)return j;const oe=/\b/g;let ae=0;for(;oe.test(j)&&!(j.length-oe.lastIndex<ie);)ae=oe.lastIndex,oe.lastIndex+=1;return j.substring(ae).replace(/^\s/,"")}e.lcut=le;const Ee=/\x1B\x5B[12]?K/g,ve=/\x1b\[\d+m/g,be=/\x1b\[0?m/g;function Te(j){return j&&(j=j.replace(Ee,""),j=j.replace(ve,""),j=j.replace(be,"")),j}e.removeAnsiEscapeCodes=Te,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function we(j){return ye(j)?j.substr(1):j}e.stripUTF8BOM=we;function Ie(j,ie){if(!j||!ie||j.length<ie.length)return!1;const oe=ie.length,ae=j.toLowerCase();let fe=0,Se=-1;for(;fe<oe;){const Pe=ae.indexOf(ie[fe],Se+1);if(Pe<0)return!1;Se=Pe,fe++}return!0}e.fuzzyContains=Ie;function Le(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=Le;function Oe(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Oe;function Ue(j,ie=1){if(ie===0)return"";let oe=-1;do oe=j.indexOf(`
`,oe+1),ie--;while(ie>0&&oe>=0);return oe===-1?j:(j[oe-1]==="\r"&&oe--,j.substr(0,oe))}e.getNLines=Ue;function qe(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=qe;function Je(j){return Ne.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Je;function $e(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=$e;var it;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(it=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=lt()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const oe=this._data,ae=oe.length/3;let fe=1;for(;fe<=ae;)if(ie<oe[3*fe])fe=2*fe;else if(ie>oe[3*fe+1])fe=2*fe+1;else return oe[3*fe+2];return 0}}Ne._INSTANCE=null;function lt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(j,ie){if(j===0)return 0;const oe=ct(j,ie);if(oe!==void 0)return oe;const ae=H(ie,j);return j-=Ge(ae),j}e.getLeftDeleteOffset=Ze;function ct(j,ie){let oe=H(ie,j);for(j-=Ge(oe);nt(oe)||oe===65039||oe===8419;){if(j===0)return;oe=H(ie,j),j-=Ge(oe)}if(!!re(oe)){if(j>=0){const ae=H(ie,j);ae===8205&&(j-=Ge(ae))}return j}}function Ge(j){return j>=65536?2:1}function nt(j){return 127995<=j&&j<=127999}var rt;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={}))}),define(J[17],Z([0,1,23,64]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,w;class v{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return D?new v(Buffer.allocUnsafe(f)):new v(new Uint8Array(f))}static wrap(f){return D&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new v(f)}static fromString(f,L){return!(L?.dontUseNodeBuffer||!1)&&D?new v(Buffer.from(f)):S?(n||(n=new TextEncoder),new v(n.encode(f))):new v(g.encodeUTF8(f))}static concat(f,L){if(typeof L=="undefined"){L=0;for(let C=0,K=f.length;C<K;C++)L+=f[C].byteLength}const F=v.alloc(L);let _=0;for(let C=0,K=f.length;C<K;C++){const ee=f[C];F.set(ee,_),_+=ee.byteLength}return F}toString(){return D?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(f,L){return new v(this.buffer.subarray(f,L))}set(f,L){f instanceof v?this.buffer.set(f.buffer,L):this.buffer.set(f,L)}readUInt32BE(f){return k(this.buffer,f)}writeUInt32BE(f,L){y(this.buffer,f,L)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,L){m(this.buffer,f,L)}readUInt8(f){return P(this.buffer,f)}writeUInt8(f,L){I(this.buffer,f,L)}}e.VSBuffer=v;function i(p,f){return p[f+0]<<0>>>0|p[f+1]<<8>>>0}e.readUInt16LE=i;function b(p,f,L){p[L+0]=f&255,f=f>>>8,p[L+1]=f&255}e.writeUInt16LE=b;function k(p,f){return p[f]*2**24+p[f+1]*2**16+p[f+2]*2**8+p[f+3]}e.readUInt32BE=k;function y(p,f,L){p[L+3]=f,f=f>>>8,p[L+2]=f,f=f>>>8,p[L+1]=f,f=f>>>8,p[L]=f}e.writeUInt32BE=y;function d(p,f){return p[f+0]<<0>>>0|p[f+1]<<8>>>0|p[f+2]<<16>>>0|p[f+3]<<24>>>0}e.readUInt32LE=d;function m(p,f,L){p[L+0]=f&255,f=f>>>8,p[L+1]=f&255,f=f>>>8,p[L+2]=f&255,f=f>>>8,p[L+3]=f&255}e.writeUInt32LE=m;function P(p,f){return p[f]}e.readUInt8=P;function I(p,f,L){p[L]=f}e.writeUInt8=I;function c(p){return M.consumeReadable(p,f=>v.concat(f))}e.readableToBuffer=c;function h(p){return M.toReadable(p)}e.bufferToReadable=h;function o(p){return M.consumeStream(p,f=>v.concat(f))}e.streamToBuffer=o;async function l(p){return p.ended?v.concat(p.buffer):v.concat([...p.buffer,await o(p.stream)])}e.bufferedStreamToBuffer=l;function t(p){return M.toStream(p,f=>v.concat(f))}e.bufferToStream=t;function s(p){return M.transform(p,{data:f=>typeof f=="string"?v.fromString(f):v.wrap(f)},f=>v.concat(f))}e.streamToBufferReadableStream=s;function r(p){return M.newWriteableStream(f=>v.concat(f),p)}e.newWriteableBufferStream=r;function a(p,f){return M.prefixedReadable(p,f,L=>v.concat(L))}e.prefixedBufferReadable=a;function u(p,f){return M.prefixedStream(p,f,L=>v.concat(L))}e.prefixedBufferStream=u}),define(J[80],Z([0,1,23]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function M(I){return D(I,0)}e.hash=M;function D(I,c){switch(typeof I){case"object":return I===null?S(349,c):Array.isArray(I)?w(I,c):v(I,c);case"string":return n(I,c);case"boolean":return E(I,c);case"number":return S(I,c);case"undefined":return S(937,c);default:return S(617,c)}}e.doHash=D;function S(I,c){return(c<<5)-c+I|0}function E(I,c){return S(I?433:863,c)}function n(I,c){c=S(149417,c);for(let h=0,o=I.length;h<o;h++)c=S(I.charCodeAt(h),c);return c}e.stringHash=n;function w(I,c){return c=S(104579,c),I.reduce((h,o)=>D(o,h),c)}function v(I,c){return c=S(181387,c),Object.keys(I).sort().reduce((h,o)=>(h=n(o,h),D(I[o],h)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=D(c,this._value),this._value}}e.Hasher=i;var b;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function k(I,c,h=32){const o=h-c,l=~((1<<o)-1);return(I<<c|(l&I)>>>o)>>>0}function y(I,c=0,h=I.byteLength,o=0){for(let l=0;l<h;l++)I[c+l]=o}function d(I,c,h="0"){for(;I.length<c;)I=h+I;return I}function m(I,c=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),c/4)}e.toHexString=m;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const o=this._buff;let l=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=c.charCodeAt(0),r=0);;){let a=s;if(g.isHighSurrogate(s))if(r+1<h){const u=c.charCodeAt(r+1);g.isLowSurrogate(u)?(r++,a=g.computeCodePoint(s,u)):a=65533}else{t=s;break}else g.isLowSurrogate(s)&&(a=65533);if(l=this._push(o,l,a),r++,r<h)s=c.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=t}_push(c,h,o){return o<128?c[h++]=o:o<2048?(c[h++]=192|(o&1984)>>>6,c[h++]=128|(o&63)>>>0):o<65536?(c[h++]=224|(o&61440)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0):(c[h++]=240|(o&1835008)>>>18,c[h++]=128|(o&258048)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=P._bigBlock32,h=this._buffDV;for(let f=0;f<64;f+=4)c.setUint32(f,h.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)c.setUint32(f,k(c.getUint32(f-12,!1)^c.getUint32(f-32,!1)^c.getUint32(f-56,!1)^c.getUint32(f-64,!1),1),!1);let o=this._h0,l=this._h1,t=this._h2,s=this._h3,r=this._h4,a,u,p;for(let f=0;f<80;f++)f<20?(a=l&t|~l&s,u=1518500249):f<40?(a=l^t^s,u=1859775393):f<60?(a=l&t|l&s|t&s,u=2400959708):(a=l^t^s,u=3395469782),p=k(o,5)+a+r+u+c.getUint32(f*4,!1)&4294967295,r=s,s=t,t=k(l,30),l=o,o=p;this._h0=this._h0+o&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(f){return Array.isArray(f)}e.isArray=g;function M(f){return typeof f=="string"}e.isString=M;function D(f){return Array.isArray(f)&&f.every(L=>M(L))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function E(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=E;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function w(f){return f===!0||f===!1}e.isBoolean=w;function v(f){return typeof f=="undefined"}e.isUndefined=v;function i(f){return!b(f)}e.isDefined=i;function b(f){return v(f)||f===null}e.isUndefinedOrNull=b;function k(f,L){if(!f)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=k;function y(f){if(b(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=y;function d(...f){const L=[];for(let F=0;F<f.length;F++){const _=f[F];if(b(_))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);L.push(_)}return L}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function P(f){if(!S(f))return!1;for(let L in f)if(m.call(f,L))return!1;return!0}e.isEmptyObject=P;function I(f){return typeof f=="function"}e.isFunction=I;function c(...f){return f.length>0&&f.every(I)}e.areFunctions=c;function h(f,L){const F=Math.min(f.length,L.length);for(let _=0;_<F;_++)o(f[_],L[_])}e.validateConstraints=h;function o(f,L){if(M(L)){if(typeof f!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(I(L)){try{if(f instanceof L)return}catch{}if(!b(f)&&f.constructor===L||L.length===1&&L.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function l(f){let L=[],F=Object.getPrototypeOf(f);for(;Object.prototype!==F;)L=L.concat(Object.getOwnPropertyNames(F)),F=Object.getPrototypeOf(F);return L}e.getAllPropertyNames=l;function t(f){const L=[];for(const F of l(f))typeof f[F]=="function"&&L.push(F);return L}e.getAllMethodNames=t;function s(f,L){const F=C=>function(){const K=Array.prototype.slice.call(arguments,0);return L(C,K)};let _={};for(const C of f)_[C]=F(C);return _}e.createProxyObject=s;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function a(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=a;function u(f){return class{constructor(){return new Proxy({},{get(L,F){if(L[F])return L[F];throw new Error(`Not Implemented: ${f}->${String(F)}`)}})}}}e.NotImplementedProxy=u;function p(f){throw new Error("Unreachable")}e.assertNever=p}),define(J[30],Z([0,1,3,23,8,13]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function w(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function v(r,a=D.posix.sep){if(!r)return"";const u=r.length,p=r.charCodeAt(0);if(E(p)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let L=3;const F=L;for(;L<u&&!E(r.charCodeAt(L));L++);if(F!==L&&!E(r.charCodeAt(L+1))){for(L+=1;L<u;L++)if(E(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(I(p)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(E(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=v;function i(r){if(!g.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let u=2;const p=u;for(;u<r.length&&(a=r.charCodeAt(u),a!==92);u++);return!(p===u||(a=r.charCodeAt(u+1),isNaN(a)||a===92))}e.isUNC=i;const b=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=g.isWindows){const u=a?b:k;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||a&&y.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function m(r,a,u){const p=r===a;return!u||p?p:!r||!a?!1:M.equalsIgnoreCase(r,a)}e.isEqual=m;function P(r,a,u,p=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(u){if(!M.startsWithIgnoreCase(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===p&&L--,r.charAt(L)===p}return a.charAt(a.length-1)!==p&&(a+=p),r.indexOf(a)===0}e.isEqualOrParent=P;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function c(r,a){return g.isWindows&&r.endsWith(":")&&(r+=D.sep),D.isAbsolute(r)||(r=D.join(a,r)),r=D.normalize(r),g.isWindows?(r=M.rtrim(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=M.rtrim(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=c;function h(r){const a=D.normalize(r);return g.isWindows?r.length>3?!1:o(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.posix.sep}e.isRootOrDriveLetter=h;function o(r){return g.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function l(r){return o(r)?r[0]:void 0}e.getDriveLetter=l;function t(r,a,u){return a.length>r.length?-1:r===a?0:(u&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=t;function s(r){const a=r.split(":");let u,p,f;if(a.forEach(L=>{const F=Number(L);S.isNumber(F)?p===void 0?p=F:f===void 0&&(f=F):u=u?[u,L].join(":"):L}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:p!==void 0?p:void 0,column:f!==void 0?f:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const P=Array.isArray(m)?[]:{};return Object.keys(m).forEach(I=>{m[I]&&typeof m[I]=="object"?P[I]=M(m[I]):P[I]=m[I]}),P}e.deepClone=M;function D(m){if(!m||typeof m!="object")return m;const P=[m];for(;P.length>0;){const I=P.shift();Object.freeze(I);for(const c in I)if(S.call(I,c)){const h=I[c];typeof h=="object"&&!Object.isFrozen(h)&&P.push(h)}}return m}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function E(m,P){return n(m,P,new Set)}e.cloneAndChange=E;function n(m,P,I){if(g.isUndefinedOrNull(m))return m;const c=P(m);if(typeof c!="undefined")return c;if(g.isArray(m)){const h=[];for(const o of m)h.push(n(o,P,I));return h}if(g.isObject(m)){if(I.has(m))throw new Error("Cannot clone recursive data-structure");I.add(m);const h={};for(let o in m)S.call(m,o)&&(h[o]=n(m[o],P,I));return I.delete(m),h}return m}function w(m,P,I=!0){return g.isObject(m)?(g.isObject(P)&&Object.keys(P).forEach(c=>{c in m?I&&(g.isObject(m[c])&&g.isObject(P[c])?w(m[c],P[c],I):m[c]=P[c]):m[c]=P[c]}),m):P}e.mixin=w;function v(m,P){if(m===P)return!0;if(m==null||P===null||P===void 0||typeof m!=typeof P||typeof m!="object"||Array.isArray(m)!==Array.isArray(P))return!1;let I,c;if(Array.isArray(m)){if(m.length!==P.length)return!1;for(I=0;I<m.length;I++)if(!v(m[I],P[I]))return!1}else{const h=[];for(c in m)h.push(c);h.sort();const o=[];for(c in P)o.push(c);if(o.sort(),!v(h,o))return!1;for(I=0;I<h.length;I++)if(!v(m[h[I]],P[h[I]]))return!1}return!0}e.equals=v;function i(m){const P=new Set;return JSON.stringify(m,(I,c)=>{if(g.isObject(c)||Array.isArray(c)){if(P.has(c))return"[Circular]";P.add(c)}return c})}e.safeStringify=i;function b(m,P,I){const c=P(m);return typeof c=="undefined"?I:c}e.getOrDefault=b;function k(m,P){const I=Object.create(null);return!m||!P||Object.keys(P).forEach(h=>{const o=m[h],l=P[h];v(o,l)||(I[h]=l)}),I}e.distinct=k;function y(m,P){const I=P.toLowerCase(),c=Object.keys(m).find(h=>h.toLowerCase()===I);return c?m[c]:m[P]}e.getCaseInsensitive=y;function d(m,P){const I=Object.create(null);for(const c of Object.keys(m))P(c,m[c])&&(I[c]=m[c]);return I}e.filter=d}),define(J[7],Z([0,1,3,8]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,a){return!r&&!a?"file":r}function v(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const i="",b="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,u,p,f,L,F=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=w(a,F),this.authority=u||i,this.path=v(this.scheme,p||i),this.query=f||i,this.fragment=L||i,n(this,F))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return h(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:p,path:f,query:L,fragment:F}=a;return u===void 0?u=this.scheme:u===null&&(u=i),p===void 0?p=this.authority:p===null&&(p=i),f===void 0?f=this.path:f===null&&(f=i),L===void 0?L=this.query:L===null&&(L=i),F===void 0?F=this.fragment:F===null&&(F=i),u===this.scheme&&p===this.authority&&f===this.path&&L===this.query&&F===this.fragment?this:new m(u,p,f,L,F)}static parse(a,u=!1){const p=k.exec(a);return p?new m(p[2]||i,s(p[4]||i),s(p[5]||i),s(p[7]||i),s(p[9]||i),u):new m(i,i,i,i,i)}static file(a){let u=i;if(g.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const p=a.indexOf(b,2);p===-1?(u=a.substring(2),a=b):(u=a.substring(2,p),a=a.substring(p)||b)}return new m("file",u,a,i,i)}static from(a){const u=new m(a.scheme,a.authority,a.path,a.query,a.fragment);return n(u,!0),u}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return g.isWindows&&a.scheme==="file"?p=y.file(M.win32.join(h(a,!0),...u)).path:p=M.posix.join(a.path,...u),a.with({path:p})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const u=new m(a);return u._formatted=a.external,u._fsPath=a._sep===d?a.fsPath:null,u}}else return a}}e.URI=y;const d=g.isWindows?1:void 0;class m extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(r,a){let u,p=-1;for(let f=0;f<r.length;f++){const L=r.charCodeAt(f);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||a&&L===47)p!==-1&&(u+=encodeURIComponent(r.substring(p,f)),p=-1),u!==void 0&&(u+=r.charAt(f));else{u===void 0&&(u=r.substr(0,f));const F=P[L];F!==void 0?(p!==-1&&(u+=encodeURIComponent(r.substring(p,f)),p=-1),u+=F):p===-1&&(p=f)}}return p!==-1&&(u+=encodeURIComponent(r.substring(p))),u!==void 0?u:r}function c(r){let a;for(let u=0;u<r.length;u++){const p=r.charCodeAt(u);p===35||p===63?(a===void 0&&(a=r.substr(0,u)),a+=P[p]):a!==void 0&&(a+=r[u])}return a!==void 0?a:r}function h(r,a){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,g.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=h;function o(r,a){const u=a?c:I;let p="",{scheme:f,authority:L,path:F,query:_,fragment:C}=r;if(f&&(p+=f,p+=":"),(L||f==="file")&&(p+=b,p+=b),L){let K=L.indexOf("@");if(K!==-1){const ee=L.substr(0,K);L=L.substr(K+1),K=ee.indexOf(":"),K===-1?p+=u(ee,!1):(p+=u(ee.substr(0,K),!1),p+=":",p+=u(ee.substr(K+1),!1)),p+="@"}L=L.toLowerCase(),K=L.indexOf(":"),K===-1?p+=u(L,!1):(p+=u(L.substr(0,K),!1),p+=L.substr(K))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const K=F.charCodeAt(1);K>=65&&K<=90&&(F=`/${String.fromCharCode(K+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const K=F.charCodeAt(0);K>=65&&K<=90&&(F=`${String.fromCharCode(K+32)}:${F.substr(2)}`)}p+=u(F,!0)}return _&&(p+="?",p+=u(_,!1)),C&&(p+="#",p+=a?C:I(C,!1)),p}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>l(a)):r}}),define(J[110],Z([0,1,7]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(v){const i=v;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=M;function D(v){const i=[];let b;try{const k=JSON.parse(v.arguments),y=k[k.length-1];y&&y.__$stack&&(k.pop(),b=y.__$stack),i.push(...k)}catch(k){i.push("Unable to log remote console arguments",v.arguments)}return{args:i,stack:b}}e.parse=D;function S(v){if(typeof v!="string")return S(D(v).stack);const i=v;if(i){const b=E(i),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(k&&k.length===4)return{uri:g.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.getFirstFrame=S;function E(v){if(!v)return v;const i=v.indexOf(`
`);return i===-1?v:v.substring(0,i)}function n(v,i){const{args:b,stack:k}=D(v),y=typeof b[0]=="string"&&b.length===1;let d=E(k);d&&(d=`(${d.trim()})`);let m=[];if(typeof b[0]=="string"?d&&y?m=[`%c[${i}] %c${b[0]} %c${d}`,w("blue"),w(""),w("grey")]:m=[`%c[${i}] %c${b[0]}`,w("blue"),w(""),...b.slice(1)]:m=[`%c[${i}]%`,w("blue"),...b],d&&!y&&m.push(d),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,m)}e.log=n;function w(v){return`color: ${v}`}});var bt=this&&this.__classPrivateFieldSet||function(q,e,g,M,D){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!D:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?D.call(q,g):D?D.value=g:e.set(q,g),g},je=this&&this.__classPrivateFieldGet||function(q,e,g,M){if(g==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!M:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?M:g==="a"?M.call(q):M?M.value:e.get(q)};define(J[37],Z([0,1,7,23]),function(q,e,g,M){"use strict";var D,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,s,r){let a=t.get(s);return a===void 0&&(a=r,t.set(s,a)),a}e.getOrSet=n;function w(t){const s=[];return t.forEach((r,a)=>{s.push(`${a} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=w;function v(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=v;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=i;class b{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?M.compareSubstring(s,this._value,0,s.length,this._from,this._to):M.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class k{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?M.compareSubstring(s,this._value,0,s.length,this._from,this._to):M.compareSubstringIgnoreCase(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return M.compareIgnoreCase(s,this._value.scheme);if(this._states[this._stateIdx]===2)return M.compareIgnoreCase(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return M.compare(s,this._value.query);if(this._states[this._stateIdx]===5)return M.compare(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new d(s))}static forPaths(){return new P(new k)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new b)}clear(){this._root=void 0}set(s,r){const a=this._iter.reset(s);let u;for(this._root||(this._root=new m,this._root.segment=a.value()),u=this._root;;){const f=a.cmp(u.segment);if(f>0)u.left||(u.left=new m,u.left.segment=a.value()),u=u.left;else if(f<0)u.right||(u.right=new m,u.right.segment=a.value()),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new m,u.mid.segment=a.value()),u=u.mid;else break}const p=u.value;return u.value=r,u.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const a=this._iter.reset(s),u=[];let p=this._root;for(;p;){const f=a.cmp(p.segment);if(f>0)u.push([1,p]),p=p.left;else if(f<0)u.push([-1,p]),p=p.right;else if(a.hasNext())a.next(),u.push([0,p]),p=p.mid;else{for(r?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;u.length>0&&p.isEmpty();){let[L,F]=u.pop();switch(L){case 1:F.left=void 0;break;case 0:F.mid=void 0;break;case-1:F.right=void 0;break}p=F}break}}}findSubstr(s){const r=this._iter.reset(s);let a=this._root,u;for(;a;){const p=r.cmp(a.segment);if(p>0)a=a.left;else if(p<0)a=a.right;else if(r.hasNext())r.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const u=r.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(s){for(const[r,a]of this)s(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const a=r.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&r.push(a.left),a.mid&&r.push(a.mid),a.right&&r.push(a.right))}}}e.TernarySearchTree=P;class I{constructor(s,r){this[D]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=r??I.defaultToKey):(this.map=new Map,this.toKey=s??I.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[a,u]of this.map)s(u,g.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield g.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[g.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[g.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var c;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class h{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const a=this._map.get(s);if(!!a)return r!==0&&this.touch(a,r),a.value}set(s,r,a=0){let u=this._map.get(s);if(u)u.value=r,a!==0&&this.touch(u,a);else{switch(u={key:s,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(s,u),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const a=this._state;let u=this._head;for(;u;){if(r?s.bind(r)(u.value,u.key,this):s(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const s=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.key,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}values(){const s=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:a.value,done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}entries(){const s=this,r=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const p={value:[a.key,a.value],done:!1};return a=a.next,p}else return{value:void 0,done:!0}}};return u}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>s;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,a=s.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const a=s.next,u=s.previous;s===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const a=s.next,u=s.previous;s===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,a)=>{s.push([a,r])}),s}fromJSON(s){this.clear();for(const[r,a]of s)this.set(r,a)}}e.LinkedMap=h;class o extends h{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class l{constructor(s){E.set(this,void 0),bt(this,E,s,"f")}get size(){return je(this,E,"f").size}forEach(s,r){je(this,E,"f").forEach(s,r)}get(s){return je(this,E,"f").get(s)}has(s){return je(this,E,"f").has(s)}entries(){return je(this,E,"f").entries()}keys(){return je(this,E,"f").keys()}values(){return je(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return je(this,E,"f").entries()}}e.ReadonlyMapView=l}),define(J[111],Z([0,1,17,23,7]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,w)}e.stringify=S;function E(i){let b=JSON.parse(i);return b=v(b),b}e.parse=E;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function w(i,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:M.regExpFlags(b)}:b}function v(i,b=0){if(!i||b>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let k=0;k<i.length;++k)i[k]=v(i[k],b+1);else for(const k in i)Object.hasOwnProperty.call(i,k)&&(i[k]=v(i[k],b+1))}return i}e.revive=v}),define(J[10],Z([0,1,7,3]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,v,i){this._hosts[w]=v,this._ports[w]=i}setConnectionToken(w,v){this._connectionTokens[w]=v}rewrite(w){if(this._delegate)return this._delegate(w);const v=w.authority;let i=this._hosts[v];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const b=this._ports[v],k=this._connectionTokens[v];let y=`path=${encodeURIComponent(w.path)}`;return typeof k=="string"&&(y+=`&tkn=${encodeURIComponent(k)}`),g.URI.from({scheme:M.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,v,i){const b=this.toUri(w,v);if(b.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(b);let k=!1;return M.isNative&&(i||M.isPreferringBrowserCodeLoad)&&b.scheme===D.file&&(k=!0),b.scheme===D.file&&typeof M.globals.importScripts=="function"&&M.globals.origin==="vscode-file://vscode-app"&&(k=!0),k?b.with({scheme:D.vscodeFileResource,authority:b.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(w,v){const i=this.toUri(w,v);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,v){return g.URI.isUri(w)?w:g.URI.parse(v.toUrl(w))}}e.FileAccess=new E}),define(J[65],Z([0,1,37]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const M=new g.LRUCache(1e4);function D(v){return w(v,"NFC",M)}e.normalizeNFC=D;const S=new g.LRUCache(1e4);function E(v){return w(v,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function w(v,i,b){if(!e.canNormalize||!v)return v;const k=b.get(v);if(k)return k;let y;return n.test(v)?y=v.normalize(i):y=v,b.set(v,y),y}e.removeAccents=function(){if(e.canNormalize){const v=/[\u0300-\u036f]/g;return function(i){return E(i).replace(v,"")}}else return function(v){return v}}()}),define(J[15],Z([0,1,30,8,7,23,10,3]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(y){return D.uriToFsPath(y,!0)}e.originalFSPath=w;class v{constructor(d){this._ignorePathCasing=d}compare(d,m,P=!1){return d===m?0:S.compare(this.getComparisonKey(d,P),this.getComparisonKey(m,P))}isEqual(d,m,P=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,P)===this.getComparisonKey(m,P)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,P=!1){if(d.scheme===m.scheme){if(d.scheme===E.Schemas.file)return g.isEqualOrParent(w(d),w(m),this._ignorePathCasing(d))&&d.query===m.query&&(P||d.fragment===m.fragment);if(e.isEqualAuthority(d.authority,m.authority))return g.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(P||d.fragment===m.fragment)}return!1}joinPath(d,...m){return D.URI.joinPath(d,...m)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===E.Schemas.file?m=D.URI.file(M.dirname(w(d))).path:(m=M.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===E.Schemas.file?m=D.URI.file(M.normalize(w(d))).path:m=M.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!e.isEqualAuthority(d.authority,m.authority))return;if(d.scheme===E.Schemas.file){const c=M.relative(w(d),w(m));return n.isWindows?g.toSlashes(c):c}let P=d.path||"/",I=m.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(P.length,I.length);c<h&&!(P.charCodeAt(c)!==I.charCodeAt(c)&&P.charAt(c).toLowerCase()!==I.charAt(c).toLowerCase());c++);P=I.substr(0,c)+P.substr(c)}return M.posix.relative(P,I)}resolvePath(d,m){if(d.scheme===E.Schemas.file){const P=D.URI.file(M.resolve(w(d),m));return d.with({authority:P.authority,path:P.path})}return m=g.toPosixPath(m),d.with({path:M.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||S.equalsIgnoreCase(d,m)}hasTrailingPathSeparator(d,m=M.sep){if(d.scheme===E.Schemas.file){const P=w(d);return P.length>g.getRoot(P).length&&P[P.length-1]===m}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=M.sep){return e.hasTrailingPathSeparator(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=M.sep){let P=!1;if(d.scheme===E.Schemas.file){const I=w(d);P=I!==void 0&&I.length===g.getRoot(I).length&&I[I.length-1]===m}else{m="/";const I=d.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!e.hasTrailingPathSeparator(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(y=>y.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new v(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const m=[];for(let P=0;P<y.length;P++){const I=d(y[P]);y.some((c,h)=>h===P?!1:e.isEqualOrParent(I,d(c)))||m.push(y[P])}return m}e.distinctParents=i;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(m){const P=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,l]=h.split(":");o&&l&&P.set(o,l)});const c=m.path.substring(0,m.path.indexOf(";"));return c&&P.set(y.META_DATA_MIME,c),P}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function k(y,d,m){if(d){let P=y.path;return P&&P[0]!==M.posix.sep&&(P=M.posix.sep+P),y.with({scheme:m,authority:d,path:P})}return y.with({scheme:m})}e.toLocalResource=k}),define(J[9],Z([0,1,25,16,5,2,15]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(H){return!!H&&typeof H.then=="function"}e.isThenable=n;function w(H){const B=new g.CancellationTokenSource,T=H(B.token),R=new Promise((O,W)=>{B.token.onCancellationRequested(()=>{W(M.canceled())}),Promise.resolve(T).then(A=>{B.dispose(),O(A)},A=>{B.dispose(),W(A)})});return new class{cancel(){B.cancel()}then(O,W){return R.then(O,W)}catch(O){return this.then(void 0,O)}finally(O){return R.finally(O)}}}e.createCancelablePromise=w;function v(H,B,T){return Promise.race([H,new Promise(R=>B.onCancellationRequested(()=>R(T)))])}e.raceCancellation=v;async function i(H){let B=-1;const T=H.map((O,W)=>O.then(A=>(B=W,A))),R=await Promise.race(T);return H.forEach((O,W)=>{W!==B&&O.cancel()}),R}e.raceCancellablePromises=i;function b(H,B,T){let R;const O=setTimeout(()=>{R?.(void 0),T?.()},B);return Promise.race([H.finally(()=>clearTimeout(O)),new Promise(W=>R=W)])}e.raceTimeout=b;function k(H){return new Promise((B,T)=>{const R=H();n(R)?R.then(B,T):B(R)})}e.asPromise=k;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const T=()=>{this.queuedPromise=null;const R=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,R};this.queuedPromise=new Promise(R=>{this.activePromise.then(T,T).then(R)})}return new Promise((T,R)=>{this.queuedPromise.then(T,R)})}return this.activePromise=B(),new Promise((T,R)=>{this.activePromise.then(O=>{this.activePromise=null,T(O)},O=>{this.activePromise=null,R(O)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue(B,T){const O=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.promiseMap.get(B)===O&&this.promiseMap.delete(B)});return this.promiseMap.set(B,O),O}}e.SequencerByKey=m;class P{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,T=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((R,O)=>{this.doResolve=R,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const R=this.task;return this.task=null,R()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},T),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(M.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class I{constructor(B){this.delayer=new P(B),this.throttler=new y}trigger(B,T){return this.delayer.trigger(()=>this.throttler.queue(B),T)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class c{constructor(){this._isOpen=!1,this._promise=new Promise((B,T)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(H,B){return B?new Promise((T,R)=>{const O=setTimeout(T,H);B.onCancellationRequested(()=>{clearTimeout(O),R(M.canceled())})}):w(T=>o(H,T))}e.timeout=o;function l(H,B=0){const T=setTimeout(H,B);return S.toDisposable(()=>clearTimeout(T))}e.disposableTimeout=l;function t(H){return H.then(void 0,B=>{})}e.ignoreErrors=t;function s(H){const B=[];let T=0;const R=H.length;function O(){return T<R?H[T++]():null}function W(A){A!=null&&B.push(A);const N=O();return N?N.then(W):Promise.resolve(B)}return Promise.resolve(null).then(W)}e.sequence=s;function r(H,B=R=>!!R,T=null){let R=0;const O=H.length,W=()=>{if(R>=O)return Promise.resolve(T);const A=H[R++];return Promise.resolve(A()).then(z=>B(z)?Promise.resolve(z):W())};return W()}e.first=r;function a(H,B=R=>!!R,T=null){if(H.length===0)return Promise.resolve(T);let R=H.length;const O=()=>{R=-1;for(const W of H)W.cancel?.()};return new Promise((W,A)=>{for(const N of H)N.then(z=>{--R>=0&&B(z)?(O(),W(z)):R===0&&W(T)}).catch(z=>{--R>=0&&(O(),A(z))})})}e.firstParallel=a;class u{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((T,R)=>{this.outstandingPromises.push({factory:B,c:T,e:R}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const T=B.factory();T.then(B.c,B.e),T.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class p extends u{constructor(){super(1)}}e.Queue=p;class f{constructor(){this.queues=new Map}queueFor(B,T=E.extUri){const R=T.getComparisonKey(B);let O=this.queues.get(R);return O||(O=new p,D.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(R)}),this.queues.set(R,O)),O}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=f;class L{constructor(B,T){this._token=-1,typeof B=="function"&&typeof T=="number"&&this.setIfNotSet(B,T)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,T){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},T)}setIfNotSet(B,T){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},T))}}e.TimeoutTimer=L;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,T){this.cancel(),this._token=setInterval(()=>{B()},T)}}e.IntervalTimer=F;class _{constructor(B,T){this.timeoutToken=-1,this.runner=B,this.timeout=T,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class C extends _{constructor(B,T){super(B,T);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=C;class K extends S.Disposable{constructor(B,T,R,O){super();this.maxWorkChunkSize=B,this.maxPendingWork=T,this.throttleDelay=R,this.handler=O,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new _(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=K,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=B=>{const T=setTimeout(()=>B(H));let R=!1;return{dispose(){R||(R=!0,clearTimeout(T))}}}}else e.runWhenIdle=(H,B)=>{const T=requestIdleCallback(H,typeof B=="number"?{timeout:B}:void 0);let R=!1;return{dispose(){R||(R=!0,cancelIdleCallback(T))}}}}();class ee{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(T){this._error=T}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ee;async function V(H,B,T){let R;for(let O=0;O<T;O++)try{return await H()}catch(W){R=W,await o(B)}throw R}e.retry=V;class x{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,T,R){return this._pending={taskId:B,cancel:()=>R?.(),promise:T},T.then(()=>this.donePending(B),()=>this.donePending(B)),T}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let T,R;const O=new Promise((W,A)=>{T=W,R=A});this._next={run:B,promise:O,promiseResolve:T,promiseReject:R}}return this._next.promise}}e.TaskSequentializer=x;class Q{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,T)=>{this.completeCallback=B,this.errorCallback=T})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(T=>{this.completeCallback(B),this.resolved=!0,T()})}error(B){return new Promise(T=>{this.errorCallback(B),this.rejected=!0,T()})}cancel(){new Promise(B=>{this.errorCallback(M.canceled()),this.rejected=!0,B()})}}e.DeferredPromise=U;var $;(function(H){async function B(T){let R;const O=await Promise.all(T.map(W=>W.then(A=>A,A=>{R||(R=A)})));if(typeof R!="undefined")throw R;return O}H.settled=B})($=e.Promises||(e.Promises={}))}),define(J[112],Z([0,1,23,30,8,37,9]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const w="**",v="/",i="[/\\\\]",b="[^/\\\\]",k=/\//g;function y(R){switch(R){case 0:return"";case 1:return`${b}*?`;default:return`(?:${i}|${b}+${i}|${i}${b}+)*?`}}function d(R,O){if(!R)return[];const W=[];let A=!1,N=!1,z="";for(const Y of R){switch(Y){case O:if(!A&&!N){W.push(z),z="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":N=!0;break;case"]":N=!1;break}z+=Y}return z&&W.push(z),W}e.splitGlobAware=d;function m(R){if(!R)return"";let O="";const W=d(R,v);if(W.every(A=>A===w))O=".*";else{let A=!1;W.forEach((N,z)=>{if(N===w){A||(O+=y(2),A=!0);return}let Y=!1,G="",X=!1,ne="";for(const se of N){if(se!=="}"&&Y){G+=se;continue}if(X&&(se!=="]"||!ne)){let ue;se==="-"?ue=se:(se==="^"||se==="!")&&!ne?ue="^":se===v?ue="":ue=g.escapeRegExpCharacters(se),ne+=ue;continue}switch(se){case"{":Y=!0;continue;case"[":X=!0;continue;case"}":O+=`(?:${d(G,",").map(re=>m(re)).join("|")})`,Y=!1,G="";break;case"]":O+="["+ne+"]",X=!1,ne="";break;case"?":O+=b;continue;case"*":O+=y(1);continue;default:O+=g.escapeRegExpCharacters(se)}}z<W.length-1&&(W[z+1]!==w||z+2<W.length)&&(O+=i),A=!1})}return O}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(R,O){if(!R)return r;let W;typeof R!="string"?W=R.pattern:W=R,W=W.trim();const A=`${W}_${!!O.trimForExclusions}`;let N=t.get(A);if(N)return u(N,R);let z;if(P.test(W)){const Y=W.substr(4);N=function(G,X){return typeof G=="string"&&G.endsWith(Y)?W:null}}else(z=I.exec(p(W,O)))?N=f(z[1],W):(O.trimForExclusions?h:c).test(W)?N=L(W,O):(z=o.exec(p(W,O)))?N=F(z[1].substr(1),W,!0):(z=l.exec(p(W,O)))?N=F(z[1],W,!1):N=_(W);return t.set(A,N),u(N,R)}function u(R,O){return typeof O=="string"?R:function(W,A){return M.isEqualOrParent(W,O.base)?R(D.relative(O.base,W),A):null}}function p(R,O){return O.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function f(R,O){const W=`/${R}`,A=`\\${R}`,N=function(Y,G){return typeof Y!="string"?null:G?G===R?O:null:Y===R||Y.endsWith(W)||Y.endsWith(A)?O:null},z=[R];return N.basenames=z,N.patterns=[O],N.allBasenames=z,N}function L(R,O){const W=T(R.slice(1,-1).split(",").map(G=>a(G,O)).filter(G=>G!==r),R),A=W.length;if(!A)return r;if(A===1)return W[0];const N=function(G,X){for(let ne=0,se=W.length;ne<se;ne++)if(W[ne](G,X))return R;return null},z=W.find(G=>!!G.allBasenames);z&&(N.allBasenames=z.allBasenames);const Y=W.reduce((G,X)=>X.allPaths?G.concat(X.allPaths):G,[]);return Y.length&&(N.allPaths=Y),N}function F(R,O,W){const A=D.sep===D.posix.sep,N=A?R:R.replace(k,D.sep),z=D.sep+N,Y=D.posix.sep+R,G=W?function(X,ne){return typeof X=="string"&&(X===N||X.endsWith(z)||!A&&(X===R||X.endsWith(Y)))?O:null}:function(X,ne){return typeof X=="string"&&(X===N||!A&&X===R)?O:null};return G.allPaths=[(W?"*/":"./")+R],G}function _(R){try{const O=new RegExp(`^${m(R)}$`);return function(W){return O.lastIndex=0,typeof W=="string"&&O.test(W)?R:null}}catch(O){return r}}function C(R,O,W){return!R||typeof O!="string"?!1:K(R)(O,void 0,W)}e.match=C;function K(R,O={}){if(!R)return s;if(typeof R=="string"||Q(R)){const W=a(R,O);if(W===r)return s;const A=function(N,z){return!!W(N,z)};return W.allBasenames&&(A.allBasenames=W.allBasenames),W.allPaths&&(A.allPaths=W.allPaths),A}return H(R,O)}e.parse=K;function ee(R){if(!R)return;let O;return W=>(O||(O=(R()||Promise.resolve([])).then(A=>A?x(A):{})),O.then(A=>!!A[W]))}e.hasSiblingPromiseFn=ee;function V(R){if(!R)return;let O;return W=>{if(!O){const A=R();O=A?x(A):{}}return!!O[W]}}e.hasSiblingFn=V;function x(R){const O={};for(const W of R)O[W]=!0;return O}function Q(R){const O=R;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=Q;function U(R){return R.allBasenames||[]}e.getBasenameTerms=U;function $(R){return R.allPaths||[]}e.getPathTerms=$;function H(R,O){const W=T(Object.getOwnPropertyNames(R).map(G=>B(G,R[G],O)).filter(G=>G!==r)),A=W.length;if(!A)return r;if(!W.some(G=>!!G.requiresSiblings)){if(A===1)return W[0];const G=function(se,ue){for(let de=0,re=W.length;de<re;de++){const le=W[de](se,ue);if(le)return le}return null},X=W.find(se=>!!se.allBasenames);X&&(G.allBasenames=X.allBasenames);const ne=W.reduce((se,ue)=>ue.allPaths?se.concat(ue.allPaths):se,[]);return ne.length&&(G.allPaths=ne),G}const N=function(G,X,ne){let se;for(let ue=0,de=W.length;ue<de;ue++){const re=W[ue];re.requiresSiblings&&ne&&(X||(X=D.basename(G)),se||(se=X.substr(0,X.length-D.extname(G).length)));const le=re(G,X,se,ne);if(le)return le}return null},z=W.find(G=>!!G.allBasenames);z&&(N.allBasenames=z.allBasenames);const Y=W.reduce((G,X)=>X.allPaths?G.concat(X.allPaths):G,[]);return Y.length&&(N.allPaths=Y),N}function B(R,O,W){if(O===!1)return r;const A=a(R,W);if(A===r)return r;if(typeof O=="boolean")return A;if(O){const N=O.when;if(typeof N=="string"){const z=(Y,G,X,ne)=>{if(!ne||!A(Y,G))return null;const se=N.replace("$(basename)",X),ue=ne(se);return E.isThenable(ue)?ue.then(de=>de?R:null):ue?R:null};return z.requiresSiblings=!0,z}}return A}function T(R,O){const W=R.filter(G=>!!G.basenames);if(W.length<2)return R;const A=W.reduce((G,X)=>{const ne=X.basenames;return ne?G.concat(ne):G},[]);let N;if(O){N=[];for(let G=0,X=A.length;G<X;G++)N.push(O)}else N=W.reduce((G,X)=>{const ne=X.patterns;return ne?G.concat(ne):G},[]);const z=function(G,X){if(typeof G!="string")return null;if(!X){let se;for(se=G.length;se>0;se--){const ue=G.charCodeAt(se-1);if(ue===47||ue===92)break}X=G.substr(se)}const ne=A.indexOf(X);return ne!==-1?N[ne]:null};z.basenames=A,z.patterns=N,z.allBasenames=A;const Y=R.filter(G=>!G.basenames);return Y.push(z),Y}}),define(J[31],Z([0,1,7,8,23,10,3,15,30]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function v(a,u,p){if(typeof a=="string"&&(a=g.URI.file(a)),p){const L=p.getWorkspaceFolder(a);if(L){const F=p.getWorkspace().folders.length>1;let _;if(n.isEqual(L.uri,a)?_="":_=n.relativePath(L.uri,a),F){const C=L.name?L.name:n.basename(L.uri);_=_?C+" \u2022 "+_:C}return _}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if(w.hasDriveLetter(a.fsPath))return M.normalize(b(a.fsPath));let f=M.normalize(a.fsPath);return!E.isWindows&&u?.userHome&&(f=y(f,u.userHome.fsPath)),f}e.getPathLabel=v;function i(a){if(!a)return;typeof a=="string"&&(a=g.URI.file(a));const u=n.basename(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return E.isWindows&&w.isRootOrDriveLetter(u)?b(u):u}e.getBaseLabel=i;function b(a){return w.hasDriveLetter(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=b;let k=Object.create(null);function y(a,u){if(E.isWindows||!a||!u)return a;let p=k.original===u?k.normalized:void 0;return p||(p=`${D.rtrim(u,M.posix.sep)}${M.posix.sep}`,k={original:u,normalized:p}),(E.isLinux?a.startsWith(p):D.startsWithIgnoreCase(a,p))&&(a=`~/${a.substr(p.length)}`),a}e.tildify=y;function d(a,u){return a.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=d;const m="\u2026",P="\\\\",I="~";function c(a,u=M.sep){const p=new Array(a.length);let f=!1;for(let L=0;L<a.length;L++){let F=a[L];if(F===""){p[L]=`.${u}`;continue}if(!F){p[L]=F;continue}f=!0;let _="";F.indexOf(P)===0?(_=F.substr(0,F.indexOf(P)+P.length),F=F.substr(F.indexOf(P)+P.length)):F.indexOf(u)===0?(_=F.substr(0,F.indexOf(u)+u.length),F=F.substr(F.indexOf(u)+u.length)):F.indexOf(I)===0&&(_=F.substr(0,F.indexOf(I)+I.length),F=F.substr(F.indexOf(I)+I.length));const C=F.split(u);for(let K=1;f&&K<=C.length;K++)for(let ee=C.length-K;f&&ee>=0;ee--){f=!1;let V=C.slice(ee,ee+K).join(u);for(let x=0;!f&&x<a.length;x++)if(x!==L&&a[x]&&a[x].indexOf(V)>-1){const Q=ee+K===C.length,U=ee>0&&a[x].indexOf(u)>-1?u+V:V,$=a[x].endsWith(U);f=!Q||$}if(!f){let x="";(C[0].endsWith(":")||_!=="")&&(ee===1&&(ee=0,K++,V=C[0]+u+V),ee>0&&(x=C[0]+u),x=_+x),ee>0&&(x=x+m+u),x=x+V,ee+K<C.length&&(x=x+u+m),p[L]=x}}f&&(p[L]=F)}return p}e.shorten=c;var h;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(a,u=Object.create(null)){const p=[];let f=!1,L="";for(const F of a)if(F==="$"||f&&F==="{")L&&p.push({value:L,type:h.TEXT}),L="",f=!0;else if(F==="}"&&f){const _=u[L];if(typeof _=="string")_.length&&p.push({value:_,type:h.VARIABLE});else if(_){const C=p[p.length-1];(!C||C.type!==h.SEPARATOR)&&p.push({value:_.label,type:h.SEPARATOR})}L="",f=!1}else L+=F;return L&&!f&&p.push({value:L,type:h.TEXT}),p.filter((F,_)=>{if(F.type===h.SEPARATOR){const C=p[_-1],K=p[_+1];return[C,K].every(ee=>ee&&(ee.type===h.VARIABLE||ee.type===h.TEXT)&&ee.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=o;function l(a,u){return E.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):a.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function t(a,u){return E.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,""):E.isWindows?a.replace(/&&|&/g,p=>p==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const u=a.indexOf("/")!==-1?M.posix:M.win32,p=u.basename(a),f=u.dirname(a);return p.length?{name:p,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(w){return g.test(w)}e.isUUID=M;const D=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let v=0;v<w.length;v++)w[v]=Math.floor(Math.random()*256);return w};function n(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,v="";return v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v+="-",v+=S[D[w++]],v+=S[D[w++]],v+="-",v+=S[D[w++]],v+=S[D[w++]],v+="-",v+=S[D[w++]],v+=S[D[w++]],v+="-",v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v+=S[D[w++]],v}e.generateUuid=n}),define(J[113],Z([0,1,29,58,43]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,b)=>{const k=g.createReadStream(E),y=M.createHash("sha1");k.pipe(y);const d=D.once((m,P)=>{k.removeAllListeners(),y.removeAllListeners(),m?b(m):i(P)});k.once("error",d),k.once("end",d),y.once("error",d),y.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],Z([0,1,239]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class M{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let w=0,v,i=w;for(;i<n.length;)if(v=n.charCodeAt(i),v===13||v===10){if(E.push(n.substring(w,i)),i++,i<n.length){const b=v;v=n.charCodeAt(i),(b===13&&v===10||b===10&&v===13)&&i++}w=i}else i++;return this.remaining=w<n.length?n.substr(w):null,E}end(){return this.remaining}}e.LineDecoder=M}),define(J[114],Z([0,1,26]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const w=n.replace(/\-/g,":").toLowerCase();return!M.has(w)}function S(){return new Promise(async(n,w)=>{const v=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){w(i)}finally{clearTimeout(v)}})}e.getMac=S;function E(){return new Promise((n,w)=>{try{const v=g.networkInterfaces();for(let i in v){const b=v[i];if(b){for(const{mac:k}of b)if(D(k))return n(k)}}w("Unable to retrieve mac address (unexpected format)")}catch(v){w(v)}})}}),define(J[66],Z([0,1,16,28,26,37,114]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,b=0;const k=D.networkInterfaces();for(let y in k){const d=k[y];if(d)for(const{mac:m,internal:P}of d)P||(b+=1,this._isVirtualMachineMacAdress(m.toUpperCase())&&(i+=1))}this._value=b>0?i/b:0}return this._value}};let n;async function w(){return n||(n=(async()=>await v()||M.generateUuid())()),n}e.getMachineId=w;async function v(){try{const i=await new Promise((k,y)=>{q(["crypto"],k,y)}),b=await E.getMac();return i.createHash("sha256").update(b,"utf8").digest("hex")}catch(i){g.onUnexpectedError(i);return}}}),define(J[18],Z([0,1,29,26,115,8,9,3,30,28,65,15,7]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(U,$=y.UNLINK){if(w.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");return $===y.UNLINK?P(U):m(U)}async function m(U){try{const $=S.join(M.tmpdir(),v.generateUuid());try{await e.Promises.rename(U,$)}catch(H){return P(U)}P($).catch(H=>{})}catch($){if($.code!=="ENOENT")throw $}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function I(U){if(w.isRootOrDriveLetter(U))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(U,{recursive:!0})}e.rimrafSync=I;async function c(U,$){return l(await($?h(U):D.promisify(g.readdir)(U)))}async function h(U){try{return await D.promisify(g.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const $=[],H=await c(U);for(const B of H){let T=!1,R=!1,O=!1;try{const W=await e.Promises.lstat(S.join(U,B));T=W.isFile(),R=W.isDirectory(),O=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}$.push({name:B,isFile:()=>T,isDirectory:()=>R,isSymbolicLink:()=>O})}return $}function o(U){return l(g.readdirSync(U))}e.readdirSync=o;function l(U){return U.map($=>typeof $=="string"?n.isMacintosh?i.normalizeNFC($):$:($.name=n.isMacintosh?i.normalizeNFC($.name):$.name,$))}async function t(U){const $=await c(U),H=[];for(const B of $)await r.existsDirectory(S.join(U,B))&&H.push(B);return H}function s(U,$=1e3){return new Promise(H=>{let B=!1;const T=setInterval(()=>{B||(B=!0,g.access(U,R=>{B=!1,R&&(clearInterval(T),H(void 0))}))},$)})}e.whenDeleted=s;var r;(function(U){async function $(T){let R;try{if(R=await e.Promises.lstat(T),!R.isSymbolicLink())return{stat:R}}catch(O){}try{return{stat:await e.Promises.stat(T),symbolicLink:R?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(n.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw W}throw O}}U.stat=$;async function H(T){try{const{stat:R,symbolicLink:O}=await U.stat(T);return R.isFile()&&O?.dangling!==!0}catch(R){}return!1}U.existsFile=H;async function B(T){try{const{stat:R,symbolicLink:O}=await U.stat(T);return R.isDirectory()&&O?.dangling!==!0}catch(R){}return!1}U.existsDirectory=B})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new E.ResourceQueue;function u(U,$,H){return a.queueFor(k.URI.file(U),b.extUriBiasedIgnorePathCase).queue(()=>{const B=F(H);return new Promise((T,R)=>f(U,$,B,O=>O?R(O):T()))})}let p=!0;function f(U,$,H,B){if(!p)return g.writeFile(U,$,{mode:H.mode,flag:H.flag},B);g.open(U,H.flag,H.mode,(T,R)=>{if(T)return B(T);g.writeFile(R,$,O=>{if(O)return g.close(R,()=>B(O));g.fdatasync(R,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),p=!1),g.close(R,A=>B(A))))})})}function L(U,$,H){const B=F(H);if(!p)return g.writeFileSync(U,$,{mode:B.mode,flag:B.flag});const T=g.openSync(U,B.flag,B.mode);try{g.writeFileSync(T,$);try{g.fdatasyncSync(T)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),p=!1}}finally{g.closeSync(T)}}e.writeFileSync=L;function F(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function _(U,$){if(U===$)return;async function H(B){try{const T=await e.Promises.lstat(B);if(T.isDirectory()||T.isSymbolicLink())return;await e.Promises.utimes(B,T.atime,new Date)}catch(T){}}try{await e.Promises.rename(U,$),await H($)}catch(B){if(U.toLowerCase()!==$.toLowerCase()&&B.code==="EXDEV"||U.endsWith("."))await C(U,$,{preserveSymlinks:!1}),await d(U,y.MOVE),await H($);else throw B}}async function C(U,$,H){return ee(U,$,{root:{source:U,target:$},options:H,handledSourcePaths:new Set})}const K=511;async function ee(U,$,H){if(H.handledSourcePaths.has(U))return;H.handledSourcePaths.add(U);const{stat:B,symbolicLink:T}=await r.stat(U);if(T){if(H.options.preserveSymlinks)try{return await Q(U,$,H)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(T.dangling)return}return B.isDirectory()?V(U,$,B.mode&K,H):x(U,$,B.mode&K)}async function V(U,$,H,B){await e.Promises.mkdir($,{recursive:!0,mode:H});const T=await c(U);for(const R of T)await ee(S.join(U,R),S.join($,R),B)}async function x(U,$,H){await e.Promises.copyFile(U,$),await e.Promises.chmod($,H)}async function Q(U,$,H){let B=await e.Promises.readlink(U);w.isEqualOrParent(B,H.root.source,!n.isLinux)&&(B=S.join(H.root.target,B.substr(H.root.source.length+1))),await e.Promises.symlink(B,$)}e.Promises=new class{get access(){return D.promisify(g.access)}get stat(){return D.promisify(g.stat)}get lstat(){return D.promisify(g.lstat)}get utimes(){return D.promisify(g.utimes)}get read(){return D.promisify(g.read)}get readFile(){return D.promisify(g.readFile)}get write(){return D.promisify(g.write)}get appendFile(){return D.promisify(g.appendFile)}get fdatasync(){return D.promisify(g.fdatasync)}get truncate(){return D.promisify(g.truncate)}get rename(){return D.promisify(g.rename)}get copyFile(){return D.promisify(g.copyFile)}get open(){return D.promisify(g.open)}get close(){return D.promisify(g.close)}get symlink(){return D.promisify(g.symlink)}get readlink(){return D.promisify(g.readlink)}get chmod(){return D.promisify(g.chmod)}get mkdir(){return D.promisify(g.mkdir)}get unlink(){return D.promisify(g.unlink)}get rmdir(){return D.promisify(g.rmdir)}get realpath(){return D.promisify(g.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return d}get move(){return _}get copy(){return C}}}),define(J[82],Z([0,1,29,23,8,18]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const b=D.dirname(i);if(i===b)return i;const k=(D.basename(i)||i).toLowerCase();try{const d=S.readdirSync(b).filter(m=>m.toLowerCase()===k);if(d.length===1){const m=E(b);if(m)return D.join(m,d[0])}else if(d.length>1){const m=d.indexOf(k);if(m>=0){const P=E(b);if(P)return D.join(P,d[m])}}}catch(y){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(b){const k=v(i);return await S.Promises.access(k,g.constants.R_OK),k}}e.realpath=n;function w(i){try{return g.realpathSync(i)}catch(b){const k=v(i);return g.accessSync(k,g.constants.R_OK),k}}e.realpathSync=w;function v(i){return M.rtrim(D.normalize(i),D.sep)}}),define(J[116],Z([0,1,59]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function M(n,w,v){let i=!1;return new Promise(b=>{const k=setTimeout(()=>{if(!i)return i=!0,b(0)},v);D(n,w,y=>{if(!i)return i=!0,clearTimeout(k),b(y)})})}e.findFreePort=M;function D(n,w,v){if(w===0)return v(0);const i=new g.Socket;i.once("connect",()=>(E(i),D(n+1,w-1,v))),i.once("data",()=>{}),i.once("error",b=>(E(i),b.code!=="ECONNREFUSED"?D(n+1,w-1,v):v(n))),i.connect(n,"127.0.0.1")}function S(n,w,v){let i=!1,b,k=1;const y=g.createServer({pauseOnConnect:!0});function d(m,P){i||(i=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),P(m))}return new Promise(m=>{b=setTimeout(()=>{d(0,m)},v),y.on("listening",()=>{d(n,m)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&k<w?(n++,k++,y.listen(n,"127.0.0.1")):d(0,m)}),y.on("close",()=>{d(0,m)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(w){console.error(w)}}}),define(J[117],Z([0,1,18,26,8]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var w;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(w||(w={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class b{constructor(l,t,s){this.exePath=l,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function k({useAlternateBitness:o=!1}={}){return o?v===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:l=!1}={}){const t=k({useAlternateBitness:o});if(!t)return null;const s=D.join(t,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(s))return null;let r=-1,a=null;for(const f of await g.Promises.readdir(s)){let L=-1;if(l){const _=f.indexOf("-");if(_<0)continue;const C=f.substring(0,_);if(!S.test(C)||f.substring(_+1)!=="preview")continue;L=parseInt(C,10)}else{if(!S.test(f))continue;L=parseInt(f,10)}if(L<=r)continue;const F=D.join(s,f,"pwsh.exe");!await g.SymlinkSupport.existsFile(F)||(a=F,r=L)}if(!a)return null;const u=t.includes("x86")?" (x86)":"",p=l?" Preview":"";return new b(a,`PowerShell${p}${u}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const l=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await g.Promises.readdir(l))if(t.test(r)){const a=D.join(l,r,"pwsh.exe");return new b(a,s)}return null}function m(){const o=D.join(M.homedir(),".dotnet","tools","pwsh.exe");return new b(o,".NET Core PowerShell Global Tool")}function P(){const o=D.join(process.env.windir,v===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(o,"Windows PowerShell",!0)}async function*I(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=m(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*c(){for await(const o of I())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=c;async function h(){for await(const o of c())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[83],Z([0,1,41,10]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(E){return new Promise((n,w)=>{let v;const i=new Map;function b(y,d,m,P,I){const c=i.get(d);if(y===E||c){const h={name:k(m),cmd:m,pid:y,ppid:d,load:P,mem:I};i.set(y,h),y===E&&(v=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((o,l)=>o.pid-l.pid)))}}function k(y){const d=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,I=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(m.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(I.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let o=h.exec(y);if(o&&o.length===2)return o[1]==="renderer"?d.exec(y)?"shared-process":"window":o[1];const l=/[a-zA-Z-]+\.js/g;let t="";do o=l.exec(y),o&&(t+=o+" ");while(o);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,m)=>{q(["windows-process-tree"],d,m)}).then(d=>{d.getProcessList(E,m=>{d.getProcessCpuUsage(m,P=>{const I=new Map;P.forEach(c=>{const h=y(c.commandLine||"");I.set(c.pid,{name:k(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),v=I.get(E),v?(I.forEach(c=>{const h=I.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),I.forEach(c=>{c.children&&(c.children=c.children.sort((h,o)=>h.pid-o.pid))}),n(v)):w(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[v];const m=[];for(;d.length;){const I=d.shift();I&&(m.push(I.pid),I.children&&(d=d.concat(I.children)))}let P=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);P+=" "+m.join(" "),g.exec(P,{},(I,c,h)=>{if(I||h)w(I||new Error(h.toString()));else{const o=c.toString().split(`
`);for(let l=0;l<m.length;l++){const t=i.get(m[l]);t.load=parseFloat(o[l])}if(!v){w(new Error(`Root process ${E} not found`));return}n(v)}})};g.exec("which ps",{},(d,m,P)=>{if(d||P)if(process.platform!=="linux")w(d||new Error(P.toString()));else{const I=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);g.exec(I,{},(c,h,o)=>{c||o?w(c||new Error(o.toString())):(S(h,b),y())})}else{const I=m.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";g.exec(`${I} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,l)=>{h||l&&!l.includes("screen size is bogus")?w(h||new Error(l.toString())):(S(o,b),process.platform==="linux"?y():v?n(v):w(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=D;function S(E,n){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=E.toString().split(`
`);for(const i of v){const b=w.exec(i.trim());b&&b.length===6&&n(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(J[118],Z([0,1,8,29,3,65,2,18]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(b,k,y){return i({path:b,isDirectory:!1},k,y)}e.watchFile=w;function v(b,k,y){return i({path:b,isDirectory:!0},k,y)}e.watchFolder=v,e.CHANGE_BUFFER_DELAY=100;function i(b,k,y){const d=g.basename(b.path),m=new Map;let P=!1,I=[E.toDisposable(()=>{m.forEach(c=>E.dispose(c)),m.clear()})];try{const c=M.watch(b.path);I.push(E.toDisposable(()=>{c.removeAllListeners(),c.close()}));const h=new Set;b.isDirectory&&n.Promises.readdir(b.path).then(o=>o.forEach(l=>h.add(l))),c.on("error",(o,l)=>{P||y(`Failed to watch ${b.path} for changes using fs.watch() (${o}, ${l})`)}),c.on("change",(o,l)=>{if(P)return;let t="";if(l&&(t=l.toString(),D.isMacintosh&&(t=S.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const s=b.isDirectory?g.join(b.path,t):b.path;if(b.isDirectory)if(o==="rename"){const r=m.get(s);r&&E.dispose(r);const a=setTimeout(async()=>{m.delete(s);const u=await n.Promises.exists(s);if(P)return;let p;u?h.has(t)?p="changed":(p="added",h.add(t)):(h.delete(t),p="deleted"),k(p,s)},e.CHANGE_BUFFER_DELAY);m.set(s,E.toDisposable(()=>clearTimeout(a)))}else{let r;h.has(t)?r="changed":(r="added",h.add(t)),k(r,s)}else if(o==="rename"||t!==d){const r=setTimeout(async()=>{const a=await n.Promises.exists(s);P||(a?(k("changed",s),I=[i(b,k,y)]):k("deleted",s))},e.CHANGE_BUFFER_DELAY);E.dispose(I),I=[E.toDisposable(()=>clearTimeout(r))]}else k("changed",s)})}catch(c){n.Promises.exists(b.path).then(h=>{h&&!P&&y(`Failed to watch ${b.path} for changes using fs.watch() (${c.toString()})`)})}return E.toDisposable(()=>{P=!0,I=E.dispose(I)})}}),define(J[119],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[120],Z([0,1,14,119,13]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){g.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,w,v,i,b)=>{const k=E(n,i,v);k.popup({window:D.withNullAsUndefined(g.BrowserWindow.fromWebContents(n.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{k&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function E(n,w,v){const i=new g.Menu;return v.forEach(b=>{let k;b.type==="separator"?k=new g.MenuItem({type:b.type}):Array.isArray(b.submenu)?k=new g.MenuItem({submenu:E(n,w,b.submenu),label:b.label}):k=new g.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,d,m)=>n.sender.send(w,b.id,m)}),i.append(k)}),i}});var he=this&&this.__decorate||function(q,e,g,M){var D=arguments.length,S=D<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,g):M,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(q,e,g,M);else for(var n=q.length-1;n>=0;n--)(E=q[n])&&(S=(D<3?E(S):D>3?E(e,g,S):E(e,g))||S);return D>3&&S&&Object.defineProperty(e,g,S),S};define(J[34],Z([0,1,5,2,9,25,16,17,36,13,111,23,47]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function P(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(I||(I={}));class c{constructor(R){this.buffer=R,this.pos=0}read(R){const O=this.buffer.slice(this.pos,this.pos+R);return this.pos+=O.byteLength,O}}class h{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var o;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(o||(o={}));function l(T){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(T,0),R}function t(T){return T.read(4).readUInt32BE(0)}function s(T){const R=n.VSBuffer.alloc(1);return R.writeUInt8(T,0),R}const r={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},a=typeof Buffer!="undefined";function u(T,R){if(typeof R=="undefined")T.write(r.Undefined);else if(typeof R=="string"){const O=n.VSBuffer.fromString(R);T.write(r.String),T.write(l(O.byteLength)),T.write(O)}else if(a&&Buffer.isBuffer(R)){const O=n.VSBuffer.wrap(R);T.write(r.Buffer),T.write(l(O.byteLength)),T.write(O)}else if(R instanceof n.VSBuffer)T.write(r.VSBuffer),T.write(l(R.byteLength)),T.write(R);else if(Array.isArray(R)){T.write(r.Array),T.write(l(R.length));for(const O of R)u(T,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(R));T.write(r.Object),T.write(l(O.byteLength)),T.write(O)}}function p(T){switch(T.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return T.read(t(T)).toString();case o.Buffer:return T.read(t(T)).buffer;case o.VSBuffer:return T.read(t(T));case o.Array:{const O=t(T),W=[];for(let A=0;A<O;A++)W.push(p(T));return W}case o.Object:return JSON.parse(T.read(t(T)).toString())}}class f{constructor(R,O,W=null,A=1e3){this.protocol=R,this.ctx=O,this.logger=W,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(R,O){this.channels.set(R,O),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const O=this.send([R.type]);this.logger&&this.logger.logOutgoing(O,0,1,P(R.type));return}case 201:case 202:case 204:case 203:{const O=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(O,R.id,1,P(R.type),R.data);return}}}send(R,O=void 0){const W=new h;return u(W,R),u(W,O),this.sendBuffer(W.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onRawMessage(R){const O=new c(R),W=p(O),A=p(O),N=W[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,W[1],1,`${d(N)}: ${W[2]}.${W[3]}`,A),this.onPromise({type:N,id:W[1],channelName:W[2],name:W[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,W[1],1,`${d(N)}: ${W[2]}.${W[3]}`,A),this.onEventListen({type:N,id:W[1],channelName:W[2],name:W[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,W[1],1,`${d(N)}`),this.disposeActiveRequest({type:N,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,W[1],1,`${d(N)}`),this.disposeActiveRequest({type:N,id:W[1]})}}onPromise(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const W=new S.CancellationTokenSource;let A;try{A=O.call(this.ctx,R.name,R.arg,W.token)}catch(Y){A=Promise.reject(Y)}const N=R.id;A.then(Y=>{this.sendResponse({id:N,data:Y,type:201}),this.activeRequests.delete(R.id)},Y=>{Y instanceof Error?this.sendResponse({id:N,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:N,data:Y,type:203}),this.activeRequests.delete(R.id)});const z=M.toDisposable(()=>W.cancel());this.activeRequests.set(R.id,z)}onEventListen(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const W=R.id,N=O.listen(this.ctx,R.name,R.arg)(z=>this.sendResponse({id:W,data:z,type:204}));this.activeRequests.set(R.id,N)}disposeActiveRequest(R){const O=this.activeRequests.get(R.id);O&&(O.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let O=this.pendingRequests.get(R.channelName);O||(O=[],this.pendingRequests.set(R.channelName,O));const W=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:R,timeoutTimer:W})}flushPendingRequests(R){const O=this.pendingRequests.get(R);if(O){for(const W of O)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var L;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class F{constructor(R,O=null){this.protocol=R,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=O}getChannel(R){const O=this;return{call(W,A,N){return O.isDisposed?Promise.reject(E.canceled()):O.requestPromise(R,W,A,N)},listen(W,A){return O.isDisposed?Promise.reject(E.canceled()):O.requestEvent(R,W,A)}}}requestPromise(R,O,W,A=S.CancellationToken.None){const N=this.lastRequestId++,Y={id:N,type:100,channelName:R,name:O,arg:W};if(A.isCancellationRequested)return Promise.reject(E.canceled());let G;return new Promise((ne,se)=>{if(A.isCancellationRequested)return se(E.canceled());const ue=()=>{const Ee=ve=>{switch(ve.type){case 201:this.handlers.delete(N),ne(ve.data);break;case 202:this.handlers.delete(N);const be=new Error(ve.data.message);be.stack=ve.data.stack,be.name=ve.data.name,se(be);break;case 203:this.handlers.delete(N),se(ve.data);break}};this.handlers.set(N,Ee),this.sendRequest(Y)};let de=null;this.state===I.Idle?ue():(de=D.createCancelablePromise(Ee=>this.whenInitialized()),de.then(()=>{de=null,ue()}));const re=()=>{de?(de.cancel(),de=null):this.sendRequest({id:N,type:101}),se(E.canceled())},le=A.onCancellationRequested(re);G=M.combinedDisposable(M.toDisposable(re),le),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(R,O,W){const A=this.lastRequestId++,z={id:A,type:102,channelName:R,name:O,arg:W};let Y=null;const G=new g.Emitter({onFirstListenerAdd:()=>{Y=D.createCancelablePromise(ne=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(G),this.sendRequest(z)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(G),this.sendRequest({id:A,type:103}))}}),X=ne=>G.fire(ne.data);return this.handlers.set(A,X),G.event}sendRequest(R){switch(R.type){case 100:case 102:{const O=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(O,R.id,0,`${d(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const O=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(O,R.id,0,d(R.type));return}}}send(R,O=void 0){const W=new h;return u(W,R),u(W,O),this.sendBuffer(W.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onBuffer(R){const O=new c(R),W=p(O),A=p(O),N=W[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,P(N)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,W[1],0,P(N),A),this.onResponse({type:W[0],id:W[1],data:A})}}onResponse(R){if(R.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(R.id);O&&O(R)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}he([k.memoize],F.prototype,"onDidInitializePromise",null),e.ChannelClient=F;class _{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:O,onDidClientDisconnect:W})=>{g.Event.once(O.onMessage)(N=>{const z=new c(N),Y=p(z),G=new f(O,Y),X=new F(O);this.channels.forEach((se,ue)=>G.registerChannel(ue,se));const ne={channelServer:G,channelClient:X,ctx:Y};this._connections.add(ne),this._onDidAddConnection.fire(ne),W(()=>{G.dispose(),X.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(O=>R.push(O)),R}getChannel(R,O){const W=this;return{call(A,N,z){let Y;if(v.isFunction(O)){let X=w.getRandomElement(W.connections.filter(O));Y=X?Promise.resolve(X):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,O))}else Y=O.routeCall(W,A,N);const G=Y.then(X=>X.channelClient.getChannel(R));return K(G).call(A,N,z)},listen(A,N){if(v.isFunction(O))return W.getMulticastEvent(R,O,A,N);const z=O.routeEvent(W,A,N).then(Y=>Y.channelClient.getChannel(R));return K(z).listen(A,N)}}}getMulticastEvent(R,O,W,A){const N=this;let z=new M.DisposableStore;const Y=new g.Emitter({onFirstListenerAdd:()=>{z=new M.DisposableStore;const G=new g.EventMultiplexer,X=new Map,ne=ue=>{const re=ue.channelClient.getChannel(R).listen(W,A),le=G.add(re);X.set(ue,le)},se=ue=>{const de=X.get(ue);!de||(de.dispose(),X.delete(ue))};N.connections.filter(O).forEach(ne),g.Event.filter(N.onDidAddConnection,O)(ne,void 0,z),N.onDidRemoveConnection(se,void 0,z),G.event(Y.fire,Y,z),z.add(G)},onLastListenerRemove:()=>{z.dispose()}});return Y.event}registerChannel(R,O){this.channels.set(R,O),this._connections.forEach(W=>{W.channelServer.registerChannel(R,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=_;class C{constructor(R,O,W=null){const A=new h;u(A,O),R.send(A.buffer),this.channelClient=new F(R,W),this.channelServer=new f(R,O,W)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,O){this.channelServer.registerChannel(R,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function K(T){return{call(R,O,W){return T.then(A=>A.call(R,O,W))},listen(R,O){const W=new g.Relay;return T.then(A=>W.input=A.listen(R,O)),W.event}}}e.getDelayedChannel=K;function ee(T){let R=!1;return{call(O,W,A){return R?T.call(O,W,A):D.timeout(0).then(()=>R=!0).then(()=>T.call(O,W,A))},listen(O,W){if(R)return T.listen(O,W);const A=new g.Relay;return D.timeout(0).then(()=>R=!0).then(()=>A.input=T.listen(O,W)),A.event}}}e.getNextTickChannel=ee;class V{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const O of R.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await g.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=V;var x;(function(T){function R(A,N){const z=A,Y=N&&N.disableMarshalling,G=new Map;for(const X in z)W(X)&&G.set(X,g.Event.buffer(z[X],!0));return new class{listen(X,ne){const se=G.get(ne);if(se)return se;throw new Error(`Event not found: ${ne}`)}call(X,ne,se){const ue=z[ne];if(typeof ue=="function"){if(!Y&&Array.isArray(se))for(let de=0;de<se.length;de++)se[de]=i.revive(se[de]);return ue.apply(z,se)}throw new Error(`Method not found: ${ne}`)}}}T.fromService=R;function O(A,N){const z=N&&N.disableMarshalling;return new Proxy({},{get(Y,G){if(typeof G=="string")return N?.properties?.has(G)?N.properties.get(G):W(G)?A.listen(G):async function(...X){let ne;N&&!v.isUndefinedOrNull(N.context)?ne=[N.context,...X]:ne=X;const se=await A.call(G,ne);return z?se:i.revive(se)};throw new Error(`Property not found: ${String(G)}`)}})}T.toService=O;function W(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let R=T.toString();if(R!=="[object Object]")return R}return T}function $(T){return Array.isArray(T)?T.map(U):U(T)}function H(T,R,O,W,A,N,z){z=$(z);const Y=Q[A],G=Y[W%Y.length];let X=[`%c[${T}]%c[${String(R).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(N)?(X=X.concat(z),X.push(")")):X.push(z),console.log.apply(console,X)}e.logWithColors=H;class B{constructor(R,O){this._outgoingPrefix=R,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,O,W,A,N){this._totalOutgoing+=R,H(this._outgoingPrefix,this._totalOutgoing,R,O,W,A,N)}logIncoming(R,O,W,A,N){this._totalIncoming+=R,H(this._incomingPrefix,this._totalIncoming,R,O,W,A,N)}}e.IPCLogger=B}),define(J[121],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class g{constructor(D,S){this.sender=D,this.onMessage=S}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=g}),define(J[122],Z([0,1,5,34,17]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=g.Event.fromDOMEventEmitter(this.port,"message",v=>D.VSBuffer.wrap(v.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends M.IPCClient{constructor(w,v){const i=new S(w);super(i,v);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],Z([0,1,5,34,2,17,3,33]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let v=null;function i(){return v||(v=S.VSBuffer.alloc(0)),v}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,u){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const F=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=a),F}if(this._chunks[0].byteLength>a){const F=this._chunks[0].slice(0,a);return u&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),F}let p=S.VSBuffer.alloc(a),f=0,L=0;for(;a>0;){const F=this._chunks[L];if(F.byteLength>a){const _=F.slice(0,a);p.set(_,f),f+=a,u&&(this._chunks[L]=F.slice(a),this._totalLength-=a),a-=a}else p.set(F,f),f+=F.byteLength,u?(this._chunks.shift(),this._totalLength-=F.byteLength):L++,a-=F.byteLength}return p}}e.ChunkStream=b;var k;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(a,u,p,f){this.type=a,this.id=u,this.ack=p,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(a){super();this._onMessage=this._register(new g.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const p=this._state.messageType,f=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(p,f,L,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=S.VSBuffer.alloc(13);u.writeUInt8(a.type,0),u.writeUInt32BE(a.id,1),u.writeUInt32BE(a.ack,5),u.writeUInt32BE(a.data.byteLength,9),this._writeSoon(u,a.data)}_bufferAdd(a,u){const p=this._totalLength===0;return this._data.push(a,u),this._totalLength+=a.byteLength+u.byteLength,p}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,u){this._bufferAdd(a,u)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends D.Disposable{constructor(a){super();this._onMessage=new g.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new d(1,0,0,a))}}e.Protocol=I;class c extends M.IPCClient{constructor(a,u,p=null){super(a,u,p);this.protocol=a}static fromSocket(a,u){return new c(new I(a),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new g.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(a){this.data=a,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],u=0,p=this._first;for(;p;)a[u++]=p.data,p=p.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const u=new o(a);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class t{constructor(){this.lastRuns=[];const a=Date.now();for(let u=0;u<t._HISTORY_LENGTH;u++)this.lastRuns[u]=a-1e3*u;setInterval(()=>{for(let u=t._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const a=Date.now(),u=(1+t._HISTORY_LENGTH)*1e3;let p=0;for(let f=0;f<t._HISTORY_LENGTH;f++)a-this.lastRuns[f]<=u&&p++;return 1-p/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(a,u=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=D.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new d(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const u=new d(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,u){this._isReconnecting=!0,this._socketDisposables=D.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let u=0,p=a.length;u<p;u++)this._socketWriter.write(a[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const u=this._outgoingUnackMsg.toArray();for(let p=0,f=u.length;p<f;p++)this._socketWriter.write(u[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new d(1,u,this._incomingAckId,a);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(a){const u=new d(2,0,0,a);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),u=Date.now()-a.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new d(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}e.PersistentProtocol=s}),define(J[123],Z([0,1,14,5,34,121,2,17]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(i,b){const k=M.Event.fromNodeEventEmitter(g.ipcMain,b,(d,m)=>({event:d,message:m})),y=M.Event.filter(k,({event:d})=>d.sender.id===i);return M.Event.map(y,({message:d})=>d&&n.VSBuffer.wrap(d))}class v extends D.IPCServer{constructor(){super(v.getOnDidClientConnect())}static getOnDidClientConnect(){const b=M.Event.fromNodeEventEmitter(g.ipcMain,"vscode:hello",({sender:k})=>k);return M.Event.map(b,k=>{const y=k.id,d=v.Clients.get(y);d&&d.dispose();const m=new M.Emitter;v.Clients.set(y,E.toDisposable(()=>m.fire()));const P=w(y,"vscode:message"),I=M.Event.any(M.Event.signal(w(y,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(k,P),onDidClientDisconnect:I}})}}e.Server=v,v.Clients=new Map}),define(J[85],Z([0,1,14,5,28,122]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(v,i){super({addEventListener:(b,k)=>v.addListener(b,k),removeEventListener:(b,k)=>v.removeListener(b,k),postMessage:b=>v.postMessage(b),start:()=>v.start(),close:()=>v.close()},i)}}e.Client=E;async function n(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const v=D.generateUuid();w.webContents.send("vscode:createMessageChannel",v);const i=M.Event.fromNodeEventEmitter(g.ipcMain,"vscode:createMessageChannelResult",(k,y)=>({nonce:y,port:k.ports[0]})),{port:b}=await M.Event.toPromise(M.Event.once(M.Event.filter(i,k=>k.nonce===v)));return b}e.connect=n}),define(J[86],Z([0,1,2,5,9,13]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class w extends g.Disposable{constructor(b,k=Object.create(null)){super();this.database=b,this.options=k,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((k,y)=>this.accept(y,k)),b.deleted?.forEach(k=>this.accept(k,void 0))}accept(b,k){if(this.state===n.Closed)return;let y=!1;S.isUndefinedOrNull(k)?y=this.cache.delete(b):this.cache.get(b)!==k&&(this.cache.set(b,k),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,k){const y=this.cache.get(b);return S.isUndefinedOrNull(y)?k:y}getBoolean(b,k){const y=this.get(b);return S.isUndefinedOrNull(y)?k:y==="true"}getNumber(b,k){const y=this.get(b);return S.isUndefinedOrNull(y)?k:parseInt(y,10)}async set(b,k){if(this.state===n.Closed)return;if(S.isUndefinedOrNull(k))return this.delete(b);const y=String(k);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===n.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class v{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((k,y)=>this.items.set(y,k)),b.delete&&b.delete.forEach(k=>this.items.delete(k))}async close(){}}e.InMemoryStorageDatabase=v}),define(J[124],Z([0,1,5,9,37,8,18]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,b=Object.create(null)){this.path=i,this.options=b,this.name=S.basename(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return g.Event.None}async getItems(){const i=await this.whenConnected,b=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(i){const b=await this.whenConnected;return this.doUpdateItems(b,i)}doUpdateItems(i,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?D.mapToString(b.insert):"0"}), delete(${b.delete?D.setToString(b.delete):"0"})`),this.transaction(i,()=>{const k=b.insert,y=b.delete;if(k&&k.size>0){const d=[];d.push([]);let m=0;k.forEach((P,I)=>{let c=d[m];c.length>n.MAX_HOST_PARAMETERS&&(m++,c=[],d.push(c)),c.push(I,P)}),d.forEach(P=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,I=>I.run(P),()=>{const I=[];let c=0;return k.forEach((h,o)=>{I.push(o),c+=h.length}),`Keys: ${I.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let m=0;y.forEach(P=>{let I=d[m];I.length>n.MAX_HOST_PARAMETERS&&(m++,I=[],d.push(I)),I.push(P)}),d.forEach(P=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,I=>I.run(P),()=>{const I=[];return y.forEach(c=>{I.push(c)}),`Keys: ${I.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,i)}doClose(i,b){return new Promise((k,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?k():!i.isErroneous&&!i.isInMemory?this.backup().then(k,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),k())):typeof b=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const P=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:b()}).then(()=>P(),I=>(P(),Promise.reject(I)))})).then(k,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const b=await this.whenConnected,k=await this.get(b,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?k.integrity_check:k.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(i,b=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${b})`);try{return await this.doConnect(i)}catch(k){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&b)return await M.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,b){i.isErroneous=!0,i.lastError=b,this.logger.error(b)}doConnect(i){return new Promise((b,k)=>{new Promise((y,d)=>{q(["vscode-sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,m=>m?d.db?d.db.close(()=>k(m)):k(m):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),P=>d.db.close(()=>k(P)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",m=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&d.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},k)})}exec(i,b){return new Promise((k,y)=>{i.db.exec(b,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):k())})}get(i,b){return new Promise((k,y)=>{i.db.get(b,(d,m)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):k(m))})}all(i,b){return new Promise((k,y)=>{i.db.all(b,(d,m)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):k(m))})}transaction(i,b){return new Promise((k,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),b(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):k())})})}prepare(i,b,k,y){const d=i.db.prepare(b),m=P=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${P} (${b}). Details: ${y()}`)};d.on("error",m),k(d),d.finalize(P=>{P&&m(P),d.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class w{constructor(i){i&&typeof i.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[125],Z([12,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[126],Z([0,1,125]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,D=M*60,S=D*24,E=S*7,n=S*30,w=S*365;function v(b,k){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return g.localize(0,null,v(new Date().getTime()+y*1e3,!1));if(y<30)return g.localize(1,null);let d;return y<M?(d=y,k?d===1?g.localize(2,null,d):g.localize(3,null,d):d===1?g.localize(4,null,d):g.localize(5,null,d)):y<D?(d=Math.floor(y/M),k?d===1?g.localize(6,null,d):g.localize(7,null,d):d===1?g.localize(8,null,d):g.localize(9,null,d)):y<S?(d=Math.floor(y/D),k?d===1?g.localize(10,null,d):g.localize(11,null,d):d===1?g.localize(12,null,d):g.localize(13,null,d)):y<E?(d=Math.floor(y/S),k?d===1?g.localize(14,null,d):g.localize(15,null,d):d===1?g.localize(16,null,d):g.localize(17,null,d)):y<n?(d=Math.floor(y/E),k?d===1?g.localize(18,null,d):g.localize(19,null,d):d===1?g.localize(20,null,d):g.localize(21,null,d)):y<w?(d=Math.floor(y/n),k?d===1?g.localize(22,null,d):g.localize(23,null,d):d===1?g.localize(24,null,d):g.localize(25,null,d)):(d=Math.floor(y/w),k?d===1?g.localize(26,null,d):g.localize(27,null,d):d===1?g.localize(28,null,d):g.localize(29,null,d))}e.fromNow=v;function i(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[127],Z([12,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,127,13,36]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(v,i){return i&&(v.stack||v.stacktrace)?g.localize(0,null,n(v),E(v.stack)||E(v.stacktrace)):n(v)}function E(v){return Array.isArray(v)?v.join(`
`):v}function n(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?g.localize(1,null,v.message):v.message||g.localize(2,null)}function w(v=null,i=!1){if(!v)return g.localize(3,null);if(Array.isArray(v)){const b=D.coalesce(v),k=w(b[0],i);return b.length>1?g.localize(4,null,k,b.length):k}if(M.isString(v))return v;if(v.detail){const b=v.detail;if(b.error)return S(b.error,i);if(b.exception)return S(b.exception,i)}return v.stack?S(v,i):v.message?v.message:g.localize(5,null)}e.toErrorMessage=w}),define(J[128],Z([12,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(J[129],Z([0,1,128]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class M{constructor(E,n,w=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=w}toLabel(E,n,w){if(n.length===0)return null;const v=[];for(let i=0,b=n.length;i<b;i++){const k=n[i],y=w(k);if(y===null)return null;v[i]=D(k,y,this.modifierLabels[E])}return v.join(" ")}}e.ModifierLabelProvider=M,e.UILabelProvider=new M({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:g.localize(0,null),shiftKey:g.localize(1,null),altKey:g.localize(2,null),metaKey:g.localize(3,null),separator:"+"},{ctrlKey:g.localize(4,null),shiftKey:g.localize(5,null),altKey:g.localize(6,null),metaKey:g.localize(7,null),separator:"+"}),e.AriaLabelProvider=new M({ctrlKey:g.localize(8,null),shiftKey:g.localize(9,null),altKey:g.localize(10,null),metaKey:g.localize(11,null),separator:"+"},{ctrlKey:g.localize(12,null),shiftKey:g.localize(13,null),altKey:g.localize(14,null),metaKey:g.localize(15,null),separator:"+"},{ctrlKey:g.localize(16,null),shiftKey:g.localize(17,null),altKey:g.localize(18,null),metaKey:g.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new M({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new M({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(S,E,n){if(E===null)return"";const w=[];return S.ctrlKey&&w.push(n.ctrlKey),S.shiftKey&&w.push(n.shiftKey),S.altKey&&w.push(n.altKey),S.metaKey&&w.push(n.metaKey),E!==""&&w.push(E),w.join(n.separator)}}),define(J[130],Z([12,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,18,41,130,33,13,44,30,3,81,10]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,l){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};l&&(t.cwd=l);const s=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,u)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?y(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(s=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,u)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o=E.env){return o.comspec||"cmd.exe"}e.getWindowsShell=m;class P{constructor(l,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=l,this.args=t,this.shell=s,this.options=r;else{const a=l;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(E.env).forEach(u=>{a[u]=E.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const t=l.lastIndexOf(g.sep);return t!==-1&&(l=l.substring(t+1)),P.WellKnowCommands[l]?l:"other"}start(l){return i.isWindows&&(this.options&&this.options.cwd&&v.isUNC(this.options.cwd)||!this.options&&v.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let s,r;const a=new Promise((u,p)=>{s=u,r=p});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(p,f,L)=>{this.childProcess=null;const F=p;F&&F.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:L.toString()}):this.handleExec(s,l,p,f,L)})}else{let u=null;const p=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,s,l,r);const L={terminated:this.terminateRequested};n.isNumber(f)&&(L.cmdCode=f),s(L)};if(this.shell&&i.isWindows){const f=w.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let L=!1,F=!1;const _=[];let C=this.ensureQuotes(this.cmd);_.push(C.value),L=C.quoted,this.args&&this.args.forEach(ee=>{C=this.ensureQuotes(ee),_.push(C.value),F=F&&C.quoted});const K=["/s","/c"];L?F?K.push('"'+_.join(" ")+'"'):_.length>1?K.push('"'+_[0]+'" '+_.slice(1).join(" ")):K.push('"'+_[0]+'"'):K.push(_.join(" ")),u=D.spawn(m(),K,f)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(n.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),u.pid&&(this.childProcess.on("close",p),this.handleSpawn(u,s,l,r,!0)))}return a})}handleClose(l,t,s,r){}ensureQuotes(l){return P.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,d(l,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!i.isWindows)return l(!1);const t=D.spawn(m(),["/s","/c"]);t.on("error",s=>l(!0)),t.on("exit",s=>l(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class I extends P{constructor(l,t,s,r){super(l,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,t,s,r,a){[r,a].forEach((u,p)=>{const f=new b.LineDecoder;f.write(u).forEach(_=>{t({line:_,source:p===0?0:1})});const F=f.end();F&&t({line:F,source:p===0?0:1})}),l({terminated:this.terminateRequested,error:s})}handleSpawn(l,t,s,r,a){const u=new b.LineDecoder,p=new b.LineDecoder;l.stdout.on("data",f=>{u.write(f).forEach(F=>s({line:F,source:0}))}),l.stderr.on("data",f=>{p.write(f).forEach(F=>s({line:F,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=p}handleClose(l,t,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&s({line:u,source:1})}}e.LineProcess=I;function c(o){let l=[],t=!1;const s=function(r){if(t){l.push(r);return}(!o.send(r,u=>{if(u&&console.error(u),t=!1,l.length>0){const p=l.slice(0);l=[],p.forEach(f=>s(f))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=c;var h;(function(o){async function l(t,s,r){if(g.isAbsolute(t))return t;if(s===void 0&&(s=E.cwd()),g.dirname(t)!=="."||(r===void 0&&n.isString(E.env.PATH)&&(r=E.env.PATH.split(g.delimiter)),r===void 0||r.length===0))return g.join(s,t);async function u(p){return await M.Promises.exists(p)?!(await M.Promises.stat(p)).isDirectory():!1}for(let p of r){let f;if(g.isAbsolute(p)?f=g.join(p,t):f=g.join(s,p,t),await u(f))return f;let L=f+".com";if(await u(L)||(L=f+".exe",await u(L)))return L}return g.join(s,t)}o.findExecutable=l})(h=e.win32||(e.win32={}))}),define(J[131],Z([0,1,26,3,117,68]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,d){return y===1?M.isWindows?b():S.getWindowsShell(d):v(y,d)}e.getSystemShell=E;function n(y,d){return y===1?M.isWindows?k(d):S.getWindowsShell(d):v(y,d)}e.getSystemShellSync=n;let w=null;function v(y,d){if(M.isLinux&&y===2||M.isMacintosh&&y===3)return"/bin/bash";if(!w){let m;if(M.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=g.userInfo().shell}catch(P){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}w=m}return w}let i=null;async function b(){return i||(i=(await D.getFirstAvailablePowerShellInstallation()).exePath),i}function k(y){if(i)return i;const d=M.isWindows&&parseFloat(g.release())>=10,m=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:S.getWindowsShell(y)}}),define(J[87],Z([0,1,41,2,9,44,5,68,34,110,25,16,17,3]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(I){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",c=>k.VSBuffer.wrap(Buffer.from(c,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(I,c){this.modulePath=I,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new D.Delayer(h),this.child=null,this._client=null}getChannel(I){const c=this;return{call(h,o,l){return c.requestPromise(I,h,o,l)},listen(h,o){return c.requestEvent(I,h,o)}}}requestPromise(I,c,h,o=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(I),t=D.createCancelablePromise(a=>l.call(c,h,a)),s=o.onCancellationRequested(()=>t.cancel()),r=M.toDisposable(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,c,h){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let o;const l=new E.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(I).listen(c,h)(l.fire,l),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...S.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),y.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=g.fork(this.modulePath,I,c);const h=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(v.isRemoteConsoleLog(u)){v.log(u,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(u,"base64")))});const l=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&l.send(u.buffer.toString("base64")),s=h.event,r={send:t,onMessage:s};this._client=new w.ChannelClient(r);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,p)=>{process.removeListener("exit",a),this.activeRequests.forEach(f=>M.dispose(f)),this.activeRequests.clear(),u!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:p})})}return this._client}getCachedChannel(I){let c=this.channels.get(I);return c||(c=this.client.getChannel(I),this.channels.set(I,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(J[132],Z([12,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[133],Z([12,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[134],Z([12,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[135],Z([12,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[136],Z([12,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[137],Z([12,11]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[138],Z([12,11]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[139],Z([12,11]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[140],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[141],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[142],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[143],Z([12,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[144],Z([12,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[145],Z([12,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[146],Z([12,11]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[147],Z([12,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[148],Z([12,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[149],Z([12,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[150],Z([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(J[151],Z([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[152],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/common/workspaces",e)}),define(J[153],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[154],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[155],Z([0,1,5,2]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new g.Emitter,this._onReloadEmitter=new g.Emitter,this._onTerminateEmitter=new g.Emitter,this._onAttachEmitter=new g.Emitter}call(n,w,v){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(n,w,v){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class S extends M.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,w,v){this.channel.call("attach",[n,w,v])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,w){this.channel.call("terminate",[n,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,w,v){return this.channel.call("openExtensionDevelopmentHostWindow",[n,w||{},v])}}e.ExtensionHostDebugChannelClient=S}),define(J[156],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class g{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,w){switch(n){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1]);case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=g;class M{constructor(E){this.channel=E}click(E,n,w){return this.channel.call("click",[E,n,w])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,w){return this.channel.call("getElementXY",[E,n,w])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=M;class D{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=D}),define(J[157],Z([0,1,8,15,47,126,10,7,33]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class v{constructor(d,m,P){this._args=d,this.paths=m,this.productService=P}get appRoot(){return g.dirname(E.FileAccess.asFileUri("",q).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(g.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return M.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return M.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=g.join(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(g.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return M.joinPath(n.URI.file(g.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return M.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return M.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=w.env.VSCODE_PORTABLE;return d?n.URI.file(g.join(d,"argv.json")):M.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return M.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(g.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return g.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?g.resolve(d):g.normalize(g.join(E.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?g.resolve(d):g.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return g.resolve(d);const m=w.env.VSCODE_EXTENSIONS;if(m)return m;const P=w.env.VSCODE_PORTABLE;return P?g.join(P,"extensions"):M.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file(g.normalize(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file(g.normalize(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return M.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(g.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([D.memoize],v.prototype,"appRoot",null),he([D.memoize],v.prototype,"userHome",null),he([D.memoize],v.prototype,"userDataPath",null),he([D.memoize],v.prototype,"appSettingsHome",null),he([D.memoize],v.prototype,"tmpDir",null),he([D.memoize],v.prototype,"userRoamingDataHome",null),he([D.memoize],v.prototype,"settingsResource",null),he([D.memoize],v.prototype,"userDataSyncHome",null),he([D.memoize],v.prototype,"userDataSyncLogResource",null),he([D.memoize],v.prototype,"sync",null),he([D.memoize],v.prototype,"machineSettingsResource",null),he([D.memoize],v.prototype,"globalStorageHome",null),he([D.memoize],v.prototype,"workspaceStorageHome",null),he([D.memoize],v.prototype,"keybindingsResource",null),he([D.memoize],v.prototype,"keyboardLayoutResource",null),he([D.memoize],v.prototype,"argvResource",null),he([D.memoize],v.prototype,"snippetsHome",null),he([D.memoize],v.prototype,"isExtensionDevelopment",null),he([D.memoize],v.prototype,"untitledWorkspacesHome",null),he([D.memoize],v.prototype,"installSourcePath",null),he([D.memoize],v.prototype,"builtinExtensionsPath",null),he([D.memoize],v.prototype,"extensionsPath",null),he([D.memoize],v.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],v.prototype,"extensionDevelopmentKind",null),he([D.memoize],v.prototype,"extensionTestsLocationURI",null),he([D.memoize],v.prototype,"debugExtensionHost",null),he([D.memoize],v.prototype,"serviceMachineIdResource",null),he([D.memoize],v.prototype,"telemetryLogResource",null),he([D.memoize],v.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=v;function i(y,d){return k(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=i;function b(y,d){return k(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=b;function k(y,d,m,P,I){const h=Number(d||y)||(P?null:m),o=h?Boolean(!!d):!1;return{port:h,break:o,debugId:I}}}),define(J[88],Z([0,1,240,135,3]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:M.localize(0,null),e:M.localize(1,null),t:M.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:M.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:M.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:M.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:M.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:M.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:M.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:M.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:M.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:M.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:M.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:M.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:M.localize(14,null)},category:{type:"string",cat:"e",description:M.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:M.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:M.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:M.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:M.localize(19,null)},verbose:{type:"boolean",cat:"t",description:M.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:M.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:M.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:M.localize(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:M.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:M.localize(25,null)},sync:{type:"string",cat:"t",description:M.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:M.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:M.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:M.localize(29,null)},"max-memory":{type:"string",cat:"t",description:M.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:M.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,P=E){const I={},c=[],h=[];for(let s in m){const r=m[s];r.alias&&(I[s]=r.alias),r.type==="string"||r.type==="string[]"?(c.push(s),r.deprecates&&c.push(r.deprecates)):r.type==="boolean"&&(h.push(s),r.deprecates&&h.push(r.deprecates))}const o=g(d,{string:c,boolean:h,alias:I}),l={},t=o;l._=o._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in m){const r=m[s];r.alias&&delete t[r.alias];let a=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(a||(a=t[r.deprecates]),delete t[r.deprecates]),typeof a!="undefined"&&(r.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):r.type==="string"&&Array.isArray(a)&&(a=a.pop(),P.onMultipleValues(s,a)),l[s]=a),delete t[s]}for(let s in t)P.onUnknownOption(s);return l}e.parseArgs=n;function w(d,m){let P="";return m.args&&(Array.isArray(m.args)?P=` <${m.args.join("> <")}>`:P=` <${m.args}>`),m.alias?`-${m.alias} --${d}${P}`:`--${d}${P}`}function v(d,m){let P=0,I=[];for(const l in d){const t=d[l],s=w(l,t);P=Math.max(P,s.length),I.push([s,t.description])}let c=P+2+1;if(m-c<25)return I.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=m-c-1,o=[];for(const l of I){let t=l[0],s=b(l[1],h),r=i(c-t.length-2);o.push("  "+t+r+s[0]);for(let a=1;a<s.length;a++)o.push(i(c)+s[a])}return o}e.formatOptions=v;function i(d){return" ".repeat(d)}function b(d,m){let P=[];for(;d.length;){let I=d.length<m?d.length:d.lastIndexOf(" ",m),c=d.slice(0,I).trim();d=d.slice(I),P.push(c)}return P}function k(d,m,P,I,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${P}`];o.push(""),o.push(`${M.localize(32,null)}: ${m} [${M.localize(33,null)}][${M.localize(34,null)}...]`),o.push(""),c&&(D.isWindows?o.push(M.localize(35,null,m)):o.push(M.localize(36,null,m)),o.push(""));const l={};for(const t in I){const s=I[t];if(s.description&&s.cat){let r=l[s.cat];r||(l[s.cat]=r={}),r[t]=s}}for(let t in l){const s=t;let r=l[s];r&&(o.push(S[s]),o.push(...v(r,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=k;function y(d,m){return`${d||M.localize(37,null)}
${m||M.localize(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[158],Z([0,1,88,59,155]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,w,v){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(v[0],v[1],v[2]):super.call(n,w,v)}async openExtensionDevelopmentHostWindow(n,w,v){const i=g.parseArgs(n,g.OPTIONS);i.debugRenderer=v;const b=i.extensionDevelopmentPath;if(!b)return{success:!1};let k;const y=Object.keys(w);for(let h of y){let o=w[h];o===null||(k||(k=Object.create(null)),k[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:i,userEnv:k});if(!v)return{success:!0};const m=d.win;if(!m)return{success:!0};const P=m.webContents.debugger;let I=P.isAttached()?Infinity:0;const c=M.createServer(h=>{I++==0&&P.attach();let o=!1;const l=r=>{o||h.write(JSON.stringify(r)+"\0")},t=(r,a,u,p)=>l({method:a,params:u,sessionId:p});m.on("close",()=>{P.removeListener("message",t),h.end(),o=!0}),P.addListener("message",t);let s=Buffer.alloc(0);h.on("data",r=>{s=Buffer.concat([s,r]);for(let a=s.indexOf(0);a!==-1;a=s.indexOf(0)){let u;try{const p=s.slice(0,a).toString("utf8");s=s.slice(a+1),u=JSON.parse(p)}catch(p){console.error("error reading cdp line",p)}P.sendCommand(u.method,u.params,u.sessionId).then(p=>l({id:u.id,sessionId:u.sessionId,result:p})).catch(p=>l({id:u.id,sessionId:u.sessionId,error:{code:0,message:p.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{o=!0,--I==0&&P.detach()})});return await new Promise(h=>c.listen(0,h)),m.on("close",()=>c.close()),{rendererDebugPort:c.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function q(e,g,M,D){function S(n){const w=E(n),v=[w];return e.isAbsolute(w)||v.unshift(D),e.resolve(...v)}function E(n){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const v=n["user-data-dir"];if(v)return v;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(b,"AppData","Roaming")}break;case"darwin":i=e.join(g.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(g.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,M)}return{getUserDataPath:S}}if(typeof define=="function")define(J[159],Z([0,160,26,10,15,33]),function(e,g,M,D,S,E){const n=S.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return q(g,M,w.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),g=require("path"),M=require("os");module.exports=q(g,M,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[161],Z([0,1,26,159,157]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(n,w){super(n,{homeDir:g.homedir(),tmpDir:g.tmpdir(),userDataDir:M.getUserDataPath(n)},w)}}e.NativeEnvironmentService=S}),define(J[162],Z([0,1,29,26,8]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=D.join(M.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return g.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(w){E&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(J[163],Z([0,1,138]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(k){return k=k.trim(),k==="*"||M.test(k)}e.isValidVersionStr=S;function E(k){if(!S(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=k.match(M);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(k){if(!k)return null;let y=k.majorBase,d=k.majorMustEqual,m=k.minorBase,P=k.minorMustEqual,I=k.patchBase,c=k.patchMustEqual;k.hasCaret&&(y===0||(P=!1),c=!1);let h=0;if(k.preRelease){const o=D.exec(k.preRelease);if(o){const[,l,t,s]=o;h=Date.UTC(Number(l),Number(t)-1,Number(s))}}return{majorBase:y,majorMustEqual:d,minorBase:m,minorMustEqual:P,patchBase:I,patchMustEqual:c,isMinimum:k.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function w(k,y,d){let m;typeof k=="string"?m=n(E(k)):m=k;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let I;if(typeof d=="string"?I=n(E(d)):I=d,!m||!I)return!1;let c=m.majorBase,h=m.minorBase,o=m.patchBase,l=I.majorBase,t=I.minorBase,s=I.patchBase,r=I.notBefore,a=I.majorMustEqual,u=I.minorMustEqual,p=I.patchMustEqual;return I.isMinimum?c>l?!0:c<l?!1:h>t?!0:h<t||P&&P<r?!1:o>=s:(c===1&&l===0&&(!a||!u||!p)&&(l=1,t=0,s=0,a=!0,u=!1,p=!1),c<l?!1:c>l?!a:h<t?!1:h>t?!u:o<s?!1:o>s?!p:!(P&&P<r))}e.isValidVersion=w;function v(k,y,d,m){return d.isBuiltin||typeof d.main=="undefined"?!0:b(k,y,d.engines.vscode,m)}e.isValidExtensionVersion=v;function i(k,y,d){return k==="*"||b(y,d,k)}e.isEngineValid=i;function b(k,y,d,m=[]){let P=n(E(d));if(!P)return m.push(g.localize(0,null,d)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return m.push(g.localize(1,null,d)),!1}else if(!P.majorMustEqual)return m.push(g.localize(2,null,d)),!1;return w(k,y,P)?!0:(m.push(g.localize(3,null,k,d)),!1)}}),define(J[164],Z([0,1,34,87,2,10]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(w,v,i,b){super();this.folders=w,this.onDidFilesChange=v,this.onLogMessage=i,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,34,87,2,10]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(w,v,i,b,k={}){super();this.folders=w,this.onDidFilesChange=v,this.onLogMessage=i,this.verboseLogging=b,this.watcherOptions=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService(g.getNextTickChannel(w.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[166],Z([0,1,41,81,112,10]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(w,v,i,b,k){this.watchedFolder=w,this.eventCallback=i,this.logCallback=b,this.verboseLogging=k,this.restartCounter=0,Array.isArray(v)?this.ignored=v.map(y=>D.parse(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}, excludes: ${v.join(",")}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=g.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,w);const v=new M.LineDecoder;this.handle.stdout.on("data",i=>{const b=[];for(const k of v.write(i)){const y=k.split("|");if(y.length===2){const d=Number(y[0]),m=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(m))){this.verboseLogging&&this.log(m);continue}b.push({type:E.changeTypeMap[d],path:m})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,b)=>this.onExit(i,b))}onError(w){this.error("process error: "+w.toString())}onExit(w,v){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${v})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[167],Z([0,1,166,8,23]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,w,v,i){this.onDidFilesChange=w,this.onLogMessage=v,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(M.posix.sep)&&(this.folder.path=D.rtrim(this.folder.path,M.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class g{constructor(S,E=[],n=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=g;const M=(D,...S)=>new g(D,S);e.createSyncDescriptor=M}),define(J[168],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class M{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new g(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),w=this._findCycle(E,n);if(w)return w}}_findCycle(S,E){for(let[n,w]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const v=this._findCycle(w,E);if(v)return v;E.delete(n)}}}e.Graph=M}),define(J[4],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function w(v){return v[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=w})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function M(n,w,v,i){w[g.DI_TARGET]===w?w[g.DI_DEPENDENCIES].push({id:n,index:v,optional:i}):(w[g.DI_DEPENDENCIES]=[{id:n,index:v,optional:i}],w[g.DI_TARGET]=w)}function D(n){if(g.serviceIds.has(n))return g.serviceIds.get(n);const w=function(v,i,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(w,v,b,!1)};return w.toString=()=>n,g.serviceIds.set(n,w),w}e.createDecorator=D;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(w,v,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(n,w,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=g.createDecorator(e.ID);function M(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=M}),define(J[89],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=g.createDecorator("encryptionMainService");class M{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>q(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=M}),define(J[48],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=g.createDecorator("environmentService"),e.INativeEnvironmentService=g.refineServiceDecorator(e.IEnvironmentService)}),define(J[169],Z([0,1,137,4,10]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var w;(function(b){b.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var v;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=M.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(k,y){super(k);this.code=y,this.name=y}}e.ExtensionManagementError=i,e.IExtensionManagementService=M.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=M.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=M.createDecorator("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=g.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=g.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=M.createDecorator("IExtensionManagementCLIService")}),define(J[170],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=g.createDecorator("extensionUrlTrustService")}),define(J[171],Z([0,1,23,4]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=D;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,k){if(typeof b=="undefined"||b===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof b=="string"||typeof k=="string"){let y=typeof b=="string"?b:b.value,d=typeof k=="string"?k:k.value;return g.equalsIgnoreCase(y,d)}return b._lower===k._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=n;function w(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function v(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=v,e.IBuiltinExtensionsScannerService=M.createDecorator("IBuiltinExtensionsScannerService")}),define(J[172],Z([0,1,23,171]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(d,m){return d.uuid&&m.uuid?d.uuid===m.uuid:d.id===m.id?!0:g.compareIgnoreCase(d.id,m.id)===0}e.areSameExtensions=D;class S{constructor(m,P){this.version=P,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof S?D(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(d,m){return`${d}.${m}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function w(d,m){return n(E(d,m))}e.getGalleryExtensionId=w;function v(d,m){const P=[],I=c=>{for(const h of P)if(h.some(o=>D(m(o),m(c))))return h;return null};for(const c of d){const h=I(c);h?h.push(c):P.push([c])}return P}e.groupByExtension=v;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function k(d){const m=new Set;for(const P of d)P.malicious&&m.add(P.id.id);return m}e.getMaliciousExtensionsSet=k;function y(d,m){const P=[],I=m.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const c=I.shift();if(c&&P.every(h=>!D(h.identifier,{id:c}))){const h=d.filter(o=>D(o.identifier,{id:c}));h.length===1&&(P.push(h[0]),I.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(J[90],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=g.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=g.createDecorator("externalTerminal")}),define(J[173],Z([0,1,41,8,68,139,18,3,90,10,106]),function(q,e,g,M,D,S,E,n,w,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=S.localize(0,null);class k{async getDefaultTerminalForPlatforms(){const o=await m.getDefaultTerminalLinuxReady();return{windows:y.getDefaultTerminalWindows(),linux:o,osx:"xterm"}}}class y extends k{openTerminal(o,l){return this.spawnTerminal(g,o,D.getWindowsShell(),l)}spawnTerminal(o,l,t,s){const r=l.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=M.basename(r).toLowerCase();if(a==="cmder"||a==="cmder.exe")return o.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return r.indexOf(" ")>=0&&u.push('""'),u.push(r),(a==="wt"||a==="wt.exe")&&u.push("-d ."),new Promise((p,f)=>{const L=P(process),F=o.spawn(t,u,{cwd:s,env:L});F.on("error",f),F.on("exit",()=>p())})}runInTerminal(o,l,t,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((u,p)=>{const f=`"${l} - ${b}"`,L=`""${t.join('" "')}" & pause"`,F=["/c","start",f,"/wait",a,"/c",L],_=Object.assign({},P(process),s);Object.keys(_).filter(ee=>_[ee]===null).forEach(ee=>delete _[ee]);const C={cwd:l,env:_,windowsVerbatimArguments:!0};g.spawn(y.CMD,F,C).on("error",ee=>{p(I(ee))}),u(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends k{openTerminal(o,l){return this.spawnTerminal(g,o,l)}runInTerminal(o,l,t,s,r){const a=r.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((u,p)=>{if(a===w.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const f=a===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",F=[v.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,q).fsPath,"-t",o||b,"-w",l];for(let K of t)F.push("-a"),F.push(K);if(s)for(let K in s){const ee=s[K];ee===null?(F.push("-u"),F.push(K)):(F.push("-e"),F.push(`${K}=${ee}`))}let _="";const C=g.spawn(d.OSASCRIPT,F);C.on("error",K=>{p(I(K))}),C.stderr.on("data",K=>{_+=K.toString()}),C.on("exit",K=>{if(K===0)u(void 0);else if(_){const ee=_.split(`
`,1);p(new Error(ee[0]))}else p(new Error(S.localize(1,null,f,K)))})}else p(new Error(S.localize(2,null,a)))})}spawnTerminal(o,l,t){const s=l.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const u=["-a",s];t&&u.push(t);const p=o.spawn("/usr/bin/open",u);p.on("error",a),p.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class m extends k{openTerminal(o,l){return this.spawnTerminal(g,o,l)}runInTerminal(o,l,t,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,p)=>{let f=[];a.then(L=>{L.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const F=`${c(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;f.push(`''${F}''`);const _=Object.assign({},process.env,s);Object.keys(_).filter(V=>_[V]===null).forEach(V=>delete _[V]);const C={cwd:l,env:_};let K="";const ee=g.spawn(L,f,C);ee.on("error",V=>{p(I(V))}),ee.stderr.on("data",V=>{K+=V.toString()}),ee.on("exit",V=>{if(V===0)u(void 0);else if(K){const x=K.split(`
`,1);p(new Error(x[0]))}else p(new Error(S.localize(4,null,L,V)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{n.isLinux?await E.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,l,t){const s=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(u=>{const p=P(process),f=o.spawn(u,[],{cwd:t,env:p});f.on("error",a),f.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=S.localize(3,null);function P(h){const o=h.env;return i.sanitizeProcessEnvironment(o),o}function I(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(S.localize(5,null,h.path)):h}function c(h){let o="";for(let l of h)l.indexOf(" ")>=0?o+='"'+l+'"':o+=l,o+=" ";return o}}),define(J[19],Z([0,1,141,8,7,4,23,13,37]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function v(U){return U.create===!0}e.isFileOpenForWriteOptions=v;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var k;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function m(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var I;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor($,H){super($);this.code=H}}e.FileSystemProviderError=c;function h(U,$){const H=new c(U.toString(),$);return l(H,$),H}e.createFileSystemProviderError=h;function o(U){return U||h(g.localize(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function l(U,$){return U.name=$?`${$} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=l;function t(U){if(!U)return I.Unknown;if(U instanceof c)return U.code;const $=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!$)return I.Unknown;switch($[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof L)return U.fileOperationResult;switch(t(U)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor($,H,B){this.resource=$,this.operation=H,this.target=B}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class p{constructor($,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const B of $)switch(B.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>H)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>H)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>H)),this.deleted.set(B.resource,B);break}}contains($,...H){return this.doContains($,{includeChildren:!1},...H)}affects($,...H){return this.doContains($,{includeChildren:!0},...H)}doContains($,H,...B){if(!$)return!1;const T=B.length>0;return!!((!T||B.includes(1))&&(this.added?.get($)||H.includeChildren&&this.added?.findSuperstr($))||(!T||B.includes(0))&&(this.updated?.get($)||H.includeChildren&&this.updated?.findSuperstr($))||(!T||B.includes(2))&&(this.deleted?.findSubstr($)||H.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function f(U,$,H){return!U||!$||U===$||$.length>U.length?!1:($.charAt($.length-1)!==M.sep&&($+=M.sep),H?E.startsWithIgnoreCase(U,$):U.indexOf($)===0)}e.isParent=f;class L extends Error{constructor($,H,B){super($);this.fileOperationResult=H,this.options=B}}e.FileOperationError=L;class F extends L{constructor($,H,B){super($,2,B);this.stat=H}}e.NotModifiedSinceFileOperationError=F;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function K(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=K;async function ee(U,$){if(!$.canHandleResource(D.URI.from({scheme:U.scheme})))return new Promise(H=>{const B=$.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===U.scheme&&T.added&&(B.dispose(),H())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class V{static formatSize($){return n.isNumber($)||($=0),$<V.KB?g.localize(1,null,$.toFixed(0)):$<V.MB?g.localize(2,null,($/V.KB).toFixed(2)):$<V.GB?g.localize(3,null,($/V.MB).toFixed(2)):$<V.TB?g.localize(4,null,($/V.GB).toFixed(2)):g.localize(5,null,($/V.TB).toFixed(2))}}e.ByteSize=V,V.KB=1024,V.MB=V.KB*V.KB,V.GB=V.MB*V.KB,V.TB=V.GB*V.KB;var x;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function Q(U){return{maxFileSize:U===0?300*V.MB:16*V.GB,maxHeapSize:U===0?700*V.MB:2*700*V.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,136,19,88]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(k,y){const d={onUnknownOption:P=>{console.warn(M.localize(0,null,P))},onMultipleValues:(P,I)=>{console.warn(M.localize(1,null,P,I))}},m=S.parseArgs(k,S.OPTIONS,y?d:void 0);return m.goto&&m._.forEach(P=>g(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),M.localize(2,null))),m["max-memory"]&&g(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(k){const y=k.findIndex(d=>!/^-/.test(d));if(y>-1)return[...k.slice(0,y),...k.slice(y+1)]}function w(k){let[,...y]=k;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!b(process.env);return E(y,d)}e.parseMainProcessArgv=w;function v(k){const[,,...y]=k;return E(y,!0)}e.parseCLIProcessArgv=v;function i(k,...y){const d=k.indexOf("--");return d===-1?k.push(...y):k.splice(d,0,...y),k}e.addArg=i;function b(k){return k.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(J[91],Z([0,1,160,41,28,3,54,67,131,25,16]),function(q,e,g,M,D,S,E,n,w,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function b(d,m,P){return m["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):E.isLaunchedFromCli(P)&&!m["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(E.isLaunchedFromCli(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),k||(k=new Promise(async I=>{const c=new v.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),c.dispose(!0),I({})},1e4);try{const o=await y(d,c.token);I(o)}catch(o){i.isPromiseCanceledError(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),I({})}finally{clearTimeout(h),c.dispose()}})),k)}e.resolveShellEnv=b;let k;async function y(d,m){const P=new Promise(async(I,c)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const l=D.generateUuid().replace(/-/g,"").substr(0,12),t=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const r=await w.getSystemShell(S.OS,s);if(d.trace("getUnixShellEnvironment#shell",r),m.isCancellationRequested)return c(i.canceled);const a=g.basename(r);let u,p;/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,p=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,p=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),u);const f=M.spawn(r,[...p,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});m.onCancellationRequested(()=>(f.kill(),c(i.canceled))),f.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(_)),I({})});const L=[];f.stdout.on("data",_=>L.push(_));const F=[];f.stderr.on("data",_=>F.push(_)),f.on("close",(_,C)=>{const K=Buffer.concat(L).toString("utf8");d.trace("getUnixShellEnvironment#raw",K);const ee=Buffer.concat(F).toString("utf8");if(ee.trim()&&d.trace("getUnixShellEnvironment#stderr",ee),_||C)return c(new Error(`Failed to get environment (code ${_}, signal ${C})`));const V=t.exec(K),x=V?V[1]:"{}";try{const Q=JSON.parse(x);h?Q.ELECTRON_RUN_AS_NODE=h:delete Q.ELECTRON_RUN_AS_NODE,o?Q.ELECTRON_NO_ATTACH_CONSOLE=o:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Q),I(Q)}catch(Q){d.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(Q)),c(Q)}})});try{return await P}catch(I){return d.error("getUnixShellEnvironment#error",n.toErrorMessage(I)),{}}}}),define(J[92],Z([0,1,7,19,3]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(v=>({type:v.type,resource:g.URI.file(v.path)}))}e.toFileChanges=S;function E(w){const v=new n;for(const i of w)v.processEvent(i);return v.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(v){const i=this.mapPathToChange.get(v.path);if(i){const b=i.type,k=v.type;b===1&&k===2?(this.mapPathToChange.delete(v.path),this.normalized.splice(this.normalized.indexOf(i),1)):b===2&&k===1?i.type=0:b===1&&k===0||(i.type=k)}else this.normalized.push(v),this.mapPathToChange.set(v.path,v)}normalize(){const v=[],i=[];return this.normalized.filter(b=>b.type!==2?(v.push(b),!1):!0).sort((b,k)=>b.path.length-k.path.length).filter(b=>i.some(k=>M.isParent(b.path,k,!D.isLinux))?!1:(i.push(b.path),!0)).concat(v)}}}),define(J[174],Z([0,1,92,2,18,82,118,9,8]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class v extends M.Disposable{constructor(b,k,y,d){super();this.path=b,this.onDidFilesChange=k,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:k}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(k)try{y=await S.realpath(y)}catch(d){if(this.onError(d),k.dangling)return}b.isDirectory()?this._register(E.watchFolder(y,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:w.join(this.path,w.basename(m))})},d=>this.onError(d))):this._register(E.watchFile(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const k=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=g.normalizeFileChanges(k);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=v}),define(J[71],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[S,E]of D)this.set(S,E)}set(D,S){const E=this._entries.get(D);return this._entries.set(D,S),E}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(J[175],Z([0,1,16,168,69,4,71,9]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class v extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new E.ServiceCollection,m=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=P,this._services.set(S.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...m){let P=k.traceInvocation(d),I=!1;try{return d({get:(h,o)=>{if(I)throw g.illegalState("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,P);if(!l&&o!==S.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...m)}finally{I=!0,P.stop()}}createInstance(d,...m){let P,I;return d instanceof D.SyncDescriptor?(P=k.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(m),P)):(P=k.traceCreation(d),I=this._createInstance(d,m,P)),P.stop(),I}_createInstance(d,m=[],P){let I=S._util.getServiceDependencies(d).sort((o,l)=>o.index-l.index),c=[];for(const o of I){let l=this._getOrCreateServiceInstance(o.id,P);if(!l&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);c.push(l)}let h=I.length>0?I[0].index:m.length;if(m.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${m.length} static arguments`);let o=h-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,h)}return new d(...[...m,...c])}_setServiceInstance(d,m){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,m.branch(d,!0)):(m.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,m,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,P){const I=new M.Graph(o=>o.id.toString());let c=0;const h=[{id:d,desc:m,_trace:P}];for(;h.length;){const o=h.pop();if(I.lookupOrInsertNode(o),c++>1e3)throw new v(I);for(let l of S._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(l.id);if(!t&&!l.optional&&console.warn(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:l.id,desc:t,_trace:o._trace.branch(l.id,!0)};I.insertEdge(o,s),h.push(s)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new v(I);break}for(const{data:l}of o){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}I.removeNode(l)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,P=[],I,c){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(m,P,I,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,P,I,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],P,I){if(P){const c=new n.IdleValue(()=>this._createInstance(d,m,I));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let l=c.value,t=l[o];return typeof t!="function"||(t=t.bind(l),h[o]=t),t},set(h,o,l){return c.value[o]=l,!0}})}else return this._createInstance(d,m,I)}}e.InstantiationService=i;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class k{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return w?new k(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):k._None}static traceCreation(d){return w?new k(0,d.name):k._None}branch(d,m){let P=new k(2,d.toString());return this._dep.push([d,m,P]),P}stop(){let d=Date.now()-this._start;k._totals+=d;let m=!1;function P(c,h){let o=[],l=new Array(c+1).join("	");for(const[t,s,r]of h._dep)if(s&&r){m=!0,o.push(`${l}CREATES -> ${t}`);let a=P(c+1,r);a&&o.push(a)}else o.push(`${l}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${k._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(I.join(`
`))}}k._None=new class extends k{constructor(){super(-1,null)}stop(){}branch(){return this}},k._totals=0}),define(J[176],Z([0,1,16,129,57]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends D.ResolvedKeybinding{constructor(n,w){super();if(w.length===0)throw g.illegalArgument("parts");this._os=n,this._parts=w}getLabel(){return M.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return M.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:M.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return M.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[177],Z([0,1,57,176]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends M.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return g.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":g.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return g.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=g.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return D.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=g.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(J[178],Z([0,1,9]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function M(D,S){if(D.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let w of D){if(w===!0)return Promise.resolve(!0);g.isThenable(w)&&E.push(w.then(v=>{v&&(n=!0)},v=>{S(v),n=!0}))}return g.Promises.settled(E).then(()=>n)}e.handleVetos=M}),define(J[6],Z([0,1,4,2,3,5,67]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=g.createDecorator("logService"),e.ILoggerService=g.createDecorator("loggerService");function n(){return new Date().toISOString()}var w;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class v extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class i extends v{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(w.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(w.Error,this.format(r))}else this.log(w.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let a=t[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(u){}s+=(r>0?" ":"")+a}return s}}e.AbstractMessageLogger=i;class b extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}debug(t,...s){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}info(t,...s){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}warn(t,...s){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...s):console.warn(`[main ${n()}]`,t,...s))}error(t,...s){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}critical(t,...s){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class k extends v{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=k;class y extends v{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:E.toErrorMessage(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends v{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class m extends M.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=m;class P extends M.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?w.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=I;function c(l){if(l.verbose)return w.Trace;if(typeof l.logLevel=="string"){const t=h(l.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(l){switch(l){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=h;function o(l){switch(l){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o});var te=this&&this.__param||function(q,e){return function(g,M){e(g,M,q)}};define(J[179],Z([0,1,9,17,40,78,48,19,4,6]),function(q,e,g,M,D,S,E,n,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(k){k.ERROR_INVALID_FILE="ERROR_INVALID_FILE",k.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=w.createDecorator(e.UserConfigurationFileServiceId);let b=class{constructor(y,d,m){this.environmentService=y,this.fileService=d,this.logService=m,this.queue=new g.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,m){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:P,mtime:I,etag:c}=await this.fileService.readFile(y,{atomic:!0});let h=P.toString();const o=[];if(D.parse(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(d,h,m)[0];if(l){h=h.substring(0,l.offset)+l.content+h.substring(l.offset+l.length);try{await this.fileService.writeFile(y,M.VSBuffer.fromString(h),{etag:c,mtime:I})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},m,P){return d.length?S.setProperty(m,d,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:m.length,offset:0}]}};b=he([te(0,E.IEnvironmentService),te(1,n.IFileService),te(2,v.ILogService)],b),e.UserConfigurationFileService=b}),define(J[93],Z([0,1,6]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function M(S,E){switch(E){case g.LogLevel.Trace:return S.trace;case g.LogLevel.Debug:return S.debug;case g.LogLevel.Info:return S.info;case g.LogLevel.Warning:return S.warn;case g.LogLevel.Error:return S.error;case g.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class D extends g.AbstractLogger{constructor(E=g.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:w}of this.buffer)M(E,n).apply(E,w);this.buffer=[]}_log(E,...n){this._logger?M(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(g.LogLevel.Trace,E,...n)}debug(E,...n){this._log(g.LogLevel.Debug,E,...n)}info(E,...n){this._log(g.LogLevel.Info,E,...n)}warn(E,...n){this._log(g.LogLevel.Warning,E,...n)}error(E,...n){this._log(g.LogLevel.Error,E,...n)}critical(E,...n){this._log(g.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(J[180],Z([0,1,6,19,9,17,15,4,93]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const v=5*M.ByteSize.MB;let i=class extends g.AbstractLogger{constructor(y,d,m,P){super();this.name=y,this.resource=d,this.fileService=P,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(g.LogLevel.Error,this.format(d))}else this._log(g.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>v&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(m)),m=""),m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(m))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,m=new Date;return`${m.getFullYear()}-${y(m.getMonth()+1)}-${y(m.getDate())} ${y(m.getHours())}:${y(m.getMinutes())}:${y(m.getSeconds())}.${d(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,E.joinPath(E.dirname(this.resource),`${E.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let m=0;m<y.length;m++){let P=y[m];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}d+=(m>0?" ":"")+P}return d}};i=he([te(3,M.IFileService)],i),e.FileLogger=i;let b=class extends g.AbstractLoggerService{constructor(y,d,m){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=m}doCreateLogger(y,d){const m=new w.BufferLogService(d);return M.whenProviderRegistered(y,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(i,E.basename(y),y,m.getLevel())),m}};b=he([te(0,g.ILogService),te(1,n.IInstantiationService),te(2,M.IFileService)],b),e.FileLoggerService=b}),define(J[181],Z([0,1,6,5,7]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(k){this.service=k,this.onDidChangeLogLevel=M.Event.buffer(k.onDidChangeLogLevel,!0)}listen(k,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class E{constructor(k){this.channel=k}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(k){E.setLevel(this.channel,k)}static setLevel(k,y){return k.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(k){this.loggerService=k,this.loggers=new Map}listen(k,y){throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"createLogger":this.createLogger(D.URI.revive(d[0]),d[1]);return;case"log":return this.log(D.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(k,y){this.loggers.set(k.toString(),this.loggerService.createLogger(k,y))}consoleLog(k,y){let d=console.log;switch(k){case g.LogLevel.Error:d=console.error;break;case g.LogLevel.Warning:d=console.warn;break;case g.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(k,y){const d=this.loggers.get(k.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,P]of y)switch(m){case g.LogLevel.Trace:d.trace(P);break;case g.LogLevel.Debug:d.debug(P);break;case g.LogLevel.Info:d.info(P);break;case g.LogLevel.Warning:d.warn(P);break;case g.LogLevel.Error:d.error(P);break;case g.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class w extends g.AbstractLoggerService{constructor(k,y,d){super(k,y);this.channel=d}createConsoleMainLogger(){return new g.AdapterLogger({log:(k,y)=>{this.channel.call("consoleLog",[k,y])}})}doCreateLogger(k,y,d){return new v(this.channel,k,y,d)}}e.LoggerChannelClient=w;class v extends g.AbstractMessageLogger{constructor(k,y,d,m){super(m?.always);this.channel=k,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,y){const d=[[k,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(k){this.channel.call("log",[this.file,k])}}class i extends g.LogService{constructor(k,y){super(y);this.parent=k,this._register(k.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(k){super.setLevel(k),this.parent.setLevel(k)}}e.FollowerLogService=i}),define(J[94],Z([0,1,6,19]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(w,v,i,b){try{const k=await new Promise((y,d)=>{q(["spdlog"],y,d)});return k.setFlushOn(g.LogLevel.Trace),k.createAsyncRotatingLogger(w,v,i,b)}catch(k){console.error(k)}return null}function S(w,v,i,b){const k=q.__$__nodeRequire("spdlog");return k.setFlushOn(g.LogLevel.Trace),k.createRotatingLogger(w,v,i,b)}e.createRotatingLogger=S;function E(w,v,i){switch(v){case g.LogLevel.Trace:w.trace(i);break;case g.LogLevel.Debug:w.debug(i);break;case g.LogLevel.Info:w.info(i);break;case g.LogLevel.Warning:w.warn(i);break;case g.LogLevel.Error:w.error(i);break;case g.LogLevel.Critical:w.critical(i);break;default:throw new Error("Invalid log level")}}class n extends g.AbstractMessageLogger{constructor(v,i,b,k){super();this.name=v,this.filepath=i,this.rotating=b,this.buffer=[],this.setLevel(k),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const v=this.rotating?6:1,i=30/v*M.ByteSize.MB;return D(this.name,this.filepath,i,v).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:k,message:y}of this.buffer)E(this._logger,k,y);this.buffer=[]}})}log(v,i){this._logger?E(this._logger,v,i):this.getLevel()<=v&&this.buffer.push({level:v,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[182],Z([0,1,6,15,10,180,94,19,28]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let v=class extends g.AbstractLoggerService{constructor(b,k){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=k}doCreateLogger(b,k,y){if(b.scheme===D.Schemas.file){const d=new E.SpdLogLogger(y?.name||w.generateUuid(),b.fsPath,!y?.donotRotate,k);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new S.FileLogger(y?.name??M.basename(b),b,k,this.fileService)}};v=he([te(0,g.ILogService),te(1,n.IFileService)],v),e.LoggerService=v}),define(J[183],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function g(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=g;function M(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function D(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function S(E){return!g(E)&&!M(E)&&!D(E)}e.isMenubarMenuItemAction=S}),define(J[49],Z([0,1,10,3,33,15]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.context!="undefined"){const n=M.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const n=S.dirname(g.FileAccess.asFileUri("",q));E=q.__$__nodeRequire(S.joinPath(n,"product.json").fsPath);const w=q.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:w.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.58.0-dev",nameShort:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[95],Z([0,1,142,17,19,16,49]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(b,k,y,d,m,P){let I;try{await w(b,k,y,d,m,P)}catch(c){I=c}finally{I&&m.errorTransformer&&(I=m.errorTransformer(I)),typeof I!="undefined"&&y.error(I),y.end()}}e.readFileIntoStream=n;async function w(b,k,y,d,m,P){v(P);const I=await b.open(k,{create:!1});try{v(P);let c=0,h=0,o=m&&typeof m.length=="number"?m.length:void 0,l=M.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,s=0;do h=await b.read(I,t,l.buffer,s,l.byteLength-s),t+=h,s+=h,c+=h,typeof o=="number"&&(o-=h),s===l.byteLength&&(await y.write(d(l)),l=M.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),s=0);while(h>0&&(typeof o!="number"||o>0)&&v(P)&&i(c,m));if(s>0){let r=s;typeof o=="number"&&(r=Math.min(s,o)),y.write(d(l.slice(0,r)))}}catch(c){throw D.ensureFileSystemProviderError(c)}finally{await b.close(I)}}function v(b){if(b.isCancellationRequested)throw S.canceled();return!0}function i(b,k){if(k?.limits){if(typeof k.limits.memory=="number"&&b>k.limits.memory)throw D.createFileSystemProviderError(g.localize(0,null,E.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&b>k.limits.size)throw D.createFileSystemProviderError(g.localize(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[184],Z([0,1,140,72,2,19,5,15,37,36,6,17,64,9,25,10,95,63]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ve extends D.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new y.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new y.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new S.FileChangesEvent(l,!0)))),this.watchedResources=w.TernarySearchTree.forUris(l=>{const t=this.getProvider(l.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(o,l){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);M.mark(`code/registerFilesystem/${o}`),this.provider.set(o,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:l});const t=new D.DisposableStore;return t.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),t.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:o}))),typeof l.onDidErrorOccur=="function"&&t.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),D.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:l}),this.provider.delete(o),D.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){l.push(t)}}),!this.provider.has(o)&&await y.Promises.settled(l)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,l){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&l)}listCapabilities(){return I.Iterable.map(this.provider,([o,l])=>({scheme:o,capabilities:l.capabilities}))}async withProvider(o){if(!n.isAbsolutePath(o))throw new S.FileOperationError(g.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const l=this.provider.get(o.scheme);if(!l){const t=new Error;throw t.name="ENOPRO",t.message=g.localize(1,null,o.toString()),t}return l}async withReadProvider(o){const l=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(l)||S.hasReadWriteCapability(l)||S.hasFileReadStreamCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const l=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(l)||S.hasReadWriteCapability(l))return l;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,l){try{return await this.doResolveFile(o,l)}catch(t){throw S.toFileSystemProviderErrorCode(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError(g.localize(2,null,this.resourceForError(o)),1):S.ensureFileSystemProviderError(t)}}async doResolveFile(o,l){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),r=l?.resolveTo,a=l?.resolveSingleChildDescendants,u=l?.resolveMetadata,p=await t.stat(o);let f;return this.toFileStat(t,o,p,void 0,!!u,(L,F)=>(f||(f=w.TernarySearchTree.forUris(()=>!s),f.set(o,!0),v.isNonEmptyArray(r)&&r.forEach(_=>f.set(_,!0))),Boolean(f.findSuperstr(L.resource)||f.get(L.resource))?!0:L.isDirectory&&a?F===1:!1))}async toFileStat(o,l,t,s,r,a){const{providerExtUri:u}=this.getExtUri(o),p={resource:l,name:u.basename(l),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:S.etag({mtime:t.mtime,size:t.size})};if(p.isDirectory&&a(p,s)){try{const f=await o.readdir(l),L=await y.Promises.settled(f.map(async([F,_])=>{try{const C=u.joinPath(l,F),K=r?await o.stat(C):{type:_};return await this.toFileStat(o,C,K,f.length,r,a)}catch(C){return this.logService.trace(C),null}}));p.children=v.coalesce(L)}catch(f){this.logService.trace(f),p.children=[]}return p}return p}async resolveAll(o){return y.Promises.settled(o.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const l=await this.withProvider(o);try{return!!await l.stat(o)}catch(t){return!1}}async canCreateFile(o,l){try{await this.doValidateCreateFile(o,l)}catch(t){return t}return!0}async doValidateCreateFile(o,l){if(!l?.overwrite&&await this.exists(o))throw new S.FileOperationError(g.localize(3,null,this.resourceForError(o)),3,l)}async createFile(o,l=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,l);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,s)),s}async writeFile(o,l,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,r.dirname(o));let u;if(S.hasReadWriteCapability(s)&&!(l instanceof b.VSBuffer))if(k.isReadableStream(l)){const p=await k.peekStream(l,3);p.ended?u=b.VSBuffer.concat(p.buffer):u=p}else u=k.peekReadable(l,p=>b.VSBuffer.concat(p),3);else u=l;!S.hasOpenReadWriteCloseCapability(s)||S.hasReadWriteCapability(s)&&u instanceof b.VSBuffer?await this.doWriteUnbuffered(s,o,t,u):await this.doWriteBuffered(s,o,t,u instanceof b.VSBuffer?b.bufferToReadable(u):u)}catch(a){throw new S.FileOperationError(g.localize(4,null,this.resourceForError(o),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,l,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error(g.localize(5,null,this.resourceForError(l)));let r;try{r=await o.stat(l)}catch(a){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError(g.localize(6,null,this.resourceForError(l)),0,t);if(this.throwIfFileIsReadonly(l,r),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==S.etag({mtime:t.mtime,size:r.size}))throw new S.FileOperationError(g.localize(7,null),3,t);return r}async readFile(o,l){const t=await this.withReadProvider(o);return l?.atomic?this.doReadFileAtomic(t,o,l):this.doReadFile(t,o,l)}async doReadFileAtomic(o,l,t){return new Promise((s,r)=>{this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,l,t);s(a)}catch(a){r(a)}})})}async doReadFile(o,l,t){const s=await this.doReadFileStream(o,l,{...t,preferUnbuffered:!0});return{...s,value:await b.streamToBuffer(s.value)}}async readFileStream(o,l){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,l)}async doReadFileStream(o,l,t){const s=new d.CancellationTokenSource,r=this.validateReadFile(l,t).then(u=>u,u=>{throw s.cancel(),u});let a;try{return t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!(S.hasOpenReadWriteCloseCapability(o)||S.hasFileReadStreamCapability(o))||S.hasReadWriteCapability(o)&&t?.preferUnbuffered?a=this.readFileUnbuffered(o,l,t):S.hasFileReadStreamCapability(o)?a=this.readFileStreamed(o,l,s.token,t):a=this.readFileBuffered(o,l,s.token,t),{...await r,value:a}}catch(u){a&&await k.consumeStream(a);const p=g.localize(8,null,this.resourceForError(l),S.ensureFileSystemProviderError(u).toString());throw u instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(p,u.stat,t):new S.FileOperationError(p,S.toFileOperationResult(u),t)}}readFileStreamed(o,l,t,s=Object.create(null)){const r=o.readFileStream(l,s,t);return k.transform(r,{data:a=>a instanceof b.VSBuffer?a:b.VSBuffer.wrap(a),error:a=>new S.FileOperationError(g.localize(9,null,this.resourceForError(l),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),s)},a=>b.VSBuffer.concat(a))}readFileBuffered(o,l,t,s=Object.create(null)){const r=b.newWriteableBufferStream();return P.readFileIntoStream(o,l,r,a=>a,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError(g.localize(10,null,this.resourceForError(l),S.ensureFileSystemProviderError(a).toString()),S.toFileOperationResult(a),s)},t),r}readFileUnbuffered(o,l,t){const s=k.newWriteableStream(r=>b.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(l);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(l,r.byteLength,t),s.end(b.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(o,l){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError(g.localize(11,null,this.resourceForError(o)),0,l);if(l&&typeof l.etag=="string"&&l.etag!==S.ETAG_DISABLED&&l.etag===t.etag)throw new S.NotModifiedSinceFileOperationError(g.localize(12,null),t,l);return this.validateReadFileLimits(o,t.size,l),t}validateReadFileLimits(o,l,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&l>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&l>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError(g.localize(13,null,this.resourceForError(o)),s)}}async canMove(o,l,t){return this.doCanMoveCopy(o,l,"move",t)}async canCopy(o,l,t){return this.doCanMoveCopy(o,l,"copy",t)}async doCanMoveCopy(o,l,t,s){if(o.toString()!==l.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,o,a,l,t,s)}catch(r){return r}return!0}async move(o,l,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(s,o,r,l,"move",!!t),u=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="move"?2:3,u)),u}async copy(o,l,t){const s=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),a=await this.doMoveCopy(s,o,r,l,"copy",!!t),u=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="copy"?3:2,u)),u}async doMoveCopy(o,l,t,s,r,a){if(l.toString()===s.toString())return r;const{exists:u,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(o,l,t,s,r,a);if(u&&!p&&a&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(o===t&&S.hasFileFolderCopyCapability(o))await o.copy(l,s,{overwrite:a});else{const f=await this.resolve(l);f.isDirectory?await this.doCopyFolder(o,f,t,s):await this.doCopyFile(o,l,t,s)}return r}else return o===t?(await o.rename(l,s,{overwrite:a}),r):(await this.doMoveCopy(o,l,t,s,"copy",a),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(o,l,t,s){if(S.hasOpenReadWriteCloseCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,l,t,s);if(S.hasOpenReadWriteCloseCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,l,t,s);if(S.hasReadWriteCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,l,t,s);if(S.hasReadWriteCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,l,t,s)}async doCopyFolder(o,l,t,s){await t.mkdir(s),Array.isArray(l.children)&&await y.Promises.settled(l.children.map(async r=>{const a=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,a):this.doCopyFile(o,r.resource,t,a)}))}async doValidateMoveCopy(o,l,t,s,r,a){let u=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(u=f.isEqual(l,s)),u&&r==="copy")throw new Error(g.localize(14,null,this.resourceForError(l),this.resourceForError(s)));if(!u&&f.isEqualOrParent(s,l))throw new Error(g.localize(15,null,this.resourceForError(l),this.resourceForError(s)))}const p=await this.exists(s);if(p&&!u){if(!a)throw new S.FileOperationError(g.localize(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(l,s))throw new Error(g.localize(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const l=this.isPathCaseSensitive(o);return{providerExtUri:l?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(l,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,l){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(l,s.dirname(l));)try{if(((await o.stat(l)).type&S.FileType.Directory)==0)throw new Error(g.localize(18,null,this.resourceForError(l)));break}catch(r){if(S.toFileSystemProviderErrorCode(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(l)),l=s.dirname(l)}for(let r=t.length-1;r>=0;r--){l=s.joinPath(l,t[r]);try{await o.mkdir(l)}catch(a){if(S.toFileSystemProviderErrorCode(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,l){try{await this.doValidateDelete(o,l)}catch(t){return t}return!0}async doValidateDelete(o,l){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!l?.useTrash&&!(t.capabilities&4096))throw new Error(g.localize(19,null,this.resourceForError(o)));let r;try{r=await t.stat(o)}catch(u){}if(r)this.throwIfFileIsReadonly(o,r);else throw new S.FileOperationError(g.localize(20,null,this.resourceForError(o)),1);if(!!!l?.recursive){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(g.localize(21,null,this.resourceForError(o)))}return t}async del(o,l){const t=await this.doValidateDelete(o,l),s=!!l?.useTrash,r=!!l?.recursive;await t.delete(o,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,l){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const r of o)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!l))}if(s){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,l={recursive:!1,excludes:[]}){const t=new D.DisposableStore;{let s=!1,r=()=>{s=!0};t.add(D.toDisposable(()=>r())),this.doWatch(o,l).then(a=>{s?D.dispose(a):r=()=>D.dispose(a)},a=>this.logService.error(a))}return l.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add(D.toDisposable(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),t}async doWatch(o,l){const t=await this.withProvider(o),s=this.toWatchKey(t,o,l),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(o,l)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,D.toDisposable(()=>{r.count--,r.count===0&&(D.dispose(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,l,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(l),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>D.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,l,t,s){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(l,{create:!0,unlock:t?.unlock??!1});try{k.isReadableStream(s)||k.isReadableBufferedStream(s)?await this.doWriteStreamBufferedQueued(o,r,s):await this.doWriteReadableBufferedQueued(o,r,s)}catch(a){throw S.ensureFileSystemProviderError(a)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,l,t){let s=0,r;if(k.isReadableBufferedStream(t)){if(t.buffer.length>0){const a=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,l,a,a.byteLength,s,0),s+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(a,u)=>{k.listenStream(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(o,l,p,p.byteLength,s,0)}catch(f){return u(f)}s+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>u(p),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,l,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,l,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(o,l,t,s,r,a){let u=0;for(;u<s;)u+=await o.write(l,r+u,t.buffer,a+u,s-u)}async doWriteUnbuffered(o,l,t,s){return this.writeQueue.queueFor(l,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,l,t,s))}async doWriteUnbufferedQueued(o,l,t,s){let r;s instanceof b.VSBuffer?r=s:k.isReadableStream(s)?r=await b.streamToBuffer(s):k.isReadableBufferedStream(s)?r=await b.bufferedStreamToBuffer(s):r=b.readableToBuffer(s),await o.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,l,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,l,t,s))}async doPipeBufferedQueued(o,l,t,s){let r,a;try{r=await o.open(l,{create:!1}),a=await t.open(s,{create:!0,unlock:!1});const u=b.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,f=0,L=0;do L=await o.read(r,p,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(t,a,u,L,p,f),p+=L,f+=L,f===u.byteLength&&(f=0);while(L>0)}catch(u){throw S.ensureFileSystemProviderError(u)}finally{await y.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,l,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,l,t,s))}async doPipeUnbufferedQueued(o,l,t,s){return t.writeFile(s,await o.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,l,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,l,t,s))}async doPipeUnbufferedToBufferedQueued(o,l,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const a=await o.readFile(l);await this.doWriteBuffer(t,r,b.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw S.ensureFileSystemProviderError(a)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,l,t,s){const r=await b.streamToBuffer(this.readFileBuffered(o,l,d.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(o,l){if(o.capabilities&2048)throw new S.FileOperationError(g.localize(22,null,this.resourceForError(l)),6);return o}throwIfFileIsReadonly(o,l){if((l.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError(g.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([te(0,i.ILogService)],c),e.FileService=c}),define(J[185],Z([0,1,2,19,5,3,18,8,15,30,9,6,143,92,165,167,164,174,64,95,36,17]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends g.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:u}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,u),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),u=[];return await Promise.all(a.map(async p=>{try{let f;p.isSymbolicLink()?f=(await this.stat(w.joinPath(r,p.name))).type:f=this.toType(p),u.push([p.name,f])}catch(f){this.logService.trace(f)}})),u}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let u;return a?.dangling?u=M.FileType.Unknown:r.isFile()?u=M.FileType.File:r.isDirectory()?u=M.FileType.Directory:u=M.FileType.Unknown,a&&(u|=M.FileType.SymbolicLink),u}async readFile(r){try{const a=this.toFilePath(r);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,u){const p=c.newWriteableStream(f=>l.VSBuffer.concat(f.map(L=>l.VSBuffer.wrap(L))).buffer);return h.readFileIntoStream(this,r,p,f=>f.buffer,{...a,bufferSize:this.BUFFER_SIZE},u),p}async writeFile(r,a,u){let p;try{const f=this.toFilePath(r);if(!u.create||!u.overwrite){if(await E.Promises.exists(f)){if(!u.overwrite)throw M.createFileSystemProviderError(k.localize(0,null),M.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw M.createFileSystemProviderError(k.localize(1,null),M.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:u.unlock}),await this.write(p,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(r,f)}finally{typeof p=="number"&&await this.close(p)}}async open(r,a){try{const u=this.toFilePath(r);if(M.isFileOpenForWriteOptions(a)&&a.unlock)try{const{stat:L}=await E.SymlinkSupport.stat(u);L.mode&128||await E.Promises.chmod(u,L.mode|128)}catch(L){this.logService.trace(L)}let p;if(M.isFileOpenForWriteOptions(a)){if(S.isWindows)try{await E.Promises.truncate(u,0),p="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}p||(p="w")}else p="r";const f=await E.Promises.open(u,p);return this.mapHandleToPos.set(f,0),M.isFileOpenForWriteOptions(a)&&this.writeHandles.set(f,r),f}catch(u){throw M.isFileOpenForWriteOptions(a)?await this.toFileSystemProviderWriteError(r,u):this.toFileSystemProviderError(u)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await E.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,u,p,f){const L=this.normalizePos(r,a);let F=null;try{const _=await E.Promises.read(r,u,p,f,L);return typeof _=="number"?F=_:F=_.bytesRead,F}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(r,L,F)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,u){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof a=="number"||(typeof u=="number"?this.mapHandleToPos.set(r,p+u):this.mapHandleToPos.delete(r)))}async write(r,a,u,p,f){return i.retry(()=>this.doWrite(r,a,u,p,f),100,3)}async doWrite(r,a,u,p,f){const L=this.normalizePos(r,a);let F=null;try{const _=await E.Promises.write(r,u,p,f,L);return typeof _=="number"?F=_:F=_.bytesWritten,F}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),_)}finally{this.updatePos(r,L,F)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const u=this.toFilePath(r);await this.doDelete(u,a)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(r,a){a.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,a,u){const p=this.toFilePath(r),f=this.toFilePath(a);if(p!==f)try{await this.validateTargetDeleted(r,a,"move",u.overwrite),await E.Promises.move(p,f)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error(k.localize(2,null,n.basename(p),n.basename(n.dirname(f)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(r,a,u){const p=this.toFilePath(r),f=this.toFilePath(a);if(p!==f)try{await this.validateTargetDeleted(r,a,"copy",u.overwrite),await E.Promises.copy(p,f,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error(k.localize(3,null,n.basename(p),n.basename(n.dirname(f)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(r,a,u,p){const f=this.toFilePath(r),L=this.toFilePath(a);let F=!1;if(!!(this.capabilities&1024)||(F=v.isEqual(f,L,!0)),F&&u==="copy")throw M.createFileSystemProviderError(k.localize(4,null),M.FileSystemProviderErrorCode.FileExists);if(!F&&await E.Promises.exists(L)){if(!p)throw M.createFileSystemProviderError(k.localize(5,null),M.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a.excludes):this.watchNonRecursive(r)}watchRecursive(r,a){const u={path:this.toFilePath(r),excludes:a},p=o.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),g.toDisposable(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;this.options?.watcher?.usePolling?(r=d.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?r=m.FileWatcher:r=d.FileWatcher:r=P.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire(y.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===b.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new I.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire(y.toFileChanges(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===b.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return g.combinedDisposable(a,u)}toFilePath(r){return n.normalize(r.fsPath)}toFileSystemProviderError(r){if(r instanceof M.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=M.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=M.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=M.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=M.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=M.FileSystemProviderErrorCode.NoPermissions;break;default:a=M.FileSystemProviderErrorCode.Unknown}return M.createFileSystemProviderError(r,a)}async toFileSystemProviderWriteError(r,a){let u=this.toFileSystemProviderError(a);if(r&&u.code===M.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await E.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(u=M.createFileSystemProviderError(a,M.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return u}dispose(){super.dispose(),g.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,g.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[20],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=g.createDecorator("productService")}),define(J[186],Z([0,1,58,6,20]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,w){this.productService=n,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const v=/^(.*)#([^#]+)$/.exec(w);if(!v)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,i,b]=v;let k=this.trustedExtensionUrlPublicKeys.get(n);if(!k){if(k=this.productService.trustedExtensionUrlPublicKeys[n],!k||k.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...k])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=y.slice(0,6),m=y.readUIntBE(0,6),P=Date.now()-m;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const I=y.slice(6),c=g.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let h=0;h<k.length;h++){let o=k[h];if(o!==null){if(typeof o=="string")try{o=g.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),k[h]=o}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,l),k[h]=null;continue}if(c.verify(o,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=he([te(0,D.IProductService),te(1,M.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=g.createDecorator("protocolMainService")}),define(J[187],Z([0,1,2,10,7,48,14,6,37,3,15,28]),function(q,e,g,M,D,S,E,n,w,v,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let k=class extends g.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=w.TernarySearchTree.forUris(()=>!v.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(D.URI.file(d.appRoot)),this.addValidFileRoot(D.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=E.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(m,P)=>this.handleResourceRequest(m,P)),d.protocol.interceptFileProtocol(M.Schemas.file,(m,P)=>this.handleFileRequest(m,P)),this._register(g.toDisposable(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?g.Disposable.None:(this.validRoots.set(d,!0),g.toDisposable(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const P=D.URI.parse(d.url);return v.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})):this.validRoots.findSubstr(P)?m({path:P.fsPath}):this.validExtensions.has(i.extname(P))?m({path:P.fsPath}):(this.logService.error(`${M.Schemas.file}: Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3}))}handleResourceRequest(d,m){const P=D.URI.parse(d.url),I=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?m({path:I.fsPath}):this.validExtensions.has(i.extname(I))?m({path:I.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(){let d;const m=D.URI.from({scheme:"vscode",path:b.generateUuid()}),P=m.toString(),I=async()=>d;return E.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:m,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),E.ipcMain.removeHandler(P)}}}};k=he([te(0,S.INativeEnvironmentService),te(1,n.ILogService)],k),e.ProtocolMainService=k}),define(J[38],Z([0,1,13,103]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(E,n){M.ok(g.isString(E)),M.ok(g.isObject(n)),M.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new D}),define(J[188],Z([0,1,38,5]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new M.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,v){this.schemasById[D(w)]=v,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;g.Registry.add(e.Extensions.JSONContribution,E)}),define(J[50],Z([0,1,133,5,38,13,188]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=D.Registry.as(E.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,c=!0){this.registerConfigurations([I],c)}registerConfigurations(I,c=!0){const h=[];I.forEach(o=>{h.push(...this.validateAndRegisterProperties(o,c,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(I){const c=[],h=o=>{if(o.properties)for(const l in o.properties)c.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,o.properties[l]);o.allOf&&o.allOf.forEach(l=>h(l))};for(const o of I){h(o);const l=this.configurationContributors.indexOf(o);l!==-1&&this.configurationContributors.splice(l,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(I){const c=[],h=[];for(const o of I)for(const l in o)if(c.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...o[l]};const t={type:"object",default:this.defaultValues[l],description:g.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};h.push(b(l)),this.configurationProperties[l]=t,this.defaultLanguageConfigurationOverridesNode.properties[l]=t}else{this.defaultValues[l]=o[l];const t=this.configurationProperties[l];t&&(this.updatePropertyDefaultValue(l,t),this.updateSchema(l,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(I){const c=[];for(const h of I)for(const o in h)if(c.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const l=this.configurationProperties[o];l&&(this.updatePropertyDefaultValue(o,l),this.updateSchema(o,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const c of I)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,c=!0,h,o=3){o=S.isUndefinedOrNull(I.scope)?o:I.scope;let l=[],t=I.properties;if(t)for(let r in t){if(c&&d(r)){delete t[r];continue}const a=t[r];if(this.updatePropertyDefaultValue(r,a),e.OVERRIDE_PROPERTY_PATTERN.test(r)?a.scope=void 0:(a.scope=S.isUndefinedOrNull(a.scope)?o:a.scope,a.restricted=S.isUndefinedOrNull(a.restricted)?!!h?.restrictedConfigurations?.includes(r):a.restricted),t[r].hasOwnProperty("included")&&!t[r].included){this.excludedConfigurationProperties[r]=t[r],delete t[r];continue}else this.configurationProperties[r]=t[r];!t[r].deprecationMessage&&t[r].markdownDeprecationMessage&&(t[r].deprecationMessage=t[r].markdownDeprecationMessage),l.push(r)}let s=I.allOf;if(s)for(let r of s)l.push(...this.validateAndRegisterProperties(r,c,h,o));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const c=h=>{let o=h.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let l=h.allOf;l&&l.forEach(c)};c(I)}updateSchema(I,c){switch(e.allSettings.properties[I]=c,c.scope){case 1:e.applicationSettings.properties[I]=c;break;case 2:e.machineSettings.properties[I]=c;break;case 6:e.machineOverridableSettings.properties[I]=c;break;case 3:e.windowSettings.properties[I]=c;break;case 4:e.resourceSettings.properties[I]=c;break;case 5:e.resourceSettings.properties[I]=c,this.resourceLanguageSettingsSchema.properties[I]=c;break}}removeFromSchema(I,c){switch(delete e.allSettings.properties[I],c.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const c=`[${I}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,h),e.allSettings.properties[c]=h,e.applicationSettings.properties[c]=h,e.machineSettings.properties[c]=h,e.machineOverridableSettings.properties[c]=h,e.windowSettings.properties[c]=h,e.resourceSettings.properties[c]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,c){let h=this.defaultValues[I];S.isUndefined(h)&&(h=c.default),S.isUndefined(h)&&(h=k(c.type)),c.default=h}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function b(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=b;function k(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=k;const y=new v;D.Registry.add(e.Extensions.Configuration,y);function d(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?g.localize(5,null,P):y.getConfigurationProperties()[P]!==void 0?g.localize(6,null,P):null:g.localize(4,null)}e.validateProperty=d;function m(){const P=[],I=y.getConfigurationProperties();for(const c of Object.keys(I))P.push([c,I[c].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=m}),define(J[21],Z([0,1,44,13,7,38,4,50]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=E.createDecorator("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=w;var v;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(v=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function b(s,r){const a=r?s?r.keys.filter(C=>s.keys.indexOf(C)===-1):[...r.keys]:[],u=s?r?s.keys.filter(C=>r.keys.indexOf(C)===-1):[...s.keys]:[],p=[];if(r&&s){for(const C of s.keys)if(r.keys.indexOf(C)!==-1){const K=I(s.contents,C),ee=I(r.contents,C);g.equals(K,ee)||p.push(C)}}const f=[],L=C=>{const K={};for(const ee of C)for(const V of ee.identifiers)K[l(V)]=ee;return K},F=r?L(r.overrides):{},_=s?L(s.overrides):{};if(Object.keys(F).length)for(const C of a){const K=F[C];K&&f.push([n.overrideIdentifierFromKey(C),K.keys])}if(Object.keys(_).length)for(const C of u){const K=_[C];K&&f.push([n.overrideIdentifierFromKey(C),K.keys])}if(Object.keys(F).length&&Object.keys(_).length)for(const C of p){const K=_[C],ee=F[C];if(K&&ee){const V=b({contents:K.contents,keys:K.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});f.push([n.overrideIdentifierFromKey(C),[...V.added,...V.removed,...V.updated]])}}return{added:a,removed:u,updated:p,overrides:f}}e.compare=b;function k(s,r){const a=[];for(const u of Object.keys(s))if(n.OVERRIDE_PROPERTY_PATTERN.test(u)){const p={};for(const f in s[u])p[f]=s[u][f];a.push({identifiers:[n.overrideIdentifierFromKey(u).trim()],keys:Object.keys(p),contents:y(p,r)})}return a}e.toOverrides=k;function y(s,r){const a=Object.create(null);for(let u in s)d(a,u,s[u],r);return a}e.toValuesTree=y;function d(s,r,a,u){const p=r.split("."),f=p.pop();let L=s;for(let F=0;F<p.length;F++){let _=p[F],C=L[_];switch(typeof C){case"undefined":C=L[_]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${p.slice(0,F+1).join(".")} is ${JSON.stringify(C)}`);return}L=C}if(typeof L=="object"&&L!==null)try{L[f]=a}catch(F){u(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(L)}`)}else u(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=d;function m(s,r){const a=r.split(".");P(s,a)}e.removeFromValueTree=m;function P(s,r){const a=r.shift();if(r.length===0){delete s[a];return}if(Object.keys(s).indexOf(a)!==-1){const u=s[a];typeof u=="object"&&!Array.isArray(u)&&(P(u,r),Object.keys(u).length===0&&delete s[a])}}function I(s,r,a){function u(L,F){let _=L;for(const C of F){if(typeof _!="object"||_===null)return;_=_[C]}return _}const p=r.split("."),f=u(s,p);return typeof f=="undefined"?a:f}e.getConfigurationValue=I;function c(s,r,a){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in s?M.isObject(s[u])&&M.isObject(r[u])?c(s[u],r[u],a):a&&(s[u]=r[u]):s[u]=r[u])})}e.merge=c;function h(){const s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=h;function o(){const s=Object.create(null),r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let a in r){let u=r[a].default;d(s,a,u,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=o;function l(s){return`[${s}]`}e.keyFromOverrideIdentifier=l;function t(s,r,a){const u=s.inspect(r),p=s.inspect(a);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:u.defaultValue}e.getMigratedSettingValue=t}),define(J[189],Z([0,1,40,37,36,13,44,7,50,21,38,2,5]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?v.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?v.getConfigurationValue(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let u=this.contents[a],p=s[a];p&&(typeof u=="object"&&typeof p=="object"?(u=E.deepClone(u),this.mergeContents(u,p)):u=p),r[a]=u}return new y(r,this.keys,this.overrides)}merge(...t){const s=E.deepClone(this.contents),r=E.deepClone(this.overrides),a=[...this.keys];for(const u of t){this.mergeContents(s,u.contents);for(const p of u.overrides){const[f]=r.filter(L=>D.equals(L.identifiers,p.identifiers));f?this.mergeContents(f.contents,p.contents):r.push(E.deepClone(p))}for(const p of u.keys)a.indexOf(p)===-1&&a.push(p)}return new y(s,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=E.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),v.addToValueTree(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&v.removeFromValueTree(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=v.getDefaultValues(),s=v.getConfigurationKeys(),r=[];for(const a of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[w.overrideIdentifierFromKey(a).trim()],keys:Object.keys(t[a]),contents:v.toValuesTree(t[a],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,s,r)}}e.DefaultConfigurationModel=d;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:a,overrides:u,restricted:p}=this.doParseRaw(t,s);this._configurationModel=new y(r,a,u),this._restrictedConfigurations=p||[]}doParseContent(t){let s={},r=null,a=[],u=[],p=[];function f(F){Array.isArray(a)?a.push(F):r&&(a[r]=F)}let L={onObjectBegin:()=>{let F={};f(F),u.push(a),a=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let F=[];f(F),u.push(a),a=F,r=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:f,onError:(F,_,C)=>{p.push({error:F,offset:_,length:C})}};if(t)try{g.visit(t,L),s=a[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return s}doParseRaw(t,s){const r=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,r,!0,s);t=a.raw;const u=v.toValuesTree(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),p=Object.keys(t),f=v.toOverrides(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:u,keys:p,overrides:f,restricted:a.restricted}}filter(t,s,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const u={},p=[];for(let f in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(f)&&r){const L=this.filter(t[f],s,!1,a);u[f]=L.raw,p.push(...L.restricted)}else{const L=s[f],F=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&p.push(f),(F===void 0||a.scopes===void 0||a.scopes.includes(F))&&(a.skipRestricted&&L?.restricted||(u[f]=t[f]))}return{raw:u,restricted:p}}}e.ConfigurationModelParser=m;class P extends b.Disposable{constructor(t,s,r,a){super();this.userSettingsResource=t,this.scopes=s,this.fileService=a,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class I{constructor(t,s,r=new y,a=new y,u=new M.ResourceMap,p=new y,f=new M.ResourceMap,L=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=p,this._memoryConfigurationByResource=f,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new y,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,s===void 0?a.removeValue(t):a.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const a=this.getConsolidateConfigurationModel(s,r),u=this.getFolderConfigurationModelForResource(s.resource,r),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,f=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),F=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),C=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,K=u?s.overrideIdentifier?u.freeze().override(s.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,ee=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(t):p.getValue(t),V=a.getValue(t),x=D.distinct(D.flatten(a.overrides.map(Q=>Q.identifiers))).filter(Q=>a.getOverrideValue(t,Q)!==void 0);return{defaultValue:f,userValue:L,userLocalValue:F,userRemoteValue:_,workspaceValue:C,workspaceFolderValue:K,memoryValue:ee,value:V,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:K!==void 0?{value:u?.freeze().getValue(t),override:s.overrideIdentifier?u?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:p.getValue(t),override:s.overrideIdentifier?p.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:x.length?x:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(a=>w.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const u=w.overrideIdentifierFromKey(a),p=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=t.getKeysForOverrideIdentifier(u),L=[...f.filter(F=>p.indexOf(F)===-1),...p.filter(F=>f.indexOf(F)===-1),...p.filter(F=>!E.equals(this._defaultConfiguration.override(u).getValue(F),t.override(u).getValue(F)))];return[u,L]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:u}=v.compare(this.localUserConfiguration,t),p=[...s,...r,...a];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:u}=v.compare(this.remoteUserConfiguration,t);let p=[...s,...r,...a];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:a,overrides:u}=v.compare(this.workspaceConfiguration,t);let p=[...s,...r,...a];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:u}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:a,updated:u,removed:p,overrides:f}=v.compare(r,s);let L=[...a,...u,...p];return(L.length||!r)&&this.updateFolderConfiguration(t,s),{keys:L,overrides:f}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:u,overrides:p}=v.compare(s,void 0);return{keys:[...r,...a,...u],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const a=s.getFolder(t);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const u=this._memoryConfigurationByResource.get(t);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(s=r.merge(a),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:a,keys:u}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:a,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>s.add(a))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((p,f)=>(p.set(n.URI.revive(f[0]),this.parseConfigurationModel(f[1])),p),new M.ResourceMap);return new I(s,r,new y,a,u,new y,new M.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function c(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const t=new Set,s=new Map;for(const a of l)a.keys.forEach(u=>t.add(u)),a.overrides.forEach(([u,p])=>{const f=M.getOrSet(s,u,new Set);p.forEach(L=>f.add(L))});const r=[];return s.forEach((a,u)=>r.push([u,[...a.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=c;class h{constructor(t,s,r,a){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(f=>u.add(f)),t.overrides.forEach(([,f])=>f.forEach(L=>u.add(L))),this.affectedKeys=[...u.values()];const p=new y;this.affectedKeys.forEach(f=>p.setValue(f,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!E.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=v.toValuesTree({[s]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(t=t[a],!t)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(t,s,r,a){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(J[190],Z([0,1,38,50,2,21,189,5,9,15]),function(q,e,g,M,D,S,E,n,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(k,y){super();this.settingsResource=k,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,v.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(M.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const k=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,k)}getConfigurationData(){return this.configuration.toData()}getValue(k,y){const d=typeof k=="string"?k:void 0,m=S.isConfigurationOverrides(k)?k:S.isConfigurationOverrides(y)?y:{};return this.configuration.getValue(d,m,void 0)}updateValue(k,y,d,m){return Promise.reject(new Error("not supported"))}inspect(k){return this.configuration.inspect(k,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const k=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(k)}onDidChangeUserConfiguration(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(k);this.trigger(d,y,1)}onDidDefaultConfigurationChange(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,k);this.trigger(d,y,6)}trigger(k,y,d){const m=new E.ConfigurationChangeEvent(k,{data:y},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(k){switch(k){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[191],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=g.createDecorator("remoteAuthorityResolverService");var M;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(E,n=M.Unknown,w){super(E);this._message=E,this._code=n,this._detail=w,this.isHandled=n===M.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===M.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===M.NoResolverFound}static isHandled(E){return E instanceof D&&E.isHandled}}e.RemoteAuthorityResolverError=D}),define(J[192],Z([0,1,84,28,2,17,5,191,16,9,25]),function(q,e,g,M,D,S,E,n,w,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var k;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(k=e.ConnectionType||(e.ConnectionType={}));function y(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(W){const A=new i.CancellationTokenSource;return setTimeout(()=>A.cancel(),W),A.token}function m(W,A){if(W.isCancellationRequested||A.isCancellationRequested)return i.CancellationToken.Cancelled;const N=new i.CancellationTokenSource;return W.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class P{constructor(A){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((N,z)=>{this._resolvePromise=N,this._rejectPromise=z}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function I(W,A){const N=new P(A);return N.registerDisposable(W.onControlMessage(z=>{const Y=JSON.parse(z.toString()),G=H(Y);G?N.reject(G):N.resolve(Y)})),N.promise}function c(W,A,N,z,Y,G){const X=new P(G);return A.connect(N,z,Y,(ne,se)=>{X.didTimeout?(ne&&W.error(ne),se?.dispose()):ne||!se?X.reject(ne):X.resolve(se)}),X.promise}function h(W,A){const N=new P(A);return W.then(z=>{N.didTimeout||N.resolve(z)},z=>{N.didTimeout||N.reject(z)}),N.promise}async function o(W,A,N,z){const Y=R(W,A);W.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let G;try{G=await c(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,z)}catch(ue){throw W.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ue),ue}W.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let X,ne;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(G,null),X=W.reconnectionProtocol,ne=!1):(X=new g.PersistentProtocol(G,null),ne=!0),W.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:W.connectionToken||"00000000000000000000"};X.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const ue=await I(X,m(z,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}W.logService.trace(`${Y} 4/6. received SignRequest control message.`);const de=await h(W.signService.sign(ue.data),z),re={type:"connectionType",commit:W.commit,signedData:de,desiredConnectionType:A};return N&&(re.args=N),W.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(S.VSBuffer.fromString(JSON.stringify(re))),{protocol:X,ownsProtocol:ne}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(W.logService.error(`${Y} the handshake timed out. Error:`),W.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(ue)),ne&&$(X),ue}}async function l(W,A,N,z){const Y=Date.now(),G=R(W,A),{protocol:X,ownsProtocol:ne}=await o(W,A,N,z),se=new P(z);return se.registerDisposable(X.onControlMessage(ue=>{const de=JSON.parse(ue.toString()),re=H(de);re?(W.logService.error(`${G} received error control message when negotiating connection. Error:`),W.logService.error(re),ne&&$(X),se.reject(re)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${O(Y)}!`),se.resolve({protocol:X,firstMessage:de}))})),se.promise}async function t(W,A){const{protocol:N}=await l(W,1,void 0,A);return{protocol:N}}async function s(W,A,N){const{protocol:z,firstMessage:Y}=await l(W,2,A,N),G=Y&&Y.debugPort;return{protocol:z,debugPort:G}}async function r(W,A,N){const z=Date.now(),Y=R(W,3),{protocol:G}=await o(W,3,A,N);return W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${O(z)}!`),G}async function a(W,A,N){const{host:z,port:Y,connectionToken:G}=await W.addressProvider.getAddress();return{commit:W.commit,host:z,port:Y,connectionToken:G,reconnectionToken:A,reconnectionProtocol:N,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function u(W,A,N){try{const z=M.generateUuid(),Y=await a(W,z,null),{protocol:G}=await t(Y,i.CancellationToken.None);return new Q(W,A,N,z,G)}catch(z){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(z),x.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentManagement=u;async function p(W,A){try{const N=M.generateUuid(),z=await a(W,N,null),{protocol:Y,debugPort:G}=await s(z,A,i.CancellationToken.None);return new U(W,A,N,Y,G)}catch(N){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(N),x.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentExtensionHost=p;async function f(W,A){const N=await a(W,M.generateUuid(),null);return await r(N,{port:A},i.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function L(W){return v.createCancelablePromise(A=>new Promise((N,z)=>{const Y=setTimeout(N,W*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),N()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=_;class C{constructor(A,N,z,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=z,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class K{constructor(A,N,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=z,this.type=2}}e.ReconnectionRunningEvent=K;class ee{constructor(A,N,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=z,this.type=4}}e.ConnectionGainEvent=ee;class V{constructor(A,N,z,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=z,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=V;class x extends D.Disposable{constructor(A,N,z,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=N,this.reconnectionToken=z,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(G=>{const X=T(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${X} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${X} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${X} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const G=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),x._instances.push(this),x._permanentFailure&&this._gotoPermanentFailure(x._permanentFailureMillisSinceLastIncomingData,x._permanentFailureAttempt,x._permanentFailureHandled)}static triggerPermanentFailure(A,N,z){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=N,this._permanentFailureHandled=z,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(x._permanentFailure)return;const A=T(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const Y=z<N.length?N[z]:N[N.length-1];try{if(Y>0){const X=L(Y);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,X)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await X}catch{}}if(x._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this._options.logService.info(`${A} resolving connection...`);const G=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,d(b)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(w.isPromiseCanceledError(G)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,n.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),x.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!x._permanentFailure)}_gotoPermanentFailure(A,N,z){this._onDidStateChange.fire(new V(this.reconnectionToken,A,N,z)),$(this.protocol)}}x._permanentFailure=!1,x._permanentFailureMillisSinceLastIncomingData=0,x._permanentFailureAttempt=0,x._permanentFailureHandled=!1,x._instances=[];class Q extends x{constructor(A,N,z,Y,G){super(1,A,Y,G);this.client=this._register(new g.Client(G,{remoteAuthority:N,clientId:z},A.ipcLogger))}async _reconnect(A,N){await t(A,N)}}e.ManagementPersistentConnection=Q;class U extends x{constructor(A,N,z,Y,G){super(2,A,z,Y);this._startArguments=N,this.debugPort=G}async _reconnect(A,N){await s(A,this._startArguments,N)}}e.ExtensionHostPersistentConnection=U;function $(W){try{W.acceptDisconnect();const A=W.getSocket();W.dispose(),A.dispose()}catch(A){w.onUnexpectedError(A)}}function H(W){if(W&&W.type==="error"){const A=new Error(`Connection error: ${W.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(W,A){for(;W.length<A;)W+=" ";return W}function T(W,A,N){return`[remote-connection][${B(y(W),13)}][${A.substr(0,5)}\u2026][${N?"reconnect":"initial"}]`}function R(W,A){return`${T(A,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function O(W){return`${Date.now()-W} ms`}}),define(J[73],Z([0,1,10]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(v){return v.scheme===g.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=M;function D(v){if(!v)return;const i=v.indexOf("+");return i<0?v:v.substr(0,i)}e.getRemoteName=D;function S(v){return v.scheme!==g.Schemas.file&&v.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function E(v){if(v.folders.length)return v.folders.every(i=>S(i.uri))?v.folders[0].uri:void 0;if(v.configuration&&S(v.configuration))return v.configuration}e.getVirtualWorkspaceLocation=E;function n(v){return E(v)?.scheme}e.getVirtualWorkspaceScheme=n;function w(v){return E(v)!==void 0}e.isVirtualWorkspace=w}),define(J[74],Z([0,1,5,3,4,6]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=D.createDecorator("tunnelService");var E;(function(y){y.Http="http",y.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=v,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=i;function b(y,d){return d?d!==1&&y<1024:!M.isWindows&&y<1024}e.isPortPrivileged=b;let k=class{constructor(d){this.logService=d,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,m){return this._tunnelProvider=d,d?(this._canElevate=m.elevation,this._canMakePublic=m.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const m=[],P=Array.from(this._tunnels.values());for(let I of P){const c=Array.from(I.values());for(let h of c){const o=await h.value;o&&m.push(o)}}d(m)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,P,I,c=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${P} on local port ${I}.`),!d)return;m||(m="localhost");const l=this.retainOrCreateTunnel(d,m,P,I,c,h,o);return l?l.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==m||t.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const P=m.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,m,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const I=P.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),I}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const P=this._tunnels.get(d);if(P&&P.has(m)){const I=P.get(m);I.refcount=0,await this.tryDisposeTunnel(d,m,I)}}addTunnelToMap(d,m,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,m){const P=this._tunnels.get(d);P&&(await P.get(m)||P.delete(m),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let P=[d];v(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const I=P.map(c=>this._tunnels.get(c));for(const c of I){const h=c?.get(m);if(h)return h}}canTunnel(d){return!!w(d)}createWithProvider(d,m,P,I,c,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${P} on local port ${I}.`);const t={elevationRequired:c?b(I===void 0?P:I):!1},s={remoteAddress:{host:m,port:P},localAddressPort:I,public:h,protocol:o},r=d.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(m,P,r),r}};k=he([te(0,S.ILogService)],k),e.AbstractTunnelService=k}),define(J[51],Z([0,1,147,4,50,38,17]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=M.createDecorator("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function w(d){return d.res.statusCode===204}async function v(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return w(d)?null:(await E.streamToBuffer(d.stream)).toString()}e.asText=v;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(w(d))return null;const P=(await E.streamToBuffer(d.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=i;function b(d){y(d)}e.updateProxyConfigurationsScope=b;let k;function y(d){const m=S.Registry.as(D.Extensions.Configuration);k&&m.deregisterConfigurations([k]),k={id:"http",order:15,title:g.localize(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:g.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:g.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:g.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[g.localize(4,null),g.localize(5,null),g.localize(6,null),g.localize(7,null)],default:"override",description:g.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:g.localize(9,null),restricted:!0}}},m.registerConfiguration(k)}y(2)}),define(J[193],Z([0,1,194,13]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,w={}){const v=g.parse(E),i=w.proxyUrl||D(v,n);if(!i)return null;const b=g.parse(i);if(!/^https?:$/.test(b.protocol||""))return null;const k={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:M.isBoolean(w.strictSSL)?w.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((y,d)=>{q(["http-proxy-agent"],y,d)}))(k):new(await new Promise((y,d)=>{q(["https-proxy-agent"],y,d)}))(k)}e.getProxyAgent=S}),define(J[195],Z([0,1,28,17]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(S,E,n){let w=n&&n.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();w=g.isUUID(i)?i:null}catch(v){w=null}if(!w){w=g.generateUuid();try{await E.writeFile(S.serviceMachineIdResource,M.VSBuffer.fromString(w))}catch(v){}}return n&&n.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(J[75],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=g.createDecorator(e.SIGN_SERVICE_ID)}),define(J[196],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((D,S)=>q(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(D)}catch(S){}return D}}e.SignService=g}),define(J[39],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=g.createDecorator("stateMainService")}),define(J[22],Z([0,1,14,6,39,5,4,178,3,2,9,13,33]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=E.createDecorator("lifecycleMainService");var y;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(y=e.UnloadReason||(e.UnloadReason={}));var d;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class ot extends v.Disposable{constructor(I,c){super();this.logService=I,this.stateMainService=c,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ot.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ot.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};g.app.addListener("before-quit",I);const c=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&g.app.quit()};g.app.addListener("window-all-closed",c),g.app.once("will-quit",h=>{this.logService.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),g.app.removeListener("before-quit",I),g.app.removeListener("window-all-closed",c),g.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({join(c){I.push(c)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(I)}catch(c){this.logService.error(c)}try{await this.stateMainService.close()}catch(c){this.logService.error(c)}})(),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===I)return;this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const c=this.phaseWhen.get(this._phase);c&&(c.open(),this.phaseWhen.delete(this._phase))}async when(I){if(I<=this._phase)return;let c=this.phaseWhen.get(I);c||(c=new i.Barrier,this.phaseWhen.set(I,c)),await c.wait()}registerWindow(I){const c=new v.DisposableStore;this.windowCounter++,c.add(I.onWillLoad(o=>this._onWillLoadWindow.fire({window:I,workspace:o.workspace})));const h=b.assertIsDefined(I.win);h.on("close",o=>{const l=I.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),o.preventDefault(),this.unload(I,1).then(t=>{if(t){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(I),I.close()})}),h.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,c.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,c){await this.unload(I,3)||I.reload(c)}async unload(I,c){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const h=this._quitRequested?2:c;let o=await this.onBeforeUnloadWindowInRenderer(I,h);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(I,h),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,h),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,c){return new Promise(h=>{const o=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${o}`,t=`vscode:cancel${o}`;g.ipcMain.once(l,()=>{h(!1)}),g.ipcMain.once(t,()=>{h(!0)}),I.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:t,reason:c})})}onBeforeUnloadWindowInMain(I,c){const h=[];return this._onBeforeUnloadWindow.fire({reason:c,window:I,veto(o){h.push(o)}}),n.handleVetos(h,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(I,c){return new Promise(h=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;g.ipcMain.once(l,()=>h()),I.send("vscode:onWillUnload",{replyChannel:l,reason:c})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(ot.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(c=>{this.pendingQuitPromiseResolve=c,this.logService.trace("Lifecycle#quit() - calling app.quit()"),g.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const c=process.argv.slice(1);if(I?.addArgs&&c.push(...I.addArgs),I?.removeArgs)for(const l of I.removeArgs){const t=c.indexOf(l);t>=0&&c.splice(t,1)}const h=()=>{try{if(w.isWindows){const l=k.cwd();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),g.app.relaunch({args:c})};g.app.once("quit",h),await this.quit(!0)&&g.app.removeListener("quit",h)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const c of g.BrowserWindow.getAllWindows())if(c&&!c.isDestroyed()){let h;c.webContents&&!c.webContents.isDestroyed()?h=new Promise(o=>c.once("closed",o)):h=Promise.resolve(),c.destroy(),await h}})()]),g.app.exit(I)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=he([te(0,M.ILogService),te(1,D.IStateMainService)],m),e.LifecycleMainService=m}),define(J[197],Z([0,1,4,5,2,22]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=g.createDecorator("keyboardLayoutMainService");let E=class extends D.Disposable{constructor(v){super();this._onDidChangeKeyboardLayout=this._register(new M.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,v.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const v=await new Promise((i,b)=>{q(["native-keymap"],i,b)});this._keyboardLayoutData=n(v),v.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(v),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(w){const v=w.getKeyMap(),i=w.getCurrentKeyboardLayout();return{keyboardMapping:v,keyboardLayoutInfo:i}}}),define(J[96],Z([0,1,4,5,2,13,86,9]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=g.createDecorator("storageService");var v;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(v=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var b;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class k extends D.Disposable{constructor(P={flushInterval:k.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new M.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new M.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new M.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){D.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===w?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,c){return this.getStorage(I)?.get(P,c)}getBoolean(P,I,c){return this.getStorage(I)?.getBoolean(P,c)}getNumber(P,I,c){return this.getStorage(I)?.getNumber(P,c)}store(P,I,c,h){if(S.isUndefinedOrNull(I)){this.remove(P,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,c,h),this.getStorage(c)?.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{this.updateKeyTarget(P,I,void 0),this.getStorage(I)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const c=[],h=this.getKeyTargets(P);for(const o of Object.keys(h))h[o]===I&&c.push(o);return c}updateKeyTarget(P,I,c){const h=this.getKeyTargets(I);typeof c=="number"?h[P]!==c&&(h[P]=c,this.getStorage(I)?.set(w,JSON.stringify(h))):typeof h[P]=="number"&&(delete h[P],this.getStorage(I)?.set(w,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(w,P);if(I)try{return JSON.parse(I)}catch(c){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:v.NONE}),await n.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return d(P,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=k,k.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends k{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function d(m,P,I,c){const h=u=>{try{return JSON.parse(u)}catch(p){return u}},o=new Map,l=new Map;m.forEach((u,p)=>{o.set(p,u),l.set(p,h(u))});const t=new Map,s=new Map;P.forEach((u,p)=>{t.set(p,u),s.set(p,h(u))}),console.group(`Storage: Global (path: ${I})`);let r=[];o.forEach((u,p)=>{r.push({key:p,value:u})}),console.table(r),console.groupEnd(),console.log(l),console.group(`Storage: Workspace (path: ${c})`);let a=[];t.forEach((u,p)=>{a.push({key:p,value:u})}),console.table(a),console.groupEnd(),console.log(s)}e.logStorage=d}),define(J[198],Z([0,1,3,33,28,7]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(v){if(g.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function n(v,i,b,k,y,d,m,P,I,c){const h=Object.create(null);h["common.machineId"]=m,h.sessionID=D.generateUuid()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=g.PlatformToString(g.platform),h["common.nodePlatform"]=M.platform,h["common.nodeArch"]=k,h["common.product"]=c||"desktop";const o=w(P||[]);o&&(h["common.msftInternal"]=o);let l=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),g.isLinuxSnap&&(h["common.snap"]="true");const s=E(b);s&&(h["common.platformDetail"]=s);try{const r=await v.readFile(S.URI.file(I));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function w(v){const i=M.env.USERDNSDOMAIN;if(!i)return!1;const b=i.toLowerCase();return v.some(k=>b===k)}e.verifyMicrosoftInternalDomain=w}),define(J[32],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=g.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=g.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[199],Z([0,1,26,66,70,8,40,83,20,3,7,32,63,10,19,18]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(l,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,u=2e4;function p(F,_,C,K){const ee=_.substring(F.length+1);return new Promise(async V=>{let x;try{x=await m.Promises.readdir(_,{withFileTypes:!0})}catch($){V();return}if(K.count>=u){K.count+=x.length,K.maxReached=!0,V();return}let Q=x.length;if(Q===0){V();return}let U=x;K.count+x.length>u&&(K.maxReached=!0,Q=u-K.count,U=x.slice(0,Q)),K.count+=x.length;for(const $ of U)if($.isDirectory()){if(C.includes($.name)||await p(F,S.join(_,$.name),C,K),--Q==0){V();return}}else{const H=$.name.lastIndexOf(".");if(H>=0){const B=$.name.substring(H+1);B&&r.set(B,(r.get(B)??0)+1)}for(const B of s)B.relativePathPattern?.test(ee)!==!1&&B.filePattern.test($.name)&&a.set(B.tag,(a.get(B.tag)??0)+1);if(--Q==0){V();return}}})}const f={count:0,maxReached:!1};await p(l,l,t,f);const L=await h(l);return{configFiles:I(a),fileTypes:I(r),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=P;function I(l){return[...k.Iterable.map(l.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function c(){const l={os:`${g.type()} ${g.arch()} ${g.release()}`,memory:`${(g.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(g.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(M.virtualMachineHint.value()*100)}%`},t=g.cpus();return t&&t.length>0&&(l.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),l}e.getMachineInfo=c;async function h(l){try{const t=new Map,s=S.join(l,".vscode","launch.json"),r=await m.Promises.readFile(s),a=[],u=E.parse(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if(E.getNodeType(u)==="object"&&u.configurations)for(const p of u.configurations){const f=p.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return I(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${g.type()} ${g.arch()} ${g.release()}`);const r=g.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(g.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(g.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),v.isWindows||s.push(`Load (avg):       ${g.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(M.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([n.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[a,u]=r,p=this.formatProcessList(t,a);return s.forEach(f=>{if(D.isRemoteDiagnosticError(f))p+=`
${f.errorMessage}`,u+=`
${f.errorMessage}`;else if(p+=`

Remote: ${f.hostName}`,f.processes&&(p+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){u+=`
|  Remote: ${f.hostName}`;for(const L of Object.keys(f.workspaceMetadata)){const F=f.workspaceMetadata[L];let _=`${F.fileCount} files`;F.maxFilesReached&&(_=`more than ${_}`),u+=`|    Folder (${L}): ${_}`,u+=this.formatWorkspaceStats(F)}}}),{processInfo:p,workspaceInfo:u}})}async getSystemInfo(t,s){const{memory:r,vmHint:a,os:u,cpus:p}=c(),f={os:u,memory:r,cpus:p,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return v.isWindows||(f.load=`${g.loadavg().map(L=>Math.round(L)).join(", ")}`),v.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,s){const r=[];return n.listProcesses(t.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,a)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(u=>{if(D.isRemoteDiagnosticError(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.formatMachineInfo(u.machineInfo)),u.processes&&r.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const p of Object.keys(u.workspaceMetadata)){const f=u.workspaceMetadata[p];let L=`${f.fileCount} files`;f.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${p}): ${L}`),r.push(this.formatWorkspaceStats(f))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[],r=60;let a=0;const u=(F,_)=>{const C=` ${F}(${_})`;a+C.length>r?(s.push(p),p="|                 ",a=p.length):a+=C.length,p+=C};let p="|      File types:";const f=10;let L=t.fileTypes.length>f?f:t.fileTypes.length;for(let F=0;F<L;F++){const _=t.fileTypes[F];u(_.name,_.count)}if(s.push(p),t.configFiles.length>=0&&(p="|      Conf files:",a=0,t.configFiles.forEach(F=>{u(F.name,F.count)}),s.push(p)),t.launchConfigFiles.length>0){let F="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{F+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),s.push(F)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(u=>{const p=i.URI.revive(u);if(p.scheme===y.Schemas.file){const f=p.fsPath;r.push(P(f,["node_modules",".git"]).then(L=>{let F=`${L.fileCount} files`;L.maxFilesReached&&(F=`more than ${F}`),s.push(`|    Folder (${S.basename(f)}): ${F}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${f} (${L.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(u=>r.set(u.pid,u.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(t,s,r,a,u){const p=u===0;let f;p?f=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(u)} ${a.name}`,a.name==="window"&&(f=`${f} (${s.get(a.pid)})`));const L=process.platform==="win32"?a.mem:g.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(F=>this.formatProcessItem(t,s,r,F,u+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=i.URI.revive(s);if(r.scheme!==y.Schemas.file)continue;const a=r.fsPath;try{const u=await P(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),u.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})}),u.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};o=he([te(0,b.ITelemetryService),te(1,w.IProductService)],o),e.DiagnosticsService=o}),define(J[200],Z([0,1,16,169,172,44,32,51,163,48,25,6,19,7,20,96,195,4,15]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var h;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished"})(h||(h={}));function o(...B){return String(B.reduce((T,R)=>T|R,0))}var l;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(l||(l={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:h.None,criteria:[],assetTypes:[]};class u{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,R=this.state.pageSize){return new u({...this.state,pageNumber:T,pageSize:R})}withFilter(T,...R){const O=[...this.state.criteria,...R.length?R.map(W=>({filterType:T,value:W})):[{filterType:T}]];return new u({...this.state,criteria:O})}withSortBy(T){return new u({...this.state,sortBy:T})}withSortOrder(T){return new u({...this.state,sortOrder:T})}withFlags(...T){return new u({...this.state,flags:T.reduce((R,O)=>R|O,0)})}withAssetTypes(...T){return new u({...this.state,assetTypes:T})}get raw(){const{criteria:T,pageNumber:R,pageSize:O,sortBy:W,sortOrder:A,flags:N,assetTypes:z}=this.state;return{filters:[{criteria:T,pageNumber:R,pageSize:O,sortBy:W,sortOrder:A}],assetTypes:z,flags:N}}get searchText(){const T=this.state.criteria.filter(R=>R.filterType===l.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function p(B,T){const R=(B||[]).filter(O=>O.statisticName===T)[0];return R?R.value:0}function f(B){const T="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(O=>O.assetType.indexOf(T)===0).reduce((O,W)=>{const A=C(B,W.assetType);return A&&O.push([W.assetType.substring(T.length),A]),O},[])}function L(B){if(B.properties){const T=B.properties.filter(W=>W.key===t.Repository),R=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),O=T.filter(W=>R.test(W.value))[0];return O?{uri:O.value,fallbackUri:O.value}:null}return C(B,t.Repository)}function F(B){return{uri:`${B.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${B.fallbackAssetUri}/${t.VSIX}`}}function _(B){const T=C(B,t.Icon);if(T)return T;const R=M.DefaultIconPath;return{uri:R,fallbackUri:R}}function C(B,T){return B.files.filter(O=>O.assetType===T)[0]?{uri:`${B.assetUri}/${T}`,fallbackUri:`${B.fallbackAssetUri}/${T}`}:null}function K(B,T){const R=B.properties?B.properties.filter(W=>W.key===T):[],O=R.length>0&&R[0].value;return O?O.split(",").map(W=>D.adoptToGalleryExtensionId(W)):[]}function ee(B){const T=B.properties?B.properties.filter(R=>R.key===s.Engine):[];return T.length>0&&T[0].value||""}function V(B){const T=B.properties?B.properties.filter(O=>O.key===s.LocalizedLanguages):[],R=T.length>0&&T[0].value||"";return R?R.split(","):[]}function x(B){return B.indexOf("preview")!==-1}function Q(B){return B.files.some(T=>T.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?c.joinPath(y.URI.parse(B.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(B,T,R,O,W){const A={manifest:C(T,t.Manifest),readme:C(T,t.Details),changelog:C(T,t.Changelog),license:C(T,t.License),repository:L(T),download:F(T),icon:_(T),coreTranslations:f(T)};return{identifier:{id:D.getGalleryExtensionId(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:T.version,date:T.lastUpdated,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,description:B.shortDescription||"",installCount:p(B.statistics,"install"),rating:p(B.statistics,"averagerating"),ratingCount:p(B.statistics,"ratingcount"),assetUri:y.URI.parse(T.assetUri),webExtension:!!B.tags?.includes(M.WEB_EXTENSION_TAG),webResource:Q(T),assetTypes:T.files.map(({assetType:N})=>N),assets:A,properties:{dependencies:K(T,s.Dependency),extensionPack:K(T,s.ExtensionPack),engine:ee(T),localizedLanguages:V(T)},telemetryData:{index:(O.pageNumber-1)*O.pageSize+R,querySource:W},preview:x(B.flags)}}let $=class{constructor(T,R,O,W,A,N,z){this.requestService=T,this.logService=R,this.environmentService=O,this.telemetryService=W,this.fileService=A,this.productService=N;const Y=N.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=H(N.version,this.environmentService,this.fileService,z)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,R){const O=[];let{total:W,firstPage:A,getPage:N}=await this.query({names:T,pageSize:T.length},R);O.push(...A);for(let z=1;O.length<W&&(A=await N(z,R),A.length);z++)O.push(...A);return O}async getCompatibleExtension(T,R){return this.getCompatibleExtensionByEngine(T,R)}async getCompatibleExtensionByEngine(T,R){const O=M.isIExtensionIdentifier(T)?null:T;if(O&&O.properties.engine&&w.isEngineValid(O.properties.engine,this.productService.version,this.productService.date))return O;const{id:W,uuid:A}=O?O.identifier:T;let N=new u().withFlags(h.IncludeAssetUri,h.IncludeStatistics,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");A?N=N.withFilter(l.ExtensionId,A):N=N.withFilter(l.ExtensionName,W);const{galleryExtensions:z}=await this.queryGallery(N,i.CancellationToken.None),[Y]=z;if(!Y||!Y.versions.length)return null;if(R){const X=Y.versions.filter(ne=>ne.version===R)[0];if(X){const ne=U(Y,X,0,N);if(ne.properties.engine&&w.isEngineValid(ne.properties.engine,this.productService.version,this.productService.date))return ne}return null}const G=await this.getLastValidExtensionVersion(Y,Y.versions);return G?U(Y,G,0,N):null}async query(T,R){const O=i.CancellationToken.isCancellationToken(T)?{}:T,W=i.CancellationToken.isCancellationToken(T)?T:R;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let A=O.text||"";const N=S.getOrDefault(O,se=>se.pageSize,50);let z=new u().withFlags(h.IncludeLatestVersionOnly,h.IncludeAssetUri,h.IncludeStatistics,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,N).withFilter(l.Target,"Microsoft.VisualStudio.Code");A?(A=A.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ue,de)=>(z=z.withFilter(l.Category,de||ue),"")),A=A.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,ue,de)=>(z=z.withFilter(l.Tag,de||ue),"")),A=A.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(l.Featured),"")),A=A.trim(),A&&(A=A.length<200?A:A.substring(0,200),z=z.withFilter(l.SearchText,A)),z=z.withSortBy(0)):O.ids?z=z.withFilter(l.ExtensionId,...O.ids):O.names?z=z.withFilter(l.ExtensionName,...O.names):z=z.withSortBy(4),typeof O.sortBy=="number"&&(z=z.withSortBy(O.sortBy)),typeof O.sortOrder=="number"&&(z=z.withSortOrder(O.sortOrder));const{galleryExtensions:Y,total:G}=await this.queryGallery(z,W),X=Y.map((se,ue)=>U(se,se.versions[0],ue,z,O.source)),ne=async(se,ue)=>{if(ue.isCancellationRequested)throw g.canceled();const de=z.withPage(se+1),{galleryExtensions:re}=await this.queryGallery(de,ue);return re.map((le,Ee)=>U(le,le.versions[0],Ee,de,O.source))};return{firstPage:X,total:G,pageSize:z.pageSize,getPage:ne}}async queryGallery(T,R){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,h.ExcludeNonValidated).withFilter(l.ExcludeWithFlags,o(h.Unpublished));const O=await this.commonHeadersPromise,W=JSON.stringify(T.raw),A={...O,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},N=new Date().getTime();let z,Y,G=0;try{if(z=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:A},R),z.res.statusCode&&z.res.statusCode>=400&&z.res.statusCode<500)return{galleryExtensions:[],total:G};const X=await n.asJson(z);if(X){const ne=X.results[0],se=ne.extensions,ue=ne.resultMetadata&&ne.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return G=ue&&ue.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:G}}return{galleryExtensions:[],total:G}}catch(X){throw Y=X,X}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(W.length),duration:new Date().getTime()-N,success:!!z&&n.isSuccess(z),responseBodySize:z?.res.headers["Content-Length"],statusCode:z?String(z.res.statusCode):void 0,errorCode:Y?g.isPromiseCanceledError(Y)?"canceled":g.getErrorMessage(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(G)})}}async reportStatistic(T,R,O,W){if(!this.isEnabled())return;const N={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${T}/extensions/${R}/${O}/stats?statType=${W}`),headers:N},i.CancellationToken.None)}catch(z){}}async download(T,R,O){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const W=D.getGalleryExtensionTelemetryData(T),A=new Date().getTime(),N=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...W,duration:X}),z=O===1?"install":O===2?"update":"",Y=z?{uri:`${T.assets.download.uri}&${z}=true`,fallbackUri:`${T.assets.download.fallbackUri}?${z}=true`}:T.assets.download,G=await this.getAsset(Y);await this.fileService.writeFile(R,G.stream),N(new Date().getTime()-A)}async getReadme(T,R){if(T.assets.readme){const O=await this.getAsset(T.assets.readme,{},R);return await n.asText(O)||""}return""}async getManifest(T,R){if(T.assets.manifest){const O=await this.getAsset(T.assets.manifest,{},R),W=await n.asText(O);return W?JSON.parse(W):null}return null}async getCoreTranslation(T,R){const O=T.assets.coreTranslations.filter(W=>W[0]===R.toUpperCase())[0];if(O){const W=await this.getAsset(O[1]),A=await n.asText(W);return A?JSON.parse(A):null}return null}async getChangelog(T,R){if(T.assets.changelog){const O=await this.getAsset(T.assets.changelog,{},R);return await n.asText(O)||""}return""}async getAllVersions(T,R){let O=new u().withFlags(h.IncludeVersions,h.IncludeCategoryAndTags,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(l.Target,"Microsoft.VisualStudio.Code");T.identifier.uuid?O=O.withFilter(l.ExtensionId,T.identifier.uuid):O=O.withFilter(l.ExtensionName,T.identifier.id);const W=[],{galleryExtensions:A}=await this.queryGallery(O,i.CancellationToken.None);return A.length&&(R?await Promise.all(A[0].versions.map(async N=>{let z;try{z=await this.getEngine(N)}catch(Y){}z&&w.isEngineValid(z,this.productService.version,this.productService.date)&&W.push({version:N.version,date:N.lastUpdated})})):W.push(...A[0].versions.map(N=>({version:N.version,date:N.lastUpdated})))),W}async getAsset(T,R={},O=i.CancellationToken.None){const W=await this.commonHeadersPromise,A={type:"GET"},N={...W,...R.headers||{}};R={...R,...A,headers:N};const z=T.uri,Y=T.fallbackUri,G={...R,url:z};try{const X=await this.requestService.request(G,O);if(X.res.statusCode===200)return X;const ne=await n.asText(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${ne}`)}catch(X){if(g.isPromiseCanceledError(X))throw X;const ne=g.getErrorMessage(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:z,message:ne});const se={...R,url:Y};return this.requestService.request(se,O)}}async getLastValidExtensionVersion(T,R){const O=this.getLastValidExtensionVersionFromProperties(T,R);return O||this.getLastValidExtensionVersionRecursively(T,R)}getLastValidExtensionVersionFromProperties(T,R){for(const O of R){const W=ee(O);if(!W)return null;if(w.isEngineValid(W,this.productService.version,this.productService.date))return O}return null}async getEngine(T){const R=ee(T);if(R)return R;const O=C(T,t.Manifest);if(!O)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},A=await this.getAsset(O,{headers:W}),N=await n.asJson(A);if(N)return N.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(T,R){if(!R.length)return null;const O=R[0],W=await this.getEngine(O);return w.isEngineValid(W,this.productService.version,this.productService.date)?{...O,properties:[...O.properties||[],{key:s.Engine,value:W}]}:this.getLastValidExtensionVersionRecursively(T,R.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const R=await n.asJson(T),O=new Map;if(R)for(const W of R.malicious){const A=O.get(W)||{id:{id:W},malicious:!0,slow:!1};A.malicious=!0,O.set(W,A)}return[...O.values()]}};$=he([te(0,n.IRequestService),te(1,b.ILogService),te(2,v.IEnvironmentService),te(3,E.ITelemetryService),te(4,k.IFileService),te(5,d.IProductService),te(6,I.optional(m.IStorageService))],$),e.ExtensionGalleryService=$;async function H(B,T,R,O){const W={"X-Market-Client-Id":`VSCode ${B}`,"User-Agent":`VSCode ${B}`},A=await P.getServiceMachineId(T,R,O);return W["X-Market-User-Id"]=A,W}e.resolveMarketplaceHeaders=H}),define(J[201],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class g{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:w}){return this.appender.log(n,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=g;class M{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(J[202],Z([0,1,49,148,23,4,21,50,2,44,38]),function(q,e,g,M,D,S,E,n,w,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp(D.escapeRegExpCharacters(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}setEnabled(d){this._enabled=d}_updateUserOptIn(){const d=this._configurationService?.getValue(k);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,P=d["common.instanceId"],I=d["common.machineId"],c=d["common.firstSessionDate"],h=d["common.msftInternal"];return{sessionId:m,instanceId:P,machineId:I,firstSessionDate:c,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(d,m,P){return this.isOptedIn?this._commonProperties.then(I=>{m=v.mixin(m,I),m=v.mixin(m,this._experimentProperties),m=v.cloneAndChange(m,c=>{if(typeof c=="string")return this._cleanupInfo(c,P)}),this._appender.log(d,m)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(d,m,P){return this.publicLog(d,m,P)}publicLogError(d,m){return this.sendErrorTelemetry?this.publicLog(d,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_cleanupInfo(d,m){let P=d;if(m){const I=[];for(let l of this._cleanupPatterns)for(;;){const t=l.exec(d);if(!t)break;I.push([t.index,l.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const l=h.exec(d);if(!l)break;!c.test(l[0])&&I.every(([t,s])=>l.index<t||l.index>=s)&&(P+=d.substring(o,l.index)+"<REDACTED: user-file-path>",o=h.lastIndex)}o<d.length&&(P+=d.substr(o))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=he([te(1,S.optional(E.IConfigurationService))],b),e.TelemetryService=b;const k="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:k,order:110,type:"object",title:M.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:g.default.privacyStatementUrl?M.localize(2,null,g.default.privacyStatementUrl):M.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[97],Z([0,1,21,44,13,9]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,m){return Promise.resolve(void 0)}publicLog2(d,m){return this.publicLog(d,m)}publicLogError(d,m){return Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(m,P,I){}async publicLogError(m,P,I){}}e.NullEndpointTelemetryService=E;function n(...d){return{log:(m,P)=>d.forEach(I=>I.log(m,P)),flush:()=>S.Promises.settled(d.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(d,m){return m.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:g.ConfigurationTargetToString(P.source),configurationKeys:k(P.sourceConfig)})})}e.configurationTelemetry=w;function v(d){const m=Object.create(null),P=Object.create(null),I=Object.create(null);b(d,I);for(let c in I){c=c.length>150?c.substr(c.length-149):c;const h=I[c];typeof h=="number"?P[c]=h:typeof h=="boolean"?P[c]=h?1:0:typeof h=="string"?m[c]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(m[c]=h)}return{properties:m,measurements:P}}e.validateTelemetryData=v;function i(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{d.indexOf(`${I}+`)===0&&(m=I)}),m}e.cleanRemoteAuthority=i;function b(d,m,P=0,I){if(!!d)for(let c of Object.getOwnPropertyNames(d)){const h=d[c],o=I?I+c:c;Array.isArray(h)?m[o]=M.safeStringify(h):h instanceof Date?m[o]=h.toISOString():D.isObject(h)?P<2?b(h,m,P+1,o+"."):m[o]=M.safeStringify(h):m[o]=h}}function k(d){if(!d)return[];const m=[];return y(m,"",d),m}function y(d,m,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>y(d,m?`${m}.${I}`:I,P[I])):d.push(m)}}),define(J[203],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(J[204],Z([0,1,4,2,38,5,203,109]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=g.createDecorator("themeService");var w;(function(P){function I(c){return c&&typeof c=="object"&&typeof c.id=="string"}P.isThemeColor=I})(w=e.ThemeColor||(e.ThemeColor={}));function v(P){return{id:P}}e.themeColorFromId=v;var i;(function(P){function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}P.isThemeIcon=I;const c=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function h(s){const r=c.exec(s);if(!r)return;let[,a]=r;return{id:a}}P.fromString=h;function o(s,r){let a=s.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),r&&(a=`${a}~${r}`),{id:a}}P.modify=o;function l(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=l;function t(s){return{id:s.id}}P.asThemeIcon=t,P.asClassNameArray=n.CSSIcon.asClassNameArray,P.asClassName=n.CSSIcon.asClassName,P.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function b(P){switch(P){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class k{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),M.toDisposable(()=>{const c=this.themingParticipants.indexOf(I);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new k;D.Registry.add(e.Extensions.ThemingContribution,y);function d(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=d;class m extends M.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,c){let h=this.theme.getColor(I);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(J[60],Z([0,1,14,3,39,4]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",w="#000000",v="theme",i="themeBackground",b="windowSplash";e.IThemeMainService=S.createDecorator("themeMainService");let k=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((M.isWindows||M.isMacintosh)&&g.nativeTheme.shouldUseInvertedColorScheme)return w;let d=this.stateMainService.getItem(i,null);if(!d){let m;(M.isWindows||M.isMacintosh)&&g.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(v,"vs-dark").split(" ")[0],d=m==="hc-black"?w:m==="vs"?E:n}return M.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,m){this.stateMainService.setItems([{key:v,data:m.baseTheme},{key:i,data:m.colorInfo.background},{key:b,data:m}]),typeof d=="number"&&this.updateBackgroundColor(d,m)}updateBackgroundColor(d,m){for(const P of g.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};k=he([te(0,D.IStateMainService)],k),e.ThemeMainService=k}),define(J[42],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(M=e.StateType||(e.StateType={}));var D;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=g.createDecorator("updateService")}),define(J[205],Z([0,1,38,50,149,3]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:D.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:D.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[D.localize(2,null),D.localize(3,null),D.localize(4,null),D.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:D.localize(6,null),deprecationMessage:D.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:D.localize(8,null),description:D.localize(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:D.localize(10,null),tags:["usesOnlineServices"]}}})}),define(J[206],Z([0,1,5,42]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(n,w,v){switch(w){case"checkForUpdates":return this.service.checkForUpdates(v);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=D;class S{constructor(n){this.channel=n,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event,this._state=M.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[98],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=g.createDecorator("urlService")}),define(J[207],Z([0,1,7]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(n){this.handler=n}listen(n,w){throw new Error(`Event not found: ${w}`)}call(n,w,v){switch(w){case"handleURL":return this.handler.handleURL(g.URI.revive(v[0]),v[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=M;class D{constructor(n){this.channel=n}handleURL(n,w){return this.channel.call("handleURL",[n.toJSON(),w])}}e.URLHandlerChannelClient=D;class S{constructor(n){this.next=n}async routeCall(n,w,v,i){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(v){const b=g.URI.revive(v);if(b&&b.query){const k=/\bwindowId=(\d+)/.exec(b.query);if(k){const y=k[1],d=new RegExp(`window:${y}`),m=n.connections.find(P=>d.test(P.ctx));if(m)return m}}}return this.next.routeCall(n,w,v,i)}routeEvent(n,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(J[208],Z([0,1,7,9,2,20]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(v,i){const b=[...this.handlers.values()];return M.first(b.map(k=>()=>k.handleURL(v,i)),void 0,!1).then(k=>k||!1)}registerHandler(v){return this.handlers.add(v),D.toDisposable(()=>this.handlers.delete(v))}}e.AbstractURLService=E;let n=class extends E{constructor(v){super();this.productService=v}create(v){let{authority:i,path:b,query:k,fragment:y}=v||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&b&&b.indexOf("/")!==0&&(b=`/${b}`),g.URI.from({scheme:this.productService.urlProtocol,authority:i,path:b,query:k,fragment:y})}};n=he([te(0,S.IProductService)],n),e.NativeURLService=n}),define(J[209],Z([0,1,5,14,7,2,3,9]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(i){try{return D.URI.parse(i)}catch(b){return null}}class v{constructor(b,k,y,d,m){if(this.urlService=k,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=b,E.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),M.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,c)}const P=g.Event.map(g.Event.fromNodeEventEmitter(M.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(P(c=>{const h=w(c);!h||this.urlService.open(h,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():g.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const k of this.uris)await this.urlService.open(k.uri,{originalUrl:k.url})||b.push(k);b.length!==0&&(this.uris=b,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=v}),define(J[76],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=g.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[210],Z([0,1,14,2,10,7,76]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends M.Disposable{constructor(){super();const v=g.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);g.protocol.registerFileProtocol(D.Schemas.vscodeWebview,i),v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,i)}async handleWebviewRequest(v,i){try{const b=S.URI.parse(v.url),k=n.validWebviewFilePaths.get(b.path);if(typeof k=="string"){const y=b.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${k}`:`vs/workbench/contrib/webview/browser/pre/${k}`,d=D.FileAccess.asFileUri(y,q);return i(decodeURIComponent(d.fsPath))}}catch{}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(v){return!!v.workspaceUri}e.isWorkspaceToOpen=M;function D(v){return!!v.folderUri}e.isFolderToOpen=D;function S(v){return!!v.fileUri}e.isFileToOpen=S;function E(v){const i=n(v),b=v.getValue("window.menuBarVisibility");return b==="default"||i==="native"&&b==="compact"||g.isMacintosh&&g.isNative?"classic":b}e.getMenuBarVisibility=E;function n(v){if(g.isWeb)return"custom";const i=v.getValue("window");if(i){if(g.isMacintosh&&i.nativeTabs===!0||g.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return g.isLinux?"native":"custom"}e.getTitleBarStyle=n;function w(v=0){return Math.pow(1.2,v)}e.zoomLevelToZoomFactor=w}),define(J[35],Z([0,1,4]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var M;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const D=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=D;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var E;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(E=e.WindowError||(e.WindowError={})),e.IWindowsMainService=g.createDecorator("windowsMainService")}),define(J[211],Z([0,1,14,5,2,74,76,210,35]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let v=class extends D.Disposable{constructor(b,k){super();this.windowsMainService=k,this._onFoundInFrame=this._register(new M.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new n.WebviewProtocolProvider);const y=g.session.fromPartition(E.webviewPartitionId);y.setPermissionRequestHandler((d,m,P)=>P(m==="clipboard-read")),y.setPermissionCheckHandler((d,m)=>m==="clipboard-read")}async setIgnoreMenuShortcuts(b,k){let y;if(typeof b.windowId=="number"){const{windowId:d}=b,m=this.windowsMainService.getWindowById(d);if(!m?.win)throw new Error(`Invalid windowId: ${d}`);y=m.win.webContents}else{const{webContentsId:d}=b;if(y=g.webContents.fromId(d),!y)throw new Error(`Invalid webContentsId: ${d}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(k)}async findInFrame(b,k,y,d){const m=this.getFrameByName(b,k),P=m;if(typeof P.findInFrame=="function"){P.findInFrame(y,{findNext:d.findNext,forward:d.forward});const I=(c,h)=>{h.finalUpdate&&(this._onFoundInFrame.fire(h),m.removeListener("found-in-frame",I))};m.on("found-in-frame",I)}}async stopFindInFrame(b,k,y){const m=this.getFrameByName(b,k);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(b,k){const y=this.windowsMainService.getWindowById(b.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${b}`);const d=y.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===k);if(!d)throw new Error(`Unknown frame: ${k}`);return d}};v=he([te(0,S.ITunnelService),te(1,w.IWindowsMainService)],v),e.WebviewMainService=v}),define(J[212],Z([0,1,5,2,9]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:w,getActiveWindowId:v}){super();this.disposables=this._register(new M.DisposableStore),g.Event.latch(g.Event.any(n,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=D.createCancelablePromise(()=>v()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[213],Z([0,1,7,15,4,37]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=D.createDecorator("contextService");var E;(function(k){k[k.EMPTY=1]="EMPTY",k[k.FOLDER=2]="FOLDER",k[k.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(k){const y=k;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function w(k){const y=k;return!!(y&&typeof y=="object"&&g.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=w;class v{constructor(y,d,m,P){this._id=y,this._configuration=m,this._ignorePathCasing=P,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=v;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return M.joinPath(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function b(k){return new i({uri:k,index:0,name:M.basenameOrAuthority(k)},{uri:k.toString()})}e.toWorkspaceFolder=b}),define(J[27],Z([0,1,4,152,213,7,3,8,15,78,40,10,31,30,73]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:M.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(U){return(typeof U=="string"?n.extname(U):w.extname(U))===m}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=g.createDecorator("workspacesService");function I(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function c(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(U){const $=U;return typeof $?.id=="string"&&S.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=o;function l(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=l;function t(U){const $=U;return typeof $?.id=="string"&&S.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function s(U){const $=U;if($?.uri)return{id:$.id,uri:S.URI.revive($.uri)};const H=U;if(H?.configPath)return{id:H.id,configPath:S.URI.revive(H.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,$){return w.extUriBiasedIgnorePathCase.isEqualOrParent(U,$.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(U){return u(U)||p(U)}e.isStoredWorkspaceFolder=a;function u(U){const $=U;return typeof $?.path=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=u;function p(U){const $=U;return typeof $?.uri=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=p;function f(U,$,H,B,T=!E.isWindows,R){if(U.scheme!==B.scheme)return{name:H,uri:U.toString(!0)};let O=$?void 0:R.relativePath(B,U);if(O!==void 0)O.length===0?O=".":E.isWindows&&U.scheme===b.Schemas.file&&!T&&(O=O.replace(/\//g,"\\"));else if(U.scheme===b.Schemas.file)O=U.fsPath,E.isWindows&&(O=k.normalizeDriveLetter(O),T&&(O=y.toSlashes(O)));else{if(!R.isEqualAuthority(U.authority,B.authority))return{name:H,uri:U.toString(!0)};O=U.path}return{name:H,path:O}}e.getStoredWorkspaceFolder=f;function L(U,$,H){let B=[],T=new Set;const R=H.dirname($);for(let O of U){let W;if(u(O))O.path&&(W=H.resolvePath(R,O.path));else if(p(O))try{W=S.URI.parse(O.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(A){console.warn(A)}if(W){let A=H.getComparisonKey(W);if(!T.has(A)){T.add(A);const N=O.name||H.basenameOrAuthority(W);B.push(new D.WorkspaceFolder({uri:W,name:N,index:B.length},O))}}}return B}e.toWorkspaceFolders=L;function F(U,$,H,B,T){let R=_($,U);const O=T.dirname($),W=T.dirname(B),A=[],N=C(R.folders);for(const X of R.folders){const ne=u(X)?T.resolvePath(O,X.path):S.URI.parse(X.uri);let se;H?se=!1:se=!u(X)||n.isAbsolute(X.path),A.push(f(ne,se,X.name,W,N,T))}const z={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},Y=v.setProperty(U,["folders"],A,z);let G=v.applyEdits(U,Y);return R.remoteAuthority===d.getRemoteAuthority(B)&&(G=v.applyEdits(G,v.removeProperty(G,["remoteAuthority"],z))),G}e.rewriteWorkspaceFileForNewLocation=F;function _(U,$){let H=i.parse($);if(H&&Array.isArray(H.folders))H.folders=H.folders.filter(B=>a(B));else throw new Error(`${U} looks like an invalid workspace file.`);return H}function C(U){return E.isWindows?U.some($=>u($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function K(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function ee(U){return typeof U.folderUri=="string"}function V(U){return typeof U.fileUri=="string"}function x(U,$){const H={workspaces:[],files:[]};if(U){const B=function(R,O){for(let W=0;W<R.length;W++)try{O(R[W],W)}catch(A){$.warn(`Error restoring recent entry ${JSON.stringify(R[W])}: ${A.toString()}. Skip entry.`)}},T=U;if(Array.isArray(T.entries))B(T.entries,R=>{const O=R.label,W=R.remoteAuthority;K(R)?H.workspaces.push({label:O,remoteAuthority:W,workspace:{id:R.workspace.id,configPath:S.URI.parse(R.workspace.configPath)}}):ee(R)?H.workspaces.push({label:O,remoteAuthority:W,folderUri:S.URI.parse(R.folderUri)}):V(R)&&H.files.push({label:O,remoteAuthority:W,fileUri:S.URI.parse(R.fileUri)})});else{const R=U;Array.isArray(R.workspaces3)&&B(R.workspaces3,(O,W)=>{const A=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[W]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?H.workspaces.push({label:A,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&H.workspaces.push({label:A,folderUri:S.URI.parse(O)})}),Array.isArray(R.files2)&&B(R.files2,(O,W)=>{const A=Array.isArray(R.fileLabels)&&R.fileLabels[W]||void 0;typeof O=="string"&&H.files.push({label:A,fileUri:S.URI.parse(O)})})}}return H}e.restoreRecentlyOpened=x;function Q(U){const $={entries:[]};for(const H of U.workspaces)c(H)?$.entries.push({folderUri:H.folderUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority}):$.entries.push({workspace:{id:H.workspace.id,configPath:H.workspace.configPath.toString()},label:H.label,remoteAuthority:H.remoteAuthority});for(const H of U.files)$.entries.push({fileUri:H.fileUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority});return $}e.toStoreData=Q}),define(J[52],Z([0,1,4,27]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=g.createDecorator("backupMainService");function D(S){const E=S;return E&&M.isWorkspaceIdentifier(E.workspace)}e.isWorkspaceBackupInfo=D}),define(J[53],Z([0,1,4,14,9,39,3,8,65,18,13,134,27,31,2,80]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=g.createDecorator("dialogMainService");let P=class gt{constructor(c){this.stateMainService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(c,h){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:b.localize(0,null)},h)}pickFolder(c,h){return this.doPick({...c,pickFolders:!0,title:b.localize(1,null)},h)}pickFile(c,h){return this.doPick({...c,pickFiles:!0,title:b.localize(2,null)},h)}pickWorkspace(c,h){const o=b.localize(3,null),l=y.mnemonicButtonLabel(b.localize(4,null)),t=k.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:o,filters:t,buttonLabel:l},h)}async doPick(c,h){const o={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};o.defaultPath=c.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(o.properties=void 0,c.pickFiles&&c.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&o.properties.push("treatPackageAsDirectory");const l=h||M.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,i.withNullAsUndefined(l));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(c){if(c){let h=this.windowDialogQueues.get(c.id);return h||(h=new D.Queue,this.windowDialogQueues.set(c.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(c,h){return this.getWindowDialogQueue(h).queue(async()=>h?M.dialog.showMessageBox(h,c):M.dialog.showMessageBox(c))}async showSaveDialog(c,h){const o=this.acquireFileDialogLock(c,h);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let l;return h?l=await M.dialog.showSaveDialog(h,c):l=await M.dialog.showSaveDialog(c),l.filePath=this.normalizePath(l.filePath),l})}finally{d.dispose(o)}}normalizePath(c){return c&&E.isMacintosh&&(c=w.normalizeNFC(c)),c}normalizePaths(c){return c.map(h=>this.normalizePath(h))}async showOpenDialog(c,h){c.defaultPath&&(await v.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const o=this.acquireFileDialogLock(c,h);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let l;return h?l=await M.dialog.showOpenDialog(h,c):l=await M.dialog.showOpenDialog(c),l.filePaths=this.normalizePaths(l.filePaths),l})}finally{d.dispose(o)}}acquireFileDialogLock(c,h){if(!h)return d.Disposable.None;let o=this.windowFileDialogLocks.get(h.id);o||(o=new Set,this.windowFileDialogLocks.set(h.id,o));const l=m.hash(c);if(!o.has(l))return o.add(l),d.toDisposable(()=>{o?.delete(l),o?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=he([te(0,S.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends M.Disposable{constructor(n,w){super();this.logService=n,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new g.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(g.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,w)=>(n?n.push(w):n=[w],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const w=new Map,v=new Set;return n.forEach(i=>{const b=this.storageMainService.globalStorage.get(i.key);typeof b=="string"?w.set(i.key,b):v.add(i.key)}),{changed:Array.from(w.entries()),deleted:Array.from(v.values())}}listen(n,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(n,w,v){const i=D.reviveIdentifier(v.workspace),b=await this.withStorageInitialized(i);switch(w){case"getItems":return Array.from(b.items.entries());case"updateItems":{const k=v;if(k.insert)for(const[y,d]of k.insert)b.set(y,d);k.delete&&k.delete.forEach(y=>b.delete(y));break}case"close":{if(i)return b.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(n){const w=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await w.init()}catch(v){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${v}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,18,5,2,6,124,86,8,96,32,28,27]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends D.Disposable{constructor(I){super();this.logService=I,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const I=await this.doCreate();this.storage.dispose(),this.storage=I,this._register(I.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(I);const c=I.getBoolean(v.IS_NEW_KEY);c===void 0?I.set(v.IS_NEW_KEY,!0):c&&I.set(v.IS_NEW_KEY,!1)}catch(I){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${I}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?I=>this.logService.trace(I):void 0,logError:I=>this.logService.error(I)}}doInit(I){return I.init()}get items(){return this.storage.items}get(I,c){return this.storage.get(I,c)}set(I,c){return this.storage.set(I,c)}delete(I){return this.storage.delete(I)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(I,c,h){super(c);this.options=I,this.environmentService=h}async doCreate(){let I;return this.options.useInMemoryStorage?I=E.SQLiteStorageDatabase.IN_MEMORY_PATH:I=w.join(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}))}async doInit(I){await super.doInit(I),this.updateTelemetryState(I)}updateTelemetryState(I){I.get(i.instanceStorageKey,void 0)===void 0&&I.set(i.instanceStorageKey,b.generateUuid()),I.get(i.firstSessionDateStorageKey,void 0)===void 0&&I.set(i.firstSessionDateStorageKey,new Date().toUTCString());const o=I.get(i.currentSessionDateStorageKey,void 0),l=new Date().toUTCString();I.set(i.lastSessionDateStorageKey,typeof o=="undefined"?null:o),I.set(i.currentSessionDateStorageKey,l)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class m extends y{constructor(I,c,h,o){super(h);this.workspace=I,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:I,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const I=w.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=w.join(I,m.WORKSPACE_STORAGE_NAME);return await g.Promises.exists(I)?{storageFilePath:c,wasCreated:!1}:(await g.Promises.mkdir(I,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(I),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(I){let c;if(k.isSingleFolderWorkspaceIdentifier(this.workspace)?c={folder:this.workspace.uri.toString()}:k.isWorkspaceIdentifier(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=w.join(I,m.WORKSPACE_META_NAME);await g.Promises.exists(h)||await g.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(J[99],Z([0,1,43,2,48,4,22,6,215]),function(q,e,g,M,D,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=S.createDecorator("storageMainService");let v=class extends M.Disposable{constructor(b,k,y){super();this.logService=b,this.environmentService=k,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,k]of this.mapWorkspaceToStorage)b.join(k.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return g.once(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new w.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let k=this.mapWorkspaceToStorage.get(b.id);return k||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),k=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,k),g.once(k.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),k}};v=he([te(0,n.ILogService),te(1,D.IEnvironmentService),te(2,E.ILifecycleMainService)],v),e.StorageMainService=v}),define(J[100],Z([0,1,7,27,15]),function(q,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,v,i){for(const k of w){const y=k.openedWorkspace;if(M.isWorkspaceIdentifier(y)){const d=i(y);if(d){if(d.folders.some(m=>D.extUriBiasedIgnorePathCase.isEqualOrParent(v,m.uri)))return k}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(v,y.configPath))return k}}const b=w.filter(k=>M.isSingleFolderWorkspaceIdentifier(k.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(v,k.openedWorkspace.uri));if(b.length)return b.sort((k,y)=>-(k.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(w,v){for(const i of w)if(M.isWorkspaceIdentifier(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,v)||M.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,v))return i}e.findWindowOnWorkspaceOrFolder=E;function n(w,v){const i=b=>v.some(k=>D.extUriBiasedIgnorePathCase.isEqual(g.URI.file(k),g.URI.file(b)));for(const b of w)if(b.config?.extensionDevelopmentPath?.some(k=>i(k)))return b}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,7,21,22,6,39,35,27]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends M.Disposable{constructor(h,o,l,t,s){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=l,this.logService=t,this.configurationService=s,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){g.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const l=P(h);this.stateMainService.setItem(mt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(l=>{const t=k.isWorkspaceIdentifier(h.openedWorkspace)&&l.workspace?.id===h.openedWorkspace.id,s=k.isSingleFolderWorkspaceIdentifier(h.openedWorkspace)&&l.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(l.folderUri,h.openedWorkspace.uri);(t||s)&&(l.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:k.isWorkspaceIdentifier(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:k.isSingleFolderWorkspaceIdentifier(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),l=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=h.workspace;if(k.isWorkspaceIdentifier(u)){const f=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===u.id).map(L=>L.uiState);if(f.length)return f[0]}if(k.isSingleFolderWorkspaceIdentifier(u)){const f=this.state.openedWindows.filter(L=>L.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(L.folderUri,u.uri)).map(L=>L.uiState);if(f.length)return f[0]}else if(h.backupPath){const f=this.state.openedWindows.filter(L=>L.backupPath===h.backupPath).map(L=>L.uiState);if(f.length)return f[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!o&&p)return p.uiState}let l;const t=g.screen.getAllDisplays();if(t.length===1)l=t[0];else{if(D.isMacintosh){const u=g.screen.getCursorScreenPoint();l=g.screen.getDisplayNearestPoint(u)}!l&&o&&(l=g.screen.getDisplayMatching(o.getBounds())),l||(l=g.screen.getPrimaryDisplay()||t[0])}let s=b.defaultWindowState();s.x=Math.round(l.bounds.x+l.bounds.width/2-s.width/2),s.y=Math.round(l.bounds.y+l.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let a=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,a=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,a=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const u=o.serializeWindowState();u.mode===3?s.mode=3:s=u,a=s.mode!==3&&r.newWindowDimensions==="offset"}}return a&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;o.some(l=>l.x===h.x||l.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=he([te(0,b.IWindowsMainService),te(1,i.IStateMainService),te(2,w.ILifecycleMainService),te(3,v.ILogService),te(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const h={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(l=>m(l))),h}e.restoreWindowsState=d;function m(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=E.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:E.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function P(c){return{lastActiveWindow:c.lastActiveWindow&&I(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&I(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=P;function I(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(J[101],Z([0,1,29,3,58,10,15]),function(q,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(v){function i(){let b=v.scheme===S.Schemas.file?E.originalFSPath(v):v.toString();return M.isLinux||(b=b.toLowerCase()),D.createHash("md5").update(b).digest("hex")}return{id:i(),configPath:v}}e.getWorkspaceIdentifier=n;function w(v,i){function b(){if(v.scheme!==S.Schemas.file)return D.createHash("md5").update(v.toString()).digest("hex");if(!i)try{i=g.statSync(v.fsPath)}catch(d){return}let y;return M.isLinux?y=i.ino:M.isMacintosh?y=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?y=Math.floor(i.birthtimeMs):y=i.birthtime.getTime()),D.createHash("md5").update(v.fsPath).update(y?String(y):"").digest("hex")}const k=b();if(typeof k=="string")return{id:k,uri:v}}e.getSingleFolderWorkspaceIdentifier=w}),define(J[56],Z([0,1,58,59,217,5,34,8,26,28,2,17,84,16,3]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(f){this.socket=f,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;y.onUnexpectedError(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const L=F=>f(b.VSBuffer.wrap(F));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(f){const L=F=>{f({type:0,hadError:F,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,L=>{if(L){if(L.code==="EPIPE")return;y.onUnexpectedError(L)}})}catch(L){if(L.code==="EPIPE")return;y.onUnexpectedError(L)}}end(){this.socket.end()}drain(){return new Promise((f,L)=>{if(this.socket.bufferSize===0){f();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),f()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var P;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(I||(I={}));class c extends i.Disposable{constructor(f,L,F,_){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=_,L?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),y.onUnexpectedError(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),F&&(this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),y.onUnexpectedError(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new k.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):b.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(b.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,L){let F=2;f.byteLength<126?F+=0:f.byteLength<2**16?F+=2:F+=8;const _=b.VSBuffer.alloc(F);if(L?_.writeUInt8(194,0):_.writeUInt8(130,0),f.byteLength<126)_.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){_.writeUInt8(126,1);let C=1;_.writeUInt8(f.byteLength>>>8&255,++C),_.writeUInt8(f.byteLength>>>0&255,++C)}else{_.writeUInt8(127,1);let C=1;_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(0,++C),_.writeUInt8(f.byteLength>>>24&255,++C),_.writeUInt8(f.byteLength>>>16&255,++C),_.writeUInt8(f.byteLength>>>8&255,++C),_.writeUInt8(f.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=_.byteLength+f.byteLength,this.socket.write(b.VSBuffer.concat([_,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),_=(L.readUInt8(0)&128)>>>7,C=L.readUInt8(1),K=(C&128)>>>7,ee=C&127;this._state.state=2,this._state.readLen=2+(K?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=_,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),F=L.readUInt8(1),_=(F&128)>>>7;let C=F&127,K=1;C===126?C=L.readUInt8(++K)*2**8+L.readUInt8(++K):C===127&&(C=L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*0+L.readUInt8(++K)*2**24+L.readUInt8(++K)*2**16+L.readUInt8(++K)*2**8+L.readUInt8(++K));let ee=0;_&&(ee=L.readUInt8(++K)*2**24+L.readUInt8(++K)*2**16+L.readUInt8(++K)*2**8+L.readUInt8(++K)),this._state.state=3,this._state.readLen=C,this._state.mask=ee}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);h(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const F=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=F.length,this._onData.fire(b.VSBuffer.wrap(F))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(p,f){if(f===0)return;let L=p.byteLength>>>2;for(let V=0;V<L;V++){const x=p.readUInt32BE(V*4);p.writeUInt32BE(x^f,V*4)}let F=L*4,_=p.byteLength-F;const C=f>>>24&255,K=f>>>16&255,ee=f>>>8&255;_>=1&&p.writeUInt8(p.readUInt8(F)^C,F),_>=2&&p.writeUInt8(p.readUInt8(F+1)^K,F+1),_>=3&&p.writeUInt8(p.readUInt8(F+2)^ee,F+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function l(){const p=v.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let f;return e.XDG_RUNTIME_DIR?f=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):f=n.join(w.tmpdir(),`vscode-ipc-${p}.sock`),s(f),f}e.createRandomIPCHandle=l;function t(p,f,L){const F=g.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${L}-${f}-sock`;let _;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?_=n.join(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${L}-${f}.sock`):_=n.join(p,`${L}-${f}.sock`),s(_),_}e.createStaticIPCHandle=t;function s(p){const f=o[d.platform];typeof f=="number"&&p.length>=f&&console.warn(`WARNING: IPC handle "${p}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{constructor(f){super(r.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const L=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(L,F=>({protocol:new k.Protocol(new m(F)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(p){return new Promise((f,L)=>{const F=M.createServer();F.on("error",L),F.listen(p,()=>{F.removeListener("error",L),f(new r(F))})})}e.serve=a;function u(p,f){return new Promise((L,F)=>{const _=M.createConnection(p,()=>{_.removeListener("error",F),L(k.Client.fromSocket(new m(_),f))});_.once("error",F)})}e.connect=u}),define(J[218],Z([0,1,56]),function(q,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class M{constructor(w){this.driver=w}listen(w,v){throw new Error("No event found")}call(w,v,i){switch(v){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${v}`)}}e.DriverChannel=M;class D{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,v){return this.channel.call("dispatchKeybinding",[w,v])}click(w,v,i,b){return this.channel.call("click",[w,v,i,b])}doubleClick(w,v){return this.channel.call("doubleClick",[w,v])}setValue(w,v,i){return this.channel.call("setValue",[w,v,i])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,v){return this.channel.call("isActiveElement",[w,v])}getElements(w,v,i){return this.channel.call("getElements",[w,v,i])}getElementXY(w,v,i,b){return this.channel.call("getElementXY",[w,v,i,b])}typeInEditor(w,v,i){return this.channel.call("typeInEditor",[w,v,i])}getTerminalBuffer(w,v){return this.channel.call("getTerminalBuffer",[w,v])}writeInTerminal(w,v,i){return this.channel.call("writeInTerminal",[w,v,i])}getLocalizedStrings(w){return this.channel.call("getLocalizedStrings",w)}}e.DriverChannelClient=D;class S{constructor(w){this.registry=w}listen(w,v){throw new Error(`Event not found: ${v}`)}call(w,v,i){switch(v){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${v}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const w=await g.connect(n,"driverClient"),v=w.getChannel("driver"),i=new D(v);return{client:w,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,47,4,48,161,56]),function(q,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=D.refineServiceDecorator(S.IEnvironmentService);class w extends E.NativeEnvironmentService{get cachedLanguagesPath(){return g.join(this.userDataPath,"clp")}get backupHome(){return g.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return g.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}he([M.memoize],w.prototype,"cachedLanguagesPath",null),he([M.memoize],w.prototype,"backupHome",null),he([M.memoize],w.prototype,"backupWorkspacesPath",null),he([M.memoize],w.prototype,"mainIPCHandle",null),he([M.memoize],w.prototype,"sandbox",null),he([M.memoize],w.prototype,"driverVerbose",null),he([M.memoize],w.prototype,"disableUpdates",null),he([M.memoize],w.prototype,"disableKeytar",null),he([M.memoize],w.prototype,"codeCachePath",null),e.EnvironmentMainService=w}),define(J[219],Z([0,1,29,58,8,3,18,52,24,21,19,6,27,7,30,10,15]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,o,l){this.configurationService=o,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,s)=>d.isEqual(t,s,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let l=[];try{Array.isArray(h.folderURIWorkspaces)&&(l=h.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const l=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(l,o),l}moveBackupFolderSync(h,o){if(g.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),g.existsSync(o))try{g.renameSync(o,h)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,l=this.workspaces.findIndex(t=>t.workspace.id===o);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(l=>this.backupUriComparer.isEqual(h,l));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const l=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:o}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return D.join(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,l=[];for(let t of h){const s=t.workspace;if(!k.isWorkspaceIdentifier(s))return[];if(!o.has(s.id)){o.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==m.Schemas.file||await E.Promises.exists(s.configPath.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return l}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],l=new Set;for(let t of h){const s=this.backupUriComparer.getComparisonKey(t);if(!l.has(s)){l.add(s);const r=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(r)?t.scheme!==m.Schemas.file||await E.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],l=new Set;for(let t of h){const s=t.backupFolder;if(typeof s!="string")return[];if(!l.has(s)){l.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?o.push(t):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(h){try{await E.Promises.exists(h)&&await E.Promises.rm(h,E.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{await E.Promises.rename(h,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const l=this.getBackupPath(o);try{g.renameSync(h,l)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return y.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):n.isWorkspaceBackupInfo(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await E.Promises.readdir(h);for(const l of o)try{if((await E.Promises.readdir(D.join(h,l))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{E.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===m.Schemas.file?o=S.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),M.createHash("md5").update(o).digest("hex")}};I=he([te(0,w.IEnvironmentMainService),te(1,v.IConfigurationService),te(2,b.ILogService)],I),e.BackupMainService=I}),define(J[220],Z([0,1,59,56]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,S,E,n){const w=i=>n(i,void 0),v=g.createConnection({host:D,port:S},()=>{v.removeListener("error",w);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const b=i.toString("base64");let k=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];v.write(k.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",y),n(void 0,new M.NodeSocket(v)))};v.on("data",y)});v.once("error",w)}}}),define(J[221],Z([0,1,59,9,2,116,21,6,20,192,74,220,75]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(I,c,h,o,l){return new d(I,c,h,o,l).waitForReady()}class d extends D.Disposable{constructor(c,h,o,l,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=c,this._server=g.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await S.findFreePortFaster(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=await v.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),o=h.getSocket().socket,l=h.readEntireBuffer();h.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let m=class extends i.AbstractTunnelService{constructor(c,h,o,l,t){super(h);this.socketFactory=c,this.signService=o,this.productService=l,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,o,l,t,s,r){const a=this.getTunnelFromMap(h,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,l,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${l}.`);const u={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},p=y(u,this.defaultTunnelHost,h,o,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,p),p}}};m=he([te(1,n.ILogService),te(2,k.ISignService),te(3,w.IProductService),te(4,E.IConfigurationService)],m),e.BaseTunnelService=m;let P=class extends m{constructor(c,h,o,l){super(b.nodeSocketFactory,c,h,o,l)}};P=he([te(0,n.ILogService),te(1,k.ISignService),te(2,w.IProductService),te(3,E.IConfigurationService)],P),e.TunnelService=P}),define(J[222],Z([0,1,217,194,2,13,16,193,21,6,17,48,91]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(m,P,I){super();this.environmentService=P,this.logService=I,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,P){this.logService.trace("RequestService#request",m.url);const{proxyUrl:I,strictSSL:c}=this,h={...process.env,...await k.resolveShellEnv(this.logService,this.environmentService.args,process.env)},o=m.agent?m.agent:await n.getProxyAgent(m.url||"",h,{proxyUrl:I,strictSSL:c});return m.agent=o,m.strictSSL=c,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,P)}async getNodeRequest(m){return(M.parse(m.url).protocol==="https:"?await new Promise((c,h)=>{q(["https"],c,h)}):await new Promise((c,h)=>{q(["http"],c,h)})).request}_request(m,P){return new Promise(async(I,c)=>{let h;const o=M.parse(m.url),l=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:S.isBoolean(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),h=l(t,s=>{const r=S.isNumber(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:r-1},P).then(I,c);else{let a=s;s.headers["content-encoding"]==="gzip"&&(a=s.pipe(g.createGunzip())),I({res:s,stream:i.streamToBufferReadableStream(a)})}}),h.on("error",c),m.timeout&&h.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&h.write(m.data),h.end(),P.onCancellationRequested(()=>{h.abort(),c(E.canceled())})})}async resolveProxy(m){}};y=he([te(0,w.IConfigurationService),te(1,b.INativeEnvironmentService),te(2,v.ILogService)],y),e.RequestService=y}),define(J[223],Z([0,1,222,14]),function(q,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(E){return M.net.request}class S extends g.RequestService{request(n,w){return super.request({...n||{},getRawRequest:D},w)}}e.RequestMainService=S}),define(J[224],Z([0,1,49,14,24,9,6,22,60,10,3,2,85,13,5,55]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let P=class extends b.Disposable{constructor(c,h,o,l,t,s,r){super();this.machineId=c,this.userEnv=h,this.environmentMainService=o,this.lifecycleMainService=l,this.logService=t,this.themeMainService=s,this.protocolMainService=r,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),M.ipcMain.on("vscode:createSharedProcessMessageChannel",async(c,h)=>this.onWindowConnection(c,h))}async onWindowConnection(c,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(c.sender.isDestroyed())return o.close();c.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[o])}onWillShutdown(){const c=this.window;!c||(!c.isDestroyed()&&!c.webContents.isDestroyed()&&c.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(c.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{c.close()}catch(h){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(c=>M.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),c()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(c=>M.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),c()}))})()),this._whenIpcReady}createWindow(){const c=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new M.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),c.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default}),this.window.loadURL(v.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=c=>{this.logService.trace("SharedProcess#close prevented"),c.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(c,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(c,h,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:h}})))}async connect(){await this.whenIpcReady;const c=y.assertIsDefined(this.window);return k.connect(c)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};P=he([te(2,D.IEnvironmentMainService),te(3,n.ILifecycleMainService),te(4,E.ILogService),te(5,w.IThemeMainService),te(6,m.IProtocolMainService)],P),e.SharedProcess=P}),define(J[225],Z([0,1,7,8,13,6,24,9,19,17]),function(q,e,g,M,D,S,E,n,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,m){this.storagePath=y,this.logService=d,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const m=this.storage[y];return D.isUndefinedOrNull(m)?d:m}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:m,data:P}of y)this.storage[m]!==P&&(D.isUndefinedOrNull(P)?D.isUndefined(this.storage[m])||(this.storage[m]=void 0,d=!0):(this.storage[m]=P,d=!0));d&&this.save()}removeItem(y){D.isUndefined(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,v.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let b=class yt{constructor(y,d,m){this.fileStorage=new i(g.URI.file(M.join(y.userDataPath,yt.STATE_FILE)),d,m)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=he([te(0,E.IEnvironmentMainService),te(1,S.ILogService),te(2,w.IFileService)],b),e.StateMainService=b}),define(J[77],Z([0,1,5,9,21,22,20,42,24,6,51,25]),function(q,e,g,M,D,S,E,n,w,v,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function k(d,m,P){return`${P.updateUrl}/api/update/${d}/${m}/${P.commit}`}e.createUpdateURL=k;let y=class{constructor(m,P,I,c,h,o){this.lifecycleMainService=m,this.configurationService=P,this.environmentMainService=I,this.requestService=c,this.logService=h,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=D.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(m);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return M.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},b.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([te(0,S.ILifecycleMainService),te(1,D.IConfigurationService),te(2,w.IEnvironmentMainService),te(3,i.IRequestService),te(4,v.ILogService),te(5,E.IProductService)],y),e.AbstractUpdateService=y}),define(J[226],Z([0,1,14,2,5,47,21,22,42,32,24,6,77,51,20]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends k.AbstractUpdateService{constructor(I,c,h,o,l,t,s){super(I,c,o,l,t,s);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"error",(I,c)=>c)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-available",(I,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-downloaded",(I,c,h,o)=>({releaseNotes:c,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(w.State.Idle(1,h))}buildUpdateFeedUrl(I){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=k.createUpdateURL(c,I,this.productService);try{g.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(I){this.setState(w.State.CheckingForUpdates(I)),g.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(w.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),g.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],m.prototype,"onRawError",null),he([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],m.prototype,"onRawUpdateAvailable",null),he([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,v.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,y.IRequestService),te(5,b.ILogService),te(6,d.IProductService)],m),e.DarwinUpdateService=m}),define(J[227],Z([0,1,5,9,22,42,24,6,8,29,41,32]),function(q,e,g,M,D,S,E,n,w,v,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let k=class{constructor(m,P,I){if(this.lifecycleMainService=m,this.logService=I,this._state=S.State.Uninitialized,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return M.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};k=he([te(0,D.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,n.ILogService)],k);let y=class extends k{constructor(m,P,I,c,h,o){super(I,c,h);this.snap=m,this.snapRevision=P,this.telemetryService=o;const l=v.watch(w.dirname(this.snap)),t=g.Event.fromNodeEventEmitter(l,"change",(u,p)=>p),s=g.Event.filter(t,u=>u==="current"),a=g.Event.debounce(s,(u,p)=>p,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{a.dispose(),l.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((I,c)=>v.realpath(`${w.dirname(this.snap)}/current`,(h,o)=>h?c(h):I(o))),P=w.basename(m);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([te(2,D.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,n.ILogService),te(5,b.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[45],Z([0,1,27,24,8,18,29,3,5,6,101,40,10,2,15,4,154,20,14,13,52,53,100,31]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=m.createDecorator("workspacesManagementMainService");let r=class extends y.Disposable{constructor(u,p,f,L,F){super();this.environmentMainService=u,this.logService=p,this.backupMainService=f,this.dialogMainService=L,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(u){return this.doResolveLocalWorkspace(u,p=>E.readFileSync(p,"utf8"))}resolveLocalWorkspace(u){return this.doResolveLocalWorkspace(u,p=>S.Promises.readFile(p,"utf8"))}doResolveLocalWorkspace(u,p){if(!!this.isWorkspacePath(u)&&u.scheme===k.Schemas.file)try{const f=p(u.fsPath);return f instanceof Promise?f.then(L=>this.doResolveWorkspace(u,L),L=>{}):this.doResolveWorkspace(u,f)}catch{return}}isWorkspacePath(u){return g.isUntitledWorkspace(u,this.environmentMainService)||g.hasWorkspaceFileExtension(u)}doResolveWorkspace(u,p){try{const f=this.doParseStoredWorkspace(u,p),L=i.getWorkspaceIdentifier(u);return{id:L.id,configPath:L.configPath,folders:g.toWorkspaceFolders(f.folders,L.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:f.remoteAuthority,transient:f.transient}}catch(f){this.logService.warn(f.toString())}}doParseStoredWorkspace(u,p){const f=b.parse(p);if(f&&Array.isArray(f.folders))f.folders=f.folders.filter(L=>g.isStoredWorkspaceFolder(L));else throw new Error(`${u.toString(!0)} looks like an invalid workspace file.`);return f}async createUntitledWorkspace(u,p){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(u,p),F=f.configPath.fsPath;return await S.Promises.mkdir(D.dirname(F),{recursive:!0}),await S.Promises.writeFile(F,JSON.stringify(L,null,"	")),f}createUntitledWorkspaceSync(u,p){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(u,p),F=f.configPath.fsPath;return E.mkdirSync(D.dirname(F),{recursive:!0}),S.writeFileSync(F,JSON.stringify(L,null,"	")),f}newUntitledWorkspace(u=[],p){const f=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=d.joinPath(this.untitledWorkspacesHome,f),F=d.joinPath(L,g.UNTITLED_WORKSPACE_NAME),_=[];for(const C of u)_.push(g.getStoredWorkspaceFolder(C.uri,!0,C.name,L,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:i.getWorkspaceIdentifier(F),storedWorkspace:{folders:_,remoteAuthority:p}}}async getWorkspaceIdentifier(u){return i.getWorkspaceIdentifier(u)}isUntitledWorkspace(u){return g.isUntitledWorkspace(u.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(u){!this.isUntitledWorkspace(u)||(this.doDeleteUntitledWorkspaceSync(u),this._onDidDeleteUntitledWorkspace.fire(u))}async deleteUntitledWorkspace(u){this.deleteUntitledWorkspaceSync(u)}doDeleteUntitledWorkspaceSync(u){const p=d.originalFSPath(u.configPath);try{S.rimrafSync(D.dirname(p));const f=D.join(this.environmentMainService.workspaceStorageHome.fsPath,u.id);E.existsSync(f)&&S.writeFileSync(D.join(f,"obsolete"),"")}catch(f){this.logService.warn(`Unable to delete untitled workspace ${p} (${f}).`)}}getUntitledWorkspacesSync(){const u=[];try{const p=S.readdirSync(this.untitledWorkspacesHome.fsPath).map(f=>d.joinPath(this.untitledWorkspacesHome,f,g.UNTITLED_WORKSPACE_NAME));for(const f of p){const L=i.getWorkspaceIdentifier(f),F=this.resolveLocalWorkspaceSync(f);F?u.push({workspace:L,remoteAuthority:F.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(p){p.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${p}).`)}return u}async enterWorkspace(u,p,f){if(!u||!u.win||!u.isReady||!await this.isValidTargetWorkspacePath(u,p,f))return;const F=this.doEnterWorkspace(u,i.getWorkspaceIdentifier(f));if(!!F)return this._onDidEnterWorkspace.fire({window:u,workspace:F.workspace}),F}async isValidTargetWorkspacePath(u,p,f){if(!f)return!0;if(g.isWorkspaceIdentifier(u.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(u.openedWorkspace.configPath,f))return!1;if(t.findWindowOnWorkspaceOrFolder(p,f)){const L={title:this.productService.nameLong,type:"info",buttons:[s.mnemonicButtonLabel(P.localize(0,null))],message:P.localize(1,null,d.basename(f)),detail:P.localize(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,h.withNullAsUndefined(c.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(u,p){if(!u.config)return;u.focus();let f;return u.config.extensionDevelopmentPath||(f=this.backupMainService.registerWorkspaceBackupSync({workspace:p,remoteAuthority:u.remoteAuthority},u.config.backupPath)),g.isWorkspaceIdentifier(u.openedWorkspace)&&this.isUntitledWorkspace(u.openedWorkspace)&&this.deleteUntitledWorkspaceSync(u.openedWorkspace),u.config.workspace=p,u.config.backupPath=f,{workspace:p,backupPath:f}}};r=he([te(0,M.IEnvironmentMainService),te(1,v.ILogService),te(2,o.IBackupMainService),te(3,l.IDialogMainService),te(4,I.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[102],Z([0,1,6,98,3,4,35,18,45,21,7,14,36,54,25,27,13]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=S.createDecorator(e.ID);let I=class{constructor(h,o,l,t,s){this.logService=h,this.windowsMainService=o,this.urlService=l,this.workspacesManagementMainService=t,this.configurationService=s}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),D.isMacintosh&&b.app.focus({steal:!0});const l=this.parseOpenUrl(h);if(l.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:s,url:r}of l)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?k.coalesce(h._urls.map(o=>{try{return{uri:i.URI.parse(o),url:o}}catch(l){return null}})):[]}async startOpenWindow(h,o){const l=y.isLaunchedFromCli(o)?0:4;let t=[];const s=h.wait&&h.waitMarkerFilePath?i.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:l,cli:h,userEnv:o,waitMarkerFileURI:s,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||h["unity-launch"])a=!0;else if(h["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!D.isMacintosh}if(a)t=this.windowsMainService.open({context:l,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const u=this.windowsMainService.getLastActiveWindow();u?(u.focus(),t=[u]):t=this.windowsMainService.open({context:l,cli:h,forceEmpty:!0,remoteAuthority:r})}}else t=this.windowsMainService.open({context:l,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:h.goto,remoteAuthority:r});if(s&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return b.BrowserWindow.getAllWindows().forEach(o=>{const l=this.windowsMainService.getWindowById(o.id);l?h.push(this.codeWindowToInfo(l)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!b.app.accessibilitySupportEnabled,gpuFeatureStatus:b.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(s=>{const r=t.remoteAuthority;if(r){const a=`vscode:getDiagnosticInfoResponse${t.id}`,u={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:u}),b.ipcMain.once(a,(p,f)=>{f||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(f)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const o=[],l=h.openedWorkspace;if(m.isSingleFolderWorkspaceIdentifier(l))o.push(l.uri);else if(m.isWorkspaceIdentifier(l)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);t&&t.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),l=P.assertIsDefined(h.win);return this.browserWindowToInfo(l,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],l){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:l}}};I=he([te(0,g.ILogService),te(1,E.IWindowsMainService),te(2,M.IURLService),te(3,w.IWorkspacesManagementMainService),te(4,v.IConfigurationService)],I),e.LaunchMainService=I}),define(J[46],Z([0,1,41,115,146,82,5,35,14,22,3,24,53,18,7,32,4,26,66,6,8,20,47,2,60,31,27,10,45]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s,r,a,u,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=P.createDecorator("nativeHostMainService");let L=class at extends s.Disposable{constructor(_,C,K,ee,V,x,Q,U,$,H){super();this.sharedProcess=_,this.windowsMainService=C,this.dialogMainService=K,this.lifecycleMainService=ee,this.environmentMainService=V,this.telemetryService=x,this.logService=Q,this.productService=U,this.themeMainService=$,this.workspacesManagementMainService=H,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-maximize",(B,T)=>T.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-unmaximize",(B,T)=>T.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-blur",(B,T)=>T.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-focus",(B,T)=>T.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(w.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(w.screen,"display-metrics-changed",(B,T,R)=>R),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),E.Event.fromNodeEventEmitter(w.screen,"display-added"),E.Event.fromNodeEventEmitter(w.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors,dark:w.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(_){return this.windowsMainService.getWindowCount()}async getActiveWindowId(_){const C=w.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(_,C,K){return Array.isArray(C)?this.doOpenWindow(_,C,K):this.doOpenEmptyWindow(_,C)}async doOpenWindow(_,C,K=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:_,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0})}async doOpenEmptyWindow(_,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:_},C)}async toggleFullScreen(_){const C=this.windowById(_);C&&C.toggleFullScreen()}async handleTitleDoubleClick(_){const C=this.windowById(_);C&&C.handleTitleDoubleClick()}async isMaximized(_){const C=this.windowById(_);return C?.win?C.win.isMaximized():!1}async maximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.maximize()}async unmaximizeWindow(_){const C=this.windowById(_);C?.win&&C.win.unmaximize()}async minimizeWindow(_){const C=this.windowById(_);C?.win&&C.win.minimize()}async focusWindow(_,C){C&&typeof C.windowId=="number"&&(_=C.windowId);const K=this.windowById(_);K&&K.focus({force:C?.force??!1})}async setMinimumSize(_,C,K){const ee=this.windowById(_);if(ee?.win){const[V,x]=ee.win.getSize(),[Q,U]=ee.win.getMinimumSize(),[$,H]=[C??Q,K??U],[B,T]=[Math.max(V,$),Math.max(x,H)];(Q!==$||U!==H)&&ee.win.setMinimumSize($,H),(V!==B||x!==T)&&ee.win.setSize(B,T)}}async saveWindowSplash(_,C){this.themeMainService.saveWindowSplash(_,C)}async installShellCommand(_){const{source:C,target:K}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await y.SymlinkSupport.stat(C);if(ee&&!ee.dangling){const V=await S.realpath(C);if(K===V)return}await y.Promises.unlink(C)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await y.Promises.symlink(K,C)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:V}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:D.localize(0,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(D.localize(1,null)),a.mnemonicButtonLabel(D.localize(2,null))],noLink:!0,defaultId:0,cancelId:1});if(V===0)try{const x=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${C}'\\" with administrator privileges"`;await M.promisify(g.exec)(x)}catch(x){throw new Error(D.localize(3,null,C))}}}async uninstallShellCommand(_){const{source:C}=await this.getShellCommandLink();try{await y.Promises.unlink(C)}catch(K){switch(K.code){case"EACCES":const{response:ee}=await this.showMessageBox(_,{title:this.productService.nameLong,type:"info",message:D.localize(4,null,this.productService.nameShort),buttons:[a.mnemonicButtonLabel(D.localize(5,null)),a.mnemonicButtonLabel(D.localize(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const V=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await M.promisify(g.exec)(V)}catch(V){throw new Error(D.localize(7,null,C))}break;case"ENOENT":break;default:throw K}}}async getShellCommandLink(){const _=o.resolve(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(_))throw new Error(D.localize(8,null,_));return{source:C,target:_}}async showMessageBox(_,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(_))}async showSaveDialog(_,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(_))}async showOpenDialog(_,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(_))}toBrowserWindow(_){const C=this.windowById(_);if(C?.win)return C.win}async pickFileFolderAndOpen(_,C){const K=await this.dialogMainService.pickFileFolder(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(K.map(async ee=>await y.SymlinkSupport.existsDirectory(ee)?{folderUri:d.URI.file(ee)}:{fileUri:d.URI.file(ee)})),C,_))}async pickFolderAndOpen(_,C){const K=await this.dialogMainService.pickFolder(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(K.map(ee=>({folderUri:d.URI.file(ee)})),C,_))}async pickFileAndOpen(_,C){const K=await this.dialogMainService.pickFile(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(K.map(ee=>({fileUri:d.URI.file(ee)})),C,_))}async pickWorkspaceAndOpen(_,C){const K=await this.dialogMainService.pickWorkspace(C);K&&(this.sendPickerTelemetry(K,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(K.map(ee=>({workspaceUri:d.URI.file(ee)})),C,_))}doOpenPicked(_,C,K){this.windowsMainService.open({context:3,contextWindowId:K,cli:this.environmentMainService.args,urisToOpen:_,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(_,C,K){const ee=_?_.length:0;this.telemetryService.publicLog(C,{...K,outcome:ee?"success":"canceled",numberOfPaths:ee})}async showItemInFolder(_,C){w.shell.showItemInFolder(C)}async setRepresentedFilename(_,C){const K=this.windowById(_);K&&K.setRepresentedFilename(C)}async setDocumentEdited(_,C){const K=this.windowById(_);K&&K.setDocumentEdited(C)}async openExternal(_,C){return i.isLinuxSnap?this.safeSnapOpenExternal(C):w.shell.openExternal(C),!0}safeSnapOpenExternal(_){const C=process.env.GDK_PIXBUF_MODULE_FILE,K=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,w.shell.openExternal(_),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=K}moveItemToTrash(_,C){return w.shell.trashItem(C)}async isAdmin(){let _;return i.isWindows?_=(await new Promise((C,K)=>{q(["native-is-elevated"],C,K)}))():_=process.getuid()===0,_}async writeElevated(_,C,K,ee){const V=await new Promise((x,Q)=>{q(["sudo-prompt"],x,Q)});return new Promise((x,Q)=>{const U=[`"${this.cliPath}"`];ee?.unlock&&U.push("--file-chmod"),U.push("--file-write",`"${C.fsPath}"`,`"${K.fsPath}"`);const $={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?o.join(o.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};V.exec(U.join(" "),$,(H,B,T)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),T&&this.logService.trace(`[sudo-prompt] received stderr: ${T}`),H?Q(H):x(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?o.join(this.environmentMainService.appRoot,"bin","code"):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:I.totalmem(),freemem:I.freemem(),loadavg:I.loadavg()}}async getOSProperties(){return{arch:I.arch(),platform:I.platform(),release:I.release(),type:I.type(),cpus:I.cpus()}}async getOSVirtualMachineHint(){return c.virtualMachineHint.value()}async killProcess(_,C,K){process.kill(C,K)}async readClipboardText(_,C){return w.clipboard.readText(C)}async writeClipboardText(_,C,K){return w.clipboard.writeText(C,K)}async readClipboardFindText(_){return w.clipboard.readFindText()}async writeClipboardFindText(_,C){return w.clipboard.writeFindText(C)}async writeClipboardBuffer(_,C,K,ee){return w.clipboard.writeBuffer(C,Buffer.from(K),ee)}async readClipboardBuffer(_,C){return w.clipboard.readBuffer(C)}async hasClipboard(_,C,K){return w.clipboard.has(C,K)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){w.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){w.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){w.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){w.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){w.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(_,C){const K=this.windowById(_);K&&K.updateTouchBar(C)}async notifyReady(_){const C=this.windowById(_);C&&C.setReady()}async relaunch(_,C){return this.lifecycleMainService.relaunch(C)}async reload(_,C){const K=this.windowById(_);if(K){if(u.isWorkspaceIdentifier(K.openedWorkspace)){const ee=K.openedWorkspace.configPath;if(ee.scheme===p.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(K,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(_){this.closeWindowById(_,_)}async closeWindowById(_,C){const K=this.windowById(C);if(K?.win)return K.win.close()}async quit(_){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(_,C){await this.lifecycleMainService.kill(C)}async resolveProxy(_,C){const ee=this.windowById(_)?.win?.webContents?.session;if(ee)return ee.resolveProxy(C)}async openDevTools(_,C){const K=this.windowById(_);K?.win&&K.win.webContents.openDevTools(C)}async toggleDevTools(_){const C=this.windowById(_);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(_,C){const K=this.windowById(_);K?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&K.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(_,C,K,ee){if(!i.isWindows)return;const V=await new Promise((x,Q)=>{q(["vscode-windows-registry"],x,Q)});try{return V.GetStringRegKey(C,K,ee)}catch{return}}async getPassword(_,C,K){const ee=await this.withKeytar(),V=await ee.getPassword(C,K);if(V)try{let{content:x,hasNextChunk:Q}=JSON.parse(V);if(!x||!Q)return V;let U=1;for(;Q;){const $=await ee.getPassword(C,`${K}-${U}`),H=JSON.parse($);x+=H.content,Q=H.hasNextChunk,U++}return x}catch{return V}return V}async setPassword(_,C,K,ee){const V=await this.withKeytar(),x=3,Q=async(U,$,H)=>{let B=0,T;for(;B<x;)try{await V.setPassword(U,$,H);return}catch(R){T=R,this.logService.warn("Error attempting to set a password: ",R),B++,await new Promise(O=>setTimeout(O,200))}throw T};if(i.isWindows&&ee.length>at.MAX_PASSWORD_LENGTH){let U=0,$=0,H=!0;for(;H;){const B=ee.substring(U,U+at.PASSWORD_CHUNK_SIZE);U+=at.PASSWORD_CHUNK_SIZE,H=ee.length-U>0;const T={content:B,hasNextChunk:H};await Q(C,$?`${K}-${$}`:K,JSON.stringify(T)),$++}}else await Q(C,K,ee);this._onDidChangePassword.fire({service:C,account:K})}async deletePassword(_,C,K){const V=await(await this.withKeytar()).deletePassword(C,K);return V&&this._onDidChangePassword.fire({service:C,account:K}),V}async findPassword(_,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(_,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((_,C)=>{q(["keytar"],_,C)})}windowById(_){if(typeof _=="number")return this.windowsMainService.getWindowById(_)}};L.MAX_PASSWORD_LENGTH=2500,L.PASSWORD_CHUNK_SIZE=L.MAX_PASSWORD_LENGTH-100,he([t.memoize],L.prototype,"cliPath",null),L=he([te(1,n.IWindowsMainService),te(2,k.IDialogMainService),te(3,v.ILifecycleMainService),te(4,b.IEnvironmentMainService),te(5,m.ITelemetryService),te(6,h.ILogService),te(7,l.IProductService),te(8,r.IThemeMainService),te(9,f.IWorkspacesManagementMainService)],L),e.NativeHostMainService=L}),define(J[228],Z([0,1,2,5,80,14,6,35,46,89,28,20,25]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends g.Disposable{constructor(P,I,c,h,o){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=M.Event.fromNodeEventEmitter(S.app,"login",(I,c,h,o,l)=>({event:I,webContents:c,req:h,authInfo:o,callback:l}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:c,callback:h}){if(!I.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const I=String(D.hash({scheme:P.scheme,host:P.host,port:P.port}));let c,h;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));c=r.username,h=r.password}}catch(s){this.logService.error(s)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const l={authInfo:P,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",k.CancellationToken.None,l),this.state=y.LoginDialogShown;const t=await new Promise(s=>{const r=async(a,u,p)=>{if(u===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),p){const f={username:p.username,password:p.password};try{if(p.remember){const L=await this.encryptionMainService.encrypt(JSON.stringify(f));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I,L)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I)}catch(L){this.logService.error(L)}s({username:f.username,password:f.password})}else s(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};d=he([te(0,E.ILogService),te(1,n.IWindowsMainService),te(2,w.INativeHostMainService),te(3,v.IEncryptionMainService),te(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(J[229],Z([0,1,218,156,35,56,2,34,57,177,3,5,79,107,9,22,46]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(o){return o<21}let c=class{constructor(l,t,s,r,a){this.windowServer=l,this.options=t,this.windowsMainService=s,this.lifecycleMainService=r,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new b.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t?.win)throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const t=this.windowsMainService.getWindowById(l);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,t){await this.whenUnfrozen(l);const s=y.KeybindingParser.parseUserBinding(t);for(let r of s)await this._dispatchKeybinding(l,r)}async _dispatchKeybinding(l,t){if(t instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const s=this.windowsMainService.getWindowById(l);if(!s?.win)throw new Error("Invalid window");const r=s.win.webContents,a=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),p=new v.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),f=[];t.ctrlKey&&f.push("ctrl"),t.metaKey&&f.push("meta"),t.shiftKey&&f.push("shift"),t.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:p,modifiers:f}),I(t.keyCode)||r.sendInputEvent({type:"char",keyCode:p,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:p,modifiers:f}),await d.timeout(100)}async click(l,t,s,r){await(await this.getWindowDriver(l)).click(t,s,r)}async doubleClick(l,t){await(await this.getWindowDriver(l)).doubleClick(t)}async setValue(l,t,s){await(await this.getWindowDriver(l)).setValue(t,s)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,t){return await(await this.getWindowDriver(l)).isActiveElement(t)}async getElements(l,t,s){return await(await this.getWindowDriver(l)).getElements(t,s)}async getElementXY(l,t,s,r){return await(await this.getWindowDriver(l)).getElementXY(t,s,r)}async typeInEditor(l,t,s){await(await this.getWindowDriver(l)).typeInEditor(t,s)}async getTerminalBuffer(l,t){return await(await this.getWindowDriver(l)).getTerminalBuffer(t)}async writeInTerminal(l,t,s){await(await this.getWindowDriver(l)).writeInTerminal(t,s)}async getLocalizedStrings(l){return await(await this.getWindowDriver(l)).getLocalizedStrings()}async getWindowDriver(l){await this.whenUnfrozen(l);const t=`window:${l}`,s=new n.StaticRouter(a=>a===t),r=this.windowServer.getChannel("windowDriver",s);return new M.WindowDriverChannelClient(r)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await b.Event.toPromise(this.onDidReloadingChange.event)}};c=he([te(2,D.IWindowsMainService),te(3,m.ILifecycleMainService),te(4,P.INativeHostMainService)],c),e.Driver=c;async function h(o,l,t,s){const r=t.driverVerbose,a=s.createInstance(c,o,{verbose:r}),u=new g.WindowDriverRegistryChannel(a);o.registerChannel("windowDriverRegistry",u);const p=await S.serve(l),f=new g.DriverChannel(a);return p.registerChannel("driver",f),E.combinedDisposable(p,o)}e.serve=h}),define(J[230],Z([0,1,144,26,49,14,102,70,24,3,6,83,53,4,61,10,46,55,2,31,20]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=y.createDecorator("issueMainService");let l=class St{constructor(s,r,a,u,p,f,L,F,_){this.userEnv=s,this.environmentMainService=r,this.launchMainService=a,this.logService=u,this.diagnosticsService=p,this.dialogMainService=f,this.nativeHostMainService=L,this.protocolMainService=F,this.productService=_,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),u=await this.diagnosticsService.getSystemInfo(r,a);this.safeSend(s,"vscode:issueSystemInfoResponse",u)}),S.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const a=await this.launchMainService.getMainProcessId();r.push({name:g.localize(0,null),rootProcess:await b.listProcesses(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(p=>{n.isRemoteDiagnosticError(p)?r.push({name:p.hostName,rootProcess:p}):p.processes&&r.push({name:p.hostName,rootProcess:p.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),S.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:g.localize(1,null),type:"warning",buttons:[h.mnemonicButtonLabel(g.localize(2,null)),h.mnemonicButtonLabel(g.localize(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:g.localize(4,null),type:"warning",buttons:[h.mnemonicButtonLabel(g.localize(5,null)),h.mnemonicButtonLabel(g.localize(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:a,from:u,args:p}=r;let f;switch(u){case"issueReporter":f=this.issueReporterParentWindow;break;case"processExplorer":f=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${u}`)}f&&f.webContents.send("vscode:runAction",{id:a,from:u,args:p})}),S.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),S.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...a){s.sender.isDestroyed()||s.sender.send(r,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new c.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,a,{backgroundColor:s.styles.backgroundColor,title:g.localize(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:M.type(),arch:M.arch(),release:M.release()},product:D.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new c.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,a,{backgroundColor:s.styles.backgroundColor,title:g.localize(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:D.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,a){const u=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,"--context-isolation"],v8CacheOptions:v.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:d.zoomLevelToZoomFactor(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,a){let u;const p=S.screen.getAllDisplays();if(p.length===1)u=p[0];else{if(v.isMacintosh){const F=S.screen.getCursorScreenPoint();u=S.screen.getDisplayNearestPoint(F)}!u&&s&&(u=S.screen.getDisplayMatching(s.getBounds())),u||(u=S.screen.getPrimaryDisplay()||p[0])}const f={width:r,height:a},L=u.bounds;return f.x=L.x+L.width/2-f.width/2,f.y=L.y+L.height/2-f.height/2,L.width>0&&L.height>0&&(f.x<L.x&&(f.x=L.x),f.y<L.y&&(f.y=L.y),f.x>L.x+L.width&&(f.x=L.x),f.y>L.y+L.height&&(f.y=L.y),f.width>L.width&&(f.width=L.width),f.height>L.height&&(f.height=L.height)),f}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=he([te(1,w.IEnvironmentMainService),te(2,E.ILaunchMainService),te(3,i.ILogService),te(4,n.IDiagnosticsService),te(5,k.IDialogMainService),te(6,P.INativeHostMainService),te(7,I.IProtocolMainService),te(8,o.IProductService)],l),e.IssueMainService=l}),define(J[231],Z([0,1,20,21,22,42,32,24,6,77,51,25,46]),function(q,e,g,M,D,S,E,n,w,v,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends v.AbstractUpdateService{constructor(m,P,I,c,h,o,l,t){super(m,P,c,h,o,t);this.telemetryService=I,this.nativeHostMainService=l}buildUpdateFeedUrl(m){return v.createUpdateURL(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},b.CancellationToken.None).then(i.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const I=m?P.message||P:void 0;this.setState(S.State.Idle(1,I))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};y=he([te(0,D.ILifecycleMainService),te(1,M.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,i.IRequestService),te(5,w.ILogService),te(6,k.INativeHostMainService),te(7,g.IProductService)],y),e.LinuxUpdateService=y}),define(J[232],Z([0,1,29,8,18,47,21,22,20,42,32,24,6,77,51,113,26,41,25,9,19,7,46]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(p,f=1e3){for(;!p();)await h.timeout(f)}let r;function a(){return typeof r=="undefined"&&(r=g.existsSync(M.join(M.dirname(process.execPath),"unins000.exe"))?0:1),r}let u=class extends y.AbstractUpdateService{constructor(f,L,F,_,C,K,ee,V,x){super(f,L,_,C,K,x);this.telemetryService=F,this.fileService=ee,this.nativeHostMainService=V}get cachePath(){const f=M.join(P.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return D.Promises.mkdir(f,{recursive:!0}).then(()=>f)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(f){let L="win32";return process.arch!=="ia32"&&(L+=`-${process.arch}`),a()===1?L+="-archive":this.productService.target==="user"&&(L+="-user"),y.createUpdateURL(L,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(v.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},c.CancellationToken.None).then(d.asJson).then(L=>{const F=a();return!L||!L.url||!L.version||!L.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(v.State.Idle(F)),Promise.resolve(null)):F===1?(this.setState(v.State.AvailableForDownload(L)),Promise.resolve(null)):(this.setState(v.State.Downloading(L)),this.cleanup(L.version).then(()=>this.getUpdatePackagePath(L.version).then(_=>D.Promises.exists(_).then(C=>{if(C)return Promise.resolve(_);const K=L.url,ee=L.hash,V=`${_}.tmp`;return this.requestService.request({url:K},c.CancellationToken.None).then(x=>this.fileService.writeFile(l.URI.file(V),x.stream)).then(ee?()=>m.checksum(V,L.hash):()=>{}).then(()=>D.Promises.rename(V,_)).then(()=>_)})).then(_=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:_},C&&L.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(v.State.Downloaded(L)):this.setState(v.State.Ready(L))})))}).then(void 0,L=>{this.logService.error(L),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const F=f?L.message||L:void 0;this.setState(v.State.Idle(a(),F))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(v.State.Idle(a()))}async getUpdatePackagePath(f){const L=await this.cachePath;return M.join(L,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const L=f?K=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test(K):()=>!0,F=await this.cachePath,C=(await D.Promises.readdir(F)).filter(L).map(async K=>{try{await D.Promises.unlink(M.join(F,K))}catch(ee){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(v.State.Updating(f));const L=await this.cachePath;this.availableUpdate.updateFilePath=M.join(L,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await D.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),I.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(v.State.Idle(a()))});const _=`${this.productService.win32MutexName}-ready`,C=await new Promise((K,ee)=>{q(["windows-mutex"],K,ee)});s(()=>C.isActive(_)).then(()=>this.setState(v.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?g.unlinkSync(this.availableUpdate.updateFilePath):I.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};he([S.memoize],u.prototype,"cachePath",null),u=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,i.ITelemetryService),te(3,b.IEnvironmentMainService),te(4,d.IRequestService),te(5,k.ILogService),te(6,o.IFileService),te(7,t.INativeHostMainService),te(8,w.IProductService)],u),e.Win32UpdateService=u}),define(J[233],Z([0,1,8,150,72,5,7,14,24,6,21,20,61,2,3,35,27,45,52,200,60,32,53,31,204,22,99,19,10,54,25,55]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s,r,a,u,p,f,L,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var C;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.LOADING=1]="LOADING",ee[ee.NAVIGATING=2]="NAVIGATING",ee[ee.READY=3]="READY"})(C||(C={}));let K=class extends y.Disposable{constructor(V,x,Q,U,$,H,B,T,R,O,W,A,N,z){super();this.logService=x,this.environmentMainService=Q,this.fileService=U,this.configurationService=H,this.themeMainService=B,this.workspacesManagementMainService=T,this.backupMainService=R,this.telemetryService=O,this.dialogMainService=W,this.lifecycleMainService=A,this.productService=N,this.protocolMainService=z,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Y,G]=this.restoreWindowState(V.state);this.windowState=Y,this.logService.trace("window#ctor: using window state",Y);const X=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),se={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!X,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:k.zoomLevelToZoomFactor(ne?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};d.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),d.isLinux?se.icon=g.join(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(se.icon=g.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(se.fullscreenable=!1),d.isMacintosh&&(se.acceptFirstMouse=!0,ne?.clickThroughInactive===!1&&(se.acceptFirstMouse=!1));const ue=d.isMacintosh&&ne?.nativeTabs===!0;ue&&(se.tabbingIdentifier=this.productService.nameShort);const de=k.getTitleBarStyle(this.configurationService)==="custom";if(de&&(se.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(se.frame=!1)),D.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(se),D.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&de&&this._win.setSheetOffset(22),d.isMacintosh&&G&&(!ue||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(re=>typeof re=="number")){const re=this.windowState;this._win.setBounds({width:re.width,height:re.height,x:re.x,y:re.y})}X&&(D.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),D.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=h.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:Y=>$.globalStorage.get(Y),store:(Y,G)=>$.globalStorage.set(Y,G)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){d.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){d.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){d.isMacintosh&&V?.force&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(V=>{function x(){Q.dispose(),U.dispose(),V()}const Q=this.onDidClose(()=>x()),U=this.onWillLoad(()=>x())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",($,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",($,H,B)=>this.onWindowError(3,{reason:B,exitCode:H})),this._win.webContents.on("will-prevent-unload",$=>{$.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const V=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),x=$=>{for(let H=$;H;H=H.parent)if(H.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Q=$=>$.resourceType==="xhr"||x($.frame);this._win.webContents.session.webRequest.onBeforeRequest(($,H)=>{const B=E.URI.parse($.url);return B.path.endsWith(".svg")&&!(V.has(B.scheme)||B.path.includes(f.Schemas.vscodeRemoteResource))?H({cancel:!Q($)}):H({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived(($,H)=>{const B=$.responseHeaders,T=B["content-type"]||B["Content-Type"];if(T&&Array.isArray(T)){const R=E.URI.parse($.url);if(R.path.endsWith(".svg")&&V.has(R.scheme))return B["Content-Type"]=["image/svg+xml"],H({cancel:!1,responseHeaders:B});if(!R.path.includes(f.Schemas.vscodeRemoteResource)&&T.some(O=>O.toLowerCase().includes("image/svg")))return H({cancel:!Q($)})}return H({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",$,this._win)}),this._win.on("unmaximize",$=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",$,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",F.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",F.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace($=>this.onDidDeleteUntitledWorkspace($)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async($,H)=>{const B=await this.marketplaceHeadersPromise;H({cancel:!1,requestHeaders:Object.assign($.requestHeaders,B)})})}async onWindowError(V,x){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${x?.reason||"<unknown>"}, code: ${x?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:x?.reason,code:x?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const Q=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[s.mnemonicButtonLabel(M.localize(0,null)),s.mnemonicButtonLabel(M.localize(1,null)),s.mnemonicButtonLabel(M.localize(2,null))],message:M.localize(3,null),detail:M.localize(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;Q.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):Q.response===2&&this.destroyWindow()}else if(V===2){let Q;x?Q=M.localize(6,null,x.reason,x.exitCode??"<unknown>"):Q=M.localize(5,null);const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[s.mnemonicButtonLabel(M.localize(7,null)),s.mnemonicButtonLabel(M.localize(8,null))],message:Q,detail:M.localize(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;U.response===0?this.reload():U.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let x=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;x?.endsWith("/")&&(x=x.substr(0,x.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((x||"").indexOf("@")===-1&&(x!==this.currentHttpProxy||Q!==this.currentNoProxy)){this.currentHttpProxy=x,this.currentNoProxy=Q;const U=x||"",$=Q?`${Q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${U}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:U,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(V){d.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,x=Object.create(null)){this.isDocumentEdited()&&(!x.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),x.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,x),this.readyState===0?this.currentConfig=V:(this.pendingLoadConfig=V,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:V.workspace})}updateConfiguration(V,x){const Q=(this.currentConfig??this.pendingLoadConfig)?.userEnv;Q&&L.isLaunchedFromCli(Q)&&!L.isLaunchedFromCli(V.userEnv)&&(V.userEnv={...Q,...V.userEnv}),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),x.disableExtensions!==void 0&&(V["disable-extensions"]=x.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),D.mark("code/willOpenNewWindow"),V.perfMarks=D.getMarks(),this.configObjectUrl.update(V)}async reload(V){const x=Object.assign({},this.currentConfig);x.workspace=await this.validateWorkspaceBeforeReload(x),delete x.filesToOpenOrCreate,delete x.filesToDiff,delete x.filesToWait,this.isExtensionDevelopmentHost&&V&&(x.verbose=V.verbose,x.debugId=V.debugId,x["inspect-extensions"]=V["inspect-extensions"],x["inspect-brk-extensions"]=V["inspect-brk-extensions"],x["extensions-dir"]=V["extensions-dir"]),x.isInitialStartup=!1,this.load(x,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if(P.isWorkspaceIdentifier(V.workspace)){const x=V.workspace.configPath;if(x.scheme===f.Schemas.file&&!await this.fileService.exists(x))return}else if(P.isSingleFolderWorkspaceIdentifier(V.workspace)){const x=V.workspace.uri;if(x.scheme===f.Schemas.file&&!await this.fileService.exists(x))return}return V.workspace}serializeWindowState(){if(!this._win)return m.defaultWindowState();if(this.isFullScreen){let Q;try{Q=n.screen.getDisplayMatching(this.getBounds())}catch(H){}const U=m.defaultWindowState();return{mode:3,display:Q?Q.id:void 0,width:this.windowState.width||U.width,height:this.windowState.height||U.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let x;if(!d.isMacintosh&&this._win.isMaximized()?x=0:x=1,x===0?V.mode=0:V.mode=1,x===1||x===0){let Q;x===1?Q=this.getBounds():Q=this._win.getNormalBounds(),V.x=Q.x,V.y=Q.y,V.width=Q.width,V.height=Q.height}return V}restoreWindowState(V){D.mark("code/willRestoreCodeWindowState");let x=!1;if(V)try{const Q=n.screen.getAllDisplays();x=Q.length>1,V=this.validateWindowState(V,Q)}catch(Q){this.logService.warn(`Unexpected error validating window state: ${Q}
${Q.stack}`)}return D.mark("code/didRestoreCodeWindowState"),[V||m.defaultWindowState(),x]}validateWindowState(V,x){if(this.logService.trace(`window#validateWindowState: validating window state on ${x.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(x.length===1){const $=this.getWorkingArea(x[0]);if($){let H=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!$||(V.x<$.x&&(V.x=$.x),V.y<$.y&&(V.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),H(),V.width>$.width&&(V.width=$.width),V.height>$.height&&(V.height=$.height),V.x>$.x+$.width-128&&(V.x=$.x+$.width-V.width),V.y>$.y+$.height-128&&(V.y=$.y+$.height-V.height),H()}return V}if(V.display&&V.mode===3){const $=x.find(H=>H.id===V.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const H=m.defaultWindowState(3);return H.x=$.bounds.x,H.y=$.bounds.y,H}}let Q,U;try{Q=n.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),U=this.getWorkingArea(Q)}catch($){}if(Q&&U&&V.x+V.width>U.x&&V.y+V.height>U.y&&V.x<U.x+U.width&&V.y<U.y+U.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",U),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,x]=this._win.getPosition(),[Q,U]=this._win.getSize();return{x:V,y:x,width:Q,height:U}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",F.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=k.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,x=!0){d.isMacintosh||(V==="toggle"&&x&&this.send("vscode:showInfoMessage",M.localize(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const x=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!x),this._win.autoHideMenuBar=x;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,x,...Q){this.isReady?this.send(V,...Q):this.ready().then(()=>{x.isCancellationRequested||this.send(V,...Q)})}send(V,...x){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${V} for window that is destroyed`);return}this._win.webContents.send(V,...x)}}updateTouchBar(V){!d.isMacintosh||this.touchBarGroups.forEach((x,Q)=>{const U=V[Q];x.segments=this.createTouchBarGroupSegments(U)})}createTouchBar(){if(!!d.isMacintosh){for(let V=0;V<10;V++){const x=this.createTouchBarGroup();this.touchBarGroups.push(x)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const x=this.createTouchBarGroupSegments(V),Q=new n.TouchBar.TouchBarSegmentedControl({segments:x,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",F.CancellationToken.None,{id:Q.segments[U].id,from:"touchbar"})}});return Q}createTouchBarGroupSegments(V=[]){return V.map(Q=>{let U;Q.icon&&!r.ThemeIcon.isThemeIcon(Q.icon)&&Q.icon?.dark?.scheme===f.Schemas.file&&(U=n.nativeImage.createFromPath(E.URI.revive(Q.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let $;return typeof Q.title=="string"?$=Q.title:$=Q.title.value,{id:Q.id,label:U?void 0:$,icon:U}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};K=he([te(1,v.ILogService),te(2,w.IEnvironmentMainService),te(3,p.IFileService),te(4,u.IStorageMainService),te(5,i.IConfigurationService),te(6,o.IThemeMainService),te(7,I.IWorkspacesManagementMainService),te(8,c.IBackupMainService),te(9,l.ITelemetryService),te(10,t.IDialogMainService),te(11,a.ILifecycleMainService),te(12,b.IProductService),te(13,_.IProtocolMainService)],K),e.CodeWindow=K}),define(J[62],Z([0,1,153,36,39,14,6,31,5,3,27,45,9,15,7,10,18,22,4,2]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=c.createDecorator("workspacesHistoryMainService");let o=class ze extends h.Disposable{constructor(p,f,L,F){super();this.stateMainService=p,this.logService=f,this.workspacesManagementMainService=L,this.lifecycleMainService=F,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(p=>this.addRecentlyOpened([{workspace:p.workspace}])))}handleWindowsJumpList(){!v.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(p){const f=[],L=[];for(let F of p)if(i.isRecentWorkspace(F))!this.workspacesManagementMainService.isUntitledWorkspace(F.workspace)&&s(f,F.workspace)===-1&&f.push(F);else if(i.isRecentFolder(F))r(f,F.folderUri)===-1&&f.push(F);else{const _=a(L,F.fileUri)>=0,C=F.fileUri.scheme===m.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf(y.basename(F.fileUri))>=0;!_&&!C&&(L.push(F),v.isWindows&&F.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(F.fileUri.fsPath))}this.addEntriesFromStorage(f,L),f.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(f.length=ze.MAX_TOTAL_RECENT_ENTRIES),L.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(L.length=ze.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:f,files:L}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(p){const f=C=>{const K=t(C);for(const ee of p)if(y.extUriBiasedIgnorePathCase.isEqual(ee,K))return!1;return!0},L=this.getRecentlyOpened(),F=L.workspaces.filter(f),_=L.files.filter(f);(F.length!==L.workspaces.length||_.length!==L.files.length)&&(this.saveRecentlyOpened({files:_,workspaces:F}),this._onDidChangeRecentlyOpened.fire(),v.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!v.isMacintosh)return;S.app.clearRecentDocuments();const p=this.getRecentlyOpened(),f=[];let L=0;for(let _=0;_<p.workspaces.length&&L<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;_++){const C=t(p.workspaces[_]);if(C.scheme===m.Schemas.file){const K=y.originalFSPath(C);await P.Promises.exists(K)&&(f.push(K),L++)}}const F=[];for(let _=0;_<p.files.length&&L<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;_++){const C=t(p.files[_]);if(C.scheme===m.Schemas.file){const K=y.originalFSPath(C);if(ze.COMMON_FILES_FILTER.includes(y.basename(C))||f.includes(K))continue;await P.Promises.exists(K)&&(F.push(K),L++)}}F.reverse().forEach(_=>S.app.addRecentDocument(_)),f.reverse().forEach(_=>S.app.addRecentDocument(_))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(p){const f=[],L=[],F=p?.config?.workspace;i.isWorkspaceIdentifier(F)&&!this.workspacesManagementMainService.isUntitledWorkspace(F)?f.push({workspace:F}):i.isSingleFolderWorkspaceIdentifier(F)&&f.push({folderUri:F.uri});const _=p?.config?.filesToOpenOrCreate;if(_)for(let C of _){const K=C.fileUri;K&&a(L,K)===-1&&L.push({fileUri:K})}return this.addEntriesFromStorage(f,L),{workspaces:f,files:L}}addEntriesFromStorage(p,f){let L=this.getRecentlyOpenedFromStorage();for(let F of L.workspaces){let _=i.isRecentFolder(F)?r(p,F.folderUri):s(p,F.workspace);_>=0?p[_].label=p[_].label||F.label:p.push(F)}for(let F of L.files){let _=a(f,F.fileUri);_>=0?f[_].label=f[_].label||F.label:f.push(F)}}getRecentlyOpenedFromStorage(){const p=this.stateMainService.getItem(ze.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(p,this.logService)}saveRecentlyOpened(p){const f=i.toStoreData(p);this.stateMainService.setItem(ze.recentlyOpenedStorageKey,f)}updateWindowsJumpList(){if(!v.isWindows)return;const p=[];if(p.push({type:"tasks",items:[{type:"task",title:g.localize(0,null),description:g.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let f=[];for(let _ of S.app.getJumpListSettings().removedItems){const C=_.args;if(C){const K=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);K&&f.push(d.URI.parse(K[2]))}}this.removeRecentlyOpened(f);let L=!1;const F=M.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(_=>{const C=i.isRecentWorkspace(_)?_.workspace:_.folderUri,{title:K,description:ee}=this.getWindowsJumpListLabel(C,_.label);let V;return d.URI.isUri(C)?V=`--folder-uri "${C.toString()}"`:(L=!0,V=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:K.substr(0,255),description:ee.substr(0,255),program:process.execPath,args:V,iconPath:"explorer.exe",iconIndex:0}}));F.length>0&&p.push({type:"custom",name:L?g.localize(2,null):g.localize(3,null),items:F})}p.push({type:"recent"});try{S.app.setJumpList(p)}catch(f){this.logService.warn("updateWindowsJumpList#setJumpList",f)}}getWindowsJumpListLabel(p,f){if(f)return{title:n.splitName(f).name,description:f};if(d.URI.isUri(p))return{title:y.basename(p),description:l(p)};if(this.workspacesManagementMainService.isUntitledWorkspace(p))return{title:g.localize(4,null),description:""};let L=y.basename(p.configPath);return L.endsWith(i.WORKSPACE_EXTENSION)&&(L=L.substr(0,L.length-i.WORKSPACE_EXTENSION.length-1)),{title:g.localize(5,null,L),description:l(p.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,D.IStateMainService),te(1,E.ILogService),te(2,b.IWorkspacesManagementMainService),te(3,I.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function l(u){return u.scheme==="file"?n.normalizeDriveLetter(u.fsPath):u.toString()}function t(u){return i.isRecentFolder(u)?u.folderUri:i.isRecentFile(u)?u.fileUri:u.workspace.configPath}function s(u,p){return u.findIndex(f=>i.isRecentWorkspace(f)&&f.workspace.id===p.id)}function r(u,p){return u.findIndex(f=>i.isRecentFolder(f)&&y.extUriBiasedIgnorePathCase.isEqual(f.folderUri,p))}function a(u,p){return u.findIndex(f=>y.extUriBiasedIgnorePathCase.isEqual(f.fileUri,p))}}),define(J[234],Z([0,1,145,3,24,14,61,21,32,42,20,9,6,31,35,62,183,7,39,22,46,25]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let s=class wt{constructor(u,p,f,L,F,_,C,K,ee,V,x){this.updateService=u,this.configurationService=p,this.windowsMainService=f,this.environmentMainService=L,this.telemetryService=F,this.workspacesHistoryMainService=_,this.stateMainService=C,this.lifecycleMainService=K,this.logService=ee,this.nativeHostMainService=V,this.productService=x,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new b.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new b.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||E.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const u=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);u&&(u.menus&&(this.menubarMenus=u.menus),u.keybindings&&(this.keybindings=u.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(_,C,K)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(_,C,K)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(_,C,K)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(K),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(_,C,K)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(K),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const u=this.productService.twitterUrl;u&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(u,"openTwitterUrl"));const p=this.productService.requestFeatureUrl;p&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(p,"openUserVoiceUrl"));const f=this.productService.reportIssueUrl;f&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(f,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const _=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${_}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const F=this.productService.privacyStatementUrl;F&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(M.language){const _=L.indexOf("?")>0?"&":"?";this.openUrl(`${F}${_}lang=${M.language}`,"openPrivacyStatement")}else this.openUrl(F,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(u=>this.onDidChangeWindowsCount(u)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let u=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof u!="boolean"&&(u=!0),u}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let u=this.configurationService.getValue("window.nativeTabs");return typeof u!="boolean"&&(u=!1),u}updateMenu(u,p){this.menubarMenus=u.menus,this.keybindings=u.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,u),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(u){!M.isMacintosh||(u.oldCount===0&&u.newCount>0||u.oldCount>0&&u.newCount===0)&&(this.closedLastWindow=u.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const u=S.Menu.getApplicationMenu();if(u&&this.oldMenus.push(u),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const p=new S.Menu;let f;if(M.isMacintosh){const F=new S.Menu;f=new S.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),p.append(f)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new S.Menu;F.append(new S.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(F)}if(this.shouldDrawMenu("File")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:F});this.setMenuById(F,"File"),p.append(_)}if(this.shouldDrawMenu("Edit")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:F});this.setMenuById(F,"Edit"),p.append(_)}if(this.shouldDrawMenu("Selection")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:F});this.setMenuById(F,"Selection"),p.append(_)}if(this.shouldDrawMenu("View")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:F});this.setMenuById(F,"View"),p.append(_)}if(this.shouldDrawMenu("Go")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:F});this.setMenuById(F,"Go"),p.append(_)}if(this.shouldDrawMenu("Run")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:F});this.setMenuById(F,"Run"),p.append(_)}if(this.shouldDrawMenu("Terminal")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:F});this.setMenuById(F,"Terminal"),p.append(_)}let L;if(this.shouldDrawMenu("Window")){const F=new S.Menu;L=new S.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}if(L&&p.append(L),this.shouldDrawMenu("Help")){const F=new S.Menu,_=new S.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:F,role:"help"});this.setMenuById(F,"Help"),p.append(_)}p.items&&p.items.length>0?S.Menu.setApplicationMenu(p):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(u){const p=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),f=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const Q=new S.Menu;this.setMenuById(Q,"Preferences"),L=new S.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:Q})}const F=new S.Menu,_=new S.MenuItem({label:g.localize(12,null),role:"services",submenu:F}),C=new S.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),K=new S.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new S.MenuItem({label:g.localize(15,null),role:"unhide"}),V=new S.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),x=[p];x.push(...f),L&&x.push(r(),L),x.push(r(),_,r(),C,K,ee,r(),V),x.forEach(Q=>u.append(Q))}shouldDrawMenu(u){if(!M.isMacintosh&&E.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(u){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[u];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[u]}}setMenu(u,p){p.forEach(f=>{if(P.isMenubarMenuItemSeparator(f))u.append(r());else if(P.isMenubarMenuItemSubmenu(f)){const L=new S.Menu,F=new S.MenuItem({label:this.mnemonicLabel(f.label),submenu:L});this.setMenu(L,f.submenu.items),u.append(F)}else P.isMenubarMenuItemRecentAction(f)?u.append(this.createOpenRecentMenuItem(f)):P.isMenubarMenuItemAction(f)&&(f.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(u),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[f.id]?u.append(new S.MenuItem(this.likeAction(f.id,{label:this.mnemonicLabel(f.label),click:this.fallbackMenuHandlers[f.id]}))):u.append(this.createMenuItem(f.label,f.id,!1,f.checked)):u.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)):u.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)))})}setMenuById(u,p){this.menubarMenus&&this.menubarMenus[p]&&this.setMenu(u,this.menubarMenus[p].items)}insertCheckForUpdatesItems(u){const p=this.getUpdateMenuItems();p.length&&(p.forEach(f=>u.append(f)),u.append(r()))}createOpenRecentMenuItem(u){const p=I.URI.revive(u.uri),f=u.id,L=f==="openRecentFile"?{fileUri:p}:f==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new S.MenuItem(this.likeAction(f,{label:u.label,click:(F,_,C)=>{const K=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:K,gotoLineMode:!1,remoteAuthority:u.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([p])}},!1))}isOptionClick(u){return!!(u&&(!M.isMacintosh&&(u.ctrlKey||u.shiftKey)||M.isMacintosh&&(u.metaKey||u.altKey)))}createRoleMenuItem(u,p,f){const L={label:this.mnemonicLabel(u),role:f,enabled:!0};return new S.MenuItem(this.withKeybinding(p,L))}setMacWindowMenu(u){const p=new S.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),f=new S.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new S.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),F=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),_=[];this.currentEnableNativeTabs&&(_.push(r()),_.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),_.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),_.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),_.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),_.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,f,r(),F,..._,r(),L].forEach(C=>u.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(u,p,f,L){const F=this.mnemonicLabel(u),_=typeof p=="function"?p:(x,Q,U)=>{const $=x?x.userSettingsLabel:null;let H=p;Array.isArray(p)&&(H=this.isOptionClick(U)?p[1]:p[0]),$&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:$}):this.runActionInRenderer({type:"commandId",commandId:H})},C=typeof f=="boolean"?f:this.windowsMainService.getWindowCount()>0,K=typeof L=="boolean"?L:!1,ee={label:F,click:_,enabled:C};K&&(ee.type="checkbox",ee.checked=K);let V;return typeof p=="string"?V=p:Array.isArray(p)&&(V=p[0]),M.isMacintosh&&(V==="editor.action.clipboardCutAction"?ee.role="cut":V==="editor.action.clipboardCopyAction"?ee.role="copy":V==="editor.action.clipboardPasteAction"&&(ee.role="paste"),V==="undo"?ee.click=this.makeContextAwareClickHandler(_,{inDevTools:x=>x.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?ee.click=this.makeContextAwareClickHandler(_,{inDevTools:x=>x.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(_,{inDevTools:x=>x.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(V,ee))}makeContextAwareClickHandler(u,p){return(f,L,F)=>{const _=S.BrowserWindow.getFocusedWindow();if(!_)return p.inNoWindow();if(_.webContents.isDevToolsFocused()&&_.webContents.devToolsWebContents)return p.inDevTools(_.webContents.devToolsWebContents);u(f,L||_,F)}}runActionInRenderer(u){let p=S.BrowserWindow.getFocusedWindow();if(!p){const L=this.windowsMainService.getLastActiveWindow();L?.isMinimized()&&(p=L.win)}const f=p?this.windowsMainService.getWindowById(p.id):void 0;if(f){if(this.logService.trace("menubar#runActionInRenderer",u),M.isMacintosh&&!this.environmentMainService.isBuilt&&!f.isReady&&(u.type==="commandId"&&u.commandId==="workbench.action.toggleDevTools"||u.type!=="commandId"&&u.userSettingsLabel==="alt+cmd+i"))return;if(u.type==="commandId"){const L={id:u.commandId,from:"menu"};f.sendWhenReady("vscode:runAction",l.CancellationToken.None,L)}else{const L={userSettingsLabel:u.userSettingsLabel};f.sendWhenReady("vscode:runKeybinding",l.CancellationToken.None,L)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",u)}withKeybinding(u,p){const f=typeof u=="string"?this.keybindings[u]:void 0;if(f?.label){if(f.isNative!==!1)p.accelerator=f.label,p.userSettingsLabel=f.userSettingsLabel;else if(typeof p.label=="string"){const L=p.label.indexOf("[");L>=0?p.label=`${p.label.substr(0,L)} [${f.label}]`:p.label=`${p.label} [${f.label}]`}}else p.accelerator=void 0;return p}likeAction(u,p,f=!p.accelerator){f&&(p=this.withKeybinding(u,p));const L=p.click;return p.click=(F,_,C)=>{this.reportMenuActionTelemetry(u),L&&L(F,_,C)},p}openUrl(u,p){this.nativeHostMainService.openExternal(void 0,u),this.reportMenuActionTelemetry(p)}reportMenuActionTelemetry(u){this.telemetryService.publicLog2("workbenchActionExecuted",{id:u,from:t})}mnemonicLabel(u){return y.mnemonicMenuLabel(u,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=he([te(0,v.IUpdateService),te(1,n.IConfigurationService),te(2,d.IWindowsMainService),te(3,D.IEnvironmentMainService),te(4,w.ITelemetryService),te(5,m.IWorkspacesHistoryMainService),te(6,c.IStateMainService),te(7,h.ILifecycleMainService),te(8,k.ILogService),te(9,o.INativeHostMainService),te(10,i.IProductService)],s),e.Menubar=s;function r(){return new S.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,234,6,4,22]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=D.createDecorator("menubarMainService");let E=class{constructor(w,v,i){this.instantiationService=w,this.lifecycleMainService=v,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(g.Menubar)}async updateMenubar(w,v){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(v,w)}};E=he([te(0,D.IInstantiationService),te(1,S.ILifecycleMainService),te(2,M.ILogService)],E),e.MenubarMainService=E}),define(J[236],Z([0,1,29,26,49,72,8,151,36,52,24,39,233,14,22,21,6,61,100,5,20,62,3,27,4,10,7,15,73,216,45,101,43,2,53,13,30,31,25,19,33,55]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s,r,a,u,p,f,L,F,_,C,K,ee,V,x,Q,U,$,H,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function T(W){return s.isWorkspaceIdentifier(W?.workspace)}function R(W){return s.isSingleFolderWorkspaceIdentifier(W?.workspace)}let O=class Qe extends K.Disposable{constructor(A,N,z,Y,G,X,ne,se,ue,de,re,le,Ee,ve,be){super();this.machineId=A,this.initialUserEnv=N,this.logService=z,this.stateMainService=Y,this.environmentMainService=G,this.lifecycleMainService=X,this.backupMainService=ne,this.configurationService=se,this.workspacesHistoryMainService=ue,this.workspacesManagementMainService=de,this.instantiationService=re,this.dialogMainService=le,this.fileService=Ee,this.productService=ve,this.protocolMainService=be,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new L.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new K.DisposableStore;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const z of A.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(u.URI.file(z)));A.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(u.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,N){let z=this.environmentMainService.args;const Y=N?.remoteAuthority||void 0,G=!0,X=N?.forceReuseWindow,ne=!X;return this.open({...A,cli:z,forceEmpty:G,forceNewWindow:ne,forceReuseWindow:X,remoteAuthority:Y})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],z=[],Y=[],G=[],X=[];let ne,se=0;const ue=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ue);for(const ve of ue)R(ve)?A.addMode?N.push(ve):z.push(ve):T(ve)?Y.push(ve):ve.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ve.remoteAuthority}),ne.filesToOpenOrCreate.push(ve)):ve.backupPath?X.push({backupFolder:E.basename(ve.backupPath),remoteAuthority:ve.remoteAuthority}):se++;A.diffMode&&ne?.filesToOpenOrCreate.length===2&&(ne.filesToDiff=ne.filesToOpenOrCreate,ne.filesToOpenOrCreate=[]),ne&&A.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...G),X.push(...this.backupMainService.getEmptyWindowBackupPaths())):X.length=0;const{windows:de,filesOpenedInWindow:re}=this.doOpen(A,Y,z,X,se,ne,N);if(this.logService.trace(`windowsManager#open used window count ${de.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${z.length}, emptyToRestore: ${X.length}, emptyToOpen: ${se})`),de.length>1)if(re)re.focus();else{const ve=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let be=!0,Te=!0;if(ve){const ye=de.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),be=!1,Te=!1)}if(be)for(let ye=de.length-1;ye>=0;ye--){const we=de[ye];if(!(we.openedWorkspace&&G.some(Ie=>we.openedWorkspace&&Ie.workspace.id===we.openedWorkspace.id)||we.backupPath&&X.some(Ie=>we.backupPath&&Ie.backupFolder===E.basename(we.backupPath)))){we.focus(),Te=!1;break}}Te&&de[de.length-1].focus()}const le=ne&&ne.filesToDiff.length>0;if(!de.some(ve=>ve.isExtensionDevelopmentHost)&&!le&&!A.noRecentEntry){const ve=[];for(const be of ue)T(be)&&!be.transient?ve.push({label:be.label,workspace:be.workspace,remoteAuthority:be.remoteAuthority}):R(be)?ve.push({label:be.label,folderUri:be.workspace.uri,remoteAuthority:be.remoteAuthority}):be.fileUri&&ve.push({label:be.label,fileUri:be.fileUri,remoteAuthority:be.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ve)}const Ee=A.waitMarkerFileURI;return A.context===0&&Ee&&de.length===1&&de[0]&&(async()=>{await de[0].whenClosedOrLoaded;try{await this.fileService.del(Ee)}catch(ve){}})(),de}doOpen(A,N,z,Y,G,X,ne){const se=[];let ue;function de(ye,we){se.push(ye),we&&(ue=ye,X=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:le}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&ne.length>0){const ye=ne[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(ye);we&&de(this.doAddFoldersToExistingWindow(we,ne.map(Ie=>Ie.workspace.uri)))}const Ee=z.length+N.length+Y.length;if(X&&Ee===0){const ye=X.filesToOpenOrCreate[0]||X.filesToDiff[0],we=this.getWindows().filter(Le=>X&&Le.remoteAuthority===X.remoteAuthority);let Ie;ye?.fileUri&&!le&&((A.context===4||A.context===0||A.context===1)&&(Ie=c.findWindowOnFile(we,ye.fileUri,Le=>Le.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(we))),Ie?s.isWorkspaceIdentifier(Ie.openedWorkspace)?N.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):s.isSingleFolderWorkspaceIdentifier(Ie.openedWorkspace)?z.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):de(this.doOpenFilesInExistingWindow(A,Ie,X),!0):de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:X,forceNewWindow:!0,remoteAuthority:X.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const ve=w.distinct(N,ye=>ye.workspace.id);if(ve.length>0){const ye=w.coalesce(ve.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(ye.length>0){const we=ye[0],Ie=X?.remoteAuthority===we.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,we,Ie),!!Ie),re=!0}ve.forEach(we=>{if(ye.some(Oe=>Oe.openedWorkspace&&Oe.openedWorkspace.id===we.workspace.id))return;const Ie=we.remoteAuthority,Le=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,we,re,Le),!!Le),re=!0})}const be=w.distinct(z,ye=>p.extUriBiasedIgnorePathCase.getComparisonKey(ye.workspace.uri));if(be.length>0){const ye=w.coalesce(be.map(we=>c.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(ye.length>0){const we=ye[0],Ie=X?.remoteAuthority===we.remoteAuthority?X:void 0;de(this.doOpenFilesInExistingWindow(A,we,Ie),!!Ie),re=!0}be.forEach(we=>{if(ye.some(Oe=>s.isSingleFolderWorkspaceIdentifier(Oe.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(Oe.openedWorkspace.uri,we.workspace.uri)))return;const Ie=we.remoteAuthority,Le=X?.remoteAuthority===Ie?X:void 0;de(this.doOpenFolderOrWorkspace(A,we,re,Le),!!Le),re=!0})}const Te=w.distinct(Y,ye=>ye.backupFolder);if(Te.length>0&&Te.forEach(ye=>{const we=ye.remoteAuthority,Ie=X?.remoteAuthority===we?X:void 0;de(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ie,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:ye}),!!Ie),re=!0}),se.length===0||X){X&&!G&&G++;const ye=X?X.remoteAuthority:A.remoteAuthority;for(let we=0;we<G;we++)de(this.doOpenEmpty(A,re,ye,X),!!X),re=!0}return{windows:w.distinct(se),filesOpenedInWindow:ue}}doOpenFilesInExistingWindow(A,N,z){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),N.focus();const Y={filesToOpenOrCreate:z?.filesToOpenOrCreate,filesToDiff:z?.filesToDiff,filesToWait:z?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",U.CancellationToken.None,Y),N}doAddFoldersToExistingWindow(A,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const z={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",U.CancellationToken.None,z),A}doOpenEmpty(A,N,z,Y,G){return!N&&!G&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:z,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:G})}doOpenFolderOrWorkspace(A,N,z,Y,G){return!z&&!G&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:G})}getPathsToOpen(A){let N,z=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(A),z=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=this.doExtractPathsFromCLI(A.cli),N.length===0&&N.push(Object.create(null)),z=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),Y=!0),!A.addMode&&z){const G=N.filter(X=>R(X));if(G.length>1){const X=G[0].remoteAuthority;if(G.every(ne=>ne.remoteAuthority===X)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(G.map(se=>({uri:se.workspace.uri})));N.push({workspace:ne,remoteAuthority:X}),N=N.filter(se=>!R(se))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(G=>T(G)||R(G)||G.backupPath)),N}doExtractPathsFromAPI(A){const N=[],z={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of w.coalesce(A.urisToOpen||[])){const G=this.resolveOpenable(Y,z);if(G)G.label=Y.label,N.push(G);else{const X=this.resourceFromOpenable(Y),ne={title:this.productService.nameLong,type:"info",buttons:[Q.mnemonicButtonLabel(n.localize(0,null))],defaultId:0,message:X.scheme===a.Schemas.file?n.localize(1,null):n.localize(2,null),detail:X.scheme===a.Schemas.file?n.localize(3,null,Q.getPathLabel(X.fsPath,this.environmentMainService)):n.localize(4,null,X.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,V.withNullAsUndefined(y.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(A){const N=[],z={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const ne of Y){const se=this.cliArgToUri(ne);if(se){const ue=this.resolveOpenable({folderUri:se},z);ue&&N.push(ue)}}const G=A["file-uri"];if(G)for(const ne of G){const se=this.cliArgToUri(ne);if(se){const ue=this.resolveOpenable(s.hasWorkspaceFileExtension(ne)?{workspaceUri:se}:{fileUri:se},z);ue&&N.push(ue)}}const X=A._;for(const ne of X){const se=z.remoteAuthority?this.doResolvePathRemote(ne,z):this.doResolveFilePath(ne,z);se&&N.push(se)}return N}cliArgToUri(A){try{const N=u.URI.parse(A);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${A}, ${N.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const N=[];A!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const z=[];for(const Y of N)if(Y.workspace){const G=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});T(G)&&z.push(G)}else if(Y.folderUri){const G=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});R(G)&&z.push(G)}else A!=="folders"&&Y.backupPath&&z.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return z}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,N=Object.create(null)){let z=this.resourceFromOpenable(A);return z.scheme===a.Schemas.file?(I.isFileToOpen(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(z.fsPath,N)):this.doResolveRemoteOpenable(A,N)}doResolveRemoteOpenable(A,N){let z=this.resourceFromOpenable(A);const Y=f.getRemoteAuthority(z)||N.remoteAuthority;if(z=p.removeTrailingPathSeparator(p.normalizePath(z)),I.isFileToOpen(A)){if(N.gotoLineMode){const{path:G,line:X,column:ne}=x.parseLineAndColumnAware(z.path);return{fileUri:z.with({path:G}),lineNumber:X,columnNumber:ne,remoteAuthority:Y}}return{fileUri:z,remoteAuthority:Y}}else if(I.isWorkspaceToOpen(A))return{workspace:_.getWorkspaceIdentifier(z),remoteAuthority:Y};return{workspace:_.getSingleFolderWorkspaceIdentifier(z),remoteAuthority:Y}}resourceFromOpenable(A){return I.isWorkspaceToOpen(A)?A.workspaceUri:I.isFolderToOpen(A)?A.folderUri:A.fileUri}doResolveFilePath(A,N){let z,Y;N.gotoLineMode&&({path:A,line:z,column:Y}=x.parseLineAndColumnAware(A)),A=x.sanitizeFilePath(E.normalize(A),H.cwd());try{const G=g.statSync(A);if(G.isFile()){if(!N.forceOpenWorkspaceAsFile){const X=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(A));if(X)return X.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},remoteAuthority:X.remoteAuthority,exists:!0,transient:X.transient}}return{fileUri:u.URI.file(A),lineNumber:z,columnNumber:Y,exists:!0}}else if(G.isDirectory())return{workspace:_.getSingleFolderWorkspaceIdentifier(u.URI.file(A),G),exists:!0}}catch(G){const X=u.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([X]),N.ignoreFileNotFound)return{fileUri:X,exists:!1}}}doResolvePathRemote(A,N){const z=A.charCodeAt(0),Y=N.remoteAuthority;let G,X;N.gotoLineMode&&({path:A,line:G,column:X}=x.parseLineAndColumnAware(A)),z!==47&&(x.isWindowsDriveLetter(z)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=x.toSlashes(A)),A=`/${A}`);const ne=u.URI.from({scheme:a.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if(s.hasWorkspaceFileExtension(A))return N.forceOpenWorkspaceAsFile?{fileUri:ne,lineNumber:G,columnNumber:X,remoteAuthority:N.remoteAuthority}:{workspace:_.getWorkspaceIdentifier(ne),remoteAuthority:Y};if(N.gotoLineMode||E.posix.basename(A).indexOf(".")!==-1)return{fileUri:ne,lineNumber:G,columnNumber:X,remoteAuthority:Y}}return{workspace:_.getSingleFolderWorkspaceIdentifier(ne),remoteAuthority:Y}}shouldOpenNewWindow(A){const N=this.configurationService.getValue("window"),z=N?.openFoldersInNewWindow||"default",Y=N?.openFilesInNewWindow||"off";let G=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(z==="on"||z==="off")&&(G=z==="on");let X=!1;return A.forceNewWindow||A.forceReuseWindow?X=!!A.forceNewWindow&&!A.forceReuseWindow:(t.isMacintosh?A.context===1&&(X=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(X=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(X=Y==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:X}}openExtensionDevelopmentHostWindow(A,N){const z=c.findWindowOnExtensionDevelopmentPath(this.getWindows(),A);if(z)return this.lifecycleMainService.reload(z,N.cli),z.focus(),[z];let Y=N.cli["folder-uri"]||[],G=N.cli["file-uri"]||[],X=N.cli._;if(!X.length&&!Y.length&&!G.length&&!N.cli.extensionTestsPath){const de=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=de&&(de.workspace||de.folderUri);re&&(u.URI.isUri(re)?re.scheme===a.Schemas.file?X=[re.fsPath]:Y=[re.toString()]:re.configPath.scheme===a.Schemas.file?X=[p.originalFSPath(re.configPath)]:G=[re.configPath.toString()])}let ne=N.remoteAuthority;for(const de of A)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=u.URI.parse(de),le=f.getRemoteAuthority(re);le&&(ne?le!==ne&&this.logService.error("more than one extension development path authority"):ne=le)}X=X.filter(de=>{const re=u.URI.file(de);return c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:f.getRemoteAuthority(re)===ne}),Y=Y.filter(de=>{const re=this.cliArgToUri(de);return re&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:re?f.getRemoteAuthority(re)===ne:!1}),G=G.filter(de=>{const re=this.cliArgToUri(de);return re&&!!c.findWindowOnWorkspaceOrFolder(this.getWindows(),re)?!1:re?f.getRemoteAuthority(re)===ne:!1}),N.cli._=X,N.cli["folder-uri"]=Y,N.cli["file-uri"]=G;const se=!X.length&&!Y.length&&!G.length,ue={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:se,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ne};return this.open(ue)}openInBrowserWindow(A){const N=this.configurationService.getValue("window"),z={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?E.join(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:S.getMarks(),os:{release:M.release(),hostname:M.hostname()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const G=Y.config;!z.extensionDevelopmentPath&&G&&!!G.extensionDevelopmentPath&&(z.extensionDevelopmentPath=G.extensionDevelopmentPath,z.verbose=G.verbose,z["inspect-brk-extensions"]=G["inspect-brk-extensions"],z.debugId=G.debugId,z["inspect-extensions"]=G["inspect-extensions"],z["extensions-dir"]=G["extensions-dir"])}else{const G=this.windowsStateHandler.getNewWindowState(z);S.mark("code/willCreateCodeWindow");const X=Y=this.instantiationService.createInstance(k.CodeWindow,{state:G,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});if(S.mark("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(X)}Qe.WINDOWS.push(X),this._onDidOpenWindow.fire(X),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),C.once(X.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(X)),C.once(X.onDidClose)(()=>this.onWindowClosed(X)),C.once(X.onDidDestroy)(()=>this._onDidDestroyWindow.fire(X));const ne=V.assertIsDefined(X.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(X)),this.lifecycleMainService.registerWindow(X)}return z.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(G=>{G||this.doOpenInBrowserWindow(Y,z,A)}):this.doOpenInBrowserWindow(Y,z,A),Y}doOpenInBrowserWindow(A,N,z){if(!N.extensionDevelopmentPath)if(s.isWorkspaceIdentifier(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if(s.isSingleFolderWorkspaceIdentifier(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync(N.workspace.uri);else{const Y=z.emptyWindowBackupInfo&&z.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,N.remoteAuthority)}A.load(N)}onWindowClosed(A){const N=Qe.WINDOWS.indexOf(A);Qe.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=y.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(N=>N.remoteAuthority===A))}doGetLastActiveWindow(A){const N=Math.max.apply(Math,A.map(z=>z.lastFocusTime));return A.find(z=>z.lastFocusTime===N)}sendToFocused(A,...N){const z=this.getFocusedWindow()||this.getLastActiveWindow();z&&z.sendWhenReady(A,U.CancellationToken.None,...N)}sendToAll(A,N,z){for(const Y of this.getWindows())z&&z.indexOf(Y.id)>=0||Y.sendWhenReady(A,U.CancellationToken.None,N)}getWindows(){return Qe.WINDOWS}getWindowCount(){return Qe.WINDOWS.length}getWindowById(A){const N=this.getWindows().filter(z=>z.id===A);return w.firstOrDefault(N)}getWindowByWebContents(A){const N=y.BrowserWindow.fromWebContents(A);if(!!N)return this.getWindowById(N.id)}};O.WINDOWS=[],O=he([te(2,P.ILogService),te(3,b.IStateMainService),te(4,i.IEnvironmentMainService),te(5,d.ILifecycleMainService),te(6,v.IBackupMainService),te(7,m.IConfigurationService),te(8,l.IWorkspacesHistoryMainService),te(9,F.IWorkspacesManagementMainService),te(10,r.IInstantiationService),te(11,ee.IDialogMainService),te(12,$.IFileService),te(13,o.IProductService),te(14,B.IProtocolMainService)],O),e.WindowsMainService=O}),define(J[237],Z([0,1,45,35,62,52]),function(q,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(w,v,i,b){this.workspacesManagementMainService=w,this.windowsMainService=v,this.workspacesHistoryMainService=i,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,v){const i=this.windowsMainService.getWindowById(w);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),v)}createUntitledWorkspace(w,v,i){return this.workspacesManagementMainService.createUntitledWorkspace(v,i)}deleteUntitledWorkspace(w,v){return this.workspacesManagementMainService.deleteUntitledWorkspace(v)}getWorkspaceIdentifier(w,v){return this.workspacesManagementMainService.getWorkspaceIdentifier(v)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,v){return this.workspacesHistoryMainService.addRecentlyOpened(v)}async removeRecentlyOpened(w,v){return this.workspacesHistoryMainService.removeRecentlyOpened(v)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,g.IWorkspacesManagementMainService),te(1,M.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[238],Z([0,1,26,29,14,3,236,22,91,42,206,34,123,85,224,102,4,71,69,6,39,24,21,98,207,32,97,201,202,198,20,228,2,35,7,27,237,66,232,231,226,230,181,16,209,229,235,120,8,15,132,10,227,99,214,219,52,62,208,45,70,158,46,53,13,31,211,76,19,40,28,17,89,212,197,54,30,170,186,43,73,75,90,173,179]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s,r,a,u,p,f,L,F,_,C,K,ee,V,x,Q,U,$,H,B,T,R,O,W,A,N,z,Y,G,X,ne,se,ue,de,re,le,Ee,ve,be,Te,ye,we,Ie,Le,Oe,Ue,qe,Je,$e,it,Ne,lt,Ze,ct,Ge,nt,rt,j,ie,oe,ae,fe,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pe=class extends C.Disposable{constructor(ce,ge,pe,me,ke,Me,De,Re,Ae,Ce){super();this.mainProcessNodeIpcServer=ce,this.userEnv=ge,this.mainInstantiationService=pe,this.logService=me,this.environmentMainService=ke,this.lifecycleMainService=Me,this.configurationService=De,this.stateMainService=Re,this.fileService=Ae,this.productService=Ce,this.configureSession(),this.registerListeners()}configureSession(){const ce=pe=>pe.startsWith(`${X.Schemas.vscodeWebview}://`);D.session.defaultSession.setPermissionRequestHandler((pe,me,ke,Me)=>ce(Me.requestingUrl)?ke(me==="clipboard-read"):ke(!1)),D.session.defaultSession.setPermissionCheckHandler((pe,me,ke,Me)=>ce(Me.requestingUrl)?me==="clipboard-read":!1);const ge=D.session.defaultSession;typeof ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&ge.setCodeCachePath(z.join(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){R.setUnexpectedErrorHandler(pe=>this.onUnexpectedError(pe)),process.on("uncaughtException",pe=>this.onUnexpectedError(pe)),process.on("unhandledRejection",pe=>R.onUnexpectedError(pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),N.registerContextMenuListener(),D.app.on("accessibility-support-changed",(pe,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),D.app.on("activate",(pe,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),D.app.on("web-contents-created",(pe,me)=>{me.on("will-attach-webview",(ke,Me,De)=>{const Re=Ae=>{if(!Ae)return!1;const Ce=ee.URI.parse(Ae);if(Ce.scheme===X.Schemas.vscodeWebview)return Ce.path==="/index.html"||Ce.path==="/electron-browser-index.html";const He=Ce.fsPath.toLowerCase(),Ke=ee.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return He.startsWith(Ke+z.sep)};delete Me.preload,Me.nodeIntegration=!1,!(Re(De.src)&&Re(Me.preloadURL))&&(delete Me.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),ke.preventDefault())}),me.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),me.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let ce=[],ge;D.app.on("open-file",(pe,me)=>{this.logService.trace("app#open-file: ",me),pe.preventDefault(),ce.push(this.getWindowOpenableFromPathSync(me)),ge!==void 0&&(clearTimeout(ge),ge=void 0),ge=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:ce,gotoLineMode:!1,preferNewWindow:!0}),ce=[],ge=void 0},100)}),D.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),D.ipcMain.handle("vscode:fetchShellEnv",pe=>{const me=this.windowsMainService?.getWindowByWebContents(pe.sender);let ke,Me;return me?.config?(ke=me.config,Me={...process.env,...me.config.userEnv}):(ke=this.environmentMainService.args,Me=process.env),w.resolveShellEnv(this.logService,ke,Me)}),D.ipcMain.handle("vscode:writeNlsFile",(pe,me,ke)=>{const Me=this.validateNlsPath([me]);if(!Me||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Me,it.VSBuffer.fromString(ke))}),D.ipcMain.handle("vscode:readNlsFile",async(pe,...me)=>{const ke=this.validateNlsPath(me);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}validateNlsPath(ce){let ge;for(const pe of ce)typeof pe=="string"&&(typeof ge!="string"?ge=pe:ge=z.join(ge,pe));if(!(typeof ge!="string"||!z.isAbsolute(ge)||!Ge.isEqualOrParent(ge,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return ee.URI.file(ge)}onUnexpectedError(ce){if(ce){const ge={message:`[uncaught exception in main]: ${ce.message}`,stack:ce.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${ce}`),ce.stack&&this.logService.error(ce.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ce=this.productService.win32AppUserModelId;S.isWindows&&ce&&D.app.setAppUserModelId(ce);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ge=new k.Server;this.logService.trace("Resolving machine identifier...");const pe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${pe}`);const{sharedProcess:me,sharedProcessReady:ke,sharedProcessClient:Me}=this.setupSharedProcess(pe),De=await this.initServices(pe,me,ke);if(this.environmentMainService.driverHandle){const Ae=await W.serve(ge,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(De.createInstance(_.ProxyAuthHandler)),De.invokeFunction(Ae=>this.initChannels(Ae,ge,Me));const Re=De.invokeFunction(Ae=>this.openFirstWindow(Ae,ge));De.invokeFunction(Ae=>this.afterWindowOpen(Ae,me)),this.environmentMainService.args.trace&&De.invokeFunction(Ae=>this.stopTracingEventually(Ae,Re))}async resolveMachineId(){let ce=this.stateMainService.getItem(a.machineIdKey);return(!ce||S.isMacintosh&&ce==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ce=await Q.getMachineId(),this.stateMainService.setItem(a.machineIdKey,ce)),ce}setupSharedProcess(ce){const ge=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,ce,this.userEnv)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ge.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(ke,"main")})(),me=(async()=>(await ge.whenReady(),pe))();return{sharedProcess:ge,sharedProcessReady:me,sharedProcessClient:pe}}async initServices(ce,ge,pe){const me=new I.ServiceCollection;switch(process.platform){case"win32":me.set(v.IUpdateService,new c.SyncDescriptor(U.Win32UpdateService));break;case"linux":S.isLinuxSnap?me.set(v.IUpdateService,new c.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(v.IUpdateService,new c.SyncDescriptor($.LinuxUpdateService));break;case"darwin":me.set(v.IUpdateService,new c.SyncDescriptor(H.DarwinUpdateService));break}me.set(K.IWindowsMainService,new c.SyncDescriptor(E.WindowsMainService,[ce,this.userEnv])),me.set(we.IDialogMainService,new c.SyncDescriptor(we.DialogMainService)),me.set(m.ILaunchMainService,new c.SyncDescriptor(m.LaunchMainService)),me.set(be.IDiagnosticsService,b.ProxyChannel.toService(b.getDelayedChannel(pe.then(Me=>Me.getChannel("diagnostics"))))),me.set(B.IIssueMainService,new c.SyncDescriptor(B.IssueMainService,[this.userEnv])),me.set(Ne.IEncryptionMainService,new c.SyncDescriptor(Ne.EncryptionMainService,[ce])),me.set(Ze.IKeyboardLayoutMainService,new c.SyncDescriptor(Ze.KeyboardLayoutMainService)),me.set(ye.INativeHostMainService,new c.SyncDescriptor(ye.NativeHostMainService,[ge])),me.set(Ue.IWebviewManagerService,new c.SyncDescriptor(Oe.WebviewMainService)),me.set(V.IWorkspacesService,new c.SyncDescriptor(x.WorkspacesMainService)),me.set(ve.IWorkspacesManagementMainService,new c.SyncDescriptor(ve.WorkspacesManagementMainService)),me.set(le.IWorkspacesHistoryMainService,new c.SyncDescriptor(le.WorkspacesHistoryMainService)),me.set(A.IMenubarMainService,new c.SyncDescriptor(A.MenubarMainService)),me.set(nt.IExtensionUrlTrustService,new c.SyncDescriptor(rt.ExtensionUrlTrustService)),me.set(se.IStorageMainService,new c.SyncDescriptor(se.StorageMainService)),S.isWindows?me.set(ae.IExternalTerminalMainService,new c.SyncDescriptor(fe.WindowsExternalTerminalService)):S.isMacintosh?me.set(ae.IExternalTerminalMainService,new c.SyncDescriptor(fe.MacExternalTerminalService)):S.isLinux&&me.set(ae.IExternalTerminalMainService,new c.SyncDescriptor(fe.LinuxExternalTerminalService));const ke=new de.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(re.IBackupMainService,ke),me.set(s.IURLService,new c.SyncDescriptor(Ee.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Me=b.getDelayedChannel(pe.then(He=>He.getChannel("telemetryAppender"))),De=new p.TelemetryAppenderClient(Me),Re=L.resolveCommonProperties(this.fileService,g.release(),g.hostname(),process.arch,this.productService.commit,this.productService.version,ce,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:De,commonProperties:Re,piiPaths:Ae,sendErrorTelemetry:!0};me.set(a.ITelemetryService,new c.SyncDescriptor(f.TelemetryService,[Ce]))}else me.set(a.ITelemetryService,u.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(me)}initChannels(ce,ge,pe){const me=b.ProxyChannel.fromService(ce.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me),ge.registerChannel(Se.UserConfigurationFileServiceId,b.ProxyChannel.fromService(new Se.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const ke=new i.UpdateChannel(ce.get(v.IUpdateService));ge.registerChannel("update",ke);const Me=b.ProxyChannel.fromService(ce.get(B.IIssueMainService));ge.registerChannel("issue",Me);const De=b.ProxyChannel.fromService(ce.get(Ne.IEncryptionMainService));ge.registerChannel("encryption",De);const Re=b.ProxyChannel.fromService(ce.get(oe.ISignService));ge.registerChannel("sign",Re);const Ae=b.ProxyChannel.fromService(ce.get(Ze.IKeyboardLayoutMainService));ge.registerChannel("keyboardLayout",Ae),this.nativeHostMainService=ce.get(ye.INativeHostMainService);const Ce=b.ProxyChannel.fromService(this.nativeHostMainService);ge.registerChannel("nativeHost",Ce),pe.then(Be=>Be.registerChannel("nativeHost",Ce));const He=b.ProxyChannel.fromService(ce.get(V.IWorkspacesService));ge.registerChannel("workspaces",He);const Ke=b.ProxyChannel.fromService(ce.get(A.IMenubarMainService));ge.registerChannel("menubar",Ke);const ut=b.ProxyChannel.fromService(ce.get(s.IURLService));ge.registerChannel("url",ut);const ht=b.ProxyChannel.fromService(ce.get(nt.IExtensionUrlTrustService));ge.registerChannel("extensionUrlTrust",ht);const _e=b.ProxyChannel.fromService(ce.get(Ue.IWebviewManagerService));ge.registerChannel("webview",_e);const xe=this._register(new ue.StorageDatabaseChannel(this.logService,ce.get(se.IStorageMainService)));ge.registerChannel("storage",xe),pe.then(Be=>Be.registerChannel("storage",xe));const et=b.ProxyChannel.fromService(ce.get(ae.IExternalTerminalMainService));ge.registerChannel("externalTerminal",et);const Ye=new T.LogLevelChannel(ce.get(h.ILogService));ge.registerChannel("logLevel",Ye),pe.then(Be=>Be.registerChannel("logLevel",Ye));const tt=new T.LoggerChannel(ce.get(h.ILoggerService));ge.registerChannel("logger",tt),pe.then(Be=>Be.registerChannel("logger",tt));const st=new Te.ElectronExtensionHostDebugBroadcastChannel(ce.get(K.IWindowsMainService));ge.registerChannel("extensionhostdebugservice",st)}openFirstWindow(ce,ge){const pe=this.windowsMainService=ce.get(K.IWindowsMainService),me=ce.get(s.IURLService),ke=ce.get(ye.INativeHostMainService);this.lifecycleMainService.phase=2;const Me=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:ee.URI.parse(We),url:We}}catch{return}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Xe=this.getWindowOpenableFromProtocolLink(We.uri);return Xe?(Me.push(Xe),!1):!0}),Re=this,Ae=this.environmentMainService,Ce=this.productService;me.registerHandler({async handleURL(We,Xe){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:ee.URI.parse(We.query).path,query:""})),Re.shouldBlockURI(We))return!0;const vt=Re.getWindowOpenableFromProtocolLink(We);if(vt){const[ft]=pe.open({context:5,cli:{...Ae.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(S.isMacintosh&&pe.getWindowCount()===0){const[ft]=pe.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:ie.getRemoteAuthority(We)});return await ft.ready(),me.open(We,Xe)}return!1}});const He=this._register(new lt.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ke=new b.StaticRouter(We=>He.getActiveClientId().then(Xe=>We===Xe)),ut=new r.URLHandlerRouter(Ke),ht=ge.getChannel("urlHandler",ut);me.registerHandler(new r.URLHandlerChannelClient(ht)),this._register(new O.ElectronURLListener(De,me,pe,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,xe=global.macOpenFiles,et=ct.isLaunchedFromCli(process.env)?0:4,Ye=_e._.length,tt=!!_e["folder-uri"],st=!!_e["file-uri"],Be=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?ee.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Me.length>0?pe.open({context:et,cli:_e,urisToOpen:Me,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Ye&&!tt&&!st?pe.open({context:et,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Be,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):xe.length&&!Ye&&!tt&&!st?pe.open({context:1,cli:_e,urisToOpen:xe.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:Be,waitMarkerFileURI:dt,initialStartup:!0}):pe.open({context:et,cli:_e,forceNewWindow:_e["new-window"]||!Ye&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:Be,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(ce){return!!(ce.authority===X.Schemas.file&&S.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Le.mnemonicButtonLabel(G.localize(0,null)),Le.mnemonicButtonLabel(G.localize(1,null))],defaultId:0,cancelId:1,message:G.localize(2,null,Le.getPathLabel(ce.fsPath,this.environmentMainService),this.productService.nameShort),detail:G.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ce){if(!!ce.path){if(ce.authority===X.Schemas.file)return{fileUri:ee.URI.file(ce.fsPath)};if(ce.authority===X.Schemas.vscodeRemote){const ge=ce.path.indexOf(z.posix.sep,1);if(ge!==-1){const pe=ce.path.substring(1,ge),me=ce.path.substring(ge),ke=ee.URI.from({scheme:X.Schemas.vscodeRemote,authority:pe,path:me,query:ce.query,fragment:ce.fragment});return V.hasWorkspaceFileExtension(me)?{workspaceUri:ke}:/:[\d]+$/.test(me)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(ce){try{if(M.statSync(ce).isDirectory())return{folderUri:ee.URI.file(ce)};if(V.hasWorkspaceFileExtension(ce))return{workspaceUri:ee.URI.file(ce)}}catch(ge){}return{fileUri:ee.URI.file(ce)}}async afterWindowOpen(ce,ge){this.lifecycleMainService.phase=3;let pe=!1;j.once(this.lifecycleMainService.onWillShutdown)(()=>pe=!0);const me=ce.get(a.ITelemetryService);this._register(ge.onDidError(({type:De,details:Re})=>{let Ae;switch(De){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}R.onUnexpectedError(new Error(Ae)),me.publicLog2("sharedprocesserror",{type:De,reason:Re?.reason,code:Re?.exitCode,visible:ge.isVisible(),shuttingdown:pe})}));const ke=this.productService.win32MutexName;if(S.isWindows&&ke)try{const De=q.__$__nodeRequire("windows-mutex").Mutex,Re=new De(ke);j.once(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(De){this.logService.error(De)}D.protocol.registerHttpProtocol(X.Schemas.vscodeRemoteResource,(De,Re)=>{Re({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const Me=ce.get(v.IUpdateService);(Me instanceof U.Win32UpdateService||Me instanceof $.LinuxUpdateService||Me instanceof H.DarwinUpdateService)&&Me.initialize(),w.resolveShellEnv(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(Je.stripComments(Re))["enable-crash-reporter"]===void 0){const Ce=this.configurationService.getValue("telemetry.enableCrashReporter")??!0,He=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${$e.generateUuid()}"`,"}"],Ke=Re.substring(0,Re.length-2).concat(`,
`,He.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,it.VSBuffer.fromString(Ke))}}catch(De){this.logService.error(De)}}stopTracingEventually(ce,ge){this.logService.info("Tracing: waiting for windows to get ready...");const pe=ce.get(we.IDialogMainService);let me=!1;const ke=async De=>{if(me)return;me=!0;const Re=await D.contentTracing.stopRecording(Y.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):pe.showMessageBox({title:this.productService.nameLong,type:"info",message:G.localize(4,null),detail:G.localize(5,null,Re),buttons:[Le.mnemonicButtonLabel(G.localize(6,null))],defaultId:0,noLink:!0},Ie.withNullAsUndefined(D.BrowserWindow.getFocusedWindow()))},Me=setTimeout(()=>ke(!0),3e4);Promise.all(ge.map(De=>De.ready())).then(()=>{clearTimeout(Me),ke(!1)})}};Pe=he([te(2,P.IInstantiationService),te(3,h.ILogService),te(4,l.IEnvironmentMainService),te(5,n.ILifecycleMainService),te(6,t.IConfigurationService),te(7,o.IStateMainService),te(8,qe.IFileService),te(9,F.IProductService)],Pe),e.CodeApplication=Pe}),define(J[242],Z([0,1,14,29,18,11,3,72,49,54,162,22,34,56,175,71,69,6,225,39,21,190,51,223,238,31,94,93,16,60,43,75,196,199,184,185,10,19,74,221,20,30,23,8,36,24,67,97,182,33,55,187,9,205]),function(q,e,g,M,D,S,E,n,w,v,i,b,k,y,d,m,P,I,c,h,o,l,t,s,r,a,u,p,f,L,F,_,C,K,ee,V,x,Q,U,$,H,B,T,R,O,W,A,N,z,Y,G,X,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class se{main(){try{this.startup()}catch(re){console.error(re.message),g.app.exit(1)}}async startup(){f.setUnexpectedErrorHandler(we=>console.error(we));const[re,le,Ee,ve,be,Te,ye]=this.createServices();try{try{await this.initServices(Ee,ve,be)}catch(we){throw this.handleStartupDataDirError(Ee,ye.nameLong,we),we}await re.invokeFunction(async we=>{const Ie=we.get(I.ILogService),Le=we.get(b.ILifecycleMainService),Oe=we.get(Q.IFileService),Ue=await this.claimInstance(Ie,Ee,Le,re,ye,!0);return Te.logger=new u.SpdLogLogger("main",R.join(Ee.logsPath,"main.log"),!0,Te.getLevel()),F.once(Le.onWillShutdown)(()=>{Oe.dispose(),ve.dispose()}),re.createInstance(r.CodeApplication,Ue,le).startup()})}catch(we){re.invokeFunction(this.quit,we)}}createServices(){const re=new m.ServiceCollection,le={_serviceBrand:void 0,...w.default};re.set(H.IProductService,le);const Ee=new W.EnvironmentMainService(this.resolveArgs(),le),ve=this.patchEnvironment(Ee);re.set(W.IEnvironmentMainService,Ee);const be=new p.BufferLogService,Te=new I.MultiplexLogService([new I.ConsoleMainLogger(I.getLogLevel(Ee)),be]);process.once("exit",()=>Te.dispose()),re.set(I.ILogService,Te);const ye=new ee.FileService(Te);re.set(Q.IFileService,ye);const we=new V.DiskFileSystemProvider(Te);ye.registerProvider(x.Schemas.file,we),re.set(I.ILoggerService,new z.LoggerService(Te,ye));const Ie=new l.ConfigurationService(Ee.settingsResource,ye);re.set(o.IConfigurationService,Ie),re.set(b.ILifecycleMainService,new P.SyncDescriptor(b.LifecycleMainService));const Le=new c.StateMainService(Ee,Te,ye);return re.set(h.IStateMainService,Le),re.set(t.IRequestService,new P.SyncDescriptor(s.RequestMainService)),re.set(L.IThemeMainService,new P.SyncDescriptor(L.ThemeMainService)),re.set(_.ISignService,new P.SyncDescriptor(C.SignService)),re.set(U.ITunnelService,new P.SyncDescriptor($.TunnelService)),re.set(G.IProtocolMainService,new P.SyncDescriptor(X.ProtocolMainService)),[new d.InstantiationService(re,!0),ve,Ee,Ie,Le,be,le]}patchEnvironment(re){const le={VSCODE_IPC_HOOK:re.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Ee=>{const ve=process.env[Ee];typeof ve=="string"&&(le[Ee]=ve)}),Object.assign(process.env,le),le}initServices(re,le,Ee){return ne.Promises.settled([Promise.all([re.extensionsPath,re.codeCachePath,re.logsPath,re.globalStorageHome.fsPath,re.workspaceStorageHome.fsPath,re.backupHome].map(ve=>ve?D.Promises.mkdir(ve,{recursive:!0}):void 0)),le.initialize(),Ee.init()])}async claimInstance(re,le,Ee,ve,be,Te){let ye;try{n.mark("code/willStartMainServer"),ye=await y.serve(le.mainIPCHandle),n.mark("code/didStartMainServer"),F.once(Ee.onWillShutdown)(()=>ye.dispose())}catch(we){if(we.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,be.nameLong,we),we;let Ie;try{Ie=await y.connect(le.mainIPCHandle,"main")}catch(Ue){if(!Te||E.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.showStartupWarningDialog(S.localize(0,null,be.nameShort),S.localize(1,null),be.nameLong),Ue;try{M.unlinkSync(le.mainIPCHandle)}catch(qe){throw re.warn("Could not delete obsolete instance handle",qe),qe}return this.claimInstance(re,le,Ee,ve,be,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ue="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw re.error(Ue),Ie.dispose(),new Error(Ue)}let Le;!le.args.wait&&!le.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog(S.localize(2,null,be.nameShort),S.localize(3,null),be.nameLong)},1e4));const Oe=k.ProxyChannel.toService(Ie.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return ve.invokeFunction(async()=>{const Ue=new K.DiagnosticsService(N.NullTelemetryService,be),qe=await Oe.getMainProcessInfo(),Je=await Oe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(qe,Je);throw console.log($e),new f.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(Oe,re),re.trace("Sending env to running instance..."),await Oe.start(le.args,process.env),Ie.dispose(),Le&&clearTimeout(Le),new f.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw re.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(re,le,Ee){if(Ee.code==="EACCES"||Ee.code==="EPERM"){const ve=O.coalesce([re.userDataPath,re.extensionsPath,y.XDG_RUNTIME_DIR]).map(be=>a.getPathLabel(be,re));this.showStartupWarningDialog(S.localize(4,null),S.localize(5,null,A.toErrorMessage(Ee),ve.join(`
`)),le)}}showStartupWarningDialog(re,le,Ee){g.dialog.showMessageBoxSync({title:Ee,type:"warning",buttons:[a.mnemonicButtonLabel(S.localize(6,null))],message:re,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(re,le){if(E.isWindows){const Ee=await re.getMainProcessId();le.trace("Sending some foreground love to the running instance:",Ee);try{(await new Promise((ve,be)=>{q(["windows-foreground-love"],ve,be)})).allowSetForegroundWindow(Ee)}catch(ve){le.error(ve)}}}quit(re,le){const Ee=re.get(I.ILogService),ve=re.get(b.ILifecycleMainService);let be=0;le&&(le.isExpected?le.message&&Ee.trace(le.message):(be=1,le.stack?Ee.error(le.stack):Ee.error(`Startup error: ${le.toString()}`))),ve.kill(be)}resolveArgs(){const re=this.validatePaths(v.parseMainProcessArgv(process.argv));if(re.wait&&!re.waitMarkerFilePath){const le=i.createWaitMarkerFile(re.verbose);le&&(v.addArg(process.argv,"--waitMarkerFilePath",le),re.waitMarkerFilePath=le)}return re}validatePaths(re){if(re["open-url"]&&(re._urls=re._,re._=[]),!re.remote){const le=this.doValidatePaths(re._,re.goto);re._=le}return re}doValidatePaths(re,le){const Ee=Y.cwd(),ve=re.map(ye=>{let we=String(ye),Ie;le&&(Ie=B.parseLineAndColumnAware(we),we=Ie.path),we&&(we=this.preparePath(Ee,we));const Le=B.sanitizeFilePath(we,Ee),Oe=R.basename(Le);return Oe&&!B.isValidBasename(Oe)?null:le&&Ie?(Ie.path=Le,this.toPath(Ie)):Le}),be=E.isWindows||E.isMacintosh,Te=O.distinct(ve,ye=>ye&&be?ye.toLowerCase():ye||"");return O.coalesce(Te)}preparePath(re,le){return E.isWindows&&(le=T.rtrim(le,'"')),le=T.trim(T.trim(le," "),"	"),E.isWindows&&(le=R.resolve(re,le),le=T.rtrim(le,".")),le}toPath(re){const le=[re.path];return typeof re.line=="number"&&le.push(String(re.line)),typeof re.column=="number"&&le.push(String(re.column)),le.join(":")}}new se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cc528230987ce3ac61fc4f094ae247d5ff24db3c/core/vs/code/electron-main/main.js.map
