/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Q=function($){for(var t=[],m=0,F=$.length;m<F;m++)t[m]=J[$[m]];return t};define(J[57],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(F,I){if(!F)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}t.ok=m}),define(J[44],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(O){return(C,f,g)=>{let w=null,E=null;if(typeof g.value=="function"?(w="value",E=g.value):typeof g.get=="function"&&(w="get",E=g.get),!E)throw new Error("not supported");g[w]=O(E,f)}}t.createDecorator=m;function F(O,C,f){let g=null,w=null;if(typeof f.value=="function"?(g="value",w=f.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(g="get",w=f.get),!w)throw new Error("not supported");const E=`$memoize$${C}`;f[g]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,b)}),this[E]}}t.memoize=F;function I(O,C,f){return m((g,w)=>{const E=`$debounce$${w}`,b=`$debounce$result$${w}`;return function(...k){this[b]||(this[b]=f?f():void 0),clearTimeout(this[E]),C&&(this[b]=C(this[b],...k),k=[this[b]]),this[E]=setTimeout(()=>{g.apply(this,k),this[b]=f?f():void 0},O)}})}t.debounce=I;function T(O,C,f){return m((g,w)=>{const E=`$throttle$timer$${w}`,b=`$throttle$result$${w}`,k=`$throttle$lastRun$${w}`,c=`$throttle$pending$${w}`;return function(...d){if(this[b]||(this[b]=f?f():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),C&&(this[b]=C(this[b],...d)),this[c])return;const S=this[k]+O;S<=Date.now()?(this[k]=Date.now(),g.apply(this,[this[b]]),this[b]=f?f():void 0):(this[c]=!0,this[E]=setTimeout(()=>{this[c]=!1,this[k]=Date.now(),g.apply(this,[this[b]]),this[b]=f?f():void 0},S-Date.now()))}})}t.throttle=T}),define(J[22],Q([0,1,12]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filterSortedByKey=t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function F(a,l=0){return a[a.length-(1+l)]}t.tail=F;function I(a){if(a.length===0)throw new Error("Invalid tail call");return[a.slice(0,a.length-1),a[a.length-1]]}t.tail2=I;function T(a,l,h=(v,L)=>v===L){if(a===l)return!0;if(!a||!l||a.length!==l.length)return!1;for(let v=0,L=a.length;v<L;v++)if(!h(a[v],l[v]))return!1;return!0}t.equals=T;function O(a,l,h){let v=0,L=a.length-1;for(;v<=L;){const N=(v+L)/2|0,U=h(a[N],l);if(U<0)v=N+1;else if(U>0)L=N-1;else return N}return-(v+1)}t.binarySearch=O;function C(a,l){let h=0,v=a.length;if(v===0)return 0;for(;h<v;){const L=Math.floor((h+v)/2);l(a[L])?v=L:h=L+1}return h}t.findFirstInSorted=C;function f(a,l,h){if(a=a|0,a>=l.length)throw new TypeError("invalid index");let v=l[Math.floor(l.length*Math.random())],L=[],N=[],U=[];for(let j of l){const B=h(j,v);B<0?L.push(j):B>0?N.push(j):U.push(j)}return a<L.length?f(a,L,h):a<L.length+U.length?U[0]:f(a-(L.length+U.length),N,h)}t.quickSelect=f;function g(a,l){const h=[];let v;for(const L of a.slice(0).sort(l))!v||l(v[0],L)!==0?(v=[L],h.push(v)):v.push(L);return h}t.groupBy=g;function w(a,l,h){const v=[];function L(j,B,W){if(B===0&&W.length===0)return;const H=v[v.length-1];H&&H.start+H.deleteCount===j?(H.deleteCount+=B,H.toInsert.push(...W)):v.push({start:j,deleteCount:B,toInsert:W})}let N=0,U=0;for(;;){if(N===a.length){L(N,0,l.slice(U));break}if(U===l.length){L(N,a.length-N,[]);break}const j=a[N],B=l[U],W=h(j,B);W===0?(N+=1,U+=1):W<0?(L(N,1,[]),N+=1):W>0&&(L(N,0,[B]),U+=1)}return v}t.sortedDiff=w;function E(a,l,h){const v=w(a,l,h),L=[],N=[];for(const U of v)L.push(...a.slice(U.start,U.start+U.deleteCount)),N.push(...U.toInsert);return{removed:L,added:N}}t.delta=E;function b(a,l,h){if(h===0)return[];const v=a.slice(0,h).sort(l);return c(a,l,v,h,a.length),v}t.top=b;function k(a,l,h,v,L){return h===0?Promise.resolve([]):new Promise((N,U)=>{(async()=>{const j=a.length,B=a.slice(0,h).sort(l);for(let W=h,H=Math.min(h+v,j);W<j;W=H,H=Math.min(H+v,j)){if(W>h&&await new Promise(Y=>setTimeout(Y)),L&&L.isCancellationRequested)throw m.canceled();c(a,l,B,W,H)}return B})().then(N,U)})}t.topAsync=k;function c(a,l,h,v,L){for(const N=h.length;v<L;v++){const U=a[v];if(l(U,h[N-1])<0){h.pop();const j=C(h,B=>l(U,B)<0);h.splice(j,0,U)}}}function d(a){return a.filter(l=>!!l)}t.coalesce=d;function S(a){let l=0;for(let h=0;h<a.length;h++)a[h]&&(a[l]=a[h],l+=1);a.length=l}t.coalesceInPlace=S;function R(a,l,h){a.splice(h,0,a.splice(l,1)[0])}t.move=R;function D(a){return!Array.isArray(a)||a.length===0}t.isFalsyOrEmpty=D;function p(a){return Array.isArray(a)&&a.length>0}t.isNonEmptyArray=p;function r(a,l){if(!l)return a.filter((v,L)=>a.indexOf(v)===L);const h=Object.create(null);return a.filter(v=>{const L=l(v);return h[L]?!1:(h[L]=!0,!0)})}t.distinct=r;function o(a){const l=new Set;return a.filter(h=>l.has(h)?!1:(l.add(h),!0))}t.distinctES6=o;function e(a){const l=Object.create(null);return h=>{const v=a(h);return l[v]?!1:(l[v]=!0,!0)}}t.uniqueFilter=e;function i(a,l){for(let h=a.length-1;h>=0;h--){const v=a[h];if(l(v))return h}return-1}t.lastIndex=i;function n(a,l){return a.length>0?a[0]:l}t.firstOrDefault=n;function s(a,l,h=(v,L)=>v===L){let v=0;for(let L=0,N=Math.min(a.length,l.length);L<N&&h(a[L],l[L]);L++)v++;return v}t.commonPrefixLength=s;function u(a){return[].concat(...a)}t.flatten=u;function y(a,l){let h=typeof l=="number"?a:0;typeof l=="number"?h=a:(h=0,l=a);const v=[];if(h<=l)for(let L=h;L<l;L++)v.push(L);else for(let L=h;L>l;L--)v.push(L);return v}t.range=y;function P(a,l,h){return a.reduce((v,L)=>(v[l(L)]=h?h(L):L,v),Object.create(null))}t.index=P;function z(a,l){return a.push(l),()=>A(a,l)}t.insert=z;function A(a,l){const h=a.indexOf(l);if(h>-1)return a.splice(h,1),l}t.remove=A;function M(a,l,h){const v=a.slice(0,l),L=a.slice(l);return v.concat(h,L)}t.arrayInsert=M;function V(a,l){let h;if(typeof l=="number"){let v=l;h=()=>{const L=Math.sin(v++)*179426549;return L-Math.floor(L)}}else h=Math.random;for(let v=a.length-1;v>0;v-=1){const L=Math.floor(h()*(v+1)),N=a[v];a[v]=a[L],a[L]=N}}t.shuffle=V;function _(a,l){const h=a.indexOf(l);h>-1&&(a.splice(h,1),a.unshift(l))}t.pushToStart=_;function X(a,l){const h=a.indexOf(l);h>-1&&(a.splice(h,1),a.push(l))}t.pushToEnd=X;function ee(a,l){return Array.isArray(a)?a.map(l):l(a)}t.mapArrayOrNot=ee;function ie(a){return Array.isArray(a)?a:[a]}t.asArray=ie;function Z(a){return a[Math.floor(Math.random()*a.length)]}t.getRandomElement=Z;function oe(a,l){for(const h of a){const v=l(h);if(v!==void 0)return v}}t.mapFind=oe;function se(a,l){let h=Number.MAX_SAFE_INTEGER,v=0;return a.forEach((L,N)=>{const U=l(L);U<h&&(h=U,v=N)}),v}t.minIndex=se;function re(a,l){let h=Number.MIN_SAFE_INTEGER,v=0;return a.forEach((L,N)=>{const U=l(L);U>h&&(h=U,v=N)}),v}t.maxIndex=re;function K(a,l,h,v=h){const L=C(a,U=>h<=l(U)),N=C(a,U=>v<l(U));return L===N?null:a.slice(L,N)}t.filterSortedByKey=K}),define(J[58],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var F;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(F=t.SyntaxKind||(t.SyntaxKind={}));var I;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(I=t.ParseErrorCode||(t.ParseErrorCode={}));var T;(function(e){e.DEFAULT={allowTrailingComma:!0}})(T=t.ParseOptions||(t.ParseOptions={}));function O(e,i=!1){let n=0,s=e.length,u="",y=0,P=16,z=0;function A(Z){let oe=0,se=0;for(;oe<Z;){const re=e.charCodeAt(n);if(re>=48&&re<=57)se=se*16+re-48;else if(re>=65&&re<=70)se=se*16+re-65+10;else if(re>=97&&re<=102)se=se*16+re-97+10;else break;n++,oe++}return oe<Z&&(se=-1),se}function M(Z){n=Z,u="",y=0,P=16,z=0}function V(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&g(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&g(e.charCodeAt(n)))for(n++;n<e.length&&g(e.charCodeAt(n));)n++;else return z=3,e.substring(Z,n);let oe=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&g(e.charCodeAt(n))){for(n++;n<e.length&&g(e.charCodeAt(n));)n++;oe=n}else z=3;return e.substring(Z,oe)}function _(){let Z="",oe=n;for(;;){if(n>=s){Z+=e.substring(oe,n),z=2;break}const se=e.charCodeAt(n);if(se===34){Z+=e.substring(oe,n),n++;break}if(se===92){if(Z+=e.substring(oe,n),n++,n>=s){z=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const K=A(4);K>=0?Z+=String.fromCharCode(K):z=4;break;default:z=5}oe=n;continue}if(se>=0&&se<=31)if(f(se)){Z+=e.substring(oe,n),z=2;break}else z=6;n++}return Z}function X(){if(u="",z=0,y=n,n>=s)return y=s,P=17;let Z=e.charCodeAt(n);if(C(Z)){do n++,u+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(C(Z));return P=15}if(f(Z))return n++,u+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,u+=`
`),P=14;switch(Z){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,u=_(),P=10;case 47:const oe=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!f(e.charCodeAt(n));)n++;return u=e.substring(oe,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const se=s-1;let re=!1;for(;n<se;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,re=!0;break}n++}return re||(n++,z=1),u=e.substring(oe,n),P=13}return u+=String.fromCharCode(Z),n++,P=16;case 45:if(u+=String.fromCharCode(Z),n++,n===s||!g(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=V(),P=11;default:for(;n<s&&ee(Z);)n++,Z=e.charCodeAt(n);if(y!==n){switch(u=e.substring(y,n),u){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return u+=String.fromCharCode(Z),n++,P=16}}function ee(Z){if(C(Z)||f(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let Z;do Z=X();while(Z>=12&&Z<=15);return Z}return{setPosition:M,getPosition:()=>n,scan:i?ie:X,getToken:()=>P,getTokenValue:()=>u,getTokenOffset:()=>y,getTokenLength:()=>n-y,getTokenError:()=>z}}t.createScanner=O;function C(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function f(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var w;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(w||(w={}));function E(e,i){const n=[],s=new Object;let u;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function z(A,M,V,_){y.value=A,y.offset=M,y.length=V,y.type=_,y.colonOffset=void 0,u=y}try{p(e,{onObjectBegin:(A,M)=>{if(i<=A)throw s;u=void 0,P=i>A,n.push("")},onObjectProperty:(A,M,V)=>{if(i<M||(z(A,M,V,"property"),n[n.length-1]=A,i<=M+V))throw s},onObjectEnd:(A,M)=>{if(i<=A)throw s;u=void 0,n.pop()},onArrayBegin:(A,M)=>{if(i<=A)throw s;u=void 0,n.push(0)},onArrayEnd:(A,M)=>{if(i<=A)throw s;u=void 0,n.pop()},onLiteralValue:(A,M,V)=>{if(i<M||(z(A,M,V,o(A)),i<=M+V))throw s},onSeparator:(A,M,V)=>{if(i<=M)throw s;if(A===":"&&u&&u.type==="property")u.colonOffset=M,P=!1,u=void 0;else if(A===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(P=!0,n[n.length-1]=""),u=void 0}}})}catch(A){if(A!==s)throw A}return{path:n,previousNode:u,isAtPropertyKey:P,matches:A=>{let M=0;for(let V=0;M<A.length&&V<n.length;V++)if(A[M]===n[V]||A[M]==="*")M++;else if(A[M]!=="**")return!1;return M===A.length}}}t.getLocation=E;function b(e,i=[],n=T.DEFAULT){let s=null,u=[];const y=[];function P(A){Array.isArray(u)?u.push(A):s!==null&&(u[s]=A)}return p(e,{onObjectBegin:()=>{const A={};P(A),y.push(u),u=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{u=y.pop()},onArrayBegin:()=>{const A=[];P(A),y.push(u),u=A,s=null},onArrayEnd:()=>{u=y.pop()},onLiteralValue:P,onError:(A,M,V)=>{i.push({error:A,offset:M,length:V})}},n),u[0]}t.parse=b;function k(e,i=[],n=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(A){s.type==="property"&&(s.length=A-s.offset,s=s.parent)}function y(A){return s.children.push(A),A}p(e,{onObjectBegin:A=>{s=y({type:"object",offset:A,length:-1,parent:s,children:[]})},onObjectProperty:(A,M,V)=>{s=y({type:"property",offset:M,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:A,offset:M,length:V,parent:s})},onObjectEnd:(A,M)=>{s.length=A+M-s.offset,s=s.parent,u(A+M)},onArrayBegin:(A,M)=>{s=y({type:"array",offset:A,length:-1,parent:s,children:[]})},onArrayEnd:(A,M)=>{s.length=A+M-s.offset,s=s.parent,u(A+M)},onLiteralValue:(A,M,V)=>{y({type:o(A),offset:M,length:V,parent:s,value:A}),u(M+V)},onSeparator:(A,M,V)=>{s.type==="property"&&(A===":"?s.colonOffset=M:A===","&&u(M))},onError:(A,M,V)=>{i.push({error:A,offset:M,length:V})}},n);const z=s.children[0];return z&&delete z.parent,z}t.parseTree=k;function c(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const y of n.children)if(Array.isArray(y.children)&&y.children[0].value===s){n=y.children[1],u=!0;break}if(!u)return}else{const u=s;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}t.findNodeAtLocation=c;function d(e){if(!e.parent||!e.parent.children)return[];const i=d(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=d;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=S(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function R(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=R;function D(e,i,n=!1){if(R(e,i,n)){const s=e.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=i;u++){const y=D(s[u],i,n);if(y)return y}return e}}t.findNodeAtOffset=D;function p(e,i,n=T.DEFAULT){const s=O(e,!1);function u(N){return N?()=>N(s.getTokenOffset(),s.getTokenLength()):()=>!0}function y(N){return N?U=>N(U,s.getTokenOffset(),s.getTokenLength()):()=>!0}const P=u(i.onObjectBegin),z=y(i.onObjectProperty),A=u(i.onObjectEnd),M=u(i.onArrayBegin),V=u(i.onArrayEnd),_=y(i.onLiteralValue),X=y(i.onSeparator),ee=u(i.onComment),ie=y(i.onError),Z=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function se(){for(;;){const N=s.scan();switch(s.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:Z||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(N){case 12:case 13:Z?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return N}}}function re(N,U=[],j=[]){if(ie(N),U.length+j.length>0){let B=s.getToken();for(;B!==17;){if(U.indexOf(B)!==-1){se();break}else if(j.indexOf(B)!==-1)break;B=se()}}}function K(N){const U=s.getTokenValue();return N?_(U):z(U),se(),!0}function a(){switch(s.getToken()){case 11:let N=0;try{N=JSON.parse(s.getTokenValue()),typeof N!="number"&&(re(2),N=0)}catch(U){re(2)}_(N);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return se(),!0}function l(){return s.getToken()!==10?(re(3,[],[2,5]),!1):(K(!1),s.getToken()===6?(X(":"),se(),L()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function h(){P(),se();let N=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(N||re(4,[],[]),X(","),se(),s.getToken()===2&&oe)break}else N&&re(6,[],[]);l()||re(4,[],[2,5]),N=!0}return A(),s.getToken()!==2?re(7,[2],[]):se(),!0}function v(){M(),se();let N=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(N||re(4,[],[]),X(","),se(),s.getToken()===4&&oe)break}else N&&re(6,[],[]);L()||re(4,[],[4,5]),N=!0}return V(),s.getToken()!==4?re(8,[4],[]):se(),!0}function L(){switch(s.getToken()){case 3:return v();case 1:return h();case 10:return K(!0);default:return a()}}return se(),s.getToken()===17?n.allowEmptyContent?!0:(re(4,[],[]),!1):L()?(s.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}t.visit=p;function r(e,i){let n=O(e),s=[],u,y=0,P;do switch(P=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:y!==P&&s.push(e.substring(y,P)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),y=n.getPosition();break}while(u!==17);return s.join("")}t.stripComments=r;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function $(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function O(f){T.push(f,Date.now())}function C(){const f=[];for(let g=0;g<T.length;g+=2)f.push({name:T[g],startTime:T[g+1]});return f}return{mark:O,getMarks:C}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const O of performance.getEntriesByType("mark"))T.push({name:O.name,startTime:Math.round(I+O.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function m(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=t()),I.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=m(F))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var F in m)(typeof exports=="object"?exports:$)[F]=m[F]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function m(F){if(t[F])return t[F].exports;var I=t[F]={i:F,l:!1,exports:{}};return $[F].call(I.exports,I,I.exports,m),I.l=!0,I.exports}return m.m=$,m.c=t,m.d=function(F,I,T){m.o(F,I)||Object.defineProperty(F,I,{enumerable:!0,get:T})},m.r=function(F){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},m.t=function(F,I){if(1&I&&(F=m(F)),8&I||4&I&&typeof F=="object"&&F&&F.__esModule)return F;var T=Object.create(null);if(m.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:F}),2&I&&typeof F!="string")for(var O in F)m.d(T,O,function(C){return F[C]}.bind(null,O));return T},m.n=function(F){var I=F&&F.__esModule?function(){return F.default}:function(){return F};return m.d(I,"a",I),I},m.o=function(F,I){return Object.prototype.hasOwnProperty.call(F,I)},m.p="",m(m.s=0)}([function($,t,m){(function(F){var I;t=$.exports=j,I=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var T=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,C=t.re=[],f=t.src=[],g=0,w=g++;f[w]="0|[1-9]\\d*";var E=g++;f[E]="[0-9]+";var b=g++;f[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=g++;f[k]="("+f[w]+")\\.("+f[w]+")\\.("+f[w]+")";var c=g++;f[c]="("+f[E]+")\\.("+f[E]+")\\.("+f[E]+")";var d=g++;f[d]="(?:"+f[w]+"|"+f[b]+")";var S=g++;f[S]="(?:"+f[E]+"|"+f[b]+")";var R=g++;f[R]="(?:-("+f[d]+"(?:\\."+f[d]+")*))";var D=g++;f[D]="(?:-?("+f[S]+"(?:\\."+f[S]+")*))";var p=g++;f[p]="[0-9A-Za-z-]+";var r=g++;f[r]="(?:\\+("+f[p]+"(?:\\."+f[p]+")*))";var o=g++,e="v?"+f[k]+f[R]+"?"+f[r]+"?";f[o]="^"+e+"$";var i="[v=\\s]*"+f[c]+f[D]+"?"+f[r]+"?",n=g++;f[n]="^"+i+"$";var s=g++;f[s]="((?:<|>)?=?)";var u=g++;f[u]=f[E]+"|x|X|\\*";var y=g++;f[y]=f[w]+"|x|X|\\*";var P=g++;f[P]="[v=\\s]*("+f[y]+")(?:\\.("+f[y]+")(?:\\.("+f[y]+")(?:"+f[R]+")?"+f[r]+"?)?)?";var z=g++;f[z]="[v=\\s]*("+f[u]+")(?:\\.("+f[u]+")(?:\\.("+f[u]+")(?:"+f[D]+")?"+f[r]+"?)?)?";var A=g++;f[A]="^"+f[s]+"\\s*"+f[P]+"$";var M=g++;f[M]="^"+f[s]+"\\s*"+f[z]+"$";var V=g++;f[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=g++;f[_]="(?:~>?)";var X=g++;f[X]="(\\s*)"+f[_]+"\\s+",C[X]=new RegExp(f[X],"g");var ee=g++;f[ee]="^"+f[_]+f[P]+"$";var ie=g++;f[ie]="^"+f[_]+f[z]+"$";var Z=g++;f[Z]="(?:\\^)";var oe=g++;f[oe]="(\\s*)"+f[Z]+"\\s+",C[oe]=new RegExp(f[oe],"g");var se=g++;f[se]="^"+f[Z]+f[P]+"$";var re=g++;f[re]="^"+f[Z]+f[z]+"$";var K=g++;f[K]="^"+f[s]+"\\s*("+i+")$|^$";var a=g++;f[a]="^"+f[s]+"\\s*("+e+")$|^$";var l=g++;f[l]="(\\s*)"+f[s]+"\\s*("+i+"|"+f[P]+")",C[l]=new RegExp(f[l],"g");var h=g++;f[h]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var v=g++;f[v]="^\\s*("+f[z]+")\\s+-\\s+("+f[z]+")\\s*$";var L=g++;f[L]="(<|>)?=?\\s*\\*";for(var N=0;N<35;N++)I(N,f[N]),C[N]||(C[N]=new RegExp(f[N]));function U(x,q){if(x instanceof j)return x;if(typeof x!="string"||x.length>T||!(q?C[n]:C[o]).test(x))return null;try{return new j(x,q)}catch(G){return null}}function j(x,q){if(x instanceof j){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof j))return new j(x,q);I("SemVer",x,q),this.loose=q;var G=x.trim().match(q?C[n]:C[o]);if(!G)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var le=+ne;if(le>=0&&le<O)return le}return ne}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}t.parse=U,t.valid=function(x,q){var G=U(x,q);return G?G.version:null},t.clean=function(x,q){var G=U(x.trim().replace(/^[=v]+/,""),q);return G?G.version:null},t.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof j||(x=new j(x,this.loose)),this.compareMain(x)||this.comparePre(x)},j.prototype.compareMain=function(x){return x instanceof j||(x=new j(x,this.loose)),W(this.major,x.major)||W(this.minor,x.minor)||W(this.patch,x.patch)},j.prototype.comparePre=function(x){if(x instanceof j||(x=new j(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var G=this.prerelease[q],ne=x.prerelease[q];if(I("prerelease compare",q,G,ne),G===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(G===void 0)return-1;if(G!==ne)return W(G,ne)}while(++q)},j.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,q,G,ne){typeof G=="string"&&(ne=G,G=void 0);try{return new j(x,G).inc(q,ne).version}catch(le){return null}},t.diff=function(x,q){if(ae(x,q))return null;var G=U(x),ne=U(q);if(G.prerelease.length||ne.prerelease.length){for(var le in G)if((le==="major"||le==="minor"||le==="patch")&&G[le]!==ne[le])return"pre"+le;return"prerelease"}for(var le in G)if((le==="major"||le==="minor"||le==="patch")&&G[le]!==ne[le])return le},t.compareIdentifiers=W;var B=/^[0-9]+$/;function W(x,q){var G=B.test(x),ne=B.test(q);return G&&ne&&(x=+x,q=+q),G&&!ne?-1:ne&&!G?1:x<q?-1:x>q?1:0}function H(x,q,G){return new j(x,G).compare(new j(q,G))}function Y(x,q,G){return H(x,q,G)>0}function te(x,q,G){return H(x,q,G)<0}function ae(x,q,G){return H(x,q,G)===0}function me(x,q,G){return H(x,q,G)!==0}function ve(x,q,G){return H(x,q,G)>=0}function Oe(x,q,G){return H(x,q,G)<=0}function Te(x,q,G,ne){var le;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof G=="object"&&(G=G.version),le=x===G;break;case"!==":typeof x=="object"&&(x=x.version),typeof G=="object"&&(G=G.version),le=x!==G;break;case"":case"=":case"==":le=ae(x,G,ne);break;case"!=":le=me(x,G,ne);break;case">":le=Y(x,G,ne);break;case">=":le=ve(x,G,ne);break;case"<":le=te(x,G,ne);break;case"<=":le=Oe(x,G,ne);break;default:throw new TypeError("Invalid operator: "+q)}return le}function Se(x,q){if(x instanceof Se){if(x.loose===q)return x;x=x.value}if(!(this instanceof Se))return new Se(x,q);I("comparator",x,q),this.loose=q,this.parse(x),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}t.rcompareIdentifiers=function(x,q){return W(q,x)},t.major=function(x,q){return new j(x,q).major},t.minor=function(x,q){return new j(x,q).minor},t.patch=function(x,q){return new j(x,q).patch},t.compare=H,t.compareLoose=function(x,q){return H(x,q,!0)},t.rcompare=function(x,q,G){return H(q,x,G)},t.sort=function(x,q){return x.sort(function(G,ne){return t.compare(G,ne,q)})},t.rsort=function(x,q){return x.sort(function(G,ne){return t.rcompare(G,ne,q)})},t.gt=Y,t.lt=te,t.eq=ae,t.neq=me,t.gte=ve,t.lte=Oe,t.cmp=Te,t.Comparator=Se;var Ae={};function ye(x,q){if(x instanceof ye)return x.loose===q?x:new ye(x.raw,q);if(x instanceof Se)return new ye(x.value,q);if(!(this instanceof ye))return new ye(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Le(x){return!x||x.toLowerCase()==="x"||x==="*"}function je(x,q,G,ne,le,be,de,Re,Ee,De,ke,we,Pe){return((q=Le(G)?"":Le(ne)?">="+G+".0.0":Le(le)?">="+G+"."+ne+".0":">="+q)+" "+(Re=Le(Ee)?"":Le(De)?"<"+(+Ee+1)+".0.0":Le(ke)?"<"+Ee+"."+(+De+1)+".0":we?"<="+Ee+"."+De+"."+ke+"-"+we:"<="+Re)).trim()}function Be(x,q){for(var G=0;G<x.length;G++)if(!x[G].test(q))return!1;if(q.prerelease.length){for(G=0;G<x.length;G++)if(I(x[G].semver),x[G].semver!==Ae&&x[G].semver.prerelease.length>0){var ne=x[G].semver;if(ne.major===q.major&&ne.minor===q.minor&&ne.patch===q.patch)return!0}return!1}return!0}function ze(x,q,G){try{q=new ye(q,G)}catch(ne){return!1}return q.test(x)}function xe(x,q,G,ne){var le,be,de,Re,Ee;switch(x=new j(x,ne),q=new ye(q,ne),G){case">":le=Y,be=Oe,de=te,Re=">",Ee=">=";break;case"<":le=te,be=ve,de=Y,Re="<",Ee="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(x,q,ne))return!1;for(var De=0;De<q.set.length;++De){var ke=q.set[De],we=null,Pe=null;if(ke.forEach(function(Ce){Ce.semver===Ae&&(Ce=new Se(">=0.0.0")),we=we||Ce,Pe=Pe||Ce,le(Ce.semver,we.semver,ne)?we=Ce:de(Ce.semver,Pe.semver,ne)&&(Pe=Ce)}),we.operator===Re||we.operator===Ee||(!Pe.operator||Pe.operator===Re)&&be(x,Pe.semver)||Pe.operator===Ee&&de(x,Pe.semver))return!1}return!0}Se.prototype.parse=function(x){var q=this.loose?C[K]:C[a],G=x.match(q);if(!G)throw new TypeError("Invalid comparator: "+x);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new j(G[2],this.loose):this.semver=Ae},Se.prototype.toString=function(){return this.value},Se.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===Ae||(typeof x=="string"&&(x=new j(x,this.loose)),Te(x,this.operator,this.semver,this.loose))},Se.prototype.intersects=function(x,q){if(!(x instanceof Se))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new ye(x.value,q),ze(this.value,G,q);if(x.operator==="")return G=new ye(this.value,q),ze(x.semver,G,q);var ne=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),le=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),be=this.semver.version===x.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Re=Te(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ee=Te(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ne||le||be&&de||Re||Ee},t.Range=ye,ye.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ye.prototype.toString=function(){return this.range},ye.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),I("range",x,q);var G=q?C[v]:C[h];x=x.replace(G,je),I("hyphen replace",x),x=x.replace(C[l],"$1$2$3"),I("comparator trim",x,C[l]),x=(x=(x=x.replace(C[X],"$1~")).replace(C[oe],"$1^")).split(/\s+/).join(" ");var ne=q?C[K]:C[a],le=x.split(" ").map(function(be){return function(de,Re){return I("comp",de),de=function(Ee,De){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){I("caret",we,Pe);var Ce=Pe?C[re]:C[se];return we.replace(Ce,function(Fe,ce,he,ge,pe){var Ie;return I("caret",we,Fe,ce,he,ge,pe),Le(ce)?Ie="":Le(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Le(ge)?Ie=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":pe?(I("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+pe+" <"+(+ce+1)+".0.0"):(I("no pr"),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+" <"+(+ce+1)+".0.0"),I("caret return",Ie),Ie})}(ke,De)}).join(" ")}(de,Re),I("caret",de),de=function(Ee,De){return Ee.trim().split(/\s+/).map(function(ke){return function(we,Pe){var Ce=Pe?C[ie]:C[ee];return we.replace(Ce,function(Fe,ce,he,ge,pe){var Ie;return I("tilde",we,Fe,ce,he,ge,pe),Le(ce)?Ie="":Le(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Le(ge)?Ie=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":pe?(I("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=">="+ce+"."+he+"."+ge+pe+" <"+ce+"."+(+he+1)+".0"):Ie=">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0",I("tilde return",Ie),Ie})}(ke,De)}).join(" ")}(de,Re),I("tildes",de),de=function(Ee,De){return I("replaceXRanges",Ee,De),Ee.split(/\s+/).map(function(ke){return function(we,Pe){we=we.trim();var Ce=Pe?C[M]:C[A];return we.replace(Ce,function(Fe,ce,he,ge,pe,Ie){I("xRange",we,Fe,ce,he,ge,pe,Ie);var Ve=Le(he),Me=Ve||Le(ge),Ue=Me||Le(pe);return ce==="="&&Ue&&(ce=""),Ve?Fe=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(ge=0),Ue&&(pe=0),ce===">"?(ce=">=",Me?(he=+he+1,ge=0,pe=0):Ue&&(ge=+ge+1,pe=0)):ce==="<="&&(ce="<",Me?he=+he+1:ge=+ge+1),Fe=ce+he+"."+ge+"."+pe):Me?Fe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Fe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),I("xRange return",Fe),Fe})}(ke,De)}).join(" ")}(de,Re),I("xrange",de),de=function(Ee,De){return I("replaceStars",Ee,De),Ee.trim().replace(C[L],"")}(de,Re),I("stars",de),de}(be,q)}).join(" ").split(/\s+/);return this.loose&&(le=le.filter(function(be){return!!be.match(ne)})),le=le.map(function(be){return new Se(be,q)})},ye.prototype.intersects=function(x,q){if(!(x instanceof ye))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ne){return x.set.some(function(le){return le.every(function(be){return ne.intersects(be,q)})})})})},t.toComparators=function(x,q){return new ye(x,q).set.map(function(G){return G.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},ye.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new j(x,this.loose));for(var q=0;q<this.set.length;q++)if(Be(this.set[q],x))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(x,q,G){var ne=null,le=null;try{var be=new ye(q,G)}catch(de){return null}return x.forEach(function(de){be.test(de)&&(ne&&le.compare(de)!==-1||(le=new j(ne=de,G)))}),ne},t.minSatisfying=function(x,q,G){var ne=null,le=null;try{var be=new ye(q,G)}catch(de){return null}return x.forEach(function(de){be.test(de)&&(ne&&le.compare(de)!==1||(le=new j(ne=de,G)))}),ne},t.validRange=function(x,q){try{return new ye(x,q).range||"*"}catch(G){return null}},t.ltr=function(x,q,G){return xe(x,q,"<",G)},t.gtr=function(x,q,G){return xe(x,q,">",G)},t.outside=xe,t.prerelease=function(x,q){var G=U(x,q);return G&&G.prerelease.length?G.prerelease:null},t.intersects=function(x,q,G){return x=new ye(x,G),q=new ye(q,G),x.intersects(q)},t.coerce=function(x){if(x instanceof j)return x;if(typeof x!="string")return null;var q=x.match(C[V]);return q==null?null:U((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,m(1))},function($,t){var m,F,I=$.exports={};function T(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function C(S){if(m===setTimeout)return setTimeout(S,0);if((m===T||!m)&&setTimeout)return m=setTimeout,setTimeout(S,0);try{return m(S,0)}catch(R){try{return m.call(null,S,0)}catch(D){return m.call(this,S,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:T}catch(S){m=T}try{F=typeof clearTimeout=="function"?clearTimeout:O}catch(S){F=O}})();var f,g=[],w=!1,E=-1;function b(){w&&f&&(w=!1,f.length?g=f.concat(g):E=-1,g.length&&k())}function k(){if(!w){var S=C(b);w=!0;for(var R=g.length;R;){for(f=g,g=[];++E<R;)f&&f[E].run();E=-1,R=g.length}f=null,w=!1,function(D){if(F===clearTimeout)return clearTimeout(D);if((F===O||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(D);try{F(D)}catch(p){try{return F.call(null,D)}catch(r){return F.call(this,D)}}}(S)}}function c(S,R){this.fun=S,this.array=R}function d(){}I.nextTick=function(S){var R=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)R[D-1]=arguments[D];g.push(new c(S,R)),g.length!==1||w||C(k)},c.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(J[34],Q([0,1,12,2]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function I(p){const r=p;return r?[r.on,r.pause,r.resume,r.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=I;function T(p){const r=p;return r?I(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=T;function O(p,r){return new C(p,r)}t.newWriteableStream=O;class C{constructor(r,o){this.reducer=r,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(o=>o(r))}emitError(r){this.listeners.error.length===0?m.onUnexpectedError(r):this.listeners.error.slice(0).forEach(o=>o(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,o){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(r,o){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(p,r){const o=[];let e;for(;(e=p.read())!==null;)o.push(e);return r(o)}t.consumeReadable=f;function g(p,r,o){const e=[];let i;for(;(i=p.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return p.read()}}}t.peekReadable=g;function w(p,r){return new Promise((o,e)=>{const i=[];E(p,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):o(void 0)},onEnd:()=>{o(r?r(i):void 0)}})})}t.consumeStream=w;function E(p,r){p.on("error",o=>r.onError(o)),p.on("end",()=>r.onEnd()),p.on("data",o=>r.onData(o))}t.listenStream=E;function b(p,r){return new Promise((o,e)=>{const i=new F.DisposableStore,n=[],s=P=>{if(n.push(P),n.length>r)return i.dispose(),p.pause(),o({stream:p,buffer:n,ended:!1})},u=P=>e(P),y=()=>o({stream:p,buffer:n,ended:!0});i.add(F.toDisposable(()=>p.removeListener("error",u))),p.on("error",u),i.add(F.toDisposable(()=>p.removeListener("end",y))),p.on("end",y),i.add(F.toDisposable(()=>p.removeListener("data",s))),p.on("data",s)})}t.peekStream=b;function k(p,r){const o=O(r);return o.end(p),o}t.toStream=k;function c(){const p=O(()=>{throw new Error("not supported")});return p.end(),p}t.emptyStream=c;function d(p){let r=!1;return{read:()=>r?null:(r=!0,p)}}t.toReadable=d;function S(p,r,o){const e=O(o);return E(p,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=S;function R(p,r,o){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?o([p,i]):p)}}}t.prefixedReadable=R;function D(p,r,o){let e=!1;const i=O(o);return E(r,{onData:n=>e?i.write(n):(e=!0,i.write(o([p,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(p)),i.end()}}),i}t.prefixedStream=D}),define(J[16],Q([0,1,19,34]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let C,f;class g{constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}static alloc(P){return I?new g(Buffer.allocUnsafe(P)):new g(new Uint8Array(P))}static wrap(P){return I&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new g(P)}static fromString(P,z){return!(z?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(P)):T?(C||(C=new TextEncoder),new g(C.encode(P))):new g(m.encodeUTF8(P))}static concat(P,z){if(typeof z=="undefined"){z=0;for(let V=0,_=P.length;V<_;V++)z+=P[V].byteLength}const A=g.alloc(z);let M=0;for(let V=0,_=P.length;V<_;V++){const X=P[V];A.set(X,M),M+=X.byteLength}return A}toString(){return I?this.buffer.toString():O?(f||(f=new TextDecoder),f.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(P,z){return new g(this.buffer.subarray(P,z))}set(P,z){P instanceof g?this.buffer.set(P.buffer,z):this.buffer.set(P,z)}readUInt32BE(P){return b(this.buffer,P)}writeUInt32BE(P,z){k(this.buffer,P,z)}readUInt32LE(P){return c(this.buffer,P)}writeUInt32LE(P,z){d(this.buffer,P,z)}readUInt8(P){return S(this.buffer,P)}writeUInt8(P,z){R(this.buffer,P,z)}}t.VSBuffer=g;function w(y,P){return y[P+0]<<0>>>0|y[P+1]<<8>>>0}t.readUInt16LE=w;function E(y,P,z){y[z+0]=P&255,P=P>>>8,y[z+1]=P&255}t.writeUInt16LE=E;function b(y,P){return y[P]*2**24+y[P+1]*2**16+y[P+2]*2**8+y[P+3]}t.readUInt32BE=b;function k(y,P,z){y[z+3]=P,P=P>>>8,y[z+2]=P,P=P>>>8,y[z+1]=P,P=P>>>8,y[z]=P}t.writeUInt32BE=k;function c(y,P){return y[P+0]<<0>>>0|y[P+1]<<8>>>0|y[P+2]<<16>>>0|y[P+3]<<24>>>0}t.readUInt32LE=c;function d(y,P,z){y[z+0]=P&255,P=P>>>8,y[z+1]=P&255,P=P>>>8,y[z+2]=P&255,P=P>>>8,y[z+3]=P&255}t.writeUInt32LE=d;function S(y,P){return y[P]}t.readUInt8=S;function R(y,P,z){y[z]=P}t.writeUInt8=R;function D(y){return F.consumeReadable(y,P=>g.concat(P))}t.readableToBuffer=D;function p(y){return F.toReadable(y)}t.bufferToReadable=p;function r(y){return F.consumeStream(y,P=>g.concat(P))}t.streamToBuffer=r;async function o(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await r(y.stream)])}t.bufferedStreamToBuffer=o;function e(y){return F.toStream(y,P=>g.concat(P))}t.bufferToStream=e;function i(y){return F.transform(y,{data:P=>typeof P=="string"?g.fromString(P):g.wrap(P)},P=>g.concat(P))}t.streamToBufferReadableStream=i;function n(y){return F.newWriteableStream(P=>g.concat(P),y)}t.newWriteableBufferStream=n;function s(y,P){return F.prefixedReadable(y,P,z=>g.concat(z))}t.prefixedBufferReadable=s;function u(y,P){return F.prefixedStream(y,P,z=>g.concat(z))}t.prefixedBufferStream=u}),define(J[20],Q([0,1,13]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function F(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(R=>{d[R]&&typeof d[R]=="object"?S[R]=F(d[R]):S[R]=d[R]}),S}t.deepClone=F;function I(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const R=S.shift();Object.freeze(R);for(const D in R)if(T.call(R,D)){const p=R[D];typeof p=="object"&&!Object.isFrozen(p)&&S.push(p)}}return d}t.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function O(d,S){return C(d,S,new Set)}t.cloneAndChange=O;function C(d,S,R){if(m.isUndefinedOrNull(d))return d;const D=S(d);if(typeof D!="undefined")return D;if(m.isArray(d)){const p=[];for(const r of d)p.push(C(r,S,R));return p}if(m.isObject(d)){if(R.has(d))throw new Error("Cannot clone recursive data-structure");R.add(d);const p={};for(let r in d)T.call(d,r)&&(p[r]=C(d[r],S,R));return R.delete(d),p}return d}function f(d,S,R=!0){return m.isObject(d)?(m.isObject(S)&&Object.keys(S).forEach(D=>{D in d?R&&(m.isObject(d[D])&&m.isObject(S[D])?f(d[D],S[D],R):d[D]=S[D]):d[D]=S[D]}),d):S}t.mixin=f;function g(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let R,D;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(R=0;R<d.length;R++)if(!g(d[R],S[R]))return!1}else{const p=[];for(D in d)p.push(D);p.sort();const r=[];for(D in S)r.push(D);if(r.sort(),!g(p,r))return!1;for(R=0;R<p.length;R++)if(!g(d[p[R]],S[p[R]]))return!1}return!0}t.equals=g;function w(d){const S=new Set;return JSON.stringify(d,(R,D)=>{if(m.isObject(D)||Array.isArray(D)){if(S.has(D))return"[Circular]";S.add(D)}return D})}t.safeStringify=w;function E(d,S,R){const D=S(d);return typeof D=="undefined"?R:D}t.getOrDefault=E;function b(d,S){const R=Object.create(null);return!d||!S||Object.keys(S).forEach(p=>{const r=d[p],o=S[p];g(r,o)||(R[p]=o)}),R}t.distinct=b;function k(d,S){const R=S.toLowerCase(),D=Object.keys(d).find(p=>p.toLowerCase()===R);return D?d[D]:d[S]}t.getCaseInsensitive=k;function c(d,S){const R=Object.create(null);for(const D of Object.keys(d))S(D,d[D])&&(R[D]=d[D]);return R}t.filter=c}),define(J[59],Q([0,1,7]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function F(g){const w=g;return w&&typeof w.type=="string"&&typeof w.severity=="string"}t.isRemoteConsoleLog=F;function I(g){const w=[];let E;try{const b=JSON.parse(g.arguments),k=b[b.length-1];k&&k.__$stack&&(b.pop(),E=k.__$stack),w.push(...b)}catch(b){w.push("Unable to log remote console arguments",g.arguments)}return{args:w,stack:E}}t.parse=I;function T(g){if(typeof g!="string")return T(I(g).stack);const w=g;if(w){const E=O(w),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:m.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}t.getFirstFrame=T;function O(g){if(!g)return g;const w=g.indexOf(`
`);return w===-1?g:g.substring(0,w)}function C(g,w){const{args:E,stack:b}=I(g),k=typeof E[0]=="string"&&E.length===1;let c=O(b);c&&(c=`(${c.trim()})`);let d=[];if(typeof E[0]=="string"?c&&k?d=[`%c[${w}] %c${E[0]} %c${c}`,f("blue"),f(""),f("grey")]:d=[`%c[${w}] %c${E[0]}`,f("blue"),f(""),...E.slice(1)]:d=[`%c[${w}]%`,f("blue"),...E],c&&!k&&d.push(c),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,d)}t.log=C;function f(g){return`color: ${g}`}}),define(J[60],Q([0,1,16,19,7]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function T(w){return JSON.stringify(w,f)}t.stringify=T;function O(w){let E=JSON.parse(w);return E=g(E),E}t.parse=O;var C;(function(w){w[w.Uri=1]="Uri",w[w.Regexp=2]="Regexp",w[w.ScmResource=3]="ScmResource",w[w.ScmResourceGroup=4]="ScmResourceGroup",w[w.ScmProvider=5]="ScmProvider",w[w.CommentController=6]="CommentController",w[w.CommentThread=7]="CommentThread",w[w.CommentThreadReply=8]="CommentThreadReply",w[w.CommentNode=9]="CommentNode",w[w.CommentThreadNode=10]="CommentThreadNode",w[w.TimelineActionContext=11]="TimelineActionContext",w[w.NotebookCellActionContext=12]="NotebookCellActionContext",w[w.TestItemContext=13]="TestItemContext"})(C=t.MarshalledId||(t.MarshalledId={}));function f(w,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:F.regExpFlags(E)}:E}function g(w,E=0){if(!w||E>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return I.URI.revive(w);case 2:return new RegExp(w.source,w.flags)}if(w instanceof m.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let b=0;b<w.length;++b)w[b]=g(w[b],E+1);else for(const b in w)Object.hasOwnProperty.call(w,b)&&(w[b]=g(w[b],E+1))}return w}t.revive=g}),define(J[61],Q([0,1,19,35,3,45,4]),function($,t,m,F,I,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function C(){return Object.create(null)}t.getEmptyExpression=C;const f="**",g="/",w="[/\\\\]",E="[^/\\\\]",b=/\//g;function k(l){switch(l){case 0:return"";case 1:return`${E}*?`;default:return`(?:${w}|${E}+${w}|${w}${E}+)*?`}}function c(l,h){if(!l)return[];const v=[];let L=!1,N=!1,U="";for(const j of l){switch(j){case h:if(!L&&!N){v.push(U),U="";continue}break;case"{":L=!0;break;case"}":L=!1;break;case"[":N=!0;break;case"]":N=!1;break}U+=j}return U&&v.push(U),v}t.splitGlobAware=c;function d(l){if(!l)return"";let h="";const v=c(l,g);if(v.every(L=>L===f))h=".*";else{let L=!1;v.forEach((N,U)=>{if(N===f){L||(h+=k(2),L=!0);return}let j=!1,B="",W=!1,H="";for(const Y of N){if(Y!=="}"&&j){B+=Y;continue}if(W&&(Y!=="]"||!H)){let te;Y==="-"?te=Y:(Y==="^"||Y==="!")&&!H?te="^":Y===g?te="":te=m.escapeRegExpCharacters(Y),H+=te;continue}switch(Y){case"{":j=!0;continue;case"[":W=!0;continue;case"}":h+=`(?:${c(B,",").map(me=>d(me)).join("|")})`,j=!1,B="";break;case"]":h+="["+H+"]",W=!1,H="";break;case"?":h+=E;continue;case"*":h+=k(1);continue;default:h+=m.escapeRegExpCharacters(Y)}}U<v.length-1&&(v[U+1]!==f||U+2<v.length)&&(h+=w),L=!1})}return h}const S=/^\*\*\/\*\.[\w\.-]+$/,R=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new T.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(l,h){if(!l)return n;let v;typeof l!="string"?v=l.pattern:v=l,v=v.trim();const L=`${v}_${!!h.trimForExclusions}`;let N=e.get(L);if(N)return u(N,l);let U;if(S.test(v)){const j=v.substr(4);N=function(B,W){return typeof B=="string"&&B.endsWith(j)?v:null}}else(U=R.exec(y(v,h)))?N=P(U[1],v):(h.trimForExclusions?p:D).test(v)?N=z(v,h):(U=r.exec(y(v,h)))?N=A(U[1].substr(1),v,!0):(U=o.exec(y(v,h)))?N=A(U[1],v,!1):N=M(v);return e.set(L,N),u(N,l)}function u(l,h){return typeof h=="string"?l:function(v,L){return F.isEqualOrParent(v,h.base)?l(I.relative(h.base,v),L):null}}function y(l,h){return h.trimForExclusions&&l.endsWith("/**")?l.substr(0,l.length-2):l}function P(l,h){const v=`/${l}`,L=`\\${l}`,N=function(j,B){return typeof j!="string"?null:B?B===l?h:null:j===l||j.endsWith(v)||j.endsWith(L)?h:null},U=[l];return N.basenames=U,N.patterns=[h],N.allBasenames=U,N}function z(l,h){const v=a(l.slice(1,-1).split(",").map(B=>s(B,h)).filter(B=>B!==n),l),L=v.length;if(!L)return n;if(L===1)return v[0];const N=function(B,W){for(let H=0,Y=v.length;H<Y;H++)if(v[H](B,W))return l;return null},U=v.find(B=>!!B.allBasenames);U&&(N.allBasenames=U.allBasenames);const j=v.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return j.length&&(N.allPaths=j),N}function A(l,h,v){const L=I.sep===I.posix.sep,N=L?l:l.replace(b,I.sep),U=I.sep+N,j=I.posix.sep+l,B=v?function(W,H){return typeof W=="string"&&(W===N||W.endsWith(U)||!L&&(W===l||W.endsWith(j)))?h:null}:function(W,H){return typeof W=="string"&&(W===N||!L&&W===l)?h:null};return B.allPaths=[(v?"*/":"./")+l],B}function M(l){try{const h=new RegExp(`^${d(l)}$`);return function(v){return h.lastIndex=0,typeof v=="string"&&h.test(v)?l:null}}catch(h){return n}}function V(l,h,v){return!l||typeof h!="string"?!1:_(l)(h,void 0,v)}t.match=V;function _(l,h={}){if(!l)return i;if(typeof l=="string"||Z(l)){const v=s(l,h);if(v===n)return i;const L=function(N,U){return!!v(N,U)};return v.allBasenames&&(L.allBasenames=v.allBasenames),v.allPaths&&(L.allPaths=v.allPaths),L}return re(l,h)}t.parse=_;function X(l){if(!l)return;let h;return v=>(h||(h=(l()||Promise.resolve([])).then(L=>L?ie(L):{})),h.then(L=>!!L[v]))}t.hasSiblingPromiseFn=X;function ee(l){if(!l)return;let h;return v=>{if(!h){const L=l();h=L?ie(L):{}}return!!h[v]}}t.hasSiblingFn=ee;function ie(l){const h={};for(const v of l)h[v]=!0;return h}function Z(l){const h=l;return h&&typeof h.base=="string"&&typeof h.pattern=="string"}t.isRelativePattern=Z;function oe(l){return l.allBasenames||[]}t.getBasenameTerms=oe;function se(l){return l.allPaths||[]}t.getPathTerms=se;function re(l,h){const v=a(Object.getOwnPropertyNames(l).map(B=>K(B,l[B],h)).filter(B=>B!==n)),L=v.length;if(!L)return n;if(!v.some(B=>!!B.requiresSiblings)){if(L===1)return v[0];const B=function(Y,te){for(let ae=0,me=v.length;ae<me;ae++){const ve=v[ae](Y,te);if(ve)return ve}return null},W=v.find(Y=>!!Y.allBasenames);W&&(B.allBasenames=W.allBasenames);const H=v.reduce((Y,te)=>te.allPaths?Y.concat(te.allPaths):Y,[]);return H.length&&(B.allPaths=H),B}const N=function(B,W,H){let Y;for(let te=0,ae=v.length;te<ae;te++){const me=v[te];me.requiresSiblings&&H&&(W||(W=I.basename(B)),Y||(Y=W.substr(0,W.length-I.extname(B).length)));const ve=me(B,W,Y,H);if(ve)return ve}return null},U=v.find(B=>!!B.allBasenames);U&&(N.allBasenames=U.allBasenames);const j=v.reduce((B,W)=>W.allPaths?B.concat(W.allPaths):B,[]);return j.length&&(N.allPaths=j),N}function K(l,h,v){if(h===!1)return n;const L=s(l,v);if(L===n)return n;if(typeof h=="boolean")return L;if(h){const N=h.when;if(typeof N=="string"){const U=(j,B,W,H)=>{if(!H||!L(j,B))return null;const Y=N.replace("$(basename)",W),te=H(Y);return O.isThenable(te)?te.then(ae=>ae?l:null):te?l:null};return U.requiresSiblings=!0,U}}return L}function a(l,h){const v=l.filter(B=>!!B.basenames);if(v.length<2)return l;const L=v.reduce((B,W)=>{const H=W.basenames;return H?B.concat(H):B},[]);let N;if(h){N=[];for(let B=0,W=L.length;B<W;B++)N.push(h)}else N=v.reduce((B,W)=>{const H=W.patterns;return H?B.concat(H):B},[]);const U=function(B,W){if(typeof B!="string")return null;if(!W){let Y;for(Y=B.length;Y>0;Y--){const te=B.charCodeAt(Y-1);if(te===47||te===92)break}W=B.substr(Y)}const H=L.indexOf(W);return H!==-1?N[H]:null};U.basenames=L,U.patterns=N,U.allBasenames=L;const j=l.filter(B=>!B.basenames);return j.push(U),j}}),define(J[62],Q([0,1,7,3,19,8,14,17,35]),function($,t,m,F,I,T,O,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(s,u,y){if(typeof s=="string"&&(s=m.URI.file(s)),y){const z=y.getWorkspaceFolder(s);if(z){const A=y.getWorkspace().folders.length>1;let M;if(C.isEqual(z.uri,s)?M="":M=C.relativePath(z.uri,s),A){const V=z.name?z.name:C.basename(z.uri);M=M?V+" \u2022 "+M:V}return M}}if(s.scheme!==T.Schemas.file&&s.scheme!==T.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(f.hasDriveLetter(s.fsPath))return F.normalize(E(s.fsPath));let P=F.normalize(s.fsPath);return!O.isWindows&&u?.userHome&&(P=k(P,u.userHome.fsPath)),P}t.getPathLabel=g;function w(s){if(!s)return;typeof s=="string"&&(s=m.URI.file(s));const u=C.basename(s)||(s.scheme===T.Schemas.file?s.fsPath:s.path);return O.isWindows&&f.isRootOrDriveLetter(u)?E(u):u}t.getBaseLabel=w;function E(s){return f.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=E;let b=Object.create(null);function k(s,u){if(O.isWindows||!s||!u)return s;let y=b.original===u?b.normalized:void 0;return y||(y=`${I.rtrim(u,F.posix.sep)}${F.posix.sep}`,b={original:u,normalized:y}),(O.isLinux?s.startsWith(y):I.startsWithIgnoreCase(s,y))&&(s=`~/${s.substr(y.length)}`),s}t.tildify=k;function c(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}t.untildify=c;const d="\u2026",S="\\\\",R="~";function D(s,u=F.sep){const y=new Array(s.length);let P=!1;for(let z=0;z<s.length;z++){let A=s[z];if(A===""){y[z]=`.${u}`;continue}if(!A){y[z]=A;continue}P=!0;let M="";A.indexOf(S)===0?(M=A.substr(0,A.indexOf(S)+S.length),A=A.substr(A.indexOf(S)+S.length)):A.indexOf(u)===0?(M=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(R)===0&&(M=A.substr(0,A.indexOf(R)+R.length),A=A.substr(A.indexOf(R)+R.length));const V=A.split(u);for(let _=1;P&&_<=V.length;_++)for(let X=V.length-_;P&&X>=0;X--){P=!1;let ee=V.slice(X,X+_).join(u);for(let ie=0;!P&&ie<s.length;ie++)if(ie!==z&&s[ie]&&s[ie].indexOf(ee)>-1){const Z=X+_===V.length,oe=X>0&&s[ie].indexOf(u)>-1?u+ee:ee,se=s[ie].endsWith(oe);P=!Z||se}if(!P){let ie="";(V[0].endsWith(":")||M!=="")&&(X===1&&(X=0,_++,ee=V[0]+u+ee),X>0&&(ie=V[0]+u),ie=M+ie),X>0&&(ie=ie+d+u),ie=ie+ee,X+_<V.length&&(ie=ie+u+d),y[z]=ie}}P&&(y[z]=A)}return y}t.shorten=D;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function r(s,u=Object.create(null)){const y=[];let P=!1,z="";for(const A of s)if(A==="$"||P&&A==="{")z&&y.push({value:z,type:p.TEXT}),z="",P=!0;else if(A==="}"&&P){const M=u[z];if(typeof M=="string")M.length&&y.push({value:M,type:p.VARIABLE});else if(M){const V=y[y.length-1];(!V||V.type!==p.SEPARATOR)&&y.push({value:M.label,type:p.SEPARATOR})}z="",P=!1}else z+=A;return z&&!P&&y.push({value:z,type:p.TEXT}),y.filter((A,M)=>{if(A.type===p.SEPARATOR){const V=y[M-1],_=y[M+1];return[V,_].every(X=>X&&(X.type===p.VARIABLE||X.type===p.TEXT)&&X.value.length>0)}return!0}).map(A=>A.value).join("")}t.template=r;function o(s,u){return O.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.isMacintosh?"&":"&&"):s.replace(/&&|&/g,y=>y==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(s,u){return O.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):O.isWindows?s.replace(/&&|&/g,y=>y==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const u=s.indexOf("/")!==-1?F.posix:F.win32,y=u.basename(s),P=u.dirname(s);return y.length?{name:y,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(J[46],Q([0,1,124]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class F{constructor(T="utf8"){this.stringDecoder=new m.StringDecoder(T),this.remaining=null}write(T){const O=[],C=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(C.length<1)return O;let f=0,g,w=f;for(;w<C.length;)if(g=C.charCodeAt(w),g===13||g===10){if(O.push(C.substring(f,w)),w++,w<C.length){const E=g;g=C.charCodeAt(w),(E===13&&g===10||E===10&&g===13)&&w++}f=w}else w++;return this.remaining=f<C.length?C.substr(f):null,O}end(){return this.remaining}}t.LineDecoder=F}),define(J[63],Q([0,1,36,19,3,9]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function O(w){const E=I.dirname(w);if(w===E)return w;const b=(I.basename(w)||w).toLowerCase();try{const c=T.readdirSync(E).filter(d=>d.toLowerCase()===b);if(c.length===1){const d=O(E);if(d)return I.join(d,c[0])}else if(c.length>1){const d=c.indexOf(b);if(d>=0){const S=O(E);if(S)return I.join(S,c[d])}}}catch(k){}return null}t.realcaseSync=O;async function C(w){try{return await T.Promises.realpath(w)}catch(E){const b=g(w);return await T.Promises.access(b,m.constants.R_OK),b}}t.realpath=C;function f(w){try{return m.realpathSync(w)}catch(E){const b=g(w);return m.accessSync(b,m.constants.R_OK),b}}t.realpathSync=f;function g(w){return F.rtrim(I.normalize(w),I.sep)}}),define(J[64],Q([0,1,9,31,3]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,O=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var f;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(f||(f={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class E{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:r=!1}={}){return r?g===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function k({useAlternateBitness:r=!1,findPreview:o=!1}={}){const e=b({useAlternateBitness:r});if(!e)return null;const i=I.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const P of await m.Promises.readdir(i)){let z=-1;if(o){const M=P.indexOf("-");if(M<0)continue;const V=P.substring(0,M);if(!T.test(V)||P.substring(M+1)!=="preview")continue;z=parseInt(V,10)}else{if(!T.test(P))continue;z=parseInt(P,10)}if(z<=n)continue;const A=I.join(i,P,"pwsh.exe");!await m.SymlinkSupport.existsFile(A)||(s=A,n=z)}if(!s)return null;const u=e.includes("x86")?" (x86)":"",y=o?" Preview":"";return new E(s,`PowerShell${y}${u}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const o=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const n of await m.Promises.readdir(o))if(e.test(n)){const s=I.join(o,n,"pwsh.exe");return new E(s,i)}return null}function d(){const r=I.join(F.homedir(),".dotnet","tools","pwsh.exe");return new E(r,".NET Core PowerShell Global Tool")}function S(){const r=I.join(process.env.windir,g===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(r,"Windows PowerShell",!0)}async function*R(){let r=await k();r&&(yield r),r=await k({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=d(),r&&(yield r),r=await k({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await k({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=S(),r&&(yield r)}async function*D(){for await(const r of R())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=D;async function p(){for await(const r of D())return r;return null}t.getFirstAvailablePowerShellInstallation=p}),define(J[65],Q([0,1,3,36,14,125,2,9]),function($,t,m,F,I,T,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function f(E,b,k){return w({path:E,isDirectory:!1},b,k)}t.watchFile=f;function g(E,b,k){return w({path:E,isDirectory:!0},b,k)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function w(E,b,k){const c=m.basename(E.path),d=new Map;let S=!1,R=[O.toDisposable(()=>{d.forEach(D=>O.dispose(D)),d.clear()})];try{const D=F.watch(E.path);R.push(O.toDisposable(()=>{D.removeAllListeners(),D.close()}));const p=new Set;E.isDirectory&&C.Promises.readdir(E.path).then(r=>r.forEach(o=>p.add(o))),D.on("error",(r,o)=>{S||k(`Failed to watch ${E.path} for changes using fs.watch() (${r}, ${o})`)}),D.on("change",(r,o)=>{if(S)return;let e="";if(o&&(e=o.toString(),I.isMacintosh&&(e=T.normalizeNFC(e))),!e||r!=="change"&&r!=="rename")return;const i=E.isDirectory?m.join(E.path,e):E.path;if(E.isDirectory)if(r==="rename"){const n=d.get(i);n&&O.dispose(n);const s=setTimeout(async()=>{d.delete(i);const u=await C.Promises.exists(i);if(S)return;let y;u?p.has(e)?y="changed":(y="added",p.add(e)):(p.delete(e),y="deleted"),b(y,i)},t.CHANGE_BUFFER_DELAY);d.set(i,O.toDisposable(()=>clearTimeout(s)))}else{let n;p.has(e)?n="changed":(n="added",p.add(e)),b(n,i)}else if(r==="rename"||e!==c){const n=setTimeout(async()=>{const s=await C.Promises.exists(i);S||(s?(b("changed",i),R=[w(E,b,k)]):b("deleted",i))},t.CHANGE_BUFFER_DELAY);O.dispose(R),R=[O.toDisposable(()=>clearTimeout(n))]}else b("changed",i)})}catch(D){C.Promises.exists(E.path).then(p=>{p&&!S&&k(`Failed to watch ${E.path} for changes using fs.watch() (${D.toString()})`)})}return O.toDisposable(()=>{S=!0,R=O.dispose(R)})}});var ue=this&&this.__decorate||function($,t,m,F){var I=arguments.length,T=I<3?t:F===null?F=Object.getOwnPropertyDescriptor(t,m):F,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate($,t,m,F);else for(var C=$.length-1;C>=0;C--)(O=$[C])&&(T=(I<3?O(T):I>3?O(t,m,T):O(t,m))||T);return I>3&&T&&Object.defineProperty(t,m,T),T};define(J[37],Q([0,1,10,2,4,26,12,16,22,13,60,19,44]),function($,t,m,F,I,T,O,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var k;(function(a){a[a.Promise=100]="Promise",a[a.PromiseCancel=101]="PromiseCancel",a[a.EventListen=102]="EventListen",a[a.EventDispose=103]="EventDispose"})(k=t.RequestType||(t.RequestType={}));function c(a){switch(a){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(a){a[a.Initialize=200]="Initialize",a[a.PromiseSuccess=201]="PromiseSuccess",a[a.PromiseError=202]="PromiseError",a[a.PromiseErrorObj=203]="PromiseErrorObj",a[a.EventFire=204]="EventFire"})(d=t.ResponseType||(t.ResponseType={}));function S(a){switch(a){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var R;(function(a){a[a.Uninitialized=0]="Uninitialized",a[a.Idle=1]="Idle"})(R||(R={}));class D{constructor(l){this.buffer=l,this.pos=0}read(l){const h=this.buffer.slice(this.pos,this.pos+l);return this.pos+=h.byteLength,h}}class p{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(l){this.buffers.push(l)}}var r;(function(a){a[a.Undefined=0]="Undefined",a[a.String=1]="String",a[a.Buffer=2]="Buffer",a[a.VSBuffer=3]="VSBuffer",a[a.Array=4]="Array",a[a.Object=5]="Object"})(r||(r={}));function o(a){const l=C.VSBuffer.alloc(4);return l.writeUInt32BE(a,0),l}function e(a){return a.read(4).readUInt32BE(0)}function i(a){const l=C.VSBuffer.alloc(1);return l.writeUInt8(a,0),l}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},s=typeof Buffer!="undefined";function u(a,l){if(typeof l=="undefined")a.write(n.Undefined);else if(typeof l=="string"){const h=C.VSBuffer.fromString(l);a.write(n.String),a.write(o(h.byteLength)),a.write(h)}else if(s&&Buffer.isBuffer(l)){const h=C.VSBuffer.wrap(l);a.write(n.Buffer),a.write(o(h.byteLength)),a.write(h)}else if(l instanceof C.VSBuffer)a.write(n.VSBuffer),a.write(o(l.byteLength)),a.write(l);else if(Array.isArray(l)){a.write(n.Array),a.write(o(l.length));for(const h of l)u(a,h)}else{const h=C.VSBuffer.fromString(JSON.stringify(l));a.write(n.Object),a.write(o(h.byteLength)),a.write(h)}}function y(a){switch(a.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return a.read(e(a)).toString();case r.Buffer:return a.read(e(a)).buffer;case r.VSBuffer:return a.read(e(a));case r.Array:{const h=e(a),v=[];for(let L=0;L<h;L++)v.push(y(a));return v}case r.Object:return JSON.parse(a.read(e(a)).toString())}}class P{constructor(l,h,v=null,L=1e3){this.protocol=l,this.ctx=h,this.logger=v,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(l,h){this.channels.set(l,h),setTimeout(()=>this.flushPendingRequests(l),0)}sendResponse(l){switch(l.type){case 200:{const h=this.send([l.type]);this.logger&&this.logger.logOutgoing(h,0,1,S(l.type));return}case 201:case 202:case 204:case 203:{const h=this.send([l.type,l.id],l.data);this.logger&&this.logger.logOutgoing(h,l.id,1,S(l.type),l.data);return}}}send(l,h=void 0){const v=new p;return u(v,l),u(v,h),this.sendBuffer(v.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(h){return 0}}onRawMessage(l){const h=new D(l),v=y(h),L=y(h),N=v[0];switch(N){case 100:return this.logger&&this.logger.logIncoming(l.byteLength,v[1],1,`${c(N)}: ${v[2]}.${v[3]}`,L),this.onPromise({type:N,id:v[1],channelName:v[2],name:v[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(l.byteLength,v[1],1,`${c(N)}: ${v[2]}.${v[3]}`,L),this.onEventListen({type:N,id:v[1],channelName:v[2],name:v[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(l.byteLength,v[1],1,`${c(N)}`),this.disposeActiveRequest({type:N,id:v[1]});case 103:return this.logger&&this.logger.logIncoming(l.byteLength,v[1],1,`${c(N)}`),this.disposeActiveRequest({type:N,id:v[1]})}}onPromise(l){const h=this.channels.get(l.channelName);if(!h){this.collectPendingRequest(l);return}const v=new T.CancellationTokenSource;let L;try{L=h.call(this.ctx,l.name,l.arg,v.token)}catch(j){L=Promise.reject(j)}const N=l.id;L.then(j=>{this.sendResponse({id:N,data:j,type:201}),this.activeRequests.delete(l.id)},j=>{j instanceof Error?this.sendResponse({id:N,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:N,data:j,type:203}),this.activeRequests.delete(l.id)});const U=F.toDisposable(()=>v.cancel());this.activeRequests.set(l.id,U)}onEventListen(l){const h=this.channels.get(l.channelName);if(!h){this.collectPendingRequest(l);return}const v=l.id,N=h.listen(this.ctx,l.name,l.arg)(U=>this.sendResponse({id:v,data:U,type:204}));this.activeRequests.set(l.id,N)}disposeActiveRequest(l){const h=this.activeRequests.get(l.id);h&&(h.dispose(),this.activeRequests.delete(l.id))}collectPendingRequest(l){let h=this.pendingRequests.get(l.channelName);h||(h=[],this.pendingRequests.set(l.channelName,h));const v=setTimeout(()=>{console.error(`Unknown channel: ${l.channelName}`),l.type===100&&this.sendResponse({id:l.id,data:{name:"Unknown channel",message:`Channel name '${l.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);h.push({request:l,timeoutTimer:v})}flushPendingRequests(l){const h=this.pendingRequests.get(l);if(h){for(const v of h)switch(clearTimeout(v.timeoutTimer),v.request.type){case 100:this.onPromise(v.request);break;case 102:this.onEventListen(v.request);break}this.pendingRequests.delete(l)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var z;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(z=t.RequestInitiator||(t.RequestInitiator={}));class A{constructor(l,h=null){this.protocol=l,this.isDisposed=!1,this.state=R.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(v=>this.onBuffer(v)),this.logger=h}getChannel(l){const h=this;return{call(v,L,N){return h.isDisposed?Promise.reject(O.canceled()):h.requestPromise(l,v,L,N)},listen(v,L){return h.isDisposed?Promise.reject(O.canceled()):h.requestEvent(l,v,L)}}}requestPromise(l,h,v,L=T.CancellationToken.None){const N=this.lastRequestId++,j={id:N,type:100,channelName:l,name:h,arg:v};if(L.isCancellationRequested)return Promise.reject(O.canceled());let B;return new Promise((H,Y)=>{if(L.isCancellationRequested)return Y(O.canceled());const te=()=>{const Oe=Te=>{switch(Te.type){case 201:this.handlers.delete(N),H(Te.data);break;case 202:this.handlers.delete(N);const Se=new Error(Te.data.message);Se.stack=Te.data.stack,Se.name=Te.data.name,Y(Se);break;case 203:this.handlers.delete(N),Y(Te.data);break}};this.handlers.set(N,Oe),this.sendRequest(j)};let ae=null;this.state===R.Idle?te():(ae=I.createCancelablePromise(Oe=>this.whenInitialized()),ae.then(()=>{ae=null,te()}));const me=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:N,type:101}),Y(O.canceled())},ve=L.onCancellationRequested(me);B=F.combinedDisposable(F.toDisposable(me),ve),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(l,h,v){const L=this.lastRequestId++,U={id:L,type:102,channelName:l,name:h,arg:v};let j=null;const B=new m.Emitter({onFirstListenerAdd:()=>{j=I.createCancelablePromise(H=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(B),this.sendRequest(U)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(B),this.sendRequest({id:L,type:103}))}}),W=H=>B.fire(H.data);return this.handlers.set(L,W),B.event}sendRequest(l){switch(l.type){case 100:case 102:{const h=this.send([l.type,l.id,l.channelName,l.name],l.arg);this.logger&&this.logger.logOutgoing(h,l.id,0,`${c(l.type)}: ${l.channelName}.${l.name}`,l.arg);return}case 101:case 103:{const h=this.send([l.type,l.id]);this.logger&&this.logger.logOutgoing(h,l.id,0,c(l.type));return}}}send(l,h=void 0){const v=new p;return u(v,l),u(v,h),this.sendBuffer(v.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(h){return 0}}onBuffer(l){const h=new D(l),v=y(h),L=y(h),N=v[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(l.byteLength,0,0,S(N)),this.onResponse({type:v[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(l.byteLength,v[1],0,S(N),L),this.onResponse({type:v[0],id:v[1],data:L})}}onResponse(l){if(l.type===200){this.state=R.Idle,this._onDidInitialize.fire();return}const h=this.handlers.get(l.id);h&&h(l)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===R.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}ue([b.memoize],A.prototype,"onDidInitializePromise",null),t.ChannelClient=A;class M{constructor(l){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,l(({protocol:h,onDidClientDisconnect:v})=>{m.Event.once(h.onMessage)(N=>{const U=new D(N),j=y(U),B=new P(h,j),W=new A(h);this.channels.forEach((Y,te)=>B.registerChannel(te,Y));const H={channelServer:B,channelClient:W,ctx:j};this._connections.add(H),this._onDidAddConnection.fire(H),v(()=>{B.dispose(),W.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}get connections(){const l=[];return this._connections.forEach(h=>l.push(h)),l}getChannel(l,h){const v=this;return{call(L,N,U){let j;if(g.isFunction(h)){let W=f.getRandomElement(v.connections.filter(h));j=W?Promise.resolve(W):m.Event.toPromise(m.Event.filter(v.onDidAddConnection,h))}else j=h.routeCall(v,L,N);const B=j.then(W=>W.channelClient.getChannel(l));return _(B).call(L,N,U)},listen(L,N){if(g.isFunction(h))return v.getMulticastEvent(l,h,L,N);const U=h.routeEvent(v,L,N).then(j=>j.channelClient.getChannel(l));return _(U).listen(L,N)}}}getMulticastEvent(l,h,v,L){const N=this;let U=new F.DisposableStore;const j=new m.Emitter({onFirstListenerAdd:()=>{U=new F.DisposableStore;const B=new m.EventMultiplexer,W=new Map,H=te=>{const me=te.channelClient.getChannel(l).listen(v,L),ve=B.add(me);W.set(te,ve)},Y=te=>{const ae=W.get(te);!ae||(ae.dispose(),W.delete(te))};N.connections.filter(h).forEach(H),m.Event.filter(N.onDidAddConnection,h)(H,void 0,U),N.onDidRemoveConnection(Y,void 0,U),B.event(j.fire,j,U),U.add(B)},onLastListenerRemove:()=>{U.dispose()}});return j.event}registerChannel(l,h){this.channels.set(l,h),this._connections.forEach(v=>{v.channelServer.registerChannel(l,h)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=M;class V{constructor(l,h,v=null){const L=new p;u(L,h),l.send(L.buffer),this.channelClient=new A(l,v),this.channelServer=new P(l,h,v)}getChannel(l){return this.channelClient.getChannel(l)}registerChannel(l,h){this.channelServer.registerChannel(l,h)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function _(a){return{call(l,h,v){return a.then(L=>L.call(l,h,v))},listen(l,h){const v=new m.Relay;return a.then(L=>v.input=L.listen(l,h)),v.event}}}t.getDelayedChannel=_;function X(a){let l=!1;return{call(h,v,L){return l?a.call(h,v,L):I.timeout(0).then(()=>l=!0).then(()=>a.call(h,v,L))},listen(h,v){if(l)return a.listen(h,v);const L=new m.Relay;return I.timeout(0).then(()=>l=!0).then(()=>L.input=a.listen(h,v)),L.event}}}t.getNextTickChannel=X;class ee{constructor(l){this.fn=l}routeCall(l){return this.route(l)}routeEvent(l){return this.route(l)}async route(l){for(const h of l.connections)if(await Promise.resolve(this.fn(h.ctx)))return Promise.resolve(h);return await m.Event.toPromise(l.onDidAddConnection),await this.route(l)}}t.StaticRouter=ee;var ie;(function(a){function l(L,N){const U=L,j=N&&N.disableMarshalling,B=new Map;for(const W in U)v(W)&&B.set(W,m.Event.buffer(U[W],!0));return new class{listen(W,H){const Y=B.get(H);if(Y)return Y;throw new Error(`Event not found: ${H}`)}call(W,H,Y){const te=U[H];if(typeof te=="function"){if(!j&&Array.isArray(Y))for(let ae=0;ae<Y.length;ae++)Y[ae]=w.revive(Y[ae]);return te.apply(U,Y)}throw new Error(`Method not found: ${H}`)}}}a.fromService=l;function h(L,N){const U=N&&N.disableMarshalling;return new Proxy({},{get(j,B){if(typeof B=="string")return N?.properties?.has(B)?N.properties.get(B):v(B)?L.listen(B):async function(...W){let H;N&&!g.isUndefinedOrNull(N.context)?H=[N.context,...W]:H=W;const Y=await L.call(B,H);return U?Y:w.revive(Y)};throw new Error(`Property not found: ${String(B)}`)}})}a.toService=h;function v(L){return L[0]==="o"&&L[1]==="n"&&E.isUpperAsciiLetter(L.charCodeAt(2))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(a){if(Array.isArray(a))return a;if(a&&typeof a=="object"&&typeof a.toString=="function"){let l=a.toString();if(l!=="[object Object]")return l}return a}function se(a){return Array.isArray(a)?a.map(oe):oe(a)}function re(a,l,h,v,L,N,U){U=se(U);const j=Z[L],B=j[v%j.length];let W=[`%c[${a}]%c[${String(l).padStart(7," ")}]%c[len: ${String(h).padStart(5," ")}]%c${String(v).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(N)?(W=W.concat(U),W.push(")")):W.push(U),console.log.apply(console,W)}t.logWithColors=re;class K{constructor(l,h){this._outgoingPrefix=l,this._incomingPrefix=h,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(l,h,v,L,N){this._totalOutgoing+=l,re(this._outgoingPrefix,this._totalOutgoing,l,h,v,L,N)}logIncoming(l,h,v,L,N){this._totalIncoming+=l,re(this._incomingPrefix,this._totalIncoming,l,h,v,L,N)}}t.IPCLogger=K}),define(J[66],Q([0,1,2,10,4,13]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var O;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=t.StorageHint||(t.StorageHint={}));var C;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(C||(C={}));class f extends m.Disposable{constructor(E,b=Object.create(null)){super();this.database=E,this.options=b,this._onDidChangeStorage=this._register(new F.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((b,k)=>this.accept(k,b)),E.deleted?.forEach(b=>this.accept(b,void 0))}accept(E,b){if(this.state===C.Closed)return;let k=!1;T.isUndefinedOrNull(b)?k=this.cache.delete(E):this.cache.get(E)!==b&&(this.cache.set(E,b),k=!0),k&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,b){const k=this.cache.get(E);return T.isUndefinedOrNull(k)?b:k}getBoolean(E,b){const k=this.get(E);return T.isUndefinedOrNull(k)?b:k==="true"}getNumber(E,b){const k=this.get(E);return T.isUndefinedOrNull(k)?b:parseInt(k,10)}async set(E,b){if(this.state===C.Closed)return;if(T.isUndefinedOrNull(b))return this.delete(E);const k=String(b);if(this.cache.get(E)!==k)return this.cache.set(E,k),this.pendingInserts.set(E,k),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===C.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((b,k)=>this.items.set(k,b)),E.delete&&E.delete.forEach(b=>this.items.delete(b))}async close(){}}t.InMemoryStorageDatabase=g}),define(J[67],Q([5,6]),function($,t){return $.create("vs/base/common/date",t)}),define(J[68],Q([0,1,67]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const F=60,I=F*60,T=I*24,O=T*7,C=T*30,f=T*365;function g(E,b){typeof E!="number"&&(E=E.getTime());const k=Math.round((new Date().getTime()-E)/1e3);if(k<-30)return m.localize(0,null,g(new Date().getTime()+k*1e3,!1));if(k<30)return m.localize(1,null);let c;return k<F?(c=k,b?c===1?m.localize(2,null,c):m.localize(3,null,c):c===1?m.localize(4,null,c):m.localize(5,null,c)):k<I?(c=Math.floor(k/F),b?c===1?m.localize(6,null,c):m.localize(7,null,c):c===1?m.localize(8,null,c):m.localize(9,null,c)):k<T?(c=Math.floor(k/I),b?c===1?m.localize(10,null,c):m.localize(11,null,c):c===1?m.localize(12,null,c):m.localize(13,null,c)):k<O?(c=Math.floor(k/T),b?c===1?m.localize(14,null,c):m.localize(15,null,c):c===1?m.localize(16,null,c):m.localize(17,null,c)):k<C?(c=Math.floor(k/O),b?c===1?m.localize(18,null,c):m.localize(19,null,c):c===1?m.localize(20,null,c):m.localize(21,null,c)):k<f?(c=Math.floor(k/C),b?c===1?m.localize(22,null,c):m.localize(23,null,c):c===1?m.localize(24,null,c):m.localize(25,null,c)):(c=Math.floor(k/f),b?c===1?m.localize(26,null,c):m.localize(27,null,c):c===1?m.localize(28,null,c):m.localize(29,null,c))}t.fromNow=g;function w(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=w}),define(J[69],Q([5,6]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(J[28],Q([0,1,69,13,22]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function T(g,w){return w&&(g.stack||g.stacktrace)?m.localize(0,null,C(g),O(g.stack)||O(g.stacktrace)):C(g)}function O(g){return Array.isArray(g)?g.join(`
`):g}function C(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?m.localize(1,null,g.message):g.message||m.localize(2,null)}function f(g=null,w=!1){if(!g)return m.localize(3,null);if(Array.isArray(g)){const E=I.coalesce(g),b=f(E[0],w);return E.length>1?m.localize(4,null,b,E.length):b}if(F.isString(g))return g;if(g.detail){const E=g.detail;if(E.error)return T(E.error,w);if(E.exception)return T(E.exception,w)}return g.stack?T(g,w):g.message?g.message:m.localize(5,null)}t.toErrorMessage=f}),define(J[70],Q([5,6]),function($,t){return $.create("vs/base/node/processes",t)}),define(J[47],Q([0,1,3,9,32,70,33,13,20,35,14,46,8]),function($,t,m,F,I,T,O,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function k(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,o){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=I.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,u)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?k(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(i=>{I.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,s,u)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r=O.env){return r.comspec||"cmd.exe"}t.getWindowsShell=d;class S{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(O.env).forEach(u=>{s[u]=O.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(m.sep);return e!==-1&&(o=o.substring(e+1)),S.WellKnowCommands[o]?o:"other"}start(o){return w.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(O.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((u,y)=>{i=u,n=y});if(e){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=I.exec(u,this.options,(y,P,z)=>{this.childProcess=null;const A=y;A&&A.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:z.toString()}):this.handleExec(i,o,y,P,z)})}else{let u=null;const y=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,o,n);const z={terminated:this.terminateRequested};C.isNumber(P)&&(z.cmdCode=P),i(z)};if(this.shell&&w.isWindows){const P=f.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let z=!1,A=!1;const M=[];let V=this.ensureQuotes(this.cmd);M.push(V.value),z=V.quoted,this.args&&this.args.forEach(X=>{V=this.ensureQuotes(X),M.push(V.value),A=A&&V.quoted});const _=["/s","/c"];z?A?_.push('"'+M.join(" ")+'"'):M.length>1?_.push('"'+M[0]+'" '+M.slice(1).join(" ")):_.push('"'+M[0]+'"'):_.push(M.join(" ")),u=I.spawn(d(),_,P)}else this.cmd&&(u=I.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),u.pid&&(this.childProcess.on("close",y),this.handleSpawn(u,i,o,n,!0)))}return s})}handleClose(o,e,i,n){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,c(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!w.isWindows)return o(!1);const e=I.spawn(d(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class R extends S{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,s){[n,s].forEach((u,y)=>{const P=new E.LineDecoder;P.write(u).forEach(M=>{e({line:M,source:y===0?0:1})});const A=P.end();A&&e({line:A,source:y===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,s){const u=new E.LineDecoder,y=new E.LineDecoder;o.stdout.on("data",P=>{u.write(P).forEach(A=>i({line:A,source:0}))}),o.stderr.on("data",P=>{y.write(P).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=y}handleClose(o,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}t.LineProcess=R;function D(r){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!r.send(n,u=>{if(u&&console.error(u),e=!1,o.length>0){const y=o.slice(0);o=[],y.forEach(P=>i(P))}})||w.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=D;var p;(function(r){async function o(e,i,n){if(m.isAbsolute(e))return e;if(i===void 0&&(i=O.cwd()),m.dirname(e)!=="."||(n===void 0&&C.isString(O.env.PATH)&&(n=O.env.PATH.split(m.delimiter)),n===void 0||n.length===0))return m.join(i,e);async function u(y){return await F.Promises.exists(y)?!(await F.Promises.stat(y)).isDirectory():!1}for(let y of n){let P;if(m.isAbsolute(y)?P=m.join(y,e):P=m.join(i,y,e),await u(P))return P;let z=P+".com";if(await u(z)||(z=P+".exe",await u(z)))return z}return m.join(i,e)}r.findExecutable=o})(p=t.win32||(t.win32={}))}),define(J[71],Q([0,1,31,14,64,47]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function O(k,c){return k===1?F.isWindows?E():T.getWindowsShell(c):g(k,c)}t.getSystemShell=O;function C(k,c){return k===1?F.isWindows?b(c):T.getWindowsShell(c):g(k,c)}t.getSystemShellSync=C;let f=null;function g(k,c){if(F.isLinux&&k===2||F.isMacintosh&&k===3)return"/bin/bash";if(!f){let d;if(F.isWindows)d="/bin/bash";else{if(d=c.SHELL,!d)try{d=m.userInfo().shell}catch(S){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}f=d}return f}let w=null;async function E(){return w||(w=(await I.getFirstAvailablePowerShellInstallation()).exePath),w}function b(k){if(w)return w;const c=F.isWindows&&parseFloat(m.release())>=10,d=k.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${k.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?S:T.getWindowsShell(k)}}),define(J[48],Q([0,1,32,2,4,20,10,47,37,59,26,12,16,14]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends f.ChannelServer{constructor(R){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(p){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",D=>b.VSBuffer.wrap(Buffer.from(D,"base64")))},R);process.once("disconnect",()=>this.dispose())}}t.Server=c;class d{constructor(R,D){this.modulePath=R,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new I.Delayer(p),this.child=null,this._client=null}getChannel(R){const D=this;return{call(p,r,o){return D.requestPromise(R,p,r,o)},listen(p,r){return D.requestEvent(R,p,r)}}}requestPromise(R,D,p,r=w.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(E.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(R),e=I.createCancelablePromise(s=>o.call(D,p,s)),i=r.onCancellationRequested(()=>e.cancel()),n=F.toDisposable(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(R,D,p){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let r;const o=new O.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(R).listen(D,p)(o.fire,o),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const R=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env={...T.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(D.env={...D.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),k.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=m.fork(this.modulePath,R,D);const p=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(g.isRemoteConsoleLog(u)){g.log(u,`IPC Library: ${this.options.serverName}`);return}p.fire(b.VSBuffer.wrap(Buffer.from(u,"base64")))});const o=this.options.useQueue?C.createQueuedSender(this.child):this.child,e=u=>this.child&&this.child.connected&&o.send(u.buffer.toString("base64")),i=p.event,n={send:e,onMessage:i};this._client=new f.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,y)=>{process.removeListener("exit",s),this.activeRequests.forEach(P=>F.dispose(P)),this.activeRequests.clear(),u!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+y),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:y})})}return this._client}getCachedChannel(R){let D=this.channels.get(R);return D||(D=this.client.getChannel(R),this.channels.set(R,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=d}),define(J[72],Q([5,6]),function($,t){return $.create("vs/base/node/zip",t)}),define(J[73],Q([5,6]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Q([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[75],Q([5,6]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[76],Q([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[77],Q([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[78],Q([5,6]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[79],Q([5,6]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[80],Q([5,6]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(J[81],Q([5,6]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(J[82],Q([5,6]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[83],Q([5,6]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(J[84],Q([5,6]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[85],Q([0,1,3,17,44,68,8,7,33]),function($,t,m,F,I,T,O,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(c,d,S){this._args=c,this.paths=d,this.productService=S}get appRoot(){return m.dirname(O.FileAccess.asFileUri("",$).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file(m.join(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return F.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return F.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=T.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=m.join(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file(m.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return F.joinPath(C.URI.file(m.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return F.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return F.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=f.env.VSCODE_PORTABLE;return c?C.URI.file(m.join(c,"argv.json")):F.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return F.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file(m.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return m.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?m.resolve(c):m.normalize(m.join(O.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?m.resolve(c):m.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return m.resolve(c);const d=f.env.VSCODE_EXTENSIONS;if(d)return d;const S=f.env.VSCODE_PORTABLE;return S?m.join(S,"extensions"):F.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(d=>/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file(m.normalize(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?C.URI.parse(c):C.URI.file(m.normalize(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return F.joinPath(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file(m.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([I.memoize],g.prototype,"appRoot",null),ue([I.memoize],g.prototype,"userHome",null),ue([I.memoize],g.prototype,"userDataPath",null),ue([I.memoize],g.prototype,"appSettingsHome",null),ue([I.memoize],g.prototype,"tmpDir",null),ue([I.memoize],g.prototype,"userRoamingDataHome",null),ue([I.memoize],g.prototype,"settingsResource",null),ue([I.memoize],g.prototype,"userDataSyncHome",null),ue([I.memoize],g.prototype,"userDataSyncLogResource",null),ue([I.memoize],g.prototype,"sync",null),ue([I.memoize],g.prototype,"machineSettingsResource",null),ue([I.memoize],g.prototype,"globalStorageHome",null),ue([I.memoize],g.prototype,"workspaceStorageHome",null),ue([I.memoize],g.prototype,"keybindingsResource",null),ue([I.memoize],g.prototype,"keyboardLayoutResource",null),ue([I.memoize],g.prototype,"argvResource",null),ue([I.memoize],g.prototype,"snippetsHome",null),ue([I.memoize],g.prototype,"isExtensionDevelopment",null),ue([I.memoize],g.prototype,"untitledWorkspacesHome",null),ue([I.memoize],g.prototype,"installSourcePath",null),ue([I.memoize],g.prototype,"builtinExtensionsPath",null),ue([I.memoize],g.prototype,"extensionsPath",null),ue([I.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ue([I.memoize],g.prototype,"extensionDevelopmentKind",null),ue([I.memoize],g.prototype,"extensionTestsLocationURI",null),ue([I.memoize],g.prototype,"debugExtensionHost",null),ue([I.memoize],g.prototype,"serviceMachineIdResource",null),ue([I.memoize],g.prototype,"telemetryLogResource",null),ue([I.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function w(k,c){return b(k["inspect-extensions"],k["inspect-brk-extensions"],5870,c,k.debugId)}t.parseExtensionHostPort=w;function E(k,c){return b(k["inspect-search"],k["inspect-brk-search"],5876,c)}t.parseSearchPort=E;function b(k,c,d,S,R){const p=Number(c||k)||(S?null:d),r=p?Boolean(!!c):!1;return{port:p,break:r,debugId:R}}}),function(){"use strict";function $(t,m,F,I){function T(C){const f=O(C),g=[f];return t.isAbsolute(f)||g.unshift(I),t.resolve(...g)}function O(C){const f=process.env.VSCODE_PORTABLE;if(f)return t.join(f,"user-data");const g=C["user-data-dir"];if(g)return g;let w=process.env.VSCODE_APPDATA;if(!w)switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=t.join(E,"AppData","Roaming")}break;case"darwin":w=t.join(m.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(w,F)}return{getUserDataPath:T}}if(typeof define=="function")define(J[86],Q([0,87,31,8,17,33]),function(t,m,F,I,T,O){const C=T.dirname(I.FileAccess.asFileUri("",t)),f=t.__$__nodeRequire(T.joinPath(C,"package.json").fsPath);return $(m,F,f.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),F=require("os");module.exports=$(m,F,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[88],Q([0,1,31,86,85]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class T extends I.AbstractNativeEnvironmentService{constructor(C,f){super(C,{homeDir:m.homedir(),tmpDir:m.tmpdir(),userDataDir:F.getUserDataPath(C)},f)}}t.NativeEnvironmentService=T}),define(J[89],Q([0,1,20]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const F=/^%([\w\d.-]+)%$/i;function I(T,O){const C=f=>{if(typeof f!="string")return;const g=F.exec(f);if(!g)return;const w=O[g[1]]??f;return typeof w=="string"?w:typeof w.message=="string"?w.message:f};return m.cloneAndChange(T,C)}t.localizeManifest=I}),define(J[49],Q([0,1,79]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(b){return b=b.trim(),b==="*"||F.test(b)}t.isValidVersionStr=T;function O(b){if(!T(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let k=b.match(F);return k?{hasCaret:k[1]==="^",hasGreaterEquals:k[1]===">=",majorBase:k[2]==="x"?0:parseInt(k[2],10),majorMustEqual:k[2]!=="x",minorBase:k[4]==="x"?0:parseInt(k[4],10),minorMustEqual:k[4]!=="x",patchBase:k[6]==="x"?0:parseInt(k[6],10),patchMustEqual:k[6]!=="x",preRelease:k[8]||null}:null}t.parseVersion=O;function C(b){if(!b)return null;let k=b.majorBase,c=b.majorMustEqual,d=b.minorBase,S=b.minorMustEqual,R=b.patchBase,D=b.patchMustEqual;b.hasCaret&&(k===0||(S=!1),D=!1);let p=0;if(b.preRelease){const r=I.exec(b.preRelease);if(r){const[,o,e,i]=r;p=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:k,majorMustEqual:c,minorBase:d,minorMustEqual:S,patchBase:R,patchMustEqual:D,isMinimum:b.hasGreaterEquals,notBefore:p}}t.normalizeVersion=C;function f(b,k,c){let d;typeof b=="string"?d=C(O(b)):d=b;let S;k instanceof Date?S=k.getTime():typeof k=="string"&&(S=new Date(k).getTime());let R;if(typeof c=="string"?R=C(O(c)):R=c,!d||!R)return!1;let D=d.majorBase,p=d.minorBase,r=d.patchBase,o=R.majorBase,e=R.minorBase,i=R.patchBase,n=R.notBefore,s=R.majorMustEqual,u=R.minorMustEqual,y=R.patchMustEqual;return R.isMinimum?D>o?!0:D<o?!1:p>e?!0:p<e||S&&S<n?!1:r>=i:(D===1&&o===0&&(!s||!u||!y)&&(o=1,e=0,i=0,s=!0,u=!1,y=!1),D<o?!1:D>o?!s:p<e?!1:p>e?!u:r<i?!1:r>i?!y:!(S&&S<n))}t.isValidVersion=f;function g(b,k,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:E(b,k,c.engines.vscode,d)}t.isValidExtensionVersion=g;function w(b,k,c){return b==="*"||E(k,c,b)}t.isEngineValid=w;function E(b,k,c,d=[]){let S=C(O(c));if(!S)return d.push(m.localize(0,null,c)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return d.push(m.localize(1,null,c)),!1}else if(!S.majorMustEqual)return d.push(m.localize(2,null,c)),!1;return f(b,k,S)?!0:(d.push(m.localize(3,null,b,c)),!1)}}),define(J[90],Q([0,1,37,48,2,8]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class O extends I.Disposable{constructor(f,g,w,E){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new F.Client(T.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=O,O.MAX_RESTARTS=5}),define(J[91],Q([0,1,37,48,2,8]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class O extends I.Disposable{constructor(f,g,w,E,b={}){super();this.folders=f,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=E,this.watcherOptions=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new F.Client(T.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService(m.getNextTickChannel(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=O,O.MAX_RESTARTS=5}),define(J[92],Q([0,1,32,46,61,8]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(f,g,w,E,b){this.watchedFolder=f,this.eventCallback=w,this.logCallback=E,this.verboseLogging=b,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(k=>I.parse(k)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=m.spawn(T.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,f);const g=new F.LineDecoder;this.handle.stdout.on("data",w=>{const E=[];for(const b of g.write(w)){const k=b.split("|");if(k.length===2){const c=Number(k[0]),d=k[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(S=>S(d))){this.verboseLogging&&this.log(d);continue}E.push({type:O.changeTypeMap[c],path:d})}else this.log(k[1])}}E.length>0&&this.eventCallback(E)}),this.handle.on("error",w=>this.onError(w)),this.handle.stderr.on("data",w=>this.onError(w)),this.handle.on("exit",(w,E)=>this.onExit(w,E))}onError(f){this.error("process error: "+f.toString())}onExit(f,g){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${g})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(J[93],Q([0,1,92,3,19]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T{constructor(C,f,g,w){this.onDidFilesChange=f,this.onLogMessage=g,this.verboseLogging=w,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(F.posix.sep)&&(this.folder.path=I.rtrim(this.folder.path,F.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=T}),define(J[50],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class m{constructor(T,O=[],C=!1){this.ctor=T,this.staticArguments=O,this.supportsDelayedInstantiation=C}}t.SyncDescriptor=m;const F=(I,...T)=>new m(I,T);t.createSyncDescriptor=F}),define(J[94],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}t.Node=m;class F{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let O of this._nodes.values())O.outgoing.size===0&&T.push(O);return T}insertEdge(T,O){const C=this.lookupOrInsertNode(T),f=this.lookupOrInsertNode(O);C.outgoing.set(this._hashFn(O),f),f.incoming.set(this._hashFn(T),C)}removeNode(T){const O=this._hashFn(T);this._nodes.delete(O);for(let C of this._nodes.values())C.outgoing.delete(O),C.incoming.delete(O)}lookupOrInsertNode(T){const O=this._hashFn(T);let C=this._nodes.get(O);return C||(C=new m(T),this._nodes.set(O,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[O,C]of this._nodes)T.push(`${O}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,O]of this._nodes){const C=new Set([T]),f=this._findCycle(O,C);if(f)return f}}_findCycle(T,O){for(let[C,f]of T.outgoing){if(O.has(C))return[...O,C].join(" -> ");O.add(C);const g=this._findCycle(f,O);if(g)return g;O.delete(C)}}}t.Graph=F}),define(J[95],Q([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=m.createDecorator("downloadService")}),define(J[21],Q([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=m.createDecorator("environmentService"),t.INativeEnvironmentService=m.refineServiceDecorator(t.IEnvironmentService)}),define(J[23],Q([0,1,74,11,8]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function T(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}t.isIExtensionIdentifier=T;var O;(function(E){E[E.NoneOrRelevance=0]="NoneOrRelevance",E[E.LastUpdatedDate=1]="LastUpdatedDate",E[E.Title=2]="Title",E[E.PublisherName=3]="PublisherName",E[E.InstallCount=4]="InstallCount",E[E.PublishedDate=5]="PublishedDate",E[E.AverageRating=6]="AverageRating",E[E.WeightedRating=12]="WeightedRating"})(O=t.SortBy||(t.SortBy={}));var C;(function(E){E[E.Default=0]="Default",E[E.Ascending=1]="Ascending",E[E.Descending=2]="Descending"})(C=t.SortOrder||(t.SortOrder={}));var f;(function(E){E.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var g;(function(E){E[E.None=0]="None",E[E.Install=1]="Install",E[E.Update=2]="Update"})(g=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=F.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class w extends Error{constructor(b,k){super(b);this.code=k,this.name=k}}t.ExtensionManagementError=w,t.IExtensionManagementService=F.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=F.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=F.createDecorator("IExtensionTipsService"),t.DefaultIconPath=I.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=m.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=m.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=F.createDecorator("IExtensionManagementCLIService")}),define(J[38],Q([0,1,19,11]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkpaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function I(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}t.getWorkpaceSupportTypeMessage=I;function T(w){return w&&typeof w=="object"&&typeof w.id=="string"&&(!w.uuid||typeof w.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(O=t.ExtensionType||(t.ExtensionType={}));class C{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,b){if(typeof E=="undefined"||E===null)return typeof b=="undefined"||b===null;if(typeof b=="undefined"||b===null)return!1;if(typeof E=="string"||typeof b=="string"){let k=typeof E=="string"?E:E.value,c=typeof b=="string"?b:b.value;return m.equalsIgnoreCase(k,c)}return E._lower===b._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}t.ExtensionIdentifier=C;function f(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}t.isLanguagePackExtension=f;function g(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=F.createDecorator("IBuiltinExtensionsScannerService")}),define(J[24],Q([0,1,19,38]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function I(c,d){return c.uuid&&d.uuid?c.uuid===d.uuid:c.id===d.id?!0:m.compareIgnoreCase(c.id,d.id)===0}t.areSameExtensions=I;class T{constructor(d,S){this.version=S,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof T?I(this,d)&&this.version===d.version:!1}}t.ExtensionIdentifierWithVersion=T;function O(c,d){return`${c}.${d}`}t.getExtensionId=O;function C(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=C;function f(c,d){return C(O(c,d))}t.getGalleryExtensionId=f;function g(c,d){const S=[],R=D=>{for(const p of S)if(p.some(r=>I(d(r),d(D))))return p;return null};for(const D of c){const p=R(D);p?p.push(D):S.push([D])}return S}t.groupByExtension=g;function w(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=w;function E(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=E,t.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function b(c){const d=new Set;for(const S of c)S.malicious&&d.add(S.id.id);return d}t.getMaliciousExtensionsSet=b;function k(c,d){const S=[],R=d.manifest.extensionDependencies?.slice(0)??[];for(;R.length;){const D=R.shift();if(D&&S.every(p=>!I(p.identifier,{id:D}))){const p=c.filter(r=>I(r.identifier,{id:D}));p.length===1&&(S.push(p[0]),R.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}t.getExtensionDependencies=k});var fe=this&&this.__param||function($,t){return function(m,F){t(m,F,$)}};define(J[96],Q([0,1,75,12,7,39,23,24,38,62,26,8]),function($,t,m,F,I,T,O,C,f,g,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const b=D=>m.localize(0,null,D),k=m.localize(1,null,"ms-dotnettools.csharp");function c(D,p){return p?`${D.publisher}.${D.name}@${D.version}`:`${D.publisher}.${D.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(D){const p=d.exec(D);return p&&p[1]?[C.adoptToGalleryExtensionId(p[1]),p[2]]:[C.adoptToGalleryExtensionId(D),void 0]}t.getIdAndVersion=S;let R=class{constructor(p,r){this.extensionManagementService=p,this.extensionGalleryService=r}get location(){}async listExtensions(p,r,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=f.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(y=>y.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){o.log("Possible Categories: "),i.forEach(s=>{o.log(s)});return}this.location&&o.log(m.localize(2,null,this.location)),e=e.sort((s,u)=>s.identifier.id.localeCompare(u.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,o.log(c(s.manifest,p)))}async installExtensions(p,r,o,e,i=console){const n=[],s=[];p.length&&i.log(this.location?m.localize(3,null,this.location):m.localize(4,null));const u=await this.extensionManagementService.getInstalled(1),y=(A,M)=>{const V=u.find(_=>C.areSameExtensions(_.identifier,{id:A}));if(V){if(!M&&!e)return i.log(m.localize(5,null,A,V.manifest.version,A)),!1;if(M&&V.manifest.version===M)return i.log(m.localize(6,null,`${A}@${M}`)),!1}return!0},P=[],z=[];for(const A of p)if(A instanceof I.URI)P.push(A);else{const[M,V]=S(A);y(M,V)&&z.push({id:M,version:V,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const A of r){const[M,V]=S(A);y(M,V)&&z.push({id:M,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async A=>{try{const M=await this.installVSIX(A,{isBuiltin:!1,isMachineScoped:o},e,i);M&&s.push(M)}catch(M){i.error(M.message||M.stack||M),n.push(A.toString())}})),z.length){const A=await this.getGalleryExtensions(z);await Promise.all(z.map(async M=>{const V=A.get(M.id.toLowerCase());if(V)try{const _=await this.installFromGallery(M,V,u,e,i);_&&s.push(_)}catch(_){i.error(_.message||_.stack||_),n.push(M.id)}else i.error(`${b(M.version?`${M.id}@${M.version}`:M.id)}
${k}`),n.push(M.id)}))}if(n.length)throw new Error(m.localize(7,null,n.join(", ")))}async installVSIX(p,r,o,e){const i=await this.extensionManagementService.getManifest(p);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(p,r),e.log(m.localize(8,null,g.getBaseLabel(p))),i}catch(s){if(F.isPromiseCanceledError(s))return e.log(m.localize(9,null,g.getBaseLabel(p))),null;throw s}return null}async getGalleryExtensions(p){const r=p.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=p.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,w.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:p,version:r,installOptions:o},e,i,n,s){const u=await this.extensionGalleryService.getManifest(e,w.CancellationToken.None);if(u&&!this.validateExtensionKind(u,s))return null;const y=i.find(P=>C.areSameExtensions(P.identifier,e.identifier));if(y){if(e.version===y.manifest.version)return s.log(m.localize(10,null,r?`${p}@${r}`:p)),null;s.log(m.localize(11,null,p,e.version))}try{return o.isBuiltin?s.log(r?m.localize(12,null,p,r):m.localize(13,null,p)):s.log(r?m.localize(14,null,p,r):m.localize(15,null,p)),await this.extensionManagementService.installFromGallery(e,o),s.log(m.localize(16,null,p,e.version)),u}catch(P){if(F.isPromiseCanceledError(P))return s.log(m.localize(17,null,p)),null;throw P}}validateExtensionKind(p,r){return!0}async validateVSIX(p,r,o){const e={id:C.getGalleryExtensionId(p.publisher,p.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>C.areSameExtensions(e,s.identifier)&&T.gt(s.manifest.version,p.version));return n&&!r?(o.log(m.localize(18,null,n.identifier.id,n.manifest.version,p.version)),!1):this.validateExtensionKind(p,o)}async uninstallExtensions(p,r,o=console){const e=async n=>{if(n instanceof I.URI){const s=await this.extensionManagementService.getManifest(n);return c(s)}return n},i=[];for(const n of p){const s=await e(n),y=(await this.extensionManagementService.getInstalled()).filter(P=>C.areSameExtensions(P.identifier,{id:s}));if(!y.length)throw new Error(`${this.notInstalled(s)}
${k}`);if(y.some(P=>P.type===0)){o.log(m.localize(19,null,s));return}if(!r&&y.some(P=>P.isBuiltin)){o.log(m.localize(20,null,s));return}o.log(m.localize(21,null,s));for(const P of y)await this.extensionManagementService.uninstall(P),i.push(P);this.location?o.log(m.localize(22,null,s,this.location)):o.log(m.localize(23,null,s))}}async locateExtension(p,r=console){const o=await this.extensionManagementService.getInstalled();p.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===E.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(p){return this.location?m.localize(24,null,p,this.location):m.localize(25,null,p)}};R=ue([fe(0,O.IExtensionManagementService),fe(1,O.IExtensionGalleryService)],R),t.ExtensionManagementCLIService=R}),define(J[97],Q([0,1,2,3,38,9]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class O extends m.Disposable{constructor(f,g){super();this.environmentService=f,this.extensionsManifestCache=F.join(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtension(w=>this.onDidInstallExtension(w))),this._register(g.onDidUninstallExtension(w=>this.onDidUnInstallExtension(w)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){T.Promises.rm(this.extensionsManifestCache,T.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=O}),define(J[98],Q([0,1,87,32,29,14,126,28,71,26,12]),function($,t,m,F,I,T,O,C,f,g,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function E(c,d,S){return d["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):T.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):O.isLaunchedFromCli(S)&&!d["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(O.isLaunchedFromCli(S)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=new Promise(async R=>{const D=new g.CancellationTokenSource,p=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),D.dispose(!0),R({})},1e4);try{const r=await k(c,D.token);R(r)}catch(r){w.isPromiseCanceledError(r)||c.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),R({})}finally{clearTimeout(p),D.dispose()}})),b)}t.resolveShellEnv=E;let b;async function k(c,d){const S=new Promise(async(R,D)=>{const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",r);const o=I.generateUuid().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",i);const n=await f.getSystemShell(T.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),d.isCancellationRequested)return D(w.canceled);const s=m.basename(n);let u,y;/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,y=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,y=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),u);const P=F.spawn(n,[...y,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});d.onCancellationRequested(()=>(P.kill(),D(w.canceled))),P.on("error",M=>{c.error("getUnixShellEnvironment#errorChildProcess",C.toErrorMessage(M)),R({})});const z=[];P.stdout.on("data",M=>z.push(M));const A=[];P.stderr.on("data",M=>A.push(M)),P.on("close",(M,V)=>{const _=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",_);const X=Buffer.concat(A).toString("utf8");if(X.trim()&&c.trace("getUnixShellEnvironment#stderr",X),M||V)return D(new Error(`Failed to get environment (code ${M}, signal ${V})`));const ee=e.exec(_),ie=ee?ee[1]:"{}";try{const Z=JSON.parse(ie);p?Z.ELECTRON_RUN_AS_NODE=p:delete Z.ELECTRON_RUN_AS_NODE,r?Z.ELECTRON_NO_ATTACH_CONSOLE=r:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Z),R(Z)}catch(Z){c.error("getUnixShellEnvironment#errorCaught",C.toErrorMessage(Z)),D(Z)}})});try{return await S}catch(R){return c.error("getUnixShellEnvironment#error",C.toErrorMessage(R)),{}}}}),define(J[51],Q([0,1,7,18,14]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function T(f){return f.map(g=>({type:g.type,resource:m.URI.file(g.path)}))}t.toFileChanges=T;function O(f){const g=new C;for(const w of f)g.processEvent(w);return g.normalize()}t.normalizeFileChanges=O;class C{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const w=this.mapPathToChange.get(g.path);if(w){const E=w.type,b=g.type;E===1&&b===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(w),1)):E===2&&b===1?w.type=0:E===1&&b===0||(w.type=b)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],w=[];return this.normalized.filter(E=>E.type!==2?(g.push(E),!1):!0).sort((E,b)=>E.path.length-b.path.length).filter(E=>w.some(b=>F.isParent(E.path,b,!I.isLinux))?!1:(w.push(E.path),!0)).concat(g)}}}),define(J[99],Q([0,1,51,2,9,63,65,4,3]),function($,t,m,F,I,T,O,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends F.Disposable{constructor(E,b,k,c){super();this.path=E,this.onDidFilesChange=b,this.onLogMessage=k,this.verboseLogging=c,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:b}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let k=this.path;if(b)try{k=await T.realpath(k)}catch(c){if(this.onError(c),b.dangling)return}E.isDirectory()?this._register(O.watchFolder(k,(c,d)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:f.join(this.path,f.basename(d))})},c=>this.onError(c))):this._register(O.watchFile(k,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const b=this.fileChangesBuffer;this.fileChangesBuffer=[];const k=m.normalizeFileChanges(b);if(this.verboseLogging)for(const c of k)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);k.length>0&&this.onDidFilesChange(k)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(J[52],Q([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...I){this._entries=new Map;for(let[T,O]of I)this.set(T,O)}set(I,T){const O=this._entries.get(I);return this._entries.set(I,T),O}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}t.ServiceCollection=m}),define(J[100],Q([0,1,12,94,50,11,52,4]),function($,t,m,F,I,T,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const f=!1;class g extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class w{constructor(c=new O.ServiceCollection,d=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=S,this._services.set(T.IInstantiationService,this)}createChild(c){return new w(c,this._strict,this)}invokeFunction(c,...d){let S=b.traceInvocation(c),R=!1;try{return c({get:(p,r)=>{if(R)throw m.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(p,S);if(!o&&r!==T.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return o}},...d)}finally{R=!0,S.stop()}}createInstance(c,...d){let S,R;return c instanceof I.SyncDescriptor?(S=b.traceCreation(c.ctor),R=this._createInstance(c.ctor,c.staticArguments.concat(d),S)):(S=b.traceCreation(c),R=this._createInstance(c,d,S)),S.stop(),R}_createInstance(c,d=[],S){let R=T._util.getServiceDependencies(c).sort((r,o)=>r.index-o.index),D=[];for(const r of R){let o=this._getOrCreateServiceInstance(r.id,S);if(!o&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);D.push(o)}let p=R.length>0?R[0].index:d.length;if(d.length!==p){console.warn(`[createInstance] First service dependency of ${c.name} at position ${p+1} conflicts with ${d.length} static arguments`);let r=p-d.length;r>0?d=d.concat(new Array(r)):d=d.slice(0,p)}return new c(...[...d,...D])}_setServiceInstance(c,d){if(this._services.get(c)instanceof I.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,d.branch(c,!0)):(d.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,d,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,S){const R=new F.Graph(r=>r.id.toString());let D=0;const p=[{id:c,desc:d,_trace:S}];for(;p.length;){const r=p.pop();if(R.lookupOrInsertNode(r),D++>1e3)throw new g(R);for(let o of T._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`),e instanceof I.SyncDescriptor){const i={id:o.id,desc:e,_trace:r._trace.branch(o.id,!0)};R.insertEdge(r,i),p.push(i)}}}for(;;){const r=R.roots();if(r.length===0){if(!R.isEmpty())throw new g(R);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof I.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}R.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,S=[],R,D){if(this._services.get(c)instanceof I.SyncDescriptor)return this._createServiceInstance(d,S,R,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,S,R,D);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],S,R){if(S){const D=new C.IdleValue(()=>this._createInstance(c,d,R));return new Proxy(Object.create(null),{get(p,r){if(r in p)return p[r];let o=D.value,e=o[r];return typeof e!="function"||(e=e.bind(o),p[r]=e),e},set(p,r,o){return D.value[r]=o,!0}})}else return this._createInstance(c,d,R)}}t.InstantiationService=w;var E;(function(k){k[k.Creation=0]="Creation",k[k.Invocation=1]="Invocation",k[k.Branch=2]="Branch"})(E||(E={}));class b{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return f?new b(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(c){return f?new b(0,c.name):b._None}branch(c,d){let S=new b(2,c.toString());return this._dep.push([c,d,S]),S}stop(){let c=Date.now()-this._start;b._totals+=c;let d=!1;function S(D,p){let r=[],o=new Array(D+1).join("	");for(const[e,i,n]of p._dep)if(i&&n){d=!0,r.push(`${o}CREATES -> ${e}`);let s=S(D+1,n);s&&r.push(s)}else r.push(`${o}uses -> ${e}`);return r.join(`
`)}let R=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(R.join(`
`))}}b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(J[53],Q([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=m.createDecorator("localizationsService");function F(I){if(typeof I.languageId!="string"||!Array.isArray(I.translations)||I.translations.length===0)return!1;for(const T of I.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(I.languageName&&typeof I.languageName!="string"||I.localizedLanguageName&&typeof I.localizedLanguageName!="string")}t.isValidLocalization=F}),define(J[15],Q([0,1,11,2,14,10,28]),function($,t,m,F,I,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=m.createDecorator("logService"),t.ILoggerService=m.createDecorator("loggerService");function C(){return new Date().toISOString()}var f;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(f=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=f.Info;class g extends F.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class w extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(f.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=w;class E extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}debug(e,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}info(e,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,e,...i):console.log(`[main ${C()}]`,e,...i))}warn(e,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,e,...i):console.warn(`[main ${C()}]`,e,...i))}error(e,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}critical(e,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,e,...i):console.error(`[main ${C()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=E;class b extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=b;class k extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:O.toErrorMessage(e,this.getLevel()<=f.Trace)}dispose(){}flush(){}}t.AdapterLogger=k;class c extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class d extends F.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=d;class S extends F.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?f.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class R{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(e){}getLevel(){return f.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=R;function D(o){if(o.verbose)return f.Trace;if(typeof o.logLevel=="string"){const e=p(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=D;function p(o){switch(o){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}t.parseLogLevel=p;function r(o){switch(o){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}t.LogLevelToString=r}),define(J[101],Q([0,1,9,2,18,23,21,7,17,24,15,29,39,14,4,12]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let R=class extends F.Disposable{constructor(p,r,o,e){super();this.fileService=r,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=C.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,r){await this.cleanUpPromise;const o=this.getName(p),e=f.joinPath(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=f.joinPath(this.extensionsDownloadDir,`.${E.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(p,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${d.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(p){}async rename(p,r,o){try{await m.Promises.rename(p.fsPath,r.fsPath)}catch(e){if(k.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${p} to ${r} with 'EPERM' error. Trying again...`),this.rename(p,r,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const r=[],o=[];for(const n of p.children){const s=this.parse(n.name);s&&o.push([s,n])}const e=g.groupByExtension(o,([n])=>n),i=[];for(const n of e)n.sort((s,u)=>b.rcompare(s[0].version,u[0].version)),r.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():E.generateUuid()}parse(p){const r=S.exec(p);return r&&r[1]&&r[2]?new g.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};R=ue([fe(0,O.INativeEnvironmentService),fe(1,I.IFileService),fe(2,T.IExtensionGalleryService),fe(3,w.ILogService)],R),t.ExtensionsDownloader=R}),define(J[102],Q([0,1,2,15,32,28,3,4,10,8,9,21]),function($,t,m,F,I,T,O,C,f,g,w,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let b=class extends m.Disposable{constructor(c,d){super();this.environmentService=c,this.logService=d,this.processesLimiter=new C.Limiter(5)}async postUninstall(c){const d=this.parseScript(c,"uninstall");return d&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${S}`)))),w.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(c,d){const S=`vscode:${d}`;if(c.location.scheme===g.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[S]=="string"){const R=c.manifest.scripts[S].split(" ");return R.length<2||R[0]!=="node"||!R[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${S} should be a node script`),null):{script:O.join(c.location.fsPath,R[1]),args:R.slice(2)||[]}}return null}runLifecycleHook(c,d,S,R,D){return new Promise((p,r)=>{const o=this.start(c,d,S,D);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):p(void 0)};o.on("error",n=>{i(T.toErrorMessage(n)||"Unknown")}),o.on("exit",(n,s)=>{i(n?`post-${d} process exited with code ${n}`:void 0)}),R&&(e=setTimeout(()=>{e=null,o.kill(),r("timed out")},5e3))})}start(c,d,S,R){const D={silent:!0,execArgv:void 0},p=I.fork(c,[`--type=extension-post-${d}`,...S],D);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const r=f.Event.fromNodeEventEmitter(p.stdout,"data"),o=f.Event.fromNodeEventEmitter(p.stderr,"data");r(n=>this.logService.info(R.identifier.id,R.manifest.version,`post-${d}`,n)),o(n=>this.logService.error(R.identifier.id,R.manifest.version,`post-${d}`,n));const e=f.Event.any(f.Event.map(r,n=>({data:`%c${n}`,format:[""]})),f.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return f.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(R.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),p}getExtensionStoragePath(c){return O.join(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};b=ue([fe(0,E.IEnvironmentService),fe(1,F.ILogService)],b),t.ExtensionsLifecycle=b}),define(J[103],Q([0,1,2,21,10,18,7,24,17,15]),function($,t,m,F,I,T,O,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let w=class extends m.Disposable{constructor(b,k,c,d){super();this.extensionsManagementService=b,this.logService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(b.onInstallExtension(D=>this.onInstallExtension(D))),this._register(b.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(b.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const S=O.URI.file(c.extensionsPath),R=new f.ExtUri(D=>!k.hasCapability(D,1024));this._register(k.watch(S)),this._register(I.Event.filter(k.onDidChangeFilesRaw,D=>D.changes.some(p=>this.doesChangeAffects(p,S,R)))(()=>this.onDidChange()))}doesChangeAffects(b,k,c){return c.isEqual(c.dirname(b.resource),k)?c.isEqual(b.resource,c.joinPath(k,".obsolete"))?!0:!(b.type!==1&&b.type!==2||c.basename(b.resource).startsWith(".")):!1}onInstallExtension(b){this.addInstallingExtension(b.identifier)}onDidInstallExtension(b){this.removeInstallingExtension(b.identifier),b.error||this.addInstalledExtension(b.identifier)}onDidUninstallExtension(b){b.error||this.removeInstalledExtension(b.identifier)}addInstallingExtension(b){this.removeInstallingExtension(b),this.installingExtensions.push(b)}removeInstallingExtension(b){this.installingExtensions=this.installingExtensions.filter(k=>!C.areSameExtensions(k,b))}addInstalledExtension(b){this.installedExtensions&&(this.removeInstalledExtension(b),this.installedExtensions.push(b))}removeInstalledExtension(b){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(k=>!C.areSameExtensions(k,b)))}async onDidChange(){if(this.installedExtensions){const b=await this.extensionsManagementService.getInstalled(1),k=b.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(S=>C.areSameExtensions(S,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),c=this.installedExtensions.filter(d=>this.installingExtensions.some(S=>C.areSameExtensions(S,d))?!1:b.every(S=>!C.areSameExtensions(S.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=b.map(d=>d.identifier),(k.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:k,removed:c})}}};w=ue([fe(1,T.IFileService),fe(2,F.INativeEnvironmentService),fe(3,g.ILogService)],w),t.ExtensionsWatcher=w}),define(J[104],Q([0,1,9,127,23,2,21,4,24,15,53,22,10,8,3]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let d=class extends T.Disposable{constructor(D,p,r){super();this.extensionManagementService=D,this.logService=r,this._onDidLanguagesChange=this._register(new b.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(p,r)),this._register(D.onDidInstallExtension(({local:o})=>this.onDidInstallExtension(o))),this._register(D.onDidUninstallExtension(({identifier:o})=>this.onDidUninstallExtension(o)))}getLanguageIds(){return this.cache.getLanguagePacks().then(D=>{const p=["en",...Object.keys(D)];return E.distinct(p)})}onDidInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",D.identifier.id),this.update().then(p=>{p&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(D){this.cache.getLanguagePacks().then(p=>{Object.keys(p).some(r=>p[r]&&p[r].extensions.some(o=>f.areSameExtensions(o.extensionIdentifier,D)))&&(this.logService.debug("Removing language packs from the extension",D.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[D,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(p);return!E.equals(Object.keys(D),Object.keys(r))}};d=ue([fe(0,I.IExtensionManagementService),fe(1,O.INativeEnvironmentService),fe(2,g.ILogService)],d),t.LocalizationsService=d;let S=class extends T.Disposable{constructor(D,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=c.join(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new C.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(p=>{Object.keys(p).forEach(r=>delete p[r]),this.createLanguagePacksFromExtensions(p,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...p){for(const r of p)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,r);Object.keys(D).forEach(r=>this.updateHash(D[r]))}createLanguagePacksFromExtension(D,p){const r=p.identifier,o=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const e of o)if(p.location.scheme===k.Schemas.file&&w.isValidLocalization(e)){let i=D[e.languageId];i||(i={hash:"",extensions:[],translations:{}},D[e.languageId]=i);let n=i.extensions.filter(s=>f.areSameExtensions(s.extensionIdentifier,r))[0];n?n.version=p.manifest.version:i.extensions.push({extensionIdentifier:r,version:p.manifest.version});for(const s of e.translations)i.translations[s.id]=c.join(p.location.fsPath,s.path)}}updateHash(D){if(D){const p=F.createHash("md5");for(const r of D.extensions)p.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);D.hash=p.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(o){return{}}}).then(r=>(p=D(r),r)).then(r=>{for(const e of Object.keys(r))r[e]||delete r[e];this.languagePacks=r,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>p,r=>this.logService.error(r))})}};S=ue([fe(0,O.INativeEnvironmentService),fe(1,g.ILogService)],S)}),define(J[105],Q([0,1,15,18]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function I(f,g,w,E){try{const b=await new Promise((k,c)=>{$(["spdlog"],k,c)});return b.setFlushOn(m.LogLevel.Trace),b.createAsyncRotatingLogger(f,g,w,E)}catch(b){console.error(b)}return null}function T(f,g,w,E){const b=$.__$__nodeRequire("spdlog");return b.setFlushOn(m.LogLevel.Trace),b.createRotatingLogger(f,g,w,E)}t.createRotatingLogger=T;function O(f,g,w){switch(g){case m.LogLevel.Trace:f.trace(w);break;case m.LogLevel.Debug:f.debug(w);break;case m.LogLevel.Info:f.info(w);break;case m.LogLevel.Warning:f.warn(w);break;case m.LogLevel.Error:f.error(w);break;case m.LogLevel.Critical:f.critical(w);break;default:throw new Error("Invalid log level")}}class C extends m.AbstractMessageLogger{constructor(g,w,E,b){super();this.name=g,this.filepath=w,this.rotating=E,this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(k=>{this._logger&&this._logger.setLevel(k)}))}_createSpdLogLogger(){const g=this.rotating?6:1,w=30/g*F.ByteSize.MB;return I(this.name,this.filepath,w,g).then(E=>{if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:b,message:k}of this.buffer)O(this._logger,b,k);this.buffer=[]}})}log(g,w){this._logger?O(this._logger,g,w):this.getLevel()<=g&&this.buffer.push({level:g,message:w})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=C}),define(J[54],Q([0,1,81,16,18,12,40]),function($,t,m,F,I,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function C(E,b,k,c,d,S){let R;try{await f(E,b,k,c,d,S)}catch(D){R=D}finally{R&&d.errorTransformer&&(R=d.errorTransformer(R)),typeof R!="undefined"&&k.error(R),k.end()}}t.readFileIntoStream=C;async function f(E,b,k,c,d,S){g(S);const R=await E.open(b,{create:!1});try{g(S);let D=0,p=0,r=d&&typeof d.length=="number"?d.length:void 0,o=F.VSBuffer.alloc(Math.min(d.bufferSize,typeof r=="number"?r:d.bufferSize)),e=d&&typeof d.position=="number"?d.position:0,i=0;do p=await E.read(R,e,o.buffer,i,o.byteLength-i),e+=p,i+=p,D+=p,typeof r=="number"&&(r-=p),i===o.byteLength&&(await k.write(c(o)),o=F.VSBuffer.alloc(Math.min(d.bufferSize,typeof r=="number"?r:d.bufferSize)),i=0);while(p>0&&(typeof r!="number"||r>0)&&g(S)&&w(D,d));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),k.write(c(o.slice(0,n)))}}catch(D){throw I.ensureFileSystemProviderError(D)}finally{await E.close(R)}}function g(E){if(E.isCancellationRequested)throw T.canceled();return!0}function w(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw I.createFileSystemProviderError(m.localize(0,null,O.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw I.createFileSystemProviderError(m.localize(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[106],Q([0,1,80,128,2,18,10,17,45,22,15,16,34,4,26,8,54,129]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let D=class Ne extends I.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new O.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new T.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new k.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new T.FileChangesEvent(o,!0)))),this.watchedResources=f.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new k.ResourceQueue)}registerProvider(r,o){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);F.mark(`code/registerFilesystem/${r}`),this.provider.set(r,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:o});const e=new I.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:r}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),I.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:o}),this.provider.delete(r),I.dispose(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){o.push(e)}}),!this.provider.has(r)&&await k.Promises.settled(o)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,o){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return R.Iterable.map(this.provider,([r,o])=>({scheme:r,capabilities:o.capabilities}))}async withProvider(r){if(!C.isAbsolutePath(r))throw new T.FileOperationError(m.localize(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const o=this.provider.get(r.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=m.localize(1,null,r.toString()),e}return o}async withReadProvider(r){const o=await this.withProvider(r);if(T.hasOpenReadWriteCloseCapability(o)||T.hasReadWriteCapability(o)||T.hasFileReadStreamCapability(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const o=await this.withProvider(r);if(T.hasOpenReadWriteCloseCapability(o)||T.hasReadWriteCapability(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,o){try{return await this.doResolveFile(r,o)}catch(e){throw T.toFileSystemProviderErrorCode(e)===T.FileSystemProviderErrorCode.FileNotFound?new T.FileOperationError(m.localize(2,null,this.resourceForError(r)),1):T.ensureFileSystemProviderError(e)}}async doResolveFile(r,o){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,u=o?.resolveMetadata,y=await e.stat(r);let P;return this.toFileStat(e,r,y,void 0,!!u,(z,A)=>(P||(P=f.TernarySearchTree.forUris(()=>!i),P.set(r,!0),g.isNonEmptyArray(n)&&n.forEach(M=>P.set(M,!0))),Boolean(P.findSuperstr(z.resource)||P.get(z.resource))?!0:z.isDirectory&&s?A===1:!1))}async toFileStat(r,o,e,i,n,s){const{providerExtUri:u}=this.getExtUri(r),y={resource:o,name:u.basename(o),isFile:(e.type&T.FileType.File)!=0,isDirectory:(e.type&T.FileType.Directory)!=0,isSymbolicLink:(e.type&T.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&T.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:T.etag({mtime:e.mtime,size:e.size})};if(y.isDirectory&&s(y,i)){try{const P=await r.readdir(o),z=await k.Promises.settled(P.map(async([A,M])=>{try{const V=u.joinPath(o,A),_=n?await r.stat(V):{type:M};return await this.toFileStat(r,V,_,P.length,n,s)}catch(V){return this.logService.trace(V),null}}));y.children=g.coalesce(z)}catch(P){this.logService.trace(P),y.children=[]}return y}return y}async resolveAll(r){return k.Promises.settled(r.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const o=await this.withProvider(r);try{return!!await o.stat(r)}catch(e){return!1}}async canCreateFile(r,o){try{await this.doValidateCreateFile(r,o)}catch(e){return e}return!0}async doValidateCreateFile(r,o){if(!o?.overwrite&&await this.exists(r))throw new T.FileOperationError(m.localize(3,null,this.resourceForError(r)),3,o)}async createFile(r,o=E.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,o);return this._onDidRunOperation.fire(new T.FileOperationEvent(r,0,i)),i}async writeFile(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let u;if(T.hasReadWriteCapability(i)&&!(o instanceof E.VSBuffer))if(b.isReadableStream(o)){const y=await b.peekStream(o,3);y.ended?u=E.VSBuffer.concat(y.buffer):u=y}else u=b.peekReadable(o,y=>E.VSBuffer.concat(y),3);else u=o;!T.hasOpenReadWriteCloseCapability(i)||T.hasReadWriteCapability(i)&&u instanceof E.VSBuffer?await this.doWriteUnbuffered(i,r,e,u):await this.doWriteBuffered(i,r,e,u instanceof E.VSBuffer?E.bufferToReadable(u):u)}catch(s){throw new T.FileOperationError(m.localize(4,null,this.resourceForError(r),T.ensureFileSystemProviderError(s).toString()),T.toFileOperationResult(s),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,o,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error(m.localize(5,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch(s){return}if((n.type&T.FileType.Directory)!=0)throw new T.FileOperationError(m.localize(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==T.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==T.etag({mtime:e.mtime,size:n.size}))throw new T.FileOperationError(m.localize(7,null),3,e);return n}async readFile(r,o){const e=await this.withReadProvider(r);return o?.atomic?this.doReadFileAtomic(e,r,o):this.doReadFile(e,r,o)}async doReadFileAtomic(r,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(r,o,e);i(s)}catch(s){n(s)}})})}async doReadFile(r,o,e){const i=await this.doReadFileStream(r,o,{...e,preferUnbuffered:!0});return{...i,value:await E.streamToBuffer(i.value)}}async readFileStream(r,o){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,o)}async doReadFileStream(r,o,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(o,e).then(u=>u,u=>{throw i.cancel(),u});let s;try{return e&&typeof e.etag=="string"&&e.etag!==T.ETAG_DISABLED&&await n,!(T.hasOpenReadWriteCloseCapability(r)||T.hasFileReadStreamCapability(r))||T.hasReadWriteCapability(r)&&e?.preferUnbuffered?s=this.readFileUnbuffered(r,o,e):T.hasFileReadStreamCapability(r)?s=this.readFileStreamed(r,o,i.token,e):s=this.readFileBuffered(r,o,i.token,e),{...await n,value:s}}catch(u){s&&await b.consumeStream(s);const y=m.localize(8,null,this.resourceForError(o),T.ensureFileSystemProviderError(u).toString());throw u instanceof T.NotModifiedSinceFileOperationError?new T.NotModifiedSinceFileOperationError(y,u.stat,e):new T.FileOperationError(y,T.toFileOperationResult(u),e)}}readFileStreamed(r,o,e,i=Object.create(null)){const n=r.readFileStream(o,i,e);return b.transform(n,{data:s=>s instanceof E.VSBuffer?s:E.VSBuffer.wrap(s),error:s=>new T.FileOperationError(m.localize(9,null,this.resourceForError(o),T.ensureFileSystemProviderError(s).toString()),T.toFileOperationResult(s),i)},s=>E.VSBuffer.concat(s))}readFileBuffered(r,o,e,i=Object.create(null)){const n=E.newWriteableBufferStream();return S.readFileIntoStream(r,o,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new T.FileOperationError(m.localize(10,null,this.resourceForError(o),T.ensureFileSystemProviderError(s).toString()),T.toFileOperationResult(s),i)},e),n}readFileUnbuffered(r,o,e){const i=b.newWriteableStream(n=>E.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(o);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(E.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,o){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new T.FileOperationError(m.localize(11,null,this.resourceForError(r)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==T.ETAG_DISABLED&&o.etag===e.etag)throw new T.NotModifiedSinceFileOperationError(m.localize(12,null),e,o);return this.validateReadFileLimits(r,e.size,o),e}validateReadFileLimits(r,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new T.FileOperationError(m.localize(13,null,this.resourceForError(r)),i)}}async canMove(r,o,e){return this.doCanMoveCopy(r,o,"move",e)}async canCopy(r,o,e){return this.doCanMoveCopy(r,o,"copy",e)}async doCanMoveCopy(r,o,e,i){if(r.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,r,s,o,e,i)}catch(n){return n}return!0}async move(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"move",!!e),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(r,s==="move"?2:3,u)),u}async copy(r,o,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"copy",!!e),u=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(r,s==="copy"?3:2,u)),u}async doMoveCopy(r,o,e,i,n,s){if(o.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:y}=await this.doValidateMoveCopy(r,o,e,i,n,s);if(u&&!y&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&T.hasFileFolderCopyCapability(r))await r.copy(o,i,{overwrite:s});else{const P=await this.resolve(o);P.isDirectory?await this.doCopyFolder(r,P,e,i):await this.doCopyFile(r,o,e,i)}return n}else return r===e?(await r.rename(o,i,{overwrite:s}),n):(await this.doMoveCopy(r,o,e,i,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(r,o,e,i){if(T.hasOpenReadWriteCloseCapability(r)&&T.hasOpenReadWriteCloseCapability(e))return this.doPipeBuffered(r,o,e,i);if(T.hasOpenReadWriteCloseCapability(r)&&T.hasReadWriteCapability(e))return this.doPipeBufferedToUnbuffered(r,o,e,i);if(T.hasReadWriteCapability(r)&&T.hasOpenReadWriteCloseCapability(e))return this.doPipeUnbufferedToBuffered(r,o,e,i);if(T.hasReadWriteCapability(r)&&T.hasReadWriteCapability(e))return this.doPipeUnbuffered(r,o,e,i)}async doCopyFolder(r,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await k.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,s):this.doCopyFile(r,n.resource,e,s)}))}async doValidateMoveCopy(r,o,e,i,n,s){let u=!1;if(r===e){const{providerExtUri:P,isPathCaseSensitive:z}=this.getExtUri(r);if(z||(u=P.isEqual(o,i)),u&&n==="copy")throw new Error(m.localize(14,null,this.resourceForError(o),this.resourceForError(i)));if(!u&&P.isEqualOrParent(i,o))throw new Error(m.localize(15,null,this.resourceForError(o),this.resourceForError(i)))}const y=await this.exists(i);if(y&&!u){if(!s)throw new T.FileOperationError(m.localize(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(r===e){const{providerExtUri:P}=this.getExtUri(r);if(P.isEqualOrParent(o,i))throw new Error(m.localize(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:u}}getExtUri(r){const o=this.isPathCaseSensitive(r);return{providerExtUri:o?C.extUri:C.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(o,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new T.FileOperationEvent(r,0,e)),e}async mkdirp(r,o){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(o,i.dirname(o));)try{if(((await r.stat(o)).type&T.FileType.Directory)==0)throw new Error(m.localize(18,null,this.resourceForError(o)));break}catch(n){if(T.toFileSystemProviderErrorCode(n)!==T.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await r.mkdir(o)}catch(s){if(T.toFileSystemProviderErrorCode(s)!==T.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(r,o){try{await this.doValidateDelete(r,o)}catch(e){return e}return!0}async doValidateDelete(r,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error(m.localize(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(u){}if(n)this.throwIfFileIsReadonly(r,n);else throw new T.FileOperationError(m.localize(20,null,this.resourceForError(r)),1);if(!!!o?.recursive){const u=await this.resolve(r);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(m.localize(21,null,this.resourceForError(r)))}return e}async del(r,o){const e=await this.doValidateDelete(r,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new T.FileOperationEvent(r,1))}onDidChangeFile(r,o){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new T.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,o={recursive:!1,excludes:[]}){const e=new I.DisposableStore;{let i=!1,n=()=>{i=!0};e.add(I.toDisposable(()=>n())),this.doWatch(r,o).then(s=>{i?I.dispose(s):n=()=>I.dispose(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add(I.toDisposable(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,o){const e=await this.withProvider(r),i=this.toWatchKey(e,r,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,I.toDisposable(()=>{n.count--,n.count===0&&(I.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,o,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>I.dispose(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(o,{create:!0,unlock:e?.unlock??!1});try{b.isReadableStream(i)||b.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(s){throw T.ensureFileSystemProviderError(s)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,o,e){let i=0,n;if(b.isReadableBufferedStream(e)){if(e.buffer.length>0){const s=E.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,o,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,u)=>{b.listenStream(n,{onData:async y=>{n.pause();try{await this.doWriteBuffer(r,o,y,y.byteLength,i,0)}catch(P){return u(P)}i+=y.byteLength,setTimeout(()=>n.resume())},onError:y=>u(y),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(r,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,o,e,i,n,s){let u=0;for(;u<i;)u+=await r.write(o,n+u,e.buffer,s+u,i-u)}async doWriteUnbuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,o,e,i))}async doWriteUnbufferedQueued(r,o,e,i){let n;i instanceof E.VSBuffer?n=i:b.isReadableStream(i)?n=await E.streamToBuffer(i):b.isReadableBufferedStream(i)?n=await E.bufferedStreamToBuffer(i):n=E.readableToBuffer(i),await r.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,o,e,i))}async doPipeBufferedQueued(r,o,e,i){let n,s;try{n=await r.open(o,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const u=E.VSBuffer.alloc(this.BUFFER_SIZE);let y=0,P=0,z=0;do z=await r.read(n,y,u.buffer,P,u.byteLength-P),await this.doWriteBuffer(e,s,u,z,y,P),y+=z,P+=z,P===u.byteLength&&(P=0);while(z>0)}catch(u){throw T.ensureFileSystemProviderError(u)}finally{await k.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,o,e,i))}async doPipeUnbufferedQueued(r,o,e,i){return e.writeFile(i,await r.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,o,e,i))}async doPipeUnbufferedToBufferedQueued(r,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await r.readFile(o);await this.doWriteBuffer(e,n,E.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw T.ensureFileSystemProviderError(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,o,e,i){const n=await E.streamToBuffer(this.readFileBuffered(r,o,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,o){if(r.capabilities&2048)throw new T.FileOperationError(m.localize(22,null,this.resourceForError(o)),6);return r}throwIfFileIsReadonly(r,o){if((o.permissions??0)&T.FilePermission.Readonly)throw new T.FileOperationError(m.localize(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===d.Schemas.file?r.fsPath:r.toString(!0)}};D.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},D=ue([fe(0,w.ILogService)],D),t.FileService=D}),define(J[107],Q([0,1,2,18,10,14,9,3,17,35,4,15,82,51,91,93,90,99,34,54,22,16]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R,D,p,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:u}=await O.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await O.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async y=>{try{let P;y.isSymbolicLink()?P=(await this.stat(f.joinPath(n,y.name))).type:P=this.toType(y),u.push([y.name,P])}catch(P){this.logService.trace(P)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let u;return s?.dangling?u=F.FileType.Unknown:n.isFile()?u=F.FileType.File:n.isDirectory()?u=F.FileType.Directory:u=F.FileType.Unknown,s&&(u|=F.FileType.SymbolicLink),u}async readFile(n){try{const s=this.toFilePath(n);return await O.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,u){const y=D.newWriteableStream(P=>o.VSBuffer.concat(P.map(z=>o.VSBuffer.wrap(z))).buffer);return p.readFileIntoStream(this,n,y,P=>P.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),y}async writeFile(n,s,u){let y;try{const P=this.toFilePath(n);if(!u.create||!u.overwrite){if(await O.Promises.exists(P)){if(!u.overwrite)throw F.createFileSystemProviderError(b.localize(0,null),F.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw F.createFileSystemProviderError(b.localize(1,null),F.FileSystemProviderErrorCode.FileNotFound)}y=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(y,0,s,0,s.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof y=="number"&&await this.close(y)}}async open(n,s){try{const u=this.toFilePath(n);if(F.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:z}=await O.SymlinkSupport.stat(u);z.mode&128||await O.Promises.chmod(u,z.mode|128)}catch(z){this.logService.trace(z)}let y;if(F.isFileOpenForWriteOptions(s)){if(T.isWindows)try{await O.Promises.truncate(u,0),y="r+"}catch(z){z.code!=="ENOENT"&&this.logService.trace(z)}y||(y="w")}else y="r";const P=await O.Promises.open(u,y);return this.mapHandleToPos.set(P,0),F.isFileOpenForWriteOptions(s)&&this.writeHandles.set(P,n),P}catch(u){throw F.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await O.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await O.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,u,y,P){const z=this.normalizePos(n,s);let A=null;try{const M=await O.Promises.read(n,u,y,P,z);return typeof M=="number"?A=M:A=M.bytesRead,A}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(n,z,A)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,u){const y=this.mapHandleToPos.get(n);typeof y=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,y+u):this.mapHandleToPos.delete(n)))}async write(n,s,u,y,P){return w.retry(()=>this.doWrite(n,s,u,y,P),100,3)}async doWrite(n,s,u,y,P){const z=this.normalizePos(n,s);let A=null;try{const M=await O.Promises.write(n,u,y,P,z);return typeof M=="number"?A=M:A=M.bytesWritten,A}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),M)}finally{this.updatePos(n,z,A)}}async mkdir(n){try{await O.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const u=this.toFilePath(n);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,s){s.recursive?await O.Promises.rm(n,O.RimRafMode.MOVE):await O.Promises.unlink(n)}async rename(n,s,u){const y=this.toFilePath(n),P=this.toFilePath(s);if(y!==P)try{await this.validateTargetDeleted(n,s,"move",u.overwrite),await O.Promises.move(y,P)}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error(b.localize(2,null,C.basename(y),C.basename(C.dirname(P)),z.toString()))),this.toFileSystemProviderError(z)}}async copy(n,s,u){const y=this.toFilePath(n),P=this.toFilePath(s);if(y!==P)try{await this.validateTargetDeleted(n,s,"copy",u.overwrite),await O.Promises.copy(y,P,{preserveSymlinks:!0})}catch(z){throw(z.code==="EINVAL"||z.code==="EBUSY"||z.code==="ENAMETOOLONG")&&(z=new Error(b.localize(3,null,C.basename(y),C.basename(C.dirname(P)),z.toString()))),this.toFileSystemProviderError(z)}}async validateTargetDeleted(n,s,u,y){const P=this.toFilePath(n),z=this.toFilePath(s);let A=!1;if(!!(this.capabilities&1024)||(A=g.isEqual(P,z,!0)),A&&u==="copy")throw F.createFileSystemProviderError(b.localize(4,null),F.FileSystemProviderErrorCode.FileExists);if(!A&&await O.Promises.exists(z)){if(!y)throw F.createFileSystemProviderError(b.localize(5,null),F.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const u={path:this.toFilePath(n),excludes:s},y=r.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),m.toDisposable(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=c.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?T.isWindows?n=d.FileWatcher:n=c.FileWatcher:n=S.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire(k.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===E.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new R.FileWatcher(this.toFilePath(n),y=>this._onDidChangeFile.fire(k.toFileChanges(y)),y=>{y.type==="error"&&this._onDidWatchErrorOccur.fire(y.message),this.logService[y.type](y.message)},this.logService.getLevel()===E.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)});return m.combinedDisposable(s,u)}toFilePath(n){return C.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof F.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=F.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=F.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=F.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=F.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=F.FileSystemProviderErrorCode.NoPermissions;break;default:s=F.FileSystemProviderErrorCode.Unknown}return F.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let u=this.toFileSystemProviderError(s);if(n&&u.code===F.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await O.SymlinkSupport.stat(this.toFilePath(n));y.mode&128||(u=F.createFileSystemProviderError(s,F.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.logService.trace(y)}return u}dispose(){super.dispose(),m.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,m.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(J[41],Q([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=m.createDecorator("productService")}),define(J[25],Q([0,1,13,57]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class I{constructor(){this.data=new Map}add(O,C){F.ok(m.isString(O)),F.ok(m.isObject(C)),F.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,C)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}t.Registry=new I}),define(J[108],Q([0,1,25,10]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function I(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new F.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,g){this.schemasById[I(f)]=g,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new T;m.Registry.add(t.Extensions.JSONContribution,O)}),define(J[30],Q([0,1,73,10,25,13,108]),function($,t,m,F,I,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=I.Registry.as(O.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new F.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new F.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(R,D=!0){this.registerConfigurations([R],D)}registerConfigurations(R,D=!0){const p=[];R.forEach(r=>{p.push(...this.validateAndRegisterProperties(r,D,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(R){const D=[],p=r=>{if(r.properties)for(const o in r.properties)D.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o]);r.allOf&&r.allOf.forEach(o=>p(o))};for(const r of R){p(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(R){const D=[],p=[];for(const r of R)for(const o in r)if(D.push(o),t.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]={...this.defaultValues[o]||{},...r[o]};const e={type:"object",default:this.defaultValues[o],description:m.localize(1,null,o),$ref:t.resourceLanguageSettingsSchemaId};p.push(E(o)),this.configurationProperties[o]=e,this.defaultLanguageConfigurationOverridesNode.properties[o]=e}else{this.defaultValues[o]=r[o];const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(R){const D=[];for(const p of R)for(const r in p)if(D.push(r),delete this.defaultValues[r],t.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...R){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(R){for(const D of R)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(R,D=!0,p,r=3){r=T.isUndefinedOrNull(R.scope)?r:R.scope;let o=[],e=R.properties;if(e)for(let n in e){if(D&&c(n)){delete e[n];continue}const s=e[n];if(this.updatePropertyDefaultValue(n,s),t.OVERRIDE_PROPERTY_PATTERN.test(n)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?r:s.scope,s.restricted=T.isUndefinedOrNull(s.restricted)?!!p?.restrictedConfigurations?.includes(n):s.restricted),e[n].hasOwnProperty("included")&&!e[n].included){this.excludedConfigurationProperties[n]=e[n],delete e[n];continue}else this.configurationProperties[n]=e[n];!e[n].deprecationMessage&&e[n].markdownDeprecationMessage&&(e[n].deprecationMessage=e[n].markdownDeprecationMessage),o.push(n)}let i=R.allOf;if(i)for(let n of i)o.push(...this.validateAndRegisterProperties(n,D,p,r));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(R){const D=p=>{let r=p.properties;if(r)for(const e in r)this.updateSchema(e,r[e]);let o=p.allOf;o&&o.forEach(D)};D(R)}updateSchema(R,D){switch(t.allSettings.properties[R]=D,D.scope){case 1:t.applicationSettings.properties[R]=D;break;case 2:t.machineSettings.properties[R]=D;break;case 6:t.machineOverridableSettings.properties[R]=D;break;case 3:t.windowSettings.properties[R]=D;break;case 4:t.resourceSettings.properties[R]=D;break;case 5:t.resourceSettings.properties[R]=D,this.resourceLanguageSettingsSchema.properties[R]=D;break}}removeFromSchema(R,D){switch(delete t.allSettings.properties[R],D.scope){case 1:delete t.applicationSettings.properties[R];break;case 2:delete t.machineSettings.properties[R];break;case 6:delete t.machineOverridableSettings.properties[R];break;case 3:delete t.windowSettings.properties[R];break;case 4:case 5:delete t.resourceSettings.properties[R];break}}updateOverridePropertyPatternKey(){for(const R of this.overrideIdentifiers.values()){const D=`[${R}]`,p={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,p),t.allSettings.properties[D]=p,t.applicationSettings.properties[D]=p,t.machineSettings.properties[D]=p,t.machineOverridableSettings.properties[D]=p,t.windowSettings.properties[D]=p,t.resourceSettings.properties[D]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(R,D){let p=this.defaultValues[R];T.isUndefined(p)&&(p=D.default),T.isUndefined(p)&&(p=b(D.type)),D.default=p}}const w="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(w);function E(S){return S.substring(1,S.length-1)}t.overrideIdentifierFromKey=E;function b(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=b;const k=new g;I.Registry.add(t.Extensions.Configuration,k);function c(S){return S.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(S)?m.localize(5,null,S):k.getConfigurationProperties()[S]!==void 0?m.localize(6,null,S):null:m.localize(4,null)}t.validateProperty=c;function d(){const S=[],R=k.getConfigurationProperties();for(const D of Object.keys(R))S.push([D,R[D].scope]);return S.push(["launch",4]),S.push(["task",4]),S}t.getScopes=d}),define(J[27],Q([0,1,20,13,7,25,11,30]),function($,t,m,F,I,T,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=O.createDecorator("configurationService");function f(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof I.URI)}t.isConfigurationOverrides=f;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function w(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=w;function E(i,n){const s=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],u=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],y=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const _=R(i.contents,V),X=R(n.contents,V);m.equals(_,X)||y.push(V)}}const P=[],z=V=>{const _={};for(const X of V)for(const ee of X.identifiers)_[o(ee)]=X;return _},A=n?z(n.overrides):{},M=i?z(i.overrides):{};if(Object.keys(A).length)for(const V of s){const _=A[V];_&&P.push([C.overrideIdentifierFromKey(V),_.keys])}if(Object.keys(M).length)for(const V of u){const _=M[V];_&&P.push([C.overrideIdentifierFromKey(V),_.keys])}if(Object.keys(A).length&&Object.keys(M).length)for(const V of y){const _=M[V],X=A[V];if(_&&X){const ee=E({contents:_.contents,keys:_.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});P.push([C.overrideIdentifierFromKey(V),[...ee.added,...ee.removed,...ee.updated]])}}return{added:s,removed:u,updated:y,overrides:P}}t.compare=E;function b(i,n){const s=[];for(const u of Object.keys(i))if(C.OVERRIDE_PROPERTY_PATTERN.test(u)){const y={};for(const P in i[u])y[P]=i[u][P];s.push({identifiers:[C.overrideIdentifierFromKey(u).trim()],keys:Object.keys(y),contents:k(y,n)})}return s}t.toOverrides=b;function k(i,n){const s=Object.create(null);for(let u in i)c(s,u,i[u],n);return s}t.toValuesTree=k;function c(i,n,s,u){const y=n.split("."),P=y.pop();let z=i;for(let A=0;A<y.length;A++){let M=y[A],V=z[M];switch(typeof V){case"undefined":V=z[M]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${y.slice(0,A+1).join(".")} is ${JSON.stringify(V)}`);return}z=V}if(typeof z=="object"&&z!==null)try{z[P]=s}catch(A){u(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(z)}`)}else u(`Ignoring ${n} as ${y.join(".")} is ${JSON.stringify(z)}`)}t.addToValueTree=c;function d(i,n){const s=n.split(".");S(i,s)}t.removeFromValueTree=d;function S(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const u=i[s];typeof u=="object"&&!Array.isArray(u)&&(S(u,n),Object.keys(u).length===0&&delete i[s])}}function R(i,n,s){function u(z,A){let M=z;for(const V of A){if(typeof M!="object"||M===null)return;M=M[V]}return M}const y=n.split("."),P=u(i,y);return typeof P=="undefined"?s:P}t.getConfigurationValue=R;function D(i,n,s){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in i?F.isObject(i[u])&&F.isObject(n[u])?D(i[u],n[u],s):s&&(i[u]=n[u]):i[u]=n[u])})}t.merge=D;function p(){const i=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=p;function r(){const i=Object.create(null),n=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let s in n){let u=n[s].default;c(i,s,u,y=>console.error(`Conflict in default settings: ${y}`))}return i}t.getDefaultValues=r;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,s){const u=i.inspect(n),y=i.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof y.userValue!="undefined"||typeof y.workspaceValue!="undefined"||typeof y.workspaceFolderValue!="undefined"?y.value:u.defaultValue}t.getMigratedSettingValue=e}),define(J[109],Q([0,1,58,45,22,13,20,7,30,27,25,2,10]),function($,t,m,F,I,T,O,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class k{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?g.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?g.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of I.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[s],y=i[s];y&&(typeof u=="object"&&typeof y=="object"?(u=O.deepClone(u),this.mergeContents(u,y)):u=y),n[s]=u}return new k(n,this.keys,this.overrides)}merge(...e){const i=O.deepClone(this.contents),n=O.deepClone(this.overrides),s=[...this.keys];for(const u of e){this.mergeContents(i,u.contents);for(const y of u.overrides){const[P]=n.filter(z=>I.equals(z.identifiers,y.identifiers));P?this.mergeContents(P.contents,y.contents):n.push(O.deepClone(y))}for(const y of u.keys)s.indexOf(y)===-1&&s.push(y)}return new k(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&T.isObject(e[n])&&T.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=O.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?O.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),g.addToValueTree(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&g.removeFromValueTree(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=k;class c extends k{constructor(){const e=g.getDefaultValues(),i=g.getConfigurationKeys(),n=[];for(const s of Object.keys(e))f.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[f.overrideIdentifierFromKey(s).trim()],keys:Object.keys(e[s]),contents:g.toValuesTree(e[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!T.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:u,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new k(n,s,u),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},n=null,s=[],u=[],y=[];function P(A){Array.isArray(s)?s.push(A):n&&(s[n]=A)}let z={onObjectBegin:()=>{let A={};P(A),u.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let A=[];P(A),u.push(s),s=A,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:P,onError:(A,M,V)=>{y.push({error:A,offset:M,length:V})}};if(e)try{m.visit(e,z),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(e,i){const n=w.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const u=g.toValuesTree(e,z=>console.error(`Conflict in settings file ${this._name}: ${z}`)),y=Object.keys(e),P=g.toOverrides(e,z=>console.error(`Conflict in settings file ${this._name}: ${z}`));return{contents:u,keys:y,overrides:P,restricted:s.restricted}}filter(e,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const u={},y=[];for(let P in e)if(f.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const z=this.filter(e[P],i,!1,s);u[P]=z.raw,y.push(...z.restricted)}else{const z=i[P],A=z?typeof z.scope!="undefined"?z.scope:3:void 0;z?.restricted&&y.push(P),(A===void 0||s.scopes===void 0||s.scopes.includes(A))&&(s.skipRestricted&&z?.restricted||(u[P]=e[P]))}return{raw:u,restricted:y}}}t.ConfigurationModelParser=d;class S extends E.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=S;class R{constructor(e,i,n=new k,s=new k,u=new F.ResourceMap,y=new k,P=new F.ResourceMap,z=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=y,this._memoryConfigurationByResource=P,this._freeze=z,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new k,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),z=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,_=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(e):u.freeze().getValue(e):void 0,X=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),ee=s.getValue(e),ie=I.distinct(I.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(e,Z)!==void 0);return{defaultValue:P,userValue:z,userLocalValue:A,userRemoteValue:M,workspaceValue:V,workspaceFolderValue:_,memoryValue:X,value:ee,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:z!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:u?.freeze().getValue(e),override:i.overrideIdentifier?u?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ie.length?ie:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>f.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=f.overrideIdentifierFromKey(s),y=this._defaultConfiguration.getKeysForOverrideIdentifier(u),P=e.getKeysForOverrideIdentifier(u),z=[...P.filter(A=>y.indexOf(A)===-1),...y.filter(A=>P.indexOf(A)===-1),...y.filter(A=>!O.equals(this._defaultConfiguration.override(u).getValue(A),e.override(u).getValue(A)))];return[u,z]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.localUserConfiguration,e),y=[...i,...n,...s];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.remoteUserConfiguration,e);let y=[...i,...n,...s];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:u}=g.compare(this.workspaceConfiguration,e);let y=[...i,...n,...s];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:u,removed:y,overrides:P}=g.compare(n,i);let z=[...s,...u,...y];return(z.length||!n)&&this.updateFolderConfiguration(e,i),{keys:z,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:u,overrides:y}=g.compare(i,void 0);return{keys:[...n,...s,...u],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(e);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:u}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),u=e.folders.reduce((y,P)=>(y.set(C.URI.revive(P[0]),this.parseConfigurationModel(P[1])),y),new F.ResourceMap);return new R(i,n,new k,s,u,new k,new F.ResourceMap,!1)}static parseConfigurationModel(e){return new k(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=R;function D(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const s of o)s.keys.forEach(u=>e.add(u)),s.overrides.forEach(([u,y])=>{const P=F.getOrSet(i,u,new Set);y.forEach(z=>P.add(z))});const n=[];return i.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=D;class p{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;e.keys.forEach(P=>u.add(P)),e.overrides.forEach(([,P])=>P.forEach(z=>u.add(z))),this.affectedKeys=[...u.values()];const y=new k;this.affectedKeys.forEach(P=>y.setValue(P,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=R.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!O.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=g.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=p;class r extends p{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=r}),define(J[110],Q([0,1,25,30,2,27,109,10,4,17]),function($,t,m,F,I,T,O,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class w extends I.Disposable{constructor(b,k){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,k)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(F.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,k){const c=typeof b=="string"?b:void 0,d=T.isConfigurationOverrides(b)?b:T.isConfigurationOverrides(k)?k:{};return this.configuration.getValue(c,d,void 0)}updateValue(b,k,c,d){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const k=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(c,k,1)}onDidDefaultConfigurationChange(b){const k=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,b);this.trigger(c,k,6)}trigger(b,k,c){const d=new O.ConfigurationChangeEvent(b,{data:k},this.configuration);d.source=c,d.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=w}),define(J[55],Q([0,1,83,11,30,25,16]),function($,t,m,F,I,T,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=F.createDecorator("requestService");function C(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=C;function f(c){return c.res.statusCode===204}async function g(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);return f(c)?null:(await O.streamToBuffer(c.stream)).toString()}t.asText=g;async function w(c){if(!C(c))throw new Error("Server returned "+c.res.statusCode);if(f(c))return null;const S=(await O.streamToBuffer(c.stream)).toString();try{return JSON.parse(S)}catch(R){throw R.message+=`:
`+S,R}}t.asJson=w;function E(c){k(c)}t.updateProxyConfigurationsScope=E;let b;function k(c){const d=T.Registry.as(I.Extensions.Configuration);b&&d.deregisterConfigurations([b]),b={id:"http",order:15,title:m.localize(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:m.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:m.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:m.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[m.localize(4,null),m.localize(5,null),m.localize(6,null),m.localize(7,null)],default:"override",description:m.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:m.localize(9,null),restricted:!0}}},d.registerConfiguration(b)}k(2)}),define(J[111],Q([0,1,112,13]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function I(O,C){return O.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:O.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function T(O,C,f={}){const g=m.parse(O),w=f.proxyUrl||I(g,C);if(!w)return null;const E=m.parse(w);if(!/^https?:$/.test(E.protocol||""))return null;const b={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:F.isBoolean(f.strictSSL)?f.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((k,c)=>{$(["http-proxy-agent"],k,c)}))(b):new(await new Promise((k,c)=>{$(["https-proxy-agent"],k,c)}))(b)}t.getProxyAgent=T}),define(J[113],Q([0,1,29,16]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function I(T,O,C){let f=C&&C.get("storage.serviceMachineId",0)||null;if(f)return f;try{const w=(await O.readFile(T.serviceMachineIdResource)).value.toString();f=m.isUUID(w)?w:null}catch(g){f=null}if(!f){f=m.generateUuid();try{await O.writeFile(T.serviceMachineIdResource,F.VSBuffer.fromString(f))}catch(g){}}return C&&C.store("storage.serviceMachineId",f,0,1),f}t.getServiceMachineId=I}),define(J[114],Q([0,1,11,10,2,13,66,4]),function($,t,m,F,I,T,O,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";t.IStorageService=m.createDecorator("storageService");var g;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var w;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(w=t.StorageScope||(t.StorageScope={}));var E;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(E=t.StorageTarget||(t.StorageTarget={}));class b extends I.Disposable{constructor(S={flushInterval:b.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new F.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new F.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new F.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=C.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){I.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,R){R===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:R,target:this.getKeyTargets(S)[R]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,R,D){return this.getStorage(R)?.get(S,D)}getBoolean(S,R,D){return this.getStorage(R)?.getBoolean(S,D)}getNumber(S,R,D){return this.getStorage(R)?.getNumber(S,D)}store(S,R,D,p){if(T.isUndefinedOrNull(R)){this.remove(S,D);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,D,p),this.getStorage(D)?.set(S,R)})}remove(S,R){this.withPausedEmitters(()=>{this.updateKeyTarget(S,R,void 0),this.getStorage(R)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,R){const D=[],p=this.getKeyTargets(S);for(const r of Object.keys(p))p[r]===R&&D.push(r);return D}updateKeyTarget(S,R,D){const p=this.getKeyTargets(R);typeof D=="number"?p[S]!==D&&(p[S]=D,this.getStorage(R)?.set(f,JSON.stringify(p))):typeof p[S]=="number"&&(delete p[S],this.getStorage(R)?.set(f,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const R=this.get(f,S);if(R)try{return JSON.parse(R)}catch(D){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(){this._onWillSaveState.fire({reason:g.NONE}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,R=this.getStorage(1)?.items??new Map;return c(S,R,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=b,b.DEFAULT_FLUSH_INTERVAL=60*1e3;class k extends b{constructor(){super();this.globalStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=k;async function c(d,S,R,D){const p=u=>{try{return JSON.parse(u)}catch(y){return u}},r=new Map,o=new Map;d.forEach((u,y)=>{r.set(y,u),o.set(y,p(u))});const e=new Map,i=new Map;S.forEach((u,y)=>{e.set(y,u),i.set(y,p(u))}),console.group(`Storage: Global (path: ${R})`);let n=[];r.forEach((u,y)=>{n.push({key:y,value:u})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${D})`);let s=[];e.forEach((u,y)=>{s.push({key:y,value:u})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=c}),define(J[115],Q([0,1,14,33,29,7]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function O(g){if(m.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function C(g,w,E,b,k,c,d,S,R,D){const p=Object.create(null);p["common.machineId"]=d,p.sessionID=I.generateUuid()+Date.now(),p.commitHash=k,p.version=c,p["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=m.PlatformToString(m.platform),p["common.nodePlatform"]=F.platform,p["common.nodeArch"]=b,p["common.product"]=D||"desktop";const r=f(S||[]);r&&(p["common.msftInternal"]=r);let o=0;const e=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),m.isLinuxSnap&&(p["common.snap"]="true");const i=O(E);i&&(p["common.platformDetail"]=i);try{const n=await g.readFile(T.URI.file(R));p["common.source"]=n.value.toString().slice(0,30)}catch(n){}return p}t.resolveCommonProperties=C;function f(g){const w=F.env.USERDNSDOMAIN;if(!w)return!1;const E=w.toLowerCase();return g.some(b=>E===b)}t.verifyMicrosoftInternalDomain=f}),define(J[42],Q([0,1,11]),function($,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=m.createDecorator("telemetryService"),t.ICustomEndpointTelemetryService=m.createDecorator("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(J[116],Q([0,1,12,23,24,20,42,55,49,21,26,15,18,7,41,114,113,11,17]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var p;(function(K){K[K.None=0]="None",K[K.IncludeVersions=1]="IncludeVersions",K[K.IncludeFiles=2]="IncludeFiles",K[K.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",K[K.IncludeSharedAccounts=8]="IncludeSharedAccounts",K[K.IncludeVersionProperties=16]="IncludeVersionProperties",K[K.ExcludeNonValidated=32]="ExcludeNonValidated",K[K.IncludeInstallationTargets=64]="IncludeInstallationTargets",K[K.IncludeAssetUri=128]="IncludeAssetUri",K[K.IncludeStatistics=256]="IncludeStatistics",K[K.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",K[K.Unpublished=4096]="Unpublished"})(p||(p={}));function r(...K){return String(K.reduce((a,l)=>a|l,0))}var o;(function(K){K[K.Tag=1]="Tag",K[K.ExtensionId=4]="ExtensionId",K[K.Category=5]="Category",K[K.ExtensionName=7]="ExtensionName",K[K.Target=8]="Target",K[K.Featured=9]="Featured",K[K.SearchText=10]="SearchText",K[K.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:p.None,criteria:[],assetTypes:[]};class u{constructor(a=s){this.state=a}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(a,l=this.state.pageSize){return new u({...this.state,pageNumber:a,pageSize:l})}withFilter(a,...l){const h=[...this.state.criteria,...l.length?l.map(v=>({filterType:a,value:v})):[{filterType:a}]];return new u({...this.state,criteria:h})}withSortBy(a){return new u({...this.state,sortBy:a})}withSortOrder(a){return new u({...this.state,sortOrder:a})}withFlags(...a){return new u({...this.state,flags:a.reduce((l,h)=>l|h,0)})}withAssetTypes(...a){return new u({...this.state,assetTypes:a})}get raw(){const{criteria:a,pageNumber:l,pageSize:h,sortBy:v,sortOrder:L,flags:N,assetTypes:U}=this.state;return{filters:[{criteria:a,pageNumber:l,pageSize:h,sortBy:v,sortOrder:L}],assetTypes:U,flags:N}}get searchText(){const a=this.state.criteria.filter(l=>l.filterType===o.SearchText)[0];return a&&a.value?a.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(a=>String(a.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function y(K,a){const l=(K||[]).filter(h=>h.statisticName===a)[0];return l?l.value:0}function P(K){const a="Microsoft.VisualStudio.Code.Translation.";return K.files.filter(h=>h.assetType.indexOf(a)===0).reduce((h,v)=>{const L=V(K,v.assetType);return L&&h.push([v.assetType.substring(a.length),L]),h},[])}function z(K){if(K.properties){const a=K.properties.filter(v=>v.key===e.Repository),l=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),h=a.filter(v=>l.test(v.value))[0];return h?{uri:h.value,fallbackUri:h.value}:null}return V(K,e.Repository)}function A(K){return{uri:`${K.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${K.fallbackAssetUri}/${e.VSIX}`}}function M(K){const a=V(K,e.Icon);if(a)return a;const l=F.DefaultIconPath;return{uri:l,fallbackUri:l}}function V(K,a){return K.files.filter(h=>h.assetType===a)[0]?{uri:`${K.assetUri}/${a}`,fallbackUri:`${K.fallbackAssetUri}/${a}`}:null}function _(K,a){const l=K.properties?K.properties.filter(v=>v.key===a):[],h=l.length>0&&l[0].value;return h?h.split(",").map(v=>I.adoptToGalleryExtensionId(v)):[]}function X(K){const a=K.properties?K.properties.filter(l=>l.key===i.Engine):[];return a.length>0&&a[0].value||""}function ee(K){const a=K.properties?K.properties.filter(h=>h.key===i.LocalizedLanguages):[],l=a.length>0&&a[0].value||"";return l?l.split(","):[]}function ie(K){return K.indexOf("preview")!==-1}function Z(K){return K.files.some(a=>a.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?D.joinPath(k.URI.parse(K.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function oe(K,a,l,h,v){const L={manifest:V(a,e.Manifest),readme:V(a,e.Details),changelog:V(a,e.Changelog),license:V(a,e.License),repository:z(a),download:A(a),icon:M(a),coreTranslations:P(a)};return{identifier:{id:I.getGalleryExtensionId(K.publisher.publisherName,K.extensionName),uuid:K.extensionId},name:K.extensionName,version:a.version,date:a.lastUpdated,displayName:K.displayName,publisherId:K.publisher.publisherId,publisher:K.publisher.publisherName,publisherDisplayName:K.publisher.displayName,description:K.shortDescription||"",installCount:y(K.statistics,"install"),rating:y(K.statistics,"averagerating"),ratingCount:y(K.statistics,"ratingcount"),assetUri:k.URI.parse(a.assetUri),webExtension:!!K.tags?.includes(F.WEB_EXTENSION_TAG),webResource:Z(a),assetTypes:a.files.map(({assetType:N})=>N),assets:L,properties:{dependencies:_(a,i.Dependency),extensionPack:_(a,i.ExtensionPack),engine:X(a),localizedLanguages:ee(a)},telemetryData:{index:(h.pageNumber-1)*h.pageSize+l,querySource:v},preview:ie(K.flags)}}let se=class{constructor(a,l,h,v,L,N,U){this.requestService=a,this.logService=l,this.environmentService=h,this.telemetryService=v,this.fileService=L,this.productService=N;const j=N.extensionsGallery;this.extensionsGalleryUrl=j&&j.serviceUrl,this.extensionsControlUrl=j&&j.controlUrl,this.commonHeadersPromise=re(N.version,this.environmentService,this.fileService,U)}api(a=""){return`${this.extensionsGalleryUrl}${a}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(a,l){const h=[];let{total:v,firstPage:L,getPage:N}=await this.query({names:a,pageSize:a.length},l);h.push(...L);for(let U=1;h.length<v&&(L=await N(U,l),L.length);U++)h.push(...L);return h}async getCompatibleExtension(a,l){return this.getCompatibleExtensionByEngine(a,l)}async getCompatibleExtensionByEngine(a,l){const h=F.isIExtensionIdentifier(a)?null:a;if(h&&h.properties.engine&&f.isEngineValid(h.properties.engine,this.productService.version,this.productService.date))return h;const{id:v,uuid:L}=h?h.identifier:a;let N=new u().withFlags(p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");L?N=N.withFilter(o.ExtensionId,L):N=N.withFilter(o.ExtensionName,v);const{galleryExtensions:U}=await this.queryGallery(N,w.CancellationToken.None),[j]=U;if(!j||!j.versions.length)return null;if(l){const W=j.versions.filter(H=>H.version===l)[0];if(W){const H=oe(j,W,0,N);if(H.properties.engine&&f.isEngineValid(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const B=await this.getLastValidExtensionVersion(j,j.versions);return B?oe(j,B,0,N):null}async query(a,l){const h=w.CancellationToken.isCancellationToken(a)?{}:a,v=w.CancellationToken.isCancellationToken(a)?a:l;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let L=h.text||"";const N=T.getOrDefault(h,Y=>Y.pageSize,50);let U=new u().withFlags(p.IncludeLatestVersionOnly,p.IncludeAssetUri,p.IncludeStatistics,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,N).withFilter(o.Target,"Microsoft.VisualStudio.Code");L?(L=L.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,te,ae)=>(U=U.withFilter(o.Category,ae||te),"")),L=L.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,te,ae)=>(U=U.withFilter(o.Tag,ae||te),"")),L=L.replace(/\bfeatured(\s+|\b|$)/g,()=>(U=U.withFilter(o.Featured),"")),L=L.trim(),L&&(L=L.length<200?L:L.substring(0,200),U=U.withFilter(o.SearchText,L)),U=U.withSortBy(0)):h.ids?U=U.withFilter(o.ExtensionId,...h.ids):h.names?U=U.withFilter(o.ExtensionName,...h.names):U=U.withSortBy(4),typeof h.sortBy=="number"&&(U=U.withSortBy(h.sortBy)),typeof h.sortOrder=="number"&&(U=U.withSortOrder(h.sortOrder));const{galleryExtensions:j,total:B}=await this.queryGallery(U,v),W=j.map((Y,te)=>oe(Y,Y.versions[0],te,U,h.source)),H=async(Y,te)=>{if(te.isCancellationRequested)throw m.canceled();const ae=U.withPage(Y+1),{galleryExtensions:me}=await this.queryGallery(ae,te);return me.map((ve,Oe)=>oe(ve,ve.versions[0],Oe,ae,h.source))};return{firstPage:W,total:B,pageSize:U.pageSize,getPage:H}}async queryGallery(a,l){if(!this.isEnabled())throw new Error("No extension gallery service configured.");a=a.withFlags(a.flags,p.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,r(p.Unpublished));const h=await this.commonHeadersPromise,v=JSON.stringify(a.raw),L={...h,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(v.length)},N=new Date().getTime();let U,j,B=0;try{if(U=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:v,headers:L},l),U.res.statusCode&&U.res.statusCode>=400&&U.res.statusCode<500)return{galleryExtensions:[],total:B};const W=await C.asJson(U);if(W){const H=W.results[0],Y=H.extensions,te=H.resultMetadata&&H.resultMetadata.filter(ae=>ae.metadataType==="ResultCount")[0];return B=te&&te.metadataItems.filter(ae=>ae.name==="TotalCount")[0].count||0,{galleryExtensions:Y,total:B}}return{galleryExtensions:[],total:B}}catch(W){throw j=W,W}finally{this.telemetryService.publicLog2("galleryService:query",{...a.telemetryData,requestBodySize:String(v.length),duration:new Date().getTime()-N,success:!!U&&C.isSuccess(U),responseBodySize:U?.res.headers["Content-Length"],statusCode:U?String(U.res.statusCode):void 0,errorCode:j?m.isPromiseCanceledError(j)?"canceled":m.getErrorMessage(j).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(B)})}}async reportStatistic(a,l,h,v){if(!this.isEnabled())return;const N={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${a}/extensions/${l}/${h}/stats?statType=${v}`),headers:N},w.CancellationToken.None)}catch(U){}}async download(a,l,h){this.logService.trace("ExtensionGalleryService#download",a.identifier.id);const v=I.getGalleryExtensionTelemetryData(a),L=new Date().getTime(),N=W=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...v,duration:W}),U=h===1?"install":h===2?"update":"",j=U?{uri:`${a.assets.download.uri}&${U}=true`,fallbackUri:`${a.assets.download.fallbackUri}?${U}=true`}:a.assets.download,B=await this.getAsset(j);await this.fileService.writeFile(l,B.stream),N(new Date().getTime()-L)}async getReadme(a,l){if(a.assets.readme){const h=await this.getAsset(a.assets.readme,{},l);return await C.asText(h)||""}return""}async getManifest(a,l){if(a.assets.manifest){const h=await this.getAsset(a.assets.manifest,{},l),v=await C.asText(h);return v?JSON.parse(v):null}return null}async getCoreTranslation(a,l){const h=a.assets.coreTranslations.filter(v=>v[0]===l.toUpperCase())[0];if(h){const v=await this.getAsset(h[1]),L=await C.asText(v);return L?JSON.parse(L):null}return null}async getChangelog(a,l){if(a.assets.changelog){const h=await this.getAsset(a.assets.changelog,{},l);return await C.asText(h)||""}return""}async getAllVersions(a,l){let h=new u().withFlags(p.IncludeVersions,p.IncludeCategoryAndTags,p.IncludeFiles,p.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");a.identifier.uuid?h=h.withFilter(o.ExtensionId,a.identifier.uuid):h=h.withFilter(o.ExtensionName,a.identifier.id);const v=[],{galleryExtensions:L}=await this.queryGallery(h,w.CancellationToken.None);return L.length&&(l?await Promise.all(L[0].versions.map(async N=>{let U;try{U=await this.getEngine(N)}catch(j){}U&&f.isEngineValid(U,this.productService.version,this.productService.date)&&v.push({version:N.version,date:N.lastUpdated})})):v.push(...L[0].versions.map(N=>({version:N.version,date:N.lastUpdated})))),v}async getAsset(a,l={},h=w.CancellationToken.None){const v=await this.commonHeadersPromise,L={type:"GET"},N={...v,...l.headers||{}};l={...l,...L,headers:N};const U=a.uri,j=a.fallbackUri,B={...l,url:U};try{const W=await this.requestService.request(B,h);if(W.res.statusCode===200)return W;const H=await C.asText(W);throw new Error(`Expected 200, got back ${W.res.statusCode} instead.

${H}`)}catch(W){if(m.isPromiseCanceledError(W))throw W;const H=m.getErrorMessage(W);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:U,message:H});const Y={...l,url:j};return this.requestService.request(Y,h)}}async getLastValidExtensionVersion(a,l){const h=this.getLastValidExtensionVersionFromProperties(a,l);return h||this.getLastValidExtensionVersionRecursively(a,l)}getLastValidExtensionVersionFromProperties(a,l){for(const h of l){const v=X(h);if(!v)return null;if(f.isEngineValid(v,this.productService.version,this.productService.date))return h}return null}async getEngine(a){const l=X(a);if(l)return l;const h=V(a,e.Manifest);if(!h)throw new Error("Manifest was not found");const v={"Accept-Encoding":"gzip"},L=await this.getAsset(h,{headers:v}),N=await C.asJson(L);if(N)return N.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(a,l){if(!l.length)return null;const h=l[0],v=await this.getEngine(h);return f.isEngineValid(v,this.productService.version,this.productService.date)?{...h,properties:[...h.properties||[],{key:i.Engine,value:v}]}:this.getLastValidExtensionVersionRecursively(a,l.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const a=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},w.CancellationToken.None);if(a.res.statusCode!==200)throw new Error("Could not get extensions report.");const l=await C.asJson(a),h=new Map;if(l)for(const v of l.malicious){const L=h.get(v)||{id:{id:v},malicious:!0,slow:!1};L.malicious=!0,h.set(v,L)}return[...h.values()]}};se=ue([fe(0,C.IRequestService),fe(1,E.ILogService),fe(2,g.IEnvironmentService),fe(3,O.ITelemetryService),fe(4,b.IFileService),fe(5,c.IProductService),fe(6,R.optional(d.IStorageService))],se),t.ExtensionGalleryService=se;async function re(K,a,l,h){const v={"X-Market-Client-Id":`VSCode ${K}`,"User-Agent":`VSCode ${K}`},L=await S.getServiceMachineId(a,l,h);return v["X-Market-User-Id"]=L,v}t.resolveMarketplaceHeaders=re}),define(J[117],Q([0,1,40,84,19,11,27,30,2,20,25]),function($,t,m,F,I,T,O,C,f,g,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let E=class{constructor(c,d){this._configurationService=d,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(I.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const R=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!R})}))}setExperimentProperty(c,d){this._experimentProperties[c]=d}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(b);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let d=c.sessionID,S=c["common.instanceId"],R=c["common.machineId"],D=c["common.firstSessionDate"],p=c["common.msftInternal"];return{sessionId:d,instanceId:S,machineId:R,firstSessionDate:D,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(c,d,S){return this.isOptedIn?this._commonProperties.then(R=>{d=g.mixin(d,R),d=g.mixin(d,this._experimentProperties),d=g.cloneAndChange(d,D=>{if(typeof D=="string")return this._cleanupInfo(D,S)}),this._appender.log(c,d)},R=>{console.error(R)}):Promise.resolve(void 0)}publicLog2(c,d,S){return this.publicLog(c,d,S)}publicLogError(c,d){return this.sendErrorTelemetry?this.publicLog(c,d,!0):Promise.resolve(void 0)}publicLogError2(c,d){return this.publicLogError(c,d)}_cleanupInfo(c,d){let S=c;if(d){const R=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(c);if(!e)break;R.push([e.index,o.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(S="";;){const o=p.exec(c);if(!o)break;!D.test(o[0])&&R.every(([e,i])=>o.index<e||o.index>=i)&&(S+=c.substring(r,o.index)+"<REDACTED: user-file-path>",r=p.lastIndex)}r<c.length&&(S+=c.substr(r))}for(let R of this._cleanupPatterns)S=S.replace(R,"");return S}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=ue([fe(1,T.optional(O.IConfigurationService))],E),t.TelemetryService=E;const b="telemetry";w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:b,order:110,type:"object",title:F.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?F.localize(2,null,m.default.privacyStatementUrl):F.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[56],Q([0,1,27,20,13,4]),function($,t,m,F,I,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,d){return Promise.resolve(void 0)}publicLog2(c,d){return this.publicLog(c,d)}publicLogError(c,d){return Promise.resolve(void 0)}publicLogError2(c,d){return this.publicLogError(c,d)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(d,S,R){}async publicLogError(d,S,R){}}t.NullEndpointTelemetryService=O;function C(...c){return{log:(d,S)=>c.forEach(R=>R.log(d,S)),flush:()=>T.Promises.settled(c.map(d=>d.flush()))}}t.combinedAppender=C,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(c,d){return d.onDidChangeConfiguration(S=>{S.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:m.ConfigurationTargetToString(S.source),configurationKeys:b(S.sourceConfig)})})}t.configurationTelemetry=f;function g(c){const d=Object.create(null),S=Object.create(null),R=Object.create(null);E(c,R);for(let D in R){D=D.length>150?D.substr(D.length-149):D;const p=R[D];typeof p=="number"?S[D]=p:typeof p=="boolean"?S[D]=p?1:0:typeof p=="string"?d[D]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(d[D]=p)}return{properties:d,measurements:S}}t.validateTelemetryData=g;function w(c){if(!c)return"none";let d="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(R=>{c.indexOf(`${R}+`)===0&&(d=R)}),d}t.cleanRemoteAuthority=w;function E(c,d,S=0,R){if(!!c)for(let D of Object.getOwnPropertyNames(c)){const p=c[D],r=R?R+D:D;Array.isArray(p)?d[r]=F.safeStringify(p):p instanceof Date?d[r]=p.toISOString():I.isObject(p)?S<2?E(p,d,S+1,r+"."):d[r]=F.safeStringify(p):d[r]=p}}function b(c){if(!c)return[];const d=[];return k(d,"",c),d}function k(c,d,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(R=>k(c,d?`${d}.${R}`:R,S[R])):c.push(d)}}),define(J[118],Q([0,1,12,20,56]),function($,t,m,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function T(C){const f=await new Promise((w,E)=>{$(["applicationinsights"],w,E)});let g;return f.defaultClient?(g=new f.TelemetryClient(C),g.channel.setUseDiskRetryCaching(!0)):(f.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=f.defaultClient),C.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class O{constructor(f,g,w){this._eventPrefix=f,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof w=="function"?this._aiClient=w():this._aiClient=w,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(g=>{f(g)},g=>{m.onUnexpectedError(g),console.error(g)})}}log(f,g){!this._aiClient||(g=F.mixin(g,this._defaultData),g=I.validateTelemetryData(g),this._withAIClient(w=>w.trackEvent({name:this._eventPrefix+"/"+f,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=O}),define(J[119],Q([0,1,9,3]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function I(T,O){const C=Object.create(null),f=(w,E)=>{const b=JSON.parse(w);C[E]=b};if(O){const w=[],E=await m.Promises.readdir(O);for(const k of E)try{(await m.Promises.stat(F.join(O,k))).isDirectory()&&w.push(k)}catch{}const b=[];for(const k of w)(await m.Promises.readdir(F.join(O,k))).filter(d=>d==="telemetry.json").length===1&&b.push(k);for(const k of b){const c=(await m.Promises.readFile(F.join(O,k,"telemetry.json"))).toString();f(c,k)}}let g=(await m.Promises.readFile(F.join(T,"telemetry-core.json"))).toString();return f(g,"vscode-core"),g=(await m.Promises.readFile(F.join(T,"telemetry-extensions.json"))).toString(),f(g,"vscode-extensions"),JSON.stringify(C,null,4)}t.buildTelemetryMessage=I}),define(J[43],Q([0,1,72,3,36,4,9,130,131,13]),function($,t,m,F,I,T,O,C,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class w extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=w;function E(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function b(o){if(o instanceof w)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new w(e,o)}function k(o,e,i,n,s,u){const y=F.dirname(e),P=F.join(n,y);if(!P.startsWith(n))return Promise.reject(new Error(m.localize(0,null,e)));const z=F.join(n,e);let A;return u.onCancellationRequested(()=>{A&&A.destroy()}),Promise.resolve(O.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((M,V)=>{if(!u.isCancellationRequested)try{A=I.createWriteStream(z,{mode:i}),A.once("close",()=>M()),A.once("error",V),o.once("error",V),o.pipe(A)}catch(_){V(_)}}))}function c(o,e,i,n){let s=T.createCancelablePromise(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((y,P)=>{const z=new T.Sequencer,A=M=>{M.isCancellationRequested||(u++,o.readEntry())};o.once("error",P),o.once("close",()=>s.then(()=>{n.isCancellationRequested||o.entryCount===u?y():P(new w("Incomplete",new Error(m.localize(1,null,u,o.entryCount))))},P)),o.readEntry(),o.on("entry",M=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(M.fileName)){A(n);return}const V=M.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ee=F.join(e,V);s=T.createCancelablePromise(ie=>O.Promises.mkdir(ee,{recursive:!0}).then(()=>A(ie)).then(void 0,P));return}const _=S(o,M),X=E(M);s=T.createCancelablePromise(ee=>z.queue(()=>_.then(ie=>k(ie,V,X,e,i,ee).then(()=>A(ee)))).then(null,P))})})}function d(o,e=!1){return new Promise((i,n)=>{C.open(o,e?{lazyEntries:!0}:void 0,(s,u)=>{s?n(b(s)):i(g.assertIsDefined(u))})})}function S(o,e){return new Promise((i,n)=>{o.openReadStream(e,(s,u)=>{s?n(b(s)):i(g.assertIsDefined(u))})})}function R(o,e){return new Promise((i,n)=>{const s=new f.ZipFile;e.forEach(y=>{y.contents?s.addBuffer(typeof y.contents=="string"?Buffer.from(y.contents,"utf8"):y.contents,y.path):y.localPath&&s.addFile(y.localPath,y.path)}),s.end();const u=I.createWriteStream(o);s.outputStream.pipe(u),s.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(o))})}t.zip=R;function D(o,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=d(o,!0);return i.overwrite&&(u=u.then(y=>O.Promises.rm(e).then(()=>y))),u.then(y=>c(y,e,{sourcePathRegex:s},n))}t.extract=D;function p(o,e){return d(o).then(i=>new Promise((n,s)=>{i.on("entry",u=>{u.fileName===e&&S(i,u).then(y=>n(y),y=>s(y))}),i.once("close",()=>s(new Error(m.localize(2,null,e))))}))}function r(o,e){return p(o,e).then(i=>new Promise((n,s)=>{const u=[];i.once("error",s),i.on("data",y=>u.push(y)),i.on("end",()=>n(Buffer.concat(u)))}))}t.buffer=r}),define(J[120],Q([0,1,43,77]),function($,t,m,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function I(T){return m.buffer(T,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(C){throw new Error(F.localize(0,null))}})}t.getManifest=I}),define(J[121],Q([0,1,39,2,9,3,15,23,24,4,7,21,89,78,41,43,14,22,8,18,17,29,12]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R,D,p,r,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",u="deleting",y="renaming";let P=class extends F.Disposable{constructor(A,M,V,_,X){super();this.beforeRemovingExtension=A,this.fileService=M,this.logService=V,this.environmentService=_,this.productService=X,this._devSystemExtensionsPath=null,this.systemExtensionsPath=_.builtinExtensionsPath,this.extensionsPath=_.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new g.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(A){const M=[];(A===null||A===0)&&M.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(V).message,i)))),(A===null||A===1)&&M.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new C.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(M);return R.flatten(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(A){this.logService.trace("Started scanning user extensions");let[M,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter(_=>!M[new f.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).key()]),A&&(V=f.groupByExtension(V,X=>X.identifier).map(X=>X.sort((ee,ie)=>m.rcompare(ee.manifest.version,ie.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(A,M,V){const _=A.key(),X=T.join(this.extensionsPath,`.${o.generateUuid()}`),ee=T.join(this.extensionsPath,_);try{await I.Promises.rm(ee)}catch(Z){try{await I.Promises.rm(ee)}catch(oe){}throw new C.ExtensionManagementError(k.localize(0,null,ee,A.id),u)}await this.extractAtLocation(A,M,X,V);let ie=await this.scanExtension(w.URI.file(X),1);if(!ie)throw new Error(k.localize(1,null,X));await this.storeMetadata(ie,{installedTimestamp:Date.now()});try{await this.rename(A,X,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(Z){try{await I.Promises.rm(X)}catch(oe){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${e.getErrorMessage(Z)}. Deleted from extracted location`,X),Z}try{ie=await this.scanExtension(w.URI.file(ee),1)}catch(Z){}if(ie)return ie;throw new Error(k.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(A,M){return this.setMetadata(A,M),await this.storeMetadata(A,{...M,installedTimestamp:A.installedTimestamp}),A}async storeMetadata(A,M){M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0;const V=T.join(A.location.fsPath,"package.json"),_=await I.Promises.readFile(V,"utf8"),{manifest:X}=await this.parseManifest(_);return X.__metadata=M,await I.Promises.writeFile(V,JSON.stringify(X,null,"	")),A}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const M=A.map(V=>new f.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{M.forEach(_=>V[_.key()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(_=>delete _[A.key()]);const V=(await this.scanExtensions(1)).find(_=>new f.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version).equals(A))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let M;try{M=await I.Promises.readFile(this.uninstalledPath,"utf8")}catch(_){if(_.code!=="ENOENT")throw _}let V={};if(M)try{V=JSON.parse(M)}catch(_){}return A&&(A(V),Object.keys(V).length?await I.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await I.Promises.rm(this.uninstalledPath)),V})}async removeExtension(A,M){this.logService.trace(`Deleting ${M} extension from disk`,A.identifier.id,A.location.fsPath),await I.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(M=>delete M[new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version).key()])}async extractAtLocation(A,M,V,_){this.logService.trace(`Started extracting the extension from ${M} to ${V}`);try{await I.Promises.rm(V)}catch(X){throw new C.ExtensionManagementError(this.joinErrors(X).message,u)}try{await d.extract(M,V,{sourcePath:"extension",overwrite:!0},_),this.logService.info(`Extracted extension to ${V}:`,A.id)}catch(X){try{await I.Promises.rm(V)}catch(ee){}throw new C.ExtensionManagementError(X.message,X instanceof d.ExtractError&&X.type?X.type:s)}}async rename(A,M,V,_){try{await I.Promises.rename(M,V)}catch(X){if(S.isWindows&&X&&X.code==="EPERM"&&Date.now()<_)return this.logService.info(`Failed renaming ${M} to ${V} with 'EPERM' error. Trying again...`,A.id),this.rename(A,M,V,_);throw new C.ExtensionManagementError(X.message||k.localize(3,null,M,V),X.code||y)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const A=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return A;const M=this.scanDevSystemExtensions(),[V,_]=await Promise.all([A,M]);return[...V,..._]}async scanExtensionsInDir(A,M){const V=new g.Limiter(10),_=await this.fileService.resolve(w.URI.file(A));return _.children?(await Promise.all(_.children.filter(ee=>ee.isDirectory).map(ee=>V.queue(async()=>M===1&&r.basename(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,M))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(A,M){try{const V=await this.fileService.resolve(A);if(V.children){const{manifest:_,metadata:X}=await this.readManifest(A.fsPath),ee=V.children.find(({name:se})=>/^readme(\.txt|\.md|)$/i.test(se))?.resource,ie=V.children.find(({name:se})=>/^changelog(\.txt|\.md|)$/i.test(se))?.resource,Z={id:f.getGalleryExtensionId(_.publisher,_.name)},oe={type:M,identifier:Z,manifest:_,location:A,readmeUrl:ee,changelogUrl:ie,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:M===0};return X&&(this.setMetadata(oe,X),oe.installedTimestamp=X.installedTimestamp),oe}}catch(V){M!==0&&this.logService.trace(V)}return null}async scanDefaultSystemExtensions(){const A=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",A.length),A}async scanDevSystemExtensions(){const A=this.getDevSystemExtensionsList();if(A.length){const M=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",M.length),M.filter(V=>A.some(_=>f.areSameExtensions(V.identifier,{id:_})))}else return[]}setMetadata(A,M){A.publisherDisplayName=M.publisherDisplayName||null,A.publisherId=M.publisherId||null,A.identifier.uuid=M.id,A.isMachineScoped=!!M.isMachineScoped,A.isBuiltin=A.type===0||!!M.isBuiltin}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),M=await this.scanAllUserExtensions(),V=new Set;for(const ee of M)A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||V.add(ee.identifier.id.toLowerCase());const _=f.groupByExtension(M,ee=>ee.identifier);await g.Promises.settled(_.map(async ee=>{const ie=ee.sort((Z,oe)=>m.rcompare(Z.manifest.version,oe.manifest.version))[0];V.has(ie.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ie)}));const X=M.filter(ee=>A[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await g.Promises.settled(X.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const A=await this.scanAllUserExtensions(),M=[],V=f.groupByExtension(A,_=>_.identifier);M.push(...R.flatten(V.map(_=>_.sort((X,ee)=>m.rcompare(X.manifest.version,ee.manifest.version)).slice(1)))),await g.Promises.settled(M.map(_=>this.removeExtension(_,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(A=>A.name)}joinErrors(A){const M=Array.isArray(A)?A:[A];return M.length===1?M[0]instanceof Error?M[0]:new Error(M[0]):M.reduce((V,_)=>new Error(`${V.message}${V.message?",":""}${_ instanceof Error?_.message:_}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(D.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(A){const M=[I.Promises.readFile(T.join(A,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),I.Promises.readFile(T.join(A,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:V,metadata:_},X]=await Promise.all(M);return{manifest:b.localizeManifest(V,X),metadata:_}}parseManifest(A){return new Promise((M,V)=>{try{const _=JSON.parse(A),X=_.__metadata||null;M({manifest:_,metadata:X})}catch(_){V(new Error(k.localize(4,null)))}})}};P=ue([fe(1,p.IFileService),fe(2,O.ILogService),fe(3,E.INativeEnvironmentService),fe(4,c.IProductService)],P),t.ExtensionsScanner=P}),define(J[122],Q([0,1,76,3,9,2,22,43,23,24,21,4,10,39,7,40,14,15,97,28,42,49,17,29,95,11,8,26,120,101,121,102,103,18]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R,D,p,r,o,e,i,n,s,u,y,P,z,A,M,V,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const X="unsetUninstalled",ee="downloading",ie="validating",Z="local",oe="cancelled",se="unknown";let re=class extends T.Disposable{constructor(a,l,h,v,L,N,U){super();this.environmentService=a,this.galleryService=l,this.logService=h,this.downloadService=v,this.telemetryService=L,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new b.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new b.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new b.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new b.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const j=this._register(N.createInstance(M.ExtensionsLifecycle));this.extensionsScanner=this._register(N.createInstance(A.ExtensionsScanner,W=>j.postUninstall(W))),this.manifestCache=this._register(new D.ExtensionsManifestCache(a,this)),this.extensionsDownloader=this._register(N.createInstance(z.ExtensionsDownloader));const B=this._register(new V.ExtensionsWatcher(this,U,a,h));this._register(B.onDidChangeExtensionsByAnotherSource(({added:W,removed:H})=>{W.forEach(Y=>this._onDidInstallExtension.fire({identifier:Y.identifier,operation:0,local:Y})),H.forEach(Y=>this._onDidUninstallExtension.fire({identifier:Y}))})),this._register(T.toDisposable(()=>{this.installingExtensions.forEach(W=>W.cancel()),this.uninstallingExtensions.forEach(W=>W.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(a){this.logService.trace("ExtensionManagementService#zip",a.identifier.id);const l=await this.collectFiles(a),h=await C.zip(e.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,l);return c.URI.file(h)}async unzip(a){return this.logService.trace("ExtensionManagementService#unzip",a.toString()),(await this.install(a)).identifier}async getManifest(a){const l=await this.downloadVsix(a),h=F.resolve(l.fsPath);return P.getManifest(h)}async collectFiles(a){const l=async v=>{let L=await I.Promises.readdir(v);L=L.map(j=>F.join(v,j));const N=await Promise.all(L.map(j=>I.Promises.stat(j)));let U=Promise.resolve([]);return N.forEach((j,B)=>{const W=L[B];j.isFile()&&(U=U.then(H=>[...H,W])),j.isDirectory()&&(U=U.then(H=>l(W).then(Y=>[...H,...Y])))}),U};return(await l(a.location.fsPath)).map(v=>({path:`extension/${F.relative(a.location.fsPath,v)}`,localPath:v}))}async install(a,l={}){return this.logService.trace("ExtensionManagementService#install",a.toString()),E.createCancelablePromise(async h=>{const v=await this.downloadVsix(a),L=F.resolve(v.fsPath),N=await P.getManifest(L),U={id:g.getGalleryExtensionId(N.publisher,N.name)};let j=1;if(N.engines&&N.engines.vscode&&!o.isEngineValid(N.engines.vscode,d.default.version,d.default.date))throw new Error(m.localize(0,null,U.id,d.default.version));const B=new g.ExtensionIdentifierWithVersion(U,N.version),H=(await this.getInstalled(1)).find(te=>g.areSameExtensions(U,te.identifier));if(H)if(l.isMachineScoped=l.isMachineScoped||H.isMachineScoped,l.isBuiltin=l.isBuiltin||H.isBuiltin,j=2,B.equals(new g.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(te){throw new Error(m.localize(1,null,N.displayName||N.name))}else k.gt(H.manifest.version,N.version)&&await this.uninstallExtension(H);else{const te=await this.unsetUninstalledAndGetLocal(B);if(te)try{await this.extensionsScanner.removeExtension(te,"existing")}catch(ae){throw new Error(m.localize(2,null,N.displayName||N.name))}}this.logService.info("Installing the extension:",U.id),this._onInstallExtension.fire({identifier:U,zipPath:L});let Y;try{Y=await this.getGalleryMetadata(g.getGalleryExtensionId(N.publisher,N.name))}catch(te){}try{const te=await this.installFromZipPath(B,L,l.installOnlyNewlyAddedFromExtensionPack?H:void 0,{...Y||{},...l},l,j,h);return this.logService.info("Successfully installed the extension:",U.id),te}catch(te){throw this.logService.error("Failed to install the extension:",U.id,te.message),te}})}async downloadVsix(a){if(a.scheme===u.Schemas.file)return a;if(!this.downloadService)throw new Error("Download service is not available");const l=e.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(a,l),l}async installFromZipPath(a,l,h,v,L,N,U){try{const j=await this.installExtension({zipPath:l,identifierWithVersion:a,metadata:v},U);try{L.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(j,h,L)}catch(B){O.isNonEmptyArray(j.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",j.identifier.id,B.message),O.isNonEmptyArray(j.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",j.identifier.id,B.message)}return this._onDidInstallExtension.fire({identifier:a,zipPath:l,local:j,operation:N}),j}catch(j){throw this._onDidInstallExtension.fire({identifier:a,zipPath:l,operation:N,error:j}),j}}async canInstall(a){return!0}async installFromGallery(a,l={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(3,null));try{a=await this.checkAndGetCompatibleVersion(a)}catch(v){const L=v&&v.code?v.code:se;throw this.logService.error("Failed to install extension:",a.identifier.id,v?v.message:L),this.reportTelemetry(this.getTelemetryEvent(1),g.getGalleryExtensionTelemetryData(a),void 0,v),v instanceof Error&&(v.name=L),v}let h=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(a.identifier,a.version).key());return h?(this.logService.info("Extensions is already requested to install",a.identifier.id),(await h.resultPromise).local):(h=this.createInstallFromGalleryExtensionTask(a,l),(await this.runInstallGalleryExtensionTask(h,l)).local)}createInstallFromGalleryExtensionTask(a,l){const h=new g.ExtensionIdentifierWithVersion(a.identifier,a.version).key();this._onInstallExtension.fire({identifier:a.identifier,gallery:a}),this.logService.info("Installing extension:",a.identifier.id);let v;const L=new E.Barrier,N={extension:a,get resultPromise(){return L.wait().then(()=>v)},run:async()=>(v||(v=E.createCancelablePromise(async U=>{try{const j=await this.installGalleryExtension(a,l,U);return this.logService.info("Extensions installed successfully:",a.identifier.id),this._onDidInstallExtension.fire({identifier:a.identifier,gallery:j.gallery,local:j.local,operation:j.operation}),j}catch(j){const B=j&&j.code?j.code:se;throw this.logService.error("Failed to install extension:",a.identifier.id,j?j.message:B),this._onDidInstallExtension.fire({identifier:a.identifier,gallery:a,operation:1,error:B}),j instanceof Error&&(j.name=B),j}})),L.open(),v.finally(()=>this.installingExtensions.delete(h)),v),cancel:()=>{v?v.cancel():this._onDidInstallExtension.fire({identifier:a.identifier,gallery:a,operation:1,error:oe})}};return this.installingExtensions.set(h,N),N}async runInstallGalleryExtensionTask(a,l){if(l.donotIncludePackAndDependencies)return this.logService.info("Installing the extension without checking dependencies and pack",a.extension.identifier.id),a.run();const h=new Map,v=[];try{const L=await this.galleryService.getManifest(a.extension,y.CancellationToken.None);if(L===null){const B=new f.ExtensionManagementError(`Missing manifest for extension ${a.extension.identifier.id}`,ie);throw this.logService.error("Failed to install extension:",a.extension.identifier.id,B.message),B}h.set(a.extension.identifier.id.toLowerCase(),{task:a,manifest:L});const N=await this.getAllDepsAndPackExtensionsToInstall(a.extension.identifier,L,y.CancellationToken.None);let U=!1;for(const{gallery:B,manifest:W}of N)if(U=U||!!W.extensionDependencies?.some(H=>g.areSameExtensions({id:H},a.extension.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(B.identifier,B.version).key()))this.logService.info("Extension is already requested to install",B.identifier.id);else{const H=this.createInstallFromGalleryExtensionTask(B,{...l,donotIncludePackAndDependencies:!0});h.set(B.identifier.id.toLowerCase(),{task:H,manifest:W})}for(;h.size;){const B=[...h.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Y=>h.has(Y.toLowerCase())));let W;B.length?W=h.size===1?B:B.filter(({task:H})=>!(H===a&&!U)):(this.logService.info("Found extensions with circular dependencies",B.map(({task:H})=>H.extension.identifier.id)),W=[...h.values()]),await Promise.all(W.map(async({task:H})=>{v.push(await H.run()),h.delete(H.extension.identifier.id.toLowerCase())}))}const j=v.find(({local:B})=>g.areSameExtensions(B.identifier,a.extension.identifier));if(j)return j;throw new Error("Extension is not installed")}catch(L){throw h.size?h.forEach(({task:N})=>N.cancel()):a.cancel(),L}}async installGalleryExtension(a,l,h){const v=new Date().getTime();let L=1;try{const U=(await this.getInstalled()).find(W=>g.areSameExtensions(W.identifier,a.identifier));U&&(L=2);const j=await this.downloadInstallableExtension(a,L);j.metadata.isMachineScoped=l.isMachineScoped||U?.isMachineScoped,j.metadata.isBuiltin=l.isBuiltin||U?.isBuiltin;const B=await this.installExtension(j,h);U&&k.neq(U.manifest.version,a.version)&&await this.extensionsScanner.setUninstalled(U);try{await this.extensionsDownloader.delete(c.URI.file(j.zipPath))}catch(W){}return this.reportTelemetry(this.getTelemetryEvent(L),g.getGalleryExtensionTelemetryData(a),new Date().getTime()-v,void 0),{local:B,operation:L,gallery:a}}catch(N){throw this.reportTelemetry(this.getTelemetryEvent(L),g.getGalleryExtensionTelemetryData(a),new Date().getTime()-v,N),N}}async getAllDepsAndPackExtensionsToInstall(a,l,h){let v=await this.getInstalled();const L=[a,...v.map(j=>j.identifier)],N=[],U=async(j,B)=>{const W=B.extensionDependencies||[];if(B.extensionPack){const H=v.find(Y=>g.areSameExtensions(Y.identifier,j));for(const Y of B.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(te=>g.areSameExtensions({id:te},{id:Y}))||W.every(te=>!g.areSameExtensions({id:te},{id:Y}))&&W.push(Y)}if(W.length){const H=[...L,...N.map(te=>te.gallery.identifier)],Y=W.filter(te=>H.every(ae=>!g.areSameExtensions(ae,{id:te})));if(Y.length){const te=await this.galleryService.query({names:Y,pageSize:W.length},y.CancellationToken.None);for(const ae of te.firstPage){if(H.find(Oe=>g.areSameExtensions(Oe,ae.identifier)))continue;const me=await this.checkAndGetCompatibleVersion(ae),ve=await this.galleryService.getManifest(me,y.CancellationToken.None);if(ve===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${me.identifier.id}`,ie);N.push({gallery:me,manifest:ve}),await U(me.identifier,ve)}}}};return await U(a,l),v=await this.getInstalled(),N.filter(j=>!v.some(B=>g.areSameExtensions(B.identifier,j.gallery.identifier)))}async checkAndGetCompatibleVersion(a){if(await this.isMalicious(a))throw new f.ExtensionManagementError(m.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const l=await this.galleryService.getCompatibleExtension(a);if(!l)throw new f.ExtensionManagementError(m.localize(5,null,a.identifier.id,d.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return l}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(6,null));const l=await this.findGalleryExtension(a);if(!l)throw new Error(m.localize(7,null));await this.extensionsScanner.setUninstalled(a);try{await this.extensionsScanner.removeUninstalledExtension(a)}catch(h){throw new Error(m.localize(8,null,p.toErrorMessage(h)))}await this.installFromGallery(l)}getTelemetryEvent(a){return a===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(a){const l=await this.getExtensionsReport();return g.getMaliciousExtensionsSet(l).has(a.identifier.id)}async downloadInstallableExtension(a,l){const h={id:a.identifier.uuid,publisherId:a.publisherId,publisherDisplayName:a.publisherDisplayName};let v;try{this.logService.trace("Started downloading extension:",a.identifier.id),v=(await this.extensionsDownloader.downloadExtension(a,l)).fsPath,this.logService.info("Downloaded extension:",a.identifier.id,v)}catch(L){throw new f.ExtensionManagementError(this.joinErrors(L).message,ee)}try{const L=await P.getManifest(v);return{zipPath:v,identifierWithVersion:new g.ExtensionIdentifierWithVersion(a.identifier,L.version),metadata:h}}catch(L){throw new f.ExtensionManagementError(this.joinErrors(L).message,ie)}}async installExtension(a,l){try{const h=await this.unsetUninstalledAndGetLocal(a.identifierWithVersion);if(h)return a.metadata?this.extensionsScanner.saveMetadataForLocalExtension(h,a.metadata):h}catch(h){throw S.isMacintosh?new f.ExtensionManagementError(m.localize(9,null),X):new f.ExtensionManagementError(m.localize(10,null),X)}return this.extractAndInstall(a,l)}async unsetUninstalledAndGetLocal(a){if(!await this.isUninstalled(a))return null;this.logService.trace("Removing the extension from uninstalled list:",a.id);const h=await this.extensionsScanner.setInstalled(a);return this.logService.info("Removed the extension from uninstalled list:",a.id),h}async extractAndInstall({zipPath:a,identifierWithVersion:l,metadata:h},v){let L=await this.extensionsScanner.extractUserExtension(l,a,v);return this.logService.info("Installation completed.",l.id),h&&(L=await this.extensionsScanner.saveMetadataForLocalExtension(L,h)),L}async installDependenciesAndPackExtensions(a,l,h){if(!this.galleryService.isEnabled())return;const v=a.manifest.extensionDependencies||[];if(a.manifest.extensionPack)for(const L of a.manifest.extensionPack)l&&l.manifest.extensionPack&&l.manifest.extensionPack.some(N=>g.areSameExtensions({id:N},{id:L}))||v.every(N=>!g.areSameExtensions({id:N},{id:L}))&&v.push(L);if(v.length){const L=await this.getInstalled(),N=v.filter(U=>L.every(({identifier:j})=>!g.areSameExtensions(j,{id:U})));if(N.length){const j=(await this.galleryService.query({names:N,pageSize:v.length},y.CancellationToken.None)).firstPage;try{await E.Promises.settled(j.map(B=>this.installFromGallery(B,h)))}catch(B){try{await this.rollback(j)}catch(W){}throw B}}}}async rollback(a){const h=(await this.getInstalled(1)).filter(v=>a.some(L=>new g.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(new g.ExtensionIdentifierWithVersion(L.identifier,L.version))));await E.Promises.settled(h.map(v=>this.uninstall(v)))}async uninstall(a,l={}){this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id);const h=await this.getInstalled(1),v=h.find(L=>g.areSameExtensions(L.identifier,a.identifier));if(!v)throw new Error(m.localize(11,null,a.manifest.displayName||a.manifest.name));try{await this.checkForDependenciesAndUninstall(v,h,l)}catch(L){throw this.joinErrors(L)}}async updateMetadata(a,l){return this.logService.trace("ExtensionManagementService#updateMetadata",a.identifier.id),a=await this.extensionsScanner.saveMetadataForLocalExtension(a,{...a.manifest.__metadata||{},...l}),this.manifestCache.invalidate(),a}async updateExtensionScope(a,l){return this.logService.trace("ExtensionManagementService#updateExtensionScope",a.identifier.id),a=await this.extensionsScanner.saveMetadataForLocalExtension(a,{...a.manifest.__metadata||{},isMachineScoped:l}),this.manifestCache.invalidate(),a}async getGalleryMetadata(a){const l=await this.findGalleryExtensionByName(a);return l?{id:l.identifier.uuid,publisherDisplayName:l.publisherDisplayName,publisherId:l.publisherId}:void 0}async findGalleryExtension(a){if(a.identifier.uuid){const l=await this.findGalleryExtensionById(a.identifier.uuid);return l||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},y.CancellationToken.None)).firstPage[0]}joinErrors(a){const l=Array.isArray(a)?a:[a];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((h,v)=>new Error(`${h.message}${h.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}async checkForDependenciesAndUninstall(a,l,h){try{await this.preUninstallExtension(a);const v=h.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(a,l);await this.uninstallExtensions(a,v,l,h)}catch(v){throw await this.postUninstallExtension(a,new f.ExtensionManagementError(v instanceof Error?v.message:v,Z)),v}await this.postUninstallExtension(a)}async uninstallExtensions(a,l,h,v){const L=[a,...l];if(!v.donotCheckDependents)for(const N of L)this.checkForDependents(N,L,h,a);await E.Promises.settled([this.uninstallExtension(a),...l.map(N=>this.doUninstall(N))])}checkForDependents(a,l,h,v){const L=this.getDependents(a,h);if(L.length){const N=L.filter(U=>l.indexOf(U)===-1);if(N.length)throw new Error(this.getDependentsErrorMessage(a,N,v))}}getDependentsErrorMessage(a,l,h){return h===a?l.length===1?m.localize(12,null,h.manifest.displayName||h.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?m.localize(13,null,h.manifest.displayName||h.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):m.localize(14,null,h.manifest.displayName||h.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):l.length===1?m.localize(15,null,h.manifest.displayName||h.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name):l.length===2?m.localize(16,null,h.manifest.displayName||h.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name):m.localize(17,null,h.manifest.displayName||h.manifest.name,a.manifest.displayName||a.manifest.name,l[0].manifest.displayName||l[0].manifest.name,l[1].manifest.displayName||l[1].manifest.name)}getAllPackExtensionsToUninstall(a,l,h=[]){if(h.indexOf(a)!==-1)return[];h.push(a);const v=a.manifest.extensionPack?a.manifest.extensionPack:[];if(v.length){const L=l.filter(U=>!U.isBuiltin&&v.some(j=>g.areSameExtensions({id:j},U.identifier))),N=[];for(const U of L)N.push(...this.getAllPackExtensionsToUninstall(U,l,h));return[...L,...N]}return[]}getDependents(a,l){return l.filter(h=>h.manifest.extensionDependencies&&h.manifest.extensionDependencies.some(v=>g.areSameExtensions({id:v},a.identifier)))}async doUninstall(a){try{await this.preUninstallExtension(a),await this.uninstallExtension(a)}catch(l){throw await this.postUninstallExtension(a,new f.ExtensionManagementError(l instanceof Error?l.message:l,Z)),l}await this.postUninstallExtension(a)}async preUninstallExtension(a){if(!await I.Promises.exists(a.location.fsPath))throw new Error(m.localize(18,null));this.logService.info("Uninstalling extension:",a.identifier.id),this._onUninstallExtension.fire(a.identifier)}async uninstallExtension(a){let l=this.uninstallingExtensions.get(a.identifier.id);return l||(l=E.createCancelablePromise(async()=>{const h=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...h.filter(v=>g.areSameExtensions(v.identifier,a.identifier)))}),this.uninstallingExtensions.set(a.identifier.id,l),l.finally(()=>this.uninstallingExtensions.delete(a.identifier.id))),l}async postUninstallExtension(a,l){if(l)this.logService.error("Failed to uninstall extension:",a.identifier.id,l.message);else if(this.logService.info("Successfully uninstalled extension:",a.identifier.id),a.identifier.uuid)try{await this.galleryService.reportStatistic(a.manifest.publisher,a.manifest.name,a.manifest.version,"uninstall")}catch(v){}this.reportTelemetry("extensionGallery:uninstall",g.getLocalExtensionTelemetryData(a),void 0,l);const h=l?l instanceof f.ExtensionManagementError?l.code:se:void 0;this._onDidUninstallExtension.fire({identifier:a.identifier,error:h})}getInstalled(a=null){return this.extensionsScanner.scanExtensions(a)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(a){return(await this.filterUninstalled(a)).length===1}async filterUninstalled(...a){const l=[],h=await this.extensionsScanner.getUninstalledExtensions();for(const v of a)h[v.key()]&&l.push(v.key());return l}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(a,l,h,v){const L=v?v instanceof f.ExtensionManagementError?v.code:se:void 0;this.telemetryService.publicLogError(a,{...l,success:!v,duration:h,errorcode:L})}};re=ue([fe(0,w.INativeEnvironmentService),fe(1,f.IExtensionGalleryService),fe(2,R.ILogService),fe(3,s.optional(n.IDownloadService)),fe(4,r.ITelemetryService),fe(5,s.IInstantiationService),fe(6,_.IFileService)],re),t.ExtensionManagementService=re}),define(J[123],Q([0,1,132,112,2,13,12,111,27,15,16,21,98]),function($,t,m,F,I,T,O,C,f,g,w,E,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let k=class extends I.Disposable{constructor(d,S,R){super();this.environmentService=S,this.logService=R,this.configure(d.getValue()),this._register(d.onDidChangeConfiguration(()=>this.configure(d.getValue()),this))}configure(d){this.proxyUrl=d.http&&d.http.proxy,this.strictSSL=!!(d.http&&d.http.proxyStrictSSL),this.authorization=d.http&&d.http.proxyAuthorization}async request(d,S){this.logService.trace("RequestService#request",d.url);const{proxyUrl:R,strictSSL:D}=this,p={...process.env,...await b.resolveShellEnv(this.logService,this.environmentService.args,process.env)},r=d.agent?d.agent:await C.getProxyAgent(d.url||"",p,{proxyUrl:R,strictSSL:D});return d.agent=r,d.strictSSL=D,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this._request(d,S)}async getNodeRequest(d){return(F.parse(d.url).protocol==="https:"?await new Promise((D,p)=>{$(["https"],D,p)}):await new Promise((D,p)=>{$(["http"],D,p)})).request}_request(d,S){return new Promise(async(R,D)=>{let p;const r=F.parse(d.url),o=d.getRawRequest?d.getRawRequest(d):await this.getNodeRequest(d),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:T.isBoolean(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(e.auth=d.user+":"+d.password),p=o(e,i=>{const n=T.isNumber(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...d,url:i.headers.location,followRedirects:n-1},S).then(R,D);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(m.createGunzip())),R({res:i,stream:w.streamToBufferReadableStream(s)})}}),p.on("error",D),d.timeout&&p.setTimeout(d.timeout),d.data&&typeof d.data=="string"&&p.write(d.data),p.end(),S.onCancellationRequested(()=>{p.abort(),D(O.canceled())})})}async resolveProxy(d){}};k=ue([fe(0,f.IConfigurationService),fe(1,E.INativeEnvironmentService),fe(2,g.ILogService)],k),t.RequestService=k}),define(J[133],Q([0,1,31,36,134,9,3,4,40,52,50,100,21,88,23,122,116,42,56,117,115,55,123,27,110,118,15,8,105,119,106,18,107,2,41,96,7,104,53,12,28,16,33]),function($,t,m,F,I,T,O,C,f,g,w,E,b,k,c,d,S,R,D,p,r,o,e,i,n,s,u,y,P,z,A,M,V,_,X,ee,ie,Z,oe,se,re,K,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class l extends _.Disposable{constructor(L){super();this.argv=L,I.gracefulify(F),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[L,N]=await this.initServices();return L.invokeFunction(async U=>{const j=U.get(u.ILogService),B=U.get(M.IFileService),W=U.get(b.INativeEnvironmentService),H=U.get(c.IExtensionManagementCLIService);return j.info("CLI main",this.argv),this.registerErrorHandler(j),await this.doRun(W,H,B),C.raceTimeout(D.combinedAppender(...N).flush(),1e3)})}async initServices(){const L=new g.ServiceCollection,N={_serviceBrand:void 0,...f.default};L.set(X.IProductService,N);const U=new k.NativeEnvironmentService(this.argv,N);L.set(b.INativeEnvironmentService,U),await Promise.all([U.appSettingsHome.fsPath,U.extensionsPath].map(me=>me?T.Promises.mkdir(me,{recursive:!0}):void 0));const j=u.getLogLevel(U),B=[];B.push(new P.SpdLogLogger("cli",O.join(U.logsPath,"cli.log"),!0,j)),j===u.LogLevel.Trace&&B.push(new u.ConsoleLogger(j));const W=this._register(new u.MultiplexLogService(B));L.set(u.ILogService,W);const H=this._register(new A.FileService(W));L.set(M.IFileService,H);const Y=this._register(new V.DiskFileSystemProvider(W));H.registerProvider(y.Schemas.file,Y);const te=this._register(new n.ConfigurationService(U.settingsResource,H));L.set(i.IConfigurationService,te),await te.initialize(),L.set(o.IRequestService,new w.SyncDescriptor(e.RequestService)),L.set(c.IExtensionManagementService,new w.SyncDescriptor(d.ExtensionManagementService)),L.set(c.IExtensionGalleryService,new w.SyncDescriptor(S.ExtensionGalleryService)),L.set(c.IExtensionManagementCLIService,new w.SyncDescriptor(ee.ExtensionManagementCLIService)),L.set(oe.ILocalizationsService,new w.SyncDescriptor(Z.LocalizationsService));const ae=[];if(U.isBuilt&&!U.isExtensionDevelopment&&!U.disableTelemetry&&N.enableTelemetry){N.aiConfig&&N.aiConfig.asimovKey&&ae.push(new s.AppInsightsAppender("monacoworkbench",null,N.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ve,installSourcePath:Oe}=U,Te={appender:D.combinedAppender(...ae),sendErrorTelemetry:!1,commonProperties:(async()=>{let Se;try{const Ae=await T.Promises.readFile(O.join(U.userDataPath,"storage.json"));Se=JSON.parse(Ae.toString())[R.machineIdKey]}catch(Ae){Ae.code!=="ENOENT"&&W.error(Ae)}return r.resolveCommonProperties(H,m.release(),m.hostname(),process.arch,N.commit,N.version,Se,N.msftInternalDomains,Oe)})(),piiPaths:[me,ve]};L.set(R.ITelemetryService,new w.SyncDescriptor(p.TelemetryService,[Te]))}else L.set(R.ITelemetryService,D.NullTelemetryService);return[new E.InstantiationService(L),ae]}registerErrorHandler(L){se.setUnexpectedErrorHandler(N=>{const U=re.toErrorMessage(N,!0);!U||L.error(`[uncaught exception in CLI]: ${U}`)})}async doRun(L,N,U){if(this.argv["install-source"])return this.setInstallSource(L,U,this.argv["install-source"]);if(this.argv["list-extensions"])return N.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return N.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return N.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return N.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await z.buildTelemetryMessage(L.appRoot,L.extensionsPath))}asExtensionIdOrVSIX(L){return L.map(N=>/\.vsix$/i.test(N)?ie.URI.file(O.isAbsolute(N)?N:O.join(a.cwd(),N)):N)}async setInstallSource(L,N,U){await N.writeFile(ie.URI.file(L.installSourcePath),K.VSBuffer.fromString(U.slice(0,30)))}}async function h(v){const L=new l(v);try{await L.run()}finally{L.dispose()}}t.main=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cc528230987ce3ac61fc4f094ae247d5ff24db3c/core/vs/code/node/cliProcessMain.js.map
